* This file contains two subroutine which computes renormalized Z
* selfenergy. These are called by CalcMasses_atlambda.F
* subroutine SelfTZZ2L_MT4(selfZ) compute the finite part of Z selfenergy
* with contribution of alpha_t^2
* subroutine SelfTZZ2L_lambda(selfZ) compute the finite part of Z selfenergy
* with contribution of alpha_t (alpha_lambda+ alpha_kappa)
* written by Thi Nhung Dao, last update 6/2021
c#define printMT4
c*********************************************************************
      subroutine SelfTZZ2L_MT4(selfZ)
      implicit none
      integer imodel,i,j,I6G3,I6G4,I6G5,I6G6,I2G3,I2G4,I5G5,I2G2,h1,h2
#include "TLMT4.h"
#include "TLMT4lambda.h"
      double precision pi2,fac,B0T,A0T,AEpT,BEpT,fac1,M14,M24,
     .     M44,M26,M22m42,M22m42s,M22m42I,M22mMSQ,M42mMSQ,
     .     lambdaN,I0A,selfZ
      double complex abrx(20),abry(20),abrz(20),afin(50)
         pi2=pi**2
         fac1= 3*SW2*CW2/16D0/Pi2**2/vv2
         fac= 3*SW2*CW2/16D0/Pi2**2/vv2
         M14=M12**2; M24=M22**2; M44=M42**2
         M22m42=M22-M42; M26=M22*M24; M22m42s=M22m42**2
         M22m42I=1D0/M22m42; M22mMSQ=M22-MSQ2; M42mMSQ=M42-MSQ2
       SelfZ=0;
       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= 1,2
       SelfZ=SelfZ-((CS13S13S13S13MT4(I6G4,I6G6,I6G5,I6G6)+3*
     &  CS13S13S13S13MT4(I6G4,I6G6,I6G6,I6G5))*CS13S13V2(I6G3,I6G4)*
     &  CS13S13V2(I6G5,I6G3)*(4*aAETN(I6G6)+aA0TN(I6G6)*(2+4*
     &  aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+(1+2*
     &  aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*aC0T(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*MassSu2(I6G3))*
     &  MassSu2(I6G6)))/16.
       enddo
       enddo
       enddo
       enddo


       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= 1,2
       SelfZ=SelfZ-((CS13S13S13S13MT4(I6G5,I6G6,I6G4,I6G6)+3*
     &  CS13S13S13S13MT4(I6G5,I6G6,I6G6,I6G4))*CS13S13V2(I6G3,I6G5)*
     &  CS13S13V2(I6G4,I6G3)*(4*aAETN(I6G6)+aA0TN(I6G6)*(2+4*
     &  aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+(1+2*
     &  aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*aC0T(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*MassSu2(I6G3))*
     &  MassSu2(I6G6)))/16.
       enddo
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= ihiggs,6
       SelfZ=SelfZ-(CS13S13V2(I6G3,I6G4)*CS13S13V2(I6G5,I6G3)*
     &  CSSSS(I6G6,I6G6,I6G4,I6G5)*(4*AETNH(I6G6)+A0TNH(I6G6)*(2+4*
     &  aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+
     &  Mah2(I6G6)*(1+2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*
     &  aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3))))/32.
       enddo
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       Do  I6G6= ihiggs,6
       SelfZ=SelfZ-(CS13S13V2(I6G3,I6G5)*CS13S13V2(I6G4,I6G3)*
     &  CSSSS(I6G6,I6G6,I6G5,I6G4)*(4*AETNH(I6G6)+A0TNH(I6G6)*(2+4*
     &  aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+
     &  Mah2(I6G6)*(1+2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*
     &  aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3))))/32.
       enddo
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfZ=SelfZ-(CS13S13V2(I6G3,I6G4)*CS13S13V2(I6G5,I6G3)*
     &  CS3S3S13S13(I2G3,I2G3,I6G4,I6G5)*(4*AETHpN(I2G3)+A0THpN(I2G3)*
     &  (2+4*aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+
     &  MassHpm(I2G3)**2*(1+2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*
     &  aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3))))/16.
       enddo
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfZ=SelfZ-(CS13S13V2(I6G3,I6G5)*CS13S13V2(I6G4,I6G3)*
     &  CS3S3S13S13(I2G3,I2G3,I6G5,I6G4)*(4*AETHpN(I2G3)+A0THpN(I2G3)*
     &  (2+4*aB0T1(I6G4,I6G5)+4*aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))+
     &  MassHpm(I2G3)**2*(1+2*aB0T1(I6G4,I6G5)+4*aBEpT1(I6G4,I6G5)+2*
     &  aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3)+4*aCEpT(I6G3,I6G4,I6G5)*
     &  MassSu2(I6G3))))/16.
       enddo
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfZ=SelfZ+(CS13S13V2(I6G3,I6G4)*CS13S13V2(I6G5,I6G3)*
     &  CS14S13S14S13MT4(I6G4,I6G5)*(-2*a0t5-4*aet5-MSQ2-2*(2*a0t5+
     &  MSQ2)*(aB0T1(I6G4,I6G5)+aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))-4*
     &  MSQ2*(aBEpT1(I6G4,I6G5)+aCEpT(I6G3,I6G4,I6G5)*MassSu2(I6G3))))
     &  /16.
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfZ=SelfZ+(CS13S13V2(I6G3,I6G5)*CS13S13V2(I6G4,I6G3)*
     &  CS14S13S14S13MT4(I6G5,I6G4)*(-2*a0t5-4*aet5-MSQ2-2*(2*a0t5+
     &  MSQ2)*(aB0T1(I6G4,I6G5)+aC0T(I6G3,I6G4,I6G5)*MassSu2(I6G3))-4*
     &  MSQ2*(aBEpT1(I6G4,I6G5)+aCEpT(I6G3,I6G4,I6G5)*MassSu2(I6G3))))
     &  /16.
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       SelfZ=SelfZ+((3*CW**2+SW**2)**2*CS3S3S14S14(I2G3,I2G3)*(-2*
     &  (a0t5-MSQ2)*A0THpN(I2G3)-2*MSQ2*AETHpN(I2G3)+(a0t5-2*aet5+MSQ2-
     &  MSQ2*Log(MSQ2/Q2))*MassHpm(I2G3)**2))/(288.*CW**2*MSQ2*SW**2)
       enddo

       Do  I2G3= 1,2
       SelfZ=SelfZ+((3*CW**2+SW**2)**2*CS3S3S14S14(I2G3,I2G3)*(-2*
     &  (a0t5-MSQ2)*A0THpN(I2G3)-2*MSQ2*AETHpN(I2G3)+(a0t5-2*aet5+MSQ2-
     &  MSQ2*Log(MSQ2/Q2))*MassHpm(I2G3)**2))/(288.*CW**2*MSQ2*SW**2)
       enddo

       Do  I6G6= 1,2
       SelfZ=SelfZ+((3*CW**2+SW**2)**2*CS14S13S14S13MT4(I6G6,I6G6)*(-2*
     &  (a0t5-MSQ2)*aA0TN(I6G6)-2*MSQ2*aAETN(I6G6)+(a0t5-2*aet5+MSQ2-
     &  MSQ2*Log(MSQ2/Q2))*MassSu2(I6G6)))/(288.*CW**2*MSQ2*SW**2)
       enddo

       Do  I6G6= 1,2
       SelfZ=SelfZ+((3*CW**2+SW**2)**2*CS14S13S14S13MT4(I6G6,I6G6)*(-2*
     &  (a0t5-MSQ2)*aA0TN(I6G6)-2*MSQ2*aAETN(I6G6)+(a0t5-2*aet5+MSQ2-
     &  MSQ2*Log(MSQ2/Q2))*MassSu2(I6G6)))/(288.*CW**2*MSQ2*SW**2)
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= 1,2
       SelfZ=SelfZ-((CS13S13S13S13MT4(I6G4,I6G5,I6G3,I6G5)+3*
     &  CS13S13S13S13MT4(I6G4,I6G5,I6G5,I6G3))*CS13S13V2V2(I6G3,I6G4)*
     &  (aAETN(I6G5)+aA0TN(I6G5)*aB0T1(I6G3,I6G4)+aBEpT1(I6G3,I6G4)*
     &  MassSu2(I6G5)))/4.
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       Do  I6G5= ihiggs,6
       SelfZ=SelfZ-(CS13S13V2V2(I6G3,I6G4)*CSSSS(I6G5,I6G5,I6G4,I6G3)*
     &  (A0TNH(I6G5)*aB0T1(I6G3,I6G4)+AETNH(I6G5)+aBEpT1(I6G3,I6G4)*
     &  Mah2(I6G5)))/8.
       enddo
       enddo
       enddo

       Do  I2G3= 1,2
       Do  I6G3= 1,2
       Do  I6G4= 1,2
       SelfZ=SelfZ-(CS13S13V2V2(I6G3,I6G4)*
     &  CS3S3S13S13(I2G3,I2G3,I6G4,I6G3)*(A0THpN(I2G3)*aB0T1(I6G3,I6G4)
     &  +AETHpN(I2G3)+aBEpT1(I6G3,I6G4)*MassHpm(I2G3)**2))/4.
       enddo
       enddo
       enddo

       Do  I6G3= 1,2
       Do  I6G4= 1,2
       SelfZ=SelfZ-((aet5+a0t5*aB0T1(I6G3,I6G4)+MSQ2*aBEpT1(I6G3,I6G4)
     &  )*CS13S13V2V2(I6G3,I6G4)*CS14S13S14S13MT4(I6G4,I6G3))/4.
       enddo
       enddo

       Do  I2G3= 1,2
       SelfZ=SelfZ+((3-2*SW2)**2*CS3S3S14S14(I2G3,I2G3)*((a0t5-MSQ2)*
     &  A0THpN(I2G3)+MSQ2*AETHpN(I2G3)+(-a0t5+aet5)*MassHpm(I2G3)**2))
     &  /(72.*CW2*MSQ2*SW2)
       enddo

       Do  I6G5= 1,2
       SelfZ=SelfZ+((3-2*SW2)**2*CS14S13S14S13MT4(I6G5,I6G5)*((a0t5-
     &  MSQ2)*aA0TN(I6G5)+MSQ2*aAETN(I6G5)+(-a0t5+aet5)*MassSu2(I6G5)))
     &  /(72.*CW2*MSQ2*SW2)
       enddo

c
c Z tranverse selfenergy, diagrams can be reduced to one-loop
c
       ! top quark diagrams
       abrz(1)=(aet1*(2*M12-MCha2+2*MSQ2)*(3*CW**2+SW**2))/(36.*CW**2*
     &  M12)+(aet5*(2*M14-M12*MCha2+2*M12*MSQ2)*(3*CW**2+SW**2))/(36.*
     &  CW**2*M12*MSQ2)+(((1+(4+8*LogM12)*logMSQ2)*M12**2-12*M14+M12*
     &  ((7+4*logcha-4*logMSQ2-4*LogM12*(1+logMSQ2))*MCha2+(-11+LogM12*
     &  (4+8*logMSQ2))*MSQ2))*(3*CW**2+SW**2))/(144.*CW**2*M12)+(-
     &  (aetcha*(M12**2-M14)*(3-2*SW**2)**2)/(36.*CW**2*SW**2)+(aet5*(-
     &  MCha2**3+M14*MSQ2+3*MCha2**2*MSQ2-3*MCha2*MSQ2**2+MSQ2**3+M12**
     &  2*(MCha2+2*MSQ2)+M12*(-M14+MCha2**2+2*MCha2*MSQ2-3*MSQ2**2))*
     &  (3-2*SW**2)**2)/(36.*CW**2*MSQ2*SW**2)-((2*M12**2*((3+LogM12*(-
     &  2+logcha-logMSQ2))*MCha2+(-1-2*LogM12*(-1+logMSQ2))*MSQ2)+M14*
     &  ((3-2*logcha)*MCha2+(3-2*logMSQ2)*MSQ2)+(MCha2-MSQ2)**2*((1+2*
     &  logcha*(-1+logMSQ2))*MCha2+(3-2*logMSQ2)*MSQ2)+M12*((1+2*
     &  LogM12*(-1+logMSQ2))*M14+(9-2*LogM12+2*logcha*(-2+LogM12-
     &  logMSQ2))*MCha2**2-2*(LogM12*(-2+logMSQ2)+2*logMSQ2+logcha*(-2+
     &  LogM12+logMSQ2))*MCha2*MSQ2+(-5+2*LogM12*(-1+logMSQ2)+4*
     &  logMSQ2)*MSQ2**2))*(3-2*SW**2)**2)/(72.*CW**2*SW**2))/alambda1+
     &  I0A1*(-((M14+MCha2**2-2*MCha2*MSQ2+MSQ2*(-2*M12+MSQ2))*(3-2*SW*
     &  *2)**2)/(36.*alambda1*CW**2*SW**2)+(9*CW**4*(3*M14**2+2*(2*
     &  MCha2-3*MSQ2)*(MCha2-MSQ2)**3+8*M12**2*MCha2*MSQ2-7*M12*(MCha2*
     &  *3-MCha2**2*MSQ2-3*MCha2*MSQ2**2+3*MSQ2**3)+M14*(5*MCha2**2-2*
     &  MCha2*MSQ2+27*MSQ2**2-5*M12*(MCha2+3*MSQ2)))+6*CW**2*(7*M14**2+
     &  M14*(-17*M12*MCha2+17*MCha2**2-19*M12*MSQ2-18*MCha2*MSQ2+15*
     &  MSQ2**2)+(MCha2-MSQ2)*(2*(MCha2-MSQ2)**2*(2*MCha2+MSQ2)+M12*(-
     &  11*MCha2**2-32*MCha2*MSQ2+MSQ2**2)))*SW**2+(31*M14**2+2*(2*
     &  MCha2-11*MSQ2)*(MCha2-MSQ2)**3-8*M12**2*MCha2*MSQ2+M14*(-89*
     &  M12*MCha2+89*MCha2**2-115*M12*MSQ2+62*MCha2*MSQ2+159*MSQ2**2)+
     &  M12*(-35*MCha2**3+27*MCha2**2*MSQ2+105*MCha2*MSQ2**2-97*MSQ2**
     &  3))*SW**4)/(144.*alambda1**2*CW**2*SW**2))+(-(aetcha*(M12**2-
     &  M14)*(M14+3*MCha2**2+2*MCha2*MSQ2+3*MSQ2**2)*(3*CW**2+SW**2))
     &  /(18.*CW**2)+(aet1*(-9*CW**4*M12*(-M14**2-(MCha2-MSQ2)**2*
     &  ((MCha2-MSQ2)**2-4*M12*(MCha2+MSQ2))+M14*(4*M12*(MCha2+MSQ2)-2*
     &  (3*MCha2**2+2*MCha2*MSQ2+3*MSQ2**2)))+6*CW**2*(M12**2*(26*M14*
     &  MCha2+22*MCha2**3+28*M14*MSQ2-32*MCha2**2*MSQ2-50*MCha2*MSQ2**
     &  2+28*MSQ2**3)+2*(MCha2-MSQ2)*(2*M14**2+(MCha2-2*MSQ2)*(MCha2-
     &  MSQ2)**3+3*M14*(3*MCha2**2+MCha2*MSQ2+4*MSQ2**2))-M12*(7*M14**
     &  2+(MCha2-MSQ2)**2*(15*MCha2**2-22*MCha2*MSQ2-9*MSQ2**2)+M14*
     &  (50*MCha2**2+20*MCha2*MSQ2+26*MSQ2**2)))*SW**2+(4*M12**2*(34*
     &  M14*MCha2+32*MCha2**3+35*M14*MSQ2-37*MCha2**2*MSQ2-46*MCha2*
     &  MSQ2**2+35*MSQ2**3)+4*(MCha2-MSQ2)*(2*M14**2+(MCha2-2*MSQ2)*
     &  (MCha2-MSQ2)**3+3*M14*(3*MCha2**2+MCha2*MSQ2+4*MSQ2**2))-M12*
     &  (35*M14**2+(MCha2-MSQ2)**2*(51*MCha2**2-86*MCha2*MSQ2+3*MSQ2**
     &  2)+2*M14*(113*MCha2**2+62*MCha2*MSQ2+89*MSQ2**2)))*SW**4))
     &  /(144.*CW**2*M12*SW**2)+(aet5*(9*CW**4*M12*(2*M12**5+(2*MCha2-
     &  3*MSQ2)*(MCha2-MSQ2)**4-M14**2*(6*MCha2+11*MSQ2)+M14*(4*MCha2**
     &  3-2*MCha2**2*MSQ2+8*MCha2*MSQ2**2-26*MSQ2**3)+2*M12*(-((MCha2-
     &  MSQ2)**2*(3*MCha2**2-7*MSQ2**2))+2*M14*(MCha2**2+3*MCha2*MSQ2+
     &  6*MSQ2**2)))+6*CW**2*(2*M12**6-M14*(MCha2-MSQ2)*(7*M14*MCha2+5*
     &  MCha2**3+8*M14*MSQ2-10*MCha2**2*MSQ2-3*MCha2*MSQ2**2+8*MSQ2**3)
     &  -M12**2*(2*M14**2+M14*(5*MCha2**2+7*MCha2*MSQ2+4*MSQ2**2)+
     &  (MCha2-MSQ2)**2*(7*MCha2**2+13*MCha2*MSQ2+4*MSQ2**2))+M12*(3*
     &  MCha2-MSQ2)*(M14**2+(MCha2-MSQ2)**4+M14*(6*MCha2**2+4*MCha2*
     &  MSQ2+6*MSQ2**2)))*SW**2+(2*M12**6-2*M14*(MCha2-MSQ2)*(7*M14*
     &  MCha2+5*MCha2**3+8*M14*MSQ2-10*MCha2**2*MSQ2-3*MCha2*MSQ2**2+8*
     &  MSQ2**3)-2*M12**2*(2*M14**2+(MCha2-MSQ2)**2*(4*MCha2**2-19*
     &  MCha2*MSQ2-21*MSQ2**2)+M14*(7*MCha2**2-19*MCha2*MSQ2-16*MSQ2**
     &  2))+M12*(M14**2*(12*MCha2-7*MSQ2)+(4*MCha2-15*MSQ2)*(MCha2-
     &  MSQ2)**4+M14*(32*MCha2**3-82*MCha2**2*MSQ2-44*MCha2*MSQ2**2-82*
     &  MSQ2**3)))*SW**4))/(72.*CW**2*M12*MSQ2*SW**2)+(9*CW**4*M12*((-
     &  17+4*LogM12*(-5+8*logMSQ2))*M12**5-16*M12**2*((-3+3*logcha+
     &  LogM12)*MCha2**3-(7+LogM12+logMSQ2-2*LogM12*logMSQ2+2*logcha*(-
     &  3+LogM12+logMSQ2))*MCha2**2*MSQ2+(-7-LogM12+logcha*(-1+2*
     &  LogM12-2*logMSQ2)+6*logMSQ2-2*LogM12*logMSQ2)*MCha2*MSQ2**2+(-
     &  3+LogM12+3*logMSQ2)*MSQ2**3+M14*((-3+logcha+3*LogM12)*MCha2+(-
     &  3+3*LogM12+logMSQ2)*MSQ2))+M12*(4*(-3+4*LogM12)*M14**2-2*M14*
     &  ((99+4*logcha*(5+LogM12+4*logMSQ2)-8*LogM12*(7+6*logMSQ2))*
     &  MCha2**2+2*(37+32*logMSQ2+6*logcha*(-5+4*LogM12+logMSQ2)-2*
     &  LogM12*(7+22*logMSQ2))*MCha2*MSQ2+(71+LogM12*(84-132*logMSQ2)-
     &  40*logMSQ2)*MSQ2**2)+(MCha2-MSQ2)*((187-44*LogM12+8*logcha*(-7+
     &  5*LogM12-12*logMSQ2))*MCha2**3-(1+(96-88*logcha)*logMSQ2+4*
     &  LogM12*(-35+22*logcha+12*logMSQ2))*MCha2**2*MSQ2+(137+48*
     &  logMSQ2+24*logcha*(-7+2*LogM12+5*logMSQ2)+4*LogM12*(-37+26*
     &  logMSQ2))*MCha2*MSQ2**2+(237+LogM12*(52-56*logMSQ2)-176*
     &  logMSQ2)*MSQ2**3))+2*(M14**2*(4*(23+logcha*(-1+3*LogM12)-3*
     &  LogM12*(1+4*logMSQ2))*MCha2+(15+LogM12*(56-76*logMSQ2)+4*
     &  logMSQ2)*MSQ2)+(MCha2-MSQ2)**3*(2*(-1+logcha*(-4+8*logMSQ2))*
     &  MCha2**2-3*(-1+8*logcha*(-1+logMSQ2)+4*logMSQ2)*MCha2*MSQ2+(-
     &  41+28*logMSQ2)*MSQ2**2)-2*M14*((59-6*LogM12+2*logcha*(-23+7*
     &  LogM12-12*logMSQ2)+8*LogM12*logMSQ2)*MCha2**3-2*(-84+2*logcha*
     &  (9+2*LogM12-3*logMSQ2)+30*logMSQ2+7*LogM12*logMSQ2)*MCha2**2*
     &  MSQ2+(11+50*LogM12-64*logMSQ2-12*LogM12*logMSQ2-2*logcha*(-29+
     &  19*LogM12+8*logMSQ2))*MCha2*MSQ2**2+2*(-25+18*logMSQ2+LogM12*(-
     &  22+25*logMSQ2))*MSQ2**3)))+6*CW**2*((271+4*LogM12*(-61+8*
     &  logMSQ2))*M12**6+16*M14*(MCha2-MSQ2)*((MCha2-MSQ2)**2*(9*MCha2+
     &  8*MSQ2)+M14*(11*MCha2+8*MSQ2))-16*M12**3*((2+12*logcha*(1+
     &  LogM12)-4*logMSQ2-LogM12*(4+5*logMSQ2))*MCha2**3+2*(6+4*logcha*
     &  (-1+LogM12)-LogM12*(5+logMSQ2))*MCha2**2*MSQ2+(-30+4*logcha*(-
     &  1+3*LogM12)+4*logMSQ2-LogM12*(8+logMSQ2))*MCha2*MSQ2**2+2*
     &  LogM12*(11-4*logMSQ2)*MSQ2**3+M14*((-2+12*LogM12+4*logcha*(1+
     &  LogM12)-4*logMSQ2-7*LogM12*logMSQ2)*MCha2+2*LogM12*(9-4*
     &  logMSQ2)*MSQ2))+2*M12*(M14**2*((-266+308*LogM12+logcha*(-4+60*
     &  LogM12)+8*logMSQ2-32*LogM12*logMSQ2)*MCha2-(239+20*logMSQ2+4*
     &  LogM12*(-98+11*logMSQ2))*MSQ2)+(MCha2-MSQ2)**3*(8*(3+LogM12+2*
     &  logcha*(-3+logMSQ2)+logMSQ2+LogM12*logMSQ2)*MCha2**2+(91-36*
     &  logMSQ2+8*logcha*logMSQ2-8*LogM12*(2+3*logMSQ2))*MCha2*MSQ2+(5-
     &  20*logMSQ2+8*LogM12*(1+2*logMSQ2))*MSQ2**2)+2*M14*((-77+24*
     &  logMSQ2+2*logcha*(-7+29*LogM12+12*logMSQ2)+LogM12*(50+28*
     &  logMSQ2))*MCha2**3+2*(9+LogM12*(10-13*logMSQ2)-64*logMSQ2+
     &  logcha*(22-40*LogM12+38*logMSQ2))*MCha2**2*MSQ2+(79+32*logMSQ2-
     &  2*LogM12*(95+4*logMSQ2)+logcha*(-70+54*LogM12+24*logMSQ2))*
     &  MCha2*MSQ2**2+2*(24+LogM12*(60-13*logMSQ2)-16*logMSQ2)*MSQ2**3)
     &  )-M12**2*(16*(4+logMSQ2+LogM12*(-5+2*logMSQ2))*M14**2+2*M14*((-
     &  177+216*LogM12+80*logMSQ2+80*LogM12*logMSQ2+4*logcha*(-23+13*
     &  LogM12+4*logMSQ2))*MCha2**2+2*(189-38*LogM12-64*logMSQ2+52*
     &  LogM12*logMSQ2+2*logcha*(-27+12*LogM12+7*logMSQ2))*MCha2*MSQ2+
     &  (-165+244*LogM12-88*logMSQ2+44*LogM12*logMSQ2)*MSQ2**2)-(MCha2-
     &  MSQ2)*((-89+8*logcha*(29+LogM12-12*logMSQ2)-80*logMSQ2-12*
     &  LogM12*(9+8*logMSQ2))*MCha2**3+(8*logcha*(64+LogM12-33*logMSQ2)
     &  +7*(-163+48*logMSQ2)+4*LogM12*(43+60*logMSQ2))*MCha2**2*MSQ2-
     &  (435+8*logcha*(9+2*LogM12-3*logMSQ2)-384*logMSQ2+4*LogM12*(5+
     &  22*logMSQ2))*MCha2*MSQ2**2-(15-32*logMSQ2+LogM12*(44+56*
     &  logMSQ2))*MSQ2**3)))*SW**2+((787+4*LogM12*(-161+8*logMSQ2))*
     &  M12**6+32*M14*(MCha2-MSQ2)*((MCha2-MSQ2)**2*(9*MCha2+8*MSQ2)+
     &  M14*(11*MCha2+8*MSQ2))-16*M12**3*((7-9*LogM12+3*logcha*(7+8*
     &  LogM12)-8*logMSQ2-10*LogM12*logMSQ2)*MCha2**3+(31-19*LogM12+
     &  logMSQ2-6*LogM12*logMSQ2+2*logcha*(-11+9*LogM12+logMSQ2))*
     &  MCha2**2*MSQ2+(-53-15*LogM12+2*logMSQ2+logcha*(-7+22*LogM12+2*
     &  logMSQ2))*MCha2*MSQ2**2+(3+LogM12*(43-16*logMSQ2)-3*logMSQ2)*
     &  MSQ2**3+M14*((-1+7*logcha+21*LogM12+8*logcha*LogM12-8*logMSQ2-
     &  14*LogM12*logMSQ2)*MCha2-(-3-33*LogM12+logMSQ2+16*LogM12*
     &  logMSQ2)*MSQ2))+2*M12*(M14**2*(4*(-210+217*LogM12+logcha*(-21+
     &  47*LogM12)+4*logMSQ2-4*LogM12*logMSQ2)*MCha2-(917+140*logMSQ2+
     &  12*LogM12*(-98+5*logMSQ2))*MSQ2)+(MCha2-MSQ2)**3*(2*(-55+8*
     &  logMSQ2+8*LogM12*(1+logMSQ2)+4*logcha*(5+2*logMSQ2))*MCha2**2-
     &  (29-4*logMSQ2+16*LogM12*(2+3*logMSQ2)+8*logcha*(-13+11*logMSQ2)
     &  )*MCha2*MSQ2+(-221+124*logMSQ2+16*LogM12*(1+2*logMSQ2))*MSQ2**
     &  2)+2*M14*((-203+102*LogM12+48*logMSQ2+64*LogM12*logMSQ2+logcha*
     &  (-2+250*LogM12+24*logMSQ2))*MCha2**3+2*(364-84*LogM12-134*
     &  logMSQ2-149*LogM12*logMSQ2+logcha*(-62+28*LogM12+66*logMSQ2))*
     &  MCha2**2*MSQ2+(981-450*LogM12-160*logMSQ2-236*LogM12*logMSQ2+2*
     &  logcha*(-197+119*LogM12+88*logMSQ2))*MCha2*MSQ2**2+2*(137+
     &  LogM12*(258-37*logMSQ2)-230*logMSQ2)*MSQ2**3))-M12**2*(4*(29+8*
     &  logMSQ2+4*LogM12*(-9+4*logMSQ2))*M14**2+2*M14*((-577+160*
     &  logMSQ2+4*logcha*(-79+85*LogM12+4*logMSQ2)+8*LogM12*(85+26*
     &  logMSQ2))*MCha2**2+2*(377+LogM12*(202-28*logMSQ2)-224*logMSQ2+
     &  2*logcha*(-131+84*LogM12+31*logMSQ2))*MCha2*MSQ2+(-717-616*
     &  logMSQ2+4*LogM12*(305+19*logMSQ2))*MSQ2**2)+(MCha2-MSQ2)*((-
     &  343+160*logMSQ2+8*logcha*(11+23*LogM12+12*logMSQ2)+4*LogM12*
     &  (31+48*logMSQ2))*MCha2**3-(-1301+8*logcha*(16+LogM12-9*logMSQ2)
     &  +384*logMSQ2+LogM12*(476+848*logMSQ2))*MCha2**2*MSQ2+(-1917-16*
     &  logMSQ2-8*logcha*(-113+22*LogM12+75*logMSQ2)+LogM12*(580+504*
     &  logMSQ2))*MCha2*MSQ2**2+(-1201+1104*logMSQ2+76*LogM12*(-3+2*
     &  logMSQ2))*MSQ2**3)))*SW**4)/(1152.*CW**2*M12*SW**2))/alambda1**2
       selfZ=selfZ+CF12F3S*CF12F3SC*abrz(1)
c
c chargino diagrams, top quark
c

       !Stop diagrams
       abrz(1)=(-(aet2*M22)+I0A2*M22+aet4*M42-I0A3*M42+2*aet2*MCha2-2*
     &  aet4*MCha2-I0A2*MCha2+I0A3*MCha2+M22*MCha2-logcha*M22*MCha2+(-
     &  1+logcha)*LogM22*M22*MCha2-M42*MCha2+logcha*M42*MCha2-(-1+
     &  logcha)*LogM42*M42*MCha2)/(4.*M22m42)
       abrz(2)=(-2*aet2*(M22-MCha2)+M22*(2*I0A2+3*M22-2*LogM22*M22+
     &  MCha2-2*logcha*MCha2+2*logcha*LogM22*MCha2))/(4.*M22)
       abrz(3)=(-2*aet4*(M42-MCha2)+M42*(2*I0A3+3*M42-2*LogM42*M42+
     &  MCha2-2*logcha*MCha2+2*logcha*LogM42*MCha2))/(4.*M42)
       abrz(4)=(-24*aet2*M24+24*I0A2*M24+41*M22*M24+40*aet2*M22*MCha2-
     &  16*I0A2*M22*MCha2-3*M24*MCha2-24*logcha*M24*MCha2-16*aet2*
     &  MCha2**2+2*M22*MCha2**2+8*logcha*M22*MCha2**2+4*LogM22*M22*(-7*
     &  M24+MCha2*((3+6*logcha)*M22-4*logcha*MCha2)))/(16.*M22*(M2-
     &  MCha)*(M2+MCha))
       abrz(5)=(-8*aet4*(3*M42**2-5*M42*MCha2+2*MCha2**2)+M42*((41-28*
     &  LogM42)*M42**2+8*I0A3*(3*M42-2*MCha2)+3*(-1+8*logcha*(-1+
     &  LogM42)+4*LogM42)*M42*MCha2+2*(1+logcha*(4-8*LogM42))*MCha2**2)
     &  )/(16.*M42*(M4-MCha)*(M4+MCha))
       abrz(6)=(-8*aet2*M24+8*I0A2*M24-7*M22*M24+24*aet4*M22*M42-24*
     &  I0A3*M22*M42-16*aet4*M42**2+16*I0A3*M42**2-7*M22*M42**2+14*M42*
     &  *3+16*aet2*M22*MCha2-32*aet4*M22*MCha2-8*I0A2*M22*MCha2+8*I0A3*
     &  M22*MCha2+18*M24*MCha2-8*logcha*M24*MCha2+16*aet4*M42*MCha2-28*
     &  M22*M42*MCha2+24*logcha*M22*M42*MCha2+10*M42**2*MCha2-16*
     &  logcha*M42**2*MCha2+4*LogM22*M24*(M22+2*(-2+logcha)*MCha2)+4*
     &  LogM42*M42*(M22*(M42-6*(-1+logcha)*MCha2)-2*M42*(M42+MCha2-2*
     &  logcha*MCha2)))/(16.*M22m42**2)
       abrz(7)=(-16*aet2*M24+16*I0A2*M24+14*M22*M24+24*aet2*M22*M42-24*
     &  I0A2*M22*M42-7*M24*M42-8*aet4*M42**2+8*I0A3*M42**2-7*M42**3+16*
     &  aet2*M22*MCha2+10*M24*MCha2-16*logcha*M24*MCha2-32*aet2*M42*
     &  MCha2+16*aet4*M42*MCha2+8*I0A2*M42*MCha2-8*I0A3*M42*MCha2-28*
     &  M22*M42*MCha2+24*logcha*M22*M42*MCha2+18*M42**2*MCha2-8*logcha*
     &  M42**2*MCha2+4*LogM42*M42**2*(M42+2*(-2+logcha)*MCha2)-4*
     &  LogM22*(-(M24*(M42-2*MCha2+4*logcha*MCha2))+2*M22*(M24+3*(-1+
     &  logcha)*M42*MCha2)))/(16.*M22m42**2)
       abrz(8)=((-8*aet4*M42+8*I0A3*M42+17*M42**2-12*LogM42*M42**2+8*
     &  aet4*MCha2+13*M42*MCha2-8*logcha*M42*MCha2-4*LogM42*M42*MCha2+
     &  8*logcha*LogM42*M42*MCha2+10*MCha2**2-8*logcha*MCha2**2)*(3*CW*
     &  *2+SW**2))/(48.*CW*(M4-MCha)*(M4+MCha)*SW)
       abrz(9)=-((8*aet2*M22-8*I0A2*M22-7*M24-8*aet4*M42+8*I0A3*M42+7*
     &  M42**2-8*I0A2*MCha2+8*I0A3*MCha2-12*M22*MCha2+8*logcha*M22*
     &  MCha2+12*M42*MCha2-8*logcha*M42*MCha2-4*LogM42*M42*(M42-2*(-1+
     &  logcha)*MCha2)+4*LogM22*(M24-2*(-1+logcha)*M22*MCha2))*(3*CW**
     &  2+SW**2))/(96.*CW*M22m42*SW)
       abrz(10)=((-8*aet2*M22+8*I0A2*M22+17*M24-12*LogM22*M24+8*aet2*
     &  MCha2+13*M22*MCha2-8*logcha*M22*MCha2-4*LogM22*M22*MCha2+8*
     &  logcha*LogM22*M22*MCha2+10*MCha2**2-8*logcha*MCha2**2)*(3*CW**
     &  2+SW**2))/(48.*CW*(M2-MCha)*(M2+MCha)*SW)
       abrz(11)=((-8*aet4*M42+8*I0A3*M42+17*M42**2+8*aet4*MCha2+13*M42*
     &  MCha2-8*logcha*M42*MCha2+10*MCha2**2-8*logcha*MCha2**2-4*
     &  LogM42*M42*(3*M42+MCha2-2*logcha*MCha2))*(3*CW**2+SW**2)**2)
     &  /(576.*CW**2*(M4-MCha)*(M4+MCha)*SW**2)
       abrz(12)=((-8*aet2*M22+8*I0A2*M22+17*M24+8*aet2*MCha2+13*M22*
     &  MCha2-8*logcha*M22*MCha2+10*MCha2**2-8*logcha*MCha2**2-4*
     &  LogM22*(3*M24+(1-2*logcha)*M22*MCha2))*(3*CW**2+SW**2)**2)
     &  /(576.*CW**2*(M2-MCha)*(M2+MCha)*SW**2)
       selfZ=selfZ+(CF12F4S(1)*(CF12F4SC(1)*(abrz(12)+abrz(10)*
     &  CS13S13V2(1,1)+abrz(4)*CS13S13V2(1,1)**2+abrz(7)*CS13S13V2(1,2)
     &  *CS13S13V2(2,1)+abrz(2)*CS13S13V2V2(1,1))+CF12F4SC(2)*(abrz(7)*
     &  CS13S13V2(1,1)*CS13S13V2(1,2)+CS13S13V2(1,2)*(abrz(9)+abrz(6)*
     &  CS13S13V2(2,2))+abrz(1)*CS13S13V2V2(1,2)))+CF12F4S(2)*
     &  (CF12F4SC(1)*(abrz(7)*CS13S13V2(1,1)*CS13S13V2(2,1)+
     &  CS13S13V2(2,1)*(abrz(9)+abrz(6)*CS13S13V2(2,2))+abrz(1)*
     &  CS13S13V2V2(2,1))+CF12F4SC(2)*(abrz(11)+abrz(6)*CS13S13V2(1,2)*
     &  CS13S13V2(2,1)+abrz(8)*CS13S13V2(2,2)+abrz(5)*CS13S13V2(2,2)**
     &  2+abrz(3)*CS13S13V2V2(2,2))))

c
c chargino diagrams, Stops
c

       do h1=ineu,3
       afin(1)=(M1*(-aet2+aet4+I0A4(h1)-I0A5(h1))*MNeu(h1))/M22m42
       afin(2)=-((M1*MNeu(h1)*(aet2*M12**2-2*aet2*M12*M22+M12**2*M22+
     &  aet2*M22**2-M22**3+M12*M22*A0TNeu(h1)-M22**2*A0TNeu(h1)+M12*
     &  M22*I0A4(h1)-M22**2*I0A4(h1)+aet2*MNeu(h1)**4+M22*MNeu(h1)**4-
     &  2*aet2*M12*MNeu2(h1)-2*aet2*M22*MNeu2(h1)+2*M12*M22*MNeu2(h1)+
     &  M22*A0TNeu(h1)*MNeu2(h1)+M22*I0A4(h1)*MNeu2(h1)-a0t2*(M12**2-3*
     &  M12*M22+2*M22**2+MNeu(h1)**4+A0TNeu(h1)*(M12+M22-MNeu2(h1))-2*
     &  M12*MNeu2(h1)-3*M22*MNeu2(h1))+a0t1*((M12-M22)*(a0t2+M22)+2*
     &  M22*A0TNeu(h1)+(-a0t2+M22)*MNeu2(h1))))/(alambda2(h1)*M22))
       afin(3)=-((M1*MNeu(h1)*(aet4*M12**2-2*aet4*M12*M42+M12**2*M42+
     &  aet4*M42**2-M42**3+M12*M42*A0TNeu(h1)-M42**2*A0TNeu(h1)+M12*
     &  M42*I0A5(h1)-M42**2*I0A5(h1)+aet4*MNeu(h1)**4+M42*MNeu(h1)**4-
     &  2*aet4*M12*MNeu2(h1)-2*aet4*M42*MNeu2(h1)+2*M12*M42*MNeu2(h1)+
     &  M42*A0TNeu(h1)*MNeu2(h1)+M42*I0A5(h1)*MNeu2(h1)-a0t4*(M12**2-3*
     &  M12*M42+2*M42**2+MNeu(h1)**4+A0TNeu(h1)*(M12+M42-MNeu2(h1))-2*
     &  M12*MNeu2(h1)-3*M42*MNeu2(h1))+a0t1*((M12-M42)*(a0t4+M42)+2*
     &  M42*A0TNeu(h1)+(-a0t4+M42)*MNeu2(h1))))/(alambda3(h1)*M42))
       afin(4)=(-(a0t1*a0t2)+a0t1*a0t4-2*aet2*M12+2*aet4*M12+aet2*M22-
     &  aet4*M42+(-a0t2+a0t4)*A0TNeu(h1)-M12*I0A5(h1)+M42*I0A5(h1)-2*
     &  aet2*MNeu2(h1)+2*aet4*MNeu2(h1)-I0A5(h1)*MNeu2(h1)+I0A4(h1)*
     &  (M12-M22+MNeu2(h1)))/(2.*M22m42)
       afin(5)=-((M12-M22+MNeu2(h1))**2*(2*a0t1+2*a0t2+M12+M22+2*
     &  A0TNeu(h1)+MNeu2(h1))-2*(M12-M22+MNeu2(h1))*((-a0t1+M12)*
     &  A0TNeu(h1)-M12*AETNeu(h1)+(a0t1-aet1)*MNeu2(h1))-2*(aet1+aet2+
     &  AETNeu(h1)-I0A4(h1))*((M12-M22)**2+MNeu(h1)**4-2*M22*MNeu2(h1))
     &  +(2*(-(a0t2*M12)+aet2*M12+a0t1*(a0t2-M22)+aet1*M22)*((M12-M22)*
     &  *2-(M12+M22)*MNeu2(h1)))/M22+(2*((a0t2-M22)*A0TNeu(h1)+M22*
     &  AETNeu(h1)+(-a0t2+aet2)*MNeu2(h1))*(M22*(-M12+M22)+MNeu(h1)**4-
     &  (M12+2*M22)*MNeu2(h1)))/M22)/(2.*(M1+M2-MNeu(h1))*(M1+M2+
     &  MNeu(h1))*((M1-M2)**2-MNeu2(h1)))
       afin(6)=-((M12-M42+MNeu2(h1))**2*(2*a0t1+2*a0t4+M12+M42+2*
     &  A0TNeu(h1)+MNeu2(h1))-2*(M12-M42+MNeu2(h1))*((-a0t1+M12)*
     &  A0TNeu(h1)-M12*AETNeu(h1)+(a0t1-aet1)*MNeu2(h1))-2*(aet1+aet4+
     &  AETNeu(h1)-I0A5(h1))*((M12-M42)**2+MNeu(h1)**4-2*M42*MNeu2(h1))
     &  +(2*(-(a0t4*M12)+aet4*M12+a0t1*(a0t4-M42)+aet1*M42)*((M12-M42)*
     &  *2-(M12+M42)*MNeu2(h1)))/M42+(2*((a0t4-M42)*A0TNeu(h1)+M42*
     &  AETNeu(h1)+(-a0t4+aet4)*MNeu2(h1))*(M42*(-M12+M42)+MNeu(h1)**4-
     &  (M12+2*M42)*MNeu2(h1)))/M42)/(2.*(M1+M4-MNeu(h1))*(M1+M4+
     &  MNeu(h1))*((M1-M4)**2-MNeu2(h1)))
       afin(7)=(MNeu(h1)*((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*
     &  M22+4*aet1*M22-M12*M22)/M22m42+(-4*a0t1*a0t4+2*a0t4*M12-4*aet4*
     &  M12+2*a0t1*M42-4*aet1*M42+M12*M42)/M22m42+((4*a0t1*a0t2-2*a0t2*
     &  M12+4*aet2*M12-2*a0t1*M22+4*aet1*M22-M12*M22)*(M12+M22-
     &  MNeu2(h1))*(M12-M22+MNeu2(h1)))/(alambda2(h1)*M22m42)+((-4*a0t1*
     &  a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(M12+
     &  M42-MNeu2(h1))*(M12-M42+MNeu2(h1)))/(alambda3(h1)*M22m42)-(4*M12*
     &  (M12-M2*M4-MNeu2(h1))*(M12+M2*M4-MNeu2(h1))*(2*(-2*a0t1+M12)*
     &  A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*MNeu2(h1)))
     &  /(alambda2(h1)*alambda3(h1))+(2*M12*(M12+M22-MNeu2(h1))*(2*(-2*a0t2+
     &  M22)*A0TNeu(h1)-4*M22*AETNeu(h1)+(2*a0t2-4*aet2+M22)*MNeu2(h1))
     &  )/(alambda2(h1)*M22m42)-(2*M12*(M12+M42-MNeu2(h1))*(2*(-2*a0t4+M42)
     &  *A0TNeu(h1)-4*M42*AETNeu(h1)+(2*a0t4-4*aet4+M42)*MNeu2(h1)))
     &  /(alambda3(h1)*M22m42)+(M12*((M12+M22+MNeu2(h1))*(M12**2+M12*M22-2*
     &  M22**2+MNeu(h1)**4+(-2*M12+M22)*MNeu2(h1))+2*(2*a0t1+2*a0t2+
     &  M12+M22+2*A0TNeu(h1)+MNeu2(h1))*(M12**2+M12*M22-2*M22**2+
     &  MNeu(h1)**4+(-2*M12+M22)*MNeu2(h1))-8*(aet1+aet2+AETNeu(h1)-
     &  I0A4(h1))*(M12*(M12-M22)+MNeu(h1)**4-(2*M12+M22)*MNeu2(h1))))
     &  /(alambda2(h1)*M22m42)+(8*M12*(-((M12+M42+MNeu2(h1))*(M12**2+M12*
     &  M42-2*M42**2+MNeu(h1)**4+(-2*M12+M42)*MNeu2(h1)))/8.-((2*a0t1+
     &  2*a0t4+M12+M42+2*A0TNeu(h1)+MNeu2(h1))*(M12**2+M12*M42-2*M42**
     &  2+MNeu(h1)**4+(-2*M12+M42)*MNeu2(h1)))/4.+(aet1+aet4+AETNeu(h1)
     &  -I0A5(h1))*(M12*(M12-M42)+MNeu(h1)**4-(2*M12+M42)*MNeu2(h1))))
     &  /(alambda3(h1)*M22m42)))/(16.*M1)
       afin(8)=(M1*MNeu(h1)*(-4*a0t1*M12**3+4*a0t2*M12**3+M12**4+12*
     &  a0t1*M12**2*M22-12*a0t2*M12**2*M22-4*M12**3*M22-12*a0t1*M12*
     &  M22**2+12*a0t2*M12*M22**2+6*M12**2*M22**2+4*a0t1*M22**3-4*a0t2*
     &  M22**3-4*M12*M22**3+M22**4-2*(2*a0t1*(2*a0t2+3*M12+M22)+(2*
     &  a0t2-3*M12-M22)*(M12+3*M22))*MNeu(h1)**4+4*(a0t1+a0t2-M12-M22)*
     &  MNeu(h1)**6+MNeu(h1)**8+8*a0t1*a0t2*M12*MNeu2(h1)+12*a0t1*M12**
     &  2*MNeu2(h1)-4*a0t2*M12**2*MNeu2(h1)-4*M12**3*MNeu2(h1)+8*a0t1*
     &  a0t2*M22*MNeu2(h1)+8*a0t1*M12*M22*MNeu2(h1)+8*a0t2*M12*M22*
     &  MNeu2(h1)+20*M12**2*M22*MNeu2(h1)-4*a0t1*M22**2*MNeu2(h1)+12*
     &  a0t2*M22**2*MNeu2(h1)+20*M12*M22**2*MNeu2(h1)-4*M22**3*
     &  MNeu2(h1)+16*M12*M22*I0A4(h1)*MNeu2(h1)-4*A0TNeu(h1)*((M12-M22)
     &  *(2*a0t2*M12-M12**2-2*a0t1*M22+M22**2)-3*(M12+M22)*MNeu(h1)**4+
     &  MNeu(h1)**6+(-2*a0t2*M12+3*M12**2-2*a0t1*M22-2*M12*M22+3*M22**
     &  2)*MNeu2(h1))))/(8.*alambda2(h1)**2)
       afin(9)=(M1*MNeu(h1)*(-4*a0t1*M12**3+4*a0t4*M12**3+M12**4+12*
     &  a0t1*M12**2*M42-12*a0t4*M12**2*M42-4*M12**3*M42-12*a0t1*M12*
     &  M42**2+12*a0t4*M12*M42**2+6*M12**2*M42**2+4*a0t1*M42**3-4*a0t4*
     &  M42**3-4*M12*M42**3+M42**4-2*(2*a0t1*(2*a0t4+3*M12+M42)+(2*
     &  a0t4-3*M12-M42)*(M12+3*M42))*MNeu(h1)**4+4*(a0t1+a0t4-M12-M42)*
     &  MNeu(h1)**6+MNeu(h1)**8+8*a0t1*a0t4*M12*MNeu2(h1)+12*a0t1*M12**
     &  2*MNeu2(h1)-4*a0t4*M12**2*MNeu2(h1)-4*M12**3*MNeu2(h1)+8*a0t1*
     &  a0t4*M42*MNeu2(h1)+8*a0t1*M12*M42*MNeu2(h1)+8*a0t4*M12*M42*
     &  MNeu2(h1)+20*M12**2*M42*MNeu2(h1)-4*a0t1*M42**2*MNeu2(h1)+12*
     &  a0t4*M42**2*MNeu2(h1)+20*M12*M42**2*MNeu2(h1)-4*M42**3*
     &  MNeu2(h1)+16*M12*M42*I0A5(h1)*MNeu2(h1)-4*A0TNeu(h1)*((M12-M42)
     &  *(2*a0t4*M12-M12**2-2*a0t1*M42+M42**2)-3*(M12+M42)*MNeu(h1)**4+
     &  MNeu(h1)**6+(-2*a0t4*M12+3*M12**2-2*a0t1*M42-2*M12*M42+3*M42**
     &  2)*MNeu2(h1))))/(8.*alambda3(h1)**2)
       afin(10)=(-8*aet1*M12**4+M12**5+32*aet1*M12**3*M22+12*M12**4*
     &  M22-48*aet1*M12**2*M22**2-42*M12**3*M22**2+32*aet1*M12*M22**3+
     &  44*M12**2*M22**3-8*aet1*M22**4-15*M12*M22**4+8*M12**4*I0A4(h1)-
     &  24*M12**3*M22*I0A4(h1)+24*M12**2*M22**2*I0A4(h1)-8*M12*M22**3*
     &  I0A4(h1)-48*aet1*M12**2*MNeu(h1)**4-42*M12**3*MNeu(h1)**4-32*
     &  aet1*M12*M22*MNeu(h1)**4-12*M12**2*M22*MNeu(h1)**4-48*aet1*M22*
     &  *2*MNeu(h1)**4-26*M12*M22**2*MNeu(h1)**4-16*M12*M22*A0TNeu(h1)*
     &  MNeu(h1)**4+24*M12**2*I0A4(h1)*MNeu(h1)**4-8*M12*M22*I0A4(h1)*
     &  MNeu(h1)**4+32*aet1*M12*MNeu(h1)**6+44*M12**2*MNeu(h1)**6+32*
     &  aet1*M22*MNeu(h1)**6+12*M12*M22*MNeu(h1)**6-8*M12*I0A4(h1)*
     &  MNeu(h1)**6-8*aet1*MNeu(h1)**8-15*M12*MNeu(h1)**8+32*aet1*M12**
     &  3*MNeu2(h1)+12*M12**4*MNeu2(h1)-32*aet1*M12**2*M22*MNeu2(h1)-
     &  76*M12**3*M22*MNeu2(h1)-32*aet1*M12*M22**2*MNeu2(h1)+20*M12**2*
     &  M22**2*MNeu2(h1)+32*aet1*M22**3*MNeu2(h1)+44*M12*M22**3*
     &  MNeu2(h1)-16*M12**2*M22*A0TNeu(h1)*MNeu2(h1)+16*M12*M22**2*
     &  A0TNeu(h1)*MNeu2(h1)-24*M12**3*I0A4(h1)*MNeu2(h1)+24*M12*M22**
     &  2*I0A4(h1)*MNeu2(h1)+8*a0t2*M12*((M12-M22)**3+(7*M12+3*M22)*
     &  MNeu(h1)**4-3*MNeu(h1)**6+(-5*M12**2+4*M12*M22+M22**2)*
     &  MNeu2(h1)-A0TNeu(h1)*((M12-M22)**2+3*MNeu(h1)**4-4*(M12+M22)*
     &  MNeu2(h1)))+4*a0t1*(2*(15*M12**2+7*M12*M22+12*M22**2-a0t2*(M12+
     &  5*M22))*MNeu(h1)**4+2*(2*a0t2-8*M12-7*M22)*MNeu(h1)**6+3*
     &  MNeu(h1)**8+(M12-M22)*((2*a0t2+7*M12-5*M22)*(M12-M22)**2-2*(2*
     &  a0t2*M12+12*M12**2+4*a0t2*M22+3*M12*M22-9*M22**2)*MNeu2(h1))+2*
     &  A0TNeu(h1)*((M1**3-M1*M22)**2+(3*M12+2*M22)*MNeu(h1)**4-
     &  MNeu(h1)**6-(3*M12**2+4*M12*M22+M22**2)*MNeu2(h1))))/(32.*
     &  alambda2(h1)**2)
       afin(11)=-(56*aet1*M12**4-31*M12**5-224*aet1*M12**3*M22+12*M12**
     &  4*M22+336*aet1*M12**2*M22**2+150*M12**3*M22**2-224*aet1*M12*
     &  M22**3-212*M12**2*M22**3+56*aet1*M22**4+81*M12*M22**4-56*M12**
     &  4*I0A4(h1)+168*M12**3*M22*I0A4(h1)-168*M12**2*M22**2*I0A4(h1)+
     &  56*M12*M22**3*I0A4(h1)+336*aet1*M12**2*MNeu(h1)**4+150*M12**3*
     &  MNeu(h1)**4+224*aet1*M12*M22*MNeu(h1)**4-12*M12**2*M22*MNeu(h1)
     &  **4+336*aet1*M22**2*MNeu(h1)**4+38*M12*M22**2*MNeu(h1)**4+112*
     &  M12*M22*A0TNeu(h1)*MNeu(h1)**4-168*M12**2*I0A4(h1)*MNeu(h1)**4+
     &  56*M12*M22*I0A4(h1)*MNeu(h1)**4-224*aet1*M12*MNeu(h1)**6-212*
     &  M12**2*MNeu(h1)**6-224*aet1*M22*MNeu(h1)**6+12*M12*M22*MNeu(h1)
     &  **6+56*M12*I0A4(h1)*MNeu(h1)**6+56*aet1*MNeu(h1)**8+81*M12*
     &  MNeu(h1)**8-224*aet1*M12**3*MNeu2(h1)+12*M12**4*MNeu2(h1)+224*
     &  aet1*M12**2*M22*MNeu2(h1)+436*M12**3*M22*MNeu2(h1)+224*aet1*
     &  M12*M22**2*MNeu2(h1)-236*M12**2*M22**2*MNeu2(h1)-224*aet1*M22**
     &  3*MNeu2(h1)-212*M12*M22**3*MNeu2(h1)+112*M12**2*M22*A0TNeu(h1)*
     &  MNeu2(h1)-112*M12*M22**2*A0TNeu(h1)*MNeu2(h1)+168*M12**3*
     &  I0A4(h1)*MNeu2(h1)-168*M12*M22**2*I0A4(h1)*MNeu2(h1)-56*a0t2*
     &  M12*((M12-M22)**3+(7*M12+3*M22)*MNeu(h1)**4-3*MNeu(h1)**6+(-5*
     &  M12**2+4*M12*M22+M22**2)*MNeu2(h1)-A0TNeu(h1)*((M12-M22)**2+3*
     &  MNeu(h1)**4-4*(M12+M22)*MNeu2(h1)))-4*a0t1*(-2*(7*a0t2*(M12+5*
     &  M22)-3*(27*M12**2+11*M12*M22+20*M22**2))*MNeu(h1)**4+(28*a0t2-
     &  80*M12-66*M22)*MNeu(h1)**6+13*MNeu(h1)**8+14*A0TNeu(h1)*((M1**
     &  3-M1*M22)**2+(3*M12+2*M22)*MNeu(h1)**4-MNeu(h1)**6-(3*M12**2+4*
     &  M12*M22+M22**2)*MNeu2(h1))+(M12-M22)*((14*a0t2+41*M12-27*M22)*
     &  (M12-M22)**2-2*(68*M12**2+21*M12*M22-47*M22**2+14*a0t2*(M12+2*
     &  M22))*MNeu2(h1))))/(32.*alambda2(h1)**2)
       afin(12)=(-8*aet1*M12**4+M12**5+32*aet1*M12**3*M42+12*M12**4*
     &  M42-48*aet1*M12**2*M42**2-42*M12**3*M42**2+32*aet1*M12*M42**3+
     &  44*M12**2*M42**3-8*aet1*M42**4-15*M12*M42**4+8*M12**4*I0A5(h1)-
     &  24*M12**3*M42*I0A5(h1)+24*M12**2*M42**2*I0A5(h1)-8*M12*M42**3*
     &  I0A5(h1)-48*aet1*M12**2*MNeu(h1)**4-42*M12**3*MNeu(h1)**4-32*
     &  aet1*M12*M42*MNeu(h1)**4-12*M12**2*M42*MNeu(h1)**4-48*aet1*M42*
     &  *2*MNeu(h1)**4-26*M12*M42**2*MNeu(h1)**4-16*M12*M42*A0TNeu(h1)*
     &  MNeu(h1)**4+24*M12**2*I0A5(h1)*MNeu(h1)**4-8*M12*M42*I0A5(h1)*
     &  MNeu(h1)**4+32*aet1*M12*MNeu(h1)**6+44*M12**2*MNeu(h1)**6+32*
     &  aet1*M42*MNeu(h1)**6+12*M12*M42*MNeu(h1)**6-8*M12*I0A5(h1)*
     &  MNeu(h1)**6-8*aet1*MNeu(h1)**8-15*M12*MNeu(h1)**8+32*aet1*M12**
     &  3*MNeu2(h1)+12*M12**4*MNeu2(h1)-32*aet1*M12**2*M42*MNeu2(h1)-
     &  76*M12**3*M42*MNeu2(h1)-32*aet1*M12*M42**2*MNeu2(h1)+20*M12**2*
     &  M42**2*MNeu2(h1)+32*aet1*M42**3*MNeu2(h1)+44*M12*M42**3*
     &  MNeu2(h1)-16*M12**2*M42*A0TNeu(h1)*MNeu2(h1)+16*M12*M42**2*
     &  A0TNeu(h1)*MNeu2(h1)-24*M12**3*I0A5(h1)*MNeu2(h1)+24*M12*M42**
     &  2*I0A5(h1)*MNeu2(h1)+8*a0t4*M12*((M12-M42)**3+(7*M12+3*M42)*
     &  MNeu(h1)**4-3*MNeu(h1)**6+(-5*M12**2+4*M12*M42+M42**2)*
     &  MNeu2(h1)-A0TNeu(h1)*((M12-M42)**2+3*MNeu(h1)**4-4*(M12+M42)*
     &  MNeu2(h1)))+4*a0t1*(2*(15*M12**2+7*M12*M42+12*M42**2-a0t4*(M12+
     &  5*M42))*MNeu(h1)**4+2*(2*a0t4-8*M12-7*M42)*MNeu(h1)**6+3*
     &  MNeu(h1)**8+(M12-M42)*((2*a0t4+7*M12-5*M42)*(M12-M42)**2-2*(2*
     &  a0t4*M12+12*M12**2+4*a0t4*M42+3*M12*M42-9*M42**2)*MNeu2(h1))+2*
     &  A0TNeu(h1)*((M1**3-M1*M42)**2+(3*M12+2*M42)*MNeu(h1)**4-
     &  MNeu(h1)**6-(3*M12**2+4*M12*M42+M42**2)*MNeu2(h1))))/(32.*
     &  alambda3(h1)**2)
       afin(13)=-(56*aet1*M12**4-31*M12**5-224*aet1*M12**3*M42+12*M12**
     &  4*M42+336*aet1*M12**2*M42**2+150*M12**3*M42**2-224*aet1*M12*
     &  M42**3-212*M12**2*M42**3+56*aet1*M42**4+81*M12*M42**4-56*M12**
     &  4*I0A5(h1)+168*M12**3*M42*I0A5(h1)-168*M12**2*M42**2*I0A5(h1)+
     &  56*M12*M42**3*I0A5(h1)+336*aet1*M12**2*MNeu(h1)**4+150*M12**3*
     &  MNeu(h1)**4+224*aet1*M12*M42*MNeu(h1)**4-12*M12**2*M42*MNeu(h1)
     &  **4+336*aet1*M42**2*MNeu(h1)**4+38*M12*M42**2*MNeu(h1)**4+112*
     &  M12*M42*A0TNeu(h1)*MNeu(h1)**4-168*M12**2*I0A5(h1)*MNeu(h1)**4+
     &  56*M12*M42*I0A5(h1)*MNeu(h1)**4-224*aet1*M12*MNeu(h1)**6-212*
     &  M12**2*MNeu(h1)**6-224*aet1*M42*MNeu(h1)**6+12*M12*M42*MNeu(h1)
     &  **6+56*M12*I0A5(h1)*MNeu(h1)**6+56*aet1*MNeu(h1)**8+81*M12*
     &  MNeu(h1)**8-224*aet1*M12**3*MNeu2(h1)+12*M12**4*MNeu2(h1)+224*
     &  aet1*M12**2*M42*MNeu2(h1)+436*M12**3*M42*MNeu2(h1)+224*aet1*
     &  M12*M42**2*MNeu2(h1)-236*M12**2*M42**2*MNeu2(h1)-224*aet1*M42**
     &  3*MNeu2(h1)-212*M12*M42**3*MNeu2(h1)+112*M12**2*M42*A0TNeu(h1)*
     &  MNeu2(h1)-112*M12*M42**2*A0TNeu(h1)*MNeu2(h1)+168*M12**3*
     &  I0A5(h1)*MNeu2(h1)-168*M12*M42**2*I0A5(h1)*MNeu2(h1)-56*a0t4*
     &  M12*((M12-M42)**3+(7*M12+3*M42)*MNeu(h1)**4-3*MNeu(h1)**6+(-5*
     &  M12**2+4*M12*M42+M42**2)*MNeu2(h1)-A0TNeu(h1)*((M12-M42)**2+3*
     &  MNeu(h1)**4-4*(M12+M42)*MNeu2(h1)))-4*a0t1*(-2*(7*a0t4*(M12+5*
     &  M42)-3*(27*M12**2+11*M12*M42+20*M42**2))*MNeu(h1)**4+(28*a0t4-
     &  80*M12-66*M42)*MNeu(h1)**6+13*MNeu(h1)**8+14*A0TNeu(h1)*((M1**
     &  3-M1*M42)**2+(3*M12+2*M42)*MNeu(h1)**4-MNeu(h1)**6-(3*M12**2+4*
     &  M12*M42+M42**2)*MNeu2(h1))+(M12-M42)*((14*a0t4+41*M12-27*M42)*
     &  (M12-M42)**2-2*(68*M12**2+21*M12*M42-47*M42**2+14*a0t4*(M12+2*
     &  M42))*MNeu2(h1))))/(32.*alambda3(h1)**2)
       afin(14)=((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*M22+4*aet1*
     &  M22-M12*M22)/M22m42+(-4*a0t1*a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*
     &  M42-4*aet1*M42+M12*M42)/M22m42+((4*a0t1*a0t2-2*a0t2*M12+4*aet2*
     &  M12-2*a0t1*M22+4*aet1*M22-M12*M22)*(M12-M22-MNeu2(h1))*(M12-
     &  M22+MNeu2(h1)))/(alambda2(h1)*M22m42)+((-4*a0t1*a0t4+2*a0t4*M12-4*
     &  aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(M12-M42-MNeu2(h1))*
     &  (M12-M42+MNeu2(h1)))/(alambda3(h1)*M22m42)+(2*M12*(M12-M22-
     &  MNeu2(h1))*(2*(-2*a0t2+M22)*A0TNeu(h1)-4*M22*AETNeu(h1)+(2*
     &  a0t2-4*aet2+M22)*MNeu2(h1)))/(alambda2(h1)*M22m42)-(2*M12*(M12-M42-
     &  MNeu2(h1))*(2*(-2*a0t4+M42)*A0TNeu(h1)-4*M42*AETNeu(h1)+(2*
     &  a0t4-4*aet4+M42)*MNeu2(h1)))/(alambda3(h1)*M22m42)-(2*(2*(-2*a0t1+
     &  M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*MNeu2(h1))
     &  *(M12*(M12-M22)*(M12-M42)-(M12+M22+M42)*MNeu(h1)**4+MNeu(h1)**
     &  6+(-M12**2+M22*M42+2*M12*(M22+M42))*MNeu2(h1)))/(alambda2(h1)*
     &  alambda3(h1))+(M12*(-8*(aet1+aet2+AETNeu(h1)-I0A4(h1))*((M12-M22)**
     &  2+MNeu(h1)**4-2*M12*MNeu2(h1))+(M12+M22+MNeu2(h1))*((M12-M22)**
     &  2+MNeu(h1)**4-2*(M12-2*M22)*MNeu2(h1))+2*(2*a0t1+2*a0t2+M12+
     &  M22+2*A0TNeu(h1)+MNeu2(h1))*((M12-M22)**2+MNeu(h1)**4-2*(M12-2*
     &  M22)*MNeu2(h1))))/(alambda2(h1)*M22m42)+(8*M12*((aet1+aet4+
     &  AETNeu(h1)-I0A5(h1))*((M12-M42)**2+MNeu(h1)**4-2*M12*MNeu2(h1))
     &  -((M12+M42+MNeu2(h1))*((M12-M42)**2+MNeu(h1)**4-2*(M12-2*M42)*
     &  MNeu2(h1)))/8.-((2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+MNeu2(h1))*
     &  ((M12-M42)**2+MNeu(h1)**4-2*(M12-2*M42)*MNeu2(h1)))/4.))
     &  /(alambda3(h1)*M22m42))/16.
       afin(15)=(M1*MNeu(h1)*((2*(-4*a0t1*a0t2+2*a0t2*M12-4*aet2*M12+2*
     &  a0t1*M22-4*aet1*M22+M12*M22)*M22m42*(-M12+M22+MNeu2(h1)))
     &  /alambda2(h1)+M42*(4*a0t1+4*a0t4+8*aet1+8*aet4+3*M12+3*M42+4*
     &  A0TNeu(h1)+8*AETNeu(h1)-8*I0A5(h1)+3*MNeu2(h1))-(4*M22*M22m42*
     &  (2*(-2*a0t1+M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+
     &  M12)*MNeu2(h1)))/alambda2(h1)+(2*M22m42*(M12+M22-MNeu2(h1))*(2*(-2*
     &  a0t2+M22)*A0TNeu(h1)-4*M22*AETNeu(h1)+(2*a0t2-4*aet2+M22)*
     &  MNeu2(h1)))/alambda2(h1)+(8*(-((aet1+aet2+AETNeu(h1)-I0A4(h1))*
     &  ((M12-M22)*(M22**2+M12*M42-2*M22*M42)+M42*MNeu(h1)**4+(M22**2-
     &  2*M12*M42-3*M22*M42)*MNeu2(h1)))-((M12+M22+MNeu2(h1))*((M12-
     &  M22)*(-3*M22**2+M12*M42+2*M22*M42)+M42*MNeu(h1)**4+(-3*M22**2-
     &  2*M12*M42+M22*M42)*MNeu2(h1)))/8.-((2*a0t1+2*a0t2+M12+M22+2*
     &  A0TNeu(h1)+MNeu2(h1))*((M12-M22)*(-3*M22**2+M12*M42+2*M22*M42)+
     &  M42*MNeu(h1)**4+(-3*M22**2-2*M12*M42+M22*M42)*MNeu2(h1)))/4.))
     &  /alambda2(h1)))/(8.*M22m42s)
       afin(16)=(8*aet1*M12**4-7*M12**5-32*aet1*M12**3*M22+12*M12**4*
     &  M22+48*aet1*M12**2*M22**2+6*M12**3*M22**2-32*aet1*M12*M22**3-
     &  20*M12**2*M22**3+8*aet1*M22**4+9*M12*M22**4-8*M12**4*I0A4(h1)+
     &  24*M12**3*M22*I0A4(h1)-24*M12**2*M22**2*I0A4(h1)+8*M12*M22**3*
     &  I0A4(h1)+48*aet1*M12**2*MNeu(h1)**4+6*M12**3*MNeu(h1)**4+32*
     &  aet1*M12*M22*MNeu(h1)**4-12*M12**2*M22*MNeu(h1)**4+48*aet1*M22*
     &  *2*MNeu(h1)**4-10*M12*M22**2*MNeu(h1)**4+16*M12*M22*A0TNeu(h1)*
     &  MNeu(h1)**4-24*M12**2*I0A4(h1)*MNeu(h1)**4+8*M12*M22*I0A4(h1)*
     &  MNeu(h1)**4-32*aet1*M12*MNeu(h1)**6-20*M12**2*MNeu(h1)**6-32*
     &  aet1*M22*MNeu(h1)**6+12*M12*M22*MNeu(h1)**6+8*M12*I0A4(h1)*
     &  MNeu(h1)**6+8*aet1*MNeu(h1)**8+9*M12*MNeu(h1)**8-32*aet1*M12**
     &  3*MNeu2(h1)+12*M12**4*MNeu2(h1)+32*aet1*M12**2*M22*MNeu2(h1)+
     &  52*M12**3*M22*MNeu2(h1)+32*aet1*M12*M22**2*MNeu2(h1)-44*M12**2*
     &  M22**2*MNeu2(h1)-32*aet1*M22**3*MNeu2(h1)-20*M12*M22**3*
     &  MNeu2(h1)+16*M12**2*M22*A0TNeu(h1)*MNeu2(h1)-16*M12*M22**2*
     &  A0TNeu(h1)*MNeu2(h1)+24*M12**3*I0A4(h1)*MNeu2(h1)-24*M12*M22**
     &  2*I0A4(h1)*MNeu2(h1)-8*a0t2*M12*((M12-M22)**3+(7*M12+3*M22)*
     &  MNeu(h1)**4-3*MNeu(h1)**6+(-5*M12**2+4*M12*M22+M22**2)*
     &  MNeu2(h1)-A0TNeu(h1)*((M12-M22)**2+3*MNeu(h1)**4-4*(M12+M22)*
     &  MNeu2(h1)))-4*a0t1*(-2*(a0t2*(M12+5*M22)-3*(3*M12**2+M12*M22+2*
     &  M22**2))*MNeu(h1)**4+(4*a0t2-8*M12-6*M22)*MNeu(h1)**6+MNeu(h1)*
     &  *8+2*A0TNeu(h1)*((M1**3-M1*M22)**2+(3*M12+2*M22)*MNeu(h1)**4-
     &  MNeu(h1)**6-(3*M12**2+4*M12*M22+M22**2)*MNeu2(h1))+(M12-M22)*
     &  ((2*a0t2+5*M12-3*M22)*(M12-M22)**2-2*(8*M12**2+3*M12*M22-5*M22*
     &  *2+2*a0t2*(M12+2*M22))*MNeu2(h1))))/(16.*alambda2(h1)**2)
       afin(17)=(M1*MNeu(h1)*((-2*M22m42*(-4*a0t1*a0t4+2*a0t4*M12-4*
     &  aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(-M12+M42+MNeu2(h1)))
     &  /alambda3(h1)+M22*(4*a0t1+4*a0t2+8*aet1+8*aet2+3*M12+3*M22+4*
     &  A0TNeu(h1)+8*AETNeu(h1)-8*I0A4(h1)+3*MNeu2(h1))+(4*M22m42*M42*
     &  (2*(-2*a0t1+M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+
     &  M12)*MNeu2(h1)))/alambda3(h1)-(2*M22m42*(M12+M42-MNeu2(h1))*(2*(-2*
     &  a0t4+M42)*A0TNeu(h1)-4*M42*AETNeu(h1)+(2*a0t4-4*aet4+M42)*
     &  MNeu2(h1)))/alambda3(h1)-(8*(((M12+M42+MNeu2(h1))*((M12-M42)*(M12*
     &  M22+(2*M22-3*M42)*M42)+M22*MNeu(h1)**4+(-2*M12*M22+(M22-3*M42)*
     &  M42)*MNeu2(h1)))/8.+((2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+
     &  MNeu2(h1))*((M12-M42)*(M12*M22+(2*M22-3*M42)*M42)+M22*MNeu(h1)*
     &  *4+(-2*M12*M22+(M22-3*M42)*M42)*MNeu2(h1)))/4.+(aet1+aet4+
     &  AETNeu(h1)-I0A5(h1))*((M12-M42)*(M12*M22-2*M22*M42+M42**2)+M22*
     &  MNeu(h1)**4+(-2*M12*M22-3*M22*M42+M42**2)*MNeu2(h1))))
     &  /alambda3(h1)))/(8.*M22m42s)
       afin(18)=(8*aet1*M12**4-7*M12**5-32*aet1*M12**3*M42+12*M12**4*
     &  M42+48*aet1*M12**2*M42**2+6*M12**3*M42**2-32*aet1*M12*M42**3-
     &  20*M12**2*M42**3+8*aet1*M42**4+9*M12*M42**4-8*M12**4*I0A5(h1)+
     &  24*M12**3*M42*I0A5(h1)-24*M12**2*M42**2*I0A5(h1)+8*M12*M42**3*
     &  I0A5(h1)+48*aet1*M12**2*MNeu(h1)**4+6*M12**3*MNeu(h1)**4+32*
     &  aet1*M12*M42*MNeu(h1)**4-12*M12**2*M42*MNeu(h1)**4+48*aet1*M42*
     &  *2*MNeu(h1)**4-10*M12*M42**2*MNeu(h1)**4+16*M12*M42*A0TNeu(h1)*
     &  MNeu(h1)**4-24*M12**2*I0A5(h1)*MNeu(h1)**4+8*M12*M42*I0A5(h1)*
     &  MNeu(h1)**4-32*aet1*M12*MNeu(h1)**6-20*M12**2*MNeu(h1)**6-32*
     &  aet1*M42*MNeu(h1)**6+12*M12*M42*MNeu(h1)**6+8*M12*I0A5(h1)*
     &  MNeu(h1)**6+8*aet1*MNeu(h1)**8+9*M12*MNeu(h1)**8-32*aet1*M12**
     &  3*MNeu2(h1)+12*M12**4*MNeu2(h1)+32*aet1*M12**2*M42*MNeu2(h1)+
     &  52*M12**3*M42*MNeu2(h1)+32*aet1*M12*M42**2*MNeu2(h1)-44*M12**2*
     &  M42**2*MNeu2(h1)-32*aet1*M42**3*MNeu2(h1)-20*M12*M42**3*
     &  MNeu2(h1)+16*M12**2*M42*A0TNeu(h1)*MNeu2(h1)-16*M12*M42**2*
     &  A0TNeu(h1)*MNeu2(h1)+24*M12**3*I0A5(h1)*MNeu2(h1)-24*M12*M42**
     &  2*I0A5(h1)*MNeu2(h1)-8*a0t4*M12*((M12-M42)**3+(7*M12+3*M42)*
     &  MNeu(h1)**4-3*MNeu(h1)**6+(-5*M12**2+4*M12*M42+M42**2)*
     &  MNeu2(h1)-A0TNeu(h1)*((M12-M42)**2+3*MNeu(h1)**4-4*(M12+M42)*
     &  MNeu2(h1)))-4*a0t1*(-2*(a0t4*(M12+5*M42)-3*(3*M12**2+M12*M42+2*
     &  M42**2))*MNeu(h1)**4+(4*a0t4-8*M12-6*M42)*MNeu(h1)**6+MNeu(h1)*
     &  *8+2*A0TNeu(h1)*((M1**3-M1*M42)**2+(3*M12+2*M42)*MNeu(h1)**4-
     &  MNeu(h1)**6-(3*M12**2+4*M12*M42+M42**2)*MNeu2(h1))+(M12-M42)*
     &  ((2*a0t4+5*M12-3*M42)*(M12-M42)**2-2*(8*M12**2+3*M12*M42-5*M42*
     &  *2+2*a0t4*(M12+2*M42))*MNeu2(h1))))/(16.*alambda3(h1)**2)
       afin(19)=(MNeu(h1)*(-8*aet1*M12**4+M12**5+32*aet1*M12**3*M22+12*
     &  M12**4*M22-48*aet1*M12**2*M22**2-42*M12**3*M22**2+32*aet1*M12*
     &  M22**3+44*M12**2*M22**3-8*aet1*M22**4-15*M12*M22**4+4*M12**4*
     &  A0TNeu(h1)-20*M12**3*M22*A0TNeu(h1)+28*M12**2*M22**2*A0TNeu(h1)
     &  -12*M12*M22**3*A0TNeu(h1)+8*M12**4*I0A4(h1)-24*M12**3*M22*
     &  I0A4(h1)+24*M12**2*M22**2*I0A4(h1)-8*M12*M22**3*I0A4(h1)-48*
     &  aet1*M12**2*MNeu(h1)**4-42*M12**3*MNeu(h1)**4-32*aet1*M12*M22*
     &  MNeu(h1)**4+4*M12**2*M22*MNeu(h1)**4-48*aet1*M22**2*MNeu(h1)**
     &  4-26*M12*M22**2*MNeu(h1)**4+12*M12**2*A0TNeu(h1)*MNeu(h1)**4-4*
     &  M12*M22*A0TNeu(h1)*MNeu(h1)**4+24*M12**2*I0A4(h1)*MNeu(h1)**4+
     &  8*M12*M22*I0A4(h1)*MNeu(h1)**4+32*aet1*M12*MNeu(h1)**6+44*M12**
     &  2*MNeu(h1)**6+32*aet1*M22*MNeu(h1)**6+28*M12*M22*MNeu(h1)**6-4*
     &  M12*A0TNeu(h1)*MNeu(h1)**6-8*M12*I0A4(h1)*MNeu(h1)**6-8*aet1*
     &  MNeu(h1)**8-15*M12*MNeu(h1)**8+32*aet1*M12**3*MNeu2(h1)+12*M12*
     &  *4*MNeu2(h1)-32*aet1*M12**2*M22*MNeu2(h1)-76*M12**3*M22*
     &  MNeu2(h1)-32*aet1*M12*M22**2*MNeu2(h1)+4*M12**2*M22**2*
     &  MNeu2(h1)+32*aet1*M22**3*MNeu2(h1)+28*M12*M22**3*MNeu2(h1)-12*
     &  M12**3*A0TNeu(h1)*MNeu2(h1)+8*M12**2*M22*A0TNeu(h1)*MNeu2(h1)+
     &  20*M12*M22**2*A0TNeu(h1)*MNeu2(h1)-24*M12**3*I0A4(h1)*MNeu2(h1)
     &  +8*M12*M22**2*I0A4(h1)*MNeu2(h1)+4*a0t2*M12*((M12-M22)**3+(7*
     &  M12+5*M22)*MNeu(h1)**4-3*MNeu(h1)**6-(5*M12**2-2*M12*M22+M22**
     &  2)*MNeu2(h1)-2*A0TNeu(h1)*(M12**2-3*M12*M22+2*M22**2+2*MNeu(h1)
     &  **4-(3*M12+4*M22)*MNeu2(h1)))+4*a0t1*(7*M12**4-25*M12**3*M22+
     &  33*M12**2*M22**2-19*M12*M22**3+4*M22**4+33*M12**2*MNeu(h1)**4+
     &  19*M12*M22*MNeu(h1)**4+24*M22**2*MNeu(h1)**4-19*M12*MNeu(h1)**
     &  6-16*M22*MNeu(h1)**6+4*MNeu(h1)**8-25*M12**3*MNeu2(h1)+18*M12**
     &  2*M22*MNeu2(h1)+19*M12*M22**2*MNeu2(h1)-16*M22**3*MNeu2(h1)+2*
     &  A0TNeu(h1)*(M12**3-2*M12**2*M22+M22**3+3*(M12+M22)*MNeu(h1)**4-
     &  MNeu(h1)**6-3*(M12**2+M12*M22+M22**2)*MNeu2(h1))+2*a0t2*((M12-
     &  M22)**3-3*M22*MNeu(h1)**4+MNeu(h1)**6+(-2*M12**2-3*M12*M22+3*
     &  M22**2)*MNeu2(h1)))))/(16.*alambda2(h1)**2*M1)
       afin(20)=-(MNeu(h1)*(72*a0t1*a0t2*M12**3+220*a0t1*M12**4+68*
     &  a0t2*M12**4-72*aet1*M12**4+17*M12**5-216*a0t1*a0t2*M12**2*M22-
     &  804*a0t1*M12**3*M22-204*a0t2*M12**3*M22+288*aet1*M12**3*M22+76*
     &  M12**4*M22+216*a0t1*a0t2*M12*M22**2+1092*a0t1*M12**2*M22**2+
     &  204*a0t2*M12**2*M22**2-432*aet1*M12**2*M22**2-330*M12**3*M22**
     &  2-72*a0t1*a0t2*M22**3-652*a0t1*M12*M22**3-68*a0t2*M12*M22**3+
     &  288*aet1*M12*M22**3+364*M12**2*M22**3+144*a0t1*M22**4-72*aet1*
     &  M22**4-127*M12*M22**4-64*a0t1*a0t2*M12*MNeu(h1)**4+1092*a0t1*
     &  M12**2*MNeu(h1)**4+220*a0t2*M12**2*MNeu(h1)**4-432*aet1*M12**2*
     &  MNeu(h1)**4-330*M12**3*MNeu(h1)**4-216*a0t1*a0t2*M22*MNeu(h1)**
     &  4+652*a0t1*M12*M22*MNeu(h1)**4+84*a0t2*M12*M22*MNeu(h1)**4-288*
     &  aet1*M12*M22*MNeu(h1)**4+196*M12**2*M22*MNeu(h1)**4+864*a0t1*
     &  M22**2*MNeu(h1)**4-432*aet1*M22**2*MNeu(h1)**4-186*M12*M22**2*
     &  MNeu(h1)**4+72*a0t1*a0t2*MNeu(h1)**6-652*a0t1*M12*MNeu(h1)**6-
     &  76*a0t2*M12*MNeu(h1)**6+288*aet1*M12*MNeu(h1)**6+364*M12**2*
     &  MNeu(h1)**6-576*a0t1*M22*MNeu(h1)**6+288*aet1*M22*MNeu(h1)**6+
     &  220*M12*M22*MNeu(h1)**6+144*a0t1*MNeu(h1)**8-72*aet1*MNeu(h1)**
     &  8-127*M12*MNeu(h1)**8-80*a0t1*a0t2*M12**2*MNeu2(h1)-804*a0t1*
     &  M12**3*MNeu2(h1)-212*a0t2*M12**3*MNeu2(h1)+288*aet1*M12**3*
     &  MNeu2(h1)+76*M12**4*MNeu2(h1)-152*a0t1*a0t2*M12*M22*MNeu2(h1)+
     &  712*a0t1*M12**2*M22*MNeu2(h1)+136*a0t2*M12**2*M22*MNeu2(h1)-
     &  288*aet1*M12**2*M22*MNeu2(h1)-524*M12**3*M22*MNeu2(h1)+216*
     &  a0t1*a0t2*M22**2*MNeu2(h1)+652*a0t1*M12*M22**2*MNeu2(h1)+60*
     &  a0t2*M12*M22**2*MNeu2(h1)-288*aet1*M12*M22**2*MNeu2(h1)+196*
     &  M12**2*M22**2*MNeu2(h1)-576*a0t1*M22**3*MNeu2(h1)+288*aet1*M22*
     &  *3*MNeu2(h1)+220*M12*M22**3*MNeu2(h1)+8*M12*I0A4(h1)*(9*(M12-
     &  M22)**3+9*(3*M12+M22)*MNeu(h1)**4-9*MNeu(h1)**6+(-27*M12**2+16*
     &  M12*M22+9*M22**2)*MNeu2(h1))+4*A0TNeu(h1)*((M12-M22)*(2*a0t1*
     &  (9*M12**2-M12*M22-9*M22**2)+M12*(-34*a0t2*M12+17*M12**2+36*
     &  a0t2*M22-36*M12*M22+19*M22**2))+3*(18*a0t1*(M12+M22)+M12*(-12*
     &  a0t2+17*M12+5*M22))*MNeu(h1)**4-(18*a0t1+17*M12)*MNeu(h1)**6+
     &  (M12*(70*a0t2*M12-51*M12**2+72*a0t2*M22+34*M12*M22+21*M22**2)-
     &  2*a0t1*(27*M12**2+19*M12*M22+27*M22**2))*MNeu2(h1))))/(16.*
     &  alambda2(h1)**2*M1)
       afin(21)=-(MNeu(h1)*(-24*a0t1*a0t2*M12**3-100*a0t1*M12**4+4*
     &  a0t2*M12**4+24*aet1*M12**4+M12**5+72*a0t1*a0t2*M12**2*M22+348*
     &  a0t1*M12**3*M22-12*a0t2*M12**3*M22-96*aet1*M12**3*M22-52*M12**
     &  4*M22-72*a0t1*a0t2*M12*M22**2-444*a0t1*M12**2*M22**2+12*a0t2*
     &  M12**2*M22**2+144*aet1*M12**2*M22**2+150*M12**3*M22**2+24*a0t1*
     &  a0t2*M22**3+244*a0t1*M12*M22**3-4*a0t2*M12*M22**3-96*aet1*M12*
     &  M22**3-148*M12**2*M22**3-48*a0t1*M22**4+24*aet1*M22**4+49*M12*
     &  M22**4-32*a0t1*a0t2*M12*MNeu(h1)**4-444*a0t1*M12**2*MNeu(h1)**
     &  4-100*a0t2*M12**2*MNeu(h1)**4+144*aet1*M12**2*MNeu(h1)**4+150*
     &  M12**3*MNeu(h1)**4+72*a0t1*a0t2*M22*MNeu(h1)**4-244*a0t1*M12*
     &  M22*MNeu(h1)**4-108*a0t2*M12*M22*MNeu(h1)**4+96*aet1*M12*M22*
     &  MNeu(h1)**4+68*M12**2*M22*MNeu(h1)**4-288*a0t1*M22**2*MNeu(h1)*
     &  *4+144*aet1*M22**2*MNeu(h1)**4+102*M12*M22**2*MNeu(h1)**4-24*
     &  a0t1*a0t2*MNeu(h1)**6+244*a0t1*M12*MNeu(h1)**6+52*a0t2*M12*
     &  MNeu(h1)**6-96*aet1*M12*MNeu(h1)**6-148*M12**2*MNeu(h1)**6+192*
     &  a0t1*M22*MNeu(h1)**6-96*aet1*M22*MNeu(h1)**6-100*M12*M22*
     &  MNeu(h1)**6-48*a0t1*MNeu(h1)**8+24*aet1*MNeu(h1)**8+49*M12*
     &  MNeu(h1)**8+80*a0t1*a0t2*M12**2*MNeu2(h1)+348*a0t1*M12**3*
     &  MNeu2(h1)+44*a0t2*M12**3*MNeu2(h1)-96*aet1*M12**3*MNeu2(h1)-52*
     &  M12**4*MNeu2(h1)+104*a0t1*a0t2*M12*M22*MNeu2(h1)-184*a0t1*M12**
     &  2*M22*MNeu2(h1)+8*a0t2*M12**2*M22*MNeu2(h1)+96*aet1*M12**2*M22*
     &  MNeu2(h1)+308*M12**3*M22*MNeu2(h1)-72*a0t1*a0t2*M22**2*
     &  MNeu2(h1)-244*a0t1*M12*M22**2*MNeu2(h1)+60*a0t2*M12*M22**2*
     &  MNeu2(h1)+96*aet1*M12*M22**2*MNeu2(h1)+68*M12**2*M22**2*
     &  MNeu2(h1)+192*a0t1*M22**3*MNeu2(h1)-96*aet1*M22**3*MNeu2(h1)-
     &  100*M12*M22**3*MNeu2(h1)-8*M12*I0A4(h1)*(3*(M12-M22)**3+3*(3*
     &  M12+M22)*MNeu(h1)**4-3*MNeu(h1)**6+(-9*M12**2-8*M12*M22+3*M22**
     &  2)*MNeu2(h1))-4*A0TNeu(h1)*(-((M12-M22)*(a0t1*(-6*M12**2+14*
     &  M12*M22+6*M22**2)+M12*(M12**2+12*M12*M22-13*M22**2-2*a0t2*(M12+
     &  6*M22))))+3*(6*a0t1*(M12+M22)-M12*(4*a0t2+M12+5*M22))*MNeu(h1)*
     &  *4+(-6*a0t1+M12)*MNeu(h1)**6+(-2*a0t1*(9*M12**2+13*M12*M22+9*
     &  M22**2)+M12*(10*a0t2*M12+3*M12**2+24*a0t2*M22-2*M12*M22+27*M22*
     &  *2))*MNeu2(h1))))/(16.*alambda2(h1)**2*M1)
       afin(22)=(MNeu(h1)*(-8*aet1*M12**4+M12**5+32*aet1*M12**3*M42+12*
     &  M12**4*M42-48*aet1*M12**2*M42**2-42*M12**3*M42**2+32*aet1*M12*
     &  M42**3+44*M12**2*M42**3-8*aet1*M42**4-15*M12*M42**4+4*M12**4*
     &  A0TNeu(h1)-20*M12**3*M42*A0TNeu(h1)+28*M12**2*M42**2*A0TNeu(h1)
     &  -12*M12*M42**3*A0TNeu(h1)+8*M12**4*I0A5(h1)-24*M12**3*M42*
     &  I0A5(h1)+24*M12**2*M42**2*I0A5(h1)-8*M12*M42**3*I0A5(h1)-48*
     &  aet1*M12**2*MNeu(h1)**4-42*M12**3*MNeu(h1)**4-32*aet1*M12*M42*
     &  MNeu(h1)**4+4*M12**2*M42*MNeu(h1)**4-48*aet1*M42**2*MNeu(h1)**
     &  4-26*M12*M42**2*MNeu(h1)**4+12*M12**2*A0TNeu(h1)*MNeu(h1)**4-4*
     &  M12*M42*A0TNeu(h1)*MNeu(h1)**4+24*M12**2*I0A5(h1)*MNeu(h1)**4+
     &  8*M12*M42*I0A5(h1)*MNeu(h1)**4+32*aet1*M12*MNeu(h1)**6+44*M12**
     &  2*MNeu(h1)**6+32*aet1*M42*MNeu(h1)**6+28*M12*M42*MNeu(h1)**6-4*
     &  M12*A0TNeu(h1)*MNeu(h1)**6-8*M12*I0A5(h1)*MNeu(h1)**6-8*aet1*
     &  MNeu(h1)**8-15*M12*MNeu(h1)**8+32*aet1*M12**3*MNeu2(h1)+12*M12*
     &  *4*MNeu2(h1)-32*aet1*M12**2*M42*MNeu2(h1)-76*M12**3*M42*
     &  MNeu2(h1)-32*aet1*M12*M42**2*MNeu2(h1)+4*M12**2*M42**2*
     &  MNeu2(h1)+32*aet1*M42**3*MNeu2(h1)+28*M12*M42**3*MNeu2(h1)-12*
     &  M12**3*A0TNeu(h1)*MNeu2(h1)+8*M12**2*M42*A0TNeu(h1)*MNeu2(h1)+
     &  20*M12*M42**2*A0TNeu(h1)*MNeu2(h1)-24*M12**3*I0A5(h1)*MNeu2(h1)
     &  +8*M12*M42**2*I0A5(h1)*MNeu2(h1)+4*a0t4*M12*((M12-M42)**3+(7*
     &  M12+5*M42)*MNeu(h1)**4-3*MNeu(h1)**6-(5*M12**2-2*M12*M42+M42**
     &  2)*MNeu2(h1)-2*A0TNeu(h1)*(M12**2-3*M12*M42+2*M42**2+2*MNeu(h1)
     &  **4-(3*M12+4*M42)*MNeu2(h1)))+4*a0t1*(7*M12**4-25*M12**3*M42+
     &  33*M12**2*M42**2-19*M12*M42**3+4*M42**4+33*M12**2*MNeu(h1)**4+
     &  19*M12*M42*MNeu(h1)**4+24*M42**2*MNeu(h1)**4-19*M12*MNeu(h1)**
     &  6-16*M42*MNeu(h1)**6+4*MNeu(h1)**8-25*M12**3*MNeu2(h1)+18*M12**
     &  2*M42*MNeu2(h1)+19*M12*M42**2*MNeu2(h1)-16*M42**3*MNeu2(h1)+2*
     &  A0TNeu(h1)*(M12**3-2*M12**2*M42+M42**3+3*(M12+M42)*MNeu(h1)**4-
     &  MNeu(h1)**6-3*(M12**2+M12*M42+M42**2)*MNeu2(h1))+2*a0t4*((M12-
     &  M42)**3-3*M42*MNeu(h1)**4+MNeu(h1)**6+(-2*M12**2-3*M12*M42+3*
     &  M42**2)*MNeu2(h1)))))/(16.*alambda3(h1)**2*M1)
       afin(23)=-(MNeu(h1)*(72*a0t1*a0t4*M12**3+220*a0t1*M12**4+68*
     &  a0t4*M12**4-72*aet1*M12**4+17*M12**5-216*a0t1*a0t4*M12**2*M42-
     &  804*a0t1*M12**3*M42-204*a0t4*M12**3*M42+288*aet1*M12**3*M42+76*
     &  M12**4*M42+216*a0t1*a0t4*M12*M42**2+1092*a0t1*M12**2*M42**2+
     &  204*a0t4*M12**2*M42**2-432*aet1*M12**2*M42**2-330*M12**3*M42**
     &  2-72*a0t1*a0t4*M42**3-652*a0t1*M12*M42**3-68*a0t4*M12*M42**3+
     &  288*aet1*M12*M42**3+364*M12**2*M42**3+144*a0t1*M42**4-72*aet1*
     &  M42**4-127*M12*M42**4-64*a0t1*a0t4*M12*MNeu(h1)**4+1092*a0t1*
     &  M12**2*MNeu(h1)**4+220*a0t4*M12**2*MNeu(h1)**4-432*aet1*M12**2*
     &  MNeu(h1)**4-330*M12**3*MNeu(h1)**4-216*a0t1*a0t4*M42*MNeu(h1)**
     &  4+652*a0t1*M12*M42*MNeu(h1)**4+84*a0t4*M12*M42*MNeu(h1)**4-288*
     &  aet1*M12*M42*MNeu(h1)**4+196*M12**2*M42*MNeu(h1)**4+864*a0t1*
     &  M42**2*MNeu(h1)**4-432*aet1*M42**2*MNeu(h1)**4-186*M12*M42**2*
     &  MNeu(h1)**4+72*a0t1*a0t4*MNeu(h1)**6-652*a0t1*M12*MNeu(h1)**6-
     &  76*a0t4*M12*MNeu(h1)**6+288*aet1*M12*MNeu(h1)**6+364*M12**2*
     &  MNeu(h1)**6-576*a0t1*M42*MNeu(h1)**6+288*aet1*M42*MNeu(h1)**6+
     &  220*M12*M42*MNeu(h1)**6+144*a0t1*MNeu(h1)**8-72*aet1*MNeu(h1)**
     &  8-127*M12*MNeu(h1)**8-80*a0t1*a0t4*M12**2*MNeu2(h1)-804*a0t1*
     &  M12**3*MNeu2(h1)-212*a0t4*M12**3*MNeu2(h1)+288*aet1*M12**3*
     &  MNeu2(h1)+76*M12**4*MNeu2(h1)-152*a0t1*a0t4*M12*M42*MNeu2(h1)+
     &  712*a0t1*M12**2*M42*MNeu2(h1)+136*a0t4*M12**2*M42*MNeu2(h1)-
     &  288*aet1*M12**2*M42*MNeu2(h1)-524*M12**3*M42*MNeu2(h1)+216*
     &  a0t1*a0t4*M42**2*MNeu2(h1)+652*a0t1*M12*M42**2*MNeu2(h1)+60*
     &  a0t4*M12*M42**2*MNeu2(h1)-288*aet1*M12*M42**2*MNeu2(h1)+196*
     &  M12**2*M42**2*MNeu2(h1)-576*a0t1*M42**3*MNeu2(h1)+288*aet1*M42*
     &  *3*MNeu2(h1)+220*M12*M42**3*MNeu2(h1)+8*M12*I0A5(h1)*(9*(M12-
     &  M42)**3+9*(3*M12+M42)*MNeu(h1)**4-9*MNeu(h1)**6+(-27*M12**2+16*
     &  M12*M42+9*M42**2)*MNeu2(h1))+4*A0TNeu(h1)*((M12-M42)*(2*a0t1*
     &  (9*M12**2-M12*M42-9*M42**2)+M12*(-34*a0t4*M12+17*M12**2+36*
     &  a0t4*M42-36*M12*M42+19*M42**2))+3*(18*a0t1*(M12+M42)+M12*(-12*
     &  a0t4+17*M12+5*M42))*MNeu(h1)**4-(18*a0t1+17*M12)*MNeu(h1)**6+
     &  (M12*(70*a0t4*M12-51*M12**2+72*a0t4*M42+34*M12*M42+21*M42**2)-
     &  2*a0t1*(27*M12**2+19*M12*M42+27*M42**2))*MNeu2(h1))))/(16.*
     &  alambda3(h1)**2*M1)
       afin(24)=-(MNeu(h1)*(-24*a0t1*a0t4*M12**3-100*a0t1*M12**4+4*
     &  a0t4*M12**4+24*aet1*M12**4+M12**5+72*a0t1*a0t4*M12**2*M42+348*
     &  a0t1*M12**3*M42-12*a0t4*M12**3*M42-96*aet1*M12**3*M42-52*M12**
     &  4*M42-72*a0t1*a0t4*M12*M42**2-444*a0t1*M12**2*M42**2+12*a0t4*
     &  M12**2*M42**2+144*aet1*M12**2*M42**2+150*M12**3*M42**2+24*a0t1*
     &  a0t4*M42**3+244*a0t1*M12*M42**3-4*a0t4*M12*M42**3-96*aet1*M12*
     &  M42**3-148*M12**2*M42**3-48*a0t1*M42**4+24*aet1*M42**4+49*M12*
     &  M42**4-32*a0t1*a0t4*M12*MNeu(h1)**4-444*a0t1*M12**2*MNeu(h1)**
     &  4-100*a0t4*M12**2*MNeu(h1)**4+144*aet1*M12**2*MNeu(h1)**4+150*
     &  M12**3*MNeu(h1)**4+72*a0t1*a0t4*M42*MNeu(h1)**4-244*a0t1*M12*
     &  M42*MNeu(h1)**4-108*a0t4*M12*M42*MNeu(h1)**4+96*aet1*M12*M42*
     &  MNeu(h1)**4+68*M12**2*M42*MNeu(h1)**4-288*a0t1*M42**2*MNeu(h1)*
     &  *4+144*aet1*M42**2*MNeu(h1)**4+102*M12*M42**2*MNeu(h1)**4-24*
     &  a0t1*a0t4*MNeu(h1)**6+244*a0t1*M12*MNeu(h1)**6+52*a0t4*M12*
     &  MNeu(h1)**6-96*aet1*M12*MNeu(h1)**6-148*M12**2*MNeu(h1)**6+192*
     &  a0t1*M42*MNeu(h1)**6-96*aet1*M42*MNeu(h1)**6-100*M12*M42*
     &  MNeu(h1)**6-48*a0t1*MNeu(h1)**8+24*aet1*MNeu(h1)**8+49*M12*
     &  MNeu(h1)**8+80*a0t1*a0t4*M12**2*MNeu2(h1)+348*a0t1*M12**3*
     &  MNeu2(h1)+44*a0t4*M12**3*MNeu2(h1)-96*aet1*M12**3*MNeu2(h1)-52*
     &  M12**4*MNeu2(h1)+104*a0t1*a0t4*M12*M42*MNeu2(h1)-184*a0t1*M12**
     &  2*M42*MNeu2(h1)+8*a0t4*M12**2*M42*MNeu2(h1)+96*aet1*M12**2*M42*
     &  MNeu2(h1)+308*M12**3*M42*MNeu2(h1)-72*a0t1*a0t4*M42**2*
     &  MNeu2(h1)-244*a0t1*M12*M42**2*MNeu2(h1)+60*a0t4*M12*M42**2*
     &  MNeu2(h1)+96*aet1*M12*M42**2*MNeu2(h1)+68*M12**2*M42**2*
     &  MNeu2(h1)+192*a0t1*M42**3*MNeu2(h1)-96*aet1*M42**3*MNeu2(h1)-
     &  100*M12*M42**3*MNeu2(h1)-8*M12*I0A5(h1)*(3*(M12-M42)**3+3*(3*
     &  M12+M42)*MNeu(h1)**4-3*MNeu(h1)**6+(-9*M12**2-8*M12*M42+3*M42**
     &  2)*MNeu2(h1))-4*A0TNeu(h1)*(-((M12-M42)*(a0t1*(-6*M12**2+14*
     &  M12*M42+6*M42**2)+M12*(M12**2+12*M12*M42-13*M42**2-2*a0t4*(M12+
     &  6*M42))))+3*(6*a0t1*(M12+M42)-M12*(4*a0t4+M12+5*M42))*MNeu(h1)*
     &  *4+(-6*a0t1+M12)*MNeu(h1)**6+(-2*a0t1*(9*M12**2+13*M12*M42+9*
     &  M42**2)+M12*(10*a0t4*M12+3*M12**2+24*a0t4*M42-2*M12*M42+27*M42*
     &  *2))*MNeu2(h1))))/(16.*alambda3(h1)**2*M1)
       afin(25)=(M1*MNeu(h1)*(8*aet2*M12**4-7*M2**10-32*aet2*M12**3*
     &  M22+9*M12**4*M22+48*aet2*M12**2*M22**2-20*M12**3*M22**2-32*
     &  aet2*M12*M22**3+6*M12**2*M22**3+8*aet2*M22**4+12*M12*M22**4+12*
     &  M12**3*M22*A0TNeu(h1)-28*M12**2*M22**2*A0TNeu(h1)+20*M12*M22**
     &  3*A0TNeu(h1)-4*M22**4*A0TNeu(h1)+8*M12**3*M22*I0A4(h1)-24*M12**
     &  2*M22**2*I0A4(h1)+24*M12*M22**3*I0A4(h1)-8*M22**4*I0A4(h1)+48*
     &  aet2*M12**2*MNeu(h1)**4+32*aet2*M12*M22*MNeu(h1)**4-10*M12**2*
     &  M22*MNeu(h1)**4+48*aet2*M22**2*MNeu(h1)**4-28*M12*M22**2*
     &  MNeu(h1)**4+6*M22**3*MNeu(h1)**4+4*M12*M22*A0TNeu(h1)*MNeu(h1)*
     &  *4-12*M22**2*A0TNeu(h1)*MNeu(h1)**4-8*M12*M22*I0A4(h1)*MNeu(h1)
     &  **4-24*M22**2*I0A4(h1)*MNeu(h1)**4-32*aet2*M12*MNeu(h1)**6-32*
     &  aet2*M22*MNeu(h1)**6-4*M12*M22*MNeu(h1)**6-20*M22**2*MNeu(h1)**
     &  6+4*M22*A0TNeu(h1)*MNeu(h1)**6+8*M22*I0A4(h1)*MNeu(h1)**6+8*
     &  aet2*MNeu(h1)**8+9*M22*MNeu(h1)**8-32*aet2*M12**3*MNeu2(h1)+32*
     &  aet2*M12**2*M22*MNeu2(h1)-4*M12**3*M22*MNeu2(h1)+32*aet2*M12*
     &  M22**2*MNeu2(h1)-28*M12**2*M22**2*MNeu2(h1)-32*aet2*M22**3*
     &  MNeu2(h1)+52*M12*M22**3*MNeu2(h1)+12*M22**4*MNeu2(h1)-20*M12**
     &  2*M22*A0TNeu(h1)*MNeu2(h1)-8*M12*M22**2*A0TNeu(h1)*MNeu2(h1)+
     &  12*M22**3*A0TNeu(h1)*MNeu2(h1)-8*M12**2*M22*I0A4(h1)*MNeu2(h1)+
     &  24*M22**3*I0A4(h1)*MNeu2(h1)-4*a0t2*((2*M12-5*M22)*(M12-M22)**
     &  3+(12*M12**2+11*M12*M22+21*M22**2)*MNeu(h1)**4-(8*M12+11*M22)*
     &  MNeu(h1)**6+2*MNeu(h1)**8+(-8*M12**3+11*M12**2*M22+10*M12*M22**
     &  2-17*M22**3)*MNeu2(h1)+2*A0TNeu(h1)*(M12**3-2*M12*M22**2+M22**
     &  3+3*(M12+M22)*MNeu(h1)**4-MNeu(h1)**6-3*(M12**2+M12*M22+M22**2)
     &  *MNeu2(h1)))+4*a0t1*(2*a0t2*((M12-M22)**3+3*M12*MNeu(h1)**4-
     &  MNeu(h1)**6+(-3*M12**2+3*M12*M22+2*M22**2)*MNeu2(h1))+M22*
     &  ((M12-M22)**3-(5*M12+7*M22)*MNeu(h1)**4+3*MNeu(h1)**6+(M12**2-
     &  2*M12*M22+5*M22**2)*MNeu2(h1)+2*A0TNeu(h1)*(2*M12**2-3*M12*M22+
     &  M22**2+2*MNeu(h1)**4-(4*M12+3*M22)*MNeu2(h1))))))/(8.*alambda2(h1)*
     &  *2*M22)
       afin(26)=(M1*MNeu(h1)*(8*aet4*M12**4-7*M4**10-32*aet4*M12**3*
     &  M42+9*M12**4*M42+48*aet4*M12**2*M42**2-20*M12**3*M42**2-32*
     &  aet4*M12*M42**3+6*M12**2*M42**3+8*aet4*M42**4+12*M12*M42**4+12*
     &  M12**3*M42*A0TNeu(h1)-28*M12**2*M42**2*A0TNeu(h1)+20*M12*M42**
     &  3*A0TNeu(h1)-4*M42**4*A0TNeu(h1)+8*M12**3*M42*I0A5(h1)-24*M12**
     &  2*M42**2*I0A5(h1)+24*M12*M42**3*I0A5(h1)-8*M42**4*I0A5(h1)+48*
     &  aet4*M12**2*MNeu(h1)**4+32*aet4*M12*M42*MNeu(h1)**4-10*M12**2*
     &  M42*MNeu(h1)**4+48*aet4*M42**2*MNeu(h1)**4-28*M12*M42**2*
     &  MNeu(h1)**4+6*M42**3*MNeu(h1)**4+4*M12*M42*A0TNeu(h1)*MNeu(h1)*
     &  *4-12*M42**2*A0TNeu(h1)*MNeu(h1)**4-8*M12*M42*I0A5(h1)*MNeu(h1)
     &  **4-24*M42**2*I0A5(h1)*MNeu(h1)**4-32*aet4*M12*MNeu(h1)**6-32*
     &  aet4*M42*MNeu(h1)**6-4*M12*M42*MNeu(h1)**6-20*M42**2*MNeu(h1)**
     &  6+4*M42*A0TNeu(h1)*MNeu(h1)**6+8*M42*I0A5(h1)*MNeu(h1)**6+8*
     &  aet4*MNeu(h1)**8+9*M42*MNeu(h1)**8-32*aet4*M12**3*MNeu2(h1)+32*
     &  aet4*M12**2*M42*MNeu2(h1)-4*M12**3*M42*MNeu2(h1)+32*aet4*M12*
     &  M42**2*MNeu2(h1)-28*M12**2*M42**2*MNeu2(h1)-32*aet4*M42**3*
     &  MNeu2(h1)+52*M12*M42**3*MNeu2(h1)+12*M42**4*MNeu2(h1)-20*M12**
     &  2*M42*A0TNeu(h1)*MNeu2(h1)-8*M12*M42**2*A0TNeu(h1)*MNeu2(h1)+
     &  12*M42**3*A0TNeu(h1)*MNeu2(h1)-8*M12**2*M42*I0A5(h1)*MNeu2(h1)+
     &  24*M42**3*I0A5(h1)*MNeu2(h1)-4*a0t4*((2*M12-5*M42)*(M12-M42)**
     &  3+(12*M12**2+11*M12*M42+21*M42**2)*MNeu(h1)**4-(8*M12+11*M42)*
     &  MNeu(h1)**6+2*MNeu(h1)**8+(-8*M12**3+11*M12**2*M42+10*M12*M42**
     &  2-17*M42**3)*MNeu2(h1)+2*A0TNeu(h1)*(M12**3-2*M12*M42**2+M42**
     &  3+3*(M12+M42)*MNeu(h1)**4-MNeu(h1)**6-3*(M12**2+M12*M42+M42**2)
     &  *MNeu2(h1)))+4*a0t1*(2*a0t4*((M12-M42)**3+3*M12*MNeu(h1)**4-
     &  MNeu(h1)**6+(-3*M12**2+3*M12*M42+2*M42**2)*MNeu2(h1))+M42*
     &  ((M12-M42)**3-(5*M12+7*M42)*MNeu(h1)**4+3*MNeu(h1)**6+(M12**2-
     &  2*M12*M42+5*M42**2)*MNeu2(h1)+2*A0TNeu(h1)*(2*M12**2-3*M12*M42+
     &  M42**2+2*MNeu(h1)**4-(4*M12+3*M42)*MNeu2(h1))))))/(8.*alambda3(h1)*
     &  *2*M42)
       afin(27)=(8*a0t1*a0t2*M12**3+52*a0t1*M12**4+32*a0t2*M12**4-24*
     &  aet1*M12**4-16*aet2*M12**4+11*M12**5+10*M2**10-24*a0t1*a0t2*
     &  M12**2*M22-200*a0t1*M12**3*M22-120*a0t2*M12**3*M22+96*aet1*M12*
     &  *3*M22+64*aet2*M12**3*M22-18*M12**4*M22+24*a0t1*a0t2*M12*M22**
     &  2+288*a0t1*M12**2*M22**2+168*a0t2*M12**2*M22**2-144*aet1*M12**
     &  2*M22**2-96*aet2*M12**2*M22**2-22*M12**3*M22**2-8*a0t1*a0t2*
     &  M22**3-184*a0t1*M12*M22**3-104*a0t2*M12*M22**3+96*aet1*M12*M22*
     &  *3+64*aet2*M12*M22**3+64*M12**2*M22**3+44*a0t1*M22**4+24*a0t2*
     &  M22**4-24*aet1*M22**4-16*aet2*M22**4-45*M12*M22**4-72*a0t1*
     &  a0t2*M12*MNeu(h1)**4+216*a0t1*M12**2*MNeu(h1)**4+152*a0t2*M12**
     &  2*MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4-96*aet2*M12**2*
     &  MNeu(h1)**4-62*M12**3*MNeu(h1)**4-104*a0t1*a0t2*M22*MNeu(h1)**
     &  4+120*a0t1*M12*M22*MNeu(h1)**4+88*a0t2*M12*M22*MNeu(h1)**4-96*
     &  aet1*M12*M22*MNeu(h1)**4-64*aet2*M12*M22*MNeu(h1)**4+40*M12**2*
     &  M22*MNeu(h1)**4+192*a0t1*M22**2*MNeu(h1)**4+96*a0t2*M22**2*
     &  MNeu(h1)**4-144*aet1*M22**2*MNeu(h1)**4-96*aet2*M22**2*MNeu(h1)
     &  **4+26*M12*M22**2*MNeu(h1)**4-20*M22**3*MNeu(h1)**4+48*a0t1*
     &  a0t2*MNeu(h1)**6-112*a0t1*M12*MNeu(h1)**6-72*a0t2*M12*MNeu(h1)*
     &  *6+96*aet1*M12*MNeu(h1)**6+64*aet2*M12*MNeu(h1)**6+76*M12**2*
     &  MNeu(h1)**6-104*a0t1*M22*MNeu(h1)**6-48*a0t2*M22*MNeu(h1)**6+
     &  96*aet1*M22*MNeu(h1)**6+64*aet2*M22*MNeu(h1)**6+44*M12*M22*
     &  MNeu(h1)**6+32*M22**2*MNeu(h1)**6+20*a0t1*MNeu(h1)**8+8*a0t2*
     &  MNeu(h1)**8-24*aet1*MNeu(h1)**8-16*aet2*MNeu(h1)**8-21*M12*
     &  MNeu(h1)**8-6*M22*MNeu(h1)**8-4*MNeu(h1)**10+16*a0t1*a0t2*M12**
     &  2*MNeu2(h1)-176*a0t1*M12**3*MNeu2(h1)-120*a0t2*M12**3*MNeu2(h1)
     &  +96*aet1*M12**3*MNeu2(h1)+64*aet2*M12**3*MNeu2(h1)-80*a0t1*
     &  a0t2*M12*M22*MNeu2(h1)+152*a0t1*M12**2*M22*MNeu2(h1)+112*a0t2*
     &  M12**2*M22*MNeu2(h1)-96*aet1*M12**2*M22*MNeu2(h1)-64*aet2*M12**
     &  2*M22*MNeu2(h1)-124*M12**3*M22*MNeu2(h1)+64*a0t1*a0t2*M22**2*
     &  MNeu2(h1)+176*a0t1*M12*M22**2*MNeu2(h1)+88*a0t2*M12*M22**2*
     &  MNeu2(h1)-96*aet1*M12*M22**2*MNeu2(h1)-64*aet2*M12*M22**2*
     &  MNeu2(h1)+140*M12**2*M22**2*MNeu2(h1)-152*a0t1*M22**3*MNeu2(h1)
     &  -80*a0t2*M22**3*MNeu2(h1)+96*aet1*M22**3*MNeu2(h1)+64*aet2*M22*
     &  *3*MNeu2(h1)-4*M12*M22**3*MNeu2(h1)-12*M22**4*MNeu2(h1)+8*
     &  A0TNeu(h1)*((a0t1-a0t2)*(3*M12-2*M22)*(M12-M22)**2+(-(a0t2*
     &  (M12-6*M22))+a0t1*(9*M12+4*M22)-6*(M12**2+M12*M22+M22**2))*
     &  MNeu(h1)**4+(-3*a0t1-2*a0t2+6*(M12+M22))*MNeu(h1)**6-2*MNeu(h1)
     &  **8+(a0t1*(-9*M12**2+M22**2)+2*(M12**3-2*M12**2*M22+M22**3+
     &  a0t2*(3*M12**2+4*M12*M22-3*M22**2)))*MNeu2(h1))+8*I0A4(h1)*(3*
     &  (3*M12**2+M12*M22+2*M22**2)*MNeu(h1)**4-(3*M12+2*M22)*MNeu(h1)*
     &  *6+(3*M12**2-5*M12*M22+2*M22**2)*((M12-M22)**2-3*(M12+M22)*
     &  MNeu2(h1))))/(32.*alambda2(h1)**2)
       afin(28)=(-8*a0t1*a0t2*M12**3-476*a0t1*M12**4-392*a0t2*M12**4+
     &  264*aet1*M12**4+256*aet2*M12**4-113*M12**5-160*M2**10+24*a0t1*
     &  a0t2*M12**2*M22+1896*a0t1*M12**3*M22+1560*a0t2*M12**3*M22-1056*
     &  aet1*M12**3*M22-1024*aet2*M12**3*M22+276*M12**4*M22-24*a0t1*
     &  a0t2*M12*M22**2-2832*a0t1*M12**2*M22**2-2328*a0t2*M12**2*M22**
     &  2+1584*aet1*M12**2*M22**2+1536*aet2*M12**2*M22**2+10*M12**3*
     &  M22**2+8*a0t1*a0t2*M22**3+1880*a0t1*M12*M22**3+1544*a0t2*M12*
     &  M22**3-1056*aet1*M12*M22**3-1024*aet2*M12*M22**3-556*M12**2*
     &  M22**3-468*a0t1*M22**4-384*a0t2*M22**4+264*aet1*M22**4+256*
     &  aet2*M22**4+543*M12*M22**4+1032*a0t1*a0t2*M12*MNeu(h1)**4-2040*
     &  a0t1*M12**2*MNeu(h1)**4-1592*a0t2*M12**2*MNeu(h1)**4+1584*aet1*
     &  M12**2*MNeu(h1)**4+1536*aet2*M12**2*MNeu(h1)**4+650*M12**3*
     &  MNeu(h1)**4+1064*a0t1*a0t2*M22*MNeu(h1)**4-1336*a0t1*M12*M22*
     &  MNeu(h1)**4-1048*a0t2*M12*M22*MNeu(h1)**4+1056*aet1*M12*M22*
     &  MNeu(h1)**4+1024*aet2*M12*M22*MNeu(h1)**4-628*M12**2*M22*
     &  MNeu(h1)**4-2016*a0t1*M22**2*MNeu(h1)**4-1536*a0t2*M22**2*
     &  MNeu(h1)**4+1584*aet1*M22**2*MNeu(h1)**4+1536*aet2*M22**2*
     &  MNeu(h1)**4-518*M12*M22**2*MNeu(h1)**4+320*M22**3*MNeu(h1)**4-
     &  528*a0t1*a0t2*MNeu(h1)**6+1088*a0t1*M12*MNeu(h1)**6+792*a0t2*
     &  M12*MNeu(h1)**6-1056*aet1*M12*MNeu(h1)**6-1024*aet2*M12*
     &  MNeu(h1)**6-748*M12**2*MNeu(h1)**6+1080*a0t1*M22*MNeu(h1)**6+
     &  768*a0t2*M22*MNeu(h1)**6-1056*aet1*M22*MNeu(h1)**6-1024*aet2*
     &  M22*MNeu(h1)**6-716*M12*M22*MNeu(h1)**6-512*M22**2*MNeu(h1)**6-
     &  204*a0t1*MNeu(h1)**8-128*a0t2*MNeu(h1)**8+264*aet1*MNeu(h1)**8+
     &  256*aet2*MNeu(h1)**8+159*M12*MNeu(h1)**8+96*M22*MNeu(h1)**8+64*
     &  MNeu(h1)**10-496*a0t1*a0t2*M12**2*MNeu2(h1)+1632*a0t1*M12**3*
     &  MNeu2(h1)+1320*a0t2*M12**3*MNeu2(h1)-1056*aet1*M12**3*MNeu2(h1)
     &  -1024*aet2*M12**3*MNeu2(h1)-12*M12**4*MNeu2(h1)+1040*a0t1*a0t2*
     &  M12*M22*MNeu2(h1)-1608*a0t1*M12**2*M22*MNeu2(h1)-1312*a0t2*M12*
     &  *2*M22*MNeu2(h1)+1056*aet1*M12**2*M22*MNeu2(h1)+1024*aet2*M12**
     &  2*M22*MNeu2(h1)+1036*M12**3*M22*MNeu2(h1)-544*a0t1*a0t2*M22**2*
     &  MNeu2(h1)-1632*a0t1*M12*M22**2*MNeu2(h1)-1288*a0t2*M12*M22**2*
     &  MNeu2(h1)+1056*aet1*M12*M22**2*MNeu2(h1)+1024*aet2*M12*M22**2*
     &  MNeu2(h1)-1748*M12**2*M22**2*MNeu2(h1)+1608*a0t1*M22**3*
     &  MNeu2(h1)+1280*a0t2*M22**3*MNeu2(h1)-1056*aet1*M22**3*MNeu2(h1)
     &  -1024*aet2*M22**3*MNeu2(h1)+532*M12*M22**3*MNeu2(h1)+192*M22**
     &  4*MNeu2(h1)-8*A0TNeu(h1)*((a0t1-a0t2)*(33*M12-32*M22)*(M12-M22)
     &  **2+(99*a0t1*M12+29*a0t2*M12-96*M12**2+34*a0t1*M22+96*a0t2*M22-
     &  66*M12*M22-96*M22**2)*MNeu(h1)**4+(-33*a0t1-32*(a0t2-3*(M12+
     &  M22)))*MNeu(h1)**6-32*MNeu(h1)**8+(32*M12**3-34*M12**2*M22-30*
     &  M12*M22**2+32*M22**3+4*a0t2*(9*M12**2+17*M12*M22-24*M22**2)+
     &  a0t1*(-99*M12**2+60*M12*M22+31*M22**2))*MNeu2(h1))-8*I0A4(h1)*
     &  ((99*M12**2+63*M12*M22+96*M22**2)*MNeu(h1)**4-(33*M12+32*M22)*
     &  MNeu(h1)**6+(33*M12**2-65*M12*M22+32*M22**2)*((M12-M22)**2-3*
     &  (M12+M22)*MNeu2(h1))))/(32.*alambda2(h1)**2)
       afin(29)=(56*a0t1*a0t2*M12**3+140*a0t1*M12**4+32*a0t2*M12**4-40*
     &  aet1*M12**4+16*aet2*M12**4+21*M12**5-10*M2**10-168*a0t1*a0t2*
     &  M12**2*M22-504*a0t1*M12**3*M22-72*a0t2*M12**3*M22+160*aet1*M12*
     &  *3*M22-64*aet2*M12**3*M22+18*M12**4*M22+168*a0t1*a0t2*M12*M22**
     &  2+672*a0t1*M12**2*M22**2+24*a0t2*M12**2*M22**2-240*aet1*M12**2*
     &  M22**2+96*aet2*M12**2*M22**2-170*M12**3*M22**2-56*a0t1*a0t2*
     &  M22**3-392*a0t1*M12*M22**3+40*a0t2*M12*M22**3+160*aet1*M12*M22*
     &  *3-64*aet2*M12*M22**3+192*M12**2*M22**3+84*a0t1*M22**4-24*a0t2*
     &  M22**4-40*aet1*M22**4+16*aet2*M22**4-51*M12*M22**4+8*a0t1*a0t2*
     &  M12*MNeu(h1)**4+552*a0t1*M12**2*MNeu(h1)**4+296*a0t2*M12**2*
     &  MNeu(h1)**4-240*aet1*M12**2*MNeu(h1)**4+96*aet2*M12**2*MNeu(h1)
     &  **4-130*M12**3*MNeu(h1)**4-216*a0t1*a0t2*M22*MNeu(h1)**4+200*
     &  a0t1*M12*M22*MNeu(h1)**4+104*a0t2*M12*M22*MNeu(h1)**4-160*aet1*
     &  M12*M22*MNeu(h1)**4+64*aet2*M12*M22*MNeu(h1)**4-40*M12**2*M22*
     &  MNeu(h1)**4+384*a0t1*M22**2*MNeu(h1)**4-96*a0t2*M22**2*MNeu(h1)
     &  **4-240*aet1*M22**2*MNeu(h1)**4+96*aet2*M22**2*MNeu(h1)**4-90*
     &  M12*M22**2*MNeu(h1)**4+20*M22**3*MNeu(h1)**4+80*a0t1*a0t2*
     &  MNeu(h1)**6-272*a0t1*M12*MNeu(h1)**6-120*a0t2*M12*MNeu(h1)**6+
     &  160*aet1*M12*MNeu(h1)**6-64*aet2*M12*MNeu(h1)**6+180*M12**2*
     &  MNeu(h1)**6-216*a0t1*M22*MNeu(h1)**6+48*a0t2*M22*MNeu(h1)**6+
     &  160*aet1*M22*MNeu(h1)**6-64*aet2*M22*MNeu(h1)**6-44*M12*M22*
     &  MNeu(h1)**6-32*M22**2*MNeu(h1)**6+44*a0t1*MNeu(h1)**8-8*a0t2*
     &  MNeu(h1)**8-40*aet1*MNeu(h1)**8+16*aet2*MNeu(h1)**8-75*M12*
     &  MNeu(h1)**8+6*M22*MNeu(h1)**8+4*MNeu(h1)**10-144*a0t1*a0t2*M12*
     &  *2*MNeu2(h1)-464*a0t1*M12**3*MNeu2(h1)-200*a0t2*M12**3*
     &  MNeu2(h1)+160*aet1*M12**3*MNeu2(h1)-64*aet2*M12**3*MNeu2(h1)-
     &  48*a0t1*a0t2*M12*M22*MNeu2(h1)+296*a0t1*M12**2*M22*MNeu2(h1)+
     &  144*a0t2*M12**2*M22*MNeu2(h1)-160*aet1*M12**2*M22*MNeu2(h1)+64*
     &  aet2*M12**2*M22*MNeu2(h1)-388*M12**3*M22*MNeu2(h1)+192*a0t1*
     &  a0t2*M22**2*MNeu2(h1)+464*a0t1*M12*M22**2*MNeu2(h1)-24*a0t2*
     &  M12*M22**2*MNeu2(h1)-160*aet1*M12*M22**2*MNeu2(h1)+64*aet2*M12*
     &  M22**2*MNeu2(h1)+116*M12**2*M22**2*MNeu2(h1)-296*a0t1*M22**3*
     &  MNeu2(h1)+80*a0t2*M22**3*MNeu2(h1)+160*aet1*M22**3*MNeu2(h1)-
     &  64*aet2*M22**3*MNeu2(h1)+260*M12*M22**3*MNeu2(h1)+12*M22**4*
     &  MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t2)*(M12-M22)**2*(5*M12+2*M22)+
     &  (-23*a0t2*M12+6*M12**2-6*a0t2*M22-10*M12*M22+6*M22**2+3*a0t1*
     &  (5*M12+4*M22))*MNeu(h1)**4-(5*a0t1-2*a0t2+6*(M12+M22))*MNeu(h1)
     &  **6+2*MNeu(h1)**8-(a0t1*(15*M12**2+32*M12*M22+9*M22**2)+2*(M12*
     &  *3+6*M12**2*M22-8*M12*M22**2+M22**3-a0t2*(13*M12**2+12*M12*M22+
     &  3*M22**2)))*MNeu2(h1))+8*I0A4(h1)*((15*M12**2-11*M12*M22-6*M22*
     &  *2)*MNeu(h1)**4+(-5*M12+2*M22)*MNeu(h1)**6+(5*M12**2-3*M12*M22-
     &  2*M22**2)*((M12-M22)**2-3*(M12+M22)*MNeu2(h1))))/(32.*alambda2(h1)*
     &  *2)
       afin(30)=-(-8*a0t1*a0t2*M12**3-116*a0t1*M12**4-32*a0t2*M12**4+
     &  24*aet1*M12**4+16*aet2*M12**4+37*M12**5-10*M2**10+24*a0t1*a0t2*
     &  M12**2*M22+456*a0t1*M12**3*M22+120*a0t2*M12**3*M22-96*aet1*M12*
     &  *3*M22-64*aet2*M12**3*M22-174*M12**4*M22-24*a0t1*a0t2*M12*M22**
     &  2-672*a0t1*M12**2*M22**2-168*a0t2*M12**2*M22**2+144*aet1*M12**
     &  2*M22**2+96*aet2*M12**2*M22**2+310*M12**3*M22**2+8*a0t1*a0t2*
     &  M22**3+440*a0t1*M12*M22**3+104*a0t2*M12*M22**3-96*aet1*M12*M22*
     &  *3-64*aet2*M12*M22**3-256*M12**2*M22**3-108*a0t1*M22**4-24*
     &  a0t2*M22**4+24*aet1*M22**4+16*aet2*M22**4+93*M12*M22**4+72*
     &  a0t1*a0t2*M12*MNeu(h1)**4-600*a0t1*M12**2*MNeu(h1)**4-152*a0t2*
     &  M12**2*MNeu(h1)**4+144*aet1*M12**2*MNeu(h1)**4+96*aet2*M12**2*
     &  MNeu(h1)**4+350*M12**3*MNeu(h1)**4+104*a0t1*a0t2*M22*MNeu(h1)**
     &  4-376*a0t1*M12*M22*MNeu(h1)**4-88*a0t2*M12*M22*MNeu(h1)**4+96*
     &  aet1*M12*M22*MNeu(h1)**4+64*aet2*M12*M22*MNeu(h1)**4+152*M12**
     &  2*M22*MNeu(h1)**4-576*a0t1*M22**2*MNeu(h1)**4-96*a0t2*M22**2*
     &  MNeu(h1)**4+144*aet1*M22**2*MNeu(h1)**4+96*aet2*M22**2*MNeu(h1)
     &  **4+262*M12*M22**2*MNeu(h1)**4+20*M22**3*MNeu(h1)**4-48*a0t1*
     &  a0t2*MNeu(h1)**6+368*a0t1*M12*MNeu(h1)**6+72*a0t2*M12*MNeu(h1)*
     &  *6-96*aet1*M12*MNeu(h1)**6-64*aet2*M12*MNeu(h1)**6-268*M12**2*
     &  MNeu(h1)**6+360*a0t1*M22*MNeu(h1)**6+48*a0t2*M22*MNeu(h1)**6-
     &  96*aet1*M22*MNeu(h1)**6-64*aet2*M22*MNeu(h1)**6-236*M12*M22*
     &  MNeu(h1)**6-32*M22**2*MNeu(h1)**6-84*a0t1*MNeu(h1)**8-8*a0t2*
     &  MNeu(h1)**8+24*aet1*MNeu(h1)**8+16*aet2*MNeu(h1)**8+69*M12*
     &  MNeu(h1)**8+6*M22*MNeu(h1)**8+4*MNeu(h1)**10-16*a0t1*a0t2*M12**
     &  2*MNeu2(h1)+432*a0t1*M12**3*MNeu2(h1)+120*a0t2*M12**3*MNeu2(h1)
     &  -96*aet1*M12**3*MNeu2(h1)-64*aet2*M12**3*MNeu2(h1)-192*M12**4*
     &  MNeu2(h1)+80*a0t1*a0t2*M12*M22*MNeu2(h1)-408*a0t1*M12**2*M22*
     &  MNeu2(h1)-112*a0t2*M12**2*M22*MNeu2(h1)+96*aet1*M12**2*M22*
     &  MNeu2(h1)+64*aet2*M12**2*M22*MNeu2(h1)+316*M12**3*M22*MNeu2(h1)
     &  -64*a0t1*a0t2*M22**2*MNeu2(h1)-432*a0t1*M12*M22**2*MNeu2(h1)-
     &  88*a0t2*M12*M22**2*MNeu2(h1)+96*aet1*M12*M22**2*MNeu2(h1)+64*
     &  aet2*M12*M22**2*MNeu2(h1)+52*M12**2*M22**2*MNeu2(h1)+408*a0t1*
     &  M22**3*MNeu2(h1)+80*a0t2*M22**3*MNeu2(h1)-96*aet1*M22**3*
     &  MNeu2(h1)-64*aet2*M22**3*MNeu2(h1)-188*M12*M22**3*MNeu2(h1)+12*
     &  M22**4*MNeu2(h1)-8*A0TNeu(h1)*((a0t1-a0t2)*(3*M12-2*M22)*(M12-
     &  M22)**2+(-(a0t2*(M12-6*M22))+a0t1*(9*M12+4*M22)-6*(M12**2+M12*
     &  M22+M22**2))*MNeu(h1)**4+(-3*a0t1-2*a0t2+6*(M12+M22))*MNeu(h1)*
     &  *6-2*MNeu(h1)**8+(a0t1*(-9*M12**2+M22**2)+2*(M12**3-2*M12**2*
     &  M22+M22**3+a0t2*(3*M12**2+4*M12*M22-3*M22**2)))*MNeu2(h1))-8*
     &  I0A4(h1)*(3*(3*M12**2+M12*M22+2*M22**2)*MNeu(h1)**4-(3*M12+2*
     &  M22)*MNeu(h1)**6+(3*M12**2-5*M12*M22+2*M22**2)*((M12-M22)**2-3*
     &  (M12+M22)*MNeu2(h1))))/(32.*alambda2(h1)**2)
       afin(31)=(8*a0t1*a0t4*M12**3+52*a0t1*M12**4+32*a0t4*M12**4-24*
     &  aet1*M12**4-16*aet4*M12**4+11*M12**5+10*M4**10-24*a0t1*a0t4*
     &  M12**2*M42-200*a0t1*M12**3*M42-120*a0t4*M12**3*M42+96*aet1*M12*
     &  *3*M42+64*aet4*M12**3*M42-18*M12**4*M42+24*a0t1*a0t4*M12*M42**
     &  2+288*a0t1*M12**2*M42**2+168*a0t4*M12**2*M42**2-144*aet1*M12**
     &  2*M42**2-96*aet4*M12**2*M42**2-22*M12**3*M42**2-8*a0t1*a0t4*
     &  M42**3-184*a0t1*M12*M42**3-104*a0t4*M12*M42**3+96*aet1*M12*M42*
     &  *3+64*aet4*M12*M42**3+64*M12**2*M42**3+44*a0t1*M42**4+24*a0t4*
     &  M42**4-24*aet1*M42**4-16*aet4*M42**4-45*M12*M42**4-72*a0t1*
     &  a0t4*M12*MNeu(h1)**4+216*a0t1*M12**2*MNeu(h1)**4+152*a0t4*M12**
     &  2*MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4-96*aet4*M12**2*
     &  MNeu(h1)**4-62*M12**3*MNeu(h1)**4-104*a0t1*a0t4*M42*MNeu(h1)**
     &  4+120*a0t1*M12*M42*MNeu(h1)**4+88*a0t4*M12*M42*MNeu(h1)**4-96*
     &  aet1*M12*M42*MNeu(h1)**4-64*aet4*M12*M42*MNeu(h1)**4+40*M12**2*
     &  M42*MNeu(h1)**4+192*a0t1*M42**2*MNeu(h1)**4+96*a0t4*M42**2*
     &  MNeu(h1)**4-144*aet1*M42**2*MNeu(h1)**4-96*aet4*M42**2*MNeu(h1)
     &  **4+26*M12*M42**2*MNeu(h1)**4-20*M42**3*MNeu(h1)**4+48*a0t1*
     &  a0t4*MNeu(h1)**6-112*a0t1*M12*MNeu(h1)**6-72*a0t4*M12*MNeu(h1)*
     &  *6+96*aet1*M12*MNeu(h1)**6+64*aet4*M12*MNeu(h1)**6+76*M12**2*
     &  MNeu(h1)**6-104*a0t1*M42*MNeu(h1)**6-48*a0t4*M42*MNeu(h1)**6+
     &  96*aet1*M42*MNeu(h1)**6+64*aet4*M42*MNeu(h1)**6+44*M12*M42*
     &  MNeu(h1)**6+32*M42**2*MNeu(h1)**6+20*a0t1*MNeu(h1)**8+8*a0t4*
     &  MNeu(h1)**8-24*aet1*MNeu(h1)**8-16*aet4*MNeu(h1)**8-21*M12*
     &  MNeu(h1)**8-6*M42*MNeu(h1)**8-4*MNeu(h1)**10+16*a0t1*a0t4*M12**
     &  2*MNeu2(h1)-176*a0t1*M12**3*MNeu2(h1)-120*a0t4*M12**3*MNeu2(h1)
     &  +96*aet1*M12**3*MNeu2(h1)+64*aet4*M12**3*MNeu2(h1)-80*a0t1*
     &  a0t4*M12*M42*MNeu2(h1)+152*a0t1*M12**2*M42*MNeu2(h1)+112*a0t4*
     &  M12**2*M42*MNeu2(h1)-96*aet1*M12**2*M42*MNeu2(h1)-64*aet4*M12**
     &  2*M42*MNeu2(h1)-124*M12**3*M42*MNeu2(h1)+64*a0t1*a0t4*M42**2*
     &  MNeu2(h1)+176*a0t1*M12*M42**2*MNeu2(h1)+88*a0t4*M12*M42**2*
     &  MNeu2(h1)-96*aet1*M12*M42**2*MNeu2(h1)-64*aet4*M12*M42**2*
     &  MNeu2(h1)+140*M12**2*M42**2*MNeu2(h1)-152*a0t1*M42**3*MNeu2(h1)
     &  -80*a0t4*M42**3*MNeu2(h1)+96*aet1*M42**3*MNeu2(h1)+64*aet4*M42*
     &  *3*MNeu2(h1)-4*M12*M42**3*MNeu2(h1)-12*M42**4*MNeu2(h1)+8*
     &  A0TNeu(h1)*((a0t1-a0t4)*(3*M12-2*M42)*(M12-M42)**2+(-(a0t4*
     &  (M12-6*M42))+a0t1*(9*M12+4*M42)-6*(M12**2+M12*M42+M42**2))*
     &  MNeu(h1)**4+(-3*a0t1-2*a0t4+6*(M12+M42))*MNeu(h1)**6-2*MNeu(h1)
     &  **8+(a0t1*(-9*M12**2+M42**2)+2*(M12**3-2*M12**2*M42+M42**3+
     &  a0t4*(3*M12**2+4*M12*M42-3*M42**2)))*MNeu2(h1))+8*I0A5(h1)*(3*
     &  (3*M12**2+M12*M42+2*M42**2)*MNeu(h1)**4-(3*M12+2*M42)*MNeu(h1)*
     &  *6+(3*M12**2-5*M12*M42+2*M42**2)*((M12-M42)**2-3*(M12+M42)*
     &  MNeu2(h1))))/(32.*alambda3(h1)**2)
       afin(32)=(-8*a0t1*a0t4*M12**3-476*a0t1*M12**4-392*a0t4*M12**4+
     &  264*aet1*M12**4+256*aet4*M12**4-113*M12**5-160*M4**10+24*a0t1*
     &  a0t4*M12**2*M42+1896*a0t1*M12**3*M42+1560*a0t4*M12**3*M42-1056*
     &  aet1*M12**3*M42-1024*aet4*M12**3*M42+276*M12**4*M42-24*a0t1*
     &  a0t4*M12*M42**2-2832*a0t1*M12**2*M42**2-2328*a0t4*M12**2*M42**
     &  2+1584*aet1*M12**2*M42**2+1536*aet4*M12**2*M42**2+10*M12**3*
     &  M42**2+8*a0t1*a0t4*M42**3+1880*a0t1*M12*M42**3+1544*a0t4*M12*
     &  M42**3-1056*aet1*M12*M42**3-1024*aet4*M12*M42**3-556*M12**2*
     &  M42**3-468*a0t1*M42**4-384*a0t4*M42**4+264*aet1*M42**4+256*
     &  aet4*M42**4+543*M12*M42**4+1032*a0t1*a0t4*M12*MNeu(h1)**4-2040*
     &  a0t1*M12**2*MNeu(h1)**4-1592*a0t4*M12**2*MNeu(h1)**4+1584*aet1*
     &  M12**2*MNeu(h1)**4+1536*aet4*M12**2*MNeu(h1)**4+650*M12**3*
     &  MNeu(h1)**4+1064*a0t1*a0t4*M42*MNeu(h1)**4-1336*a0t1*M12*M42*
     &  MNeu(h1)**4-1048*a0t4*M12*M42*MNeu(h1)**4+1056*aet1*M12*M42*
     &  MNeu(h1)**4+1024*aet4*M12*M42*MNeu(h1)**4-628*M12**2*M42*
     &  MNeu(h1)**4-2016*a0t1*M42**2*MNeu(h1)**4-1536*a0t4*M42**2*
     &  MNeu(h1)**4+1584*aet1*M42**2*MNeu(h1)**4+1536*aet4*M42**2*
     &  MNeu(h1)**4-518*M12*M42**2*MNeu(h1)**4+320*M42**3*MNeu(h1)**4-
     &  528*a0t1*a0t4*MNeu(h1)**6+1088*a0t1*M12*MNeu(h1)**6+792*a0t4*
     &  M12*MNeu(h1)**6-1056*aet1*M12*MNeu(h1)**6-1024*aet4*M12*
     &  MNeu(h1)**6-748*M12**2*MNeu(h1)**6+1080*a0t1*M42*MNeu(h1)**6+
     &  768*a0t4*M42*MNeu(h1)**6-1056*aet1*M42*MNeu(h1)**6-1024*aet4*
     &  M42*MNeu(h1)**6-716*M12*M42*MNeu(h1)**6-512*M42**2*MNeu(h1)**6-
     &  204*a0t1*MNeu(h1)**8-128*a0t4*MNeu(h1)**8+264*aet1*MNeu(h1)**8+
     &  256*aet4*MNeu(h1)**8+159*M12*MNeu(h1)**8+96*M42*MNeu(h1)**8+64*
     &  MNeu(h1)**10-496*a0t1*a0t4*M12**2*MNeu2(h1)+1632*a0t1*M12**3*
     &  MNeu2(h1)+1320*a0t4*M12**3*MNeu2(h1)-1056*aet1*M12**3*MNeu2(h1)
     &  -1024*aet4*M12**3*MNeu2(h1)-12*M12**4*MNeu2(h1)+1040*a0t1*a0t4*
     &  M12*M42*MNeu2(h1)-1608*a0t1*M12**2*M42*MNeu2(h1)-1312*a0t4*M12*
     &  *2*M42*MNeu2(h1)+1056*aet1*M12**2*M42*MNeu2(h1)+1024*aet4*M12**
     &  2*M42*MNeu2(h1)+1036*M12**3*M42*MNeu2(h1)-544*a0t1*a0t4*M42**2*
     &  MNeu2(h1)-1632*a0t1*M12*M42**2*MNeu2(h1)-1288*a0t4*M12*M42**2*
     &  MNeu2(h1)+1056*aet1*M12*M42**2*MNeu2(h1)+1024*aet4*M12*M42**2*
     &  MNeu2(h1)-1748*M12**2*M42**2*MNeu2(h1)+1608*a0t1*M42**3*
     &  MNeu2(h1)+1280*a0t4*M42**3*MNeu2(h1)-1056*aet1*M42**3*MNeu2(h1)
     &  -1024*aet4*M42**3*MNeu2(h1)+532*M12*M42**3*MNeu2(h1)+192*M42**
     &  4*MNeu2(h1)-8*A0TNeu(h1)*((a0t1-a0t4)*(33*M12-32*M42)*(M12-M42)
     &  **2+(99*a0t1*M12+29*a0t4*M12-96*M12**2+34*a0t1*M42+96*a0t4*M42-
     &  66*M12*M42-96*M42**2)*MNeu(h1)**4+(-33*a0t1-32*(a0t4-3*(M12+
     &  M42)))*MNeu(h1)**6-32*MNeu(h1)**8+(32*M12**3-34*M12**2*M42-30*
     &  M12*M42**2+32*M42**3+4*a0t4*(9*M12**2+17*M12*M42-24*M42**2)+
     &  a0t1*(-99*M12**2+60*M12*M42+31*M42**2))*MNeu2(h1))-8*I0A5(h1)*
     &  ((99*M12**2+63*M12*M42+96*M42**2)*MNeu(h1)**4-(33*M12+32*M42)*
     &  MNeu(h1)**6+(33*M12**2-65*M12*M42+32*M42**2)*((M12-M42)**2-3*
     &  (M12+M42)*MNeu2(h1))))/(32.*alambda3(h1)**2)
       afin(33)=(56*a0t1*a0t4*M12**3+140*a0t1*M12**4+32*a0t4*M12**4-40*
     &  aet1*M12**4+16*aet4*M12**4+21*M12**5-10*M4**10-168*a0t1*a0t4*
     &  M12**2*M42-504*a0t1*M12**3*M42-72*a0t4*M12**3*M42+160*aet1*M12*
     &  *3*M42-64*aet4*M12**3*M42+18*M12**4*M42+168*a0t1*a0t4*M12*M42**
     &  2+672*a0t1*M12**2*M42**2+24*a0t4*M12**2*M42**2-240*aet1*M12**2*
     &  M42**2+96*aet4*M12**2*M42**2-170*M12**3*M42**2-56*a0t1*a0t4*
     &  M42**3-392*a0t1*M12*M42**3+40*a0t4*M12*M42**3+160*aet1*M12*M42*
     &  *3-64*aet4*M12*M42**3+192*M12**2*M42**3+84*a0t1*M42**4-24*a0t4*
     &  M42**4-40*aet1*M42**4+16*aet4*M42**4-51*M12*M42**4+8*a0t1*a0t4*
     &  M12*MNeu(h1)**4+552*a0t1*M12**2*MNeu(h1)**4+296*a0t4*M12**2*
     &  MNeu(h1)**4-240*aet1*M12**2*MNeu(h1)**4+96*aet4*M12**2*MNeu(h1)
     &  **4-130*M12**3*MNeu(h1)**4-216*a0t1*a0t4*M42*MNeu(h1)**4+200*
     &  a0t1*M12*M42*MNeu(h1)**4+104*a0t4*M12*M42*MNeu(h1)**4-160*aet1*
     &  M12*M42*MNeu(h1)**4+64*aet4*M12*M42*MNeu(h1)**4-40*M12**2*M42*
     &  MNeu(h1)**4+384*a0t1*M42**2*MNeu(h1)**4-96*a0t4*M42**2*MNeu(h1)
     &  **4-240*aet1*M42**2*MNeu(h1)**4+96*aet4*M42**2*MNeu(h1)**4-90*
     &  M12*M42**2*MNeu(h1)**4+20*M42**3*MNeu(h1)**4+80*a0t1*a0t4*
     &  MNeu(h1)**6-272*a0t1*M12*MNeu(h1)**6-120*a0t4*M12*MNeu(h1)**6+
     &  160*aet1*M12*MNeu(h1)**6-64*aet4*M12*MNeu(h1)**6+180*M12**2*
     &  MNeu(h1)**6-216*a0t1*M42*MNeu(h1)**6+48*a0t4*M42*MNeu(h1)**6+
     &  160*aet1*M42*MNeu(h1)**6-64*aet4*M42*MNeu(h1)**6-44*M12*M42*
     &  MNeu(h1)**6-32*M42**2*MNeu(h1)**6+44*a0t1*MNeu(h1)**8-8*a0t4*
     &  MNeu(h1)**8-40*aet1*MNeu(h1)**8+16*aet4*MNeu(h1)**8-75*M12*
     &  MNeu(h1)**8+6*M42*MNeu(h1)**8+4*MNeu(h1)**10-144*a0t1*a0t4*M12*
     &  *2*MNeu2(h1)-464*a0t1*M12**3*MNeu2(h1)-200*a0t4*M12**3*
     &  MNeu2(h1)+160*aet1*M12**3*MNeu2(h1)-64*aet4*M12**3*MNeu2(h1)-
     &  48*a0t1*a0t4*M12*M42*MNeu2(h1)+296*a0t1*M12**2*M42*MNeu2(h1)+
     &  144*a0t4*M12**2*M42*MNeu2(h1)-160*aet1*M12**2*M42*MNeu2(h1)+64*
     &  aet4*M12**2*M42*MNeu2(h1)-388*M12**3*M42*MNeu2(h1)+192*a0t1*
     &  a0t4*M42**2*MNeu2(h1)+464*a0t1*M12*M42**2*MNeu2(h1)-24*a0t4*
     &  M12*M42**2*MNeu2(h1)-160*aet1*M12*M42**2*MNeu2(h1)+64*aet4*M12*
     &  M42**2*MNeu2(h1)+116*M12**2*M42**2*MNeu2(h1)-296*a0t1*M42**3*
     &  MNeu2(h1)+80*a0t4*M42**3*MNeu2(h1)+160*aet1*M42**3*MNeu2(h1)-
     &  64*aet4*M42**3*MNeu2(h1)+260*M12*M42**3*MNeu2(h1)+12*M42**4*
     &  MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t4)*(M12-M42)**2*(5*M12+2*M42)+
     &  (-23*a0t4*M12+6*M12**2-6*a0t4*M42-10*M12*M42+6*M42**2+3*a0t1*
     &  (5*M12+4*M42))*MNeu(h1)**4-(5*a0t1-2*a0t4+6*(M12+M42))*MNeu(h1)
     &  **6+2*MNeu(h1)**8-(a0t1*(15*M12**2+32*M12*M42+9*M42**2)+2*(M12*
     &  *3+6*M12**2*M42-8*M12*M42**2+M42**3-a0t4*(13*M12**2+12*M12*M42+
     &  3*M42**2)))*MNeu2(h1))+8*I0A5(h1)*((15*M12**2-11*M12*M42-6*M42*
     &  *2)*MNeu(h1)**4+(-5*M12+2*M42)*MNeu(h1)**6+(5*M12**2-3*M12*M42-
     &  2*M42**2)*((M12-M42)**2-3*(M12+M42)*MNeu2(h1))))/(32.*alambda3(h1)*
     &  *2)
       afin(34)=-(-8*a0t1*a0t4*M12**3-116*a0t1*M12**4-32*a0t4*M12**4+
     &  24*aet1*M12**4+16*aet4*M12**4+37*M12**5-10*M4**10+24*a0t1*a0t4*
     &  M12**2*M42+456*a0t1*M12**3*M42+120*a0t4*M12**3*M42-96*aet1*M12*
     &  *3*M42-64*aet4*M12**3*M42-174*M12**4*M42-24*a0t1*a0t4*M12*M42**
     &  2-672*a0t1*M12**2*M42**2-168*a0t4*M12**2*M42**2+144*aet1*M12**
     &  2*M42**2+96*aet4*M12**2*M42**2+310*M12**3*M42**2+8*a0t1*a0t4*
     &  M42**3+440*a0t1*M12*M42**3+104*a0t4*M12*M42**3-96*aet1*M12*M42*
     &  *3-64*aet4*M12*M42**3-256*M12**2*M42**3-108*a0t1*M42**4-24*
     &  a0t4*M42**4+24*aet1*M42**4+16*aet4*M42**4+93*M12*M42**4+72*
     &  a0t1*a0t4*M12*MNeu(h1)**4-600*a0t1*M12**2*MNeu(h1)**4-152*a0t4*
     &  M12**2*MNeu(h1)**4+144*aet1*M12**2*MNeu(h1)**4+96*aet4*M12**2*
     &  MNeu(h1)**4+350*M12**3*MNeu(h1)**4+104*a0t1*a0t4*M42*MNeu(h1)**
     &  4-376*a0t1*M12*M42*MNeu(h1)**4-88*a0t4*M12*M42*MNeu(h1)**4+96*
     &  aet1*M12*M42*MNeu(h1)**4+64*aet4*M12*M42*MNeu(h1)**4+152*M12**
     &  2*M42*MNeu(h1)**4-576*a0t1*M42**2*MNeu(h1)**4-96*a0t4*M42**2*
     &  MNeu(h1)**4+144*aet1*M42**2*MNeu(h1)**4+96*aet4*M42**2*MNeu(h1)
     &  **4+262*M12*M42**2*MNeu(h1)**4+20*M42**3*MNeu(h1)**4-48*a0t1*
     &  a0t4*MNeu(h1)**6+368*a0t1*M12*MNeu(h1)**6+72*a0t4*M12*MNeu(h1)*
     &  *6-96*aet1*M12*MNeu(h1)**6-64*aet4*M12*MNeu(h1)**6-268*M12**2*
     &  MNeu(h1)**6+360*a0t1*M42*MNeu(h1)**6+48*a0t4*M42*MNeu(h1)**6-
     &  96*aet1*M42*MNeu(h1)**6-64*aet4*M42*MNeu(h1)**6-236*M12*M42*
     &  MNeu(h1)**6-32*M42**2*MNeu(h1)**6-84*a0t1*MNeu(h1)**8-8*a0t4*
     &  MNeu(h1)**8+24*aet1*MNeu(h1)**8+16*aet4*MNeu(h1)**8+69*M12*
     &  MNeu(h1)**8+6*M42*MNeu(h1)**8+4*MNeu(h1)**10-16*a0t1*a0t4*M12**
     &  2*MNeu2(h1)+432*a0t1*M12**3*MNeu2(h1)+120*a0t4*M12**3*MNeu2(h1)
     &  -96*aet1*M12**3*MNeu2(h1)-64*aet4*M12**3*MNeu2(h1)-192*M12**4*
     &  MNeu2(h1)+80*a0t1*a0t4*M12*M42*MNeu2(h1)-408*a0t1*M12**2*M42*
     &  MNeu2(h1)-112*a0t4*M12**2*M42*MNeu2(h1)+96*aet1*M12**2*M42*
     &  MNeu2(h1)+64*aet4*M12**2*M42*MNeu2(h1)+316*M12**3*M42*MNeu2(h1)
     &  -64*a0t1*a0t4*M42**2*MNeu2(h1)-432*a0t1*M12*M42**2*MNeu2(h1)-
     &  88*a0t4*M12*M42**2*MNeu2(h1)+96*aet1*M12*M42**2*MNeu2(h1)+64*
     &  aet4*M12*M42**2*MNeu2(h1)+52*M12**2*M42**2*MNeu2(h1)+408*a0t1*
     &  M42**3*MNeu2(h1)+80*a0t4*M42**3*MNeu2(h1)-96*aet1*M42**3*
     &  MNeu2(h1)-64*aet4*M42**3*MNeu2(h1)-188*M12*M42**3*MNeu2(h1)+12*
     &  M42**4*MNeu2(h1)-8*A0TNeu(h1)*((a0t1-a0t4)*(3*M12-2*M42)*(M12-
     &  M42)**2+(-(a0t4*(M12-6*M42))+a0t1*(9*M12+4*M42)-6*(M12**2+M12*
     &  M42+M42**2))*MNeu(h1)**4+(-3*a0t1-2*a0t4+6*(M12+M42))*MNeu(h1)*
     &  *6-2*MNeu(h1)**8+(a0t1*(-9*M12**2+M42**2)+2*(M12**3-2*M12**2*
     &  M42+M42**3+a0t4*(3*M12**2+4*M12*M42-3*M42**2)))*MNeu2(h1))-8*
     &  I0A5(h1)*(3*(3*M12**2+M12*M42+2*M42**2)*MNeu(h1)**4-(3*M12+2*
     &  M42)*MNeu(h1)**6+(3*M12**2-5*M12*M42+2*M42**2)*((M12-M42)**2-3*
     &  (M12+M42)*MNeu2(h1))))/(32.*alambda3(h1)**2)
       afin(35)=(((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*M22+4*aet1*
     &  M22-M12*M22)*(M12-4*M22+4*MNeu2(h1)))/(M12*M22m42)+((-4*a0t1*
     &  a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(M12-
     &  4*M42+4*MNeu2(h1)))/(M12*M22m42)+((4*a0t1*a0t2-2*a0t2*M12+4*
     &  aet2*M12-2*a0t1*M22+4*aet1*M22-M12*M22)*(M12-M22+MNeu2(h1))*
     &  (M12**2+3*M12*M22-4*M22**2-4*MNeu(h1)**4+(3*M12+8*M22)*
     &  MNeu2(h1)))/(alambda2(h1)*M12*M22m42)+(2*((-4*a0t2+2*M22)*
     &  A0TNeu(h1)-4*M22*AETNeu(h1)+(2*a0t2-4*aet2+M22)*MNeu2(h1))*
     &  (M12**2+3*M12*M22-4*M22**2-4*MNeu(h1)**4+(3*M12+8*M22)*
     &  MNeu2(h1)))/(alambda2(h1)*M22m42)+((-4*a0t1*a0t4+2*a0t4*M12-4*aet4*
     &  M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(M12-M42+MNeu2(h1))*(M12**2+
     &  3*M12*M42-4*M42**2-4*MNeu(h1)**4+(3*M12+8*M42)*MNeu2(h1)))
     &  /(alambda3(h1)*M12*M22m42)-(2*((-4*a0t4+2*M42)*A0TNeu(h1)-4*M42*
     &  AETNeu(h1)+(2*a0t4-4*aet4+M42)*MNeu2(h1))*(M12**2+3*M12*M42-4*
     &  M42**2-4*MNeu(h1)**4+(3*M12+8*M42)*MNeu2(h1)))/(alambda3(h1)*
     &  M22m42)-(10*(2*(-2*a0t1+M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*
     &  a0t1-4*aet1+M12)*MNeu2(h1))*(M12*(M12-M22)*(M12-M42)-(M12+M22+
     &  M42)*MNeu(h1)**4+MNeu(h1)**6+(-M12**2+M22*M42+2*M12*(M22+M42))*
     &  MNeu2(h1)))/(alambda2(h1)*alambda3(h1))+(-8*(aet1+aet2+AETNeu(h1)-
     &  I0A4(h1))*((M12-M22)**2*(M12+4*M22)-(7*M12+4*M22)*MNeu(h1)**4+
     &  4*MNeu(h1)**6+2*(M12**2-4*M12*M22-2*M22**2)*MNeu2(h1))+(M12+
     &  M22+MNeu2(h1))*((M12-M22)**2*(M12+4*M22)-(7*M12+4*M22)*MNeu(h1)
     &  **4+4*MNeu(h1)**6+2*(M12**2+6*M12*M22-2*M22**2)*MNeu2(h1))+2*
     &  (2*a0t1+2*a0t2+M12+M22+2*A0TNeu(h1)+MNeu2(h1))*((M12-M22)**2*
     &  (M12+4*M22)-(7*M12+4*M22)*MNeu(h1)**4+4*MNeu(h1)**6+2*(M12**2+
     &  6*M12*M22-2*M22**2)*MNeu2(h1)))/(alambda2(h1)*M22m42)+(4*(2*(aet1+
     &  aet4+AETNeu(h1)-I0A5(h1))*((M12-M42)**2*(M12+4*M42)-(7*M12+4*
     &  M42)*MNeu(h1)**4+4*MNeu(h1)**6+2*(M12**2-4*M12*M42-2*M42**2)*
     &  MNeu2(h1))-((M12+M42+MNeu2(h1))*((M12-M42)**2*(M12+4*M42)-(7*
     &  M12+4*M42)*MNeu(h1)**4+4*MNeu(h1)**6+2*(M12**2+6*M12*M42-2*M42*
     &  *2)*MNeu2(h1)))/4.-((2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+
     &  MNeu2(h1))*((M12-M42)**2*(M12+4*M42)-(7*M12+4*M42)*MNeu(h1)**4+
     &  4*MNeu(h1)**6+2*(M12**2+6*M12*M42-2*M42**2)*MNeu2(h1)))/2.))
     &  /(alambda3(h1)*M22m42))/16.
       afin(36)=(((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*M22+4*aet1*
     &  M22-M12*M22)*(4*M12-M22+MNeu2(h1)))/(M12*M22m42)+((-4*a0t1*
     &  a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(4*
     &  M12-M42+MNeu2(h1)))/(M12*M22m42)-(2*(-4*M12**2+3*M12*M22+M22**
     &  2+MNeu(h1)**4+(3*M12-2*M22)*MNeu2(h1))*(2*(-2*a0t2+M22)*
     &  A0TNeu(h1)-4*M22*AETNeu(h1)+(2*a0t2-4*aet2+M22)*MNeu2(h1)))
     &  /(alambda2(h1)*M22m42)+((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*
     &  M22+4*aet1*M22-M12*M22)*(M12-M22+MNeu2(h1))*(4*M12**2-3*M12*
     &  M22-M22**2-MNeu(h1)**4+(-3*M12+2*M22)*MNeu2(h1)))/(alambda2(h1)*
     &  M12*M22m42)+(2*(-4*M12**2+3*M12*M42+M42**2+MNeu(h1)**4+(3*M12-
     &  2*M42)*MNeu2(h1))*(2*(-2*a0t4+M42)*A0TNeu(h1)-4*M42*AETNeu(h1)+
     &  (2*a0t4-4*aet4+M42)*MNeu2(h1)))/(alambda3(h1)*M22m42)+((-4*a0t1*
     &  a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*(M12-
     &  M42+MNeu2(h1))*(4*M12**2-3*M12*M42-M42**2-MNeu(h1)**4+(-3*M12+
     &  2*M42)*MNeu2(h1)))/(alambda3(h1)*M12*M22m42)-(10*(2*(-2*a0t1+M12)*
     &  A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*MNeu2(h1))*
     &  (M12*(M12-M22)*(M12-M42)-(M12+M22+M42)*MNeu(h1)**4+MNeu(h1)**6+
     &  (-M12**2+M22*M42+2*M12*(M22+M42))*MNeu2(h1)))/(alambda2(h1)*
     &  alambda3(h1))+((M12+M22+MNeu2(h1))*((M12-M22)**2*(4*M12+M22)+(2*
     &  M12-M22)*MNeu(h1)**4+MNeu(h1)**6-(7*M12**2-18*M12*M22+M22**2)*
     &  MNeu2(h1))+2*(2*a0t1+2*a0t2+M12+M22+2*A0TNeu(h1)+MNeu2(h1))*
     &  ((M12-M22)**2*(4*M12+M22)+(2*M12-M22)*MNeu(h1)**4+MNeu(h1)**6-
     &  (7*M12**2-18*M12*M22+M22**2)*MNeu2(h1))-8*(aet1+aet2+AETNeu(h1)
     &  -I0A4(h1))*((M12-M22)**2*(4*M12+M22)+(2*M12-M22)*MNeu(h1)**4+
     &  MNeu(h1)**6-(7*M12**2+2*M12*M22+M22**2)*MNeu2(h1)))/(alambda2(h1)*
     &  M22m42)+(8*(-((M12+M42+MNeu2(h1))*((M12-M42)**2*(4*M12+M42)+(2*
     &  M12-M42)*MNeu(h1)**4+MNeu(h1)**6-(7*M12**2-18*M12*M42+M42**2)*
     &  MNeu2(h1)))/8.-((2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+MNeu2(h1))*
     &  ((M12-M42)**2*(4*M12+M42)+(2*M12-M42)*MNeu(h1)**4+MNeu(h1)**6-
     &  (7*M12**2-18*M12*M42+M42**2)*MNeu2(h1)))/4.+(aet1+aet4+
     &  AETNeu(h1)-I0A5(h1))*((M12-M42)**2*(4*M12+M42)+(2*M12-M42)*
     &  MNeu(h1)**4+MNeu(h1)**6-(7*M12**2+2*M12*M42+M42**2)*MNeu2(h1)))
     &  )/(alambda3(h1)*M22m42))/16.
       afin(37)=(((4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*a0t1*M22+4*aet1*
     &  M22-M12*M22)*(M2-MNeu(h1))*(M2+MNeu(h1)))/(M12*M22m42)+((-4*
     &  a0t1*a0t4+2*a0t4*M12-4*aet4*M12+2*a0t1*M42-4*aet1*M42+M12*M42)*
     &  (M4-MNeu(h1))*(M4+MNeu(h1)))/(M12*M22m42)+(2*(2*(-2*a0t2+M22)*
     &  A0TNeu(h1)-4*M22*AETNeu(h1)+(2*a0t2-4*aet2+M22)*MNeu2(h1))*
     &  (M22*(-M12+M22)+MNeu(h1)**4-(M12+2*M22)*MNeu2(h1)))/(alambda2(h1)*
     &  M22m42)+((-4*a0t1*a0t2+2*a0t2*M12-4*aet2*M12+2*a0t1*M22-4*aet1*
     &  M22+M12*M22)*(M12-M22+MNeu2(h1))*((M12-M22)*M22-MNeu(h1)**4+
     &  (M12+2*M22)*MNeu2(h1)))/(alambda2(h1)*M12*M22m42)-(2*(2*(-2*a0t4+
     &  M42)*A0TNeu(h1)-4*M42*AETNeu(h1)+(2*a0t4-4*aet4+M42)*MNeu2(h1))
     &  *(M42*(-M12+M42)+MNeu(h1)**4-(M12+2*M42)*MNeu2(h1)))/(alambda3(h1)*
     &  M22m42)+((4*a0t1*a0t4-2*a0t4*M12+4*aet4*M12-2*a0t1*M42+4*aet1*
     &  M42-M12*M42)*(M12-M42+MNeu2(h1))*((M12-M42)*M42-MNeu(h1)**4+
     &  (M12+2*M42)*MNeu2(h1)))/(alambda3(h1)*M12*M22m42)+(2*(2*(-2*a0t1+
     &  M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*MNeu2(h1))
     &  *(M12*(M12-M22)*(M12-M42)-(M12+M22+M42)*MNeu(h1)**4+MNeu(h1)**
     &  6+(-M12**2+M22*M42+2*M12*(M22+M42))*MNeu2(h1)))/(alambda2(h1)*
     &  alambda3(h1))+(8*((aet1+aet2+AETNeu(h1)-I0A4(h1))*((-(M12*M2)+M2**
     &  3)**2-(2*M12+M22)*MNeu(h1)**4+MNeu(h1)**6+(M12**2-2*M12*M22-
     &  M22**2)*MNeu2(h1))-((M12+M22+MNeu2(h1))*((-(M12*M2)+M2**3)**2-
     &  (2*M12+M22)*MNeu(h1)**4+MNeu(h1)**6+(M12**2+2*M12*M22-M22**2)*
     &  MNeu2(h1)))/8.-((2*a0t1+2*a0t2+M12+M22+2*A0TNeu(h1)+MNeu2(h1))*
     &  ((-(M12*M2)+M2**3)**2-(2*M12+M22)*MNeu(h1)**4+MNeu(h1)**6+(M12*
     &  *2+2*M12*M22-M22**2)*MNeu2(h1)))/4.))/(alambda2(h1)*M22m42)+(-8*
     &  (aet1+aet4+AETNeu(h1)-I0A5(h1))*((-(M12*M4)+M4**3)**2-(2*M12+
     &  M42)*MNeu(h1)**4+MNeu(h1)**6+(M12**2-2*M12*M42-M42**2)*
     &  MNeu2(h1))+(M12+M42+MNeu2(h1))*((-(M12*M4)+M4**3)**2-(2*M12+
     &  M42)*MNeu(h1)**4+MNeu(h1)**6+(M12**2+2*M12*M42-M42**2)*
     &  MNeu2(h1))+2*(2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+MNeu2(h1))*((-
     &  (M12*M4)+M4**3)**2-(2*M12+M42)*MNeu(h1)**4+MNeu(h1)**6+(M12**2+
     &  2*M12*M42-M42**2)*MNeu2(h1)))/(alambda3(h1)*M22m42))/16.
       afin(38)=(2*M42*(2*a0t4*M12+4*aet4*M12+4*aet1*M42+M12*M42+2*
     &  a0t1*(2*a0t4+M42))-2*(2*a0t2*M12*M22-4*aet2*M12*M22-4*aet1*M22*
     &  *2+M12*M22**2+8*aet2*M12*M42+8*aet1*M22*M42+a0t1*(-4*a0t2*M22+
     &  2*M22**2+8*a0t2*M42))+(2*(4*a0t1*a0t2-2*a0t2*M12+4*aet2*M12-2*
     &  a0t1*M22+4*aet1*M22-M12*M22)*M22m42*(M12-M22-MNeu2(h1))*(M12-
     &  M22+MNeu2(h1)))/alambda2(h1)-M42*(-M12+M42-MNeu2(h1))*(4*a0t1+4*
     &  a0t4+8*aet1+8*aet4+3*M12+3*M42+4*A0TNeu(h1)+8*AETNeu(h1)-8*
     &  I0A5(h1)+3*MNeu2(h1))+(4*M22*M22m42*(-M12+M22-MNeu2(h1))*(2*(-
     &  2*a0t1+M12)*A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*
     &  MNeu2(h1)))/alambda2(h1)+2*M42*(2*(2*a0t4+M42)*A0TNeu(h1)+4*M42*
     &  AETNeu(h1)+(2*a0t4+4*aet4+M42)*MNeu2(h1))+(2*(-4*M22m42*(2*M22*
     &  A0TNeu(h1)+(2*a0t2+M22)*MNeu2(h1))*(M22*(-M12+M22)+MNeu(h1)**4-
     &  (M12+2*M22)*MNeu2(h1))+(2*(2*a0t2+M22)*A0TNeu(h1)+4*M22*
     &  AETNeu(h1)+(2*a0t2+4*aet2+M22)*MNeu2(h1))*(-((M12-M22)*(2*M22**
     &  2+M12*M42-3*M22*M42))+(2*M22-3*M42)*MNeu(h1)**4+(-2*M12*M22-4*
     &  M22**2+4*M12*M42+6*M22*M42)*MNeu2(h1))))/alambda2(h1)+(8*(-((aet1+
     &  aet2+AETNeu(h1)-I0A4(h1))*((M12-M22)**2*(2*M22**2+M12*M42-3*
     &  M22*M42)+(2*M22**2-M12*M42-5*M22*M42)*MNeu(h1)**4+M42*MNeu(h1)*
     &  *6-(4*M22**3+M12**2*M42+2*M12*M22*M42-7*M22**2*M42)*MNeu2(h1)))
     &  -((M12+M22+MNeu2(h1))*((M12-M22)**2*(-2*M22**2+M12*M42+M22*M42)
     &  -(2*M22**2+M12*M42+M22*M42)*MNeu(h1)**4+M42*MNeu(h1)**6-(2*M12*
     &  M22*(4*M22-3*M42)+M12**2*M42+M22**2*(-4*M22+M42))*MNeu2(h1)))
     &  /8.-((2*a0t1+2*a0t2+M12+M22+2*A0TNeu(h1)+MNeu2(h1))*((M12-M22)*
     &  *2*(-2*M22**2+M12*M42+M22*M42)-(2*M22**2+M12*M42+M22*M42)*
     &  MNeu(h1)**4+M42*MNeu(h1)**6-(2*M12*M22*(4*M22-3*M42)+M12**2*
     &  M42+M22**2*(-4*M22+M42))*MNeu2(h1)))/4.))/alambda2(h1))/(16.*
     &  M22m42s)
       afin(39)=-(-8*a0t1*a0t2*M12**3+4*a0t1*M12**4+16*a0t2*M12**4-8*
     &  aet1*M12**4-16*aet2*M12**4+3*M12**5+10*M2**10+24*a0t1*a0t2*M12*
     &  *2*M22-24*a0t1*M12**3*M22-72*a0t2*M12**3*M22+32*aet1*M12**3*
     &  M22+64*aet2*M12**3*M22-18*M12**4*M22-24*a0t1*a0t2*M12*M22**2+
     &  48*a0t1*M12**2*M22**2+120*a0t2*M12**2*M22**2-48*aet1*M12**2*
     &  M22**2-96*aet2*M12**2*M22**2+26*M12**3*M22**2+8*a0t1*a0t2*M22**
     &  3-40*a0t1*M12*M22**3-88*a0t2*M12*M22**3+32*aet1*M12*M22**3+64*
     &  aet2*M12*M22**3+12*a0t1*M22**4+24*a0t2*M22**4-8*aet1*M22**4-16*
     &  aet2*M22**4-21*M12*M22**4-56*a0t1*a0t2*M12*MNeu(h1)**4+24*a0t1*
     &  M12**2*MNeu(h1)**4+40*a0t2*M12**2*MNeu(h1)**4-48*aet1*M12**2*
     &  MNeu(h1)**4-96*aet2*M12**2*MNeu(h1)**4-14*M12**3*MNeu(h1)**4-
     &  24*a0t1*a0t2*M22*MNeu(h1)**4+40*a0t1*M12*M22*MNeu(h1)**4+40*
     &  a0t2*M12*M22*MNeu(h1)**4-32*aet1*M12*M22*MNeu(h1)**4-64*aet2*
     &  M12*M22*MNeu(h1)**4+40*M12**2*M22*MNeu(h1)**4+48*a0t1*M22**2*
     &  MNeu(h1)**4+96*a0t2*M22**2*MNeu(h1)**4-48*aet1*M22**2*MNeu(h1)*
     &  *4-96*aet2*M22**2*MNeu(h1)**4+42*M12*M22**2*MNeu(h1)**4-20*M22*
     &  *3*MNeu(h1)**4+16*a0t1*a0t2*MNeu(h1)**6-16*a0t1*M12*MNeu(h1)**
     &  6-24*a0t2*M12*MNeu(h1)**6+32*aet1*M12*MNeu(h1)**6+64*aet2*M12*
     &  MNeu(h1)**6+12*M12**2*MNeu(h1)**6-24*a0t1*M22*MNeu(h1)**6-48*
     &  a0t2*M22*MNeu(h1)**6+32*aet1*M22*MNeu(h1)**6+64*aet2*M22*
     &  MNeu(h1)**6+44*M12*M22*MNeu(h1)**6+32*M22**2*MNeu(h1)**6+4*
     &  a0t1*MNeu(h1)**8+8*a0t2*MNeu(h1)**8-8*aet1*MNeu(h1)**8-16*aet2*
     &  MNeu(h1)**8+3*M12*MNeu(h1)**8-6*M22*MNeu(h1)**8-4*MNeu(h1)**10+
     &  48*a0t1*a0t2*M12**2*MNeu2(h1)-16*a0t1*M12**3*MNeu2(h1)-40*a0t2*
     &  M12**3*MNeu2(h1)+32*aet1*M12**3*MNeu2(h1)+64*aet2*M12**3*
     &  MNeu2(h1)-48*a0t1*a0t2*M12*M22*MNeu2(h1)+40*a0t1*M12**2*M22*
     &  MNeu2(h1)+48*a0t2*M12**2*M22*MNeu2(h1)-32*aet1*M12**2*M22*
     &  MNeu2(h1)-64*aet2*M12**2*M22*MNeu2(h1)+4*M12**3*M22*MNeu2(h1)+
     &  16*a0t1*M12*M22**2*MNeu2(h1)+72*a0t2*M12*M22**2*MNeu2(h1)-32*
     &  aet1*M12*M22**2*MNeu2(h1)-64*aet2*M12*M22**2*MNeu2(h1)+76*M12**
     &  2*M22**2*MNeu2(h1)-40*a0t1*M22**3*MNeu2(h1)-80*a0t2*M22**3*
     &  MNeu2(h1)+32*aet1*M22**3*MNeu2(h1)+64*aet2*M22**3*MNeu2(h1)-68*
     &  M12*M22**3*MNeu2(h1)-12*M22**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-
     &  a0t2)*(M12-2*M22)*(M12-M22)**2+(3*a0t1*M12+5*a0t2*M12-6*M12**2+
     &  6*a0t2*M22-2*M12*M22-6*M22**2)*MNeu(h1)**4-(a0t1+2*(a0t2-3*
     &  (M12+M22)))*MNeu(h1)**6-2*MNeu(h1)**8+(a0t1*(-3*M12**2+8*M12*
     &  M22+3*M22**2)+2*(M12**3-2*M12*M22**2+M22**3-a0t2*(M12**2+3*M22*
     &  *2)))*MNeu2(h1))+8*I0A4(h1)*((3*M12**2+5*M12*M22+6*M22**2)*
     &  MNeu(h1)**4-(M12+2*M22)*MNeu(h1)**6+(M12**2-3*M12*M22+2*M22**2)
     &  *((M12-M22)**2-3*(M12+M22)*MNeu2(h1))))/(16.*alambda2(h1)**2)
       afin(40)=-(40*a0t1*a0t2*M12**3+76*a0t1*M12**4+16*a0t2*M12**4-24*
     &  aet1*M12**4+16*aet2*M12**4+25*M12**5-10*M2**10-120*a0t1*a0t2*
     &  M12**2*M22-264*a0t1*M12**3*M22-24*a0t2*M12**3*M22+96*aet1*M12**
     &  3*M22-64*aet2*M12**3*M22-30*M12**4*M22+120*a0t1*a0t2*M12*M22**
     &  2+336*a0t1*M12**2*M22**2-24*a0t2*M12**2*M22**2-144*aet1*M12**2*
     &  M22**2+96*aet2*M12**2*M22**2-50*M12**3*M22**2-40*a0t1*a0t2*M22*
     &  *3-184*a0t1*M12*M22**3+56*a0t2*M12*M22**3+96*aet1*M12*M22**3-
     &  64*aet2*M12*M22**3+80*M12**2*M22**3+36*a0t1*M22**4-24*a0t2*M22*
     &  *4-24*aet1*M22**4+16*aet2*M22**4-15*M12*M22**4+24*a0t1*a0t2*
     &  M12*MNeu(h1)**4+264*a0t1*M12**2*MNeu(h1)**4+184*a0t2*M12**2*
     &  MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4+96*aet2*M12**2*MNeu(h1)
     &  **4-10*M12**3*MNeu(h1)**4-136*a0t1*a0t2*M22*MNeu(h1)**4+56*
     &  a0t1*M12*M22*MNeu(h1)**4+56*a0t2*M12*M22*MNeu(h1)**4-96*aet1*
     &  M12*M22*MNeu(h1)**4+64*aet2*M12*M22*MNeu(h1)**4+8*M12**2*M22*
     &  MNeu(h1)**4+144*a0t1*M22**2*MNeu(h1)**4-96*a0t2*M22**2*MNeu(h1)
     &  **4-144*aet1*M22**2*MNeu(h1)**4+96*aet2*M22**2*MNeu(h1)**4-2*
     &  M12*M22**2*MNeu(h1)**4+20*M22**3*MNeu(h1)**4+48*a0t1*a0t2*
     &  MNeu(h1)**6-112*a0t1*M12*MNeu(h1)**6-72*a0t2*M12*MNeu(h1)**6+
     &  96*aet1*M12*MNeu(h1)**6-64*aet2*M12*MNeu(h1)**6+68*M12**2*
     &  MNeu(h1)**6-72*a0t1*M22*MNeu(h1)**6+48*a0t2*M22*MNeu(h1)**6+96*
     &  aet1*M22*MNeu(h1)**6-64*aet2*M22*MNeu(h1)**6-92*M12*M22*
     &  MNeu(h1)**6-32*M22**2*MNeu(h1)**6+12*a0t1*MNeu(h1)**8-8*a0t2*
     &  MNeu(h1)**8-24*aet1*MNeu(h1)**8+16*aet2*MNeu(h1)**8-39*M12*
     &  MNeu(h1)**8+6*M22*MNeu(h1)**8+4*MNeu(h1)**10-112*a0t1*a0t2*M12*
     &  *2*MNeu2(h1)-240*a0t1*M12**3*MNeu2(h1)-120*a0t2*M12**3*
     &  MNeu2(h1)+96*aet1*M12**3*MNeu2(h1)-64*aet2*M12**3*MNeu2(h1)-48*
     &  M12**4*MNeu2(h1)-16*a0t1*a0t2*M12*M22*MNeu2(h1)+120*a0t1*M12**
     &  2*M22*MNeu2(h1)+80*a0t2*M12**2*M22*MNeu2(h1)-96*aet1*M12**2*
     &  M22*MNeu2(h1)+64*aet2*M12**2*M22*MNeu2(h1)-212*M12**3*M22*
     &  MNeu2(h1)+128*a0t1*a0t2*M22**2*MNeu2(h1)+240*a0t1*M12*M22**2*
     &  MNeu2(h1)-40*a0t2*M12*M22**2*MNeu2(h1)-96*aet1*M12*M22**2*
     &  MNeu2(h1)+64*aet2*M12*M22**2*MNeu2(h1)+100*M12**2*M22**2*
     &  MNeu2(h1)-120*a0t1*M22**3*MNeu2(h1)+80*a0t2*M22**3*MNeu2(h1)+
     &  96*aet1*M22**3*MNeu2(h1)-64*aet2*M22**3*MNeu2(h1)+148*M12*M22**
     &  3*MNeu2(h1)+12*M22**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t2)*(M12-
     &  M22)**2*(3*M12+2*M22)+(9*a0t1*M12-17*a0t2*M12+6*M12**2+8*a0t1*
     &  M22-6*a0t2*M22-6*M12*M22+6*M22**2)*MNeu(h1)**4-(3*a0t1-2*a0t2+
     &  6*(M12+M22))*MNeu(h1)**6+2*MNeu(h1)**8-(a0t1*(9*M12**2+24*M12*
     &  M22+7*M22**2)+2*(M12**3+4*M12**2*M22-6*M12*M22**2+M22**3-a0t2*
     &  (9*M12**2+8*M12*M22+3*M22**2)))*MNeu2(h1))+8*I0A4(h1)*((9*M12**
     &  2-9*M12*M22-6*M22**2)*MNeu(h1)**4+(-3*M12+2*M22)*MNeu(h1)**6+
     &  (3*M12**2-M12*M22-2*M22**2)*((M12-M22)**2-3*(M12+M22)*MNeu2(h1)
     &  )))/(16.*alambda2(h1)**2)
       afin(41)=(-40*a0t1*a0t2*M12**3-4*a0t1*M12**4+56*a0t2*M12**4-24*
     &  aet1*M12**4-64*aet2*M12**4+5*M12**5+40*M2**10+120*a0t1*a0t2*
     &  M12**2*M22-24*a0t1*M12**3*M22-264*a0t2*M12**3*M22+96*aet1*M12**
     &  3*M22+256*aet2*M12**3*M22-60*M12**4*M22-120*a0t1*a0t2*M12*M22**
     &  2+96*a0t1*M12**2*M22**2+456*a0t2*M12**2*M22**2-144*aet1*M12**2*
     &  M22**2-384*aet2*M12**2*M22**2+110*M12**3*M22**2+40*a0t1*a0t2*
     &  M22**3-104*a0t1*M12*M22**3-344*a0t2*M12*M22**3+96*aet1*M12*M22*
     &  *3+256*aet2*M12*M22**3-20*M12**2*M22**3+36*a0t1*M22**4+96*a0t2*
     &  M22**4-24*aet1*M22**4-64*aet2*M22**4-75*M12*M22**4-216*a0t1*
     &  a0t2*M12*MNeu(h1)**4+24*a0t1*M12**2*MNeu(h1)**4+104*a0t2*M12**
     &  2*MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4-384*aet2*M12**2*
     &  MNeu(h1)**4-50*M12**3*MNeu(h1)**4-56*a0t1*a0t2*M22*MNeu(h1)**4+
     &  136*a0t1*M12*M22*MNeu(h1)**4+136*a0t2*M12*M22*MNeu(h1)**4-96*
     &  aet1*M12*M22*MNeu(h1)**4-256*aet2*M12*M22*MNeu(h1)**4+148*M12**
     &  2*M22*MNeu(h1)**4+144*a0t1*M22**2*MNeu(h1)**4+384*a0t2*M22**2*
     &  MNeu(h1)**4-144*aet1*M22**2*MNeu(h1)**4-384*aet2*M22**2*
     &  MNeu(h1)**4+158*M12*M22**2*MNeu(h1)**4-80*M22**3*MNeu(h1)**4+
     &  48*a0t1*a0t2*MNeu(h1)**6-32*a0t1*M12*MNeu(h1)**6-72*a0t2*M12*
     &  MNeu(h1)**6+96*aet1*M12*MNeu(h1)**6+256*aet2*M12*MNeu(h1)**6+
     &  28*M12**2*MNeu(h1)**6-72*a0t1*M22*MNeu(h1)**6-192*a0t2*M22*
     &  MNeu(h1)**6+96*aet1*M22*MNeu(h1)**6+256*aet2*M22*MNeu(h1)**6+
     &  188*M12*M22*MNeu(h1)**6+128*M22**2*MNeu(h1)**6+12*a0t1*MNeu(h1)
     &  **8+32*a0t2*MNeu(h1)**8-24*aet1*MNeu(h1)**8-64*aet2*MNeu(h1)**
     &  8+21*M12*MNeu(h1)**8-24*M22*MNeu(h1)**8-16*MNeu(h1)**10+208*
     &  a0t1*a0t2*M12**2*MNeu2(h1)-120*a0t2*M12**3*MNeu2(h1)+96*aet1*
     &  M12**3*MNeu2(h1)+256*aet2*M12**3*MNeu2(h1)+12*M12**4*MNeu2(h1)-
     &  176*a0t1*a0t2*M12*M22*MNeu2(h1)+120*a0t1*M12**2*M22*MNeu2(h1)+
     &  160*a0t2*M12**2*M22*MNeu2(h1)-96*aet1*M12**2*M22*MNeu2(h1)-256*
     &  aet2*M12**2*M22*MNeu2(h1)+68*M12**3*M22*MNeu2(h1)-32*a0t1*a0t2*
     &  M22**2*MNeu2(h1)+280*a0t2*M12*M22**2*MNeu2(h1)-96*aet1*M12*M22*
     &  *2*MNeu2(h1)-256*aet2*M12*M22**2*MNeu2(h1)+260*M12**2*M22**2*
     &  MNeu2(h1)-120*a0t1*M22**3*MNeu2(h1)-320*a0t2*M22**3*MNeu2(h1)+
     &  96*aet1*M22**3*MNeu2(h1)+256*aet2*M22**3*MNeu2(h1)-292*M12*M22*
     &  *3*MNeu2(h1)-48*M22**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t2)*(3*
     &  M12-8*M22)*(M12-M22)**2+(a0t1*(9*M12-2*M22)+a0t2*(23*M12+24*
     &  M22)-6*(4*M12**2+M12*M22+4*M22**2))*MNeu(h1)**4+(-3*a0t1-8*
     &  (a0t2-3*(M12+M22)))*MNeu(h1)**6-8*MNeu(h1)**8+(a0t1*(-9*M12**2+
     &  36*M12*M22+13*M22**2)+2*(4*M12**3+M12**2*M22-9*M12*M22**2+4*
     &  M22**3-2*a0t2*(3*M12**2+M12*M22+6*M22**2)))*MNeu2(h1))+8*
     &  I0A4(h1)*(3*(3*M12**2+7*M12*M22+8*M22**2)*MNeu(h1)**4-(3*M12+8*
     &  M22)*MNeu(h1)**6+(3*M12**2-11*M12*M22+8*M22**2)*((M12-M22)**2-
     &  3*(M12+M22)*MNeu2(h1))))/(16.*alambda2(h1)**2)
       afin(42)=-(-2*M22*(2*a0t2*M12+4*aet2*M12+4*aet1*M22+M12*M22+2*
     &  a0t1*(2*a0t2+M22))+2*(aet4*M12*(8*M22-4*M42)+M42*(2*a0t4*M12+8*
     &  aet1*M22-4*aet1*M42+M12*M42)+2*a0t1*(4*a0t4*M22-2*a0t4*M42+M42*
     &  *2))+(2*M22m42*(4*a0t1*a0t4-2*a0t4*M12+4*aet4*M12-2*a0t1*M42+4*
     &  aet1*M42-M12*M42)*(M12-M42-MNeu2(h1))*(M12-M42+MNeu2(h1)))
     &  /alambda3(h1)+M22*(-M12+M22-MNeu2(h1))*(4*a0t1+4*a0t2+8*aet1+8*
     &  aet2+3*M12+3*M22+4*A0TNeu(h1)+8*AETNeu(h1)-8*I0A4(h1)+3*
     &  MNeu2(h1))+(4*M22m42*M42*(-M12+M42-MNeu2(h1))*(2*(-2*a0t1+M12)*
     &  A0TNeu(h1)-4*M12*AETNeu(h1)+(2*a0t1-4*aet1+M12)*MNeu2(h1)))
     &  /alambda3(h1)-2*M22*(2*(2*a0t2+M22)*A0TNeu(h1)+4*M22*AETNeu(h1)+(2*
     &  a0t2+4*aet2+M22)*MNeu2(h1))+(32*(-(M22m42*(2*M42*A0TNeu(h1)+(2*
     &  a0t4+M42)*MNeu2(h1))*(M42*(-M12+M42)+MNeu(h1)**4-(M12+2*M42)*
     &  MNeu2(h1)))/4.-((2*(2*a0t4+M42)*A0TNeu(h1)+4*M42*AETNeu(h1)+(2*
     &  a0t4+4*aet4+M42)*MNeu2(h1))*(-((M12-M42)*(M12*M22-3*M22*M42+2*
     &  M42**2))+(-3*M22+2*M42)*MNeu(h1)**4+(4*M12*M22-2*M12*M42+6*M22*
     &  M42-4*M42**2)*MNeu2(h1)))/16.))/alambda3(h1)+(8*((aet1+aet4+
     &  AETNeu(h1)-I0A5(h1))*((M12-M42)**2*(M12*M22-3*M22*M42+2*M42**2)
     &  -(M12*M22+(5*M22-2*M42)*M42)*MNeu(h1)**4+M22*MNeu(h1)**6-(M12**
     &  2*M22+2*M12*M22*M42-7*M22*M42**2+4*M42**3)*MNeu2(h1))+((M12+
     &  M42+MNeu2(h1))*((M12-M42)**2*(M12*M22+(M22-2*M42)*M42)-(M12*
     &  M22+M42*(M22+2*M42))*MNeu(h1)**4+M22*MNeu(h1)**6-(M12**2*M22+
     &  (M22-4*M42)*M42**2+M12*(-6*M22*M42+8*M42**2))*MNeu2(h1)))/8.+
     &  ((2*a0t1+2*a0t4+M12+M42+2*A0TNeu(h1)+MNeu2(h1))*((M12-M42)**2*
     &  (M12*M22+(M22-2*M42)*M42)-(M12*M22+M42*(M22+2*M42))*MNeu(h1)**
     &  4+M22*MNeu(h1)**6-(M12**2*M22+(M22-4*M42)*M42**2+M12*(-6*M22*
     &  M42+8*M42**2))*MNeu2(h1)))/4.))/alambda3(h1))/(16.*M22m42s)
       afin(43)=-(-8*a0t1*a0t4*M12**3+4*a0t1*M12**4+16*a0t4*M12**4-8*
     &  aet1*M12**4-16*aet4*M12**4+3*M12**5+10*M4**10+24*a0t1*a0t4*M12*
     &  *2*M42-24*a0t1*M12**3*M42-72*a0t4*M12**3*M42+32*aet1*M12**3*
     &  M42+64*aet4*M12**3*M42-18*M12**4*M42-24*a0t1*a0t4*M12*M42**2+
     &  48*a0t1*M12**2*M42**2+120*a0t4*M12**2*M42**2-48*aet1*M12**2*
     &  M42**2-96*aet4*M12**2*M42**2+26*M12**3*M42**2+8*a0t1*a0t4*M42**
     &  3-40*a0t1*M12*M42**3-88*a0t4*M12*M42**3+32*aet1*M12*M42**3+64*
     &  aet4*M12*M42**3+12*a0t1*M42**4+24*a0t4*M42**4-8*aet1*M42**4-16*
     &  aet4*M42**4-21*M12*M42**4-56*a0t1*a0t4*M12*MNeu(h1)**4+24*a0t1*
     &  M12**2*MNeu(h1)**4+40*a0t4*M12**2*MNeu(h1)**4-48*aet1*M12**2*
     &  MNeu(h1)**4-96*aet4*M12**2*MNeu(h1)**4-14*M12**3*MNeu(h1)**4-
     &  24*a0t1*a0t4*M42*MNeu(h1)**4+40*a0t1*M12*M42*MNeu(h1)**4+40*
     &  a0t4*M12*M42*MNeu(h1)**4-32*aet1*M12*M42*MNeu(h1)**4-64*aet4*
     &  M12*M42*MNeu(h1)**4+40*M12**2*M42*MNeu(h1)**4+48*a0t1*M42**2*
     &  MNeu(h1)**4+96*a0t4*M42**2*MNeu(h1)**4-48*aet1*M42**2*MNeu(h1)*
     &  *4-96*aet4*M42**2*MNeu(h1)**4+42*M12*M42**2*MNeu(h1)**4-20*M42*
     &  *3*MNeu(h1)**4+16*a0t1*a0t4*MNeu(h1)**6-16*a0t1*M12*MNeu(h1)**
     &  6-24*a0t4*M12*MNeu(h1)**6+32*aet1*M12*MNeu(h1)**6+64*aet4*M12*
     &  MNeu(h1)**6+12*M12**2*MNeu(h1)**6-24*a0t1*M42*MNeu(h1)**6-48*
     &  a0t4*M42*MNeu(h1)**6+32*aet1*M42*MNeu(h1)**6+64*aet4*M42*
     &  MNeu(h1)**6+44*M12*M42*MNeu(h1)**6+32*M42**2*MNeu(h1)**6+4*
     &  a0t1*MNeu(h1)**8+8*a0t4*MNeu(h1)**8-8*aet1*MNeu(h1)**8-16*aet4*
     &  MNeu(h1)**8+3*M12*MNeu(h1)**8-6*M42*MNeu(h1)**8-4*MNeu(h1)**10+
     &  48*a0t1*a0t4*M12**2*MNeu2(h1)-16*a0t1*M12**3*MNeu2(h1)-40*a0t4*
     &  M12**3*MNeu2(h1)+32*aet1*M12**3*MNeu2(h1)+64*aet4*M12**3*
     &  MNeu2(h1)-48*a0t1*a0t4*M12*M42*MNeu2(h1)+40*a0t1*M12**2*M42*
     &  MNeu2(h1)+48*a0t4*M12**2*M42*MNeu2(h1)-32*aet1*M12**2*M42*
     &  MNeu2(h1)-64*aet4*M12**2*M42*MNeu2(h1)+4*M12**3*M42*MNeu2(h1)+
     &  16*a0t1*M12*M42**2*MNeu2(h1)+72*a0t4*M12*M42**2*MNeu2(h1)-32*
     &  aet1*M12*M42**2*MNeu2(h1)-64*aet4*M12*M42**2*MNeu2(h1)+76*M12**
     &  2*M42**2*MNeu2(h1)-40*a0t1*M42**3*MNeu2(h1)-80*a0t4*M42**3*
     &  MNeu2(h1)+32*aet1*M42**3*MNeu2(h1)+64*aet4*M42**3*MNeu2(h1)-68*
     &  M12*M42**3*MNeu2(h1)-12*M42**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-
     &  a0t4)*(M12-2*M42)*(M12-M42)**2+(3*a0t1*M12+5*a0t4*M12-6*M12**2+
     &  6*a0t4*M42-2*M12*M42-6*M42**2)*MNeu(h1)**4-(a0t1+2*(a0t4-3*
     &  (M12+M42)))*MNeu(h1)**6-2*MNeu(h1)**8+(a0t1*(-3*M12**2+8*M12*
     &  M42+3*M42**2)+2*(M12**3-2*M12*M42**2+M42**3-a0t4*(M12**2+3*M42*
     &  *2)))*MNeu2(h1))+8*I0A5(h1)*((3*M12**2+5*M12*M42+6*M42**2)*
     &  MNeu(h1)**4-(M12+2*M42)*MNeu(h1)**6+(M12**2-3*M12*M42+2*M42**2)
     &  *((M12-M42)**2-3*(M12+M42)*MNeu2(h1))))/(16.*alambda3(h1)**2)
       afin(44)=-(40*a0t1*a0t4*M12**3+76*a0t1*M12**4+16*a0t4*M12**4-24*
     &  aet1*M12**4+16*aet4*M12**4+25*M12**5-10*M4**10-120*a0t1*a0t4*
     &  M12**2*M42-264*a0t1*M12**3*M42-24*a0t4*M12**3*M42+96*aet1*M12**
     &  3*M42-64*aet4*M12**3*M42-30*M12**4*M42+120*a0t1*a0t4*M12*M42**
     &  2+336*a0t1*M12**2*M42**2-24*a0t4*M12**2*M42**2-144*aet1*M12**2*
     &  M42**2+96*aet4*M12**2*M42**2-50*M12**3*M42**2-40*a0t1*a0t4*M42*
     &  *3-184*a0t1*M12*M42**3+56*a0t4*M12*M42**3+96*aet1*M12*M42**3-
     &  64*aet4*M12*M42**3+80*M12**2*M42**3+36*a0t1*M42**4-24*a0t4*M42*
     &  *4-24*aet1*M42**4+16*aet4*M42**4-15*M12*M42**4+24*a0t1*a0t4*
     &  M12*MNeu(h1)**4+264*a0t1*M12**2*MNeu(h1)**4+184*a0t4*M12**2*
     &  MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4+96*aet4*M12**2*MNeu(h1)
     &  **4-10*M12**3*MNeu(h1)**4-136*a0t1*a0t4*M42*MNeu(h1)**4+56*
     &  a0t1*M12*M42*MNeu(h1)**4+56*a0t4*M12*M42*MNeu(h1)**4-96*aet1*
     &  M12*M42*MNeu(h1)**4+64*aet4*M12*M42*MNeu(h1)**4+8*M12**2*M42*
     &  MNeu(h1)**4+144*a0t1*M42**2*MNeu(h1)**4-96*a0t4*M42**2*MNeu(h1)
     &  **4-144*aet1*M42**2*MNeu(h1)**4+96*aet4*M42**2*MNeu(h1)**4-2*
     &  M12*M42**2*MNeu(h1)**4+20*M42**3*MNeu(h1)**4+48*a0t1*a0t4*
     &  MNeu(h1)**6-112*a0t1*M12*MNeu(h1)**6-72*a0t4*M12*MNeu(h1)**6+
     &  96*aet1*M12*MNeu(h1)**6-64*aet4*M12*MNeu(h1)**6+68*M12**2*
     &  MNeu(h1)**6-72*a0t1*M42*MNeu(h1)**6+48*a0t4*M42*MNeu(h1)**6+96*
     &  aet1*M42*MNeu(h1)**6-64*aet4*M42*MNeu(h1)**6-92*M12*M42*
     &  MNeu(h1)**6-32*M42**2*MNeu(h1)**6+12*a0t1*MNeu(h1)**8-8*a0t4*
     &  MNeu(h1)**8-24*aet1*MNeu(h1)**8+16*aet4*MNeu(h1)**8-39*M12*
     &  MNeu(h1)**8+6*M42*MNeu(h1)**8+4*MNeu(h1)**10-112*a0t1*a0t4*M12*
     &  *2*MNeu2(h1)-240*a0t1*M12**3*MNeu2(h1)-120*a0t4*M12**3*
     &  MNeu2(h1)+96*aet1*M12**3*MNeu2(h1)-64*aet4*M12**3*MNeu2(h1)-48*
     &  M12**4*MNeu2(h1)-16*a0t1*a0t4*M12*M42*MNeu2(h1)+120*a0t1*M12**
     &  2*M42*MNeu2(h1)+80*a0t4*M12**2*M42*MNeu2(h1)-96*aet1*M12**2*
     &  M42*MNeu2(h1)+64*aet4*M12**2*M42*MNeu2(h1)-212*M12**3*M42*
     &  MNeu2(h1)+128*a0t1*a0t4*M42**2*MNeu2(h1)+240*a0t1*M12*M42**2*
     &  MNeu2(h1)-40*a0t4*M12*M42**2*MNeu2(h1)-96*aet1*M12*M42**2*
     &  MNeu2(h1)+64*aet4*M12*M42**2*MNeu2(h1)+100*M12**2*M42**2*
     &  MNeu2(h1)-120*a0t1*M42**3*MNeu2(h1)+80*a0t4*M42**3*MNeu2(h1)+
     &  96*aet1*M42**3*MNeu2(h1)-64*aet4*M42**3*MNeu2(h1)+148*M12*M42**
     &  3*MNeu2(h1)+12*M42**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t4)*(M12-
     &  M42)**2*(3*M12+2*M42)+(9*a0t1*M12-17*a0t4*M12+6*M12**2+8*a0t1*
     &  M42-6*a0t4*M42-6*M12*M42+6*M42**2)*MNeu(h1)**4-(3*a0t1-2*a0t4+
     &  6*(M12+M42))*MNeu(h1)**6+2*MNeu(h1)**8-(a0t1*(9*M12**2+24*M12*
     &  M42+7*M42**2)+2*(M12**3+4*M12**2*M42-6*M12*M42**2+M42**3-a0t4*
     &  (9*M12**2+8*M12*M42+3*M42**2)))*MNeu2(h1))+8*I0A5(h1)*((9*M12**
     &  2-9*M12*M42-6*M42**2)*MNeu(h1)**4+(-3*M12+2*M42)*MNeu(h1)**6+
     &  (3*M12**2-M12*M42-2*M42**2)*((M12-M42)**2-3*(M12+M42)*MNeu2(h1)
     &  )))/(16.*alambda3(h1)**2)
       afin(45)=(-40*a0t1*a0t4*M12**3-4*a0t1*M12**4+56*a0t4*M12**4-24*
     &  aet1*M12**4-64*aet4*M12**4+5*M12**5+40*M4**10+120*a0t1*a0t4*
     &  M12**2*M42-24*a0t1*M12**3*M42-264*a0t4*M12**3*M42+96*aet1*M12**
     &  3*M42+256*aet4*M12**3*M42-60*M12**4*M42-120*a0t1*a0t4*M12*M42**
     &  2+96*a0t1*M12**2*M42**2+456*a0t4*M12**2*M42**2-144*aet1*M12**2*
     &  M42**2-384*aet4*M12**2*M42**2+110*M12**3*M42**2+40*a0t1*a0t4*
     &  M42**3-104*a0t1*M12*M42**3-344*a0t4*M12*M42**3+96*aet1*M12*M42*
     &  *3+256*aet4*M12*M42**3-20*M12**2*M42**3+36*a0t1*M42**4+96*a0t4*
     &  M42**4-24*aet1*M42**4-64*aet4*M42**4-75*M12*M42**4-216*a0t1*
     &  a0t4*M12*MNeu(h1)**4+24*a0t1*M12**2*MNeu(h1)**4+104*a0t4*M12**
     &  2*MNeu(h1)**4-144*aet1*M12**2*MNeu(h1)**4-384*aet4*M12**2*
     &  MNeu(h1)**4-50*M12**3*MNeu(h1)**4-56*a0t1*a0t4*M42*MNeu(h1)**4+
     &  136*a0t1*M12*M42*MNeu(h1)**4+136*a0t4*M12*M42*MNeu(h1)**4-96*
     &  aet1*M12*M42*MNeu(h1)**4-256*aet4*M12*M42*MNeu(h1)**4+148*M12**
     &  2*M42*MNeu(h1)**4+144*a0t1*M42**2*MNeu(h1)**4+384*a0t4*M42**2*
     &  MNeu(h1)**4-144*aet1*M42**2*MNeu(h1)**4-384*aet4*M42**2*
     &  MNeu(h1)**4+158*M12*M42**2*MNeu(h1)**4-80*M42**3*MNeu(h1)**4+
     &  48*a0t1*a0t4*MNeu(h1)**6-32*a0t1*M12*MNeu(h1)**6-72*a0t4*M12*
     &  MNeu(h1)**6+96*aet1*M12*MNeu(h1)**6+256*aet4*M12*MNeu(h1)**6+
     &  28*M12**2*MNeu(h1)**6-72*a0t1*M42*MNeu(h1)**6-192*a0t4*M42*
     &  MNeu(h1)**6+96*aet1*M42*MNeu(h1)**6+256*aet4*M42*MNeu(h1)**6+
     &  188*M12*M42*MNeu(h1)**6+128*M42**2*MNeu(h1)**6+12*a0t1*MNeu(h1)
     &  **8+32*a0t4*MNeu(h1)**8-24*aet1*MNeu(h1)**8-64*aet4*MNeu(h1)**
     &  8+21*M12*MNeu(h1)**8-24*M42*MNeu(h1)**8-16*MNeu(h1)**10+208*
     &  a0t1*a0t4*M12**2*MNeu2(h1)-120*a0t4*M12**3*MNeu2(h1)+96*aet1*
     &  M12**3*MNeu2(h1)+256*aet4*M12**3*MNeu2(h1)+12*M12**4*MNeu2(h1)-
     &  176*a0t1*a0t4*M12*M42*MNeu2(h1)+120*a0t1*M12**2*M42*MNeu2(h1)+
     &  160*a0t4*M12**2*M42*MNeu2(h1)-96*aet1*M12**2*M42*MNeu2(h1)-256*
     &  aet4*M12**2*M42*MNeu2(h1)+68*M12**3*M42*MNeu2(h1)-32*a0t1*a0t4*
     &  M42**2*MNeu2(h1)+280*a0t4*M12*M42**2*MNeu2(h1)-96*aet1*M12*M42*
     &  *2*MNeu2(h1)-256*aet4*M12*M42**2*MNeu2(h1)+260*M12**2*M42**2*
     &  MNeu2(h1)-120*a0t1*M42**3*MNeu2(h1)-320*a0t4*M42**3*MNeu2(h1)+
     &  96*aet1*M42**3*MNeu2(h1)+256*aet4*M42**3*MNeu2(h1)-292*M12*M42*
     &  *3*MNeu2(h1)-48*M42**4*MNeu2(h1)+8*A0TNeu(h1)*((a0t1-a0t4)*(3*
     &  M12-8*M42)*(M12-M42)**2+(a0t1*(9*M12-2*M42)+a0t4*(23*M12+24*
     &  M42)-6*(4*M12**2+M12*M42+4*M42**2))*MNeu(h1)**4+(-3*a0t1-8*
     &  (a0t4-3*(M12+M42)))*MNeu(h1)**6-8*MNeu(h1)**8+(a0t1*(-9*M12**2+
     &  36*M12*M42+13*M42**2)+2*(4*M12**3+M12**2*M42-9*M12*M42**2+4*
     &  M42**3-2*a0t4*(3*M12**2+M12*M42+6*M42**2)))*MNeu2(h1))+8*
     &  I0A5(h1)*(3*(3*M12**2+7*M12*M42+8*M42**2)*MNeu(h1)**4-(3*M12+8*
     &  M42)*MNeu(h1)**6+(3*M12**2-11*M12*M42+8*M42**2)*((M12-M42)**2-
     &  3*(M12+M42)*MNeu2(h1))))/(16.*alambda3(h1)**2)
       afin(46)=(16*aet2*M12**5-24*aet2*M2**10-30*M12*M2**10+13*M2**12-
     &  88*aet2*M12**4*M22+6*M12**5*M22+192*aet2*M12**3*M22**2-27*M12**
     &  4*M22**2-208*aet2*M12**2*M22**3+32*M12**3*M22**3+112*aet2*M12*
     &  M22**4+6*M12**2*M22**4+24*M2**10*I0A4(h1)+16*M12**4*M22*
     &  I0A4(h1)-72*M12**3*M22**2*I0A4(h1)+120*M12**2*M22**3*I0A4(h1)-
     &  88*M12*M22**4*I0A4(h1)+32*aet2*M12**3*MNeu(h1)**4-16*aet2*M12**
     &  2*M22*MNeu(h1)**4-20*M12**3*M22*MNeu(h1)**4+64*aet2*M12*M22**2*
     &  MNeu(h1)**4-66*M12**2*M22**2*MNeu(h1)**4-208*aet2*M22**3*
     &  MNeu(h1)**4+96*M12*M22**3*MNeu(h1)**4+6*M22**4*MNeu(h1)**4-88*
     &  M12**2*M22*A0TNeu(h1)*MNeu(h1)**4-64*M12*M22**2*A0TNeu(h1)*
     &  MNeu(h1)**4-24*M22**3*A0TNeu(h1)*MNeu(h1)**4+32*M12**2*M22*
     &  I0A4(h1)*MNeu(h1)**4+24*M12*M22**2*I0A4(h1)*MNeu(h1)**4+120*
     &  M22**3*I0A4(h1)*MNeu(h1)**4+32*aet2*M12**2*MNeu(h1)**6+96*aet2*
     &  M12*M22*MNeu(h1)**6-20*M12**2*M22*MNeu(h1)**6+192*aet2*M22**2*
     &  MNeu(h1)**6-36*M12*M22**2*MNeu(h1)**6+32*M22**3*MNeu(h1)**6+56*
     &  M12*M22*A0TNeu(h1)*MNeu(h1)**6+24*M22**2*A0TNeu(h1)*MNeu(h1)**
     &  6-32*M12*M22*I0A4(h1)*MNeu(h1)**6-72*M22**2*I0A4(h1)*MNeu(h1)**
     &  6-48*aet2*M12*MNeu(h1)**8-88*aet2*M22*MNeu(h1)**8+14*M12*M22*
     &  MNeu(h1)**8-27*M22**2*MNeu(h1)**8-8*M22*A0TNeu(h1)*MNeu(h1)**8+
     &  16*M22*I0A4(h1)*MNeu(h1)**8+16*aet2*MNeu(h1)**10+6*M22*MNeu(h1)
     &  **10-48*aet2*M12**4*MNeu2(h1)-30*M2**10*MNeu2(h1)+96*aet2*M12**
     &  3*M22*MNeu2(h1)+14*M12**4*M22*MNeu2(h1)+64*aet2*M12**2*M22**2*
     &  MNeu2(h1)-36*M12**3*M22**2*MNeu2(h1)-224*aet2*M12*M22**3*
     &  MNeu2(h1)+96*M12**2*M22**3*MNeu2(h1)+112*aet2*M22**4*MNeu2(h1)-
     &  44*M12*M22**4*MNeu2(h1)+40*M12**3*M22*A0TNeu(h1)*MNeu2(h1)-56*
     &  M12**2*M22**2*A0TNeu(h1)*MNeu2(h1)+8*M12*M22**3*A0TNeu(h1)*
     &  MNeu2(h1)+8*M22**4*A0TNeu(h1)*MNeu2(h1)-32*M12**3*M22*I0A4(h1)*
     &  MNeu2(h1)+24*M12**2*M22**2*I0A4(h1)*MNeu2(h1)+96*M12*M22**3*
     &  I0A4(h1)*MNeu2(h1)-88*M22**4*I0A4(h1)*MNeu2(h1)-4*a0t2*((M12-
     &  M22)**3*(4*M12**2-9*M12*M22+7*M22**2)+(8*M12**3+26*M12**2*M22+
     &  38*M12*M22**2-52*M22**3)*MNeu(h1)**4+(8*M12**2+8*M12*M22+46*
     &  M22**2)*MNeu(h1)**6-3*(4*M12+7*M22)*MNeu(h1)**8+4*MNeu(h1)**10+
     &  (-12*M12**4+8*M12**3*M22+38*M12**2*M22**2-64*M12*M22**3+30*M22*
     &  *4)*MNeu2(h1)+2*A0TNeu(h1)*((2*M12-3*M22)*(M12-M22)**2*M22-(6*
     &  M12**2+10*M12*M22+15*M22**2)*MNeu(h1)**4+(6*M12+9*M22)*MNeu(h1)
     &  **6-2*MNeu(h1)**8+(2*M12**3-M12**2*M22-4*M12*M22**2+11*M22**3)*
     &  MNeu2(h1)))-8*a0t1*(-((-(M12*M22*(11*M12+7*M22))+a0t2*(6*M12**
     &  2+M12*M22+7*M22**2))*MNeu(h1)**4)+(-5*M12*M22+2*a0t2*(M12+M22))
     &  *MNeu(h1)**6+M22*A0TNeu(h1)*(-((2*M12-3*M22)*(M12-M22)**2)+(2*
     &  M12+7*M22)*MNeu(h1)**4-2*MNeu(h1)**6+2*(M12**2-M12*M22-4*M22**
     &  2)*MNeu2(h1))+(M12-M22)*((M12-M22)**2*(-2*a0t2*M12+3*a0t2*M22+
     &  M12*M22)+(M12*M22*(-7*M12+M22)+a0t2*(6*M12**2-4*M12*M22-8*M22**
     &  2))*MNeu2(h1))))/(16.*alambda2(h1)**2*M22)
       afin(47)=(16*aet4*M12**5-24*aet4*M4**10-30*M12*M4**10+13*M4**12-
     &  88*aet4*M12**4*M42+6*M12**5*M42+192*aet4*M12**3*M42**2-27*M12**
     &  4*M42**2-208*aet4*M12**2*M42**3+32*M12**3*M42**3+112*aet4*M12*
     &  M42**4+6*M12**2*M42**4+24*M4**10*I0A5(h1)+16*M12**4*M42*
     &  I0A5(h1)-72*M12**3*M42**2*I0A5(h1)+120*M12**2*M42**3*I0A5(h1)-
     &  88*M12*M42**4*I0A5(h1)+32*aet4*M12**3*MNeu(h1)**4-16*aet4*M12**
     &  2*M42*MNeu(h1)**4-20*M12**3*M42*MNeu(h1)**4+64*aet4*M12*M42**2*
     &  MNeu(h1)**4-66*M12**2*M42**2*MNeu(h1)**4-208*aet4*M42**3*
     &  MNeu(h1)**4+96*M12*M42**3*MNeu(h1)**4+6*M42**4*MNeu(h1)**4-88*
     &  M12**2*M42*A0TNeu(h1)*MNeu(h1)**4-64*M12*M42**2*A0TNeu(h1)*
     &  MNeu(h1)**4-24*M42**3*A0TNeu(h1)*MNeu(h1)**4+32*M12**2*M42*
     &  I0A5(h1)*MNeu(h1)**4+24*M12*M42**2*I0A5(h1)*MNeu(h1)**4+120*
     &  M42**3*I0A5(h1)*MNeu(h1)**4+32*aet4*M12**2*MNeu(h1)**6+96*aet4*
     &  M12*M42*MNeu(h1)**6-20*M12**2*M42*MNeu(h1)**6+192*aet4*M42**2*
     &  MNeu(h1)**6-36*M12*M42**2*MNeu(h1)**6+32*M42**3*MNeu(h1)**6+56*
     &  M12*M42*A0TNeu(h1)*MNeu(h1)**6+24*M42**2*A0TNeu(h1)*MNeu(h1)**
     &  6-32*M12*M42*I0A5(h1)*MNeu(h1)**6-72*M42**2*I0A5(h1)*MNeu(h1)**
     &  6-48*aet4*M12*MNeu(h1)**8-88*aet4*M42*MNeu(h1)**8+14*M12*M42*
     &  MNeu(h1)**8-27*M42**2*MNeu(h1)**8-8*M42*A0TNeu(h1)*MNeu(h1)**8+
     &  16*M42*I0A5(h1)*MNeu(h1)**8+16*aet4*MNeu(h1)**10+6*M42*MNeu(h1)
     &  **10-48*aet4*M12**4*MNeu2(h1)-30*M4**10*MNeu2(h1)+96*aet4*M12**
     &  3*M42*MNeu2(h1)+14*M12**4*M42*MNeu2(h1)+64*aet4*M12**2*M42**2*
     &  MNeu2(h1)-36*M12**3*M42**2*MNeu2(h1)-224*aet4*M12*M42**3*
     &  MNeu2(h1)+96*M12**2*M42**3*MNeu2(h1)+112*aet4*M42**4*MNeu2(h1)-
     &  44*M12*M42**4*MNeu2(h1)+40*M12**3*M42*A0TNeu(h1)*MNeu2(h1)-56*
     &  M12**2*M42**2*A0TNeu(h1)*MNeu2(h1)+8*M12*M42**3*A0TNeu(h1)*
     &  MNeu2(h1)+8*M42**4*A0TNeu(h1)*MNeu2(h1)-32*M12**3*M42*I0A5(h1)*
     &  MNeu2(h1)+24*M12**2*M42**2*I0A5(h1)*MNeu2(h1)+96*M12*M42**3*
     &  I0A5(h1)*MNeu2(h1)-88*M42**4*I0A5(h1)*MNeu2(h1)-4*a0t4*((M12-
     &  M42)**3*(4*M12**2-9*M12*M42+7*M42**2)+(8*M12**3+26*M12**2*M42+
     &  38*M12*M42**2-52*M42**3)*MNeu(h1)**4+(8*M12**2+8*M12*M42+46*
     &  M42**2)*MNeu(h1)**6-3*(4*M12+7*M42)*MNeu(h1)**8+4*MNeu(h1)**10+
     &  (-12*M12**4+8*M12**3*M42+38*M12**2*M42**2-64*M12*M42**3+30*M42*
     &  *4)*MNeu2(h1)+2*A0TNeu(h1)*((2*M12-3*M42)*(M12-M42)**2*M42-(6*
     &  M12**2+10*M12*M42+15*M42**2)*MNeu(h1)**4+(6*M12+9*M42)*MNeu(h1)
     &  **6-2*MNeu(h1)**8+(2*M12**3-M12**2*M42-4*M12*M42**2+11*M42**3)*
     &  MNeu2(h1)))-8*a0t1*(-((-(M12*M42*(11*M12+7*M42))+a0t4*(6*M12**
     &  2+M12*M42+7*M42**2))*MNeu(h1)**4)+(-5*M12*M42+2*a0t4*(M12+M42))
     &  *MNeu(h1)**6+M42*A0TNeu(h1)*(-((2*M12-3*M42)*(M12-M42)**2)+(2*
     &  M12+7*M42)*MNeu(h1)**4-2*MNeu(h1)**6+2*(M12**2-M12*M42-4*M42**
     &  2)*MNeu2(h1))+(M12-M42)*((M12-M42)**2*(-2*a0t4*M12+3*a0t4*M42+
     &  M12*M42)+(M12*M42*(-7*M12+M42)+a0t4*(6*M12**2-4*M12*M42-8*M42**
     &  2))*MNeu2(h1))))/(16.*alambda3(h1)**2*M42)


       selfZ=selfZ+(CF11FSL(h1,1)*(CF11FSRC(h1,1)*((CW**2*afin(19))
     &  /(4.*SW**2)-(SW**2*afin(20))/(36.*CW**2)+afin(21)/6.+(-(CW*
     &  afin(8))/(2.*SW)+(5*SW*afin(8))/(6.*CW))*CS13S13V2(1,1)+
     &  afin(25)*CS13S13V2(1,1)**2+afin(15)*CS13S13V2(1,2)*
     &  CS13S13V2(2,1)-(afin(2)*CS13S13V2V2(1,1))/2.)+CF11FSRC(h1,2)*
     &  (CS13S13V2(1,2)*(-(CW*afin(7))/(2.*SW)+(5*SW*afin(7))/(6.*CW)+
     &  afin(15)*CS13S13V2(1,1)+afin(17)*CS13S13V2(2,2))-(afin(1)*
     &  CS13S13V2V2(1,2))/2.))+CF11FSRC(h1,1)*(CF11FSR(h1,1)*((CW**2*
     &  afin(10))/(4.*SW**2)+afin(11)/6.-(SW**2*afin(28))/(36.*CW**2)+
     &  (-(CW*afin(16))/(2.*SW)+(SW*afin(41))/(6.*CW))*CS13S13V2(1,1)+
     &  afin(46)*CS13S13V2(1,1)**2+afin(38)*CS13S13V2(1,2)*
     &  CS13S13V2(2,1)-(afin(5)*CS13S13V2V2(1,1))/2.)+CF11FSR(h1,2)*
     &  (CS13S13V2(2,1)*(-(CW*afin(14))/(2.*SW)+(SW*afin(35))/(6.*CW)+
     &  afin(38)*CS13S13V2(1,1)+afin(42)*CS13S13V2(2,2))-(afin(4)*
     &  CS13S13V2V2(2,1))/2.))+CF11FSLC(h1,1)*(CF11FSR(h1,1)*((CW**2*
     &  afin(19))/(4.*SW**2)-(SW**2*afin(20))/(36.*CW**2)+afin(21)/6.+
     &  (-(CW*afin(8))/(2.*SW)+(5*SW*afin(8))/(6.*CW))*CS13S13V2(1,1)+
     &  afin(25)*CS13S13V2(1,1)**2+afin(15)*CS13S13V2(1,2)*
     &  CS13S13V2(2,1)-(afin(2)*CS13S13V2V2(1,1))/2.)+CF11FSL(h1,1)*
     &  ((CW**2*afin(27))/(4.*SW**2)+afin(29)/6.+(SW**2*afin(30))/(36.*
     &  CW**2)+((CW*afin(39))/(2.*SW)+(SW*afin(40))/(6.*CW))*
     &  CS13S13V2(1,1)+afin(46)*CS13S13V2(1,1)**2+afin(38)*
     &  CS13S13V2(1,2)*CS13S13V2(2,1)-(afin(5)*CS13S13V2V2(1,1))/2.)+
     &  CF11FSR(h1,2)*(CS13S13V2(2,1)*(-(CW*afin(7))/(2.*SW)+(5*SW*
     &  afin(7))/(6.*CW)+afin(15)*CS13S13V2(1,1)+afin(17)*
     &  CS13S13V2(2,2))-(afin(1)*CS13S13V2V2(2,1))/2.)+CF11FSL(h1,2)*
     &  (CS13S13V2(2,1)*((SW*afin(36))/(6.*CW)+(CW*afin(37))/(2.*SW)+
     &  afin(38)*CS13S13V2(1,1)+afin(42)*CS13S13V2(2,2))-(afin(4)*
     &  CS13S13V2V2(2,1))/2.))+CF11FSL(h1,2)*(CF11FSRC(h1,1)*
     &  (CS13S13V2(2,1)*(-(CW*afin(7))/(2.*SW)+(5*SW*afin(7))/(6.*CW)+
     &  afin(15)*CS13S13V2(1,1)+afin(17)*CS13S13V2(2,2))-(afin(1)*
     &  CS13S13V2V2(2,1))/2.)+CF11FSRC(h1,2)*((CW**2*afin(22))/(4.*SW**
     &  2)-(SW**2*afin(23))/(36.*CW**2)+afin(24)/6.+afin(17)*
     &  CS13S13V2(1,2)*CS13S13V2(2,1)+(-(CW*afin(9))/(2.*SW)+(5*SW*
     &  afin(9))/(6.*CW))*CS13S13V2(2,2)+afin(26)*CS13S13V2(2,2)**2-
     &  (afin(3)*CS13S13V2V2(2,2))/2.))+CF11FSLC(h1,2)*(CF11FSR(h1,1)*
     &  (CS13S13V2(1,2)*(-(CW*afin(7))/(2.*SW)+(5*SW*afin(7))/(6.*CW)+
     &  afin(15)*CS13S13V2(1,1)+afin(17)*CS13S13V2(2,2))-(afin(1)*
     &  CS13S13V2V2(1,2))/2.)+CF11FSL(h1,1)*(CS13S13V2(1,2)*((SW*
     &  afin(36))/(6.*CW)+(CW*afin(37))/(2.*SW)+afin(38)*CS13S13V2(1,1)
     &  +afin(42)*CS13S13V2(2,2))-(afin(4)*CS13S13V2V2(1,2))/2.)+
     &  CF11FSR(h1,2)*((CW**2*afin(22))/(4.*SW**2)-(SW**2*afin(23))
     &  /(36.*CW**2)+afin(24)/6.+afin(17)*CS13S13V2(1,2)*CS13S13V2(2,1)
     &  +(-(CW*afin(9))/(2.*SW)+(5*SW*afin(9))/(6.*CW))*CS13S13V2(2,2)+
     &  afin(26)*CS13S13V2(2,2)**2-(afin(3)*CS13S13V2V2(2,2))/2.)+
     &  CF11FSL(h1,2)*((CW**2*afin(31))/(4.*SW**2)+afin(33)/6.+(SW**2*
     &  afin(34))/(36.*CW**2)+afin(42)*CS13S13V2(1,2)*CS13S13V2(2,1)+
     &  ((CW*afin(43))/(2.*SW)+(SW*afin(44))/(6.*CW))*CS13S13V2(2,2)+
     &  afin(47)*CS13S13V2(2,2)**2-(afin(6)*CS13S13V2V2(2,2))/2.))+
     &  CF11FSRC(h1,2)*(CF11FSR(h1,1)*(CS13S13V2(1,2)*(-(CW*afin(14))
     &  /(2.*SW)+(SW*afin(35))/(6.*CW)+afin(38)*CS13S13V2(1,1)+afin(42)
     &  *CS13S13V2(2,2))-(afin(4)*CS13S13V2V2(1,2))/2.)+CF11FSR(h1,2)*
     &  ((CW**2*afin(12))/(4.*SW**2)+afin(13)/6.-(SW**2*afin(32))/(36.*
     &  CW**2)+afin(42)*CS13S13V2(1,2)*CS13S13V2(2,1)+(-(CW*afin(18))
     &  /(2.*SW)+(SW*afin(45))/(6.*CW))*CS13S13V2(2,2)+afin(47)*
     &  CS13S13V2(2,2)**2-(afin(6)*CS13S13V2V2(2,2))/2.)))

       enddo
c
c neutralino diagrams
c

        ! charged Higgs contribution

       afin(1)=-(CTBS3(2)*(-8*aet1*M12+16*AETHp*M12+8*I0A6*M12+17*M12**2+
     &  4*a0t1*(6*A0THp+7*M12-MHp2)+24*A0THp*MHp2+8*aet1*MHp2-16*AETHp*
     &  MHp2+16*I0A6*MHp2+21*M12*MHp2+10*MHp2**2))/(16.*(M12-MHp2))
       afin(2)=(3*CTBS3(2)*(-8*aet1*M12+16*AETHp*M12+8*I0A6*M12+5*M12**2+
     &  4*a0t1*(6*A0THp+11*M12-5*MHp2)+24*A0THp*MHp2+8*aet1*MHp2-16*
     &  AETHp*MHp2+16*I0A6*MHp2+33*M12*MHp2+10*MHp2**2))/(32.*(M12-
     &  MHp2))
       afin(3)=(-9*CTBS3(2)*(-24*aet1*M12-16*AETHp*M12+24*I0A6*M12+11*
     &  M12**2+a0t1*(8*A0THp+52*M12-44*MHp2)+8*A0THp*(4*M12-3*MHp2)+24*
     &  aet1*MHp2+16*AETHp*MHp2-16*I0A6*MHp2+15*M12*MHp2-10*MHp2**2))
     &  /(16.*(M12-MHp2))
       selfZ=selfZ+((CW**2*afin(1))/(8.*SW**2)+afin(2)/6.-(SW**2*
     &  afin(3))/(72.*CW**2))*CTBS3C(2)

c
c Charged Higgs boson  diagrams, top bottom only
c

       afin(1)=-((aet5*M22**2-2*aet5*M22*MHp2+aet5*MHp2**2+A0THp*M22*
     &  MSQ2-2*aet5*M22*MSQ2+I0A7*M22*MSQ2+M22**2*MSQ2+A0THp*MHp2*MSQ2-
     &  2*aet5*MHp2*MSQ2+I0A7*MHp2*MSQ2+2*M22*MHp2*MSQ2+MHp2**2*MSQ2-
     &  A0THp*MSQ2**2+aet5*MSQ2**2-I0A7*MSQ2**2-MSQ2**3+a0t2*(a0t5*
     &  (M22-MHp2-MSQ2)+(2*A0THp+M22+MHp2-MSQ2)*MSQ2)-a0t5*(M22**2-2*
     &  M22*MHp2+MHp2**2-3*M22*MSQ2-3*MHp2*MSQ2+2*MSQ2**2+A0THp*(M22-
     &  MHp2+MSQ2)))/(alambda4*MSQ2))
       afin(2)=-((aet5*M42**2-2*aet5*M42*MHp2+aet5*MHp2**2+A0THp*M42*
     &  MSQ2-2*aet5*M42*MSQ2+I0A8*M42*MSQ2+M42**2*MSQ2+A0THp*MHp2*MSQ2-
     &  2*aet5*MHp2*MSQ2+I0A8*MHp2*MSQ2+2*M42*MHp2*MSQ2+MHp2**2*MSQ2-
     &  A0THp*MSQ2**2+aet5*MSQ2**2-I0A8*MSQ2**2-MSQ2**3+a0t4*(a0t5*
     &  (M42-MHp2-MSQ2)+(2*A0THp+M42+MHp2-MSQ2)*MSQ2)-a0t5*(M42**2-2*
     &  M42*MHp2+MHp2**2-3*M42*MSQ2-3*MHp2*MSQ2+2*MSQ2**2+A0THp*(M42-
     &  MHp2+MSQ2)))/(alambda5*MSQ2))
       afin(3)=(-aet2+aet4+I0A7-I0A8)/M22m42
       afin(4)=-((-(A0THp*M22**2)+aet2*M22**2-I0A7*M22**2-M22**3+A0THp*
     &  M22*MHp2-2*aet2*M22*MHp2+I0A7*M22*MHp2+aet2*MHp2**2+M22*MHp2**
     &  2+A0THp*M22*MSQ2-2*aet2*M22*MSQ2+I0A7*M22*MSQ2-2*aet2*MHp2*
     &  MSQ2+2*M22*MHp2*MSQ2+aet2*MSQ2**2+M22*MSQ2**2+a0t5*M22*(2*
     &  A0THp-M22+MHp2+MSQ2)-a0t2*(2*M22**2-3*M22*MHp2+MHp2**2+a0t5*
     &  (M22+MHp2-MSQ2)-3*M22*MSQ2-2*MHp2*MSQ2+MSQ2**2+A0THp*(M22-MHp2+
     &  MSQ2)))/(alambda4*M22))
       afin(5)=-((-(A0THp*M42**2)+aet4*M42**2-I0A8*M42**2-M42**3+A0THp*
     &  M42*MHp2-2*aet4*M42*MHp2+I0A8*M42*MHp2+aet4*MHp2**2+M42*MHp2**
     &  2+A0THp*M42*MSQ2-2*aet4*M42*MSQ2+I0A8*M42*MSQ2-2*aet4*MHp2*
     &  MSQ2+2*M42*MHp2*MSQ2+aet4*MSQ2**2+M42*MSQ2**2+a0t5*M42*(2*
     &  A0THp-M42+MHp2+MSQ2)-a0t4*(2*M42**2-3*M42*MHp2+MHp2**2+a0t5*
     &  (M42+MHp2-MSQ2)-3*M42*MSQ2-2*MHp2*MSQ2+MSQ2**2+A0THp*(M42-MHp2+
     &  MSQ2)))/(alambda5*M42))
       afin(6)=((2*(-4*a0t2*A0THp+2*A0THp*M22-4*AETHp*M22+2*a0t2*MHp2-
     &  4*aet2*MHp2+M22*MHp2)*(M22-MHp2+MSQ2))/(alambda4*M22m42)+(2*(4*
     &  a0t4*A0THp-2*A0THp*M42+4*AETHp*M42-2*a0t4*MHp2+4*aet4*MHp2-M42*
     &  MHp2)*(M42-MHp2+MSQ2))/(alambda5*M22m42)+(4*a0t2*a0t5-2*a0t5*
     &  M22+4*aet5*M22-2*a0t2*MSQ2+4*aet2*MSQ2-M22*MSQ2)/(M22m42*MSQ2)+
     &  ((M22-MHp2-MSQ2)*(M22-MHp2+MSQ2)*(-4*a0t2*a0t5+2*a0t5*M22-4*
     &  aet5*M22+2*a0t2*MSQ2-4*aet2*MSQ2+M22*MSQ2))/(alambda4*M22m42*
     &  MSQ2)+(-4*a0t4*a0t5+2*a0t5*M42-4*aet5*M42+2*a0t4*MSQ2-4*aet4*
     &  MSQ2+M42*MSQ2)/(M22m42*MSQ2)-((M42-MHp2-MSQ2)*(M42-MHp2+MSQ2)*
     &  (-4*a0t4*a0t5+2*a0t5*M42-4*aet5*M42+2*a0t4*MSQ2-4*aet4*MSQ2+
     &  M42*MSQ2))/(alambda5*M22m42*MSQ2)+(4*(M2*M4+MHp2-MSQ2)*(M2*M4-
     &  MHp2+MSQ2)*(-4*aet5*MHp2+a0t5*(-4*A0THp+2*MHp2)+(2*A0THp-4*
     &  AETHp+MHp2)*MSQ2))/(alambda4*alambda5)+
     &  (4*(-((M22+MHp2+MSQ2)*(2*M22**2-(MHp2-MSQ2)*
     &  *2-M22*(MHp2+MSQ2)))/4.-((2*a0t2+2*a0t5+2*A0THp+M22+MHp2+MSQ2)*
     &  (2*M22**2-(MHp2-MSQ2)**2-M22*(MHp2+MSQ2)))/2.+2*(aet2+aet5+
     &  AETHp-I0A7)*(-(MHp2-MSQ2)**2+M22*(MHp2+MSQ2))))/(alambda4*
     &  M22m42)+((M42+MHp2+MSQ2)*(2*M42**2-(MHp2-MSQ2)**2-M42*(MHp2+
     &  MSQ2))+2*(2*a0t4+2*a0t5+2*A0THp+M42+MHp2+MSQ2)*(2*M42**2-(MHp2-
     &  MSQ2)**2-M42*(MHp2+MSQ2))-8*(aet4+aet5+AETHp-I0A8)*(-(MHp2-
     &  MSQ2)**2+M42*(MHp2+MSQ2)))/(alambda5*M22m42))/16.
       afin(7)=(4*A0THp*M22**3+M22**4-12*A0THp*M22**2*MHp2-4*M22**3*
     &  MHp2+12*A0THp*M22*MHp2**2+6*M22**2*MHp2**2-4*A0THp*MHp2**3-4*
     &  M22*MHp2**3+MHp2**4-4*A0THp*M22**2*MSQ2-4*M22**3*MSQ2+8*A0THp*
     &  M22*MHp2*MSQ2+16*I0A7*M22*MHp2*MSQ2+20*M22**2*MHp2*MSQ2+12*
     &  A0THp*MHp2**2*MSQ2+20*M22*MHp2**2*MSQ2-4*MHp2**3*MSQ2-4*A0THp*
     &  M22*MSQ2**2+6*M22**2*MSQ2**2-12*A0THp*MHp2*MSQ2**2+20*M22*MHp2*
     &  MSQ2**2+6*MHp2**2*MSQ2**2+4*A0THp*MSQ2**3-4*M22*MSQ2**3-4*MHp2*
     &  MSQ2**3+MSQ2**4-4*a0t5*(-M22**3+2*A0THp*M22*(M22-MHp2-MSQ2)-(-
     &  2*a0t2*MHp2+(MHp2-MSQ2)**2)*(MHp2-MSQ2)+M22**2*(MHp2+3*MSQ2)+
     &  M22*(-2*a0t2*MHp2+MHp2**2-2*MHp2*MSQ2-3*MSQ2**2))-4*a0t2*(M22**
     &  3-3*M22**2*(MHp2+MSQ2)-(MHp2-MSQ2)*(MHp2**2+(2*A0THp-MSQ2)*
     &  MSQ2)+M22*(3*MHp2**2-2*MHp2*MSQ2+MSQ2*(-2*A0THp+3*MSQ2))))/(8.*
     &  alambda4**2)
       afin(8)=(4*A0THp*M42**3+M42**4-12*A0THp*M42**2*MHp2-4*M42**3*
     &  MHp2+12*A0THp*M42*MHp2**2+6*M42**2*MHp2**2-4*A0THp*MHp2**3-4*
     &  M42*MHp2**3+MHp2**4-4*A0THp*M42**2*MSQ2-4*M42**3*MSQ2+8*A0THp*
     &  M42*MHp2*MSQ2+16*I0A8*M42*MHp2*MSQ2+20*M42**2*MHp2*MSQ2+12*
     &  A0THp*MHp2**2*MSQ2+20*M42*MHp2**2*MSQ2-4*MHp2**3*MSQ2-4*A0THp*
     &  M42*MSQ2**2+6*M42**2*MSQ2**2-12*A0THp*MHp2*MSQ2**2+20*M42*MHp2*
     &  MSQ2**2+6*MHp2**2*MSQ2**2+4*A0THp*MSQ2**3-4*M42*MSQ2**3-4*MHp2*
     &  MSQ2**3+MSQ2**4-4*a0t5*(-M42**3+2*A0THp*M42*(M42-MHp2-MSQ2)-(-
     &  2*a0t4*MHp2+(MHp2-MSQ2)**2)*(MHp2-MSQ2)+M42**2*(MHp2+3*MSQ2)+
     &  M42*(-2*a0t4*MHp2+MHp2**2-2*MHp2*MSQ2-3*MSQ2**2))-4*a0t4*(M42**
     &  3-3*M42**2*(MHp2+MSQ2)-(MHp2-MSQ2)*(MHp2**2+(2*A0THp-MSQ2)*
     &  MSQ2)+M42*(3*MHp2**2-2*MHp2*MSQ2+MSQ2*(-2*A0THp+3*MSQ2))))/(8.*
     &  alambda5**2)
       afin(9)=((2*M22m42*(4*a0t2*A0THp-2*A0THp*M22+4*AETHp*M22-2*a0t2*
     &  MHp2+4*aet2*MHp2-M22*MHp2)*(M22-MHp2+MSQ2))/alambda4-M42*(4*
     &  a0t4+4*a0t5+4*A0THp+8*aet4+8*aet5+8*AETHp-8*I0A8+3*M42+3*MHp2+
     &  3*MSQ2)-(2*M22m42*(M22+MHp2-MSQ2)*(-4*a0t2*a0t5+2*a0t5*M22-4*
     &  aet5*M22+2*a0t2*MSQ2-4*aet2*MSQ2+M22*MSQ2))/alambda4+(4*M22*
     &  M22m42*(-4*aet5*MHp2+a0t5*(-4*A0THp+2*MHp2)+(2*A0THp-4*AETHp+
     &  MHp2)*MSQ2))/alambda4+(-8*(aet2+aet5+AETHp-I0A7)*(M22**3-M42*
     &  (MHp2-MSQ2)**2+3*M22*M42*(MHp2+MSQ2)-M22**2*(2*M42+MHp2+MSQ2))+
     &  (M22+MHp2+MSQ2)*(3*M22**3+M42*(MHp2-MSQ2)**2+M22*M42*(MHp2+
     &  MSQ2)-M22**2*(2*M42+3*(MHp2+MSQ2)))+2*(2*a0t2+2*a0t5+2*A0THp+
     &  M22+MHp2+MSQ2)*(3*M22**3+M42*(MHp2-MSQ2)**2+M22*M42*(MHp2+MSQ2)
     &  -M22**2*(2*M42+3*(MHp2+MSQ2))))/alambda4)/(16.*M22m42s)
       afin(10)=-((2*M22m42*(4*a0t4*A0THp-2*A0THp*M42+4*AETHp*M42-2*
     &  a0t4*MHp2+4*aet4*MHp2-M42*MHp2)*(M42-MHp2+MSQ2))/alambda5+M22*
     &  (4*a0t2+4*a0t5+4*A0THp+8*aet2+8*aet5+8*AETHp-8*I0A7+3*M22+3*
     &  MHp2+3*MSQ2)-(2*M22m42*(M42+MHp2-MSQ2)*(-4*a0t4*a0t5+2*a0t5*
     &  M42-4*aet5*M42+2*a0t4*MSQ2-4*aet4*MSQ2+M42*MSQ2))/alambda5+(4*
     &  M22m42*M42*(-4*aet5*MHp2+a0t5*(-4*A0THp+2*MHp2)+(2*A0THp-4*
     &  AETHp+MHp2)*MSQ2))/alambda5+(8*(-((aet4+aet5+AETHp-I0A8)*(M42**
     &  2*(-M42+MHp2+MSQ2)+M22*(2*M42**2+(MHp2-MSQ2)**2-3*M42*(MHp2+
     &  MSQ2))))+((2*a0t4+2*a0t5+2*A0THp+M42+MHp2+MSQ2)*(3*M42**2*(-
     &  M42+MHp2+MSQ2)+M22*(2*M42**2-(MHp2-MSQ2)**2-M42*(MHp2+MSQ2))))
     &  /4.-((M42+MHp2+MSQ2)*(3*M42**2*(M42-MHp2-MSQ2)+M22*(-2*M42**2+
     &  (MHp2-MSQ2)**2+M42*(MHp2+MSQ2))))/8.))/alambda5)/(16.*M22m42s)
       afin(11)=(7*M2**10+4*a0t5*M22**4-8*aet2*M22**4+8*I0A7*M22**4-20*
     &  a0t5*M22**3*MHp2+32*aet2*M22**3*MHp2-24*I0A7*M22**3*MHp2-12*
     &  M22**4*MHp2+28*a0t5*M22**2*MHp2**2-48*aet2*M22**2*MHp2**2+24*
     &  I0A7*M22**2*MHp2**2-6*M22**3*MHp2**2-12*a0t5*M22*MHp2**3+32*
     &  aet2*M22*MHp2**3-8*I0A7*M22*MHp2**3+20*M22**2*MHp2**3-8*aet2*
     &  MHp2**4-9*M22*MHp2**4-12*a0t5*M22**3*MSQ2+32*aet2*M22**3*MSQ2-
     &  24*I0A7*M22**3*MSQ2-12*M22**4*MSQ2+8*a0t5*M22**2*MHp2*MSQ2-32*
     &  aet2*M22**2*MHp2*MSQ2-52*M22**3*MHp2*MSQ2+20*a0t5*M22*MHp2**2*
     &  MSQ2-32*aet2*M22*MHp2**2*MSQ2+8*I0A7*M22*MHp2**2*MSQ2+28*M22**
     &  2*MHp2**2*MSQ2+32*aet2*MHp2**3*MSQ2+4*M22*MHp2**3*MSQ2+12*a0t5*
     &  M22**2*MSQ2**2-48*aet2*M22**2*MSQ2**2+24*I0A7*M22**2*MSQ2**2-6*
     &  M22**3*MSQ2**2-4*a0t5*M22*MHp2*MSQ2**2-32*aet2*M22*MHp2*MSQ2**
     &  2+8*I0A7*M22*MHp2*MSQ2**2+28*M22**2*MHp2*MSQ2**2-48*aet2*MHp2**
     &  2*MSQ2**2+10*M22*MHp2**2*MSQ2**2-4*a0t5*M22*MSQ2**3+32*aet2*
     &  M22*MSQ2**3-8*I0A7*M22*MSQ2**3+20*M22**2*MSQ2**3+32*aet2*MHp2*
     &  MSQ2**3+4*M22*MHp2*MSQ2**3-8*aet2*MSQ2**4-9*M22*MSQ2**4+4*
     &  A0THp*M22*(M22**3-(MHp2-MSQ2)**2*(MHp2+3*MSQ2)-M22**2*(3*MHp2+
     &  5*MSQ2)+M22*(3*MHp2**2+2*MHp2*MSQ2+7*MSQ2**2)-2*a0t5*(M22**2+2*
     &  (MHp2-MSQ2)**2-3*M22*(MHp2+MSQ2)))+4*a0t2*(5*M22**4-17*M22**3*
     &  MHp2+21*M22**2*MHp2**2-11*M22*MHp2**3+2*MHp2**4-17*M22**3*MSQ2+
     &  10*M22**2*MHp2*MSQ2+11*M22*MHp2**2*MSQ2-8*MHp2**3*MSQ2+21*M22**
     &  2*MSQ2**2+11*M22*MHp2*MSQ2**2+12*MHp2**2*MSQ2**2-11*M22*MSQ2**
     &  3-8*MHp2*MSQ2**3+2*MSQ2**4+2*A0THp*(M22**3+3*M22*MHp2*(MHp2-
     &  MSQ2)-(MHp2-MSQ2)**3-M22**2*(3*MHp2+2*MSQ2))+2*a0t5*(M22**3+
     &  (MHp2-MSQ2)**3+3*M22*MSQ2*(-MHp2+MSQ2)-M22**2*(2*MHp2+3*MSQ2)))
     &  )/(16.*alambda4**2*M22)
       afin(12)=(7*M4**10+4*a0t5*M42**4-8*aet4*M42**4+8*I0A8*M42**4-20*
     &  a0t5*M42**3*MHp2+32*aet4*M42**3*MHp2-24*I0A8*M42**3*MHp2-12*
     &  M42**4*MHp2+28*a0t5*M42**2*MHp2**2-48*aet4*M42**2*MHp2**2+24*
     &  I0A8*M42**2*MHp2**2-6*M42**3*MHp2**2-12*a0t5*M42*MHp2**3+32*
     &  aet4*M42*MHp2**3-8*I0A8*M42*MHp2**3+20*M42**2*MHp2**3-8*aet4*
     &  MHp2**4-9*M42*MHp2**4-12*a0t5*M42**3*MSQ2+32*aet4*M42**3*MSQ2-
     &  24*I0A8*M42**3*MSQ2-12*M42**4*MSQ2+8*a0t5*M42**2*MHp2*MSQ2-32*
     &  aet4*M42**2*MHp2*MSQ2-52*M42**3*MHp2*MSQ2+20*a0t5*M42*MHp2**2*
     &  MSQ2-32*aet4*M42*MHp2**2*MSQ2+8*I0A8*M42*MHp2**2*MSQ2+28*M42**
     &  2*MHp2**2*MSQ2+32*aet4*MHp2**3*MSQ2+4*M42*MHp2**3*MSQ2+12*a0t5*
     &  M42**2*MSQ2**2-48*aet4*M42**2*MSQ2**2+24*I0A8*M42**2*MSQ2**2-6*
     &  M42**3*MSQ2**2-4*a0t5*M42*MHp2*MSQ2**2-32*aet4*M42*MHp2*MSQ2**
     &  2+8*I0A8*M42*MHp2*MSQ2**2+28*M42**2*MHp2*MSQ2**2-48*aet4*MHp2**
     &  2*MSQ2**2+10*M42*MHp2**2*MSQ2**2-4*a0t5*M42*MSQ2**3+32*aet4*
     &  M42*MSQ2**3-8*I0A8*M42*MSQ2**3+20*M42**2*MSQ2**3+32*aet4*MHp2*
     &  MSQ2**3+4*M42*MHp2*MSQ2**3-8*aet4*MSQ2**4-9*M42*MSQ2**4+4*
     &  A0THp*M42*(M42**3-(MHp2-MSQ2)**2*(MHp2+3*MSQ2)-M42**2*(3*MHp2+
     &  5*MSQ2)+M42*(3*MHp2**2+2*MHp2*MSQ2+7*MSQ2**2)-2*a0t5*(M42**2+2*
     &  (MHp2-MSQ2)**2-3*M42*(MHp2+MSQ2)))+4*a0t4*(5*M42**4-17*M42**3*
     &  MHp2+21*M42**2*MHp2**2-11*M42*MHp2**3+2*MHp2**4-17*M42**3*MSQ2+
     &  10*M42**2*MHp2*MSQ2+11*M42*MHp2**2*MSQ2-8*MHp2**3*MSQ2+21*M42**
     &  2*MSQ2**2+11*M42*MHp2*MSQ2**2+12*MHp2**2*MSQ2**2-11*M42*MSQ2**
     &  3-8*MHp2*MSQ2**3+2*MSQ2**4+2*A0THp*(M42**3+3*M42*MHp2*(MHp2-
     &  MSQ2)-(MHp2-MSQ2)**3-M42**2*(3*MHp2+2*MSQ2))+2*a0t5*(M42**3+
     &  (MHp2-MSQ2)**3+3*M42*MSQ2*(-MHp2+MSQ2)-M42**2*(2*MHp2+3*MSQ2)))
     &  )/(16.*alambda5**2*M42)
       afin(13)=(-24*aet5*M22**4+96*aet5*M22**3*MHp2-144*aet5*M22**2*
     &  MHp2**2+96*aet5*M22*MHp2**3-24*aet5*MHp2**4-20*A0THp*M22**3*
     &  MSQ2+96*aet5*M22**3*MSQ2-24*I0A7*M22**3*MSQ2-23*M22**4*MSQ2+12*
     &  A0THp*M22**2*MHp2*MSQ2-96*aet5*M22**2*MHp2*MSQ2+24*I0A7*M22**2*
     &  MHp2*MSQ2-4*M22**3*MHp2*MSQ2+36*A0THp*M22*MHp2**2*MSQ2-96*aet5*
     &  M22*MHp2**2*MSQ2+24*I0A7*M22*MHp2**2*MSQ2+54*M22**2*MHp2**2*
     &  MSQ2-28*A0THp*MHp2**3*MSQ2+96*aet5*MHp2**3*MSQ2-24*I0A7*MHp2**
     &  3*MSQ2-4*M22*MHp2**3*MSQ2-23*MHp2**4*MSQ2+68*A0THp*M22**2*MSQ2*
     &  *2-144*aet5*M22**2*MSQ2**2+72*I0A7*M22**2*MSQ2**2+44*M22**3*
     &  MSQ2**2+56*A0THp*M22*MHp2*MSQ2**2-96*aet5*M22*MHp2*MSQ2**2+64*
     &  I0A7*M22*MHp2*MSQ2**2+164*M22**2*MHp2*MSQ2**2+84*A0THp*MHp2**2*
     &  MSQ2**2-144*aet5*MHp2**2*MSQ2**2+72*I0A7*MHp2**2*MSQ2**2+164*
     &  M22*MHp2**2*MSQ2**2+44*MHp2**3*MSQ2**2-76*A0THp*M22*MSQ2**3+96*
     &  aet5*M22*MSQ2**3-72*I0A7*M22*MSQ2**3+6*M22**2*MSQ2**3-84*A0THp*
     &  MHp2*MSQ2**3+96*aet5*MHp2*MSQ2**3-72*I0A7*MHp2*MSQ2**3-76*M22*
     &  MHp2*MSQ2**3+6*MHp2**2*MSQ2**3+28*A0THp*MSQ2**4-24*aet5*MSQ2**
     &  4+24*I0A7*MSQ2**4-52*M22*MSQ2**4-52*MHp2*MSQ2**4+25*MSQ2**5+4*
     &  a0t5*(6*M22**4+(6*MHp2-11*MSQ2)*(MHp2-MSQ2)**3-M22**3*(24*MHp2+
     &  29*MSQ2)+M22**2*(36*MHp2**2+29*MHp2*MSQ2+51*MSQ2**2)+M22*(-24*
     &  MHp2**3+29*MHp2**2*MSQ2+38*MHp2*MSQ2**2-39*MSQ2**3)+2*A0THp*(3*
     &  M22**3-3*(MHp2-MSQ2)**3-M22**2*(9*MHp2+4*MSQ2)+M22*(9*MHp2**2-
     &  5*MHp2*MSQ2-2*MSQ2**2)))-4*a0t2*(-(MSQ2*(-7*M22**3-(5*MHp2-7*
     &  MSQ2)*(MHp2-MSQ2)**2+3*M22**2*(3*MHp2+7*MSQ2)+M22*(3*MHp2**2+
     &  14*MHp2*MSQ2-21*MSQ2**2)-2*A0THp*(6*M22**2-12*M22*MHp2+6*MHp2**
     &  2-13*M22*MSQ2-13*MHp2*MSQ2+7*MSQ2**2)))+2*a0t5*(3*M22**3-3*
     &  MHp2**3+4*MHp2**2*MSQ2+2*MHp2*MSQ2**2-3*MSQ2**3-9*M22**2*(MHp2+
     &  MSQ2)+M22*(9*MHp2**2+5*MHp2*MSQ2+9*MSQ2**2))))/(32.*alambda4**
     &  2*MSQ2)
       afin(14)=(-8*aet5*M22**4+32*aet5*M22**3*MHp2-48*aet5*M22**2*
     &  MHp2**2+32*aet5*M22*MHp2**3-8*aet5*MHp2**4-12*A0THp*M22**3*
     &  MSQ2+32*aet5*M22**3*MSQ2-8*I0A7*M22**3*MSQ2-9*M22**4*MSQ2+20*
     &  A0THp*M22**2*MHp2*MSQ2-32*aet5*M22**2*MHp2*MSQ2+8*I0A7*M22**2*
     &  MHp2*MSQ2+4*M22**3*MHp2*MSQ2-4*A0THp*M22*MHp2**2*MSQ2-32*aet5*
     &  M22*MHp2**2*MSQ2+8*I0A7*M22*MHp2**2*MSQ2+10*M22**2*MHp2**2*
     &  MSQ2-4*A0THp*MHp2**3*MSQ2+32*aet5*MHp2**3*MSQ2-8*I0A7*MHp2**3*
     &  MSQ2+4*M22*MHp2**3*MSQ2-9*MHp2**4*MSQ2+28*A0THp*M22**2*MSQ2**2-
     &  48*aet5*M22**2*MSQ2**2+24*I0A7*M22**2*MSQ2**2+20*M22**3*MSQ2**
     &  2+8*A0THp*M22*MHp2*MSQ2**2-32*aet5*M22*MHp2*MSQ2**2+28*M22**2*
     &  MHp2*MSQ2**2+12*A0THp*MHp2**2*MSQ2**2-48*aet5*MHp2**2*MSQ2**2+
     &  24*I0A7*MHp2**2*MSQ2**2+28*M22*MHp2**2*MSQ2**2+20*MHp2**3*MSQ2*
     &  *2-20*A0THp*M22*MSQ2**3+32*aet5*M22*MSQ2**3-24*I0A7*M22*MSQ2**
     &  3-6*M22**2*MSQ2**3-12*A0THp*MHp2*MSQ2**3+32*aet5*MHp2*MSQ2**3-
     &  24*I0A7*MHp2*MSQ2**3-52*M22*MHp2*MSQ2**3-6*MHp2**2*MSQ2**3+4*
     &  A0THp*MSQ2**4-8*aet5*MSQ2**4+8*I0A7*MSQ2**4-12*M22*MSQ2**4-12*
     &  MHp2*MSQ2**4+7*MSQ2**5+4*a0t5*(2*M22**4+(2*MHp2-5*MSQ2)*(MHp2-
     &  MSQ2)**3-M22**3*(8*MHp2+11*MSQ2)+M22**2*(12*MHp2**2+11*MHp2*
     &  MSQ2+21*MSQ2**2)+M22*(-8*MHp2**3+11*MHp2**2*MSQ2+10*MHp2*MSQ2**
     &  2-17*MSQ2**3)+2*A0THp*(M22**3-3*M22**2*MHp2-(MHp2-MSQ2)**3+M22*
     &  (3*MHp2**2-3*MHp2*MSQ2-2*MSQ2**2)))-4*a0t2*(2*a0t5*(M22**3-
     &  MHp2**3+2*MHp2*MSQ2**2-MSQ2**3-3*M22**2*(MHp2+MSQ2)+3*M22*
     &  (MHp2**2+MHp2*MSQ2+MSQ2**2))+MSQ2*(M22**3+M22**2*(MHp2-3*MSQ2)+
     &  (MHp2-MSQ2)**2*(3*MHp2-MSQ2)+2*A0THp*(2*M22**2-4*M22*MHp2+2*
     &  MHp2**2-3*M22*MSQ2-3*MHp2*MSQ2+MSQ2**2)+M22*(-5*MHp2**2-2*MHp2*
     &  MSQ2+3*MSQ2**2))))/(32.*alambda4**2*MSQ2)
       afin(15)=(-24*aet5*M42**4+96*aet5*M42**3*MHp2-144*aet5*M42**2*
     &  MHp2**2+96*aet5*M42*MHp2**3-24*aet5*MHp2**4-20*A0THp*M42**3*
     &  MSQ2+96*aet5*M42**3*MSQ2-24*I0A8*M42**3*MSQ2-23*M42**4*MSQ2+12*
     &  A0THp*M42**2*MHp2*MSQ2-96*aet5*M42**2*MHp2*MSQ2+24*I0A8*M42**2*
     &  MHp2*MSQ2-4*M42**3*MHp2*MSQ2+36*A0THp*M42*MHp2**2*MSQ2-96*aet5*
     &  M42*MHp2**2*MSQ2+24*I0A8*M42*MHp2**2*MSQ2+54*M42**2*MHp2**2*
     &  MSQ2-28*A0THp*MHp2**3*MSQ2+96*aet5*MHp2**3*MSQ2-24*I0A8*MHp2**
     &  3*MSQ2-4*M42*MHp2**3*MSQ2-23*MHp2**4*MSQ2+68*A0THp*M42**2*MSQ2*
     &  *2-144*aet5*M42**2*MSQ2**2+72*I0A8*M42**2*MSQ2**2+44*M42**3*
     &  MSQ2**2+56*A0THp*M42*MHp2*MSQ2**2-96*aet5*M42*MHp2*MSQ2**2+64*
     &  I0A8*M42*MHp2*MSQ2**2+164*M42**2*MHp2*MSQ2**2+84*A0THp*MHp2**2*
     &  MSQ2**2-144*aet5*MHp2**2*MSQ2**2+72*I0A8*MHp2**2*MSQ2**2+164*
     &  M42*MHp2**2*MSQ2**2+44*MHp2**3*MSQ2**2-76*A0THp*M42*MSQ2**3+96*
     &  aet5*M42*MSQ2**3-72*I0A8*M42*MSQ2**3+6*M42**2*MSQ2**3-84*A0THp*
     &  MHp2*MSQ2**3+96*aet5*MHp2*MSQ2**3-72*I0A8*MHp2*MSQ2**3-76*M42*
     &  MHp2*MSQ2**3+6*MHp2**2*MSQ2**3+28*A0THp*MSQ2**4-24*aet5*MSQ2**
     &  4+24*I0A8*MSQ2**4-52*M42*MSQ2**4-52*MHp2*MSQ2**4+25*MSQ2**5+4*
     &  a0t5*(6*M42**4+(6*MHp2-11*MSQ2)*(MHp2-MSQ2)**3-M42**3*(24*MHp2+
     &  29*MSQ2)+M42**2*(36*MHp2**2+29*MHp2*MSQ2+51*MSQ2**2)+M42*(-24*
     &  MHp2**3+29*MHp2**2*MSQ2+38*MHp2*MSQ2**2-39*MSQ2**3)+2*A0THp*(3*
     &  M42**3-3*(MHp2-MSQ2)**3-M42**2*(9*MHp2+4*MSQ2)+M42*(9*MHp2**2-
     &  5*MHp2*MSQ2-2*MSQ2**2)))-4*a0t4*(-(MSQ2*(-7*M42**3-(5*MHp2-7*
     &  MSQ2)*(MHp2-MSQ2)**2+3*M42**2*(3*MHp2+7*MSQ2)+M42*(3*MHp2**2+
     &  14*MHp2*MSQ2-21*MSQ2**2)-2*A0THp*(6*M42**2-12*M42*MHp2+6*MHp2**
     &  2-13*M42*MSQ2-13*MHp2*MSQ2+7*MSQ2**2)))+2*a0t5*(3*M42**3-3*
     &  MHp2**3+4*MHp2**2*MSQ2+2*MHp2*MSQ2**2-3*MSQ2**3-9*M42**2*(MHp2+
     &  MSQ2)+M42*(9*MHp2**2+5*MHp2*MSQ2+9*MSQ2**2))))/(32.*alambda5**
     &  2*MSQ2)
       afin(16)=(-8*aet5*M42**4+32*aet5*M42**3*MHp2-48*aet5*M42**2*
     &  MHp2**2+32*aet5*M42*MHp2**3-8*aet5*MHp2**4-12*A0THp*M42**3*
     &  MSQ2+32*aet5*M42**3*MSQ2-8*I0A8*M42**3*MSQ2-9*M42**4*MSQ2+20*
     &  A0THp*M42**2*MHp2*MSQ2-32*aet5*M42**2*MHp2*MSQ2+8*I0A8*M42**2*
     &  MHp2*MSQ2+4*M42**3*MHp2*MSQ2-4*A0THp*M42*MHp2**2*MSQ2-32*aet5*
     &  M42*MHp2**2*MSQ2+8*I0A8*M42*MHp2**2*MSQ2+10*M42**2*MHp2**2*
     &  MSQ2-4*A0THp*MHp2**3*MSQ2+32*aet5*MHp2**3*MSQ2-8*I0A8*MHp2**3*
     &  MSQ2+4*M42*MHp2**3*MSQ2-9*MHp2**4*MSQ2+28*A0THp*M42**2*MSQ2**2-
     &  48*aet5*M42**2*MSQ2**2+24*I0A8*M42**2*MSQ2**2+20*M42**3*MSQ2**
     &  2+8*A0THp*M42*MHp2*MSQ2**2-32*aet5*M42*MHp2*MSQ2**2+28*M42**2*
     &  MHp2*MSQ2**2+12*A0THp*MHp2**2*MSQ2**2-48*aet5*MHp2**2*MSQ2**2+
     &  24*I0A8*MHp2**2*MSQ2**2+28*M42*MHp2**2*MSQ2**2+20*MHp2**3*MSQ2*
     &  *2-20*A0THp*M42*MSQ2**3+32*aet5*M42*MSQ2**3-24*I0A8*M42*MSQ2**
     &  3-6*M42**2*MSQ2**3-12*A0THp*MHp2*MSQ2**3+32*aet5*MHp2*MSQ2**3-
     &  24*I0A8*MHp2*MSQ2**3-52*M42*MHp2*MSQ2**3-6*MHp2**2*MSQ2**3+4*
     &  A0THp*MSQ2**4-8*aet5*MSQ2**4+8*I0A8*MSQ2**4-12*M42*MSQ2**4-12*
     &  MHp2*MSQ2**4+7*MSQ2**5+4*a0t5*(2*M42**4+(2*MHp2-5*MSQ2)*(MHp2-
     &  MSQ2)**3-M42**3*(8*MHp2+11*MSQ2)+M42**2*(12*MHp2**2+11*MHp2*
     &  MSQ2+21*MSQ2**2)+M42*(-8*MHp2**3+11*MHp2**2*MSQ2+10*MHp2*MSQ2**
     &  2-17*MSQ2**3)+2*A0THp*(M42**3-3*M42**2*MHp2-(MHp2-MSQ2)**3+M42*
     &  (3*MHp2**2-3*MHp2*MSQ2-2*MSQ2**2)))-4*a0t4*(2*a0t5*(M42**3-
     &  MHp2**3+2*MHp2*MSQ2**2-MSQ2**3-3*M42**2*(MHp2+MSQ2)+3*M42*
     &  (MHp2**2+MHp2*MSQ2+MSQ2**2))+MSQ2*(M42**3+M42**2*(MHp2-3*MSQ2)+
     &  (MHp2-MSQ2)**2*(3*MHp2-MSQ2)+2*A0THp*(2*M42**2-4*M42*MHp2+2*
     &  MHp2**2-3*M42*MSQ2-3*MHp2*MSQ2+MSQ2**2)+M42*(-5*MHp2**2-2*MHp2*
     &  MSQ2+3*MSQ2**2))))/(32.*alambda5**2*MSQ2)

       selfZ=selfZ+((afin(1)/(6.*CW**2)-(SW**2*afin(13))/(18.*CW**2)+
     &  afin(14)/3.+(-afin(1)/(8.*CW**2)+(CW**2*afin(14))/2.)/SW**2)*
     &  CS3S13S14(1)*CS3S14S13(1)+(-(CW*afin(7))/(2.*SW)-(SW*afin(7))
     &  /(6.*CW))*CS13S13V2(1,1)*CS3S13S14(1)*CS3S14S13(1)+afin(11)*
     &  CS13S13V2(1,1)**2*CS3S13S14(1)*CS3S14S13(1)+(afin(4)*
     &  CS13S13V2V2(1,1)*CS3S13S14(1)*CS3S14S13(1))/4.+(afin(3)*
     &  CS13S13V2V2(1,2)*CS3S13S14(2)*CS3S14S13(1))/4.+(afin(3)*
     &  CS13S13V2V2(2,1)*CS3S13S14(1)*CS3S14S13(2))/4.+(afin(2)/(6.*CW*
     &  *2)-(SW**2*afin(15))/(18.*CW**2)+afin(16)/3.+(-afin(2)/(8.*CW**
     &  2)+(CW**2*afin(16))/2.)/SW**2)*CS3S13S14(2)*CS3S14S13(2)+(-(CW*
     &  afin(8))/(2.*SW)-(SW*afin(8))/(6.*CW))*CS13S13V2(2,2)*
     &  CS3S13S14(2)*CS3S14S13(2)+afin(12)*CS13S13V2(2,2)**2*
     &  CS3S13S14(2)*CS3S14S13(2)+(afin(5)*CS13S13V2V2(2,2)*
     &  CS3S13S14(2)*CS3S14S13(2))/4.+CS13S13V2(2,1)*((-(CW*afin(6))
     &  /(2.*SW)-(SW*afin(6))/(6.*CW))*CS3S13S14(1)*CS3S14S13(2)+
     &  afin(9)*CS13S13V2(1,1)*CS3S13S14(1)*CS3S14S13(2)+afin(10)*
     &  CS13S13V2(2,2)*CS3S13S14(1)*CS3S14S13(2))+CS13S13V2(1,2)*((-
     &  (CW*afin(6))/(2.*SW)-(SW*afin(6))/(6.*CW))*CS3S13S14(2)*
     &  CS3S14S13(1)+afin(9)*CS13S13V2(1,1)*CS3S13S14(2)*CS3S14S13(1)+
     &  afin(10)*CS13S13V2(2,2)*CS3S13S14(2)*CS3S14S13(1)+
     &  CS13S13V2(2,1)*(afin(9)*CS3S13S14(1)*CS3S14S13(1)+afin(10)*
     &  CS3S13S14(2)*CS3S14S13(2))))

c
c Charged Higgs boson  diagrams, stop sbottom only
c

c[ charged goldstone contribution
       afin(1)=(-28*a0t1+8*aet1-8*I0A26-17*M12)/16.
       afin(2)=(3*(44*a0t1-8*aet1+8*I0A26+5*M12))/32.
       afin(3)=(-9*(52*a0t1-24*aet1+24*I0A26+11*M12))/16.
       selfZ=selfZ+((CW**2*afin(1))/(8.*SW**2)+afin(2)/6.-(SW**2*
     &  afin(3))/(72.*CW**2))*CTBS3(1)*CTBS3C(1)

c
c Charged Goldstone boson  diagrams, top, bottom only
c

       afin(1)=-((-(a0t5*M22)+aet5*M22+2*a0t5*MSQ2-aet5*MSQ2+I0A19*
     &  MSQ2+M22*MSQ2+MSQ2**2+a0t2*(a0t5+MSQ2))/(M22mMSQ*MSQ2))
       afin(2)=-((-(a0t5*M42)+aet5*M42+2*a0t5*MSQ2-aet5*MSQ2+I0A20*
     &  MSQ2+M42*MSQ2+MSQ2**2+a0t4*(a0t5+MSQ2))/(M42mMSQ*MSQ2))
       afin(3)=(-aet2+aet4+I0A19-I0A20)/M22m42
       afin(4)=(a0t5*M22-aet2*M22+I0A19*M22+M22**2+a0t2*(a0t5+2*M22-
     &  MSQ2)+aet2*MSQ2+M22*MSQ2)/(M22*M22mMSQ)
       afin(5)=(a0t5*M42-aet4*M42+I0A20*M42+M42**2+a0t4*(a0t5+2*M42-
     &  MSQ2)+aet4*MSQ2+M42*MSQ2)/(M42*M42mMSQ)
       afin(6)=(-3*M22**2*M42+3*M22*M42**2+4*a0t4*(a0t5+M42)*(M22-MSQ2)
     &  -4*a0t2*(a0t5+M22)*(M42-MSQ2)+4*a0t5*M22*MSQ2+4*I0A20*M22*MSQ2+
     &  3*M22**2*MSQ2-4*a0t5*M42*MSQ2-4*I0A19*M42*MSQ2-3*M42**2*MSQ2+4*
     &  I0A19*MSQ2**2-4*I0A20*MSQ2**2+5*M22*MSQ2**2-5*M42*MSQ2**2)/(8.*
     &  M22m42*M22mMSQ*M42mMSQ)
       afin(7)=(-4*a0t2+4*a0t5+M22-MSQ2)/(8*M22-8*MSQ2)
       afin(8)=(-4*a0t4+4*a0t5+M42-MSQ2)/(8*M42-8*MSQ2)
       afin(9)=(-8*aet2*M22**2+8*I0A19*M22**2+9*M22**3+8*a0t5*M22*(M22-
     &  M42)-4*a0t4*M22*M42+16*aet2*M22*M42-8*aet4*M22*M42-16*I0A19*
     &  M22*M42+8*I0A20*M22*M42-6*M22**2*M42-3*M22*M42**2+8*aet2*M22*
     &  MSQ2+7*M22**2*MSQ2+4*a0t4*M42*MSQ2-16*aet2*M42*MSQ2+8*aet4*M42*
     &  MSQ2+8*I0A19*M42*MSQ2-8*I0A20*M42*MSQ2-10*M22*M42*MSQ2+3*M42**
     &  2*MSQ2+4*a0t2*(3*M22**2+2*a0t5*M22m42-M22*(2*M42+MSQ2)))/(16.*
     &  M22m42s*M22mMSQ)
       afin(10)=(-8*a0t5*M22*M42-8*aet2*M22*M42+16*aet4*M22*M42+8*
     &  I0A19*M22*M42-16*I0A20*M22*M42-3*M22**2*M42+8*a0t5*M42**2-8*
     &  aet4*M42**2+8*I0A20*M42**2-6*M22*M42**2+9*M42**3+8*aet2*M22*
     &  MSQ2-16*aet4*M22*MSQ2-8*I0A19*M22*MSQ2+8*I0A20*M22*MSQ2+3*M22**
     &  2*MSQ2+8*aet4*M42*MSQ2-10*M22*M42*MSQ2+7*M42**2*MSQ2+4*a0t2*
     &  M22*(-M42+MSQ2)-4*a0t4*(2*a0t5*M22m42+M42*(2*M22-3*M42+MSQ2)))
     &  /(16.*M22m42s*M42mMSQ)
       afin(11)=(8*a0t2*a0t5+20*a0t2*M22+4*a0t5*M22-8*aet2*M22+8*I0A19*
     &  M22+7*M22**2-8*a0t2*MSQ2+8*aet2*MSQ2+9*M22*MSQ2)/(16.*M22*
     &  M22mMSQ)
       afin(12)=(8*a0t4*a0t5+20*a0t4*M42+4*a0t5*M42-8*aet4*M42+8*I0A20*
     &  M42+7*M42**2-8*a0t4*MSQ2+8*aet4*MSQ2+9*M42*MSQ2)/(16.*M42*
     &  M42mMSQ)
       afin(13)=-(24*a0t2*a0t5-24*a0t5*M22+24*aet5*M22+28*a0t2*MSQ2+44*
     &  a0t5*MSQ2-24*aet5*MSQ2+24*I0A19*MSQ2+23*M22*MSQ2+25*MSQ2**2)
     &  /(32.*M22mMSQ*MSQ2)
       afin(14)=-(8*a0t2*a0t5-8*a0t5*M22+8*aet5*M22+4*a0t2*MSQ2+20*
     &  a0t5*MSQ2-8*aet5*MSQ2+8*I0A19*MSQ2+9*M22*MSQ2+7*MSQ2**2)/(32.*
     &  M22mMSQ*MSQ2)
       afin(15)=-(24*a0t4*a0t5-24*a0t5*M42+24*aet5*M42+28*a0t4*MSQ2+44*
     &  a0t5*MSQ2-24*aet5*MSQ2+24*I0A20*MSQ2+23*M42*MSQ2+25*MSQ2**2)
     &  /(32.*M42mMSQ*MSQ2)
       afin(16)=-(8*a0t4*a0t5-8*a0t5*M42+8*aet5*M42+4*a0t4*MSQ2+20*
     &  a0t5*MSQ2-8*aet5*MSQ2+8*I0A20*MSQ2+9*M42*MSQ2+7*MSQ2**2)/(32.*
     &  M42mMSQ*MSQ2)

       selfZ=selfZ+(CS3S13S(1,1)*((afin(1)/(6.*CW**2)-(SW**2*afin(13))
     &  /(18.*CW**2)+afin(14)/3.+(-afin(1)/(8.*CW**2)+(CW**2*afin(14))
     &  /2.)/SW**2+(-(CW*afin(7))/(2.*SW)-(SW*afin(7))/(6.*CW))*
     &  CS13S13V2(1,1)+afin(11)*CS13S13V2(1,1)**2+afin(9)*
     &  CS13S13V2(1,2)*CS13S13V2(2,1)+(afin(4)*CS13S13V2V2(1,1))/4.)*
     &  CS3S13SC(1,1)+(CS13S13V2(2,1)*(-(CW*afin(6))/(2.*SW)-(SW*
     &  afin(6))/(6.*CW)+afin(9)*CS13S13V2(1,1)+afin(10)*CS13S13V2(2,2)
     &  )+(afin(3)*CS13S13V2V2(2,1))/4.)*CS3S13SC(1,2))+CS3S13S(1,2)*
     &  ((CS13S13V2(1,2)*(-(CW*afin(6))/(2.*SW)-(SW*afin(6))/(6.*CW)+
     &  afin(9)*CS13S13V2(1,1)+afin(10)*CS13S13V2(2,2))+(afin(3)*
     &  CS13S13V2V2(1,2))/4.)*CS3S13SC(1,1)+(afin(2)/(6.*CW**2)-(SW**2*
     &  afin(15))/(18.*CW**2)+afin(16)/3.+(-afin(2)/(8.*CW**2)+(CW**2*
     &  afin(16))/2.)/SW**2+afin(10)*CS13S13V2(1,2)*CS13S13V2(2,1)+(-
     &  (CW*afin(8))/(2.*SW)-(SW*afin(8))/(6.*CW))*CS13S13V2(2,2)+
     &  afin(12)*CS13S13V2(2,2)**2+(afin(5)*CS13S13V2V2(2,2))/4.)*
     &  CS3S13SC(1,2)))
c
c Charged Goldstone boson  diagrams, stop, sbottom only
c

c charged goldstone contribution ]
c[ neutral Higgs contribution
       do h1=ihiggs,5
       afin(1)=(-2*a0t1**2+20*a0t1*M12-8*aet1*M12+2*(a0t1+M12)*
     &  A0TNH(h1)+2*M12*I0A9(h1)-4*a0t1*Mah2(h1)+2*aet1*Mah2(h1)+3*M12*
     &  Mah2(h1))/(8*M12-2*Mah2(h1))
       afin(2)=(-9*(-2*a0t1**2+20*a0t1*M12-8*aet1*M12+2*(a0t1+M12)*
     &  A0TNH(h1)+2*M12*I0A9(h1)-4*a0t1*Mah2(h1)+2*aet1*Mah2(h1)+3*M12*
     &  Mah2(h1)))/(8*M12-2*Mah2(h1))
       afin(3)=(3*(-2*a0t1**2+20*a0t1*M12-8*aet1*M12+2*(a0t1+M12)*
     &  A0TNH(h1)+2*M12*I0A9(h1)-4*a0t1*Mah2(h1)+2*aet1*Mah2(h1)+3*M12*
     &  Mah2(h1)))/(8*M12-2*Mah2(h1))
       afin(4)=(-8*a0t1**2+192*a0t1*M12-96*aet1*M12+28*M12**2+40*M12*
     &  I0A9(h1)+4*A0TNH(h1)*(2*(a0t1+7*M12)-3*Mah2(h1))-44*a0t1*
     &  Mah2(h1)+24*aet1*Mah2(h1)+25*M12*Mah2(h1)-8*I0A9(h1)*Mah2(h1)-
     &  5*Mah2(h1)**2+8*AETNH(h1)*(-4*M12+Mah2(h1)))/(32*M12-8*Mah2(h1)
     &  )
       afin(5)=(3*(-8*a0t1**2+192*a0t1*M12-96*aet1*M12+28*M12**2+40*
     &  M12*I0A9(h1)+4*A0TNH(h1)*(2*(a0t1+7*M12)-3*Mah2(h1))-44*a0t1*
     &  Mah2(h1)+24*aet1*Mah2(h1)+25*M12*Mah2(h1)-8*I0A9(h1)*Mah2(h1)-
     &  5*Mah2(h1)**2+8*AETNH(h1)*(-4*M12+Mah2(h1))))/(32*M12-8*
     &  Mah2(h1))
       afin(6)=(9*(8*a0t1**2-192*a0t1*M12+96*aet1*M12-28*M12**2-40*M12*
     &  I0A9(h1)-4*A0TNH(h1)*(2*(a0t1+7*M12)-3*Mah2(h1))+8*AETNH(h1)*
     &  (4*M12-Mah2(h1))+44*a0t1*Mah2(h1)-24*aet1*Mah2(h1)-25*M12*
     &  Mah2(h1)+8*I0A9(h1)*Mah2(h1)+5*Mah2(h1)**2))/(32*M12-8*Mah2(h1)
     &  )

       selfZ=selfZ+(((CW**2*afin(1))/(8.*SW**2)-(SW**2*afin(2))/(72.*
     &  CW**2)+afin(3)/12.)*hy(h1)**2+((CW**2*afin(4))/(8.*SW**2)+
     &  afin(5)/12.-(SW**2*afin(6))/(72.*CW**2))*hy(h1)*hyc(h1)+((CW**
     &  2*afin(1))/(8.*SW**2)-(SW**2*afin(2))/(72.*CW**2)+afin(3)/12.)*
     &  hyc(h1)**2)
       enddo


c
c Neutral Higgs diagrams (1->5), top only
c

       do h1=ihiggs,5
       afin(1)=(-aet2+aet4+I0A10(h1)-I0A11(h1))/M22m42
       afin(2)=(-a0t2**2+6*a0t2*M22-4*aet2*M22+2*M22**2+(a0t2+M22)*
     &  A0TNH(h1)+M22*I0A10(h1)-a0t2*Mah2(h1)+aet2*Mah2(h1)+M22*
     &  Mah2(h1))/(M22*(4*M22-Mah2(h1)))
       afin(3)=-((-(a0t4*M22**2)+aet4*M22**2+a0t2*a0t4*M22m42+3*a0t4*
     &  M22*M42-2*aet4*M22*M42+M22**2*M42+a0t2*M22m42*M42-2*a0t4*M42**
     &  2+aet4*M42**2-M42**3-a0t2*a0t4*Mah2(h1)+2*a0t4*M22*Mah2(h1)-2*
     &  aet4*M22*Mah2(h1)+a0t2*M42*Mah2(h1)+3*a0t4*M42*Mah2(h1)-2*aet4*
     &  M42*Mah2(h1)+2*M22*M42*Mah2(h1)-a0t4*Mah2(h1)**2+aet4*Mah2(h1)*
     &  *2+M42*Mah2(h1)**2+M42*I0A11(h1)*(M22-M42+Mah2(h1))+A0TNH(h1)*
     &  ((2*a0t2+M22-M42)*M42-a0t4*(M22+M42)+(a0t4+M42)*Mah2(h1)))
     &  /(M42*alambda6(h1)))
       afin(4)=(-aet2+aet4+I0A11(h1)-I0A12(h1))/M22m42
       afin(5)=(2*a0t2*M22**2-aet2*M22**2+M22**3+a0t2*a0t4*M22m42+a0t4*
     &  M22*M22m42-3*a0t2*M22*M42+2*aet2*M22*M42+a0t2*M42**2-aet2*M42**
     &  2-M22*M42**2+M22*I0A11(h1)*(M22-M42-Mah2(h1))+a0t2*a0t4*
     &  Mah2(h1)-3*a0t2*M22*Mah2(h1)-a0t4*M22*Mah2(h1)+2*aet2*M22*
     &  Mah2(h1)-2*a0t2*M42*Mah2(h1)+2*aet2*M42*Mah2(h1)-2*M22*M42*
     &  Mah2(h1)+a0t2*Mah2(h1)**2-aet2*Mah2(h1)**2-M22*Mah2(h1)**2+
     &  A0TNH(h1)*(M22*(-2*a0t4+M22-M42)+a0t2*(M22+M42)-(a0t2+M22)*
     &  Mah2(h1)))/(M22*alambda6(h1))
       afin(6)=(-a0t4**2+6*a0t4*M42-4*aet4*M42+2*M42**2+(a0t4+M42)*
     &  A0TNH(h1)+M42*I0A12(h1)-a0t4*Mah2(h1)+aet4*Mah2(h1)+M42*
     &  Mah2(h1))/(M42*(4*M42-Mah2(h1)))
       afin(7)=-(-2*a0t2**2+4*a0t2*a0t4-2*a0t4**2+M22**2-2*M22*M42+M42*
     &  *2-4*M42*I0A12(h1)+4*I0A11(h1)*(M22+M42-Mah2(h1))+2*I0A12(h1)*
     &  Mah2(h1)+2*I0A10(h1)*(-2*M22+Mah2(h1)))/(16.*M22m42s)
       afin(8)=-(-2*a0t2**2+4*a0t2*a0t4-2*a0t4**2+M22**2-2*M22*M42+M42*
     &  *2-4*M42*I0A12(h1)+4*I0A11(h1)*(M22+M42-Mah2(h1))+2*I0A12(h1)*
     &  Mah2(h1)+2*I0A10(h1)*(-2*M22+Mah2(h1)))/(8.*M22m42s)
       afin(9)=(M22**4-4*a0t2*M22m42**3+4*a0t4*M22m42**3-4*M22**3*M42+
     &  6*M22**2*M42**2-4*M22*M42**3+M42**4+4*(-((M22+M42)*(a0t4*M22+
     &  M22**2-3*a0t4*M42-6*M22*M42+M42**2+a0t2*(-2*a0t4-3*M22+M42)))+
     &  4*M22*M42*I0A11(h1))*Mah2(h1)-2*(2*a0t2*(2*a0t4+3*M22+M42)+(2*
     &  a0t4-3*M22-M42)*(M22+3*M42))*Mah2(h1)**2+4*(a0t2+a0t4-M22-M42)*
     &  Mah2(h1)**3+Mah2(h1)**4+4*A0TNH(h1)*(M22**3-M22**2*M42+2*a0t2*
     &  M22m42*M42+M42**3-M22*(2*a0t4*M22m42+M42**2)+(2*a0t4*M22-3*M22*
     &  *2+2*a0t2*M42+2*M22*M42-3*M42**2)*Mah2(h1)+3*(M22+M42)*Mah2(h1)
     &  **2-Mah2(h1)**3))/(8.*alambda6(h1)**2)
       afin(10)=(4*a0t2*M22**3-8*aet2*M22**3+3*M22**4-8*a0t2*a0t4*
     &  M22m42**2-16*a0t2*M22**2*M42+32*aet2*M22**2*M42-8*aet4*M22**2*
     &  M42-16*M22**3*M42-12*a0t4*M22m42**2*M42+20*a0t2*M22*M42**2-40*
     &  aet2*M22*M42**2+16*aet4*M22*M42**2+14*M22**2*M42**2-8*a0t2*M42*
     &  *3+16*aet2*M42**3-8*aet4*M42**3+8*M22*M42**3-9*M42**4-8*M22**3*
     &  I0A11(h1)+24*M22**2*M42*I0A11(h1)-24*M22*M42**2*I0A11(h1)+8*
     &  M42**3*I0A11(h1)-8*a0t2*M22**2*Mah2(h1)+16*aet2*M22**2*Mah2(h1)
     &  -6*M22**3*Mah2(h1)+8*a0t2*a0t4*M22m42*Mah2(h1)-16*a0t2*M22*M42*
     &  Mah2(h1)-16*aet2*M22*M42*Mah2(h1)+16*aet4*M22*M42*Mah2(h1)-18*
     &  M22**2*M42*Mah2(h1)+8*a0t2*M42**2*Mah2(h1)+16*a0t4*M42**2*
     &  Mah2(h1)-32*aet2*M42**2*Mah2(h1)+16*aet4*M42**2*Mah2(h1)+22*
     &  M22*M42**2*Mah2(h1)+2*M42**3*Mah2(h1)+16*M22**2*I0A11(h1)*
     &  Mah2(h1)-24*M22*M42*I0A11(h1)*Mah2(h1)-24*M42**2*I0A11(h1)*
     &  Mah2(h1)+4*a0t2*M22*Mah2(h1)**2-8*aet2*M22*Mah2(h1)**2+3*M22**
     &  2*Mah2(h1)**2-4*a0t4*M42*Mah2(h1)**2+16*aet2*M42*Mah2(h1)**2-8*
     &  aet4*M42*Mah2(h1)**2-10*M22*M42*Mah2(h1)**2+7*M42**2*Mah2(h1)**
     &  2-8*M22*I0A11(h1)*Mah2(h1)**2+16*M42*I0A11(h1)*Mah2(h1)**2+8*
     &  A0TNH(h1)*(-((M22-M42)*(2*a0t2+M22-M42)*M42)+a0t4*M22m42*(M22+
     &  M42)+(-(a0t4*M22m42)+M42*(-M22+M42))*Mah2(h1))+8*(M22-2*M42)*
     &  I0A10(h1)*((M22-M42)**2-2*(M22+M42)*Mah2(h1)+Mah2(h1)**2))
     &  /(16.*M22m42s*alambda6(h1))
       afin(11)=(32*a0t2*M22**2-32*aet2*M22**2+20*M22**3-8*a0t2**2*
     &  M22m42-16*a0t2*M22*M42-16*a0t4*M22*M42+64*aet2*M22*M42-32*aet4*
     &  M22*M42-8*M22**2*M42-12*M22*M42**2+8*(M22**2+a0t2*M22m42-M22*
     &  M42)*A0TNH(h1)+32*M22*M42*I0A11(h1)-4*a0t2*M22*Mah2(h1)+8*aet2*
     &  M22*Mah2(h1)+7*M22**2*Mah2(h1)+4*a0t4*M42*Mah2(h1)-16*aet2*M42*
     &  Mah2(h1)+8*aet4*M42*Mah2(h1)-10*M22*M42*Mah2(h1)+3*M42**2*
     &  Mah2(h1)-8*M42*I0A11(h1)*Mah2(h1)+8*I0A10(h1)*(M22**2-5*M22*
     &  M42+M42*Mah2(h1)))/(16.*M22m42s*(4*M22-Mah2(h1)))
       afin(12)=(-8*aet2*M22**3+9*M22**4+8*a0t2*a0t4*M22m42**2+12*a0t2*
     &  M22*M22m42**2+8*a0t4*M22*M22m42**2+32*aet2*M22**2*M42-8*aet4*
     &  M22**2*M42-8*M22**3*M42-4*a0t4*M22m42**2*M42-40*aet2*M22*M42**
     &  2+16*aet4*M22*M42**2-14*M22**2*M42**2+16*aet2*M42**3-8*aet4*
     &  M42**3+16*M22*M42**3-3*M42**4+8*M22**2*M42*I0A12(h1)-16*M22*
     &  M42**2*I0A12(h1)+8*M42**3*I0A12(h1)-16*a0t2*M22**2*Mah2(h1)-8*
     &  a0t4*M22**2*Mah2(h1)+16*aet2*M22**2*Mah2(h1)-2*M22**3*Mah2(h1)+
     &  8*a0t2*a0t4*M22m42*Mah2(h1)+16*a0t4*M22*M42*Mah2(h1)-16*aet2*
     &  M22*M42*Mah2(h1)+16*aet4*M22*M42*Mah2(h1)-22*M22**2*M42*
     &  Mah2(h1)+8*a0t4*M42**2*Mah2(h1)-32*aet2*M42**2*Mah2(h1)+16*
     &  aet4*M42**2*Mah2(h1)+18*M22*M42**2*Mah2(h1)+6*M42**3*Mah2(h1)-
     &  16*M22*M42*I0A12(h1)*Mah2(h1)-16*M42**2*I0A12(h1)*Mah2(h1)+4*
     &  a0t2*M22*Mah2(h1)**2-8*aet2*M22*Mah2(h1)**2-7*M22**2*Mah2(h1)**
     &  2-4*a0t4*M42*Mah2(h1)**2+16*aet2*M42*Mah2(h1)**2-8*aet4*M42*
     &  Mah2(h1)**2+10*M22*M42*Mah2(h1)**2-3*M42**2*Mah2(h1)**2+8*M42*
     &  I0A12(h1)*Mah2(h1)**2+8*A0TNH(h1)*(M22**3+a0t2*M22*M22m42-2*
     &  a0t4*M22*(M22-M42)-2*M22**2*M42+a0t2*M22m42*M42+M22*M42**2-
     &  (M22**2+a0t2*M22m42-M22*M42)*Mah2(h1))+8*I0A11(h1)*((M22-M42)**
     &  3+(-M22**2+3*M22*M42+2*M42**2)*Mah2(h1)-M42*Mah2(h1)**2))/(16.*
     &  M22m42s*alambda6(h1))
       afin(13)=-(4*a0t2*M22**3+8*aet2*M22**3-16*aet4*M22**3+3*M22**4-
     &  8*a0t2*a0t4*M22m42**2-16*a0t2*M22**2*M42-16*aet2*M22**2*M42+40*
     &  aet4*M22**2*M42-16*M22**3*M42-12*a0t4*M22m42**2*M42+20*a0t2*
     &  M22*M42**2+8*aet2*M22*M42**2-32*aet4*M22*M42**2+14*M22**2*M42**
     &  2-8*a0t2*M42**3+8*aet4*M42**3+8*M22*M42**3-9*M42**4+8*M22**3*
     &  I0A11(h1)-24*M22**2*M42*I0A11(h1)+24*M22*M42**2*I0A11(h1)-8*
     &  M42**3*I0A11(h1)-8*a0t2*M22**2*Mah2(h1)-16*aet2*M22**2*Mah2(h1)
     &  +32*aet4*M22**2*Mah2(h1)-6*M22**3*Mah2(h1)+8*a0t2*a0t4*M22m42*
     &  Mah2(h1)-16*a0t2*M22*M42*Mah2(h1)-16*aet2*M22*M42*Mah2(h1)+16*
     &  aet4*M22*M42*Mah2(h1)-18*M22**2*M42*Mah2(h1)+8*a0t2*M42**2*
     &  Mah2(h1)+16*a0t4*M42**2*Mah2(h1)-16*aet4*M42**2*Mah2(h1)+22*
     &  M22*M42**2*Mah2(h1)+2*M42**3*Mah2(h1)-16*M22**2*I0A11(h1)*
     &  Mah2(h1)-24*M22*M42*I0A11(h1)*Mah2(h1)+8*M42**2*I0A11(h1)*
     &  Mah2(h1)+4*a0t2*M22*Mah2(h1)**2+8*aet2*M22*Mah2(h1)**2-16*aet4*
     &  M22*Mah2(h1)**2+3*M22**2*Mah2(h1)**2-4*a0t4*M42*Mah2(h1)**2+8*
     &  aet4*M42*Mah2(h1)**2-10*M22*M42*Mah2(h1)**2+7*M42**2*Mah2(h1)**
     &  2+8*M22*I0A11(h1)*Mah2(h1)**2+8*A0TNH(h1)*(-((M22-M42)*(2*a0t2+
     &  M22-M42)*M42)+a0t4*M22m42*(M22+M42)+(-(a0t4*M22m42)+M42*(-M22+
     &  M42))*Mah2(h1))-8*M22*I0A10(h1)*((M22-M42)**2-2*(M22+M42)*
     &  Mah2(h1)+Mah2(h1)**2))/(16.*M22m42s*alambda6(h1))
       afin(14)=(-8*aet2*M22**3+8*aet4*M22**3+3*M22**4+8*a0t2*a0t4*
     &  M22m42**2+4*a0t2*M22*M22m42**2+4*a0t4*M22*M22m42**2+24*aet2*
     &  M22**2*M42-24*aet4*M22**2*M42+4*M22**3*M42+4*a0t2*M22m42**2*
     &  M42+4*a0t4*M22m42**2*M42-24*aet2*M22*M42**2+24*aet4*M22*M42**2-
     &  14*M22**2*M42**2+8*aet2*M42**3-8*aet4*M42**3+4*M22*M42**3+3*
     &  M42**4+4*M22**2*M42*I0A12(h1)-8*M22*M42**2*I0A12(h1)+4*M42**3*
     &  I0A12(h1)+16*aet2*M22**2*Mah2(h1)-16*aet4*M22**2*Mah2(h1)+2*
     &  M22**3*Mah2(h1)-4*a0t2*M22m42**2*Mah2(h1)-4*a0t4*M22m42**2*
     &  Mah2(h1)-2*M22**2*M42*Mah2(h1)-16*aet2*M42**2*Mah2(h1)+16*aet4*
     &  M42**2*Mah2(h1)-2*M22*M42**2*Mah2(h1)+2*M42**3*Mah2(h1)+4*M22**
     &  2*I0A11(h1)*Mah2(h1)+24*M22*M42*I0A11(h1)*Mah2(h1)+4*M42**2*
     &  I0A11(h1)*Mah2(h1)-8*M22*M42*I0A12(h1)*Mah2(h1)-8*M42**2*
     &  I0A12(h1)*Mah2(h1)-8*aet2*M22*Mah2(h1)**2+8*aet4*M22*Mah2(h1)**
     &  2-5*M22**2*Mah2(h1)**2+8*aet2*M42*Mah2(h1)**2-8*aet4*M42*
     &  Mah2(h1)**2+10*M22*M42*Mah2(h1)**2-5*M42**2*Mah2(h1)**2-4*M22*
     &  I0A11(h1)*Mah2(h1)**2-4*M42*I0A11(h1)*Mah2(h1)**2+4*M42*
     &  I0A12(h1)*Mah2(h1)**2+4*A0TNH(h1)*(M22**3+a0t2*M22*M22m42-3*
     &  a0t4*M22*M22m42-M22**2*M42+3*a0t2*M22m42*M42-a0t4*M22m42*M42-
     &  M22*M42**2+M42**3-(M22**2+a0t2*M22m42-a0t4*M22m42-2*M22*M42+
     &  M42**2)*Mah2(h1))+4*M22*I0A10(h1)*((M22-M42)**2-2*(M22+M42)*
     &  Mah2(h1)+Mah2(h1)**2))/(8.*M22m42s*alambda6(h1))
       afin(15)=(8*a0t4**2*M22m42-32*aet2*M22*M42+64*aet4*M22*M42-12*
     &  M22**2*M42-32*aet4*M42**2-8*M22*M42**2+20*M42**3-8*M22*M42*
     &  A0TNH(h1)+8*M42**2*A0TNH(h1)+32*M22*M42*I0A11(h1)-40*M22*M42*
     &  I0A12(h1)+8*M42**2*I0A12(h1)+8*aet2*M22*Mah2(h1)-16*aet4*M22*
     &  Mah2(h1)+3*M22**2*Mah2(h1)+8*aet4*M42*Mah2(h1)-10*M22*M42*
     &  Mah2(h1)+7*M42**2*Mah2(h1)-8*M22*I0A11(h1)*Mah2(h1)+8*M22*
     &  I0A12(h1)*Mah2(h1)+4*a0t2*M22*(-4*M42+Mah2(h1))-4*a0t4*(2*
     &  M22m42*A0TNH(h1)+M42*(4*M22-8*M42+Mah2(h1))))/(16.*M22m42s*(4*
     &  M42-Mah2(h1)))
       afin(16)=(-8*aet2*M22**3+16*aet4*M22**3-9*M22**4-8*a0t2*a0t4*
     &  M22m42**2-12*a0t2*M22*M22m42**2-8*a0t4*M22*M22m42**2+16*aet2*
     &  M22**2*M42-40*aet4*M22**2*M42+8*M22**3*M42+4*a0t4*M22m42**2*
     &  M42-8*aet2*M22*M42**2+32*aet4*M22*M42**2+14*M22**2*M42**2-8*
     &  aet4*M42**3-16*M22*M42**3+3*M42**4-16*M22**3*I0A12(h1)+40*M22**
     &  2*M42*I0A12(h1)-32*M22*M42**2*I0A12(h1)+8*M42**3*I0A12(h1)+16*
     &  a0t2*M22**2*Mah2(h1)+8*a0t4*M22**2*Mah2(h1)+16*aet2*M22**2*
     &  Mah2(h1)-32*aet4*M22**2*Mah2(h1)+2*M22**3*Mah2(h1)-8*a0t2*a0t4*
     &  M22m42*Mah2(h1)-16*a0t4*M22*M42*Mah2(h1)+16*aet2*M22*M42*
     &  Mah2(h1)-16*aet4*M22*M42*Mah2(h1)+22*M22**2*M42*Mah2(h1)-8*
     &  a0t4*M42**2*Mah2(h1)+16*aet4*M42**2*Mah2(h1)-18*M22*M42**2*
     &  Mah2(h1)-6*M42**3*Mah2(h1)+32*M22**2*I0A12(h1)*Mah2(h1)+16*M22*
     &  M42*I0A12(h1)*Mah2(h1)-16*M42**2*I0A12(h1)*Mah2(h1)-4*a0t2*M22*
     &  Mah2(h1)**2-8*aet2*M22*Mah2(h1)**2+16*aet4*M22*Mah2(h1)**2+7*
     &  M22**2*Mah2(h1)**2+4*a0t4*M42*Mah2(h1)**2-8*aet4*M42*Mah2(h1)**
     &  2-10*M22*M42*Mah2(h1)**2+3*M42**2*Mah2(h1)**2-16*M22*I0A12(h1)*
     &  Mah2(h1)**2+8*M42*I0A12(h1)*Mah2(h1)**2-8*A0TNH(h1)*(M22**3+
     &  a0t2*M22*M22m42-2*a0t4*M22*(M22-M42)-2*M22**2*M42+a0t2*M22m42*
     &  M42+M22*M42**2-(M22**2+a0t2*M22m42-M22*M42)*Mah2(h1))+8*
     &  I0A11(h1)*((M22-M42)**3+(-3*M22**2-3*M22*M42+2*M42**2)*Mah2(h1)
     &  +(2*M22-M42)*Mah2(h1)**2))/(16.*M22m42s*alambda6(h1))
       afin(17)=(-a0t2**2-4*aet2*M22+2*M22**2+M22*A0TNH(h1)+M22*
     &  I0A10(h1)+a0t2*(6*M22+A0TNH(h1)-Mah2(h1))+aet2*Mah2(h1)+M22*
     &  Mah2(h1))/(8*M22**2-2*M22*Mah2(h1))
       afin(18)=(7*M2**10+20*a0t2*M22**4-8*aet2*M22**4+8*a0t2*a0t4*
     &  M22m42**3+4*a0t4*M22*M22m42**3-68*a0t2*M22**3*M42+32*aet2*M22**
     &  3*M42-12*M22**4*M42+84*a0t2*M22**2*M42**2-48*aet2*M22**2*M42**
     &  2-6*M22**3*M42**2-44*a0t2*M22*M42**3+32*aet2*M22*M42**3+20*M22*
     &  *2*M42**3+8*a0t2*M42**4-8*aet2*M42**4-9*M22*M42**4-16*a0t2*
     &  a0t4*M22**2*Mah2(h1)-68*a0t2*M22**3*Mah2(h1)-20*a0t4*M22**3*
     &  Mah2(h1)+32*aet2*M22**3*Mah2(h1)-12*M22**4*Mah2(h1)-24*a0t2*
     &  a0t4*M22*M42*Mah2(h1)+40*a0t2*M22**2*M42*Mah2(h1)+8*a0t4*M22**
     &  2*M42*Mah2(h1)-32*aet2*M22**2*M42*Mah2(h1)-52*M22**3*M42*
     &  Mah2(h1)+24*a0t2*a0t4*M42**2*Mah2(h1)+44*a0t2*M22*M42**2*
     &  Mah2(h1)-4*a0t4*M22*M42**2*Mah2(h1)-32*aet2*M22*M42**2*Mah2(h1)
     &  +28*M22**2*M42**2*Mah2(h1)-32*a0t2*M42**3*Mah2(h1)+32*aet2*M42*
     &  *3*Mah2(h1)+4*M22*M42**3*Mah2(h1)+84*a0t2*M22**2*Mah2(h1)**2+
     &  28*a0t4*M22**2*Mah2(h1)**2-48*aet2*M22**2*Mah2(h1)**2-6*M22**3*
     &  Mah2(h1)**2-24*a0t2*a0t4*M42*Mah2(h1)**2+44*a0t2*M22*M42*
     &  Mah2(h1)**2+20*a0t4*M22*M42*Mah2(h1)**2-32*aet2*M22*M42*
     &  Mah2(h1)**2+28*M22**2*M42*Mah2(h1)**2+48*a0t2*M42**2*Mah2(h1)**
     &  2-48*aet2*M42**2*Mah2(h1)**2+10*M22*M42**2*Mah2(h1)**2+8*a0t2*
     &  a0t4*Mah2(h1)**3-44*a0t2*M22*Mah2(h1)**3-12*a0t4*M22*Mah2(h1)**
     &  3+32*aet2*M22*Mah2(h1)**3+20*M22**2*Mah2(h1)**3-32*a0t2*M42*
     &  Mah2(h1)**3+32*aet2*M42*Mah2(h1)**3+4*M22*M42*Mah2(h1)**3+8*
     &  a0t2*Mah2(h1)**4-8*aet2*Mah2(h1)**4-9*M22*Mah2(h1)**4+8*M22*
     &  I0A11(h1)*((M22-M42)**3+(-3*M22**2+M42**2)*Mah2(h1)+(3*M22+M42)
     &  *Mah2(h1)**2-Mah2(h1)**3)+4*A0TNH(h1)*((M22-M42)*(2*a0t2*(M22**
     &  2-M22*M42-M42**2)+M22*(-2*a0t4*M22+M22**2+4*a0t4*M42-4*M22*M42+
     &  3*M42**2))+(-6*a0t2*(M22**2+M22*M42+M42**2)+M22*(6*a0t4*M22-3*
     &  M22**2+8*a0t4*M42+2*M22*M42+5*M42**2))*Mah2(h1)+(M22*(-4*a0t4+
     &  3*M22-M42)+6*a0t2*(M22+M42))*Mah2(h1)**2-(2*a0t2+M22)*Mah2(h1)*
     &  *3))/(16.*M22*alambda6(h1)**2)
       afin(19)=(-8*aet4*M22**4-8*a0t2*a0t4*M22m42**3+8*a0t4*M22*
     &  M22m42**3+7*M4**10+32*aet4*M22**3*M42-9*M22**4*M42-4*a0t2*
     &  M22m42**3*M42-20*a0t4*M22m42**3*M42-48*aet4*M22**2*M42**2+20*
     &  M22**3*M42**2+32*aet4*M22*M42**3-6*M22**2*M42**3-8*aet4*M42**4-
     &  12*M22*M42**4+24*a0t2*a0t4*M22**2*Mah2(h1)-32*a0t4*M22**3*
     &  Mah2(h1)+32*aet4*M22**3*Mah2(h1)-24*a0t2*a0t4*M22*M42*Mah2(h1)-
     &  4*a0t2*M22**2*M42*Mah2(h1)+44*a0t4*M22**2*M42*Mah2(h1)-32*aet4*
     &  M22**2*M42*Mah2(h1)+4*M22**3*M42*Mah2(h1)-16*a0t2*a0t4*M42**2*
     &  Mah2(h1)+8*a0t2*M22*M42**2*Mah2(h1)+40*a0t4*M22*M42**2*Mah2(h1)
     &  -32*aet4*M22*M42**2*Mah2(h1)+28*M22**2*M42**2*Mah2(h1)-20*a0t2*
     &  M42**3*Mah2(h1)-68*a0t4*M42**3*Mah2(h1)+32*aet4*M42**3*Mah2(h1)
     &  -52*M22*M42**3*Mah2(h1)-12*M42**4*Mah2(h1)-24*a0t2*a0t4*M22*
     &  Mah2(h1)**2+48*a0t4*M22**2*Mah2(h1)**2-48*aet4*M22**2*Mah2(h1)*
     &  *2+20*a0t2*M22*M42*Mah2(h1)**2+44*a0t4*M22*M42*Mah2(h1)**2-32*
     &  aet4*M22*M42*Mah2(h1)**2+10*M22**2*M42*Mah2(h1)**2+28*a0t2*M42*
     &  *2*Mah2(h1)**2+84*a0t4*M42**2*Mah2(h1)**2-48*aet4*M42**2*
     &  Mah2(h1)**2+28*M22*M42**2*Mah2(h1)**2-6*M42**3*Mah2(h1)**2+8*
     &  a0t2*a0t4*Mah2(h1)**3-32*a0t4*M22*Mah2(h1)**3+32*aet4*M22*
     &  Mah2(h1)**3-12*a0t2*M42*Mah2(h1)**3-44*a0t4*M42*Mah2(h1)**3+32*
     &  aet4*M42*Mah2(h1)**3+4*M22*M42*Mah2(h1)**3+20*M42**2*Mah2(h1)**
     &  3+8*a0t4*Mah2(h1)**4-8*aet4*Mah2(h1)**4-9*M42*Mah2(h1)**4+8*
     &  M42*I0A11(h1)*(-(M22-M42)**3+(M22**2-3*M42**2)*Mah2(h1)+(M22+3*
     &  M42)*Mah2(h1)**2-Mah2(h1)**3)+4*A0TNH(h1)*(-((M22-M42)*(-2*
     &  a0t4*(M22**2+M22*M42-M42**2)+M42*(4*a0t2*M22+3*M22**2-2*a0t2*
     &  M42-4*M22*M42+M42**2)))+(M42*(8*a0t2*M22+5*M22**2+6*a0t2*M42+2*
     &  M22*M42-3*M42**2)-6*a0t4*(M22**2+M22*M42+M42**2))*Mah2(h1)+(6*
     &  a0t4*(M22+M42)+M42*(-4*a0t2-M22+3*M42))*Mah2(h1)**2-(2*a0t4+
     &  M42)*Mah2(h1)**3))/(16.*M42*alambda6(h1)**2)
       afin(20)=(-a0t4**2-4*aet4*M42+2*M42**2+M42*A0TNH(h1)+M42*
     &  I0A12(h1)+a0t4*(6*M42+A0TNH(h1)-Mah2(h1))+aet4*Mah2(h1)+M42*
     &  Mah2(h1))/(8*M42**2-2*M42*Mah2(h1))

       selfZ=selfZ+((afin(17)*CS13S13V2(1,1)**2+afin(11)*CS13S13V2(1,2)
     &  *CS13S13V2(2,1)+(afin(2)*CS13S13V2V2(1,1))/4.)*CSSS(h1,1,1)**2+
     &  afin(7)*CS13S13V2(2,1)**2*CSSS(h1,1,2)**2+afin(7)*
     &  CS13S13V2(1,2)**2*CSSS(h1,2,1)**2+(CS13S13V2(1,2)*(afin(12)*
     &  CS13S13V2(1,1)+afin(16)*CS13S13V2(2,2))+(afin(4)*
     &  CS13S13V2V2(1,2))/4.)*CSSS(h1,2,1)*CSSS(h1,2,2)+(afin(15)*
     &  CS13S13V2(1,2)*CS13S13V2(2,1)+afin(20)*CS13S13V2(2,2)**2+
     &  (afin(6)*CS13S13V2V2(2,2))/4.)*CSSS(h1,2,2)**2+CSSS(h1,1,1)*
     &  ((CS13S13V2(2,1)*(afin(10)*CS13S13V2(1,1)+afin(13)*
     &  CS13S13V2(2,2))+(afin(1)*CS13S13V2V2(2,1))/4.)*CSSS(h1,1,2)+
     &  (CS13S13V2(1,2)*(afin(10)*CS13S13V2(1,1)+afin(13)*
     &  CS13S13V2(2,2))+(afin(1)*CS13S13V2V2(1,2))/4.)*CSSS(h1,2,1)+
     &  afin(8)*CS13S13V2(1,2)*CS13S13V2(2,1)*CSSS(h1,2,2))+
     &  CSSS(h1,1,2)*((afin(18)*CS13S13V2(1,1)**2+afin(14)*
     &  CS13S13V2(1,2)*CS13S13V2(2,1)+afin(9)*CS13S13V2(1,1)*
     &  CS13S13V2(2,2)+afin(19)*CS13S13V2(2,2)**2+(afin(5)*
     &  CS13S13V2V2(1,1))/4.+(afin(3)*CS13S13V2V2(2,2))/4.)*
     &  CSSS(h1,2,1)+(CS13S13V2(2,1)*(afin(12)*CS13S13V2(1,1)+afin(16)*
     &  CS13S13V2(2,2))+(afin(4)*CS13S13V2V2(2,1))/4.)*CSSS(h1,2,2)))
       enddo
c
c Neutral Higgs diagrams,(1->5), stop only
c
c neutral Higgs contribution]
c[ neutral Goldstone boson contribution
       afin(1)=-((a0t2**2+2*a0t2*M22+M22*(aet2-aet4+I0A21+2*M22))/(M22*M22m42))
       afin(2)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(2.*M22**2)
       afin(3)=-((-(a0t4*M22)+aet4*M22+2*a0t4*M42-aet4*M42+I0A21*M42+
     &  M22*M42+M42**2+a0t2*(a0t4+M42))/(M22m42*M42))
       afin(4)=(a0t4**2+2*a0t4*M42+M42*(-aet2+aet4+I0A21+2*M42))/(M22m42*M42)
       afin(5)=(a0t4*M22-aet2*M22+I0A21*M22+M22**2+a0t2*(a0t4+2*M22-
     &  M42)+aet2*M42+M22*M42)/(M22*M22m42)
       afin(6)=-(a0t4**2-2*a0t4*M42+2*aet4*M42)/(2.*M42**2)
       afin(7)=-(2*a0t2**2+4*a0t2*a0t4+2*a0t4**2+8*a0t2*M22+4*I0A21*
     &  M22+9*M22**2+8*a0t4*M42+4*I0A21*M42-2*M22*M42+9*M42**2)/(16.*
     &  M22m42s)
       afin(8)=-(2*a0t2**2+4*a0t2*a0t4+2*a0t4**2+8*a0t2*M22+4*I0A21*
     &  M22+9*M22**2+8*a0t4*M42+4*I0A21*M42-2*M22*M42+9*M42**2)/(8.*
     &  M22m42s)
       afin(9)=(-4*a0t2+4*a0t4+M22m42)/(8*M22-8*M42)
       afin(10)=-(4*a0t2*M22*(2*a0t4+3*M22-6*M42)+8*a0t2**2*(M22-2*M42)
     &  +M22*(8*I0A21*M22+13*M22**2+8*aet2*(M22-2*M42)+12*a0t4*M42+8*
     &  aet4*M42-8*I0A21*M42-22*M22*M42+9*M42**2))/(16.*M22*M22m42s)
       afin(11)=(-4*a0t2**2*(M22-3*M42)+4*a0t2*M22*(M22+4*M42)+M22*
     &  (M22**2-8*aet2*(M22-2*M42)+18*M22*M42-M42*(4*a0t4+8*aet4-8*
     &  I0A21+3*M42)))/(16.*M22*M22m42s)
       afin(12)=(8*a0t2*a0t4-8*a0t4**2+12*a0t2*M22+8*a0t4*M22-8*aet2*
     &  M22+8*I0A21*M22+9*M22**2-20*a0t4*M42+16*aet2*M42-8*aet4*M42-8*
     &  I0A21*M42+10*M22*M42-19*M42**2)/(16.*M22m42s)
       afin(13)=(-8*a0t2**2-8*aet2*M22+16*aet4*M22-8*I0A21*M22-19*M22**
     &  2+12*a0t4*M42-8*aet4*M42+8*I0A21*M42+10*M22*M42+9*M42**2+4*
     &  a0t2*(2*a0t4-5*M22+2*M42))/(16.*M22m42s)
       afin(14)=(-4*a0t2**2-4*a0t4**2+4*a0t4*M22m42+4*a0t2*(2*a0t4-M22+
     &  M42)+M22m42*(-8*aet2+8*aet4-5*M22+5*M42))/(8.*M22m42s)
       afin(15)=(4*a0t4**2*(3*M22-M42)+4*a0t4*M42*(4*M22+M42)+M42*(-4*
     &  a0t2*M22-8*aet2*M22+16*aet4*M22+8*I0A21*M22-3*M22**2-8*aet4*
     &  M42+18*M22*M42+M42**2))/(16.*M22m42s*M42)
       afin(16)=(8*a0t4**2*(2*M22-M42)-4*a0t4*M42*(2*a0t2-6*M22+3*M42)+
     &  M42*(-12*a0t2*M22-8*aet2*M22+16*aet4*M22+8*I0A21*M22m42-9*M22*
     &  M22m42-8*aet4*M42+13*M22m42*M42))/(16.*M22m42s*M42)
       afin(17)=-(a0t2**2-2*a0t2*M22+2*aet2*M22)/(4.*M22**2)
       afin(18)=(8*a0t2*a0t4+20*a0t2*M22+4*a0t4*M22-8*aet2*M22+8*I0A21*
     &  M22+7*M22**2-8*a0t2*M42+8*aet2*M42+9*M22*M42)/(16.*M22*M22m42)
       afin(19)=-(8*a0t2*a0t4-8*a0t4*M22+8*aet4*M22+4*a0t2*M42+20*a0t4*
     &  M42-8*aet4*M42+8*I0A21*M42+9*M22*M42+7*M42**2)/(16.*M22m42*M42)
     &  
       afin(20)=-(a0t4**2-2*a0t4*M42+2*aet4*M42)/(4.*M42**2)
       selfZ=selfZ+((afin(17)*CS13S13V2(1,1)**2+afin(11)*CS13S13V2(1,2)
     &  *CS13S13V2(2,1)+(afin(2)*CS13S13V2V2(1,1))/4.)*CSSS(6,1,1)**2+
     &  afin(7)*CS13S13V2(2,1)**2*CSSS(6,1,2)**2+afin(7)*CS13S13V2(1,2)
     &  **2*CSSS(6,2,1)**2+(CS13S13V2(1,2)*(afin(12)*CS13S13V2(1,1)+
     &  afin(16)*CS13S13V2(2,2))+(afin(4)*CS13S13V2V2(1,2))/4.)*
     &  CSSS(6,2,1)*CSSS(6,2,2)+(afin(15)*CS13S13V2(1,2)*CS13S13V2(2,1)
     &  +afin(20)*CS13S13V2(2,2)**2+(afin(6)*CS13S13V2V2(2,2))/4.)*
     &  CSSS(6,2,2)**2+CSSS(6,1,1)*((CS13S13V2(2,1)*(afin(10)*
     &  CS13S13V2(1,1)+afin(13)*CS13S13V2(2,2))+(afin(1)*
     &  CS13S13V2V2(2,1))/4.)*CSSS(6,1,2)+(CS13S13V2(1,2)*(afin(10)*
     &  CS13S13V2(1,1)+afin(13)*CS13S13V2(2,2))+(afin(1)*
     &  CS13S13V2V2(1,2))/4.)*CSSS(6,2,1)+afin(8)*CS13S13V2(1,2)*
     &  CS13S13V2(2,1)*CSSS(6,2,2))+CSSS(6,1,2)*((afin(18)*
     &  CS13S13V2(1,1)**2+afin(14)*CS13S13V2(1,2)*CS13S13V2(2,1)+
     &  afin(9)*CS13S13V2(1,1)*CS13S13V2(2,2)+afin(19)*CS13S13V2(2,2)**
     &  2+(afin(5)*CS13S13V2V2(1,1))/4.+(afin(3)*CS13S13V2V2(2,2))/4.)*
     &  CSSS(6,2,1)+(CS13S13V2(2,1)*(afin(12)*CS13S13V2(1,1)+afin(16)*
     &  CS13S13V2(2,2))+(afin(4)*CS13S13V2V2(2,1))/4.)*CSSS(6,2,2)))

c
c Neutral  Goldstone boson contribution, stop only
c
       afin(1)=-(a0t1**2-4*a0t1*M12+2*aet1*M12+M12**2)/(2.*M12)
       afin(2)=(9*(-4*a0t1+2*aet1+a0t1**2/M12+M12))/2.
       afin(3)=(-3*(a0t1**2-4*a0t1*M12+M12*(2*aet1+M12)))/(2.*M12)
       afin(4)=(7*a0t1)/2.-3*aet1-(3*a0t1**2)/(2.*M12)-(13*M12)/8.
       afin(5)=(21*a0t1)/2.-9*aet1-(9*a0t1**2)/(2.*M12)-(39*M12)/8.
       afin(6)=(9*(-28*a0t1+24*aet1+(12*a0t1**2)/M12+13*M12))/8.
       selfZ=selfZ+(((CW**2*afin(1))/(8.*SW**2)-(SW**2*afin(2))/(72.*
     &  CW**2)+afin(3)/12.)*hy(6)**2+((CW**2*afin(4))/(8.*SW**2)+
     &  afin(5)/12.-(SW**2*afin(6))/(72.*CW**2))*hy(6)*hyc(6)+((CW**2*
     &  afin(1))/(8.*SW**2)-(SW**2*afin(2))/(72.*CW**2)+afin(3)/12.)*
     &  hyc(6)**2)

c
c Neutral  Goldstone boson contribution, top only
c 
c neutral Goldstone boson contribution]
       SelfZ=-((SelfZ)*fac)
#ifdef printMT4
      Write(16,110) "TwoLoopZSelfMSSM[Sum][Nhung]=",selfZ
110   format(A,F24.14)   
#endif
      end subroutine SelfTZZ2L_MT4
c
c======================================================================
c
      subroutine SelfTZZ2L_lambda(selfZ)
      implicit none
      integer imodel,indexdelta(2,2),signf, facZ
      double precision selfZ,selfZCT
      double precision afac,afac2,MSQ, C2W,S2W
#include "TLMT4.h"
#include "TLMT4lambda.h"
#ifdef printMT4
      Write(16,110) "========== Z selfenergy======================================"
#endif
         afac= SW2*CW2/16D0/pi**4/vv2
         afac2= SW2*CW2/16D0/pi**2/vv2
	selfZ=0D0
	selfZCT=0D0
	MSQ=Sqrt(MSQ2); C2W=CW2-SW2; S2W=2*SW*CW
	MSQ=Sqrt(MSQ2)
	signf=1D0
	facZ=1D0
c	   EL= sqrt(MW2)/vv*2*SW
	indexdelta(1,1)=1
	indexdelta(2,2)=1
	indexdelta(1,2)=0
	indexdelta(2,1)=0

       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       selfZ=selfZ+-(CS1S1S1S1(INH4,INH5,INH6,INH6)*CS1S1V2(INH3,INH4)*
     &  CS1S1V2(INH3,INH5)*(4*AETNH(INH6)+A0TNH(INH6)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  Mah2(INH6)))/32.
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       selfZ=selfZ+-(CS1S1S3S3(INH4,INH5,ICH3,ICH3)*CS1S1V2(INH3,INH4)*
     &  CS1S1V2(INH3,INH5)*(4*AETHpN(ICH3)+A0THpN(ICH3)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  MassHpm(ICH3)**2))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=2,2
       do INH3=1,6     
       selfZ=selfZ+-(C2W**2*CS1S1S3S3(INH3,INH3,ICH3,ICH3)*(4*
     &  AETNH(INH3)+A0TNH(INH3)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+Mah2(INH3)*(1+2*
     &  aB0TCH(ICH3,ICH3)+4*aBEpTCH(ICH3,ICH3)+2*
     &  (aC0TCH(ICH3,ICH3,ICH3)+2*aCEpTCH(ICH3,ICH3,ICH3))*
     &  MassHpm(ICH3)**2)))/(16.*S2W**2)
       enddo 
       enddo 
       do ICH3=2,2
       do ICH4=1,2       
       selfZ=selfZ+-(C2W**2*CS3S3S3S3(ICH3,ICH4,ICH3,ICH4)*(4*
     &  AETHpN(ICH4)+A0THpN(ICH4)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+(1+2*aB0TCH(ICH3,ICH3)
     &  +4*aBEpTCH(ICH3,ICH3)+2*(aC0TCH(ICH3,ICH3,ICH3)+2*
     &  aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2)*MassHpm(ICH4)**2))
     &  /(8.*S2W**2)
       enddo 
       enddo 

       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do ISt3=1,2
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then       
       selfZ=selfZ+(-3*CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  CSSSS(INH4,INH5,ISt3,ISt3)*(4*aAETN(ISt3)+aA0TN(ISt3)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  MassSu2(ISt3)))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=2,2
       do ISt3=1,2
       selfZ=selfZ+(-3*C2W**2*CS3S3S13S13(ICH3,ICH3,ISt3,ISt3)*(4*
     &  aAETN(ISt3)+aA0TN(ISt3)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+(1+2*aB0TCH(ICH3,ICH3)
     &  +4*aBEpTCH(ICH3,ICH3)+2*(aC0TCH(ICH3,ICH3,ICH3)+2*
     &  aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2)*MassSu2(ISt3)))/(8.*
     &  S2W**2)
       enddo 
       enddo 

       do ICH3=2,2        
       selfZ=selfZ+(-3*C2W**2*CS3S3S14S14(ICH3,ICH3)*(2*a0t5+4*aet5+
     &  MSQ2+2*(2*a0t5+MSQ2)*aB0TCH(ICH3,ICH3)+4*MSQ2*
     &  aBEpTCH(ICH3,ICH3)+2*((2*a0t5+MSQ2)*aC0TCH(ICH3,ICH3,ICH3)+2*
     &  MSQ2*aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2))/(8.*S2W**2)
       enddo 
c
c topo1-NoGBC
c
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then         
       selfZ=selfZ+-(CS1S1S1S1(INH4,INH5,INH6,INH6)*CS1S1V2(INH3,INH4)*
     &  CS1S1V2(INH3,INH5)*(4*AETNH(INH6)+A0TNH(INH6)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  Mah2(INH6)))/32.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then        
       selfZ=selfZ+-(CS1S1S3S3(INH4,INH5,ICH3,ICH3)*CS1S1V2(INH3,INH4)*
     &  CS1S1V2(INH3,INH5)*(4*AETHpN(ICH3)+A0THpN(ICH3)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  MassHpm(ICH3)**2))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,1
       do INH3=1,6       
       selfZ=selfZ+-(C2W**2*CS1S1S3S3(INH3,INH3,ICH3,ICH3)*(4*
     &  AETNH(INH3)+A0TNH(INH3)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+Mah2(INH3)*(1+2*
     &  aB0TCH(ICH3,ICH3)+4*aBEpTCH(ICH3,ICH3)+2*
     &  (aC0TCH(ICH3,ICH3,ICH3)+2*aCEpTCH(ICH3,ICH3,ICH3))*
     &  MassHpm(ICH3)**2)))/(16.*S2W**2)
       enddo 
       enddo 

       do ICH3=1,1
       do ICH4=1,2       
       selfZ=selfZ+-(C2W**2*CS3S3S3S3(ICH3,ICH4,ICH3,ICH4)*(4*
     &  AETHpN(ICH4)+A0THpN(ICH4)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+(1+2*aB0TCH(ICH3,ICH3)
     &  +4*aBEpTCH(ICH3,ICH3)+2*(aC0TCH(ICH3,ICH3,ICH3)+2*
     &  aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2)*MassHpm(ICH4)**2))
     &  /(8.*S2W**2)
       enddo 
       enddo 

       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do ISt3=1,2
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then       
       selfZ=selfZ+(-3*CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  CSSSS(INH4,INH5,ISt3,ISt3)*(4*aAETN(ISt3)+aA0TN(ISt3)*(2+4*
     &  aB0TNH(INH4,INH5)+4*aC0TNH(INH3,INH4,INH5)*Mah2(INH3))+(1+2*
     &  aB0TNH(INH4,INH5)+4*aBEpTNH(INH4,INH5)+2*
     &  (aC0TNH(INH3,INH4,INH5)+2*aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))*
     &  MassSu2(ISt3)))/16.
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,1
       do ISt3=1,2       
       selfZ=selfZ+(-3*C2W**2*CS3S3S13S13(ICH3,ICH3,ISt3,ISt3)*(4*
     &  aAETN(ISt3)+aA0TN(ISt3)*(2+4*aB0TCH(ICH3,ICH3)+4*
     &  aC0TCH(ICH3,ICH3,ICH3)*MassHpm(ICH3)**2)+(1+2*aB0TCH(ICH3,ICH3)
     &  +4*aBEpTCH(ICH3,ICH3)+2*(aC0TCH(ICH3,ICH3,ICH3)+2*
     &  aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2)*MassSu2(ISt3)))/(8.*
     &  S2W**2)
       enddo 
       enddo 


       do ICH3=1,1        
       selfZ=selfZ+(-3*C2W**2*CS3S3S14S14(ICH3,ICH3)*(2*a0t5+4*aet5+
     &  MSQ2+2*(2*a0t5+MSQ2)*aB0TCH(ICH3,ICH3)+4*MSQ2*
     &  aBEpTCH(ICH3,ICH3)+2*((2*a0t5+MSQ2)*aC0TCH(ICH3,ICH3,ICH3)+2*
     &  MSQ2*aCEpTCH(ICH3,ICH3,ICH3))*MassHpm(ICH3)**2))/(8.*S2W**2)
       enddo 
c
c topo1-GBC
c
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then     
       selfZ=selfZ+-(CS1S1S1S1(INH3,INH4,INH5,INH5)*
     &  CS1S1V2V2(INH3,INH4)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+AETNH(INH5)
     &  +aBEpTNH(INH3,INH4)*Mah2(INH5)))/16.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then        
       selfZ=selfZ+-(CS1S1S3S3(INH3,INH4,ICH3,ICH3)*
     &  CS1S1V2V2(INH3,INH4)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then      
       selfZ=selfZ+-(CS1S1S3S3(INH3,INH3,ICH4,ICH3)*
     &  CS3S3V2V2(ICH3,ICH4)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+AETNH(INH3)
     &  +aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfZ=selfZ+-(CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*
     &  CS3S3V2V2(ICH3,ICH4)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/4.
              endif
       enddo 
       enddo 
       enddo 
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then        
       selfZ=selfZ+(-3*CS1S1V2V2(INH3,INH4)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  (aAETN(ISt3)+aA0TN(ISt3)*aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*
     &  MassSu2(ISt3)))/8.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then         
       selfZ=selfZ+(-3*CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*
     &  CS3S3V2V2(ICH3,ICH4)*(aAETN(ISt3)+aA0TN(ISt3)*aB0TCH(ICH3,ICH4)
     &  +aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/4.
              endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then        
       selfZ=selfZ+(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS3S3S14S14(ICH4,ICH3)*CS3S3V2V2(ICH3,ICH4)
     &  )/4.
              endif
       enddo 
       enddo 
c
c topo9-NoGBC
c
        INH3=6
        INH4=6
       do INH5=1,6
       selfZ=selfZ+-(CS1S1S1S1(INH3,INH4,INH5,INH5)*
     &  CS1S1V2V2(INH3,INH4)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+AETNH(INH5)
     &  +aBEpTNH(INH3,INH4)*Mah2(INH5)))/16.
       enddo 
        INH3=6
        INH4=6
       do ICH3=1,2  
       selfZ=selfZ+-(CS1S1S3S3(INH3,INH4,ICH3,ICH3)*
     &  CS1S1V2V2(INH3,INH4)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/8.
       enddo 
        ICH3=1
        ICH4=1
       do INH3=1,6
       selfZ=selfZ+-(CS1S1S3S3(INH3,INH3,ICH4,ICH3)*
     &  CS3S3V2V2(ICH3,ICH4)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+AETNH(INH3)
     &  +aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/8.
       enddo 
        ICH3=1
        ICH4=1
       do ICH5=1,2
       selfZ=selfZ+-(CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*
     &  CS3S3V2V2(ICH3,ICH4)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/4.
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2  
       selfZ=selfZ+(-3*CS1S1V2V2(INH3,INH4)*CSSSS(INH3,INH4,ISt3,ISt3)*
     &  (aAETN(ISt3)+aA0TN(ISt3)*aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*
     &  MassSu2(ISt3)))/8.
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2
       selfZ=selfZ+(-3*CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*
     &  CS3S3V2V2(ICH3,ICH4)*(aAETN(ISt3)+aA0TN(ISt3)*aB0TCH(ICH3,ICH4)
     &  +aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/4.
       enddo 
        ICH3=1
        ICH4=1
       selfZ=selfZ+(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS3S3S14S14(ICH4,ICH3)*CS3S3V2V2(ICH3,ICH4)
     &  )/4.

c
c topo9-GBC
c


c
c topo10-NoGBC
c
c
c topo10-GBC
c        
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*(CFF12S1L(INH4)*
     &  (CFF12S1R(INH3)*(-FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+
     &  MCha2*CFF12S1L(INH3)*(-FD111ChaHCha(1,INH3)+
     &  FD111ChaHCha(1,INH4)))+CFF12S1R(INH4)*(CFF12S1L(INH3)*(-
     &  FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+MCha2*CFF12S1R(INH3)
     &  *(-FD111ChaHCha(1,INH3)+FD111ChaHCha(1,INH4)))+3*
     &  (FD111THT(2,INH3)-FD111THT(2,INH4)-FD111THT(4,INH3)+
     &  FD111THT(4,INH4))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))-3*
     &  M12*FD111THT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+3*
     &  M12*FD111THT(1,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /(4.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+-(CS1S1V2V2(INH3,INH4)*(CFF12S1R(INH3)*(MCha2*
     &  CFF12S1R(INH4)*FD211HChaCha(1,INH3)+CFF12S1L(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))+CFF12S1L(INH3)*
     &  (MCha2*CFF12S1L(INH4)*FD211HChaCha(1,INH3)+CFF12S1R(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))-3*(FD211HTT(2,INH3)
     &  -FD211HTT(3,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))+3*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /4.
               endif
              endif
       enddo 
       enddo 
        
       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*(-((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe4,INH4)))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(1,INe3,INe4,INH3)-
     &  FD111ChiChiH(1,INe3,INe4,INH4))*MNeu(INe3)*MNeu(INe4)))/(8.*
     &  (Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD211HNeuNeu(2,INH3,INe4,INe3)-
     &  FD211HNeuNeu(3,INH3,INe4,INe3))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4)))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS3S3V2V2(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD111THpB(2,ICH3)-FD111THpB(2,ICH4)-FD111THpB(4,ICH3)+
     &  FD111THpB(4,ICH4)))/(2.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS3S3V2V2(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211HpTB(2,ICH3)-FD211HpTB(3,ICH3)))/2.
               endif
              endif
       enddo 
       enddo
        
       do ICH3=1,2
       do ICH4=1,2
       do INe3=1,3
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+(CS3S3V2V2(ICH3,ICH4)*(-((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(2,INe3,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH4)))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(1,INe3,ICH3)-
     &  FD111ChaChiHp(1,INe3,ICH4))*MNeu(INe3)))/(2.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+(CS3S3V2V2(ICH3,ICH4)*((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(3,ICH3,INe3))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3)))/2.
               endif
              endif
       enddo 
       enddo 
       enddo 

c
c topo11-NoGBC
c
        INH3=6
        INH4=6        
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*(CFF12S1L(INH3)*CFF12S1R(INH4)
     &  *(12*aetcha-12*a0tcha*logx+6*logx**2*MCha2+MCha2*Pi**2+6*
     &  FD111ChaHCha(1,INH3)-12*MCha2*FD211HChaCha(1,INH3))+
     &  CFF12S1L(INH4)*(CFF12S1R(INH3)*(12*aetcha-12*a0tcha*logx+6*
     &  logx**2*MCha2+MCha2*Pi**2+6*FD111ChaHCha(1,INH3))-12*MCha2*
     &  (CFF12S1L(INH3)+CFF12S1R(INH3))*FD211HChaCha(1,INH3))+3*(-4*
     &  MCha2*CFF12S1R(INH3)*CFF12S1R(INH4)*FD211HChaCha(1,INH3)-12*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)+hyc(INH3))*(hy(INH4)+hyc(INH4))+
     &  (12*aet1-12*a0t1*logx+6*logx**2*M12+M12*Pi**2+6*
     &  FD111THT(1,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4)))))
     &  /48.
        INH3=6
        INH4=6
       do INe3=1,3
       do INe4=1,3      
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*(-((CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4))+((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(-12*logx*A0TNeu(INe3)-12*logx*
     &  A0TNeu(INe4)+12*(AETNeu(INe3)+AETNeu(INe4)+
     &  FD111ChiChiH(1,INe3,INe4,INH3))+(6*logx**2+Pi**2-12*
     &  FD211HNeuNeu(1,INH3,INe4,INe3))*(MNeu2(INe3)+MNeu2(INe4))))/24.))/8.
       enddo 
       enddo 
        ICH3=1
        ICH4=1      
       selfZ=selfZ+((3*(2*(aet1+aK0TT)-4*a0t1*(-1+logx)+(-3-(-4+
     &  LogM12)*LogM12+logx**2+logx2)*M12)*
     &  CS3S3V2V2(ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4))/8.)
        ICH3=1
        ICH4=1
       do INe3=1,3        
       selfZ=selfZ+(CS3S3V2V2(ICH3,ICH4)*(-(MCha*(CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3))+((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(12*aetcha-12*a0tcha*logx+6*
     &  logx**2*MCha2+MCha2*Pi**2-12*logx*A0TNeu(INe3)+12*AETNeu(INe3)+
     &  12*FD111ChaChiHp(1,INe3,ICH3)+(6*logx**2+Pi**2)*MNeu2(INe3)-12*
     &  FD211HpChiCha(1,ICH3,INe3)*(MCha2+MNeu2(INe3))))/24.))/2.
       enddo 
c
c topo11-GBC
c       
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
              if( Abs(Mah(INH5) - Mah(INH6)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V2V2(INH5,INH6)*(FD111HHH(1,INH3,INH4,INH5)-
     &  FD111HHH(1,INH3,INH4,INH6)))/(16.*(Mah(INH5)**2-Mah(INH6)**2))
              else
               if( Abs(Mah(INH5)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V2V2(INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/16.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(FD111HpHpH(1,ICH3,ICH4,INH3)-
     &  FD111HpHpH(1,ICH3,ICH4,INH4)))/(8.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S1V2V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*FD211HHpHp(1,INH3,ICH4,ICH3))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
              if( Abs(MassHpm(ICH4) - MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V2V2(ICH4,ICH5)*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH3,ICH3,ICH5)))/(4.*(MassHpm(ICH4)**2-
     &  MassHpm(ICH5)**2))
              else
               if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V2V2(ICH4,ICH5)*FD211HpHpH(1,ICH4,ICH3,INH3))/4.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
       do ISt4=1,2
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS1S1V2V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH4,ISt3,ISt4)))/(8.*(Mah(INH3)**2-Mah(INH4)**2))
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS1S1V2V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/8.
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V2V2(ICH4,ICH3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)))/(4.*(MassHpm(ICH3)**2-MassHpm(ICH4)*
     &  *2))
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V2V2(ICH4,ICH3)*FD211HpSTSB(1,ICH3,ISt3))/4.
               endif
              endif
       enddo 
       enddo 
       enddo 

c
c topo12-NoGBC
c


        INH5=6
        INH6=6
       do INH3=1,6
       do INH4=1,6       
       selfZ=selfZ+(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1V2V2(INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/16.
       enddo 
       enddo 
        ICH4=1
        ICH5=1
       do ICH3=1,2
       do INH3=1,6       
       selfZ=selfZ+(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH5,ICH3)*
     &  CS3S3V2V2(ICH4,ICH5)*FD211HpHpH(1,ICH4,ICH3,INH3))/4.
       enddo 
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2
       selfZ=selfZ+(3*CS1S1V2V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/8.
       enddo 
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2
       selfZ=selfZ+(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  CS3S3V2V2(ICH4,ICH3)*FD211HpSTSB(1,ICH3,ISt3))/4.
       enddo 
c
c topo12-GBC
c
       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
       do INe6=1,3
       do INH3=1,6
          if( Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
          if( Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe6,INe4)*(CFF11S1L(INe5,INe6,INH3)*
     &  (2*CF11F11V2R(INe3,INe5)*(CFF11S1R(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(7,INe3,INe4,INH3)+FD111ChiChiH(7,INe3,INe6,INH3)+
     &  FD111ChiChiH(7,INe4,INe5,INH3)-FD111ChiChiH(7,INe5,INe6,INH3))+
     &  CFF11S1L(INe4,INe3,INH3)*(-FD111ChiChiH(2,INe3,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe6,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3))*MNeu(INe3)*MNeu(INe4))+
     &  CF11F11V2L(INe3,INe5)*(CFF11S1R(INe4,INe3,INH3)*
     &  (FD111ChiChiH(4,INe4,INe3,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)-
     &  FD111ChiChiH(4,INe6,INe3,INH3)+FD111ChiChiH(4,INe6,INe5,INH3))*
     &  MNeu(INe3)+CFF11S1L(INe4,INe3,INH3)*
     &  (FD111ChiChiH(2,INe3,INe4,INH3)-FD111ChiChiH(2,INe3,INe6,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe4))*MNeu(INe5))+CFF11S1R(INe5,INe6,INH3)*
     &  (CF11F11V2L(INe3,INe5)*(CFF11S1R(INe4,INe3,INH3)*
     &  (FD111ChiChiH(2,INe3,INe4,INH3)-FD111ChiChiH(2,INe3,INe6,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe3)+CFF11S1L(INe4,INe3,INH3)*
     &  (FD111ChiChiH(4,INe3,INe4,INH3)-FD111ChiChiH(4,INe3,INe6,INH3)-
     &  FD111ChiChiH(4,INe5,INe4,INH3)+FD111ChiChiH(4,INe5,INe6,INH3))*
     &  MNeu(INe4))-2*CF11F11V2R(INe3,INe5)*(CFF11S1R(INe4,INe3,INH3)*
     &  (FD111ChiChiH(2,INe3,INe4,INH3)-FD111ChiChiH(2,INe3,INe6,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD111ChiChiH(2,INe5,INe6,INH3))+
     &  CFF11S1L(INe4,INe3,INH3)*(FD111ChiChiH(1,INe3,INe4,INH3)-
     &  FD111ChiChiH(1,INe3,INe6,INH3)-FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD111ChiChiH(1,INe5,INe6,INH3))*MNeu(INe3)*MNeu(INe4))*
     &  MNeu(INe5))*MNeu(INe6))+CF11F11V2R(INe6,INe4)*
     &  (CFF11S1R(INe5,INe6,INH3)*(2*CF11F11V2L(INe3,INe5)*
     &  (CFF11S1L(INe4,INe3,INH3)*(-FD111ChiChiH(7,INe3,INe4,INH3)+
     &  FD111ChiChiH(7,INe3,INe6,INH3)+FD111ChiChiH(7,INe4,INe5,INH3)-
     &  FD111ChiChiH(7,INe5,INe6,INH3))+CFF11S1R(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(2,INe3,INe4,INH3)+FD111ChiChiH(2,INe3,INe6,INH3)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4))+CF11F11V2R(INe3,INe5)*
     &  (CFF11S1L(INe4,INe3,INH3)*(FD111ChiChiH(4,INe4,INe3,INH3)-
     &  FD111ChiChiH(4,INe4,INe5,INH3)-FD111ChiChiH(4,INe6,INe3,INH3)+
     &  FD111ChiChiH(4,INe6,INe5,INH3))*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,INH3)*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe6,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD111ChiChiH(2,INe5,INe6,INH3))*MNeu(INe4))*MNeu(INe5))+
     &  CFF11S1L(INe5,INe6,INH3)*(CF11F11V2R(INe3,INe5)*
     &  (CFF11S1L(INe4,INe3,INH3)*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe6,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD111ChiChiH(2,INe5,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,INH3)*(FD111ChiChiH(4,INe3,INe4,INH3)-
     &  FD111ChiChiH(4,INe3,INe6,INH3)-FD111ChiChiH(4,INe5,INe4,INH3)+
     &  FD111ChiChiH(4,INe5,INe6,INH3))*MNeu(INe4))-2*
     &  CF11F11V2L(INe3,INe5)*(CFF11S1L(INe4,INe3,INH3)*
     &  (FD111ChiChiH(2,INe3,INe4,INH3)-FD111ChiChiH(2,INe3,INe6,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD111ChiChiH(2,INe5,INe6,INH3))+
     &  CFF11S1R(INe4,INe3,INH3)*(FD111ChiChiH(1,INe3,INe4,INH3)-
     &  FD111ChiChiH(1,INe3,INe6,INH3)-FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD111ChiChiH(1,INe5,INe6,INH3))*MNeu(INe3)*MNeu(INe4))*
     &  MNeu(INe5))*MNeu(INe6)))/(8.*(MNeu(INe3)**2-MNeu(INe5)**2)*
     &  (MNeu(INe4)**2-MNeu(INe6)**2))+(CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)**4*MNeu2(INe3)+
     &  CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe3)-CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe6)**
     &  4*MNeu2(INe3)-CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)**
     &  4*MNeu2(INe3)+CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)+CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)+8*A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe4)-8*
     &  A0TNeu(INe5)*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe4)+8*A0TNeu(INe3)*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe4)-8*
     &  A0TNeu(INe5)*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe4)-CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe5)**4*MNeu2(INe4)-
     &  CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)**
     &  4*MNeu2(INe4)-12*A0TNeu(INe3)*CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*MNeu2(INe4)-12*
     &  A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)-12*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)*
     &  MNeu2(INe3)*MNeu2(INe4)-12*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+6*
     &  CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)*MNeu2(INe4)+6*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)*
     &  MNeu2(INe4)+4*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)*
     &  MNeu(INe5)*MNeu2(INe3)*MNeu2(INe4)+4*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe5)*MNeu2(INe3)*
     &  MNeu2(INe4)+4*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)*
     &  MNeu(INe6)*MNeu2(INe3)*MNeu2(INe4)+4*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe6)*MNeu2(INe3)*
     &  MNeu2(INe4)+6*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*
     &  MNeu(INe6)*MNeu2(INe3)*MNeu2(INe4)+6*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe6)*MNeu2(INe3)*
     &  MNeu2(INe4)-6*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)-6*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)-6*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2-6*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2+4*A0TNeu(INe4)*(CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*(2*
     &  CF11F11V2R(INe6,INe4)*MNeu(INe4)*MNeu(INe6)-3*
     &  CF11F11V2L(INe6,INe4)*MNeu2(INe4))+CF11F11V2L(INe3,INe5)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*(2*
     &  CF11F11V2L(INe6,INe4)*MNeu(INe4)*MNeu(INe6)-3*
     &  CF11F11V2R(INe6,INe4)*MNeu2(INe4)))*(MNeu2(INe3)-MNeu2(INe5))-
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe5)-CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe5)+CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe6)**
     &  4*MNeu2(INe5)+CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)**
     &  4*MNeu2(INe5)+12*A0TNeu(INe5)*CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu2(INe4)*MNeu2(INe5)+12*
     &  A0TNeu(INe5)*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe4)*
     &  MNeu2(INe5)+12*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)*
     &  MNeu2(INe4)*MNeu2(INe5)+12*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*Mah2(INH3)*MNeu2(INe4)*MNeu2(INe5)-6*
     &  CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe4)*MNeu2(INe5)-6*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe4)*
     &  MNeu2(INe5)-4*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)*
     &  MNeu(INe5)*MNeu2(INe4)*MNeu2(INe5)-4*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe5)*MNeu2(INe4)*
     &  MNeu2(INe5)-4*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)*
     &  MNeu(INe6)*MNeu2(INe4)*MNeu2(INe5)-4*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe6)*MNeu2(INe4)*
     &  MNeu2(INe5)-6*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*
     &  MNeu(INe6)*MNeu2(INe4)*MNeu2(INe5)-6*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe6)*MNeu2(INe4)*
     &  MNeu2(INe5)+6*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe4)**
     &  2*MNeu2(INe5)+6*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe4)**
     &  2*MNeu2(INe5)+6*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe4)*
     &  MNeu2(INe5)**2+6*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe4)*
     &  MNeu2(INe5)**2+(-(CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**
     &  4)-CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)**
     &  4-8*A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)+8*A0TNeu(INe5)*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*MNeu(INe5)-8*A0TNeu(INe3)*
     &  CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*
     &  MNeu(INe5)+8*A0TNeu(INe5)*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe5)+
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe5)**
     &  4+CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)**
     &  4+12*A0TNeu(INe3)*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)+
     &  12*A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe3)+
     &  12*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)*
     &  MNeu2(INe3)+12*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*Mah2(INH3)*
     &  MNeu2(INe3)-6*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-6*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-4*
     &  CF11F11V2L(INe3,INe5)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)*
     &  MNeu(INe5)*MNeu2(INe3)-4*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe5)*MNeu2(INe3)-4*
     &  CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)*
     &  MNeu(INe6)*MNeu2(INe3)-4*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)*MNeu(INe6)*MNeu2(INe3)-6*
     &  CF11F11V2R(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*
     &  MNeu(INe6)*MNeu2(INe3)-6*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)*MNeu(INe6)*MNeu2(INe3)+6*
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)**
     &  2+6*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu2(INe3)**
     &  2+2*(-6*A0TNeu(INe5)*(CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)+CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3))+CF11F11V2L(INe6,INe4)*
     &  (CFF11S1L(INe5,INe6,INH3)*(-6*CF11F11V2R(INe3,INe5)*
     &  CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)+CF11F11V2L(INe3,INe5)*(3*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)+2*CFF11S1L(INe4,INe3,INH3)*
     &  MNeu(INe4))*MNeu(INe5))+CF11F11V2L(INe3,INe5)*
     &  CFF11S1R(INe5,INe6,INH3)*(2*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)
     &  +3*CFF11S1L(INe4,INe3,INH3)*MNeu(INe4))*MNeu(INe6))+
     &  CF11F11V2R(INe6,INe4)*(CFF11S1R(INe5,INe6,INH3)*(-6*
     &  CF11F11V2L(INe3,INe5)*CFF11S1L(INe4,INe3,INH3)*Mah2(INH3)+
     &  CF11F11V2R(INe3,INe5)*(3*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+2*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe4))*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*(2*
     &  CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+3*CFF11S1R(INe4,INe3,INH3)*
     &  MNeu(INe4))*MNeu(INe6)))*MNeu2(INe5)-6*(CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)+CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe6,INH3))*MNeu2(INe5)**2)*MNeu2(INe6)+6*
     &  (CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)+
     &  CF11F11V2L(INe3,INe5)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3))*(MNeu2(INe3)
     &  -MNeu2(INe5))*MNeu2(INe6)**2-4*A0TNeu(INe6)*(MNeu2(INe3)-
     &  MNeu2(INe5))*(CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*(2*CF11F11V2R(INe6,INe4)*MNeu(INe4)*
     &  MNeu(INe6)-3*CF11F11V2L(INe6,INe4)*MNeu2(INe6))+CF11F11V2L(INe3,INe5)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe6,INH3)
     &  *(2*CF11F11V2L(INe6,INe4)*MNeu(INe4)*MNeu(INe6)-3*CF11F11V2R(INe6,INe4)*
     &  MNeu2(INe6))))/(128.*(MNeu2(INe3)-MNeu2(INe5))*(MNeu2(INe4)-MNeu2(INe6))))
              else
       selfZ=selfZ+((CF11F11V2L(INe4,INe4)*(CF11F11V2L(INe3,INe5)*
     &  (CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*(CFF11S1R(INe5,INe4,INH3)*
     &  (FD211ChiChiH(2,INe4,INe3,INH3)-FD211ChiChiH(2,INe4,INe5,INH3))
     &  *MNeu(INe4)+CFF11S1L(INe5,INe4,INH3)*
     &  (FD211ChiChiH(4,INe4,INe3,INH3)-FD211ChiChiH(4,INe4,INe5,INH3))
     &  *MNeu(INe5))+CFF11S1L(INe4,INe3,INH3)*(CFF11S1L(INe5,INe4,INH3)
     &  *(FD211ChiChiH(2,INe4,INe3,INH3)-FD211ChiChiH(2,INe4,INe5,INH3)
     &  )*MNeu(INe4)*MNeu(INe5)+CFF11S1R(INe5,INe4,INH3)*
     &  (FD211ChiChiH(3,INe4,INe3,INH3)-FD211ChiChiH(3,INe4,INe5,INH3))
     &  *MNeu2(INe4)))+2*CF11F11V2R(INe3,INe5)*
     &  (CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(7,INe4,INe3,INH3)+FD211ChiChiH(7,INe4,INe5,INH3))+
     &  CFF11S1L(INe4,INe3,INH3)*(-FD211ChiChiH(2,INe4,INe3,INH3)+
     &  FD211ChiChiH(2,INe4,INe5,INH3))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe5,INe4,INH3)*MNeu(INe5)*(CFF11S1R(INe4,INe3,INH3)*
     &  (-FD211ChiChiH(2,INe4,INe3,INH3)+FD211ChiChiH(2,INe4,INe5,INH3)
     &  )*MNeu(INe4)+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(1,INe4,INe3,INH3)+FD211ChiChiH(1,INe4,INe5,INH3))*
     &  MNeu(INe3)*MNeu2(INe4))))+CF11F11V2R(INe4,INe4)*
     &  (CF11F11V2R(INe3,INe5)*(CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)*
     &  (CFF11S1L(INe5,INe4,INH3)*(FD211ChiChiH(2,INe4,INe3,INH3)-
     &  FD211ChiChiH(2,INe4,INe5,INH3))*MNeu(INe4)+
     &  CFF11S1R(INe5,INe4,INH3)*(FD211ChiChiH(4,INe4,INe3,INH3)-
     &  FD211ChiChiH(4,INe4,INe5,INH3))*MNeu(INe5))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF11S1R(INe5,INe4,INH3)*
     &  (FD211ChiChiH(2,INe4,INe3,INH3)-FD211ChiChiH(2,INe4,INe5,INH3))
     &  *MNeu(INe4)*MNeu(INe5)+CFF11S1L(INe5,INe4,INH3)*
     &  (FD211ChiChiH(3,INe4,INe3,INH3)-FD211ChiChiH(3,INe4,INe5,INH3))
     &  *MNeu2(INe4)))+2*CF11F11V2L(INe3,INe5)*
     &  (CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(7,INe4,INe3,INH3)+FD211ChiChiH(7,INe4,INe5,INH3))+
     &  CFF11S1L(INe5,INe4,INH3)*(-FD211ChiChiH(2,INe4,INe3,INH3)+
     &  FD211ChiChiH(2,INe4,INe5,INH3))*MNeu(INe4)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*(CFF11S1R(INe5,INe4,INH3)*
     &  (-FD211ChiChiH(2,INe4,INe3,INH3)+FD211ChiChiH(2,INe4,INe5,INH3)
     &  )*MNeu(INe4)+CFF11S1L(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(1,INe4,INe3,INH3)+FD211ChiChiH(1,INe4,INe5,INH3))*
     &  MNeu(INe5)*MNeu2(INe4)))))/(8.*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  (4*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe4,INH3)*MNeu(INe3)*
     &  MNeu(INe4)**3*MNeu2(INe3)+4*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe4,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*MNeu(INe3)*MNeu(INe4)**3*MNeu2(INe3)+
     &  2*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe3)+2*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe3)+4*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)**
     &  3*MNeu(INe5)*MNeu2(INe3)+4*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1R(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*MNeu(INe4)**3*MNeu(INe5)*MNeu2(INe3)-
     &  5*CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)-5*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)+8*A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2L(INe4,INe4)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe4)-8*
     &  A0TNeu(INe5)*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe4)+8*A0TNeu(INe3)*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe4)-8*
     &  A0TNeu(INe5)*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe4)-7*CF11F11V2L(INe4,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe5)**4*MNeu2(INe4)-7*
     &  CF11F11V2L(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu(INe5)**
     &  4*MNeu2(INe4)-12*A0TNeu(INe3)*CF11F11V2L(INe4,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*MNeu2(INe4)-24*
     &  A0TNeu(INe4)*CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)+8*A0TNeu(INe4)*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*MNeu2(INe4)+8*A0TNeu(INe4)
     &  *CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)-12*A0TNeu(INe3)*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*MNeu2(INe3)*MNeu2(INe4)-24*
     &  A0TNeu(INe4)*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)-12*CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)*
     &  MNeu2(INe3)*MNeu2(INe4)-12*CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+6*
     &  CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)*MNeu2(INe4)+6*CF11F11V2R(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)*
     &  MNeu2(INe4)+2*CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2-4*CF11F11V2R(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2-4*CF11F11V2L(INe3,INe5)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2+2*CF11F11V2L(INe3,INe5)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe5,INe4,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2-2*((-6*A0TNeu(INe5)*(CF11F11V2L(INe4,INe4)*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)+CF11F11V2L(INe3,INe5)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3))+CF11F11V2L(INe4,INe4)*(-6*
     &  CF11F11V2R(INe3,INe5)*CFF11S1L(INe5,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)+CF11F11V2L(INe3,INe5)*
     &  (CFF11S1R(INe5,INe4,INH3)*MNeu(INe4)*(2*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)+CFF11S1L(INe4,INe3,INH3)*
     &  MNeu(INe4))+CFF11S1L(INe5,INe4,INH3)*(3*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)+2*CFF11S1L(INe4,INe3,INH3)*
     &  MNeu(INe4))*MNeu(INe5)))+CF11F11V2R(INe4,INe4)*(-6*
     &  CF11F11V2L(INe3,INe5)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*Mah2(INH3)+CF11F11V2R(INe3,INe5)*
     &  (CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*(2*
     &  CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+CFF11S1R(INe4,INe3,INH3)*
     &  MNeu(INe4))+CFF11S1R(INe5,INe4,INH3)*(3*
     &  CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+2*CFF11S1R(INe4,INe3,INH3)*
     &  MNeu(INe4))*MNeu(INe5))))*MNeu2(INe4)+4*A0TNeu(INe4)*
     &  (CF11F11V2L(INe3,INe5)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*(CF11F11V2L(INe4,INe4)*MNeu2(INe4)-3*
     &  CF11F11V2R(INe4,INe4)*MNeu2(INe4))+CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*(-3*
     &  CF11F11V2L(INe4,INe4)*MNeu2(INe4)+CF11F11V2R(INe4,INe4)*
     &  MNeu2(INe4)))+MNeu2(INe4)*(CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)*
     &  (CF11F11V2L(INe4,INe4)*MNeu2(INe4)-2*CF11F11V2R(INe4,INe4)*
     &  MNeu2(INe4))+CF11F11V2L(INe3,INe5)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe5,INe4,INH3)*(-2*CF11F11V2L(INe4,INe4)*MNeu2(INe4)+
     &  CF11F11V2R(INe4,INe4)*MNeu2(INe4))))*MNeu2(INe5)+12*
     &  (CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe5)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)+
     &  CF11F11V2L(INe3,INe5)*CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)
     &  *CFF11S1R(INe5,INe4,INH3))*MNeu2(INe4)*MNeu2(INe5)**2)/(128.*MNeu(INe4)**2*(MNeu2(INe3)-MNeu2(INe5))))
              endif
             else
          if( Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2R(INe3,INe3)*(CF11F11V2R(INe6,INe4)*
     &  (CFF11S1L(INe3,INe6,INH3)*(CFF11S1L(INe4,INe3,INH3)*
     &  (FD211ChiChiH(2,INe3,INe4,INH3)-FD211ChiChiH(2,INe3,INe6,INH3))
     &  *MNeu(INe3)+CFF11S1R(INe4,INe3,INH3)*
     &  (FD211ChiChiH(4,INe3,INe4,INH3)-FD211ChiChiH(4,INe3,INe6,INH3))
     &  *MNeu(INe4))*MNeu(INe6)+CFF11S1R(INe3,INe6,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(FD211ChiChiH(2,INe3,INe4,INH3)-
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe4,INe3,INH3)*(FD211ChiChiH(3,INe3,INe4,INH3)-
     &  FD211ChiChiH(3,INe3,INe6,INH3))*MNeu2(INe3)))+2*
     &  CF11F11V2L(INe6,INe4)*(CFF11S1L(INe3,INe6,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD211ChiChiH(7,INe3,INe4,INH3)+
     &  FD211ChiChiH(7,INe3,INe6,INH3))+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe3,INe6,INH3)*MNeu(INe6)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD211ChiChiH(2,INe3,INe4,INH3)+
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1L(INe4,INe3,INH3)*(-FD211ChiChiH(1,INe3,INe4,INH3)+
     &  FD211ChiChiH(1,INe3,INe6,INH3))*MNeu(INe4)*MNeu2(INe3))))+
     &  CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe6,INe4)*
     &  (CFF11S1R(INe3,INe6,INH3)*(CFF11S1R(INe4,INe3,INH3)*
     &  (FD211ChiChiH(2,INe3,INe4,INH3)-FD211ChiChiH(2,INe3,INe6,INH3))
     &  *MNeu(INe3)+CFF11S1L(INe4,INe3,INH3)*
     &  (FD211ChiChiH(4,INe3,INe4,INH3)-FD211ChiChiH(4,INe3,INe6,INH3))
     &  *MNeu(INe4))*MNeu(INe6)+CFF11S1L(INe3,INe6,INH3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(FD211ChiChiH(2,INe3,INe4,INH3)-
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe3,INH3)*(FD211ChiChiH(3,INe3,INe4,INH3)-
     &  FD211ChiChiH(3,INe3,INe6,INH3))*MNeu2(INe3)))+2*
     &  CF11F11V2R(INe6,INe4)*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe6,INH3)*(-FD211ChiChiH(7,INe3,INe4,INH3)+
     &  FD211ChiChiH(7,INe3,INe6,INH3))+CFF11S1L(INe3,INe6,INH3)*(-
     &  FD211ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe6))+CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*
     &  (CFF11S1R(INe3,INe6,INH3)*(-FD211ChiChiH(2,INe3,INe4,INH3)+
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1L(INe3,INe6,INH3)*(-FD211ChiChiH(1,INe3,INe4,INH3)+
     &  FD211ChiChiH(1,INe3,INe6,INH3))*MNeu(INe6)*MNeu2(INe3)))))/(8.*
     &  (MNeu(INe4)**2-MNeu(INe6)**2))+(7*CF11F11V2L(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)*MNeu(INe4)**4*MNeu2(INe3)+7*
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)**
     &  4*MNeu2(INe3)-8*A0TNeu(INe6)*CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)*MNeu(INe4)*MNeu(INe6)*MNeu2(INe3)-8*
     &  A0TNeu(INe6)*CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*
     &  MNeu(INe6)*MNeu2(INe3)-7*CF11F11V2L(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)*MNeu(INe6)**4*MNeu2(INe3)-7*
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe6)**
     &  4*MNeu2(INe3)+2*CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)+2*CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**
     &  4*MNeu2(INe4)+4*CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)**
     &  3*MNeu(INe4)*MNeu2(INe4)+4*CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1R(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**3*MNeu(INe4)*MNeu2(INe4)+
     &  4*CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)**
     &  3*MNeu(INe6)*MNeu2(INe4)+4*CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1R(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)**3*MNeu(INe6)*MNeu2(INe4)-
     &  24*A0TNeu(INe3)*CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)+8*A0TNeu(INe3)*CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)*MNeu2(INe3)*MNeu2(INe4)+8*A0TNeu(INe3)
     &  *CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)-24*A0TNeu(INe3)*CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*MNeu2(INe4)-12*
     &  CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*Mah2(INH3)*
     &  MNeu2(INe3)*MNeu2(INe4)-12*CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+6*
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu(INe4)*
     &  MNeu(INe6)*MNeu2(INe3)*MNeu2(INe4)+6*CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe4)*MNeu(INe6)*MNeu2(INe3)*
     &  MNeu2(INe4)+2*CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)-4*CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)-4*CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)+2*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)**
     &  2*MNeu2(INe4)-12*CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2-12*CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3)*MNeu2(INe3)*
     &  MNeu2(INe4)**2+4*A0TNeu(INe4)*MNeu2(INe3)*
     &  (CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*(2*CF11F11V2R(INe6,INe4)*MNeu(INe4)*
     &  MNeu(INe6)-3*CF11F11V2L(INe6,INe4)*MNeu2(INe4))+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)*(2*CF11F11V2L(INe6,INe4)*MNeu(INe4)*
     &  MNeu(INe6)-3*CF11F11V2R(INe6,INe4)*MNeu2(INe4)))-2*((-6*
     &  A0TNeu(INe6)*(CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)+
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3))+
     &  CF11F11V2L(INe3,INe3)*(-6*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)*Mah2(INH3)+
     &  CF11F11V2L(INe6,INe4)*(CFF11S1L(INe3,INe6,INH3)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)+2*CFF11S1L(INe4,INe3,INH3)
     &  *MNeu(INe4))+CFF11S1R(INe3,INe6,INH3)*(2*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)+3*CFF11S1L(INe4,INe3,INH3)*
     &  MNeu(INe4))*MNeu(INe6)))+CF11F11V2R(INe3,INe3)*(-6*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*Mah2(INH3)+CF11F11V2R(INe6,INe4)*
     &  (CFF11S1R(INe3,INe6,INH3)*MNeu(INe3)*(CFF11S1L(INe4,INe3,INH3)*
     &  MNeu(INe3)+2*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4))+
     &  CFF11S1L(INe3,INe6,INH3)*(2*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)
     &  +3*CFF11S1R(INe4,INe3,INH3)*MNeu(INe4))*MNeu(INe6))))*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*((CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)+CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe6,INe4)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3)-3*(CF11F11V2L(INe3,INe3)*
     &  CF11F11V2R(INe6,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe6,INH3)+CF11F11V2L(INe6,INe4)*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe6,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3))+MNeu2(INe3)*(-2*
     &  (CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe4)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3)+
     &  (CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)+
     &  CF11F11V2L(INe6,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3))
     &  )*MNeu2(INe6)+12*(CF11F11V2L(INe3,INe3)*CF11F11V2R(INe6,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe6,INH3)+CF11F11V2L(INe6,INe4)
     &  *CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe6,INH3)*CFF11S1R(INe4,INe3,INH3))*
     &  MNeu2(INe3)*MNeu2(INe6)**2)/(128.*MNeu(INe3)**2*(MNeu2(INe4)-MNeu2(INe6))))
          else 
       selfZ=selfZ+((-2*(CF11F11V2L(INe3,INe3)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*
     &  FD221ChiChiH(4,INe3,INe4,INH3)+(CF11F11V2L(INe3,INe3)*
     &  (CF11F11V2L(INe4,INe4)-2*CF11F11V2R(INe4,INe4))+
     &  CF11F11V2R(INe3,INe3)*(-2*CF11F11V2L(INe4,INe4)+
     &  CF11F11V2R(INe4,INe4)))*(CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*FD221ChiChiH(2,INe3,INe4,INH3)*
     &  MNeu(INe3)*MNeu(INe4)+(CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe4,INe4)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*FD221ChiChiH(3,INe4,INe3,INH3)*
     &  MNeu2(INe3)+(CF11F11V2L(INe3,INe3)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*
     &  FD221ChiChiH(3,INe3,INe4,INH3)*MNeu2(INe4)-2*
     &  (CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*
     &  FD221ChiChiH(1,INe3,INe4,INH3)*MNeu2(INe3)*MNeu2(INe4))/8.+(2*
     &  (CF11F11V2L(INe3,INe3)*CF11F11V2L(INe4,INe4)+
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe4,INe4))*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH3)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*MNeu(INe3)*
     &  MNeu(INe4)-(CF11F11V2R(INe3,INe3)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe4,INe4)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*(-4*
     &  A0TNeu(INe3)+MNeu2(INe3))-(CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*(-4*A0TNeu(INe4)+MNeu2(INe4))-2*
     &  (CF11F11V2L(INe3,INe3)*CF11F11V2R(INe4,INe4)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe4,INe4)*CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))*(8*
     &  A0TNeu(INe3)+8*A0TNeu(INe4)+4*A0TNH(INH3)+3*Mah2(INH3)+2*
     &  (MNeu2(INe3)+MNeu2(INe4)))+(CF11F11V2L(INe3,INe3)*
     &  CF11F11V2R(INe4,INe4)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2L(INe4,INe4)*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))
     &  *(4*A0TNeu(INe3)+4*A0TNeu(INe4)+8*A0TNH(INH3)+5*(MNeu2(INe3)+MNeu2(INe4))))/64.)
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       ! diagram 2
       do INH3=1,6
       selfZ=selfZ+(((CF12F12V2L**2-4*CF12F12V2L*CF12F12V2R+CF12F12V2R*
     &  *2)*MCha2*CFF12S1L(INH3)**2*FD221ChaChaH(2,INH3)+(CF12F12V2L**
     &  2-4*CF12F12V2L*CF12F12V2R+CF12F12V2R**2)*MCha2*CFF12S1R(INH3)**
     &  2*FD221ChaChaH(2,INH3)+2*CFF12S1L(INH3)*CFF12S1R(INH3)*(-2*
     &  CF12F12V2L*CF12F12V2R*MCha2**2*FD221ChaChaH(1,INH3)+
     &  (CF12F12V2L**2+CF12F12V2R**2)*MCha2*FD221ChaChaH(3,INH3)-2*
     &  CF12F12V2L*CF12F12V2R*FD221ChaChaH(4,INH3)))/4.+((CF12F12V2L**
     &  2+CF12F12V2R**2)*MCha2*CFF12S1L(INH3)**2+(CF12F12V2L**2+
     &  CF12F12V2R**2)*MCha2*CFF12S1R(INH3)**2+CFF12S1L(INH3)*
     &  CFF12S1R(INH3)*(4*a0tcha*(CF12F12V2L**2-6*CF12F12V2L*
     &  CF12F12V2R+CF12F12V2R**2)+2*CF12F12V2L*CF12F12V2R*MCha2-
     &  (CF12F12V2L**2+CF12F12V2R**2)*MCha2-6*CF12F12V2L*CF12F12V2R*
     &  Mah2(INH3)))/16.)
       enddo 
       ! diagram 3
       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
       selfZ=selfZ+(((CF11F11V2L(INe4,INe3)-CF11F11V2R(INe3,INe4))*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(CF11F12S3R(INe3,ICH3)*
     &  (CF12F12V2L*MCha2*(FD211ChaChiHp(3,INe3,ICH3)-
     &  FD211ChaChiHp(3,INe4,ICH3))+2*CF12F12V2R*(-
     &  FD211ChaChiHp(7,INe3,ICH3)+FD211ChaChiHp(7,INe4,ICH3)))+
     &  (CF12F12V2L-2*CF12F12V2R)*MCha*CF11F12S3L(INe3,ICH3)*
     &  (FD211ChaChiHp(2,INe3,ICH3)-FD211ChaChiHp(2,INe4,ICH3))*
     &  MNeu(INe3))+DCONJG(CF11F12S3L(INe4,ICH3))*((CF12F12V2L-2*
     &  CF12F12V2R)*MCha*CF11F12S3R(INe3,ICH3)*
     &  (FD211ChaChiHp(2,INe3,ICH3)-FD211ChaChiHp(2,INe4,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*(2*CF12F12V2R*MCha2*(-
     &  FD211ChaChiHp(1,INe3,ICH3)+FD211ChaChiHp(1,INe4,ICH3))+
     &  CF12F12V2L*(FD211ChaChiHp(4,INe3,ICH3)-
     &  FD211ChaChiHp(4,INe4,ICH3)))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F11V2R(INe4,INe3)*(DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CF11F12S3L(INe3,ICH3)*(CF12F12V2R*MCha2*
     &  (FD211ChaChiHp(3,INe3,ICH3)-FD211ChaChiHp(3,INe4,ICH3))+2*
     &  CF12F12V2L*(-FD211ChaChiHp(7,INe3,ICH3)+
     &  FD211ChaChiHp(7,INe4,ICH3)))+(-2*CF12F12V2L+CF12F12V2R)*MCha*
     &  CF11F12S3R(INe3,ICH3)*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3))*MNeu(INe3))+
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(-((2*CF12F12V2L-CF12F12V2R)*
     &  MCha*CF11F12S3L(INe3,ICH3)*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3)))+CF11F12S3R(INe3,ICH3)*(2*
     &  CF12F12V2L*MCha2*(-FD211ChaChiHp(1,INe3,ICH3)+
     &  FD211ChaChiHp(1,INe4,ICH3))+CF12F12V2R*
     &  (FD211ChaChiHp(4,INe3,ICH3)-FD211ChaChiHp(4,INe4,ICH3)))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F11V2L(INe3,INe4)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(CF11F12S3L(INe3,ICH3)*
     &  (CF12F12V2R*MCha2*(-FD211ChaChiHp(3,INe3,ICH3)+
     &  FD211ChaChiHp(3,INe4,ICH3))+2*CF12F12V2L*
     &  (FD211ChaChiHp(7,INe3,ICH3)-FD211ChaChiHp(7,INe4,ICH3)))+(2*
     &  CF12F12V2L-CF12F12V2R)*MCha*CF11F12S3R(INe3,ICH3)*
     &  (FD211ChaChiHp(2,INe3,ICH3)-FD211ChaChiHp(2,INe4,ICH3))*
     &  MNeu(INe3))+DCONJG(CF11F12S3R(INe4,ICH3))*((2*CF12F12V2L-
     &  CF12F12V2R)*MCha*CF11F12S3L(INe3,ICH3)*
     &  (FD211ChaChiHp(2,INe3,ICH3)-FD211ChaChiHp(2,INe4,ICH3))+
     &  CF11F12S3R(INe3,ICH3)*(2*CF12F12V2L*MCha2*
     &  (FD211ChaChiHp(1,INe3,ICH3)-FD211ChaChiHp(1,INe4,ICH3))+
     &  CF12F12V2R*(-FD211ChaChiHp(4,INe3,ICH3)+
     &  FD211ChaChiHp(4,INe4,ICH3)))*MNeu(INe3))*MNeu(INe4)))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+(4*A0TNeu(INe3)*(-
     &  ((CF11F11V2L(INe3,INe4)-CF11F11V2R(INe4,INe3))*(2*CF12F12V2R*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)-3*CF12F12V2L*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu2(INe3)))+
     &  CF11F11V2L(INe4,INe3)*(2*CF12F12V2L*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)-3*
     &  CF12F12V2R*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu2(INe3))+CF11F11V2R(INe3,INe4)*(-2*CF12F12V2L*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)+3*CF12F12V2R*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu2(INe3)))-4*A0TNeu(INe4)*(-
     &  ((CF11F11V2L(INe3,INe4)-CF11F11V2R(INe4,INe3))*(2*CF12F12V2R*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)-3*CF12F12V2L*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu2(INe4)))+
     &  CF11F11V2L(INe4,INe3)*(2*CF12F12V2L*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)-3*
     &  CF12F12V2R*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu2(INe4))+CF11F11V2R(INe3,INe4)*(-2*CF12F12V2L*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)+3*CF12F12V2R*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu2(INe4)))+
     &  CF11F11V2R(INe4,INe3)*(2*CF12F12V2R*CF11F12S3R(INe3,ICH3)*
     &  MNeu(INe3)*(2*MCha*DCONJG(CF11F12S3L(INe4,ICH3))+3*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4))*(MNeu2(INe3)-
     &  MNeu2(INe4))+CF11F12S3L(INe3,ICH3)*(4*CF12F12V2R*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(MNeu2(INe3)-
     &  MNeu2(INe4))+DCONJG(CF11F12S3L(INe4,ICH3))*(-3*CF12F12V2L*
     &  MNeu(INe3)**4+3*CF12F12V2L*MNeu(INe4)**4-2*(MNeu2(INe3)-
     &  MNeu2(INe4))*(12*a0tcha*CF12F12V2L-4*a0tcha*CF12F12V2R-
     &  CF12F12V2L*MCha2+CF12F12V2R*MCha2+CF12F12V2L*(6*MassHpm(ICH3)**
     &  2+MNeu2(INe3)+MNeu2(INe4))))))+CF11F11V2L(INe3,INe4)*(-2*
     &  CF12F12V2R*CF11F12S3R(INe3,ICH3)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+3*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe4))*(MNeu2(INe3)-MNeu2(INe4))+CF11F12S3L(INe3,ICH3)*(4*
     &  CF12F12V2R*MCha*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  MNeu2(INe3)+MNeu2(INe4))+DCONJG(CF11F12S3L(INe4,ICH3))*(3*
     &  CF12F12V2L*MNeu(INe3)**4-3*CF12F12V2L*MNeu(INe4)**4+2*
     &  (MNeu2(INe3)-MNeu2(INe4))*(12*a0tcha*CF12F12V2L-4*a0tcha*
     &  CF12F12V2R-CF12F12V2L*MCha2+CF12F12V2R*MCha2+CF12F12V2L*(6*
     &  MassHpm(ICH3)**2+MNeu2(INe3)+MNeu2(INe4))))))-
     &  (CF11F11V2L(INe4,INe3)-CF11F11V2R(INe3,INe4))*(-2*CF12F12V2L*
     &  CF11F12S3L(INe3,ICH3)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))+3*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe4))*(MNeu2(INe3)-MNeu2(INe4))+CF11F12S3R(INe3,ICH3)*(4*
     &  CF12F12V2L*MCha*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  MNeu2(INe3)+MNeu2(INe4))+DCONJG(CF11F12S3R(INe4,ICH3))*(3*
     &  CF12F12V2R*MNeu(INe3)**4-3*CF12F12V2R*MNeu(INe4)**4+2*
     &  (MNeu2(INe3)-MNeu2(INe4))*(-4*a0tcha*CF12F12V2L+12*a0tcha*
     &  CF12F12V2R+CF12F12V2L*MCha2-CF12F12V2R*MCha2+CF12F12V2R*
     &  (6*MassHpm(ICH3)**2+MNeu2(INe3)+MNeu2(INe4)))))))/(64.*(MNeu2(INe3)-MNeu2(INe4))))
              else
       selfZ=selfZ+(((CF11F11V2L(INe3,INe3)-CF11F11V2R(INe3,INe3))*(16*
     &  A0TNeu(INe3)*(CF12F12V2L*Abs(CF11F12S3L(INe3,ICH3))**2-
     &  CF12F12V2R*Abs(CF11F12S3R(INe3,ICH3))**2)*MNeu2(INe3)+
     &  MNeu2(INe3)*(2*(CF12F12V2L-CF12F12V2R)*MCha*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  +Abs(CF11F12S3L(INe3,ICH3))**2*(12*a0tcha*CF12F12V2L-4*a0tcha*
     &  CF12F12V2R-CF12F12V2L*MCha2+CF12F12V2R*MCha2-CF12F12V2L*(-6*
     &  MassHpm(ICH3)**2+2*MNeu2(INe3)))+Abs(CF11F12S3R(INe3,ICH3))**2*
     &  (4*a0tcha*(CF12F12V2L-3*CF12F12V2R)-CF12F12V2L*MCha2+
     &  CF12F12V2R*MCha2+CF12F12V2R*(-6*MassHpm(ICH3)**2+2*MNeu2(INe3))
     &  ))))/(32.*MNeu(INe3)**2)+((CF11F11V2L(INe3,INe3)-
     &  CF11F11V2R(INe3,INe3))*(CF11F12S3L(INe3,ICH3)*(3*(CF12F12V2L-
     &  CF12F12V2R)*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChaChiHp(2,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-(CF12F12V2R*MCha2*
     &  (FD221ChaChiHp(5,INe3,ICH3)+2*FD221ChaChiHp(1,INe3,ICH3)*
     &  MNeu2(INe3)))+CF12F12V2L*(2*FD221ChaChiHp(4,INe3,ICH3)+
     &  FD221ChaChiHp(3,INe3,ICH3)*MNeu2(INe3))))+CF11F12S3R(INe3,ICH3)
     &  *(3*(CF12F12V2L-CF12F12V2R)*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChaChiHp(2,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(CF12F12V2L*MCha2*
     &  (FD221ChaChiHp(5,INe3,ICH3)+2*FD221ChaChiHp(1,INe3,ICH3)*
     &  MNeu2(INe3))-CF12F12V2R*(2*FD221ChaChiHp(4,INe3,ICH3)+
     &  FD221ChaChiHp(3,INe3,ICH3)*MNeu2(INe3))))))/4.)
              endif
       enddo 
       enddo 
       enddo 

        !diagram 4-7
       do INe3=1,3
       do INe4=1,3
       do ISt3=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
       selfZ=selfZ+(((CF11F11V2L(INe4,INe3)-CF11F11V2R(INe3,INe4))*
     &  (CF11FSR(INe3,ISt3)*(CF11FSRC(INe4,ISt3)*(M12*(3*CW**2-SW2)*
     &  FD211TChiSt(3,INe3,ISt3)+M12*(-3*CW**2+SW2)*
     &  FD211TChiSt(3,INe4,ISt3)+8*SW2*(FD211TChiSt(7,INe3,ISt3)-
     &  FD211TChiSt(7,INe4,ISt3)))+M1*(3*CW**2+7*SW2)*
     &  CF11FSLC(INe4,ISt3)*(FD211TChiSt(2,INe3,ISt3)-
     &  FD211TChiSt(2,INe4,ISt3))*MNeu(INe4))+CF11FSL(INe3,ISt3)*
     &  MNeu(INe3)*(M1*(3*CW**2+7*SW2)*CF11FSRC(INe4,ISt3)*
     &  (FD211TChiSt(2,INe3,ISt3)-FD211TChiSt(2,INe4,ISt3))+
     &  CF11FSLC(INe4,ISt3)*(8*M12*SW2*FD211TChiSt(1,INe3,ISt3)-8*M12*
     &  SW2*FD211TChiSt(1,INe4,ISt3)+(3*CW**2-SW2)*
     &  (FD211TChiSt(4,INe3,ISt3)-FD211TChiSt(4,INe4,ISt3)))*MNeu(INe4)
     &  ))+2*CF11F11V2L(INe3,INe4)*(CF11FSL(INe3,ISt3)*
     &  (CF11FSLC(INe4,ISt3)*(2*M12*SW2*FD211TChiSt(3,INe3,ISt3)-2*M12*
     &  SW2*FD211TChiSt(3,INe4,ISt3)+(3*CW**2-SW2)*
     &  (FD211TChiSt(7,INe3,ISt3)-FD211TChiSt(7,INe4,ISt3)))+M1*(3*CW**
     &  2+SW2)*CF11FSRC(INe4,ISt3)*(FD211TChiSt(2,INe3,ISt3)-
     &  FD211TChiSt(2,INe4,ISt3))*MNeu(INe4))+CF11FSR(INe3,ISt3)*
     &  MNeu(INe3)*(M1*(3*CW**2+SW2)*CF11FSLC(INe4,ISt3)*
     &  (FD211TChiSt(2,INe3,ISt3)-FD211TChiSt(2,INe4,ISt3))+
     &  CF11FSRC(INe4,ISt3)*(M12*(3*CW**2-SW2)*FD211TChiSt(1,INe3,ISt3)
     &  +M12*(-3*CW**2+SW2)*FD211TChiSt(1,INe4,ISt3)+2*SW2*
     &  (FD211TChiSt(4,INe3,ISt3)-FD211TChiSt(4,INe4,ISt3)))*MNeu(INe4)
     &  ))-2*CF11F11V2R(INe4,INe3)*(CF11FSL(INe3,ISt3)*
     &  (CF11FSLC(INe4,ISt3)*(2*M12*SW2*FD211TChiSt(3,INe3,ISt3)-2*M12*
     &  SW2*FD211TChiSt(3,INe4,ISt3)+(3*CW**2-SW2)*
     &  (FD211TChiSt(7,INe3,ISt3)-FD211TChiSt(7,INe4,ISt3)))+M1*(3*CW**
     &  2+SW2)*CF11FSRC(INe4,ISt3)*(FD211TChiSt(2,INe3,ISt3)-
     &  FD211TChiSt(2,INe4,ISt3))*MNeu(INe4))+CF11FSR(INe3,ISt3)*
     &  MNeu(INe3)*(M1*(3*CW**2+SW2)*CF11FSLC(INe4,ISt3)*
     &  (FD211TChiSt(2,INe3,ISt3)-FD211TChiSt(2,INe4,ISt3))+
     &  CF11FSRC(INe4,ISt3)*(M12*(3*CW**2-SW2)*FD211TChiSt(1,INe3,ISt3)
     &  +M12*(-3*CW**2+SW2)*FD211TChiSt(1,INe4,ISt3)+2*SW2*
     &  (FD211TChiSt(4,INe3,ISt3)-FD211TChiSt(4,INe4,ISt3)))*MNeu(INe4)
     &  )))/(8.*CW*SW*(MNeu(INe3)**2-MNeu(INe4)**2))+(9*CW**2*M12*
     &  CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)**4-3*M12*SW2*CF11F11V2L(INe3,INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)**4-9*CW**2*
     &  M12*CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)**4+3*M12*SW2*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)**4+12*M12*SW2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**4-12*M12*
     &  SW2*CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)**4+24*CW**2*M12*A0TNeu(INe3)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-8*M12*SW2*A0TNeu(INe3)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-24*CW**2*M12*A0TNeu(INe4)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)+8*M12*SW2*A0TNeu(INe4)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-24*CW**2*M12*A0TNeu(INe3)*
     &  CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)+8*M12*SW2*A0TNeu(INe3)*
     &  CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)+24*CW**2*M12*A0TNeu(INe4)*
     &  CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-8*M12*SW2*A0TNeu(INe4)*
     &  CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)+32*M12*SW2*A0TNeu(INe3)*
     &  CF11F11V2L(INe3,INe4)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-32*M12*SW2*A0TNeu(INe4)*
     &  CF11F11V2L(INe3,INe4)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-32*M12*SW2*A0TNeu(INe3)*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)+32*M12*SW2*A0TNeu(INe4)*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)-9*CW**2*M12*CF11F11V2L(INe3,INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe4)**4+3*M12*SW2*
     &  CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe4)**4+9*CW**2*M12*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe4)**4-3*M12*SW2*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe4)**4-12*M12*SW2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe4)**4+12*M12*
     &  SW2*CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)**4+72*a0t1*CW**2*M12*
     &  CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu2(INe3)-6*CW**2*M12**2*CF11F11V2L(INe3,INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu2(INe3)+8*a0t1*M12*
     &  SW2*CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)-6*M12**2*SW2*
     &  CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu2(INe3)+36*CW**2*M12*A0TNeu(INe3)*CF11F11V2L(INe3,INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu2(INe3)-12*M12*SW2*
     &  A0TNeu(INe3)*CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)-72*a0t1*CW**2*M12*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu2(INe3)+6*CW**2*M12**2*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu2(INe3)-8*a0t1*M12*
     &  SW2*CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)+6*M12**2*SW2*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu2(INe3)-36*CW**2*M12*A0TNeu(INe3)*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu2(INe3)+12*M12*SW2*
     &  A0TNeu(INe3)*CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)+24*a0t1*CW**2*M12*
     &  CF11F11V2L(INe4,INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu2(INe3)-6*CW**2*M12**2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu2(INe3)+88*a0t1*M12*
     &  SW2*CF11F11V2L(INe4,INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu2(INe3)-6*M12**2*SW2*
     &  CF11F11V2L(INe4,INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu2(INe3)+48*M12*SW2*A0TNeu(INe3)*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu2(INe3)-24*a0t1*CW**
     &  2*M12*CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu2(INe3)+6*CW**2*M12**2*
     &  CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu2(INe3)-88*a0t1*M12*SW2*CF11F11V2R(INe3,INe4)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu2(INe3)+6*M12**2*
     &  SW2*CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu2(INe3)-48*M12*SW2*A0TNeu(INe3)*
     &  CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu2(INe3)+36*CW**2*M12*CF11F11V2L(INe3,INe4)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe3)-12*M12*SW2*CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)
     &  *CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*MNeu2(INe3)-36*CW**2*M12*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)+12*M12*SW2*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe3)+48*M12*SW2*CF11F11V2L(INe4,INe3)*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*MNeu2(INe3)-48*M12*SW2*
     &  CF11F11V2R(INe3,INe4)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)+16*M1*M12*SW2*CF11F11V2L(INe3,INe4)*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  16*M1*M12*SW2*CF11F11V2R(INe4,INe3)*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)+12*CW**2*M1*M12*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)-4*M1*M12*SW2*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  12*CW**2*M1*M12*CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)+4*M1*M12*SW2*
     &  CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)+12*CW**2*M1*M12*CF11F11V2L(INe4,INe3)*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)-
     &  4*M1*M12*SW2*CF11F11V2L(INe4,INe3)*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)-12*CW**2*M1*M12*
     &  CF11F11V2R(INe3,INe4)*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  MNeu(INe4)*MNeu2(INe3)+4*M1*M12*SW2*CF11F11V2R(INe3,INe4)*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)+
     &  16*M1*M12*SW2*CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)*MNeu2(INe3)-16*M1*M12*SW2*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe4)*MNeu2(INe3)+18*CW**2*M12*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)-6*M12*SW2*CF11F11V2L(INe4,INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-18*CW**2*
     &  M12*CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+6*M12*
     &  SW2*CF11F11V2R(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+24*M12*
     &  SW2*CF11F11V2L(INe3,INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-24*M12*
     &  SW2*CF11F11V2R(INe4,INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+6*CW**2*
     &  M12*CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)**2-2*M12*SW2*
     &  CF11F11V2L(INe3,INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu2(INe3)**2-6*CW**2*M12*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu2(INe3)**2+2*M12*
     &  SW2*CF11F11V2R(INe4,INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu2(INe3)**2+8*M12*SW2*
     &  CF11F11V2L(INe4,INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu2(INe3)**2-8*M12*SW2*CF11F11V2R(INe3,INe4)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu2(INe3)**2+2*(-
     &  ((CF11F11V2L(INe4,INe3)-CF11F11V2R(INe3,INe4))*(M12*(3*CW**2-
     &  SW2)*CF11FSL(INe3,ISt3)*MNeu(INe3)*(2*M1*CF11FSRC(INe4,ISt3)+3*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe4))+CF11FSR(INe3,ISt3)*
     &  (CF11FSRC(INe4,ISt3)*(3*CW**2*(4*a0t1-M12)*M12+(44*a0t1*M12-3*
     &  M12**2)*SW2+24*M12*SW2*(A0TNeu(INe4)+MassSu2(ISt3)))+2*M1*M12*
     &  (3*CW**2-SW2)*CF11FSLC(INe4,ISt3)*MNeu(INe4))))+
     &  CF11F11V2L(INe3,INe4)*(-4*M12*SW2*CF11FSR(INe3,ISt3)*MNeu(INe3)
     &  *(2*M1*CF11FSLC(INe4,ISt3)+3*CF11FSRC(INe4,ISt3)*MNeu(INe4))+
     &  CF11FSL(INe3,ISt3)*(CF11FSLC(INe4,ISt3)*(3*CW**2*M12*(-12*a0t1+
     &  M12)-(16*a0t1*M12+M12**2-4*M12*(3*a0t1+M12))*SW2-6*M12*(3*CW**
     &  2-SW2)*(A0TNeu(INe4)+MassSu2(ISt3)))-8*M1*M12*SW2*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)))+CF11F11V2R(INe4,INe3)*(4*M12*
     &  SW2*CF11FSR(INe3,ISt3)*MNeu(INe3)*(2*M1*CF11FSLC(INe4,ISt3)+3*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4))+CF11FSL(INe3,ISt3)*
     &  (CF11FSLC(INe4,ISt3)*(3*CW**2*(12*a0t1-M12)*M12+(16*a0t1*M12+
     &  M12**2-4*M12*(3*a0t1+M12))*SW2+6*M12*(3*CW**2-SW2)*
     &  (A0TNeu(INe4)+MassSu2(ISt3)))+8*M1*M12*SW2*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe4))))*MNeu2(INe4)+2*M12*(-((3*CW**2-SW2)*
     &  (CF11F11V2L(INe3,INe4)-CF11F11V2R(INe4,INe3))*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3))+4*SW2*(-
     &  CF11F11V2L(INe4,INe3)+CF11F11V2R(INe3,INe4))*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe4,ISt3))*MNeu2(INe4)**2)/(128.*CW*M12*SW*(MNeu2(INe3)-MNeu2(INe4))))
              else
       selfZ=selfZ+(((CF11F11V2L(INe3,INe3)-CF11F11V2R(INe3,INe3))*
     &  (CF11FSL(INe3,ISt3)*(9*M1*(CW**2+SW2)*CF11FSRC(INe3,ISt3)*
     &  FD221TChiSt(2,INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*((6*CW*
     &  *2-2*SW2)*FD221TChiSt(4,INe3,ISt3)+4*M12*SW2*
     &  FD221TChiSt(5,INe3,ISt3)+(8*M12*SW2*FD221TChiSt(1,INe3,ISt3)+
     &  (3*CW**2-SW2)*FD221TChiSt(3,INe3,ISt3))*MNeu2(INe3)))+
     &  CF11FSR(INe3,ISt3)*(9*M1*(CW**2+SW2)*CF11FSLC(INe3,ISt3)*
     &  FD221TChiSt(2,INe3,ISt3)*MNeu(INe3)+CF11FSRC(INe3,ISt3)*(8*SW2*
     &  FD221TChiSt(4,INe3,ISt3)+M12*(3*CW**2-SW2)*
     &  FD221TChiSt(5,INe3,ISt3)+2*(M12*(3*CW**2-SW2)*
     &  FD221TChiSt(1,INe3,ISt3)+2*SW2*FD221TChiSt(3,INe3,ISt3))*
     &  MNeu2(INe3)))))/(8.*CW*SW)-((CF11F11V2L(INe3,INe3)-
     &  CF11F11V2R(INe3,INe3))*(-16*M12*A0TNeu(INe3)*((3*CW**2-SW2)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt3)+4*SW2*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe3,ISt3))*MNeu2(INe3)-MNeu2(INe3)*
     &  (CF11FSL(INe3,ISt3)*(6*M1*M12*(CW**2+SW2)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)+CF11FSLC(INe3,ISt3)*(3*CW**2*(12*a0t1-M12)*M12+(16*
     &  a0t1*M12+M12**2-4*M12*(3*a0t1+M12))*SW2-M12*(3*CW**2-SW2)*(-6*
     &  MassSu2(ISt3)+2*MNeu2(INe3))))+CF11FSR(INe3,ISt3)*(6*M1*M12*
     &  (CW**2+SW2)*CF11FSLC(INe3,ISt3)*MNeu(INe3)+CF11FSRC(INe3,ISt3)*
     &  (3*CW**2*(4*a0t1-M12)*M12+(44*a0t1*M12-3*M12**2)*SW2-4*M12*SW2*
     &  (-6*MassSu2(ISt3)+2*MNeu2(INe3)))))))/(64.*CW*M12*SW*MNeu(INe3)
     &  **2))
              endif
       enddo 
       enddo 
       enddo 
       do ISt3=1,2
       selfZ=selfZ+(-((3*CW**2+SW2)*CF12F4S(ISt3)*CF12F4SC(ISt3)*
     &  (CF12F12V2L*MCha2*FD221BChaST(3,ISt3)-2*CF12F12V2R*
     &  FD221BChaST(4,ISt3)))/(4.*CW*SW)+((3*CW**2+SW2)*CF12F4S(ISt3)*
     &  CF12F4SC(ISt3)*(-4*a0tcha*(CF12F12V2L-3*CF12F12V2R)+CF12F12V2L*
     &  MCha2-CF12F12V2R*MCha2+6*CF12F12V2R*MassSu2(ISt3)))/(32.*CW*SW)
     &  )
       enddo 
       selfZ=selfZ+((CF12F3S*CF12F3SC*(3*CF12F12V2R*CW**2*M12*(-4*a0t1+
     &  M12)+(-44*a0t1*CF12F12V2R*M12+M12*(16*a0tcha*(CF12F12V2L-3*
     &  CF12F12V2R)-4*CF12F12V2L*MCha2-CF12F12V2R*(M12-4*(M12+MCha2-6*
     &  MSQ2))))*SW2))/(32.*CW*M12*SW)+(CF12F3S*CF12F3SC*(2*CF12F12V2L*
     &  MCha2*(3*CW**2*M12*FD221TChaSB(1)+SW2*(-(M12*FD221TChaSB(1))+2*
     &  FD221TChaSB(3)))-8*CF12F12V2R*SW2*FD221TChaSB(4)+CF12F12V2R*
     &  M12*(-3*CW**2+SW2)*FD221TChaSB(5)))/(4.*CW*SW))

c
c topo2-NoGBC
c
       do INH3=1,6
       do INH4=1,6
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*(-(IC*CS1S1V2(INH3,INH4)*(2*CF12F12V2L*CW*MCha2*SW*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*FD211ChaHCha(2,INH3)+2*
     &  CF12F12V2R*CW*MCha2*SW*CFF12S1R(INH3)*CFF12S1R(INH4)*
     &  FD211ChaHCha(2,INH3)-2*CF12F12V2L*CW*MCha2*SW*CFF12S1R(INH3)*
     &  CFF12S1R(INH4)*FD211ChaHCha(2,INH4)-2*CF12F12V2R*CW*MCha2*SW*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*FD211ChaHCha(2,INH4)+2*CW*SW*
     &  CFF12S1L(INH4)*CFF12S1R(INH3)*(CF12F12V2L*MCha2*
     &  FD211ChaHCha(2,INH3)-CF12F12V2L*MCha2*FD211ChaHCha(2,INH4)-
     &  CF12F12V2L*MCha2*FD211ChaHCha(3,INH3)+CF12F12V2L*MCha2*
     &  FD211ChaHCha(3,INH4)+CF12F12V2R*FD211ChaHCha(5,INH3)-
     &  CF12F12V2R*FD211ChaHCha(5,INH4)+CF12F12V2R*FD211ChaHCha(6,INH3)
     &  -CF12F12V2R*FD211ChaHCha(6,INH4)-2*CF12F12V2R*
     &  FD211ChaHCha(7,INH3)+2*CF12F12V2R*FD211ChaHCha(7,INH4))+2*CW*
     &  SW*CFF12S1L(INH3)*((CF12F12V2L+CF12F12V2R)*MCha2*CFF12S1L(INH4)
     &  *(FD211ChaHCha(2,INH3)-FD211ChaHCha(2,INH4))+CFF12S1R(INH4)*
     &  (CF12F12V2R*MCha2*FD211ChaHCha(2,INH3)-CF12F12V2R*MCha2*
     &  FD211ChaHCha(2,INH4)-CF12F12V2R*MCha2*FD211ChaHCha(3,INH3)+
     &  CF12F12V2R*MCha2*FD211ChaHCha(3,INH4)+CF12F12V2L*
     &  FD211ChaHCha(5,INH3)-CF12F12V2L*FD211ChaHCha(5,INH4)+
     &  CF12F12V2L*FD211ChaHCha(6,INH3)-CF12F12V2L*FD211ChaHCha(6,INH4)
     &  -2*CF12F12V2L*FD211ChaHCha(7,INH3)+2*CF12F12V2L*
     &  FD211ChaHCha(7,INH4)))+3*CW**2*M12*FD211THT(2,INH3)*hy(INH3)*
     &  hy(INH4)-5*M12*SW2*FD211THT(2,INH3)*hy(INH3)*hy(INH4)-3*CW**2*
     &  M12*FD211THT(2,INH4)*hy(INH3)*hy(INH4)+5*M12*SW2*
     &  FD211THT(2,INH4)*hy(INH3)*hy(INH4)+3*CW**2*M12*FD211THT(2,INH3)
     &  *hy(INH4)*hyc(INH3)-M12*SW2*FD211THT(2,INH3)*hy(INH4)*hyc(INH3)
     &  -3*CW**2*M12*FD211THT(2,INH4)*hy(INH4)*hyc(INH3)+M12*SW2*
     &  FD211THT(2,INH4)*hy(INH4)*hyc(INH3)-3*CW**2*M12*
     &  FD211THT(3,INH3)*hy(INH4)*hyc(INH3)+M12*SW2*FD211THT(3,INH3)*
     &  hy(INH4)*hyc(INH3)+3*CW**2*M12*FD211THT(3,INH4)*hy(INH4)*
     &  hyc(INH3)-M12*SW2*FD211THT(3,INH4)*hy(INH4)*hyc(INH3)-4*SW2*
     &  FD211THT(5,INH3)*hy(INH4)*hyc(INH3)+4*SW2*FD211THT(5,INH4)*
     &  hy(INH4)*hyc(INH3)-4*SW2*FD211THT(6,INH3)*hy(INH4)*hyc(INH3)+4*
     &  SW2*FD211THT(6,INH4)*hy(INH4)*hyc(INH3)+8*SW2*FD211THT(7,INH3)*
     &  hy(INH4)*hyc(INH3)-8*SW2*FD211THT(7,INH4)*hy(INH4)*hyc(INH3)-4*
     &  M12*SW2*FD211THT(2,INH3)*hy(INH3)*hyc(INH4)+4*M12*SW2*
     &  FD211THT(2,INH4)*hy(INH3)*hyc(INH4)+4*M12*SW2*FD211THT(3,INH3)*
     &  hy(INH3)*hyc(INH4)-4*M12*SW2*FD211THT(3,INH4)*hy(INH3)*
     &  hyc(INH4)+3*CW**2*FD211THT(5,INH3)*hy(INH3)*hyc(INH4)-SW2*
     &  FD211THT(5,INH3)*hy(INH3)*hyc(INH4)-3*CW**2*FD211THT(5,INH4)*
     &  hy(INH3)*hyc(INH4)+SW2*FD211THT(5,INH4)*hy(INH3)*hyc(INH4)+3*
     &  CW**2*FD211THT(6,INH3)*hy(INH3)*hyc(INH4)-SW2*FD211THT(6,INH3)*
     &  hy(INH3)*hyc(INH4)-3*CW**2*FD211THT(6,INH4)*hy(INH3)*hyc(INH4)+
     &  SW2*FD211THT(6,INH4)*hy(INH3)*hyc(INH4)-6*CW**2*
     &  FD211THT(7,INH3)*hy(INH3)*hyc(INH4)+2*SW2*FD211THT(7,INH3)*
     &  hy(INH3)*hyc(INH4)+6*CW**2*FD211THT(7,INH4)*hy(INH3)*hyc(INH4)-
     &  2*SW2*FD211THT(7,INH4)*hy(INH3)*hyc(INH4)+3*CW**2*M12*
     &  FD211THT(2,INH3)*hyc(INH3)*hyc(INH4)-5*M12*SW2*FD211THT(2,INH3)
     &  *hyc(INH3)*hyc(INH4)-3*CW**2*M12*FD211THT(2,INH4)*hyc(INH3)*
     &  hyc(INH4)+5*M12*SW2*FD211THT(2,INH4)*hyc(INH3)*hyc(INH4)))/(8.*
     &  CW*SW*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)))+(IC*
     &  CS1S1V2(INH3,INH4)*(4*CF12F12V2L*CW*M12*MCha2*SW*CFF12S1R(INH3)
     &  *CFF12S1R(INH4)*Mah2(INH3)+4*CF12F12V2R*CW*M12*MCha2*SW*
     &  CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH3)+6*CW**2*M12**2*
     &  hy(INH3)*hy(INH4)*Mah2(INH3)-10*M12**2*SW2*hy(INH3)*hy(INH4)*
     &  Mah2(INH3)-12*a0t1*CW**2*M12*hy(INH4)*hyc(INH3)*Mah2(INH3)+9*
     &  CW**2*M12**2*hy(INH4)*hyc(INH3)*Mah2(INH3)-12*a0t1*M12*SW2*
     &  hy(INH4)*hyc(INH3)*Mah2(INH3)-23*M12**2*SW2*hy(INH4)*hyc(INH3)*
     &  Mah2(INH3)-16*M12*SW2*A0TNH(INH3)*hy(INH4)*hyc(INH3)*Mah2(INH3)
     &  +12*a0t1*CW**2*M12*hy(INH3)*hyc(INH4)*Mah2(INH3)+15*CW**2*M12**
     &  2*hy(INH3)*hyc(INH4)*Mah2(INH3)+12*a0t1*M12*SW2*hy(INH3)*
     &  hyc(INH4)*Mah2(INH3)-17*M12**2*SW2*hy(INH3)*hyc(INH4)*
     &  Mah2(INH3)+12*CW**2*M12*A0TNH(INH3)*hy(INH3)*hyc(INH4)*
     &  Mah2(INH3)-4*M12*SW2*A0TNH(INH3)*hy(INH3)*hyc(INH4)*Mah2(INH3)+
     &  6*CW**2*M12**2*hyc(INH3)*hyc(INH4)*Mah2(INH3)-10*M12**2*SW2*
     &  hyc(INH3)*hyc(INH4)*Mah2(INH3)-4*M12*SW2*hy(INH4)*hyc(INH3)*
     &  Mah2(INH3)**2+3*CW**2*M12*hy(INH3)*hyc(INH4)*Mah2(INH3)**2-M12*
     &  SW2*hy(INH3)*hyc(INH4)*Mah2(INH3)**2-4*CF12F12V2L*CW*M12*MCha2*
     &  SW*CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH4)-4*CF12F12V2R*CW*
     &  M12*MCha2*SW*CFF12S1R(INH3)*CFF12S1R(INH4)*Mah2(INH4)-6*CW**2*
     &  M12**2*hy(INH3)*hy(INH4)*Mah2(INH4)+10*M12**2*SW2*hy(INH3)*
     &  hy(INH4)*Mah2(INH4)+12*a0t1*CW**2*M12*hy(INH4)*hyc(INH3)*
     &  Mah2(INH4)-9*CW**2*M12**2*hy(INH4)*hyc(INH3)*Mah2(INH4)+12*
     &  a0t1*M12*SW2*hy(INH4)*hyc(INH3)*Mah2(INH4)+23*M12**2*SW2*
     &  hy(INH4)*hyc(INH3)*Mah2(INH4)+16*M12*SW2*A0TNH(INH4)*hy(INH4)*
     &  hyc(INH3)*Mah2(INH4)-12*a0t1*CW**2*M12*hy(INH3)*hyc(INH4)*
     &  Mah2(INH4)-15*CW**2*M12**2*hy(INH3)*hyc(INH4)*Mah2(INH4)-12*
     &  a0t1*M12*SW2*hy(INH3)*hyc(INH4)*Mah2(INH4)+17*M12**2*SW2*
     &  hy(INH3)*hyc(INH4)*Mah2(INH4)-12*CW**2*M12*A0TNH(INH4)*hy(INH3)
     &  *hyc(INH4)*Mah2(INH4)+4*M12*SW2*A0TNH(INH4)*hy(INH3)*hyc(INH4)*
     &  Mah2(INH4)-6*CW**2*M12**2*hyc(INH3)*hyc(INH4)*Mah2(INH4)+10*
     &  M12**2*SW2*hyc(INH3)*hyc(INH4)*Mah2(INH4)+4*M12*SW2*hy(INH4)*
     &  hyc(INH3)*Mah2(INH4)**2-3*CW**2*M12*hy(INH3)*hyc(INH4)*
     &  Mah2(INH4)**2+M12*SW2*hy(INH3)*hyc(INH4)*Mah2(INH4)**2-2*CW*
     &  M12*SW*CFF12S1L(INH4)*CFF12S1R(INH3)*((4*a0tcha*CF12F12V2L-4*
     &  a0tcha*CF12F12V2R-3*CF12F12V2L*MCha2-5*CF12F12V2R*MCha2-4*
     &  CF12F12V2R*A0TNH(INH3))*Mah2(INH3)-CF12F12V2R*Mah2(INH3)**2+
     &  Mah2(INH4)*(-4*a0tcha*CF12F12V2L+4*a0tcha*CF12F12V2R+3*
     &  CF12F12V2L*MCha2+5*CF12F12V2R*MCha2+4*CF12F12V2R*A0TNH(INH4)+
     &  CF12F12V2R*Mah2(INH4)))+2*CW*M12*SW*CFF12S1L(INH3)*(2*
     &  (CF12F12V2L+CF12F12V2R)*MCha2*CFF12S1L(INH4)*(Mah2(INH3)-
     &  Mah2(INH4))+CFF12S1R(INH4)*((4*a0tcha*CF12F12V2L-4*a0tcha*
     &  CF12F12V2R+5*CF12F12V2L*MCha2+3*CF12F12V2R*MCha2+4*CF12F12V2L*
     &  A0TNH(INH3))*Mah2(INH3)+CF12F12V2L*Mah2(INH3)**2-Mah2(INH4)*(4*
     &  a0tcha*CF12F12V2L-4*a0tcha*CF12F12V2R+5*CF12F12V2L*MCha2+3*
     &  CF12F12V2R*MCha2+4*CF12F12V2L*A0TNH(INH4)+CF12F12V2L*Mah2(INH4)
     &  )))))/(64.*CW*M12*SW*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))))
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*(-(IC*CS1S1V2(INH3,INH3)*(2*(CF12F12V2L+CF12F12V2R)*
     &  CW*MCha2*SW*CFF12S1L(INH3)**2*FD221ChaHCha(2,INH3)+2*
     &  (CF12F12V2L+CF12F12V2R)*CW*MCha2*SW*CFF12S1R(INH3)**2*
     &  FD221ChaHCha(2,INH3)+2*(CF12F12V2L+CF12F12V2R)*CW*SW*
     &  CFF12S1L(INH3)*CFF12S1R(INH3)*(MCha2*FD221ChaHCha(2,INH3)-2*
     &  FD221ChaHCha(4,INH3)-MCha2*FD221ChaHCha(5,INH3)+
     &  FD221ChaHCha(6,INH3)+FD221ChaHCha(7,INH3))+(3*CW**2-5*SW2)*((-
     &  2*FD221THT(4,INH3)-M12*FD221THT(5,INH3)+FD221THT(6,INH3)+
     &  FD221THT(7,INH3))*hy(INH3)*hyc(INH3)+M12*FD221THT(2,INH3)*
     &  (hy(INH3)**2+hy(INH3)*hyc(INH3)+hyc(INH3)**2))))/(8.*CW*SW)+
     &  (IC*CS1S1V2(INH3,INH3)*(4*(CF12F12V2L+CF12F12V2R)*CW*M12*MCha2*
     &  SW*CFF12S1L(INH3)**2+4*(CF12F12V2L+CF12F12V2R)*CW*M12*MCha2*SW*
     &  CFF12S1R(INH3)**2+2*(CF12F12V2L+CF12F12V2R)*CW*M12*SW*
     &  CFF12S1L(INH3)*CFF12S1R(INH3)*(8*MCha2+8*A0TNH(INH3)-2*
     &  Mah2(INH3))+(3*CW**2-5*SW2)*(2*M12**2*hy(INH3)**2+2*M12**2*
     &  hyc(INH3)**2+hy(INH3)*hyc(INH3)*(8*M12**2+8*M12*A0TNH(INH3)-2*
     &  M12*Mah2(INH3)))))/(64.*CW*M12*SW))
             endif
              endif
       enddo 
       enddo 



       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
       do INH3=1,6
       do INH4=1,6
          if( Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((IC*CS1S1V2(INH3,INH4)*(CF11F11V2L(INe5,INe3)*
     &  (CFF11S1L(INe4,INe5,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD111ChiHChi(5,INe3,INH3,INe4)-FD111ChiHChi(5,INe3,INH4,INe4)-
     &  FD111ChiHChi(5,INe5,INH3,INe4)+FD111ChiHChi(5,INe5,INH4,INe4)+
     &  FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH4,INe4)-
     &  FD111ChiHChi(6,INe5,INH3,INe4)+FD111ChiHChi(6,INe5,INH4,INe4)-
     &  2*FD111ChiHChi(7,INe3,INH3,INe4)+2*
     &  FD111ChiHChi(7,INe3,INH4,INe4)+2*FD111ChiHChi(7,INe5,INH3,INe4)
     &  -2*FD111ChiHChi(7,INe5,INH4,INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (FD111ChiHChi(2,INe3,INH3,INe4)-FD111ChiHChi(2,INe3,INH4,INe4)-
     &  FD111ChiHChi(2,INe5,INH3,INe4)+FD111ChiHChi(2,INe5,INH4,INe4))*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe4,INe5,INH4)*
     &  (CFF11S1L(INe3,INe4,INH3)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD111ChiHChi(3,INe5,INH3,INe4)-
     &  FD111ChiHChi(3,INe5,INH4,INe4))*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,INH3)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4))*MNeu(INe4))*MNeu(INe5))+
     &  CF11F11V2R(INe5,INe3)*(CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4))*MNeu(INe4)+
     &  CFF11S1L(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD111ChiHChi(3,INe5,INH3,INe4)-
     &  FD111ChiHChi(3,INe5,INH4,INe4))*MNeu(INe5))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1R(INe4,INe5,INH4)*
     &  (FD111ChiHChi(5,INe3,INH3,INe4)-FD111ChiHChi(5,INe3,INH4,INe4)-
     &  FD111ChiHChi(5,INe5,INH3,INe4)+FD111ChiHChi(5,INe5,INH4,INe4)+
     &  FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH4,INe4)-
     &  FD111ChiHChi(6,INe5,INH3,INe4)+FD111ChiHChi(6,INe5,INH4,INe4)-
     &  2*FD111ChiHChi(7,INe3,INH3,INe4)+2*
     &  FD111ChiHChi(7,INe3,INH4,INe4)+2*FD111ChiHChi(7,INe5,INH3,INe4)
     &  -2*FD111ChiHChi(7,INe5,INH4,INe4))+CFF11S1L(INe4,INe5,INH4)*
     &  (FD111ChiHChi(2,INe3,INH3,INe4)-FD111ChiHChi(2,INe3,INH4,INe4)-
     &  FD111ChiHChi(2,INe5,INH3,INe4)+FD111ChiHChi(2,INe5,INH4,INe4))*
     &  MNeu(INe4)*MNeu(INe5)))))/(8.*(Mah(INH3)**2-Mah(INH4)**2)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2))+(IC*CS1S1V2(INH3,INH4)*(-3*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu(INe3)**4-3*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe3)**4+3*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu(INe3)**4+3*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe3)**4-
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu(INe5)**4-
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe5)**4+
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu(INe5)**4+
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe5)**4-8*A0TNH(INH3)
     &  *CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)-8*A0TNH(INH3)*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu2(INe3)-2*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)**2*MNeu2(INe3)-2*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)**2*MNeu2(INe3)+8*
     &  A0TNH(INH4)*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu2(INe3)+8*A0TNH(INH4)*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu2(INe3)+2*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)**2*MNeu2(INe3)+2*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)**2*MNeu2(INe3)-4*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)-4*CF11F11V2R(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+4*CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+4*CF11F11V2R(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)+2*CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)-2*CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)-2*CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)-4*CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe4)*MNeu(INe5)*
     &  MNeu2(INe3)-4*CF11F11V2L(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu(INe4)*MNeu(INe5)*
     &  MNeu2(INe3)+4*CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe4)*MNeu(INe5)*
     &  MNeu2(INe3)+4*CF11F11V2L(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu(INe4)*MNeu(INe5)*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*(Mah2(INH3)-Mah2(INH4))*(2*
     &  (CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2L(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH4))*MNeu(INe3)*
     &  MNeu(INe5)-(CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH4))*MNeu2(INe3))
     &  -8*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)-8*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+8*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)+8*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4)*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)+2*
     &  (4*A0TNH(INH3)*(CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH4))*Mah2(INH3)+
     &  CF11F11V2L(INe5,INe3)*(-(CFF11S1R(INe4,INe5,INH4)*(Mah2(INH3)-
     &  Mah2(INH4))*(CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)-2*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4))*MNeu(INe5))+
     &  CFF11S1L(INe4,INe5,INH4)*(2*CFF11S1L(INe3,INe4,INH3)*
     &  (Mah2(INH3)-Mah2(INH4))*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)**2+4*Mah2(INH3)*
     &  MNeu2(INe4)-Mah2(INH4)*(4*A0TNH(INH4)+Mah2(INH4)+4*MNeu2(INe4))
     &  )))+CF11F11V2R(INe5,INe3)*(CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)
     &  -Mah2(INH4))*MNeu(INe3)*(2*CFF11S1R(INe4,INe5,INH4)*MNeu(INe4)-
     &  CFF11S1L(INe4,INe5,INH4)*MNeu(INe5))+CFF11S1L(INe3,INe4,INH3)*
     &  (2*CFF11S1L(INe4,INe5,INH4)*(Mah2(INH3)-Mah2(INH4))*MNeu(INe4)*
     &  MNeu(INe5)+CFF11S1R(INe4,INe5,INH4)*(Mah2(INH3)**2+4*Mah2(INH3)
     &  *MNeu2(INe4)-Mah2(INH4)*(4*A0TNH(INH4)+Mah2(INH4)+4*MNeu2(INe4)
     &  )))))*MNeu2(INe5)+4*(CF11F11V2L(INe5,INe3)*
     &  CFF11S1L(INe4,INe5,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH4))*(Mah2(INH3)-Mah2(INH4))*MNeu2(INe5)**
     &  2-4*A0TNeu(INe5)*(Mah2(INH3)-Mah2(INH4))*(2*
     &  (CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2L(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH4))*MNeu(INe3)*
     &  MNeu(INe5)-(CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH4))*MNeu2(INe5))))
     &  /(128.*(Mah2(INH3)-Mah2(INH4))*(MNeu2(INe3)-MNeu2(INe5))))
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((IC*CS1S1V2(INH3,INH3)*(CF11F11V2L(INe5,INe3)*
     &  (CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211HNeuNeu(6,INH3,INe3,INe4)-FD211HNeuNeu(6,INH3,INe5,INe4)-
     &  2*FD211HNeuNeu(7,INH3,INe3,INe4)+2*
     &  FD211HNeuNeu(7,INH3,INe5,INe4)+FD211HNeuNeu(9,INH3,INe3,INe4)-
     &  FD211HNeuNeu(9,INH3,INe5,INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (FD211HNeuNeu(2,INH3,INe3,INe4)-FD211HNeuNeu(2,INH3,INe5,INe4))
     &  *MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe4,INe5,INH3)*
     &  (CFF11S1L(INe3,INe4,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(4,INH3,INe3,INe4)+
     &  FD211HNeuNeu(4,INH3,INe5,INe4))*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4))*MNeu(INe4))*MNeu(INe5))+
     &  CF11F11V2R(INe5,INe3)*(CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4))*MNeu(INe4)+
     &  CFF11S1L(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(4,INH3,INe3,INe4)+
     &  FD211HNeuNeu(4,INH3,INe5,INe4))*MNeu(INe5))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1R(INe4,INe5,INH3)*
     &  (FD211HNeuNeu(6,INH3,INe3,INe4)-FD211HNeuNeu(6,INH3,INe5,INe4)-
     &  2*FD211HNeuNeu(7,INH3,INe3,INe4)+2*
     &  FD211HNeuNeu(7,INH3,INe5,INe4)+FD211HNeuNeu(9,INH3,INe3,INe4)-
     &  FD211HNeuNeu(9,INH3,INe5,INe4))+CFF11S1L(INe4,INe5,INH3)*
     &  (FD211HNeuNeu(2,INH3,INe3,INe4)-FD211HNeuNeu(2,INH3,INe5,INe4))
     &  *MNeu(INe4)*MNeu(INe5)))))/(8.*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  (IC*CS1S1V2(INH3,INH3)*(3*CF11F11V2L(INe5,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)**
     &  4+3*CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)**4+8*A0TNeu(INe3)*
     &  (CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2L(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3))*MNeu(INe3)*
     &  MNeu(INe5)-3*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe5)**4-3*CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)**
     &  4-16*A0TNH(INH3)*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)
     &  *CFF11S1R(INe3,INe4,INH3)*MNeu2(INe3)-16*A0TNH(INH3)*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu2(INe3)-4*A0TNeu(INe3)*
     &  (CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3))*MNeu2(INe3)+
     &  4*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)+4*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*Mah2(INH3)*MNeu2(INe3)-4*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-4*
     &  CF11F11V2R(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+2*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)+2*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-4*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)*MNeu2(INe3)-4*
     &  CF11F11V2L(INe5,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)*MNeu2(INe3)-6*
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu2(INe3)**2-6*CF11F11V2R(INe5,INe3)
     &  *CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*MNeu2(INe3)*
     &  *2-8*CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu2(INe3)*MNeu2(INe4)-8*
     &  CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3)*MNeu2(INe3)*MNeu2(INe4)+2*(8*
     &  A0TNH(INH3)*(CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3))+
     &  CF11F11V2L(INe5,INe3)*(CFF11S1R(INe4,INe5,INH3)*(-
     &  (CFF11S1L(INe3,INe4,INH3)*MNeu(INe3))+2*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4))*MNeu(INe5)+
     &  CFF11S1L(INe4,INe5,INH3)*(2*CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)
     &  *MNeu(INe4)-2*CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)-2*
     &  MNeu2(INe4))))+CF11F11V2R(INe5,INe3)*(CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe3)*(2*CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)-
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe5))+CFF11S1L(INe3,INe4,INH3)*
     &  (2*CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)-2*
     &  CFF11S1R(INe4,INe5,INH3)*(Mah2(INH3)-2*MNeu2(INe4)))))*
     &  MNeu2(INe5)+6*(CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe5,INH3))*MNeu2(INe5)*
     &  *2+4*A0TNeu(INe5)*(-2*(CF11F11V2R(INe5,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3))*MNeu(INe3)*MNeu(INe5)+
     &  (CF11F11V2L(INe5,INe3)*CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe5,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe5,INH3))*MNeu2(INe5))))/(128.*(MNeu2(INe3)-MNeu2(INe5))))
             endif
              endif
             else
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((IC*CS1S1V2(INH3,INH4)*(CF11F11V2L(INe3,INe3)*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211ChiHChi(5,INe3,INH3,INe4)-FD211ChiHChi(5,INe3,INH4,INe4)+
     &  FD211ChiHChi(6,INe3,INH3,INe4)-FD211ChiHChi(6,INe3,INH4,INe4)-
     &  2*FD211ChiHChi(7,INe3,INH3,INe4)+2*
     &  FD211ChiHChi(7,INe3,INH4,INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4))
     &  *MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe4,INe3,INH4)*
     &  ((FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)
     &  )*MNeu(INe3)*(CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (-FD211ChiHChi(3,INe3,INH3,INe4)+FD211ChiHChi(3,INe3,INH4,INe4)
     &  )*MNeu2(INe3)))+CF11F11V2R(INe3,INe3)*(CFF11S1L(INe3,INe4,INH3)
     &  *(CFF11S1R(INe4,INe3,INH4)*(FD211ChiHChi(5,INe3,INH3,INe4)-
     &  FD211ChiHChi(5,INe3,INH4,INe4)+FD211ChiHChi(6,INe3,INH3,INe4)-
     &  FD211ChiHChi(6,INe3,INH4,INe4)-2*FD211ChiHChi(7,INe3,INH3,INe4)
     &  +2*FD211ChiHChi(7,INe3,INH4,INe4))+CFF11S1L(INe4,INe3,INH4)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4))
     &  *MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe3,INe4,INH3)*
     &  ((FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)
     &  )*MNeu(INe3)*(CFF11S1L(INe4,INe3,INH4)*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,INH4)*MNeu(INe4))+CFF11S1L(INe4,INe3,INH4)*
     &  (-FD211ChiHChi(3,INe3,INH3,INe4)+FD211ChiHChi(3,INe3,INH4,INe4)
     &  )*MNeu2(INe3)))))/(8.*(Mah(INH3)**2-Mah(INH4)**2))+(IC*
     &  CS1S1V2(INH3,INH4)*(-(CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*
     &  MNeu(INe3)**4)-CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)*MNeu(INe3)**4+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu(INe3)**4+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu(INe3)**4-2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH4)*Mah2(INH3)*MNeu(INe3)**3*MNeu(INe4)-2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH4)*Mah2(INH3)*MNeu(INe3)**3*MNeu(INe4)-2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)*MNeu(INe3)**3*MNeu(INe4)-2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH4)*Mah2(INH4)*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH4)*Mah2(INH4)*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu(INe3)**3*MNeu(INe4)-4*
     &  A0TNH(INH3)*(CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH4))*Mah2(INH3)*
     &  MNeu2(INe3)-CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)**2*MNeu2(INe3)-
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)**2*MNeu2(INe3)+4*
     &  A0TNH(INH4)*CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu2(INe3)+4*A0TNH(INH4)*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu2(INe3)+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)**2*MNeu2(INe3)+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)**2*MNeu2(INe3)-
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)**2-2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH3)*MNeu2(INe3)**2-2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)*MNeu2(INe3)**2-
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH3)*MNeu2(INe3)**2+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu2(INe3)**2+2*
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH3)*Mah2(INH4)*MNeu2(INe3)**2+2*
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu2(INe3)**2+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4)*Mah2(INH4)*MNeu2(INe3)**2+4*
     &  A0TNeu(INe3)*(Mah2(INH3)-Mah2(INH4))*((CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*MNeu2(INe3)-(CF11F11V2L(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*MNeu2(INe3))-4*(CF11F11V2L(INe3,INe3)
     &  *CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH4))*(Mah2(INH3)-Mah2(INH4))*MNeu2(INe3)*MNeu2(INe4)))
     &  /(64.*(Mah2(INH3)-Mah2(INH4))*MNeu(INe3)**2))
          else 
          if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+2*((IC*CS1S1V2(INH3,INH3)*(CF11F11V2L(INe3,INe3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*(-2*
     &  FD221ChiHChi(4,INe3,INH3,INe4)+FD221ChiHChi(6,INe3,INH3,INe4)+
     &  FD221ChiHChi(7,INe3,INH3,INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(2,INe3,INH3,INe4)*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH3)*(FD221ChiHChi(2,INe3,INH3,INe4)*
     &  MNeu(INe3)*(CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe4))-CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(5,INe3,INH3,INe4)*MNeu2(INe3)))+
     &  CF11F11V2R(INe3,INe3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-2*FD221ChiHChi(4,INe3,INH3,INe4)+
     &  FD221ChiHChi(6,INe3,INH3,INe4)+FD221ChiHChi(7,INe3,INH3,INe4))+
     &  CFF11S1L(INe4,INe3,INH3)*FD221ChiHChi(2,INe3,INH3,INe4)*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)*MNeu(INe3)*
     &  (CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+CFF11S1R(INe4,INe3,INH3)*
     &  MNeu(INe4))-CFF11S1L(INe4,INe3,INH3)*
     &  FD221ChiHChi(5,INe3,INH3,INe4)*MNeu2(INe3)))))/8.-(IC*
     &  CS1S1V2(INH3,INH3)*(4*A0TNeu(INe3)*(-((CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2L(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3))+(CF11F11V2L(INe3,INe3)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH3)+
     &  CF11F11V2R(INe3,INe3)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*MNeu2(INe3))+MNeu2(INe3)*(8*
     &  A0TNH(INH3)*(CF11F11V2L(INe3,INe3)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CF11F11V2R(INe3,INe3)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3))+
     &  CF11F11V2L(INe3,INe3)*(CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*(3*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)+2*CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe4))+CFF11S1L(INe4,INe3,INH3)*(2*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(-2*Mah2(INH3)+MNeu2(INe3)+4*
     &  MNeu2(INe4))))+CF11F11V2R(INe3,INe3)*(CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe3)*(3*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)+2*
     &  CFF11S1R(INe4,INe3,INH3)*MNeu(INe4))+CFF11S1L(INe3,INe4,INH3)*
     &  (2*CFF11S1L(INe4,INe3,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe3,INH3)*(-2*Mah2(INH3)+MNeu2(INe3)+4*
     &  MNeu2(INe4)))))))/(64.*MNeu(INe3)**2))
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       !diagram3
       do ICH3=1,2
       do ICH4=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*(-((3*CW**2+SW2)*CTBS3(ICH4)*CTBS3C(ICH3)*
     &  (FD211BHpT(5,ICH3)-FD211BHpT(5,ICH4)+FD211BHpT(6,ICH3)-
     &  FD211BHpT(6,ICH4)-2*FD211BHpT(7,ICH3)+2*FD211BHpT(7,ICH4))*
     &  indexdelta(ICH3,ICH4))+CTBS3(ICH3)*CTBS3C(ICH4)*(M12*(-3*CW**2+
     &  SW2)*FD211THpB(2,ICH3)+M12*(3*CW**2-SW2)*FD211THpB(2,ICH4)+3*
     &  CW**2*M12*FD211THpB(3,ICH3)-M12*SW2*FD211THpB(3,ICH3)-3*CW**2*
     &  M12*FD211THpB(3,ICH4)+M12*SW2*FD211THpB(3,ICH4)+4*SW2*
     &  FD211THpB(5,ICH3)-4*SW2*FD211THpB(5,ICH4)+4*SW2*
     &  FD211THpB(6,ICH3)-4*SW2*FD211THpB(6,ICH4)-8*SW2*
     &  FD211THpB(7,ICH3)+8*SW2*FD211THpB(7,ICH4))*
     &  indexdelta(ICH4,ICH3)))/(8.*CW*S2W*SW*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))+(C2W*(CTBS3(ICH3)*CTBS3C(ICH4)*
     &  indexdelta(ICH4,ICH3)*(-(MassHpm(ICH3)**2*(3*CW**2*(4*a0t1-3*
     &  M12)*M12+(12*a0t1*M12+7*M12**2)*SW2+4*M12*SW2*(4*A0THpN(ICH3)+
     &  MassHpm(ICH3)**2)))+(3*CW**2*(4*a0t1-3*M12)*M12+(12*a0t1*M12+7*
     &  M12**2)*SW2+16*M12*SW2*A0THpN(ICH4))*MassHpm(ICH4)**2+4*M12*
     &  SW2*MassHpm(ICH4)**4)+M12*(3*CW**2+SW2)*CTBS3(ICH4)*
     &  CTBS3C(ICH3)*indexdelta(ICH3,ICH4)*(4*(M12+A0THpN(ICH3))*
     &  MassHpm(ICH3)**2+MassHpm(ICH3)**4-MassHpm(ICH4)**2*(4*(M12+
     &  A0THpN(ICH4))+MassHpm(ICH4)**2))))/(64.*CW*M12*S2W*SW*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)))
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*CTBS3(ICH3)*CTBS3C(ICH3)*(2*(3*CW**2+SW2)*
     &  FD221BHpT(4,ICH3)-(3*CW**2+SW2)*FD221BHpT(6,ICH3)-3*CW**2*
     &  FD221BHpT(7,ICH3)-SW2*FD221BHpT(7,ICH3)-3*CW**2*M12*
     &  FD221THpB(2,ICH3)+M12*SW2*FD221THpB(2,ICH3)-8*SW2*
     &  FD221THpB(4,ICH3)+3*CW**2*M12*FD221THpB(5,ICH3)-M12*SW2*
     &  FD221THpB(5,ICH3)+4*SW2*FD221THpB(6,ICH3)+4*SW2*
     &  FD221THpB(7,ICH3))*indexdelta(ICH3,ICH3))/(8.*CW*S2W*SW)+(C2W*
     &  CTBS3(ICH3)*CTBS3C(ICH3)*indexdelta(ICH3,ICH3)*(3*CW**2*(-4*
     &  a0t1*M12+7*M12**2)+(-12*a0t1*M12-3*M12**2)*SW2+6*M12*(CW-SW)*
     &  (CW+SW)*(4*A0THpN(ICH3)-MassHpm(ICH3)**2)))/(64.*CW*M12*S2W*SW)
     &  )
             endif
              endif
       enddo 
       enddo 

       !diagram 4
       do ICH3=1,2
       do ICH4=1,2
       do INe3=1,3
       do INe4=1,3
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH4,ICH3)*(CF11F11V2R(INe4,INe3)*
     &  (CF11F12S3R(INe4,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(5,INe3,ICH3)-FD111ChiHpCha(5,INe3,ICH4)-
     &  FD111ChiHpCha(5,INe4,ICH3)+FD111ChiHpCha(5,INe4,ICH4)+
     &  FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(6,INe4,ICH3)+FD111ChiHpCha(6,INe4,ICH4)-2*
     &  FD111ChiHpCha(7,INe3,ICH3)+2*FD111ChiHpCha(7,INe3,ICH4)+2*
     &  FD111ChiHpCha(7,INe4,ICH3)-2*FD111ChiHpCha(7,INe4,ICH4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))*MNeu(INe3))+CF11F12S3L(INe4,ICH4)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)
     &  -FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4)-
     &  FD111ChiHpCha(3,INe3,ICH3)+FD111ChiHpCha(3,INe3,ICH4)+
     &  FD111ChiHpCha(3,INe4,ICH3)-FD111ChiHpCha(3,INe4,ICH4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F11V2L(INe4,INe3)*
     &  (CF11F12S3L(INe4,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD111ChiHpCha(5,INe3,ICH3)-FD111ChiHpCha(5,INe3,ICH4)-
     &  FD111ChiHpCha(5,INe4,ICH3)+FD111ChiHpCha(5,INe4,ICH4)+
     &  FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(6,INe4,ICH3)+FD111ChiHpCha(6,INe4,ICH4)-2*
     &  FD111ChiHpCha(7,INe3,ICH3)+2*FD111ChiHpCha(7,INe3,ICH4)+2*
     &  FD111ChiHpCha(7,INe4,ICH3)-2*FD111ChiHpCha(7,INe4,ICH4))+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))*MNeu(INe3))+CF11F12S3R(INe4,ICH4)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)
     &  -FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4)-
     &  FD111ChiHpCha(3,INe3,ICH3)+FD111ChiHpCha(3,INe3,ICH4)+
     &  FD111ChiHpCha(3,INe4,ICH3)-FD111ChiHpCha(3,INe4,ICH4))*
     &  MNeu(INe3))*MNeu(INe4))))/(4.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))
     &  *(MassHpm(ICH3)+MassHpm(ICH4))*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(C2W*indexdelta(ICH4,ICH3)*(-
     &  (CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**4)-
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**4+
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)**4+
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)**4+
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)**4+
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)**4-
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)**4-
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)**4-8*
     &  MCha2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)-8*
     &  A0THpN(ICH3)*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)-8*
     &  MCha2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)-8*
     &  A0THpN(ICH3)*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)-2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**4*MNeu2(INe3)-2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**4*MNeu2(INe3)+8*
     &  MCha2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH4)*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)+8*
     &  MCha2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH4)*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)+2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**4*MNeu2(INe3)+2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**4*MNeu2(INe3)-4*
     &  MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu2(INe3)-4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu2(INe3)+4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu2(INe3)+4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu2(INe3)-4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe3)-4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe3)+4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)*
     &  MNeu2(INe3)+4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)+2*CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-2*CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH4)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)**2-
     &  2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)**2+
     &  2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)**2+
     &  2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe3)**2+
     &  4*A0TNeu(INe3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*
     &  (CF11F11V2L(INe4,INe3)*(2*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)
     &  )+CF11F11V2R(INe4,INe3)*(2*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-
     &  CF11F12S3R(INe4,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)
     &  ))+8*MCha2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)+8*
     &  A0THpN(ICH3)*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)+8*
     &  MCha2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)+8*
     &  A0THpN(ICH3)*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)+2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**4*MNeu2(INe4)+2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**4*MNeu2(INe4)-8*
     &  MCha2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)-8*
     &  A0THpN(ICH4)*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)-8*
     &  MCha2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)-8*
     &  A0THpN(ICH4)*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)-2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**4*MNeu2(INe4)-2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**4*MNeu2(INe4)+4*
     &  MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu2(INe4)+4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu2(INe4)-4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu2(INe4)-4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu2(INe4)+4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe4)+4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe4)-4*MCha*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)*
     &  MNeu2(INe4)-4*MCha*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe4)*
     &  MNeu2(INe4)-2*CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)-2*CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+2*CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH4)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)**2+
     &  2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)**2-
     &  2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)**2-
     &  2*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH4)**2*MNeu2(INe4)**2-
     &  4*A0TNeu(INe4)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*
     &  (CF11F11V2L(INe4,INe3)*(2*CF11F12S3R(INe4,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe4)
     &  )+CF11F11V2R(INe4,INe3)*(2*CF11F12S3L(INe4,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe4,ICH4)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe4)))))/(64.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))
     &  *(MassHpm(ICH3)+MassHpm(ICH4))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))))
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F11V2R(INe4,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211HpChiCha(6,ICH3,INe3)-FD211HpChiCha(6,ICH3,INe4)-2*
     &  FD211HpChiCha(7,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe4)+
     &  FD211HpChiCha(9,ICH3,INe3)-FD211HpChiCha(9,ICH3,INe4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4))*MNeu(INe3))+CF11F12S3L(INe4,ICH3)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)
     &  -FD211HpChiCha(2,ICH3,INe4))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD211HpChiCha(2,ICH3,INe3)-FD211HpChiCha(2,ICH3,INe4)-
     &  FD211HpChiCha(4,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F11V2L(INe4,INe3)*
     &  (CF11F12S3L(INe4,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD211HpChiCha(6,ICH3,INe3)-FD211HpChiCha(6,ICH3,INe4)-2*
     &  FD211HpChiCha(7,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe4)+
     &  FD211HpChiCha(9,ICH3,INe3)-FD211HpChiCha(9,ICH3,INe4))+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4))*MNeu(INe3))+CF11F12S3R(INe4,ICH3)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)
     &  -FD211HpChiCha(2,ICH3,INe4))+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211HpChiCha(2,ICH3,INe3)-FD211HpChiCha(2,ICH3,INe4)-
     &  FD211HpChiCha(4,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))))/(4.*S2W*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4)))+(C2W*indexdelta(ICH3,ICH3)*(-3*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)**4-3*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**4+3*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)**4+3*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)**4-8*MCha2*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)-16*A0THpN(ICH3)*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)-8*MCha2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)-16*A0THpN(ICH3)*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)+4*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)+4*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe3)-4*
     &  MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu2(INe3)-4*MCha*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu2(INe3)-4*MCha*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*MNeu2(INe3)-4*MCha*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*MNeu2(INe3)+2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  +2*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  +A0TNeu(INe3)*(4*CF11F11V2L(INe4,INe3)*(2*CF11F12S3R(INe4,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)
     &  )+CF11F11V2R(INe4,INe3)*(8*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)-4*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)
     &  ))+8*MCha2*CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe4)+16*A0THpN(ICH3)*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe4)+8*MCha2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe4)+16*A0THpN(ICH3)*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe4)-4*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)-4*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu2(INe4)+4*
     &  MCha*CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu2(INe4)+4*MCha*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu2(INe4)+4*MCha*
     &  CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*MNeu2(INe4)+4*MCha*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*MNeu2(INe4)-2*
     &  CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  -2*CF11F11V2L(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +A0TNeu(INe4)*(4*CF11F11V2L(INe4,INe3)*(-2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)+CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu2(INe4))+CF11F11V2R(INe4,INe3)*(-8*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)+4*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe4)))))
     &  /(64.*S2W*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))))
             endif
              endif
             else
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH4,ICH3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211ChiHpCha(5,INe3,ICH3)-FD211ChiHpCha(5,INe3,ICH4)+
     &  FD211ChiHpCha(6,INe3,ICH3)-FD211ChiHpCha(6,INe3,ICH4)-2*
     &  FD211ChiHpCha(7,INe3,ICH3)+2*FD211ChiHpCha(7,INe3,ICH4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4))*MNeu(INe3))+CF11F12S3L(INe3,ICH4)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)
     &  -FD211ChiHpCha(2,INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)**2-FD211ChiHpCha(2,INe3,ICH4)*MNeu(INe3)**2+(-
     &  FD211ChiHpCha(3,INe3,ICH3)+FD211ChiHpCha(3,INe3,ICH4))*
     &  MNeu2(INe3))))+CF11F11V2L(INe3,INe3)*(CF11F12S3L(INe3,ICH4)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(5,INe3,ICH3)-
     &  FD211ChiHpCha(5,INe3,ICH4)+FD211ChiHpCha(6,INe3,ICH3)-
     &  FD211ChiHpCha(6,INe3,ICH4)-2*FD211ChiHpCha(7,INe3,ICH3)+2*
     &  FD211ChiHpCha(7,INe3,ICH4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211ChiHpCha(2,INe3,ICH3)-FD211ChiHpCha(2,INe3,ICH4))*
     &  MNeu(INe3))+CF11F12S3R(INe3,ICH4)*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)**2-FD211ChiHpCha(2,INe3,ICH4)*MNeu(INe3)**2+(-
     &  FD211ChiHpCha(3,INe3,ICH3)+FD211ChiHpCha(3,INe3,ICH4))*
     &  MNeu2(INe3))))))/(4.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4)))+(C2W*indexdelta(ICH4,ICH3)*(4*
     &  A0TNeu(INe3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*
     &  (CF11F11V2R(INe3,INe3)*(CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)-CF11F12S3R(INe3,ICH4)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3))+
     &  CF11F11V2L(INe3,INe3)*(-(CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)
     &  ))+CF11F11V2L(INe3,INe3)*(-(CF11F12S3R(INe3,ICH4)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3)+3*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu2(INe3)))+
     &  CF11F12S3L(INe3,ICH4)*MNeu2(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-MassHpm(ICH3)**2+MassHpm(ICH4)*
     &  *2)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-MassHpm(ICH3)**
     &  4-MassHpm(ICH3)**2*(4*MCha2+4*A0THpN(ICH3)+MNeu2(INe3))+
     &  MassHpm(ICH4)**2*(4*MCha2+4*A0THpN(ICH4)+MassHpm(ICH4)**2+
     &  MNeu2(INe3)))))+CF11F11V2R(INe3,INe3)*(-(CF11F12S3L(INe3,ICH4)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)+3*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu2(INe3)))+
     &  CF11F12S3R(INe3,ICH4)*MNeu2(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-MassHpm(ICH3)**2+MassHpm(ICH4)*
     &  *2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-MassHpm(ICH3)**
     &  4-MassHpm(ICH3)**2*(4*MCha2+4*A0THpN(ICH3)+MNeu2(INe3))+
     &  MassHpm(ICH4)**2*(4*MCha2+4*A0THpN(ICH4)+MassHpm(ICH4)**2+
     &  MNeu2(INe3)))))))/(32.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))
     &  *(MassHpm(ICH3)+MassHpm(ICH4))*MNeu(INe3)**2))
          else 
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3R(INe3,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  FD221ChiHpCha(4,INe3,ICH3)+FD221ChiHpCha(6,INe3,ICH3)+
     &  FD221ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3))+CF11F12S3L(INe3,ICH3)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*FD221ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3)**2-
     &  FD221ChiHpCha(5,INe3,ICH3)*MNeu2(INe3))))+CF11F11V2L(INe3,INe3)
     &  *(CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3))*(-2*
     &  FD221ChiHpCha(4,INe3,ICH3)+FD221ChiHpCha(6,INe3,ICH3)+
     &  FD221ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3))+CF11F12S3R(INe3,ICH3)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*FD221ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3)**2-
     &  FD221ChiHpCha(5,INe3,ICH3)*MNeu2(INe3))))))/(4.*S2W)+(C2W*
     &  indexdelta(ICH3,ICH3)*(4*A0TNeu(INe3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu2(INe3)-CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))
     &  *MNeu2(INe3))+CF11F11V2L(INe3,INe3)*(-(CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)
     &  ))-MNeu2(INe3)*(CF11F11V2L(INe3,INe3)*(CF11F12S3R(INe3,ICH3)*
     &  MNeu(INe3)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))+3*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3))+CF11F12S3L(INe3,ICH3)
     &  *(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(4*MCha2+8*A0THpN(ICH3)-2*
     &  MassHpm(ICH3)**2+MNeu2(INe3))))+CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))+3*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe3))+CF11F12S3R(INe3,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(4*MCha2+8*A0THpN(ICH3)-2*
     &  MassHpm(ICH3)**2+MNeu2(INe3)))))))/(32.*S2W*MNeu(INe3)**2))
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 

       !diagram 5
       do ICH3=1,2
       do ICH4=1,2
       do INe3=1,3
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH4)*(CF11F12S3R(INe3,ICH3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH4))*(CF12F12V2L*MCha**2*
     &  FD211ChaHpChi(2,ICH3,INe3)-CF12F12V2L*MCha**2*
     &  FD211ChaHpChi(2,ICH4,INe3)-CF12F12V2L*MCha2*
     &  FD211ChaHpChi(3,ICH3,INe3)+CF12F12V2L*MCha2*
     &  FD211ChaHpChi(3,ICH4,INe3)+CF12F12V2R*
     &  FD211ChaHpChi(5,ICH3,INe3)-CF12F12V2R*
     &  FD211ChaHpChi(5,ICH4,INe3)+CF12F12V2R*
     &  FD211ChaHpChi(6,ICH3,INe3)-CF12F12V2R*
     &  FD211ChaHpChi(6,ICH4,INe3)-2*CF12F12V2R*
     &  FD211ChaHpChi(7,ICH3,INe3)+2*CF12F12V2R*
     &  FD211ChaHpChi(7,ICH4,INe3))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(FD211ChaHpChi(2,ICH3,INe3)-
     &  FD211ChaHpChi(2,ICH4,INe3))*MNeu(INe3))+CF11F12S3L(INe3,ICH3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH4))*(CF12F12V2R*MCha**2*
     &  FD211ChaHpChi(2,ICH3,INe3)-CF12F12V2R*MCha**2*
     &  FD211ChaHpChi(2,ICH4,INe3)-CF12F12V2R*MCha2*
     &  FD211ChaHpChi(3,ICH3,INe3)+CF12F12V2R*MCha2*
     &  FD211ChaHpChi(3,ICH4,INe3)+CF12F12V2L*
     &  FD211ChaHpChi(5,ICH3,INe3)-CF12F12V2L*
     &  FD211ChaHpChi(5,ICH4,INe3)+CF12F12V2L*
     &  FD211ChaHpChi(6,ICH3,INe3)-CF12F12V2L*
     &  FD211ChaHpChi(6,ICH4,INe3)-2*CF12F12V2L*
     &  FD211ChaHpChi(7,ICH3,INe3)+2*CF12F12V2L*
     &  FD211ChaHpChi(7,ICH4,INe3))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(FD211ChaHpChi(2,ICH3,INe3)-
     &  FD211ChaHpChi(2,ICH4,INe3))*MNeu(INe3))))/(4.*S2W*
     &  (MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4)))+
     &  (C2W*indexdelta(ICH3,ICH4)*(CF11F12S3L(INe3,ICH3)*(-2*
     &  (CF12F12V2L+CF12F12V2R)*MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-(CF12F12V2L*MassHpm(ICH3)**4)-
     &  MassHpm(ICH3)**2*(4*a0tcha*CF12F12V2L-4*a0tcha*CF12F12V2R+
     &  CF12F12V2L*MCha2+3*CF12F12V2R*MCha2+4*CF12F12V2L*A0THpN(ICH3)+
     &  4*CF12F12V2L*MNeu2(INe3))+MassHpm(ICH4)**2*(4*a0tcha*
     &  CF12F12V2L-4*a0tcha*CF12F12V2R+CF12F12V2L*MCha2+3*CF12F12V2R*
     &  MCha2+4*CF12F12V2L*A0THpN(ICH4)+CF12F12V2L*MassHpm(ICH4)**2+4*
     &  CF12F12V2L*MNeu2(INe3))))+CF11F12S3R(INe3,ICH3)*(-2*
     &  (CF12F12V2L+CF12F12V2R)*MCha*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-(CF12F12V2R*MassHpm(ICH3)**4)+
     &  MassHpm(ICH3)**2*(4*a0tcha*CF12F12V2L-4*a0tcha*CF12F12V2R-3*
     &  CF12F12V2L*MCha2-CF12F12V2R*MCha2-4*CF12F12V2R*A0THpN(ICH3)-4*
     &  CF12F12V2R*MNeu2(INe3))+MassHpm(ICH4)**2*(-4*a0tcha*CF12F12V2L+
     &  4*a0tcha*CF12F12V2R+3*CF12F12V2L*MCha2+CF12F12V2R*MCha2+4*
     &  CF12F12V2R*A0THpN(ICH4)+CF12F12V2R*MassHpm(ICH4)**2+4*
     &  CF12F12V2R*MNeu2(INe3))))))/(32.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4))))
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(CF12F12V2L*MCha**2*
     &  FD221ChaHpChi(2,ICH3,INe3)-2*CF12F12V2R*
     &  FD221ChaHpChi(4,ICH3,INe3)-CF12F12V2L*MCha2*
     &  FD221ChaHpChi(5,ICH3,INe3)+CF12F12V2R*
     &  FD221ChaHpChi(6,ICH3,INe3)+CF12F12V2R*
     &  FD221ChaHpChi(7,ICH3,INe3))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD221ChaHpChi(2,ICH3,INe3)*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(CF12F12V2R*MCha**2*FD221ChaHpChi(2,ICH3,INe3)-2*CF12F12V2L*
     &  FD221ChaHpChi(4,ICH3,INe3)-CF12F12V2R*MCha2*
     &  FD221ChaHpChi(5,ICH3,INe3)+CF12F12V2L*
     &  FD221ChaHpChi(6,ICH3,INe3)+CF12F12V2L*
     &  FD221ChaHpChi(7,ICH3,INe3))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD221ChaHpChi(2,ICH3,INe3)*
     &  MNeu(INe3))))/(4.*S2W)-(C2W*indexdelta(ICH3,ICH3)*
     &  (CF11F12S3L(INe3,ICH3)*(2*(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(4*a0tcha*CF12F12V2L-4*a0tcha*
     &  CF12F12V2R+CF12F12V2L*MCha2+3*CF12F12V2R*MCha2+8*CF12F12V2L*
     &  A0THpN(ICH3)-2*CF12F12V2L*MassHpm(ICH3)**2+4*CF12F12V2L*
     &  MNeu2(INe3)))+CF11F12S3R(INe3,ICH3)*(2*(CF12F12V2L+CF12F12V2R)*
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-4*a0tcha*CF12F12V2L+4*a0tcha*
     &  CF12F12V2R+3*CF12F12V2L*MCha2+CF12F12V2R*MCha2+8*CF12F12V2R*
     &  A0THpN(ICH3)-2*CF12F12V2R*MassHpm(ICH3)**2+4*CF12F12V2R*MNeu2(INe3)))))/(32.*S2W))
             endif
              endif
       enddo 
       enddo 
       enddo 

       !diagram 6
       do INe3=1,3
       do INe4=1,3
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((-3*CS13S13V2(ISt4,ISt3)*(CF11F11V2R(INe4,INe3)*
     &  (CF11FSR(INe4,ISt4)*(CF11FSRC(INe3,ISt3)*
     &  (FD111ChiStT(5,INe3,ISt3)-FD111ChiStT(5,INe3,ISt4)-
     &  FD111ChiStT(5,INe4,ISt3)+FD111ChiStT(5,INe4,ISt4)+
     &  FD111ChiStT(6,INe3,ISt3)-FD111ChiStT(6,INe3,ISt4)-
     &  FD111ChiStT(6,INe4,ISt3)+FD111ChiStT(6,INe4,ISt4)-2*
     &  FD111ChiStT(7,INe3,ISt3)+2*FD111ChiStT(7,INe3,ISt4)+2*
     &  FD111ChiStT(7,INe4,ISt3)-2*FD111ChiStT(7,INe4,ISt4))+M1*
     &  CF11FSLC(INe3,ISt3)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(2,INe4,ISt3)+
     &  FD111ChiStT(2,INe4,ISt4))*MNeu(INe3))+CF11FSL(INe4,ISt4)*(M1*
     &  CF11FSRC(INe3,ISt3)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(2,INe4,ISt3)+
     &  FD111ChiStT(2,INe4,ISt4))+CF11FSLC(INe3,ISt3)*
     &  (FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(2,INe3,ISt4)-
     &  FD111ChiStT(2,INe4,ISt3)+FD111ChiStT(2,INe4,ISt4)-
     &  FD111ChiStT(3,INe3,ISt3)+FD111ChiStT(3,INe3,ISt4)+
     &  FD111ChiStT(3,INe4,ISt3)-FD111ChiStT(3,INe4,ISt4))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F11V2L(INe4,INe3)*(CF11FSL(INe4,ISt4)*
     &  (CF11FSLC(INe3,ISt3)*(FD111ChiStT(5,INe3,ISt3)-
     &  FD111ChiStT(5,INe3,ISt4)-FD111ChiStT(5,INe4,ISt3)+
     &  FD111ChiStT(5,INe4,ISt4)+FD111ChiStT(6,INe3,ISt3)-
     &  FD111ChiStT(6,INe3,ISt4)-FD111ChiStT(6,INe4,ISt3)+
     &  FD111ChiStT(6,INe4,ISt4)-2*FD111ChiStT(7,INe3,ISt3)+2*
     &  FD111ChiStT(7,INe3,ISt4)+2*FD111ChiStT(7,INe4,ISt3)-2*
     &  FD111ChiStT(7,INe4,ISt4))+M1*CF11FSRC(INe3,ISt3)*
     &  (FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(2,INe3,ISt4)-
     &  FD111ChiStT(2,INe4,ISt3)+FD111ChiStT(2,INe4,ISt4))*MNeu(INe3))+
     &  CF11FSR(INe4,ISt4)*(M1*CF11FSLC(INe3,ISt3)*
     &  (FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(2,INe3,ISt4)-
     &  FD111ChiStT(2,INe4,ISt3)+FD111ChiStT(2,INe4,ISt4))+
     &  CF11FSRC(INe3,ISt3)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(2,INe4,ISt3)+
     &  FD111ChiStT(2,INe4,ISt4)-FD111ChiStT(3,INe3,ISt3)+
     &  FD111ChiStT(3,INe3,ISt4)+FD111ChiStT(3,INe4,ISt3)-
     &  FD111ChiStT(3,INe4,ISt4))*MNeu(INe3))*MNeu(INe4))))/(4.*
     &  (MassSu(ISt3)-MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4))*
     &  (MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)))+(3*
     &  CS13S13V2(ISt4,ISt3)*(CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)**4+
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe3)**4-CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)
     &  **4-CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)**4-
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe4)**4-CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe4)
     &  **4+CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe4)**4+
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt4)*MNeu(INe4)**4+2*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu(ISt3)**4*
     &  MNeu2(INe3)+2*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu(ISt3)**4*MNeu2(INe3)-2*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu(ISt4)**4*MNeu2(INe3)-2*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu(ISt4)**4*
     &  MNeu2(INe3)+8*M12*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe3)+8*aA0TN(ISt3)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)+8*M12*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe3)+8*aA0TN(ISt3)*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe3)-8*M12*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*MNeu2(INe3)-8*aA0TN(ISt4)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu2(ISt4)*MNeu2(INe3)-8*M12*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe3)-8*aA0TN(ISt4)*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe3)+4*M1*CF11F11V2R(INe4,INe3)*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt4)*MassSu2(ISt3)*MNeu(INe3)*MNeu2(INe3)+4*M1*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe3)*MNeu2(INe3)-4*M1*CF11F11V2R(INe4,INe3)
     &  *CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*MassSu2(ISt4)*
     &  MNeu(INe3)*MNeu2(INe3)-4*M1*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)
     &  *MNeu2(INe3)+4*M1*CF11F11V2L(INe4,INe3)*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt4)*MassSu2(ISt3)*MNeu(INe4)*MNeu2(INe3)+4*M1*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe4)*MNeu2(INe3)-4*M1*CF11F11V2L(INe4,INe3)
     &  *CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*MassSu2(ISt4)*
     &  MNeu(INe4)*MNeu2(INe3)-4*M1*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe4)
     &  *MNeu2(INe3)-2*CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)-2*CF11F11V2L(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11F11V2L(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe3)**2+2*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)**2-2*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe3)**2-2*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu2(INe3)**2-4*A0TNeu(INe3)
     &  *(MassSu2(ISt3)-MassSu2(ISt4))*(CF11F11V2L(INe4,INe3)*(2*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MNeu2(INe3))+
     &  CF11F11V2R(INe4,INe3)*(2*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)-CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MNeu2(INe3)))-2*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MassSu(ISt3)**4*MNeu2(INe4)-2*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu(ISt3)**4*MNeu2(INe4)+2*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu(ISt4)**4*
     &  MNeu2(INe4)+2*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu(ISt4)**4*MNeu2(INe4)-8*M12*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)-8*aA0TN(ISt3)*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe4)-8*M12*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe4)-8*aA0TN(ISt3)*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)+8*M12*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe4)+8*aA0TN(ISt4)*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe4)+8*M12*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu2(INe4)+8*aA0TN(ISt4)*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt4)*MNeu2(INe4)-4*M1*CF11F11V2R(INe4,INe3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu2(INe4)-4*M1*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu2(INe4)+4*M1*
     &  CF11F11V2R(INe4,INe3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*
     &  MassSu2(ISt4)*MNeu(INe3)*MNeu2(INe4)+4*M1*CF11F11V2L(INe4,INe3)
     &  *CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu(INe3)*MNeu2(INe4)-4*M1*CF11F11V2L(INe4,INe3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*MassSu2(ISt3)*MNeu(INe4)
     &  *MNeu2(INe4)-4*M1*CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe4)*MNeu2(INe4)+4*M1*
     &  CF11F11V2L(INe4,INe3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt4)*
     &  MassSu2(ISt4)*MNeu(INe4)*MNeu2(INe4)+4*M1*CF11F11V2R(INe4,INe3)
     &  *CF11FSL(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu(INe4)*MNeu2(INe4)+2*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)+2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)-2*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)-2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)-2*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe4)**2-2*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe4)**2+2*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*
     &  MassSu2(ISt4)*MNeu2(INe4)**2+2*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MassSu2(ISt4)*
     &  MNeu2(INe4)**2+4*A0TNeu(INe4)*(MassSu2(ISt3)-MassSu2(ISt4))*
     &  (CF11F11V2L(INe4,INe3)*(2*CF11FSR(INe4,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-CF11FSL(INe4,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MNeu2(INe4))+CF11F11V2R(INe4,INe3)*(2*
     &  CF11FSL(INe4,ISt4)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSR(INe4,ISt4)*CF11FSRC(INe3,ISt3)*MNeu2(INe4)))))/(64.*
     &  (MassSu(ISt3)-MassSu(ISt4))*(MassSu(ISt3)+MassSu(ISt4))*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))))
              else
       selfZ=selfZ+2*((-3*CS13S13V2(ISt3,ISt3)*(CF11F11V2R(INe4,INe3)*
     &  (CF11FSR(INe4,ISt3)*(CF11FSRC(INe3,ISt3)*
     &  (FD211StChiT(6,ISt3,INe3)-FD211StChiT(6,ISt3,INe4)-2*
     &  FD211StChiT(7,ISt3,INe3)+2*FD211StChiT(7,ISt3,INe4)+
     &  FD211StChiT(9,ISt3,INe3)-FD211StChiT(9,ISt3,INe4))+M1*
     &  CF11FSLC(INe3,ISt3)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(2,ISt3,INe4))*MNeu(INe3))+CF11FSL(INe4,ISt3)*(M1*
     &  CF11FSRC(INe3,ISt3)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(2,ISt3,INe4))+CF11FSLC(INe3,ISt3)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(2,ISt3,INe4)-
     &  FD211StChiT(4,ISt3,INe3)+FD211StChiT(4,ISt3,INe4))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F11V2L(INe4,INe3)*(CF11FSL(INe4,ISt3)*
     &  (CF11FSLC(INe3,ISt3)*(FD211StChiT(6,ISt3,INe3)-
     &  FD211StChiT(6,ISt3,INe4)-2*FD211StChiT(7,ISt3,INe3)+2*
     &  FD211StChiT(7,ISt3,INe4)+FD211StChiT(9,ISt3,INe3)-
     &  FD211StChiT(9,ISt3,INe4))+M1*CF11FSRC(INe3,ISt3)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(2,ISt3,INe4))*MNeu(INe3))
     &  +CF11FSR(INe4,ISt3)*(M1*CF11FSLC(INe3,ISt3)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(2,ISt3,INe4))+
     &  CF11FSRC(INe3,ISt3)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(2,ISt3,INe4)-FD211StChiT(4,ISt3,INe3)+
     &  FD211StChiT(4,ISt3,INe4))*MNeu(INe3))*MNeu(INe4))))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+(3*CS13S13V2(ISt3,ISt3)*(3*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)**4+3*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)**4-3*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe4)**4-3*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe4)**4+8*M12*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu2(INe3)+16*aA0TN(ISt3)*
     &  CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu2(INe3)+8*M12*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu2(INe3)+16*aA0TN(ISt3)*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu2(INe3)-4*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe3)-4*
     &  CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)+4*M1*CF11F11V2R(INe4,INe3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)+
     &  4*M1*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)+4*M1*
     &  CF11F11V2L(INe4,INe3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  MNeu(INe4)*MNeu2(INe3)+4*M1*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)-
     &  2*CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*CF11F11V2L(INe4,INe3)*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*(CF11F11V2L(INe4,INe3)*(-2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu2(INe3))+
     &  CF11F11V2R(INe4,INe3)*(-2*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu2(INe3)))-8*M12*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu2(INe4)-16*
     &  aA0TN(ISt3)*CF11F11V2L(INe4,INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu2(INe4)-8*M12*CF11F11V2R(INe4,INe3)*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu2(INe4)-16*
     &  aA0TN(ISt3)*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu2(INe4)+4*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe4)+4*CF11F11V2R(INe4,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu2(INe4)-4*M1*
     &  CF11F11V2R(INe4,INe3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  MNeu(INe3)*MNeu2(INe4)-4*M1*CF11F11V2L(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu2(INe4)-
     &  4*M1*CF11F11V2L(INe4,INe3)*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4)*MNeu2(INe4)-4*M1*
     &  CF11F11V2R(INe4,INe3)*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe4)*MNeu2(INe4)+2*CF11F11V2R(INe4,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe4)+2*CF11F11V2L(INe4,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+
     &  A0TNeu(INe4)*(4*CF11F11V2L(INe4,INe3)*(2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu2(INe4))+CF11F11V2R(INe4,INe3)*(8*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-4*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu2(INe4)))))/(64.*(MNeu2(INe3)-MNeu2(INe4))))
              endif
             else
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((-3*CS13S13V2(ISt4,ISt3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11FSR(INe3,ISt4)*(CF11FSRC(INe3,ISt3)*
     &  (FD211ChiSTT(5,INe3,ISt3)-FD211ChiSTT(5,INe3,ISt4)+
     &  FD211ChiSTT(6,INe3,ISt3)-FD211ChiSTT(6,INe3,ISt4)-2*
     &  FD211ChiSTT(7,INe3,ISt3)+2*FD211ChiSTT(7,INe3,ISt4))+M1*
     &  CF11FSLC(INe3,ISt3)*(FD211ChiSTT(2,INe3,ISt3)-
     &  FD211ChiSTT(2,INe3,ISt4))*MNeu(INe3))+CF11FSL(INe3,ISt4)*(M1*
     &  CF11FSRC(INe3,ISt3)*(FD211ChiSTT(2,INe3,ISt3)-
     &  FD211ChiSTT(2,INe3,ISt4))*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  (FD211ChiSTT(2,INe3,ISt3)*MNeu(INe3)**2-
     &  FD211ChiSTT(2,INe3,ISt4)*MNeu(INe3)**2+(-
     &  FD211ChiSTT(3,INe3,ISt3)+FD211ChiSTT(3,INe3,ISt4))*MNeu2(INe3))
     &  ))+CF11F11V2L(INe3,INe3)*(CF11FSL(INe3,ISt4)*
     &  (CF11FSLC(INe3,ISt3)*(FD211ChiSTT(5,INe3,ISt3)-
     &  FD211ChiSTT(5,INe3,ISt4)+FD211ChiSTT(6,INe3,ISt3)-
     &  FD211ChiSTT(6,INe3,ISt4)-2*FD211ChiSTT(7,INe3,ISt3)+2*
     &  FD211ChiSTT(7,INe3,ISt4))+M1*CF11FSRC(INe3,ISt3)*
     &  (FD211ChiSTT(2,INe3,ISt3)-FD211ChiSTT(2,INe3,ISt4))*MNeu(INe3))
     &  +CF11FSR(INe3,ISt4)*(M1*CF11FSLC(INe3,ISt3)*
     &  (FD211ChiSTT(2,INe3,ISt3)-FD211ChiSTT(2,INe3,ISt4))*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt3)*(FD211ChiSTT(2,INe3,ISt3)*MNeu(INe3)**2-
     &  FD211ChiSTT(2,INe3,ISt4)*MNeu(INe3)**2+(-
     &  FD211ChiSTT(3,INe3,ISt3)+FD211ChiSTT(3,INe3,ISt4))*MNeu2(INe3))
     &  ))))/(4.*(MassSu(ISt3)**2-MassSu(ISt4)**2))+(3*
     &  CS13S13V2(ISt4,ISt3)*(-4*A0TNeu(INe3)*(MassSu2(ISt3)-
     &  MassSu2(ISt4))*(CF11F11V2R(INe3,INe3)*(CF11FSL(INe3,ISt4)*
     &  CF11FSLC(INe3,ISt3)*MNeu2(INe3)-CF11FSR(INe3,ISt4)*
     &  CF11FSRC(INe3,ISt3)*MNeu2(INe3))+CF11F11V2L(INe3,INe3)*(-
     &  (CF11FSL(INe3,ISt4)*CF11FSLC(INe3,ISt3)*MNeu2(INe3))+
     &  CF11FSR(INe3,ISt4)*CF11FSRC(INe3,ISt3)*MNeu2(INe3)))+
     &  CF11F11V2L(INe3,INe3)*(CF11FSR(INe3,ISt4)*(MassSu2(ISt3)-
     &  MassSu2(ISt4))*MNeu(INe3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu2(INe3)
     &  +3*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3))+
     &  CF11FSL(INe3,ISt4)*MNeu2(INe3)*(2*M1*CF11FSRC(INe3,ISt3)*
     &  (MassSu2(ISt3)-MassSu2(ISt4))*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  (MassSu(ISt3)**4+MassSu2(ISt3)*(4*M12+4*aA0TN(ISt3)+MNeu2(INe3)
     &  )-MassSu2(ISt4)*(4*M12+4*aA0TN(ISt4)+MassSu2(ISt4)+MNeu2(INe3))
     &  )))+CF11F11V2R(INe3,INe3)*(CF11FSL(INe3,ISt4)*(MassSu2(ISt3)-
     &  MassSu2(ISt4))*MNeu(INe3)*(2*M1*CF11FSRC(INe3,ISt3)*MNeu2(INe3)
     &  +3*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3))+
     &  CF11FSR(INe3,ISt4)*MNeu2(INe3)*(2*M1*CF11FSLC(INe3,ISt3)*
     &  (MassSu2(ISt3)-MassSu2(ISt4))*MNeu(INe3)+CF11FSRC(INe3,ISt3)*
     &  (MassSu(ISt3)**4+MassSu2(ISt3)*(4*M12+4*aA0TN(ISt3)+MNeu2(INe3)
     &  )-MassSu2(ISt4)*(4*M12+4*aA0TN(ISt4)+MassSu2(ISt4)+MNeu2(INe3))
     &  )))))/(32.*(MassSu2(ISt3)-MassSu2(ISt4))*MNeu(INe3)**2))
          else 
       selfZ=selfZ+2*((-3*CS13S13V2(ISt3,ISt3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11FSR(INe3,ISt3)*(CF11FSRC(INe3,ISt3)*(-2*
     &  FD221ChiStT(4,INe3,ISt3)+FD221ChiStT(6,INe3,ISt3)+
     &  FD221ChiStT(7,INe3,ISt3))+M1*CF11FSLC(INe3,ISt3)*
     &  FD221ChiStT(2,INe3,ISt3)*MNeu(INe3))+CF11FSL(INe3,ISt3)*(M1*
     &  CF11FSRC(INe3,ISt3)*FD221ChiStT(2,INe3,ISt3)*MNeu(INe3)+
     &  CF11FSLC(INe3,ISt3)*(FD221ChiStT(2,INe3,ISt3)*MNeu(INe3)**2-
     &  FD221ChiStT(5,INe3,ISt3)*MNeu2(INe3))))+CF11F11V2L(INe3,INe3)*
     &  (CF11FSL(INe3,ISt3)*(CF11FSLC(INe3,ISt3)*(-2*
     &  FD221ChiStT(4,INe3,ISt3)+FD221ChiStT(6,INe3,ISt3)+
     &  FD221ChiStT(7,INe3,ISt3))+M1*CF11FSRC(INe3,ISt3)*
     &  FD221ChiStT(2,INe3,ISt3)*MNeu(INe3))+CF11FSR(INe3,ISt3)*(M1*
     &  CF11FSLC(INe3,ISt3)*FD221ChiStT(2,INe3,ISt3)*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt3)*(FD221ChiStT(2,INe3,ISt3)*MNeu(INe3)**2-
     &  FD221ChiStT(5,INe3,ISt3)*MNeu2(INe3))))))/4.+(3*
     &  CS13S13V2(ISt3,ISt3)*(-4*A0TNeu(INe3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt3)*MNeu2(INe3)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt3)*MNeu2(INe3))+
     &  CF11F11V2L(INe3,INe3)*(-(CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt3)
     &  *MNeu2(INe3))+CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu2(INe3)))+MNeu2(INe3)*(CF11F11V2L(INe3,INe3)*
     &  (CF11FSR(INe3,ISt3)*MNeu(INe3)*(2*M1*CF11FSLC(INe3,ISt3)+3*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3))+CF11FSL(INe3,ISt3)*(2*M1*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*(4*M12+8*
     &  aA0TN(ISt3)-2*MassSu2(ISt3)+MNeu2(INe3))))+
     &  CF11F11V2R(INe3,INe3)*(CF11FSL(INe3,ISt3)*MNeu(INe3)*(2*M1*
     &  CF11FSRC(INe3,ISt3)+3*CF11FSLC(INe3,ISt3)*MNeu(INe3))+
     &  CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt3)*(4*M12+8*aA0TN(ISt3)-2*MassSu2(ISt3)+
     &  MNeu2(INe3)))))))/(32.*MNeu(INe3)**2))
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 


       !diagram 7

       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((3*CF12F4S(ISt4)*CF12F4SC(ISt3)*
     &  CS13S13V2(ISt4,ISt3)*(CF12F12V2L*MCha2*FD211ChaStB(2,ISt3)-
     &  CF12F12V2L*MCha2*FD211ChaStB(2,ISt4)-CF12F12V2L*MCha2*
     &  FD211ChaStB(3,ISt3)+CF12F12V2L*MCha2*FD211ChaStB(3,ISt4)+
     &  CF12F12V2R*FD211ChaStB(5,ISt3)-CF12F12V2R*FD211ChaStB(5,ISt4)+
     &  CF12F12V2R*FD211ChaStB(6,ISt3)-CF12F12V2R*FD211ChaStB(6,ISt4)-
     &  2*CF12F12V2R*FD211ChaStB(7,ISt3)+2*CF12F12V2R*
     &  FD211ChaStB(7,ISt4)))/(4.*(MassSu(ISt3)**2-MassSu(ISt4)**2))+
     &  (3*CF12F4S(ISt4)*CF12F4SC(ISt3)*CS13S13V2(ISt4,ISt3)*(-
     &  (CF12F12V2R*MassSu(ISt3)**4)+(4*a0tcha*CF12F12V2L-4*a0tcha*
     &  CF12F12V2R-3*CF12F12V2L*MCha2-CF12F12V2R*MCha2-4*CF12F12V2R*
     &  aA0TN(ISt3))*MassSu2(ISt3)+MassSu2(ISt4)*(-4*a0tcha*CF12F12V2L+
     &  4*a0tcha*CF12F12V2R+3*CF12F12V2L*MCha2+CF12F12V2R*MCha2+4*
     &  CF12F12V2R*aA0TN(ISt4)+CF12F12V2R*MassSu2(ISt4))))/(32.*
     &  (MassSu2(ISt3)-MassSu2(ISt4))))
              else
       selfZ=selfZ+2*((3*CF12F4S(ISt3)*CF12F4SC(ISt3)*
     &  CS13S13V2(ISt3,ISt3)*(CF12F12V2L*MCha2*FD221ChaStSb(2,ISt3)-2*
     &  CF12F12V2R*FD221ChaStSb(4,ISt3)-CF12F12V2L*MCha2*
     &  FD221ChaStSb(5,ISt3)+CF12F12V2R*FD221ChaStSb(6,ISt3)+
     &  CF12F12V2R*FD221ChaStSb(7,ISt3)))/4.+(3*CF12F4S(ISt3)*
     &  CF12F4SC(ISt3)*CS13S13V2(ISt3,ISt3)*(4*a0tcha*CF12F12V2L-4*
     &  a0tcha*CF12F12V2R-3*CF12F12V2L*MCha2-CF12F12V2R*MCha2-8*
     &  CF12F12V2R*aA0TN(ISt3)+2*CF12F12V2R*MassSu2(ISt3)))/32.)
              endif
       enddo 
       enddo 

       selfZ=selfZ+2*((3*CF12F3S*CF12F3SC*CS14S14V2*(-4*a0tcha*
     &  CF12F12V2L+8*a0t5*CF12F12V2R+4*a0tcha*CF12F12V2R+4*CF12F12V2R*
     &  M12+3*CF12F12V2L*MCha2+CF12F12V2R*MCha2-2*CF12F12V2R*MSQ2))
     &  /32.-(3*CF12F3S*CF12F3SC*CS14S14V2*(CF12F12V2L*MCha2*
     &  (FD221SBChaT(2)-FD221SBChaT(3))+CF12F12V2R*(-2*FD221SBChaT(4)+
     &  FD221SBChaT(7)+FD221SBChaT(9))))/4.)

c
c topo3+4-NoGBC
c
        !diagram 3
        ICH3=1
        ICH4=1        
       selfZ=selfZ+2*((C2W*(3*CW**2*(-6*a0t1*M12**2+(11-2*logx)*M12**3+2*
     &  (-1+logx)*M12**3)+(-14*a0t1*M12**2+M12*(-4*M12**2+(5-2*logx)*
     &  M12**2+2*(-1+logx)*M12**2))*SW**2-2*LogM12*M12**3*(3*CW**2+SW**
     &  2))*CTBS3(ICH3)*CTBS3C(ICH3)*indexdelta(ICH3,ICH3))/(64.*CW*
     &  M12**2*S2W*SW)+(C2W*CTBS3(ICH3)*CTBS3C(ICH3)*(2*(3*CW**2+SW**2)*
     &  FD221BHpT(4,ICH3)-(3*CW**2+SW**2)*FD221BHpT(6,ICH3)-3*CW**2*
     &  FD221BHpT(7,ICH3)-SW**2*FD221BHpT(7,ICH3)-3*CW**2*M12*
     &  FD221THpB(2,ICH3)+M12*SW**2*FD221THpB(2,ICH3)-8*SW**2*
     &  FD221THpB(4,ICH3)+3*CW**2*M12*FD221THpB(5,ICH3)-M12*SW**2*
     &  FD221THpB(5,ICH3)+4*SW**2*FD221THpB(6,ICH3)+4*SW**2*
     &  FD221THpB(7,ICH3))*indexdelta(ICH3,ICH3))/(8.*CW*S2W*SW))
        !diagram 4

        ICH3=1
        ICH4=1
       do INe3=1,3
       do INe4=1,3
          if( Abs(MNeu(INe3) - MNeu(INe4)) .gt. 1D-15) then 
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F11V2R(INe4,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211HpChiCha(6,ICH3,INe3)-FD211HpChiCha(6,ICH3,INe4)-2*
     &  FD211HpChiCha(7,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe4)+
     &  FD211HpChiCha(9,ICH3,INe3)-FD211HpChiCha(9,ICH3,INe4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4))*MNeu(INe3))+CF11F12S3L(INe4,ICH3)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)
     &  -FD211HpChiCha(2,ICH3,INe4))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD211HpChiCha(2,ICH3,INe3)-FD211HpChiCha(2,ICH3,INe4)-
     &  FD211HpChiCha(4,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F11V2L(INe4,INe3)*
     &  (CF11F12S3L(INe4,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD211HpChiCha(6,ICH3,INe3)-FD211HpChiCha(6,ICH3,INe4)-2*
     &  FD211HpChiCha(7,ICH3,INe3)+2*FD211HpChiCha(7,ICH3,INe4)+
     &  FD211HpChiCha(9,ICH3,INe3)-FD211HpChiCha(9,ICH3,INe4))+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4))*MNeu(INe3))+CF11F12S3R(INe4,ICH3)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)
     &  -FD211HpChiCha(2,ICH3,INe4))+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD211HpChiCha(2,ICH3,INe3)-FD211HpChiCha(2,ICH3,INe4)-
     &  FD211HpChiCha(4,ICH3,INe3)+FD211HpChiCha(4,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))))/(4.*S2W*(MNeu(INe3)**2-MNeu(INe4)**2)
     &  )+(C2W*indexdelta(ICH3,ICH3)*(8*A0TNeu(INe3)*
     &  (CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  *MNeu(INe4)-4*A0TNeu(INe3)*(CF11F11V2L(INe4,INe3)*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F11V2R(INe4,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu2(INe3)+4*A0TNeu(INe4)*(-2*
     &  (CF11F11V2R(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F11V2L(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  *MNeu(INe4)+(CF11F11V2L(INe4,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F11V2R(INe4,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  MNeu2(INe4))+CF11F11V2R(INe4,INe3)*(2*CF11F12S3L(INe4,ICH3)*
     &  MNeu(INe4)*(DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*((-1+2*
     &  logx)*MNeu2(INe3)-2*(-1+logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*
     &  logx)*MNeu2(INe4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*((-1+2*
     &  logx)*MNeu2(INe3)-(1+2*logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*
     &  logx)*MNeu2(INe4)))+CF11F12S3R(INe4,ICH3)*(-
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(MNeu2(INe3)-MNeu2(INe4))*(8*
     &  MCha2+3*MNeu2(INe3)+3*MNeu2(INe4)))+2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*((-1+2*logx)*
     &  MNeu2(INe3)-(1+2*logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*logx)*
     &  MNeu2(INe4))))+CF11F11V2L(INe4,INe3)*(2*CF11F12S3R(INe4,ICH3)*
     &  MNeu(INe4)*(DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*((-1+2*
     &  logx)*MNeu2(INe3)-2*(-1+logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*
     &  logx)*MNeu2(INe4))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*((-1+2*
     &  logx)*MNeu2(INe3)-(1+2*logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*
     &  logx)*MNeu2(INe4)))+CF11F12S3L(INe4,ICH3)*(-
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(MNeu2(INe3)-MNeu2(INe4))*(8*
     &  MCha2+3*MNeu2(INe3)+3*MNeu2(INe4)))+2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*((-1+2*logx)*
     &  MNeu2(INe3)-(1+2*logx)*(MNeu2(INe3)-MNeu2(INe4))+(1-2*logx)*MNeu2(INe4))))))/(64.*S2W*(MNeu2(INe3)-MNeu2(INe4))))
          else
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3R(INe3,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  FD221ChiHpCha(4,INe3,ICH3)+FD221ChiHpCha(6,INe3,ICH3)+
     &  FD221ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3))+CF11F12S3L(INe3,ICH3)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*FD221ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3)**2-
     &  FD221ChiHpCha(5,INe3,ICH3)*MNeu2(INe3))))+CF11F11V2L(INe3,INe3)
     &  *(CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3))*(-2*
     &  FD221ChiHpCha(4,INe3,ICH3)+FD221ChiHpCha(6,INe3,ICH3)+
     &  FD221ChiHpCha(7,INe3,ICH3))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3))+CF11F12S3R(INe3,ICH3)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*FD221ChiHpCha(2,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD221ChiHpCha(2,INe3,ICH3)*MNeu(INe3)**2-
     &  FD221ChiHpCha(5,INe3,ICH3)*MNeu2(INe3))))))/(4.*S2W)+(C2W*
     &  indexdelta(ICH3,ICH3)*(4*A0TNeu(INe3)*(CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu2(INe3)-CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))
     &  *MNeu2(INe3))+CF11F11V2L(INe3,INe3)*(-(CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu2(INe3))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu2(INe3)
     &  ))-MNeu2(INe3)*(CF11F11V2L(INe3,INe3)*(CF11F12S3R(INe3,ICH3)*
     &  MNeu(INe3)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))+3*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3))+CF11F12S3L(INe3,ICH3)
     &  *(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(4*MCha2+8*A0THpN(ICH3)-2*
     &  MassHpm(ICH3)**2+MNeu2(INe3))))+CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*MNeu(INe3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))+3*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe3))+CF11F12S3R(INe3,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(4*MCha2+8*A0THpN(ICH3)-2*
     &  MassHpm(ICH3)**2+MNeu2(INe3)))))))/(32.*S2W*MNeu(INe3)**2))
          endif
       enddo 
       enddo 

       !diagram 5

        ICH3=1
        ICH4=1
       do INe3=1,3       
       selfZ=selfZ+2*((C2W*indexdelta(ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(CF12F12V2L*MCha**2*
     &  FD221ChaHpChi(2,ICH3,INe3)-CF12F12V2L*MCha2*
     &  FD221ChaHpChi(5,ICH3,INe3)+CF12F12V2R*(-2*
     &  FD221ChaHpChi(4,ICH3,INe3)+FD221ChaHpChi(6,ICH3,INe3)+
     &  FD221ChaHpChi(7,ICH3,INe3)))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD221ChaHpChi(2,ICH3,INe3)*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(CF12F12V2R*MCha**2*FD221ChaHpChi(2,ICH3,INe3)-CF12F12V2R*
     &  MCha2*FD221ChaHpChi(5,ICH3,INe3)+CF12F12V2L*(-2*
     &  FD221ChaHpChi(4,ICH3,INe3)+FD221ChaHpChi(6,ICH3,INe3)+
     &  FD221ChaHpChi(7,ICH3,INe3)))+(CF12F12V2L+CF12F12V2R)*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD221ChaHpChi(2,ICH3,INe3)*
     &  MNeu(INe3))))/(4.*S2W)+(C2W*indexdelta(ICH3,ICH3)*
     &  (((CF12F12V2R*MCha*Abs(CF11F12S3L(INe3,ICH3))**2+CF12F12V2L*
     &  MCha*Abs(CF11F12S3R(INe3,ICH3))**2+(CF12F12V2L+CF12F12V2R)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  )*(-4*MCha2**3+(4*a0tcha-7*MCha2)*MNeu(INe3)**4+4*(2*a0tcha*
     &  MCha2-MCha2**2)*MNeu2(INe3)+(-8*a0tcha*MCha2+12*MCha2**2)*
     &  MNeu2(INe3)-(4*a0tcha-3*MCha2)*MNeu2(INe3)**2))/(MCha*(MCha2-
     &  MNeu2(INe3))**2)+(2*(CF12F12V2R*Abs(CF11F12S3L(INe3,ICH3))**2+
     &  CF12F12V2L*Abs(CF11F12S3R(INe3,ICH3))**2)*(MCha2*((4*a0tcha-
     &  MCha2)*MCha2+2*MNeu(INe3)**4)-2*(4*a0tcha*MCha2-MCha2**2)*
     &  MNeu2(INe3)+(4*a0tcha-3*MCha2)*MNeu2(INe3)**2))/(MCha2-
     &  MNeu2(INe3))**2-(2*(CF12F12V2L*Abs(CF11F12S3L(INe3,ICH3))**2+
     &  CF12F12V2R*Abs(CF11F12S3R(INe3,ICH3))**2)*(2*MCha2**2*(4*
     &  a0tcha+MCha2)+4*A0TNeu(INe3)*(MNeu(INe3)**4+MCha2*(MCha2-2*
     &  MNeu2(INe3)))-MCha2*(16*a0tcha+MCha2)*MNeu2(INe3)+(4*a0tcha-9*
     &  MCha2)*MNeu2(INe3)**2+MNeu(INe3)**4*(4*a0tcha+5*MCha2+3*
     &  MNeu2(INe3))))/(MCha2-MNeu2(INe3))**2+((CF12F12V2L*
     &  Abs(CF11F12S3L(INe3,ICH3))**2+CF12F12V2R*
     &  Abs(CF11F12S3R(INe3,ICH3))**2)*(-8*MCha2**3-MNeu(INe3)**6-8*
     &  A0TNeu(INe3)*(MNeu(INe3)**4+MCha2*(MCha2-2*MNeu2(INe3)))+
     &  MNeu(INe3)**4*(4*a0tcha-9*MCha2-MNeu2(INe3))-4*MCha2*
     &  MNeu2(INe3)*(4*a0tcha-4*MCha2+MNeu2(INe3)-2*logx*MNeu2(INe3))+
     &  MNeu2(INe3)*((2-4*logx)*MCha2**2+4*MCha2*(4*a0tcha+(-1+logx)*
     &  MCha2)+(-4*a0tcha+(9-8*logx)*MCha2)*MNeu2(INe3))))/(MCha2-
     &  MNeu2(INe3))**2+2*(CF12F12V2L*Abs(CF11F12S3L(INe3,ICH3))**2+
     &  CF12F12V2R*Abs(CF11F12S3R(INe3,ICH3))**2)*(((MNeu(INe3)**4+
     &  MCha2*(MCha2-2*MNeu2(INe3)))*(MCha2+2*MNeu2(INe3)))/(MCha2-
     &  MNeu2(INe3))**2+2*(A0TNeu(INe3)-(-1+2*logx)*(MCha-MNeu(INe3))*
     &  (MCha+MNeu(INe3))+(4*(a0tcha+A0TNeu(INe3))*(MNeu(INe3)**4+
     &  MCha2*(MCha2-2*MNeu2(INe3))))/(MCha2-MNeu2(INe3))**2-logx*
     &  MNeu2(INe3)+((MNeu(INe3)**4+MCha2*(MCha2-2*MNeu2(INe3)))*(-
     &  (MCha2*A0TNeu(INe3))+(-a0tcha+MCha2)*MNeu2(INe3)))/(MCha**3-
     &  MCha*MNeu2(INe3))**2+(MCha2*(-2*a0tcha+MCha2+2*logx*MCha2)+
     &  (a0tcha-(1+logx)*MCha2)*MNeu2(INe3))/MCha**2))))/(64.*S2W))
       enddo 
c
c topo3+4-GBC
c
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
       do INH7=1,6
          if( Abs(-Mah(INH3) + Mah(INH6)) .gt. 1D-15) then 
          if( Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH6,INH7)*
     &  CS1S1V2(INH3,INH6)*CS1S1V2(INH4,INH7)*
     &  (FD111HHH(2,INH3,INH4,INH5)-FD111HHH(2,INH3,INH7,INH5)-
     &  FD111HHH(2,INH4,INH6,INH5)+FD111HHH(2,INH6,INH7,INH5)))/(8.*
     &  (Mah(INH3)-Mah(INH6))*(Mah(INH3)+Mah(INH6))*(Mah(INH4)-
     &  Mah(INH7))*(Mah(INH4)+Mah(INH7)))-(CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1V2(INH3,INH6)*CS1S1V2(INH4,INH7)*
     &  (Mah2(INH3)-Mah2(INH6))*(Mah2(INH4)-Mah2(INH7)))/(32.*
     &  (Mah(INH3)-Mah(INH6))*(Mah(INH3)+Mah(INH6))*(Mah(INH4)-
     &  Mah(INH7))*(Mah(INH4)+Mah(INH7))))
              else
          if( Abs(Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH6,INH4)*
     &  CS1S1V2(INH3,INH6)*CS1S1V2(INH4,INH4)*
     &  (FD211HHH(2,INH4,INH3,INH5)-FD211HHH(2,INH4,INH6,INH5)))/(8.*
     &  (Mah(INH3)**2-Mah(INH6)**2))+(CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH6,INH4)*CS1S1V2(INH3,INH6)*CS1S1V2(INH4,INH4)*
     &  (-Mah2(INH3)+Mah2(INH6)))/(32.*(Mah2(INH3)-Mah2(INH6))))
              endif
              endif
              else
          if( Abs(Mah(INH6)) .gt. 1D-15) then 
          if( Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH3,INH7)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH7)*
     &  (FD211HHH(2,INH3,INH4,INH5)-FD211HHH(2,INH3,INH7,INH5)))/(8.*
     &  (Mah(INH4)**2-Mah(INH7)**2))+(CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH7)*CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH7)*
     &  (-Mah2(INH4)+Mah2(INH7)))/(32.*(Mah2(INH4)-Mah2(INH7))))
              else
          if( Abs(Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+(-(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH3,INH4)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH4))/32.+
     &  (CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH3,INH4)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH4)*
     &  FD221HHH(2,INH3,INH4,INH5))/8.)
              endif
              endif
              endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3=1,6
       do INH4=1,6
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W*IC*CS1S1V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH5)*indexdelta(ICH5,ICH3)*(Mah2(INH3)-
     &  Mah2(INH4)))/(8.*S2W*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)
     &  ))+(C2W*IC*CS1S1V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH5)*(-FD111HHpHp(2,INH3,ICH3,ICH4)+
     &  FD111HHpHp(2,INH3,ICH5,ICH4)+FD111HHpHp(2,INH4,ICH3,ICH4)-
     &  FD111HHpHp(2,INH4,ICH5,ICH4))*indexdelta(ICH5,ICH3))/(2.*S2W*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(MassHpm(ICH3)-
     &  MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))))
              else
          if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W*IC*CS1S1V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(-FD211HpHHp(2,ICH3,INH3,ICH4)+
     &  FD211HpHHp(2,ICH3,INH4,ICH4))*indexdelta(ICH3,ICH3))/(2.*S2W*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)))+(C2W*IC*
     &  CS1S1V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*indexdelta(ICH3,ICH3)*(Mah2(INH3)-
     &  Mah2(INH4)))/(8.*S2W*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4)
     &  )))
              endif
              endif
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W*IC*CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH5)*indexdelta(ICH5,ICH3))/(8.*S2W)+(C2W*
     &  IC*CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH5)*(-FD211HHpHp(2,INH3,ICH3,ICH4)+
     &  FD211HHpHp(2,INH3,ICH5,ICH4))*indexdelta(ICH5,ICH3))/(2.*S2W*
     &  (MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))))
              else
          if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W*IC*CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*indexdelta(ICH3,ICH3))/(8.*S2W)-(C2W*
     &  IC*CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*FD221HHpHp(2,INH3,ICH3,ICH4)*
     &  indexdelta(ICH3,ICH3))/(2.*S2W))
              endif
              endif
              endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
       do INH3=1,6
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH5)*indexdelta(ICH4,ICH6)*
     &  indexdelta(ICH5,ICH3))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH6,ICH5)*
     &  (FD111HpHpH(2,ICH3,ICH4,INH3)-FD111HpHpH(2,ICH3,ICH6,INH3)-
     &  FD111HpHpH(2,ICH4,ICH5,INH3)+FD111HpHpH(2,ICH5,ICH6,INH3))*
     &  indexdelta(ICH4,ICH6)*indexdelta(ICH5,ICH3))/(4.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  (MassHpm(ICH4)-MassHpm(ICH6))*(MassHpm(ICH4)+MassHpm(ICH6))))
              else
          if( Abs(MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH5)*indexdelta(ICH4,ICH4)*
     &  indexdelta(ICH5,ICH3))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  (FD211HpHpH(2,ICH4,ICH3,INH3)-FD211HpHpH(2,ICH4,ICH5,INH3))*
     &  indexdelta(ICH4,ICH4)*indexdelta(ICH5,ICH3))/(4.*S2W**2*
     &  (MassHpm(ICH3)**2-MassHpm(ICH5)**2)))
              endif
              endif
              else
          if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH6))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH6,ICH3)*
     &  (FD211HpHpH(2,ICH3,ICH4,INH3)-FD211HpHpH(2,ICH3,ICH6,INH3))*
     &  indexdelta(ICH3,ICH3)*indexdelta(ICH4,ICH6))/(4.*S2W**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH6)**2)))
              else
          if( Abs(MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH4))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD221HpHpH(2,ICH3,ICH4,INH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH4))/(4.*S2W**2))
              endif
              endif
              endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do INH3=1,6
       do INH4=1,6
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*IC*CS13S13V2(ISt5,ISt3)*CS1S1V2(INH3,INH4)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt5))/8.+(3*IC*
     &  CS13S13V2(ISt5,ISt3)*CS1S1V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt5)*(FD111HSTST(2,INH3,ISt3,ISt4)-
     &  FD111HSTST(2,INH3,ISt5,ISt4)-FD111HSTST(2,INH4,ISt3,ISt4)+
     &  FD111HSTST(2,INH4,ISt5,ISt4)))/(2.*(Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(MassSu(ISt3)-MassSu(ISt5))*(MassSu(ISt3)
     &  +MassSu(ISt5))))
              else
          if( Abs(MassSu(ISt5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*IC*CS13S13V2(ISt3,ISt3)*CS1S1V2(INH3,INH4)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3))/8.+(3*IC*
     &  CS13S13V2(ISt3,ISt3)*CS1S1V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD211StHSt(2,ISt3,INH3,ISt4)-
     &  FD211StHSt(2,ISt3,INH4,ISt4)))/(2.*(Mah(INH3)**2-Mah(INH4)**2))
     &  )
              endif
              endif
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*IC*CS13S13V2(ISt5,ISt3)*CS1S1V2(INH3,INH3)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt5))/8.+(3*IC*
     &  CS13S13V2(ISt5,ISt3)*CS1S1V2(INH3,INH3)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt4,ISt5)*(FD211HSTST(2,INH3,ISt3,ISt4)-
     &  FD211HSTST(2,INH3,ISt5,ISt4)))/(2.*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2)))
              else
          if( Abs(MassSu(ISt5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*IC*CS13S13V2(ISt3,ISt3)*CS1S1V2(INH3,INH3)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3))/8.+(3*IC*
     &  CS13S13V2(ISt3,ISt3)*CS1S1V2(INH3,INH3)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt4,ISt3)*FD221HStSt(2,INH3,ISt3,ISt4))/2.)
              endif
              endif
              endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W*CS13S13V2(ISt4,ISt3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt4)*indexdelta(ICH4,ICH3))/(8.*S2W)+(3*C2W*
     &  CS13S13V2(ISt4,ISt3)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt4)*
     &  (FD111HpSTSB(2,ICH3,ISt3)-FD111HpSTSB(2,ICH3,ISt4)-
     &  FD111HpSTSB(2,ICH4,ISt3)+FD111HpSTSB(2,ICH4,ISt4))*
     &  indexdelta(ICH4,ICH3))/(2.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4))))
              else
          if( Abs(MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W*CS13S13V2(ISt3,ISt3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,ICH3))/(8.*S2W)+(3*C2W*
     &  CS13S13V2(ISt3,ISt3)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  (FD211StHpSb(2,ISt3,ICH3)-FD211StHpSb(2,ISt3,ICH4))*
     &  indexdelta(ICH4,ICH3))/(2.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))))
              endif
              endif
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W*CS13S13V2(ISt4,ISt3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH3,ISt4)*indexdelta(ICH3,ICH3))/(8.*S2W)+(3*C2W*
     &  CS13S13V2(ISt4,ISt3)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  (FD211HpSTSB(2,ICH3,ISt3)-FD211HpSTSB(2,ICH3,ISt4))*
     &  indexdelta(ICH3,ICH3))/(2.*S2W*(MassSu(ISt3)-MassSu(ISt4))*
     &  (MassSu(ISt3)+MassSu(ISt4))))
              else
          if( Abs(MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W*CS13S13V2(ISt3,ISt3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH3))/(8.*S2W)+(3*C2W*
     &  CS13S13V2(ISt3,ISt3)*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  FD221HpStSb(2,ICH3,ISt3)*indexdelta(ICH3,ICH3))/(2.*S2W))
              endif
              endif
              endif
              endif
       enddo 
       enddo 
       enddo 
       enddo

       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W*CS14S14V2*(CS3S13S(ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH4)+CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,ICH3)))/(16.*S2W)-(3*C2W*
     &  CS14S14V2*(FD211SBHpSt(2,ICH3,ISt3)-FD211SBHpSt(2,ICH4,ISt3))*
     &  (CS3S13S(ICH4,ISt3)*CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH4)+
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,ICH3)))
     &  /(4.*S2W*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))))
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W*CS14S14V2*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH3))/(8.*S2W)-(3*C2W*
     &  CS14S14V2*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  FD221SBHpSt(2,ICH3,ISt3)*indexdelta(ICH3,ICH3))/(2.*S2W))
              endif
              endif
       enddo 
       enddo 
       enddo 
c
c topo5-NoGBC
c

        INH3=6
        INH6=6
        ! diagram1
       do INH4=1,6
       do INH5=1,6
       do INH7=1,6
        
        !UV
        
          if( Abs(Mah(INH4) - Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(6,INH4,INH5)*CS1S1S1(INH5,6,INH7)*
     &  CS1S1V2(6,6)*CS1S1V2(INH4,INH7)*(FD211HHH(2,6,INH4,INH5)-
     &  FD211HHH(2,6,INH7,INH5)))/(8.*(Mah(INH4)**2-Mah(INH7)**2))+
     &  (CS1S1S1(6,INH4,INH5)*CS1S1S1(INH5,6,INH7)*CS1S1V2(6,6)*
     &  CS1S1V2(INH4,INH7)*((-1+2*logx)*Mah2(INH4)-(1+2*logx)*
     &  (Mah2(INH4)-Mah2(INH7))+(1-2*logx)*Mah2(INH7)))/(64.*
     &  (Mah2(INH4)-Mah2(INH7))))
          else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH3,INH4)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH4)*
     &  FD221HHH(2,INH3,INH4,INH5))/8.-(CS1S1S1(6,INH4,INH5)*
     &  CS1S1S1(INH5,6,INH4)*CS1S1V2(6,6)*CS1S1V2(INH4,INH4)*Mah2(INH4)
     &  )/(32.*Mah(INH4)**2))
            else
       selfZ=selfZ+(-(CS1S1S1(6,INH4,INH5)*CS1S1S1(INH5,6,INH4)*
     &  CS1S1V2(6,6)*CS1S1V2(INH4,INH4))/32.+(CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH4)*CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH4)*
     &  FD221HHH(2,INH3,INH4,INH5))/8.)
            endif
          endif
       enddo 
       enddo 
       enddo 


        INH4=6
        INH7=6
        ! diagram1
       do INH3=1,6
       do INH5=1,6
       do INH6=1,6
        
        !UV
        
          if( Abs(Mah(INH3) - Mah(INH6)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,6,INH5)*CS1S1S1(INH5,INH6,6)*
     &  CS1S1V2(6,6)*CS1S1V2(INH3,INH6)*(FD211HHH(2,6,INH3,INH5)-
     &  FD211HHH(2,6,INH6,INH5)))/(8.*(Mah(INH3)**2-Mah(INH6)**2))+
     &  (CS1S1S1(INH3,6,INH5)*CS1S1S1(INH5,INH6,6)*CS1S1V2(6,6)*
     &  CS1S1V2(INH3,INH6)*((-1+2*logx)*Mah2(INH3)-(1+2*logx)*
     &  (Mah2(INH3)-Mah2(INH6))+(1-2*logx)*Mah2(INH6)))/(64.*
     &  (Mah2(INH3)-Mah2(INH6))))
          else
          if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH5,INH3,INH4)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH4,INH4)*
     &  FD221HHH(2,INH3,INH4,INH5))/8.-(CS1S1S1(INH3,6,INH5)*
     &  CS1S1S1(INH5,INH3,6)*CS1S1V2(6,6)*CS1S1V2(INH3,INH3)*Mah2(INH3)
     &  )/(32.*Mah(INH3)**2))
            endif
          endif
       enddo 
       enddo 
       enddo 

        INH3=6
        INH4=6
        ! diagram2
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
          if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+(((0D0,0.125)*C2W*CS1S1V2(6,6)*CS1S3S3(6,ICH3,ICH4)*
     &  CS1S3S3(6,ICH4,ICH5)*indexdelta(ICH5,ICH3))/S2W-((0D0,0.5)*C2W*
     &  CS1S1V2(6,6)*CS1S3S3(6,ICH3,ICH4)*CS1S3S3(6,ICH4,ICH5)*
     &  (FD211HHpHp(2,6,ICH3,ICH4)-FD211HHpHp(2,6,ICH5,ICH4))*
     &  indexdelta(ICH5,ICH3))/(S2W*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)
     &  ))
          else
          if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+(((0D0,0.125)*C2W*CS1S1V2(6,6)*CS1S3S3(6,ICH3,ICH4)*
     &  CS1S3S3(6,ICH4,ICH3)*indexdelta(ICH3,ICH3))/S2W-((0D0,0.5)*C2W*
     &  CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*FD221HHpHp(2,INH3,ICH3,ICH4)*
     &  indexdelta(ICH3,ICH3))/S2W)
            else
       selfZ=selfZ+(((0D0,0.125)*C2W*CS1S1V2(6,6)*CS1S3S3(6,ICH3,ICH4)*
     &  CS1S3S3(6,ICH4,ICH3)*indexdelta(ICH3,ICH3))/S2W-((0D0,0.5)*C2W*
     &  CS1S1V2(INH3,INH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*FD221HHpHp(2,INH3,ICH3,ICH4)*
     &  indexdelta(ICH3,ICH3))/S2W)
            endif
          endif
       enddo 
       enddo 
       enddo 


        ICH3=1
        ICH5=1
        ! diagram2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
          if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+(((0D0,-0.5)*C2W*CS1S1V2(INH3,INH4)*
     &  CS1S3S3(INH3,1,ICH4)*CS1S3S3(INH4,ICH4,1)*
     &  (FD211HpHHp(2,1,INH3,ICH4)-FD211HpHHp(2,1,INH4,ICH4))*
     &  indexdelta(1,1))/(S2W*(Mah(INH3)**2-Mah(INH4)**2))-
     &  ((0D0,0.0625)*C2W*CS1S1V2(INH3,INH4)*CS1S3S3(INH3,1,ICH4)*
     &  CS1S3S3(INH4,ICH4,1)*indexdelta(1,1)*((-1+2*logx)*Mah2(INH3)-
     &  (1+2*logx)*(Mah2(INH3)-Mah2(INH4))+(1-2*logx)*Mah2(INH4)))
     &  /(S2W*(Mah2(INH3)-Mah2(INH4))))
          else
          if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+(((0D0,-0.5)*C2W*CS1S1V2(INH3,INH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD221HHpHp(2,INH3,ICH3,ICH4)*indexdelta(ICH3,ICH3))/S2W+
     &  ((0D0,0.125)*C2W*CS1S1V2(INH3,INH3)*CS1S3S3(INH3,1,ICH4)*
     &  CS1S3S3(INH3,ICH4,1)*indexdelta(1,1)*Mah2(INH3))/(S2W*Mah(INH3)
     &  **2))
            endif
          endif
       enddo 
       enddo 
       enddo 

        ICH3=1
        ICH5=1
        ! diagram3
       do ICH4=1,2
       do ICH6=1,2
       do INH3=1,6
          if( Abs(MassHpm(ICH4) - MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH4)*CS1S3S3(INH3,ICH6,1)*
     &  indexdelta(1,1)*indexdelta(ICH4,ICH6))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,1,ICH4)*CS1S3S3(INH3,ICH6,1)*
     &  (FD211HpHpH(2,1,ICH4,INH3)-FD211HpHpH(2,1,ICH6,INH3))*
     &  indexdelta(1,1)*indexdelta(ICH4,ICH6))/(4.*S2W**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH6)**2)))
          else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH4)*CS1S3S3(INH3,ICH4,1)*
     &  indexdelta(1,1)*indexdelta(ICH4,ICH4))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD221HpHpH(2,ICH3,ICH4,INH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH4))/(4.*S2W**2))
            else
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH4)*CS1S3S3(INH3,ICH4,1)*
     &  indexdelta(1,1)*indexdelta(ICH4,ICH4))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD221HpHpH(2,ICH3,ICH4,INH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH4))/(4.*S2W**2))
            endif
          endif
       enddo 
       enddo 
       enddo 


        ICH4=1
        ICH6=1
        ! diagram3
       do ICH3=1,2
       do ICH5=1,2
       do INH3=1,6
          if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH3,1)*
     &  indexdelta(1,1)*indexdelta(ICH5,ICH3))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH3,1)*
     &  (FD211HpHpH(2,1,ICH3,INH3)-FD211HpHpH(2,1,ICH5,INH3))*
     &  indexdelta(1,1)*indexdelta(ICH5,ICH3))/(4.*S2W**2*
     &  (MassHpm(ICH3)**2-MassHpm(ICH5)**2)))
          else
          if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH3)*CS1S3S3(INH3,ICH3,1)*
     &  indexdelta(1,1)*indexdelta(ICH3,ICH3))/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD221HpHpH(2,ICH3,ICH4,INH3)*indexdelta(ICH3,ICH3)*
     &  indexdelta(ICH4,ICH4))/(4.*S2W**2))
            endif
          endif
       enddo 
       enddo 
       enddo 

        INH3=6
        INH4=6
        ! diagram4
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
          if( Abs(MassSu(ISt3) - MassSu(ISt5)) .gt. 1D-15) then 
       selfZ=selfZ+((0D0,-0.375)*CS13S13V2(ISt5,ISt3)*CS1S1V2(6,6)*
     &  CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt5)+((0D0,1.5)*
     &  CS13S13V2(ISt5,ISt3)*CS1S1V2(6,6)*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt5)*(FD211HSTST(2,6,ISt3,ISt4)-
     &  FD211HSTST(2,6,ISt5,ISt4)))/(MassSu(ISt3)**2-MassSu(ISt5)**2))
          else
          if( Abs(MassSu(ISt3)) .gt. 1D-15) then 
       selfZ=selfZ+((0D0,-0.375)*CS13S13V2(ISt3,ISt3)*CS1S1V2(6,6)*
     &  CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt3)+(0D0,1.5)*
     &  CS13S13V2(ISt3,ISt3)*CS1S1V2(INH3,INH3)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt4,ISt3)*FD221HStSt(2,INH3,ISt3,ISt4))
            endif
          endif
       enddo 
       enddo 
       enddo 
        ICH3=1
        ICH4=1
        ! diagram5
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(MassSu(ISt3) - MassSu(ISt4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W*CS13S13V2(ISt4,ISt3)*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt4)*indexdelta(1,1))/(8.*S2W)+(3*C2W*
     &  CS13S13V2(ISt4,ISt3)*CS3S13S(1,ISt3)*CS3S13SC(1,ISt4)*
     &  (FD211HpSTSB(2,1,ISt3)-FD211HpSTSB(2,1,ISt4))*indexdelta(1,1))
     &  /(2.*S2W*(MassSu(ISt3)**2-MassSu(ISt4)**2)))
          else
          if( Abs(MassSu(ISt3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W*CS13S13V2(ISt3,ISt3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH3,ISt3)*FD221HpStSb(2,ICH3,ISt3)*
     &  indexdelta(ICH3,ICH3))/(2.*S2W)-(3*C2W*CS13S13V2(ISt3,ISt3)*
     &  CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*indexdelta(1,1)*(MSQ2-
     &  MassSu2(ISt3))**2*MassSu2(ISt3))/(8.*S2W*(-(MSQ2*MassSu(ISt3))+
     &  MassSu(ISt3)**3)**2))
            endif
          endif
       enddo 
       enddo 
        ICH3=1
        ICH4=1
        ! diagram6
       do ISt3=1,2 
       selfZ=selfZ+((-3*C2W*CS14S14V2*CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*
     &  FD221SBHpSt(2,1,ISt3)*indexdelta(1,1))/(2.*S2W)-(3*C2W*
     &  CS14S14V2*CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*indexdelta(1,1)*(-2*
     &  MSQ2**3-2*MassSu2(ISt3)*(-2*MSQ2**2+MSQ2*MassSu2(ISt3))))/(16.*
     &  MSQ2*S2W*(MSQ2-MassSu2(ISt3))**2))
       enddo 
c
c topo5-GBC
c

       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
       do INe6=1,3
       do INH3=1,6
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe6))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2R(INe3,INe4)*(CF11F11V2R(INe6,INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe6,INH3)*
     &  MNeu(INe6)*(FD111ChiChiH(2,INe5,INe6,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(MNeu(INe4)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe4)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  +CFF11S1L(INe4,INe5,INH3)*(CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*
     &  MNeu(INe6)*(FD111ChiChiH(4,INe6,INe5,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe4)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*
     &  (FD111ChiChiH(5,INe6,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiChiH(5,INe3,INe5,INH3)*(MNeu(INe4)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(5,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  )+2*CF11F11V2L(INe6,INe3)*MNeu(INe3)*(CFF11S1R(INe5,INe6,INH3)*
     &  MNeu(INe6)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)*
     &  (FD111ChiChiH(1,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*(FD111ChiChiH(2,INe5,INe6,INH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(-
     &  MNeu(INe4)**2+MNeu(INe6)**2)))+CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(2,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2)))
     &  ))+CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe6,INe3)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(2,INe5,INe6,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(MNeu(INe4)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe4)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  +CFF11S1L(INe5,INe6,INH3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  MNeu(INe5)*(FD111ChiChiH(4,INe6,INe5,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe4)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe4,INe5,INH3)*
     &  (FD111ChiChiH(5,INe6,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiChiH(5,INe3,INe5,INH3)*(MNeu(INe4)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(5,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  )+2*CF11F11V2R(INe6,INe3)*MNeu(INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*(FD111ChiChiH(2,INe5,INe6,INH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(-
     &  MNeu(INe4)**2+MNeu(INe6)**2)))+CFF11S1R(INe4,INe5,INH3)*
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)*
     &  (FD111ChiChiH(2,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2)))
     &  )))/(4.*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)-MNeu(INe6))*(MNeu(INe4)-MNeu(INe6))*(MNeu(INe3)+
     &  MNeu(INe6))*(MNeu(INe4)+MNeu(INe6)))+((2*MNeu(INe5)*
     &  (CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)+
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe6))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  (CFF11S1L(INe4,INe5,INH3)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)))*
     &  (4*A0TNeu(INe3)*MNeu2(INe3)+4*A0TNH(INH3)*MNeu2(INe3)+3*
     &  Mah2(INH3)*MNeu2(INe3)+3*MNeu2(INe3)**2+4*A0TNeu(INe5)*
     &  (Mah2(INH3)+MNeu2(INe3))+4*A0TNH(INH3)*MNeu2(INe5)+2*Mah2(INH3)
     &  *MNeu2(INe5)+3*MNeu2(INe3)*MNeu2(INe5)))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe6))*
     &  (MNeu(INe3)+MNeu(INe6)))-(2*MNeu(INe5)*(CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe6,INe3)*(CFF11S1R(INe4,INe5,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)+CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6))+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe6,INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)))*(4*A0TNeu(INe4)*
     &  MNeu2(INe4)+4*A0TNH(INH3)*MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe4)+
     &  3*MNeu2(INe4)**2+4*A0TNeu(INe5)*(Mah2(INH3)+MNeu2(INe4))+4*
     &  A0TNH(INH3)*MNeu2(INe5)+2*Mah2(INH3)*MNeu2(INe5)+3*MNeu2(INe4)*
     &  MNeu2(INe5)))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe4)-MNeu(INe6))*(MNeu(INe4)+MNeu(INe6)))+
     &  ((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*(4*
     &  A0TNeu(INe3)*MNeu(INe3)**4+2*Mah2(INH3)*MNeu(INe3)**4+4*
     &  Mah2(INH3)*MNeu(INe5)**4-3*Mah2(INH3)**2*MNeu2(INe3)+MNeu(INe3)
     &  **4*MNeu2(INe3)+MNeu(INe5)**4*MNeu2(INe3)+2*MNeu2(INe3)**3+8*
     &  A0TNeu(INe5)*Mah2(INH3)*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe3)*
     &  MNeu2(INe5)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe5)+4*MNeu2(INe3)*
     &  *2*MNeu2(INe5)+2*MNeu2(INe3)*MNeu2(INe5)**2+A0TNH(INH3)*(8*
     &  MNeu(INe3)**4+8*MNeu(INe5)**4-4*Mah2(INH3)*MNeu2(INe3)+8*
     &  MNeu2(INe3)*MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)
     &  +MNeu(INe4))*(MNeu(INe3)-MNeu(INe6))*(MNeu(INe3)+MNeu(INe6)))-
     &  ((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*(4*
     &  A0TNeu(INe4)*MNeu(INe4)**4+2*Mah2(INH3)*MNeu(INe4)**4+4*
     &  Mah2(INH3)*MNeu(INe5)**4-3*Mah2(INH3)**2*MNeu2(INe4)+MNeu(INe4)
     &  **4*MNeu2(INe4)+MNeu(INe5)**4*MNeu2(INe4)+2*MNeu2(INe4)**3+8*
     &  A0TNeu(INe5)*Mah2(INH3)*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe4)*
     &  MNeu2(INe5)+2*Mah2(INH3)*MNeu2(INe4)*MNeu2(INe5)+4*MNeu2(INe4)*
     &  *2*MNeu2(INe5)+2*MNeu2(INe4)*MNeu2(INe5)**2+A0TNH(INH3)*(8*
     &  MNeu(INe4)**4+8*MNeu(INe5)**4-4*Mah2(INH3)*MNeu2(INe4)+8*
     &  MNeu2(INe4)*MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)
     &  +MNeu(INe4))*(MNeu(INe4)-MNeu(INe6))*(MNeu(INe4)+MNeu(INe6)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*MNeu(INe4)*
     &  MNeu(INe6)*(3*Mah2(INH3)**2-MNeu(INe3)**4-MNeu(INe5)**4-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-2*MNeu2(INe3)**2-4*A0TNeu(INe5)*
     &  MNeu2(INe5)-4*MNeu2(INe3)*MNeu2(INe5)-2*MNeu2(INe5)**2-2*
     &  Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe5))+4*A0TNH(INH3)*(Mah2(INH3)-
     &  2*(MNeu2(INe3)+MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe6))*(MNeu(INe3)+
     &  MNeu(INe6)))+((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*MNeu(INe4)*
     &  MNeu(INe6)*(3*Mah2(INH3)**2-MNeu(INe4)**4-MNeu(INe5)**4-4*
     &  A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe4)**2-4*A0TNeu(INe5)*
     &  MNeu2(INe5)-4*MNeu2(INe4)*MNeu2(INe5)-2*MNeu2(INe5)**2-2*
     &  Mah2(INH3)*(MNeu2(INe4)+MNeu2(INe5))+4*A0TNH(INH3)*(Mah2(INH3)-
     &  2*(MNeu2(INe4)+MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe6))*(MNeu(INe4)+
     &  MNeu(INe6)))-(2*MNeu(INe5)*(CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe6,INe3)*(CFF11S1R(INe4,INe5,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe4)+CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6))+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe6,INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH3)*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)))*(2*Mah2(INH3)*MNeu2(INe5)
     &  +4*A0TNeu(INe6)*MNeu2(INe6)+3*Mah2(INH3)*MNeu2(INe6)+3*
     &  MNeu2(INe5)*MNeu2(INe6)+3*MNeu2(INe6)**2+4*A0TNeu(INe5)*
     &  (Mah2(INH3)+MNeu2(INe6))+4*A0TNH(INH3)*(MNeu2(INe5)+MNeu2(INe6)
     &  )))/((MNeu(INe3)-MNeu(INe6))*(MNeu(INe3)+MNeu(INe6))*(-
     &  MNeu(INe4)+MNeu(INe6))*(MNeu(INe4)+MNeu(INe6)))+
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*MNeu(INe4)*
     &  MNeu(INe6)*(3*Mah2(INH3)**2-MNeu(INe5)**4-MNeu(INe6)**4-4*
     &  A0TNeu(INe5)*MNeu2(INe5)-2*MNeu2(INe5)**2-4*A0TNeu(INe6)*
     &  MNeu2(INe6)-4*MNeu2(INe5)*MNeu2(INe6)-2*MNeu2(INe6)**2-2*
     &  Mah2(INH3)*(MNeu2(INe5)+MNeu2(INe6))+4*A0TNH(INH3)*(Mah2(INH3)-
     &  2*(MNeu2(INe5)+MNeu2(INe6)))))/((MNeu(INe3)-MNeu(INe6))*
     &  (MNeu(INe3)+MNeu(INe6))*(-MNeu(INe4)+MNeu(INe6))*(MNeu(INe4)+
     &  MNeu(INe6)))-((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe4,INe5,INH3)+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe6,INH3))*(-3*
     &  Mah2(INH3)**2*MNeu2(INe6)+A0TNH(INH3)*(8*MNeu(INe5)**4+8*
     &  MNeu(INe6)**4-4*(Mah2(INH3)-2*MNeu2(INe5))*MNeu2(INe6))+2*
     &  Mah2(INH3)*(2*MNeu(INe5)**4+MNeu(INe6)**4+MNeu2(INe5)*(4*
     &  A0TNeu(INe5)+MNeu2(INe6)))+MNeu2(INe6)*(MNeu(INe5)**4+
     &  MNeu(INe6)**4+2*(2*A0TNeu(INe5)*MNeu2(INe5)+MNeu2(INe5)**2+2*
     &  A0TNeu(INe6)*MNeu2(INe6)+2*MNeu2(INe5)*MNeu2(INe6)+MNeu2(INe6)*
     &  *2))))/((MNeu(INe3)-MNeu(INe6))*(MNeu(INe3)+MNeu(INe6))*
     &  (-MNeu(INe4)+MNeu(INe6))*(MNeu(INe4)+MNeu(INe6))))/64.)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe6))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2R(INe3,INe3)*(CF11F11V2R(INe6,INe3)*
     &  (CFF11S1R(INe3,INe5,INH3)*MNeu(INe3)*(CFF11S1L(INe5,INe6,INH3)*
     &  MNeu(INe6)*(-FD111ChiChiH(2,INe3,INe5,INH3)+
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*
     &  MNeu(INe5)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe6,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)))+CFF11S1L(INe3,INe5,INH3)*
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*(-FD111ChiChiH(5,INe3,INe5,INH3)+
     &  FD111ChiChiH(5,INe6,INe5,INH3)+FD211ChiChiH(5,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2))))+2*CF11F11V2L(INe6,INe3)*
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)*(CFF11S1R(INe3,INe5,INH3)*
     &  MNeu(INe3)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2))+CFF11S1L(INe3,INe5,INH3)*
     &  MNeu(INe5)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe6,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2)))+CFF11S1R(INe5,INe6,INH3)*
     &  MNeu(INe6)*(CFF11S1L(INe3,INe5,INH3)*MNeu(INe3)*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe3,INe5,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe5,INe6,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))*
     &  MNeu2(INe3))))+CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe6,INe3)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)*(CFF11S1L(INe3,INe5,INH3)*
     &  MNeu(INe3)*(-FD111ChiChiH(2,INe3,INe5,INH3)+
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2))+CFF11S1R(INe3,INe5,INH3)*
     &  MNeu(INe5)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe6,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)))+CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1L(INe3,INe5,INH3)*MNeu(INe3)*MNeu(INe5)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2))+
     &  CFF11S1R(INe3,INe5,INH3)*(-FD111ChiChiH(5,INe3,INe5,INH3)+
     &  FD111ChiChiH(5,INe6,INe5,INH3)+FD211ChiChiH(5,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2))))+2*CF11F11V2R(INe6,INe3)*
     &  (CFF11S1R(INe3,INe5,INH3)*MNeu(INe3)*(CFF11S1L(INe5,INe6,INH3)*
     &  MNeu(INe6)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*
     &  MNeu(INe5)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe6,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2)))+CFF11S1L(INe3,INe5,INH3)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)**2*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe5,INe6,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))*
     &  MNeu2(INe3)))))/(4.*(MNeu(INe3)**2-MNeu(INe6)**2)**2)+(-4*
     &  A0TNH(INH3)*(2*CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe3)*
     &  CFF11S1L(INe5,INe6,INH3)*CFF11S1R(INe3,INe5,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe6)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe6))+2*
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe3)*
     &  CFF11S1L(INe3,INe5,INH3)*CFF11S1R(INe5,INe6,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe6)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe6)))+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe6,INe3)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)*(4*A0TNeu(INe3)*
     &  (CFF11S1L(INe3,INe5,INH3)*MNeu(INe3)+2*CFF11S1R(INe3,INe5,INH3)
     &  *MNeu(INe5))*(MNeu2(INe3)-2*MNeu2(INe6))+
     &  CFF11S1L(INe3,INe5,INH3)*MNeu(INe3)*(-MNeu(INe3)**4+MNeu(INe6)*
     &  *4+4*A0TNeu(INe6)*MNeu2(INe6)-2*MNeu2(INe3)*MNeu2(INe6)+2*
     &  MNeu2(INe6)**2)+2*CFF11S1R(INe3,INe5,INH3)*MNeu(INe5)*(-
     &  MNeu2(INe3)**2+4*A0TNeu(INe6)*MNeu2(INe6)-2*MNeu2(INe3)*
     &  MNeu2(INe6)+3*MNeu2(INe6)**2))+CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1R(INe3,INe5,INH3)*(5*MNeu(INe3)**6-MNeu(INe3)**4*
     &  MNeu2(INe3)+2*MNeu(INe5)**4*MNeu2(INe3)-2*MNeu2(INe3)**3+4*
     &  MNeu2(INe3)**2*MNeu2(INe5)-2*MNeu2(INe3)*MNeu2(INe5)**2-5*
     &  MNeu(INe3)**4*MNeu2(INe6)-2*MNeu(INe5)**4*MNeu2(INe6)+
     &  MNeu(INe6)**4*MNeu2(INe6)-8*MNeu2(INe3)*MNeu2(INe5)*MNeu2(INe6)
     &  +2*MNeu2(INe5)**2*MNeu2(INe6)+4*A0TNeu(INe6)*MNeu2(INe6)**2+4*
     &  MNeu2(INe5)*MNeu2(INe6)**2+2*MNeu2(INe6)**3-2*Mah2(INH3)*
     &  (MNeu(INe3)**4-MNeu(INe6)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*
     &  MNeu2(INe6))-4*A0TNeu(INe3)*(MNeu(INe3)**4+3*MNeu2(INe3)*(-
     &  MNeu2(INe3)+MNeu2(INe6))))+2*CFF11S1L(INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5)*(-MNeu2(INe3)**2+4*A0TNeu(INe6)*
     &  MNeu2(INe6)-2*MNeu2(INe3)*MNeu2(INe6)+3*MNeu2(INe6)**2+
     &  A0TNeu(INe3)*(8*MNeu2(INe3)-4*(MNeu2(INe3)+2*MNeu2(INe6))))))+
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe6,INe3)*
     &  (CFF11S1R(INe3,INe5,INH3)*MNeu(INe3)*(-
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)**4*MNeu(INe6))-2*
     &  CFF11S1L(INe5,INe6,INH3)*Mah2(INH3)*MNeu(INe6)**3+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)**5-2*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)**3*MNeu2(INe3)-2*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*MNeu2(INe3)**2-4*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)**3*MNeu2(INe5)+8*
     &  A0TNeu(INe6)*CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*MNeu2(INe6)+4*
     &  A0TNeu(INe6)*CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)*MNeu2(INe6)+2*
     &  CFF11S1L(INe5,INe6,INH3)*Mah2(INH3)*MNeu(INe6)*MNeu2(INe6)-4*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*MNeu2(INe3)*MNeu2(INe6)+4*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)*MNeu2(INe5)*MNeu2(INe6)+6*
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*MNeu2(INe6)**2+2*
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6)*MNeu2(INe6)**2-4*
     &  A0TNeu(INe3)*(2*CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe6))*(-MNeu2(INe3)+2*
     &  MNeu2(INe6)))+CFF11S1L(INe3,INe5,INH3)*
     &  (CFF11S1R(INe5,INe6,INH3)*(5*MNeu(INe3)**6-MNeu(INe3)**4*
     &  MNeu2(INe3)+2*MNeu(INe5)**4*MNeu2(INe3)-2*MNeu2(INe3)**3+4*
     &  MNeu2(INe3)**2*MNeu2(INe5)-2*MNeu2(INe3)*MNeu2(INe5)**2-5*
     &  MNeu(INe3)**4*MNeu2(INe6)-2*MNeu(INe5)**4*MNeu2(INe6)+
     &  MNeu(INe6)**4*MNeu2(INe6)-8*MNeu2(INe3)*MNeu2(INe5)*MNeu2(INe6)
     &  +2*MNeu2(INe5)**2*MNeu2(INe6)+4*A0TNeu(INe6)*MNeu2(INe6)**2+4*
     &  MNeu2(INe5)*MNeu2(INe6)**2+2*MNeu2(INe6)**3-2*Mah2(INH3)*
     &  (MNeu(INe3)**4-MNeu(INe6)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*
     &  MNeu2(INe6))-4*A0TNeu(INe3)*(MNeu(INe3)**4+3*MNeu2(INe3)*(-
     &  MNeu2(INe3)+MNeu2(INe6))))+2*CFF11S1L(INe5,INe6,INH3)*
     &  MNeu(INe5)*MNeu(INe6)*(-MNeu2(INe3)**2+4*A0TNeu(INe6)*
     &  MNeu2(INe6)-2*MNeu2(INe3)*MNeu2(INe6)+3*MNeu2(INe6)**2+
     &  A0TNeu(INe3)*(8*MNeu2(INe3)-4*(MNeu2(INe3)+2*MNeu2(INe6)))))))/(64.*(MNeu2(INe3)-MNeu2(INe6))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe3,INe4)*
     &  (CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(-FD111ChiChiH(2,INe3,INe5,INH3)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+CFF11S1R(INe4,INe5,INH3)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))*
     &  MNeu(INe5))+CFF11S1L(INe5,INe3,INH3)*(CFF11S1R(INe4,INe5,INH3)*
     &  (-FD111ChiChiH(5,INe3,INe5,INH3)+FD111ChiChiH(5,INe4,INe5,INH3)
     &  +FD211ChiChiH(5,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))*
     &  MNeu(INe5)))+2*CF11F11V2R(INe3,INe4)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe3)*(CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe3,INH3)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,INH3)*
     &  MNeu(INe3)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe5,INe3,INH3)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)*MNeu2(INe3))))+CF11F11V2R(INe3,INe3)*
     &  (CF11F11V2R(INe3,INe4)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*(-
     &  FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe5,INe3,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe5,INe3,INH3)*(-
     &  FD111ChiChiH(5,INe3,INe5,INH3)+FD111ChiChiH(5,INe4,INe5,INH3)+
     &  FD211ChiChiH(5,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))*
     &  MNeu(INe5)))+2*CF11F11V2L(INe3,INe4)*(CFF11S1R(INe5,INe3,INH3)*
     &  MNeu(INe3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe5,INe3,INH3)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)**
     &  2*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(1,INe3,INe5,INH3)-
     &  FD111ChiChiH(1,INe4,INe5,INH3)+FD211ChiChiH(1,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu(INe5)*MNeu2(INe3)))))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)**2)+(-4*A0TNH(INH3)*(2*
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe3,INe4)*
     &  CFF11S1L(INe5,INe3,INH3)*CFF11S1R(INe4,INe5,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe4)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe4))+2*
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe3,INe4)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe3,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe4)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe4)))+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe3,INe4)*
     &  (CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*(-4*A0TNeu(INe3)*
     &  (CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)+2*CFF11S1R(INe4,INe5,INH3)
     &  *MNeu(INe5))*(-MNeu2(INe3)+2*MNeu2(INe4))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*(-MNeu(INe3)**4+MNeu(INe4)*
     &  *4+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2)+2*CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)*(-
     &  MNeu2(INe3)**2+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2))+CFF11S1L(INe5,INe3,INH3)*(2*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)*(-MNeu2(INe3)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)+3*
     &  MNeu2(INe4)**2+A0TNeu(INe3)*(8*MNeu2(INe3)-4*(MNeu2(INe3)+2*
     &  MNeu2(INe4))))+CFF11S1R(INe4,INe5,INH3)*(5*MNeu(INe3)**6+4*
     &  A0TNeu(INe4)*MNeu(INe4)**4-MNeu(INe3)**4*MNeu2(INe3)+2*
     &  MNeu(INe5)**4*MNeu2(INe3)-2*MNeu2(INe3)**3-5*MNeu(INe3)**4*
     &  MNeu2(INe4)+MNeu(INe4)**4*MNeu2(INe4)-2*MNeu(INe5)**4*
     &  MNeu2(INe4)+2*MNeu2(INe4)**3-2*Mah2(INH3)*(MNeu(INe3)**4-
     &  MNeu(INe4)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe4))-4*
     &  A0TNeu(INe3)*(MNeu(INe3)**4+3*MNeu2(INe3)*(-MNeu2(INe3)+
     &  MNeu2(INe4)))+4*MNeu2(INe3)**2*MNeu2(INe5)-8*MNeu2(INe3)*
     &  MNeu2(INe4)*MNeu2(INe5)+4*MNeu2(INe4)**2*MNeu2(INe5)-2*
     &  MNeu2(INe3)*MNeu2(INe5)**2+2*MNeu2(INe4)*MNeu2(INe5)**2)))+
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe3,INe4)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(4*A0TNeu(INe3)*
     &  (CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)+2*CFF11S1R(INe5,INe3,INH3)
     &  *MNeu(INe5))*(MNeu2(INe3)-2*MNeu2(INe4))+
     &  CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*(-MNeu(INe3)**4+MNeu(INe4)*
     &  *4+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2)+2*CFF11S1R(INe5,INe3,INH3)*MNeu(INe5)*(-
     &  MNeu2(INe3)**2+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*(2*
     &  CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*MNeu(INe5)*(-MNeu2(INe3)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)-2*MNeu2(INe3)*MNeu2(INe4)+3*
     &  MNeu2(INe4)**2+A0TNeu(INe3)*(8*MNeu2(INe3)-4*(MNeu2(INe3)+2*
     &  MNeu2(INe4))))+CFF11S1R(INe5,INe3,INH3)*(5*MNeu(INe3)**6+4*
     &  A0TNeu(INe4)*MNeu(INe4)**4-MNeu(INe3)**4*MNeu2(INe3)+2*
     &  MNeu(INe5)**4*MNeu2(INe3)-2*MNeu2(INe3)**3-5*MNeu(INe3)**4*
     &  MNeu2(INe4)+MNeu(INe4)**4*MNeu2(INe4)-2*MNeu(INe5)**4*
     &  MNeu2(INe4)+2*MNeu2(INe4)**3-2*Mah2(INH3)*(MNeu(INe3)**4-
     &  MNeu(INe4)**4-2*MNeu2(INe3)**2+2*MNeu2(INe3)*MNeu2(INe4))-4*
     &  A0TNeu(INe3)*(MNeu(INe3)**4+3*MNeu2(INe3)*(-MNeu2(INe3)+
     &  MNeu2(INe4)))+4*MNeu2(INe3)**2*MNeu2(INe5)-8*MNeu2(INe3)*
     &  MNeu2(INe4)*MNeu2(INe5)+4*MNeu2(INe4)**2*MNeu2(INe5)-2*
     &  MNeu2(INe3)*MNeu2(INe5)**2+2*MNeu2(INe4)*MNeu2(INe5)**2))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe6)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe4,INe3)*
     &  (CFF11S1R(INe5,INe4,INH3)*MNeu(INe4)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe4,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe4,INe5,INH3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5))+CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe5,INH3)*
     &  (FD111ChiChiH(5,INe3,INe5,INH3)-FD111ChiChiH(5,INe4,INe5,INH3)+
     &  FD211ChiChiH(5,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)))+2*CF11F11V2R(INe4,INe3)*MNeu(INe3)*
     &  (CFF11S1R(INe5,INe4,INH3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*(-FD111ChiChiH(1,INe3,INe5,INH3)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)+FD211ChiChiH(1,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5)*MNeu2(INe4))))+
     &  CF11F11V2R(INe3,INe4)*(CF11F11V2R(INe4,INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe4,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe4,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe5,INe4,INH3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5))+CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe5,INe4,INH3)*
     &  (FD111ChiChiH(5,INe3,INe5,INH3)-FD111ChiChiH(5,INe4,INe5,INH3)+
     &  FD211ChiChiH(5,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)))+2*CF11F11V2L(INe4,INe3)*MNeu(INe3)*
     &  (CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1R(INe5,INe4,INH3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(-FD111ChiChiH(1,INe3,INe5,INH3)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)+FD211ChiChiH(1,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5)*MNeu2(INe4)))))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)**2)+(4*A0TNH(INH3)*(2*
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe4,INe3)*
     &  CFF11S1L(INe5,INe4,INH3)*CFF11S1R(INe4,INe5,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe4)**4-2*MNeu2(INe3)*MNeu2(INe4)+2*MNeu2(INe4)**2)+2*
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe4,INe3)*
     &  CFF11S1L(INe4,INe5,INH3)*CFF11S1R(INe5,INe4,INH3)*(MNeu(INe3)**
     &  4-MNeu(INe4)**4-2*MNeu2(INe3)*MNeu2(INe4)+2*MNeu2(INe4)**2))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe4,INe3)*
     &  (CFF11S1R(INe5,INe4,INH3)*MNeu(INe4)*(-4*A0TNeu(INe4)*
     &  (CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)+2*CFF11S1R(INe4,INe5,INH3)
     &  *MNeu(INe5))*(2*MNeu2(INe3)-MNeu2(INe4))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*(MNeu(INe3)**4-MNeu(INe4)**
     &  4+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2-2*MNeu2(INe3)*
     &  MNeu2(INe4))+2*CFF11S1R(INe4,INe5,INH3)*MNeu(INe5)*(4*
     &  A0TNeu(INe3)*MNeu2(INe3)+3*MNeu2(INe3)**2-2*MNeu2(INe3)*
     &  MNeu2(INe4)-MNeu2(INe4)**2))+CFF11S1L(INe5,INe4,INH3)*(2*
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*MNeu(INe5)*(4*A0TNeu(INe3)*
     &  MNeu2(INe3)+3*MNeu2(INe3)**2-4*A0TNeu(INe4)*(2*MNeu2(INe3)-
     &  MNeu2(INe4))-2*MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2)+
     &  CFF11S1R(INe4,INe5,INH3)*(4*A0TNeu(INe3)*MNeu(INe3)**4-4*
     &  A0TNeu(INe4)*MNeu(INe4)**4+5*MNeu(INe4)**6+MNeu(INe3)**4*
     &  MNeu2(INe3)-5*MNeu(INe4)**4*MNeu2(INe3)-2*MNeu(INe5)**4*
     &  MNeu2(INe3)+2*MNeu2(INe3)**3-MNeu(INe4)**4*MNeu2(INe4)+2*
     &  MNeu(INe5)**4*MNeu2(INe4)-12*A0TNeu(INe4)*MNeu2(INe3)*
     &  MNeu2(INe4)+12*A0TNeu(INe4)*MNeu2(INe4)**2-2*MNeu2(INe4)**3+2*
     &  Mah2(INH3)*(MNeu(INe3)**4-MNeu(INe4)**4-2*MNeu2(INe3)*
     &  MNeu2(INe4)+2*MNeu2(INe4)**2)+4*MNeu2(INe3)**2*MNeu2(INe5)-8*
     &  MNeu2(INe3)*MNeu2(INe4)*MNeu2(INe5)+4*MNeu2(INe4)**2*
     &  MNeu2(INe5)+2*MNeu2(INe3)*MNeu2(INe5)**2-2*MNeu2(INe4)*
     &  MNeu2(INe5)**2)))+CF11F11V2R(INe3,INe4)*CF11F11V2R(INe4,INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(-4*A0TNeu(INe4)*
     &  (CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)+2*CFF11S1R(INe5,INe4,INH3)
     &  *MNeu(INe5))*(2*MNeu2(INe3)-MNeu2(INe4))+
     &  CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*(MNeu(INe3)**4-MNeu(INe4)**
     &  4+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2-2*MNeu2(INe3)*
     &  MNeu2(INe4))+2*CFF11S1R(INe5,INe4,INH3)*MNeu(INe5)*(4*
     &  A0TNeu(INe3)*MNeu2(INe3)+3*MNeu2(INe3)**2-2*MNeu2(INe3)*
     &  MNeu2(INe4)-MNeu2(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*(2*
     &  CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*MNeu(INe5)*(4*A0TNeu(INe3)*
     &  MNeu2(INe3)+3*MNeu2(INe3)**2-4*A0TNeu(INe4)*(2*MNeu2(INe3)-
     &  MNeu2(INe4))-2*MNeu2(INe3)*MNeu2(INe4)-MNeu2(INe4)**2)+
     &  CFF11S1R(INe5,INe4,INH3)*(4*A0TNeu(INe3)*MNeu(INe3)**4-4*
     &  A0TNeu(INe4)*MNeu(INe4)**4+5*MNeu(INe4)**6+MNeu(INe3)**4*
     &  MNeu2(INe3)-5*MNeu(INe4)**4*MNeu2(INe3)-2*MNeu(INe5)**4*
     &  MNeu2(INe3)+2*MNeu2(INe3)**3-MNeu(INe4)**4*MNeu2(INe4)+2*
     &  MNeu(INe5)**4*MNeu2(INe4)-12*A0TNeu(INe4)*MNeu2(INe3)*
     &  MNeu2(INe4)+12*A0TNeu(INe4)*MNeu2(INe4)**2-2*MNeu2(INe4)**3+2*
     &  Mah2(INH3)*(MNeu(INe3)**4-MNeu(INe4)**4-2*MNeu2(INe3)*
     &  MNeu2(INe4)+2*MNeu2(INe4)**2)+4*MNeu2(INe3)**2*MNeu2(INe5)-8*
     &  MNeu2(INe3)*MNeu2(INe4)*MNeu2(INe5)+4*MNeu2(INe4)**2*
     &  MNeu2(INe5)+2*MNeu2(INe3)*MNeu2(INe5)**2-2*MNeu2(INe4)*
     &  MNeu2(INe5)**2))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe6)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe3,INe3)**2*(CFF11S1L(INe5,INe3,INH3)
     &  *(CFF11S1R(INe3,INe5,INH3)*FD311ChiChiH(4,INe3,INe5,INH3)+
     &  CFF11S1L(INe3,INe5,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5))+CFF11S1R(INe5,INe3,INH3)*
     &  (CFF11S1R(INe3,INe5,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5)+CFF11S1L(INe3,INe5,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3)))+
     &  CF11F11V2R(INe3,INe3)**2*(CFF11S1L(INe3,INe5,INH3)*
     &  (CFF11S1R(INe5,INe3,INH3)*FD311ChiChiH(4,INe3,INe5,INH3)+
     &  CFF11S1L(INe5,INe3,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5))+CFF11S1R(INe3,INe5,INH3)*
     &  (CFF11S1R(INe5,INe3,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5)+CFF11S1L(INe5,INe3,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3)))-2*
     &  CF11F11V2L(INe3,INe3)*CF11F11V2R(INe3,INe3)*
     &  (CFF11S1R(INe3,INe5,INH3)*(CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*
     &  (FD311ChiChiH(3,INe3,INe5,INH3)+FD311ChiChiH(1,INe3,INe5,INH3)*
     &  MNeu(INe3)**2)*MNeu(INe5)+2*CFF11S1L(INe5,INe3,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3))+
     &  CFF11S1L(INe3,INe5,INH3)*(CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*
     &  (FD311ChiChiH(3,INe3,INe5,INH3)+FD311ChiChiH(1,INe3,INe5,INH3)*
     &  MNeu(INe3)**2)*MNeu(INe5)+2*CFF11S1R(INe5,INe3,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3))))/4.+
     &  ((CF11F11V2R(INe3,INe3)**2*CFF11S1L(INe5,INe3,INH3)*
     &  CFF11S1R(INe3,INe5,INH3)+CF11F11V2L(INe3,INe3)**2*
     &  CFF11S1L(INe3,INe5,INH3)*CFF11S1R(INe5,INe3,INH3))*(4*
     &  A0TNeu(INe3)-3*MNeu2(INe3))+(2*(CF11F11V2L(INe3,INe3)**2+
     &  CF11F11V2R(INe3,INe3)**2)*(CFF11S1L(INe3,INe5,INH3)*
     &  CFF11S1L(INe5,INe3,INH3)+CFF11S1R(INe3,INe5,INH3)*
     &  CFF11S1R(INe5,INe3,INH3))*MNeu(INe5)*(4*A0TNeu(INe3)-3*
     &  MNeu2(INe3)))/MNeu(INe3)+(CF11F11V2L(INe3,INe3)**2*
     &  CFF11S1L(INe5,INe3,INH3)*CFF11S1R(INe3,INe5,INH3)+
     &  CF11F11V2R(INe3,INe3)**2*CFF11S1L(INe3,INe5,INH3)*
     &  CFF11S1R(INe5,INe3,INH3))*(12*A0TNeu(INe3)+8*A0TNH(INH3)+
     & 2*Mah2(INH3)-MNeu2(INe3)+4*MNeu2(INe5)))/64.)
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do INH3=1,6
       selfZ=selfZ+((MCha2*CFF12S1L(INH3)**2*(-2*CF12F12V2L*CF12F12V2R*
     &  MCha2*FD311ChaChaH(1,INH3)+(CF12F12V2L-CF12F12V2R)**2*
     &  FD311ChaChaH(3,INH3))+MCha2*CFF12S1R(INH3)**2*(-2*CF12F12V2L*
     &  CF12F12V2R*MCha2*FD311ChaChaH(1,INH3)+(CF12F12V2L-CF12F12V2R)**
     &  2*FD311ChaChaH(3,INH3))+CFF12S1L(INH3)*CFF12S1R(INH3)*
     &  ((CF12F12V2L**2-8*CF12F12V2L*CF12F12V2R+CF12F12V2R**2)*MCha2*
     &  FD311ChaChaH(2,INH3)+(CF12F12V2L**2+CF12F12V2R**2)*
     &  FD311ChaChaH(4,INH3)))/2.+((CF12F12V2L**2+CF12F12V2R**2)*((8*
     &  a0tcha-6*MCha2)*CFF12S1L(INH3)**2+2*(4*a0tcha-3*MCha2)*
     &  CFF12S1R(INH3)**2+CFF12S1L(INH3)*CFF12S1R(INH3)*(16*a0tcha+8*
     &  A0TNH(INH3)+2*Mah2(INH3))))/32.)
       enddo 


       do ICH3=1,2
       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe5,INe3)*(-
     &  (MCha*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4))+MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe4)+MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)**3-MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe4)**3-MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe5)+MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe5)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+
     &  MCha*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)**2*MNeu(INe5)-MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe4)**2*MNeu(INe5)+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**3*MNeu(INe5)+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**3*MNeu(INe5)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe4)**3*MNeu(INe5)-
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe4)**3*MNeu(INe5)-MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)*MNeu(INe5)**2+MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe4)*MNeu(INe5)**2-MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe5)**3+MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe5)**3-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(FD111ChaChiHp(8,INe5,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)+FD111ChaChiHp(8,INe3,ICH3)*
     &  (MNeu(INe4)**2-MNeu(INe5)**2)+FD111ChaChiHp(8,INe4,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+MCha*DCONJG(CF11F12S3R(INe4,ICH3)
     &  )*MNeu(INe4)*(FD111ChiChaHp(4,INe5,ICH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChaHp(4,INe3,ICH3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiChaHp(4,INe4,ICH3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2)))+CF11F12S3R(INe4,ICH3)*
     &  (DCONJG(CF11F12S3R(INe5,ICH3))*(FD111ChaChiHp(8,INe5,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)+FD111ChaChiHp(8,INe3,ICH3)*
     &  (MNeu(INe4)**2-MNeu(INe5)**2)+FD111ChaChiHp(8,INe4,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+MCha*DCONJG(CF11F12S3L(INe5,ICH3)
     &  )*MNeu(INe5)*(FD111ChiChaHp(4,INe5,ICH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChaHp(4,INe3,ICH3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiChaHp(4,INe4,ICH3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2))))+2*CF11F11V2R(INe5,INe3)*MNeu(INe3)*
     &  (CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**3+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**3+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe5)**3-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe5)**3+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChaChiHp(2,INe5,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChaChiHp(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChaChiHp(2,INe3,ICH3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*(FD111ChiChaHp(4,INe5,ICH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChaHp(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111ChiChaHp(4,INe3,ICH3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2)))+CF11F12S3R(INe4,ICH3)*
     &  (DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)*
     &  (FD111ChaChiHp(2,INe5,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChaChiHp(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChaChiHp(2,INe3,ICH3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe5,ICH3))*(FD111ChiChaHp(4,INe5,ICH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChaHp(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111ChiChaHp(4,INe3,ICH3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2)))))+CF11F11V2R(INe3,INe4)*
     &  (CF11F11V2R(INe5,INe3)*(-(MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4))+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe4)**3-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe4)**3-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe5)**3+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe5)**3-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(FD111ChaChiHp(8,INe5,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)+FD111ChaChiHp(8,INe3,ICH3)*
     &  (MNeu(INe4)**2-MNeu(INe5)**2)+FD111ChaChiHp(8,INe4,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+MCha*DCONJG(CF11F12S3L(INe4,ICH3)
     &  )*MNeu(INe4)*(FD111ChiChaHp(4,INe5,ICH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChaHp(4,INe3,ICH3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiChaHp(4,INe4,ICH3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2)))+CF11F12S3L(INe4,ICH3)*
     &  (DCONJG(CF11F12S3L(INe5,ICH3))*(FD111ChaChiHp(8,INe5,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)+FD111ChaChiHp(8,INe3,ICH3)*
     &  (MNeu(INe4)**2-MNeu(INe5)**2)+FD111ChaChiHp(8,INe4,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+MCha*DCONJG(CF11F12S3R(INe5,ICH3)
     &  )*MNeu(INe5)*(FD111ChiChaHp(4,INe5,ICH3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiChaHp(4,INe3,ICH3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiChaHp(4,INe4,ICH3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2))))+2*CF11F11V2L(INe5,INe3)*MNeu(INe3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**3+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**3+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)+MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe4)**2*MNeu(INe5)-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe4)**3*MNeu(INe5)+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**2+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe5)**3-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe5)**3+MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChaChiHp(2,INe5,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChaChiHp(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChaChiHp(2,INe3,ICH3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(FD111ChiChaHp(4,INe5,ICH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChaHp(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111ChiChaHp(4,INe3,ICH3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2)))+CF11F12S3L(INe4,ICH3)*
     &  (DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)*
     &  (FD111ChaChiHp(2,INe5,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChaChiHp(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChaChiHp(2,INe3,ICH3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe5,ICH3))*(FD111ChiChaHp(4,INe5,ICH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChaHp(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111ChiChaHp(4,INe3,ICH3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2))))))/(4.*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  ((2*MCha*(CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)
     &  +CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe5)
     &  )+CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)
     &  +CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe5)
     &  ))*(4*A0THpN(ICH3)*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(4*
     &  a0tcha+2*MCha2+3*MNeu2(INe3))+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe3)+3*MNeu2(INe3))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+(2*MCha*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*(CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe4)+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5))+CF11F11V2R(INe3,INe4)
     &  *CF11F11V2R(INe5,INe3)*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe4)+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)))*(4*A0THpN(ICH3)*
     &  (MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*
     &  MNeu2(INe3))+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0TNeu(INe3)+3*
     &  MNeu2(INe3))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)))*MNeu(INe4)
     &  *MNeu(INe5)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe3)**4+4*MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+
     &  A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe3)))))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3)))*MNeu(INe4)*MNeu(INe5)*(4*a0tcha*
     &  MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+MNeu(INe3)**4+4*MCha2*
     &  MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+A0THpN(ICH3)*(-4*
     &  MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe3)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5)))+((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*(-3*MassHpm(ICH3)**4*MNeu2(INe3)
     &  +MNeu2(INe3)*(MCha2*(4*a0tcha+3*MCha2)+3*MNeu(INe3)**4+4*
     &  (MCha2+A0TNeu(INe3))*MNeu2(INe3))+A0THpN(ICH3)*(8*MCha2**2+(8*
     &  MCha2-4*MassHpm(ICH3)**2)*MNeu2(INe3)+8*MNeu2(INe3)**2)+2*
     &  MassHpm(ICH3)**2*(MNeu(INe3)**4+MCha2*(4*a0tcha+2*MCha2+
     &  MNeu2(INe3)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)
     &  )*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+MNeu2(INe3)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe3)**4+4*(MCha2+A0TNeu(INe3))*MNeu2(INe3))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassHpm(ICH3)**2*(MNeu(INe3)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe3)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5)))-(2*MCha*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe5))+CF11F11V2R(INe3,INe4)
     &  *CF11F11V2R(INe5,INe3)*(CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe5)))*(4*A0THpN(ICH3)*
     &  (MCha2+MNeu2(INe4))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*
     &  MNeu2(INe4))+MNeu2(INe4)*(4*a0tcha+3*MCha2+4*A0TNeu(INe4)+3*
     &  MNeu2(INe4))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-(2*MCha*
     &  (CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe4)
     &  +CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)
     &  )+CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe4)
     &  +CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)
     &  ))*(4*A0THpN(ICH3)*(MCha2+MNeu2(INe4))+MassHpm(ICH3)**2*(4*
     &  a0tcha+2*MCha2+3*MNeu2(INe4))+MNeu2(INe4)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe4)+3*MNeu2(INe4))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)))*MNeu(INe4)
     &  *MNeu(INe5)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe4)**4+4*MCha2*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassHpm(ICH3)**2*(MCha2+MNeu2(INe4))+
     &  A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe4)))))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3)))*MNeu(INe4)*MNeu(INe5)*(4*a0tcha*
     &  MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+MNeu(INe4)**4+4*MCha2*
     &  MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*MNeu2(INe4)**2+2*
     &  MassHpm(ICH3)**2*(MCha2+MNeu2(INe4))+A0THpN(ICH3)*(-4*
     &  MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe4)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*(-3*MassHpm(ICH3)**4*MNeu2(INe4)
     &  +MNeu2(INe4)*(MCha2*(4*a0tcha+3*MCha2)+3*MNeu(INe4)**4+4*
     &  (MCha2+A0TNeu(INe4))*MNeu2(INe4))+A0THpN(ICH3)*(8*MCha2**2+(8*
     &  MCha2-4*MassHpm(ICH3)**2)*MNeu2(INe4)+8*MNeu2(INe4)**2)+2*
     &  MassHpm(ICH3)**2*(MNeu(INe4)**4+MCha2*(4*a0tcha+2*MCha2+
     &  MNeu2(INe4)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4)
     &  )*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe4)+MNeu2(INe4)*(MCha2*(4*a0tcha+3*
     &  MCha2)+3*MNeu(INe4)**4+4*(MCha2+A0TNeu(INe4))*MNeu2(INe4))+
     &  A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*
     &  MNeu2(INe4)+8*MNeu2(INe4)**2)+2*MassHpm(ICH3)**2*(MNeu(INe4)**
     &  4+MCha2*(4*a0tcha+2*MCha2+MNeu2(INe4)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))-(2*MCha*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe5))+CF11F11V2R(INe3,INe4)
     &  *CF11F11V2R(INe5,INe3)*(CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe5)))*(4*A0THpN(ICH3)*
     &  (MCha2+MNeu2(INe5))+MassHpm(ICH3)**2*(4*a0tcha+2*MCha2+3*
     &  MNeu2(INe5))+MNeu2(INe5)*(4*a0tcha+3*MCha2+4*A0TNeu(INe5)+3*
     &  MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))
     &  *(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-(2*MCha*
     &  (CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe4)
     &  +CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)
     &  )+CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe4)
     &  +CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)
     &  ))*(4*A0THpN(ICH3)*(MCha2+MNeu2(INe5))+MassHpm(ICH3)**2*(4*
     &  a0tcha+2*MCha2+3*MNeu2(INe5))+MNeu2(INe5)*(4*a0tcha+3*MCha2+4*
     &  A0TNeu(INe5)+3*MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)))*MNeu(INe4)
     &  *MNeu(INe5)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe5)**4+4*MCha2*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+2*
     &  MNeu2(INe5)**2+2*MassHpm(ICH3)**2*(MCha2+MNeu2(INe5))+
     &  A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe5)))))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3)))*MNeu(INe4)*MNeu(INe5)*(4*a0tcha*
     &  MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+MNeu(INe5)**4+4*MCha2*
     &  MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+2*MNeu2(INe5)**2+2*
     &  MassHpm(ICH3)**2*(MCha2+MNeu2(INe5))+A0THpN(ICH3)*(-4*
     &  MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*(-3*MassHpm(ICH3)**4*MNeu2(INe5)
     &  +MNeu2(INe5)*(MCha2*(4*a0tcha+3*MCha2)+3*MNeu(INe5)**4+4*
     &  (MCha2+A0TNeu(INe5))*MNeu2(INe5))+A0THpN(ICH3)*(8*MCha2**2+(8*
     &  MCha2-4*MassHpm(ICH3)**2)*MNeu2(INe5)+8*MNeu2(INe5)**2)+2*
     &  MassHpm(ICH3)**2*(MNeu(INe5)**4+MCha2*(4*a0tcha+2*MCha2+
     &  MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)
     &  )*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)))*(-3*
     &  MassHpm(ICH3)**4*MNeu2(INe5)+MNeu2(INe5)*(MCha2*(4*a0tcha+
     &  3*MCha2)+3*MNeu(INe5)**4+4*(MCha2+A0TNeu(INe5))*MNeu2(INe5))
     &  +A0THpN(ICH3)*(8*MCha2**2+(8*MCha2-4*MassHpm(ICH3)**2)*MNeu2(INe5)
     &  +8*MNeu2(INe5)**2)+2*MassHpm(ICH3)**2*(MNeu(INe5)**4+MCha2*
     &   (4*a0tcha+2*MCha2+MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5))))/64.)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2R(INe3,INe3)*(CF11F11V2R(INe5,INe3)*(-
     &  (MCha*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3))+MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe5)+MCha*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)-MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**2-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe5)**3-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3L(INe3,ICH3)*(MCha*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  DCONJG(CF11F12S3L(INe5,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe5,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)))+CF11F12S3R(INe5,ICH3)*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe5,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2))))+2*CF11F11V2L(INe5,INe3)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)**2+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+CF11F12S3L(INe3,ICH3)*MNeu(INe3)
     &  *(DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe5,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3R(INe5,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3)))+CF11F11V2L(INe3,INe3)*
     &  (CF11F11V2L(INe5,INe3)*(-(MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe3))+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**3-MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe5)+MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiChaHp(4,INe5,ICH3)*
     &  MNeu(INe5)-CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)*MNeu(INe5)+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)*MNeu(INe5)+MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe5)+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3*MNeu(INe5)+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3*MNeu(INe5)-MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)**2-MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe5)**3-CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3-CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe5,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)))+CF11F12S3R(INe3,ICH3)*(MCha*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe5)**2))+
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe5,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2))))+2*CF11F11V2R(INe5,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)**2+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+CF11F12S3R(INe3,ICH3)*MNeu(INe3)
     &  *(DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe5,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3L(INe5,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3))))/(4.*(MNeu(INe3)**2-MNeu(INe5)**2)*
     &  *2)+(CF11F11V2R(INe3,INe3)*CF11F11V2R(INe5,INe3)*(8*a0tcha*
     &  MCha*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MNeu(INe3)**3+6*MCha*MCha2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)**3+8*MCha*A0THpN(ICH3)
     &  *CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)
     &  **3+16*MCha*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)**3+6*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3+4*MCha2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe5)+8*
     &  A0THpN(ICH3)*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe5)+8*A0TNeu(INe3)*CF11F12S3L(INe5,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe5)+4*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)**3*MNeu(INe5)+8*A0THpN(ICH3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)**3*MNeu(INe5)+8*
     &  A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe5)+2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**3*
     &  MNeu(INe5)+2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)
     &  )*MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe5)-
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  *5*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)**5*MNeu(INe5)-8*
     &  a0tcha*MCha*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))
     &  *MNeu(INe5)**3-6*MCha*MCha2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)**3-8*MCha*A0THpN(ICH3)
     &  *CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)
     &  **3-16*MCha*A0TNeu(INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)**3-6*MCha*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe5)**3-4*MCha2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**3-8*
     &  A0THpN(ICH3)*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)*MNeu(INe5)**3-8*A0TNeu(INe3)*CF11F12S3L(INe5,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**3-4*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)**3-8*A0THpN(ICH3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)**3-8*
     &  A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)
     &  )*MNeu(INe3)*MNeu(INe5)**3-2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe5)**3-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**5+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)**5-8*a0tcha*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MNeu(INe3)*MNeu2(INe3)-8*MCha*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)-8*MCha*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu2(INe3)+4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  *3*MNeu2(INe3)+8*MCha*A0TNeu(INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)*MNeu2(INe3)-4*MCha2*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-8*A0THpN(ICH3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -4*A0TNeu(INe3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -4*MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-8*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -2*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)+2*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  *3*MNeu(INe5)*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)**3*MNeu(INe5)*
     &  MNeu2(INe3)-4*MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)**3*MNeu2(INe3)-2*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)**3*MNeu2(INe3)-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)**3*
     &  MNeu2(INe3)-6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)**2-2*MCha*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe3)**2-2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  **2-2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-16*MCha*A0TNeu(INe3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe5)+8*MCha*A0TNeu(INe5)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu2(INe5)+8*a0tcha*
     &  MCha*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe5)*MNeu2(INe5)+6*MCha*MCha2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)*MNeu2(INe5)+8*MCha*
     &  A0THpN(ICH3)*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe5)*MNeu2(INe5)+8*MCha*A0TNeu(INe5)*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe5)+6*MCha*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe5)*
     &  MNeu2(INe5)+4*MCha2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +8*A0THpN(ICH3)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +4*A0TNeu(INe5)*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +4*MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+8*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+4*A0TNeu(INe5)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +2*CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)-4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe5)+6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu2(INe5)**2+6*MCha*
     &  CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe5)**2+2*CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  **2+2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+CF11F12S3L(INe3,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe5)+3*MCha2*MNeu2(INe5)+4*A0THpN(ICH3)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*MNeu2(INe5)+3*MassHpm(ICH3)**2*MNeu2(INe5)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe5)+3*MNeu2(INe5)**2)+
     &  DCONJG(CF11F12S3L(INe5,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe5)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe5)+3*MCha2**2*
     &  MNeu2(INe5)+8*MCha2*A0THpN(ICH3)*MNeu2(INe5)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe5)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe5)-3*MassHpm(ICH3)**4*MNeu2(INe5)+3*MNeu(INe5)**4*
     &  MNeu2(INe5)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe5)+4*MCha2*MNeu2(INe5)**2+8*A0THpN(ICH3)*MNeu2(INe5)**
     &  2+4*A0TNeu(INe5)*MNeu2(INe5)**2))+CF11F12S3R(INe5,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe5)+3*MCha2*MNeu2(INe5)+4*A0THpN(ICH3)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*MNeu2(INe5)+3*MassHpm(ICH3)**2*MNeu2(INe5)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe5)+3*MNeu2(INe5)**2)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe5)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe5)+3*MCha2**2*
     &  MNeu2(INe5)+8*MCha2*A0THpN(ICH3)*MNeu2(INe5)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe5)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe5)-3*MassHpm(ICH3)**4*MNeu2(INe5)+3*MNeu(INe5)**4*
     &  MNeu2(INe5)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe5)+4*MCha2*MNeu2(INe5)**2+8*A0THpN(ICH3)*MNeu2(INe5)**
     &  2+4*A0TNeu(INe5)*MNeu2(INe5)**2)))+CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe5,INe3)*(8*a0tcha*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)**3+6*MCha*MCha2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  *3+8*MCha*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)**3+16*MCha*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3)
     &  )*MNeu(INe3)**3+6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**3+4*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MNeu(INe3)**3*MNeu(INe5)+8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)**3*MNeu(INe5)+8*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe5)+4*MCha2*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe5)+8*
     &  A0THpN(ICH3)*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe5)+8*A0TNeu(INe3)*CF11F12S3R(INe5,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe5)+2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe5)+2*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe5)-CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)**5*MNeu(INe5)-
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  *5*MNeu(INe5)-8*a0tcha*MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)**3-6*MCha*MCha2*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*
     &  *3-8*MCha*A0THpN(ICH3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)**3-16*MCha*
     &  A0TNeu(INe3)*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe5)**3-6*MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe5)**3-4*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)**3-8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)**3-8*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3)
     &  )*MNeu(INe3)*MNeu(INe5)**3-4*MCha2*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**3-8*
     &  A0THpN(ICH3)*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe3)*MNeu(INe5)**3-8*A0TNeu(INe3)*CF11F12S3R(INe5,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**3-2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)**3-2*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)**3+CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)**5+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)**5-8*a0tcha*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe3)*MNeu2(INe3)-8*MCha*A0THpN(ICH3)*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)-8*MCha*A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu2(INe3)+4*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  *3*MNeu2(INe3)+8*MCha*A0TNeu(INe3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*MNeu2(INe3)-4*MCha2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -4*A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -4*MCha2*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-8*A0THpN(ICH3)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  -2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-2*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)+2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  *3*MNeu(INe5)*MNeu2(INe3)+2*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe5)*
     &  MNeu2(INe3)-4*MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)**3*MNeu2(INe3)-2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)**3*MNeu2(INe3)-2*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)**3*
     &  MNeu2(INe3)-6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu2(INe3)**2-2*MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe3)**2-2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)
     &  **2-2*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-16*MCha*A0TNeu(INe3)*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe5)+8*MCha*A0TNeu(INe5)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu2(INe5)+8*a0tcha*
     &  MCha*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe5)*MNeu2(INe5)+6*MCha*MCha2*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*MNeu2(INe5)+8*MCha*
     &  A0THpN(ICH3)*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe5)*MNeu2(INe5)+8*MCha*A0TNeu(INe5)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe5)+6*MCha*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe5)*
     &  MNeu2(INe5)+4*MCha2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +4*A0TNeu(INe5)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +4*MCha2*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+8*A0THpN(ICH3)*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+4*A0TNeu(INe5)*CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  +2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+2*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)-4*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe5)+6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe3)*MNeu2(INe5)**2+6*MCha*
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe5)*
     &  MNeu2(INe5)**2+2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)
     &  **2+2*CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+CF11F12S3L(INe5,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe5)+3*MCha2*MNeu2(INe5)+4*A0THpN(ICH3)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*MNeu2(INe5)+3*MassHpm(ICH3)**2*MNeu2(INe5)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe5)+3*MNeu2(INe5)**2)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe5)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe5)+3*MCha2**2*
     &  MNeu2(INe5)+8*MCha2*A0THpN(ICH3)*MNeu2(INe5)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe5)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe5)-3*MassHpm(ICH3)**4*MNeu2(INe5)+3*MNeu(INe5)**4*
     &  MNeu2(INe5)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe5)+4*MCha2*MNeu2(INe5)**2+8*A0THpN(ICH3)*MNeu2(INe5)**
     &  2+4*A0TNeu(INe5)*MNeu2(INe5)**2))+CF11F12S3R(INe3,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe5)+3*MCha2*MNeu2(INe5)+4*A0THpN(ICH3)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*MNeu2(INe5)+3*MassHpm(ICH3)**2*MNeu2(INe5)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe5)+3*MNeu2(INe5)**2)+
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe5)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe5)+3*MCha2**2*
     &  MNeu2(INe5)+8*MCha2*A0THpN(ICH3)*MNeu2(INe5)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe5)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe5)-3*MassHpm(ICH3)**4*MNeu2(INe5)+3*MNeu(INe5)**4*
     &  MNeu2(INe5)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*MNeu2(INe5)+
     &  4*MCha2*MNeu2(INe5)**2+8*A0THpN(ICH3)*MNeu2(INe5)**2+4*A0TNeu(INe5)
     &  *MNeu2(INe5)**2))))/(64.*(MNeu2(INe3)-MNeu2(INe5))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe3,INe4)*(-
     &  (MCha*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3))+MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)+MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe4)-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)-MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**2-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe4)**3-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3L(INe3,ICH3)*(MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CF11F12S3R(INe4,ICH3)*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))))+2*CF11F11V2R(INe3,INe4)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)**2+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3L(INe4,ICH3)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+CF11F12S3L(INe3,ICH3)*MNeu(INe3)
     &  *(DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3R(INe4,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3)))+CF11F11V2R(INe3,INe3)*
     &  (CF11F11V2R(INe3,INe4)*(-(MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe3))+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**3-MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiChaHp(4,INe3,ICH3)*
     &  MNeu(INe4)+MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiChaHp(4,INe4,ICH3)*
     &  MNeu(INe4)-CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)*MNeu(INe4)+
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)*MNeu(INe4)+MCha*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe4)+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**3*MNeu(INe4)-MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)**2-MCha*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe4)**3-CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3-CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3L(INe4,ICH3)*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CF11F12S3R(INe3,ICH3)*(MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))))+2*CF11F11V2L(INe3,INe4)*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)**2+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3R(INe4,ICH3)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+CF11F12S3R(INe3,ICH3)*MNeu(INe3)
     &  *(DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3L(INe4,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3)+MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3))))/(4.*(MNeu(INe3)**2-MNeu(INe4)**2)*
     &  *2)+(CF11F11V2L(INe3,INe3)*CF11F11V2L(INe3,INe4)*(8*a0tcha*
     &  MCha*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe3)**3+6*MCha*MCha2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)**3+8*MCha*A0THpN(ICH3)
     &  *CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)
     &  **3+16*MCha*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)**3+6*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3+4*MCha2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe4)+8*
     &  A0THpN(ICH3)*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe4)+8*A0TNeu(INe3)*CF11F12S3L(INe4,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe4)+4*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)**3*MNeu(INe4)+8*A0THpN(ICH3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)**3*MNeu(INe4)+8*
     &  A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe4)+2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**3*
     &  MNeu(INe4)+2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)
     &  )*MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  *5*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)**5*MNeu(INe4)-8*
     &  a0tcha*MCha*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))
     &  *MNeu(INe4)**3-6*MCha*MCha2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)**3-8*MCha*A0THpN(ICH3)
     &  *CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)
     &  **3-16*MCha*A0TNeu(INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)**3-6*MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe4)**3-4*MCha2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**3-8*
     &  A0THpN(ICH3)*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)*MNeu(INe4)**3-8*A0TNeu(INe3)*CF11F12S3L(INe4,ICH3)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**3-4*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)**3-8*A0THpN(ICH3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)**3-8*
     &  A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)
     &  )*MNeu(INe3)*MNeu(INe4)**3-2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe4)**3-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**5+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)**5-8*a0tcha*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe3)*MNeu2(INe3)-8*MCha*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)-8*MCha*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu2(INe3)+4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  *3*MNeu2(INe3)+8*MCha*A0TNeu(INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*MNeu2(INe3)-4*MCha2*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-8*A0THpN(ICH3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -4*A0TNeu(INe3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -4*MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-8*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -2*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+2*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  *3*MNeu(INe4)*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)**3*MNeu(INe4)*
     &  MNeu2(INe3)-4*MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)**3*MNeu2(INe3)-2*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)**3*MNeu2(INe3)-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)**3*
     &  MNeu2(INe3)-6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)**2-2*MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe3)**2-2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  **2-2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-16*MCha*A0TNeu(INe3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe4)+8*MCha*A0TNeu(INe4)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu2(INe4)+8*a0tcha*
     &  MCha*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe4)*MNeu2(INe4)+6*MCha*MCha2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*MNeu2(INe4)+8*MCha*
     &  A0THpN(ICH3)*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe4)*MNeu2(INe4)+8*MCha*A0TNeu(INe4)*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe4)+6*MCha*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe4)+4*MCha2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +8*A0THpN(ICH3)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +4*A0TNeu(INe4)*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +4*MCha2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+8*A0THpN(ICH3)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+4*A0TNeu(INe4)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +2*CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)-4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu2(INe4)**2+6*MCha*
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe4)**2+2*CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  **2+2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+CF11F12S3L(INe3,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe4)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe4)+3*MNeu2(INe4)**2)+
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe4)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe4)+3*MCha2**2*
     &  MNeu2(INe4)+8*MCha2*A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe4)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-3*MassHpm(ICH3)**4*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe4)+4*MCha2*MNeu2(INe4)**2+8*A0THpN(ICH3)*MNeu2(INe4)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)**2))+CF11F12S3R(INe4,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe4)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe4)+3*MNeu2(INe4)**2)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe4)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe4)+3*MCha2**2*
     &  MNeu2(INe4)+8*MCha2*A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe4)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-3*MassHpm(ICH3)**4*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe4)+4*MCha2*MNeu2(INe4)**2+8*A0THpN(ICH3)*MNeu2(INe4)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)**2)))+CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe3,INe4)*(8*a0tcha*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)**3+6*MCha*MCha2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  *3+8*MCha*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)**3+16*MCha*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3)
     &  )*MNeu(INe3)**3+6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MassHpm(ICH3)**2*MNeu(INe3)**3+4*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe3)**3*MNeu(INe4)+8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)**3*MNeu(INe4)+8*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe4)+4*MCha2*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe4)+8*
     &  A0THpN(ICH3)*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe3)**3*MNeu(INe4)+8*A0TNeu(INe3)*CF11F12S3R(INe4,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)**3*MNeu(INe4)-CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)**5*MNeu(INe4)-
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  *5*MNeu(INe4)-8*a0tcha*MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)**3-6*MCha*MCha2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*
     &  *3-8*MCha*A0THpN(ICH3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)**3-16*MCha*
     &  A0TNeu(INe3)*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe4)**3-6*MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)**3-4*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)**3-8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)**3-8*
     &  A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3)
     &  )*MNeu(INe3)*MNeu(INe4)**3-4*MCha2*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**3-8*
     &  A0THpN(ICH3)*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*MNeu(INe3)*MNeu(INe4)**3-8*A0TNeu(INe3)*CF11F12S3R(INe4,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**3-2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)**3-2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)**3+CF11F12S3L(INe3,ICH3)
     &  *DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)**5+
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)**5-8*a0tcha*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  MCha2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe3)*MNeu2(INe3)-8*MCha*A0THpN(ICH3)*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)-8*MCha*A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)-6*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu2(INe3)+4*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  *3*MNeu2(INe3)+8*MCha*A0TNeu(INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*MNeu2(INe3)-4*MCha2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -4*A0TNeu(INe3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -4*MCha2*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-8*A0THpN(ICH3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  -2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)+2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  *3*MNeu(INe4)*MNeu2(INe3)+2*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)**3*MNeu(INe4)*
     &  MNeu2(INe3)-4*MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)**3*MNeu2(INe3)-2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)**3*MNeu2(INe3)-2*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)**3*
     &  MNeu2(INe3)-6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu2(INe3)**2-2*MCha*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe3)**2-2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)
     &  **2-2*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-16*MCha*A0TNeu(INe3)*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe4)+8*MCha*A0TNeu(INe4)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu2(INe4)+8*a0tcha*
     &  MCha*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe4)*MNeu2(INe4)+6*MCha*MCha2*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*MNeu2(INe4)+8*MCha*
     &  A0THpN(ICH3)*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe4)*MNeu2(INe4)+8*MCha*A0TNeu(INe4)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe4)+6*MCha*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MassHpm(ICH3)**2*MNeu(INe4)*
     &  MNeu2(INe4)+4*MCha2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +8*A0THpN(ICH3)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +4*A0TNeu(INe4)*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +4*MCha2*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+8*A0THpN(ICH3)*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+4*A0TNeu(INe4)*CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  +2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MassHpm(ICH3)**2*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)-4*MCha*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+6*MCha*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe3)*MNeu2(INe4)**2+6*MCha*
     &  CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe4)*
     &  MNeu2(INe4)**2+2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)
     &  **2+2*CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+CF11F12S3L(INe4,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe4)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe4)+3*MNeu2(INe4)**2)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe4)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe4)+3*MCha2**2*
     &  MNeu2(INe4)+8*MCha2*A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe4)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-3*MassHpm(ICH3)**4*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*
     &  MNeu2(INe4)+4*MCha2*MNeu2(INe4)**2+8*A0THpN(ICH3)*MNeu2(INe4)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)**2))+CF11F12S3R(INe3,ICH3)*(2*
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-4*a0tcha*
     &  MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe3)+3*MassHpm(ICH3)**2+2*MNeu2(INe3))+4*a0tcha*
     &  MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe4)-(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe3)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe3))*MNeu2(INe4)+3*MNeu2(INe4)**2)+
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(-2*MassHpm(ICH3)**2*MNeu(INe3)**
     &  4+2*MassHpm(ICH3)**2*MNeu(INe4)**4-4*a0tcha*MCha2*MNeu2(INe3)-
     &  3*MCha2**2*MNeu2(INe3)-8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*
     &  MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)
     &  **2*MNeu2(INe3)+3*MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*
     &  MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**
     &  2-4*A0TNeu(INe3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+3*MNeu(INe3)**4+8*MCha2*MNeu2(INe3)
     &  +12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*MassHpm(ICH3)**
     &  2*(MCha2+2*MNeu2(INe3))+4*A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**
     &  2+4*MNeu2(INe3)))+4*a0tcha*MCha2*MNeu2(INe4)+3*MCha2**2*
     &  MNeu2(INe4)+8*MCha2*A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe4)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-3*MassHpm(ICH3)**4*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)-(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe3)**4+8*MCha2*MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+
     &  2*MNeu2(INe3)**2+2*MassHpm(ICH3)**2*(MCha2+2*MNeu2(INe3))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+4*MNeu2(INe3)))*MNeu2(INe4)+4*MCha2
     &  *MNeu2(INe4)**2+8*A0THpN(ICH3)*MNeu2(INe4)**2+4*A0TNeu(INe4)
     &  *MNeu2(INe4)**2))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((CF11F11V2R(INe3,INe4)*(CF11F11V2R(INe4,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*(DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe4,ICH3)-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe3)**2+
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2-
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11F12S3L(INe4,ICH3)*(DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe4,ICH3)-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe3)**2+
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2-
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+
     &  4*CF11F11V2L(INe4,INe3)*MNeu(INe3)*(CF11F12S3L(INe4,ICH3)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChaChiHp(2,INe3,ICH3)+FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChiChaHp(4,INe3,ICH3)
     &  +FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CF11F12S3R(INe4,ICH3)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChaChiHp(2,INe3,ICH3)+FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(1,INe3,ICH3)
     &  +FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu2(INe4))))+
     &  CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe4,INe3)*
     &  (CF11F12S3R(INe4,ICH3)*(DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe4,ICH3)-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe3)**2+
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2-
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11F12S3L(INe4,ICH3)*(DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe4,ICH3)-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe3)**2+
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2-
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+
     &  4*CF11F11V2R(INe4,INe3)*MNeu(INe3)*(CF11F12S3R(INe4,ICH3)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChaChiHp(2,INe3,ICH3)+FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChiChaHp(4,INe3,ICH3)
     &  +FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CF11F12S3L(INe4,ICH3)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChaChiHp(2,INe3,ICH3)+FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChaChiHp(1,INe3,ICH3)
     &  +FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu2(INe4)))))/(4.*(MNeu(INe3)*
     &  *2-MNeu(INe4)**2)**2)-((CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe4,INe3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe4,INe3))*(CF11F12S3L(INe4,ICH3)*(4*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-4*a0tcha*MNeu2(INe3)
     &  -3*MCha2*MNeu2(INe3)-4*A0THpN(ICH3)*MNeu2(INe3)-4*A0TNeu(INe3)*
     &  MNeu2(INe3)-3*MassHpm(ICH3)**2*MNeu2(INe3)-3*MNeu2(INe3)**2+4*
     &  a0tcha*MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*
     &  MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*
     &  A0THpN(ICH3)+8*A0TNeu(INe4)+3*MassHpm(ICH3)**2+2*MNeu2(INe4))-
     &  MNeu2(INe4)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe4)+3*
     &  MassHpm(ICH3)**2+2*MNeu2(INe4)))+DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (-2*MassHpm(ICH3)**2*MNeu(INe3)**4+2*MassHpm(ICH3)**2*
     &  MNeu(INe4)**4-4*a0tcha*MCha2*MNeu2(INe3)-3*MCha2**2*MNeu2(INe3)
     &  -8*MCha2*A0THpN(ICH3)*MNeu2(INe3)-2*MCha2*MassHpm(ICH3)**2*
     &  MNeu2(INe3)+4*A0THpN(ICH3)*MassHpm(ICH3)**2*MNeu2(INe3)+3*
     &  MassHpm(ICH3)**4*MNeu2(INe3)-3*MNeu(INe3)**4*MNeu2(INe3)-4*
     &  MCha2*MNeu2(INe3)**2-8*A0THpN(ICH3)*MNeu2(INe3)**2-4*
     &  A0TNeu(INe3)*MNeu2(INe3)**2+4*a0tcha*MCha2*MNeu2(INe4)+3*MCha2*
     &  *2*MNeu2(INe4)+8*MCha2*A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*
     &  MassHpm(ICH3)**2*MNeu2(INe4)-4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  MNeu2(INe4)-3*MassHpm(ICH3)**4*MNeu2(INe4)+3*MNeu(INe4)**4*
     &  MNeu2(INe4)+4*MCha2*MNeu2(INe4)**2+8*A0THpN(ICH3)*MNeu2(INe4)**
     &  2+4*A0TNeu(INe4)*MNeu2(INe4)**2-2*MNeu(INe4)**4*(2*MCha2+4*
     &  A0THpN(ICH3)+4*A0TNeu(INe4)+MassHpm(ICH3)**2+MNeu2(INe4))+
     &  MNeu2(INe3)*(4*a0tcha*MCha2+3*MCha2**2+2*MCha2*MassHpm(ICH3)**
     &  2-3*MassHpm(ICH3)**4+3*MNeu(INe4)**4+8*MCha2*MNeu2(INe4)+12*
     &  A0TNeu(INe4)*MNeu2(INe4)+4*MassHpm(ICH3)**2*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MNeu2(INe4)*(2*MCha2+4*A0TNeu(INe4)+
     &  MassHpm(ICH3)**2+MNeu2(INe4))+4*A0THpN(ICH3)*(2*MCha2-
     &  MassHpm(ICH3)**2+6*MNeu2(INe4)))-MNeu2(INe4)*(4*a0tcha*MCha2+3*
     &  MCha2**2-3*MassHpm(ICH3)**4+MNeu(INe3)**4+2*MNeu(INe4)**4+4*
     &  MCha2*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+
     &  4*MCha2*MNeu2(INe4)+8*A0TNeu(INe4)*MNeu2(INe4)+2*MassHpm(ICH3)*
     &  *2*(MCha2+MNeu2(INe3)+MNeu2(INe4))+A0THpN(ICH3)*(-4*
     &  MassHpm(ICH3)**2+8*(MCha2+MNeu2(INe3)+MNeu2(INe4))))))+
     &  CF11F12S3R(INe4,ICH3)*(4*MCha*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  MNeu(INe4)*(-4*a0tcha*MNeu2(INe3)-3*MCha2*MNeu2(INe3)-4*
     &  A0THpN(ICH3)*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-3*
     &  MassHpm(ICH3)**2*MNeu2(INe3)-3*MNeu2(INe3)**2+4*a0tcha*
     &  MNeu2(INe4)+3*MCha2*MNeu2(INe4)+4*A0THpN(ICH3)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*MNeu2(INe4)+3*MassHpm(ICH3)**2*MNeu2(INe4)+3*
     &  MNeu2(INe4)**2+MNeu2(INe3)*(4*a0tcha+3*MCha2+4*A0THpN(ICH3)+8*
     &  A0TNeu(INe4)+3*MassHpm(ICH3)**2+2*MNeu2(INe4))-MNeu2(INe4)*(4*
     &  a0tcha+3*MCha2+4*A0THpN(ICH3)+8*A0TNeu(INe4)+3*MassHpm(ICH3)**
     &  2+2*MNeu2(INe4)))+DCONJG(CF11F12S3R(INe4,ICH3))*(-2*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4+2*MassHpm(ICH3)**2*MNeu(INe4)**
     &  4-4*a0tcha*MCha2*MNeu2(INe3)-3*MCha2**2*MNeu2(INe3)-8*MCha2*
     &  A0THpN(ICH3)*MNeu2(INe3)-2*MCha2*MassHpm(ICH3)**2*MNeu2(INe3)+
     &  4*A0THpN(ICH3)*MassHpm(ICH3)**2*MNeu2(INe3)+3*MassHpm(ICH3)**4*
     &  MNeu2(INe3)-3*MNeu(INe3)**4*MNeu2(INe3)-4*MCha2*MNeu2(INe3)**2-
     &  8*A0THpN(ICH3)*MNeu2(INe3)**2-4*A0TNeu(INe3)*MNeu2(INe3)**2+4*
     &  a0tcha*MCha2*MNeu2(INe4)+3*MCha2**2*MNeu2(INe4)+8*MCha2*
     &  A0THpN(ICH3)*MNeu2(INe4)+2*MCha2*MassHpm(ICH3)**2*MNeu2(INe4)-
     &  4*A0THpN(ICH3)*MassHpm(ICH3)**2*MNeu2(INe4)-3*MassHpm(ICH3)**4*
     &  MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)+4*MCha2*MNeu2(INe4)**2+
     &  8*A0THpN(ICH3)*MNeu2(INe4)**2+4*A0TNeu(INe4)*MNeu2(INe4)**2-2*
     &  MNeu(INe4)**4*(2*MCha2+4*A0THpN(ICH3)+4*A0TNeu(INe4)+
     &  MassHpm(ICH3)**2+MNeu2(INe4))+MNeu2(INe3)*(4*a0tcha*MCha2+3*
     &  MCha2**2+2*MCha2*MassHpm(ICH3)**2-3*MassHpm(ICH3)**4+3*
     &  MNeu(INe4)**4+8*MCha2*MNeu2(INe4)+12*A0TNeu(INe4)*MNeu2(INe4)+
     &  4*MassHpm(ICH3)**2*MNeu2(INe4)+2*MNeu2(INe4)**2+2*MNeu2(INe4)*
     &  (2*MCha2+4*A0TNeu(INe4)+MassHpm(ICH3)**2+MNeu2(INe4))+4*
     &  A0THpN(ICH3)*(2*MCha2-MassHpm(ICH3)**2+6*MNeu2(INe4)))-
     &  MNeu2(INe4)*(4*a0tcha*MCha2+3*MCha2**2-3*MassHpm(ICH3)**4+
     &  MNeu(INe3)**4+2*MNeu(INe4)**4+4*MCha2*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+4*MCha2*MNeu2(INe4)+
     &  8*A0TNeu(INe4)*MNeu2(INe4)+2*MassHpm(ICH3)**2*(MCha2+
     &  MNeu2(INe3)+MNeu2(INe4))+A0THpN(ICH3)*(-4*MassHpm(ICH3)**2+
     &  8*(MCha2+MNeu2(INe3)+MNeu2(INe4))))))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe5)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       selfZ=selfZ+(((CF11F11V2R(INe3,INe3)**2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F11V2L(INe3,INe3)**2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*(4*
     &  A0TNeu(INe3)-3*MNeu2(INe3))+(CF11F11V2L(INe3,INe3)**2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F11V2R(INe3,INe3)**2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(4*A0TNeu(INe3)-3*MNeu2(INe3))+
     &  (4*MCha*(CF11F11V2L(INe3,INe3)**2+CF11F11V2R(INe3,INe3)**2)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*(4*
     &  A0TNeu(INe3)-3*MNeu2(INe3)))/MNeu(INe3)+(CF11F11V2R(INe3,INe3)*
     &  *2*CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F11V2L(INe3,INe3)**2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3)))*(4*MCha2+8*A0THpN(ICH3)+12*
     &  A0TNeu(INe3)+2*MassHpm(ICH3)**2-MNeu2(INe3))+
     &  (CF11F11V2L(INe3,INe3)**2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF11F11V2R(INe3,INe3)**2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*(4*MCha2+
     &  8*A0THpN(ICH3)+12*A0TNeu(INe3)+2*MassHpm(ICH3)**2-MNeu2(INe3)))
     &  /64.+(-4*CF11F11V2L(INe3,INe3)*CF11F11V2R(INe3,INe3)*
     &  (CF11F12S3L(INe3,ICH3)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  MNeu(INe3)*(FD311ChiChaHp(3,INe3,ICH3)+
     &  FD311ChiChaHp(1,INe3,ICH3)*MNeu(INe3)**2)+2*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChiChaHp(2,INe3,ICH3)*
     &  MNeu2(INe3))+CF11F12S3R(INe3,ICH3)*(MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (FD311ChiChaHp(3,INe3,ICH3)+FD311ChiChaHp(1,INe3,ICH3)*
     &  MNeu(INe3)**2)+2*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3)))+CF11F11V2L(INe3,INe3)*
     &  *2*(CF11F12S3L(INe3,ICH3)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))
     &  *FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)+
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3R(INe3,ICH3)*
     &  (2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)+
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3))))+CF11F11V2R(INe3,INe3)
     &  **2*(CF11F12S3L(INe3,ICH3)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)+
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3R(INe3,ICH3)*
     &  (2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)+
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3)))))/4.)
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do INe3=1,3
       selfZ=selfZ+((CF11F12S3R(INe3,ICH3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(CF12F12V2L*(CF12F12V2L-4*
     &  CF12F12V2R)*MCha2*FD311ChaChiHp(2,INe3,ICH3)+CF12F12V2R**2*
     &  FD311ChaChiHp(4,INe3,ICH3))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-2*CF12F12V2L*CF12F12V2R*MCha**2*FD311ChaChiHp(1,INe3,ICH3)+
     &  (CF12F12V2L-CF12F12V2R)**2*FD311ChaChiHp(3,INe3,ICH3))*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(CF12F12V2R*(-4*CF12F12V2L+CF12F12V2R)*MCha2*
     &  FD311ChaChiHp(2,INe3,ICH3)+CF12F12V2L**2*
     &  FD311ChaChiHp(4,INe3,ICH3))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-2*CF12F12V2L*CF12F12V2R*MCha**2*FD311ChaChiHp(1,INe3,ICH3)+
     &  (CF12F12V2L-CF12F12V2R)**2*FD311ChaChiHp(3,INe3,ICH3))*
     &  MNeu(INe3)))/2.+((4*a0tcha-3*MCha2)*(CF12F12V2R**2*
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+CF12F12V2L*
     &  *2*CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))+(2*
     &  (CF12F12V2L**2+CF12F12V2R**2)*(4*a0tcha-3*MCha2)*
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*MNeu(INe3)
     &  )/MCha+(CF12F12V2L**2*CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))+CF12F12V2R**2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*(12*
     &  a0tcha-MCha2+8*A0THpN(ICH3)+2*MassHpm(ICH3)**2+4*MNeu2(INe3)))/32.)
       enddo 
       enddo 



       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
       do ISt3=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((3*(CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe5,INe3)*(-
     &  (M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4))+M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111ChiTST(4,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**3-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111ChiTST(4,INe5,ISt3)
     &  *MNeu(INe4)**3-M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe5)+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*FD111ChiTST(4,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu(INe5)-CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu(INe5)+M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**2*MNeu(INe5)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*FD111ChiTST(4,INe5,ISt3)
     &  *MNeu(INe4)**2*MNeu(INe5)+CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu(INe5)+CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3*MNeu(INe5)-
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe4)**3*MNeu(INe5)-CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe4)**3*
     &  MNeu(INe5)-M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)*MNeu(INe5)**2+M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111ChiTST(4,INe4,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**2-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe5,ISt3)*FD111ChiTST(4,INe3,ISt3)*MNeu(INe5)**3+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*FD111ChiTST(4,INe4,ISt3)
     &  *MNeu(INe5)**3-CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe4)*MNeu(INe5)**3-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**3+CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe4)*MNeu(INe5)**3+
     &  CF11FSL(INe5,ISt3)*(M1*CF11FSRC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe5,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2)+
     &  FD111ChiTST(4,INe3,ISt3)*(MNeu(INe4)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSLC(INe4,ISt3)*(FD111ChiTST(5,INe5,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiTST(5,INe3,ISt3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(5,INe4,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2)))+CF11FSR(INe4,ISt3)*(M1*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe5)*(FD111ChiTST(4,INe5,ISt3)*(MNeu(INe3)**2-MNeu(INe4)*
     &  *2)+FD111ChiTST(4,INe3,ISt3)*(MNeu(INe4)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSRC(INe5,ISt3)*(FD111ChiTST(5,INe5,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiTST(5,INe3,ISt3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(5,INe4,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2))))+2*CF11F11V2R(INe5,INe3)*MNeu(INe3)*
     &  (CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)-CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe4)**3+CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe5)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu(INe5)+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2*MNeu(INe5)+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe4)**2*
     &  MNeu(INe5)-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe4)**3*MNeu(INe5)-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)**3*MNeu(INe5)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(1,INe5,ISt3)*MNeu(INe4)**3*
     &  MNeu(INe5)+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe4)**3*MNeu(INe5)+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**2-CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**2+CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe5)**3-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe5)**3+M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**3-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*MNeu(INe5)**3-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(1,INe4,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+CF11FSLC(INe5,ISt3)*(M1*
     &  CF11FSR(INe4,ISt3)*(FD111ChiTST(4,INe5,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe4)**2)+FD111ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(4,INe3,ISt3)*(-MNeu(INe4)**2+
     &  MNeu(INe5)**2))+CF11FSL(INe4,ISt3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe5,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111TChiST(2,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111TChiST(2,INe3,ISt3)*(-MNeu(INe4)**2+MNeu(INe5)**2)))+
     &  CF11FSLC(INe4,ISt3)*(M1*CF11FSR(INe5,ISt3)*
     &  (FD111ChiTST(4,INe5,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe3,ISt3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  CF11FSL(INe5,ISt3)*MNeu(INe5)*(FD111TChiST(2,INe5,ISt3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111TChiST(2,INe4,ISt3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111TChiST(2,INe3,ISt3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2)))))+CF11F11V2R(INe3,INe4)*
     &  (CF11F11V2R(INe5,INe3)*(-(M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4))+M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe4)**3-M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe4)**3-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe5)-
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu(INe5)+CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)**2*
     &  MNeu(INe5)-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe4)**2*MNeu(INe5)+
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**3*MNeu(INe5)+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu(INe5)-CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe4)**3*MNeu(INe5)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe4)**3*MNeu(INe5)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**2+M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)*MNeu(INe5)**2-M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe5)**3+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe5)**3-CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**3-CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe4)*MNeu(INe5)**3+
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**3+CF11FSL(INe4,ISt3)*(M1*CF11FSRC(INe5,ISt3)*
     &  MNeu(INe5)*(FD111ChiTST(4,INe5,ISt3)*(MNeu(INe3)**2-MNeu(INe4)*
     &  *2)+FD111ChiTST(4,INe3,ISt3)*(MNeu(INe4)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSLC(INe5,ISt3)*(FD111ChiTST(5,INe5,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiTST(5,INe3,ISt3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(5,INe4,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2)))+CF11FSR(INe5,ISt3)*(M1*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe4)*(FD111ChiTST(4,INe5,ISt3)*(MNeu(INe3)**2-MNeu(INe4)*
     &  *2)+FD111ChiTST(4,INe3,ISt3)*(MNeu(INe4)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSRC(INe4,ISt3)*(FD111ChiTST(5,INe5,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)+FD111ChiTST(5,INe3,ISt3)*(MNeu(INe4)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(5,INe4,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe5)**2))))+2*CF11F11V2L(INe5,INe3)*MNeu(INe3)*
     &  (CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**3+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe4)**3+CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe5)-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu(INe5)+M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)
     &  *FD111TChiST(1,INe4,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu(INe5)-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2*MNeu(INe5)+CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe4)**2*
     &  MNeu(INe5)-M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe4)**3*MNeu(INe5)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)**3*MNeu(INe5)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD111TChiST(1,INe5,ISt3)*MNeu(INe4)**3*
     &  MNeu(INe5)+M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe4)**3*MNeu(INe5)+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**2-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**2+CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe5)**3-CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe5)**3+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*
     &  MNeu(INe5)**3-M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*MNeu(INe5)**3-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*FD111TChiST(1,INe4,ISt3)
     &  *MNeu(INe4)*MNeu(INe5)**3+CF11FSL(INe5,ISt3)*(M1*
     &  CF11FSRC(INe4,ISt3)*(FD111ChiTST(4,INe5,ISt3)*(-MNeu(INe3)**2+
     &  MNeu(INe4)**2)+FD111ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-
     &  MNeu(INe5)**2)+FD111ChiTST(4,INe3,ISt3)*(-MNeu(INe4)**2+
     &  MNeu(INe5)**2))+CF11FSLC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe5,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111TChiST(2,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111TChiST(2,INe3,ISt3)*(-MNeu(INe4)**2+MNeu(INe5)**2)))+
     &  CF11FSL(INe4,ISt3)*(M1*CF11FSRC(INe5,ISt3)*
     &  (FD111ChiTST(4,INe5,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe5)**2)+
     &  FD111ChiTST(4,INe3,ISt3)*(-MNeu(INe4)**2+MNeu(INe5)**2))+
     &  CF11FSLC(INe5,ISt3)*MNeu(INe5)*(FD111TChiST(2,INe5,ISt3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111TChiST(2,INe4,ISt3)*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)+FD111TChiST(2,INe3,ISt3)*(-
     &  MNeu(INe4)**2+MNeu(INe5)**2)))))))/(4.*(MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  (3*((2*M1*(CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe4)+
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe3))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe3))+MNeu2(INe3)*(4*a0t1+3*M12+4*A0TNeu(INe3)+3*
     &  MNeu2(INe3))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+(2*M1*
     &  (CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe3))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe3))+MNeu2(INe3)*(4*a0t1+3*M12+4*A0TNeu(INe3)+3*
     &  MNeu2(INe3))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe3)**4+4*M12*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe3))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)))))/((MNeu(INe3)-MNeu(INe4))
     &  *(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe3)**4+4*M12*MNeu2(INe3)+4*A0TNeu(INe3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe3))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)))))/((MNeu(INe3)-MNeu(INe4))
     &  *(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  (-3*MassSu(ISt3)**4*MNeu2(INe3)+MNeu2(INe3)*(M12*(4*a0t1+3*M12)
     &  +3*MNeu(INe3)**4+4*(M12+A0TNeu(INe3))*MNeu2(INe3))+aA0TN(ISt3)*
     &  (8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe3)+8*MNeu2(INe3)**2)
     &  +2*MassSu2(ISt3)*(MNeu(INe3)**4+M12*(4*a0t1+2*M12+MNeu2(INe3)))
     &  ))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)
     &  -MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+((CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3))*(-3*MassSu(ISt3)**4*MNeu2(INe3)+
     &  MNeu2(INe3)*(M12*(4*a0t1+3*M12)+3*MNeu(INe3)**4+4*(M12+
     &  A0TNeu(INe3))*MNeu2(INe3))+aA0TN(ISt3)*(8*M12**2+(8*M12-4*
     &  MassSu2(ISt3))*MNeu2(INe3)+8*MNeu2(INe3)**2)+2*MassSu2(ISt3)*
     &  (MNeu(INe3)**4+M12*(4*a0t1+2*M12+MNeu2(INe3)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5)))-(2*M1*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*(CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe4)+CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe4))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe4))+MNeu2(INe4)*(4*a0t1+3*M12+4*A0TNeu(INe4)+3*
     &  MNeu2(INe4))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-(2*M1*
     &  (CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe4))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe4))+MNeu2(INe4)*(4*a0t1+3*M12+4*A0TNeu(INe4)+3*
     &  MNeu2(INe4))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe4)**4+4*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe4))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe4)))))/((MNeu(INe3)-MNeu(INe4))
     &  *(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe4)**4+4*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe4))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe4)))))/((MNeu(INe3)-MNeu(INe4))
     &  *(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  (-3*MassSu(ISt3)**4*MNeu2(INe4)+MNeu2(INe4)*(M12*(4*a0t1+3*M12)
     &  +3*MNeu(INe4)**4+4*(M12+A0TNeu(INe4))*MNeu2(INe4))+aA0TN(ISt3)*
     &  (8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe4)+8*MNeu2(INe4)**2)
     &  +2*MassSu2(ISt3)*(MNeu(INe4)**4+M12*(4*a0t1+2*M12+MNeu2(INe4)))
     &  ))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)
     &  -MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-((CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+
     &  CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3))*(-3*MassSu(ISt3)**4*MNeu2(INe4)+
     &  MNeu2(INe4)*(M12*(4*a0t1+3*M12)+3*MNeu(INe4)**4+4*(M12+
     &  A0TNeu(INe4))*MNeu2(INe4))+aA0TN(ISt3)*(8*M12**2+(8*M12-4*
     &  MassSu2(ISt3))*MNeu2(INe4)+8*MNeu2(INe4)**2)+2*MassSu2(ISt3)*
     &  (MNeu(INe4)**4+M12*(4*a0t1+2*M12+MNeu2(INe4)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))-(2*M1*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*(CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe4)+CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe5))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe5))+MNeu2(INe5)*(4*a0t1+3*M12+4*A0TNeu(INe5)+3*
     &  MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))
     &  *(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-(2*M1*
     &  (CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  (CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe4)+
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe5))+
     &  CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  (CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe5)))*(4*
     &  aA0TN(ISt3)*(M12+MNeu2(INe5))+MassSu2(ISt3)*(4*a0t1+2*M12+3*
     &  MNeu2(INe5))+MNeu2(INe5)*(4*a0t1+3*M12+4*A0TNeu(INe5)+3*
     &  MNeu2(INe5))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))
     &  *(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe5)**4+4*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+2*
     &  MNeu2(INe5)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe5))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe5))
     &  *(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3))*
     &  MNeu(INe4)*MNeu(INe5)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+
     &  MNeu(INe5)**4+4*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+2*
     &  MNeu2(INe5)**2+2*MassSu2(ISt3)*(M12+MNeu2(INe5))+aA0TN(ISt3)*(-
     &  4*MassSu2(ISt3)+8*(M12+MNeu2(INe5)))))/((MNeu(INe3)-MNeu(INe5))
     &  *(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-((CF11F11V2L(INe3,INe4)*CF11F11V2L(INe5,INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe5,INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3))*
     &  (-3*MassSu(ISt3)**4*MNeu2(INe5)+MNeu2(INe5)*(M12*(4*a0t1+3*M12)
     &  +3*MNeu(INe5)**4+4*(M12+A0TNeu(INe5))*MNeu2(INe5))+aA0TN(ISt3)*
     &  (8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe5)+8*MNeu2(INe5)**2)
     &  +2*MassSu2(ISt3)*(MNeu(INe5)**4+M12*(4*a0t1+2*M12+MNeu2(INe5)))
     &  ))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-
     &  MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  ((CF11F11V2R(INe3,INe4)*CF11F11V2R(INe5,INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)+CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe5,INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3))*
     &  (-3*MassSu(ISt3)**4*MNeu2(INe5)+MNeu2(INe5)*(M12*(4*a0t1+3*M12)
     &  +3*MNeu(INe5)**4+4*(M12+A0TNeu(INe5))*MNeu2(INe5))+aA0TN(ISt3)*
     &  (8*M12**2+(8*M12-4*MassSu2(ISt3))*MNeu2(INe5)+8*MNeu2(INe5)**2)
     &  +2*MassSu2(ISt3)*(MNeu(INe5)**4+M12*(4*a0t1+2*M12+MNeu2(INe5)))))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*
     &  (-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))))/64.)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*(CF11F11V2R(INe3,INe3)*(CF11F11V2R(INe5,INe3)*
     &  (M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)-M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**3+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe5)-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111ChiTST(4,INe5,ISt3)*MNeu(INe5)+
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)+CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)-CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*MNeu(INe5)-M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)-CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe5)-CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)**2+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe5)**3+
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)**3+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11FSL(INe3,ISt3)*(M1*CF11FSRC(INe5,ISt3)*
     &  MNeu(INe5)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSLC(INe5,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2)))+CF11FSR(INe5,ISt3)*(M1*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSRC(INe3,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))))-2*CF11F11V2L(INe5,INe3)*
     &  (CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**4+CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)-CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)**2+CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11FSL(INe5,ISt3)*MNeu(INe3)*
     &  (CF11FSLC(INe3,ISt3)*MNeu(INe3)*(FD111TChiST(2,INe3,ISt3)-
     &  FD111TChiST(2,INe5,ISt3)+FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))+M1*CF11FSRC(INe3,ISt3)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CF11FSL(INe3,ISt3)*MNeu(INe3)*(CF11FSLC(INe5,ISt3)*MNeu(INe5)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+M1*
     &  CF11FSRC(INe5,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe5,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2)))+M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe5)*MNeu2(INe3)+M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe5)*MNeu2(INe3)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)-M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*MNeu2(INe3)-M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe5,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)*MNeu2(INe3)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*
     &  MNeu2(INe3)+M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*MNeu2(INe3)))+
     &  CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe5,INe3)*(M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)-M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe5)-M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe5)+CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)+CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)-CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*MNeu(INe5)-M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)-CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe5)-CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)**2+M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe5,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe5)**3+
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)**3+CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11FSL(INe5,ISt3)*(M1*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSLC(INe3,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2)))+CF11FSR(INe3,ISt3)*(M1*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe5)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CF11FSRC(INe5,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))))-2*CF11F11V2R(INe5,INe3)*
     &  (CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2-
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**4+CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(2,INe5,ISt3)
     &  *MNeu(INe3)*MNeu(INe5)-CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11FSLC(INe5,ISt3)*MNeu(INe3)*
     &  (CF11FSL(INe3,ISt3)*MNeu(INe3)*(FD111TChiST(2,INe3,ISt3)-
     &  FD111TChiST(2,INe5,ISt3)+FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))+M1*CF11FSR(INe3,ISt3)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*(CF11FSL(INe5,ISt3)*MNeu(INe5)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+M1*
     &  CF11FSR(INe5,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe5,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2)))+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe5)*MNeu2(INe3)+M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe5)*MNeu2(INe3)-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)-M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*MNeu2(INe3)-M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)*MNeu2(INe3)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*
     &  MNeu2(INe3)+M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*MNeu2(INe3)))))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe5)**2)**2)+(3*(CF11F11V2R(INe3,INe3)*
     &  CF11F11V2R(INe5,INe3)*(8*a0t1*M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3+6*M1*M12*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3+16*M1*A0TNeu(INe3)*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)**3+8*M1*
     &  aA0TN(ISt3)*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)**
     &  3+6*M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)**3+4*M12*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe5)+8*A0TNeu(INe3)*CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+8*aA0TN(ISt3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)
     &  +4*M12*CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe5)+8*A0TNeu(INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)**3*MNeu(INe5)+8*aA0TN(ISt3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)**3*MNeu(INe5)
     &  +2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)**3*MNeu(INe5)+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)**3*MNeu(INe5)-
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)**5*MNeu(INe5)
     &  -CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)**5*
     &  MNeu(INe5)-8*a0t1*M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe5)**3-6*M1*M12*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe5)**3-16*M1*A0TNeu(INe3)*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe5)**3-8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)**3-6*M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe5)
     &  **3-4*M12*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3-8*A0TNeu(INe3)*CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**3-8*aA0TN(ISt3)*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  3-4*M12*CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3-8*A0TNeu(INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**3-8*aA0TN(ISt3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  3-2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu(INe5)**3-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)**3+
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  5+CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  *5-8*a0t1*M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*
     &  MNeu2(INe3)-6*M1*M12*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)-8*M1*A0TNeu(INe3)*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)-8*M1*aA0TN(ISt3)*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  6*M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)+4*M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3*MNeu2(INe3)+8*M1*A0TNeu(INe3)*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*MNeu2(INe3)-
     &  4*M12*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-8*
     &  aA0TN(ISt3)*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*M12*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-8*aA0TN(ISt3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-2*
     &  CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe5)*MNeu2(INe3)-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)+2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)
     &  **3*MNeu(INe5)*MNeu2(INe3)+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)**3*MNeu(INe5)*MNeu2(INe3)-4*M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)**3*
     &  MNeu2(INe3)-2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)
     &  *MNeu(INe5)**3*MNeu2(INe3)-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**3*MNeu2(INe3)-6*M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)**
     &  2-2*M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)**2-2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-16*M1*
     &  A0TNeu(INe3)*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*
     &  MNeu2(INe5)+8*M1*A0TNeu(INe5)*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe5)+8*a0t1*M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*MNeu2(INe5)+
     &  6*M1*M12*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*
     &  MNeu2(INe5)+8*M1*A0TNeu(INe5)*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe5)*MNeu2(INe5)+8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*MNeu2(INe5)+
     &  6*M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe5)*MNeu2(INe5)+4*M12*CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+8*aA0TN(ISt3)*CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+4*M12*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe5)+4*A0TNeu(INe5)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+8*
     &  aA0TN(ISt3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)
     &  *MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+2*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe5)*MNeu2(INe5)-4*M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)*MNeu2(INe5)+6*M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe5)**
     &  2+6*M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe5)*
     &  MNeu2(INe5)**2+2*CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+
     &  CF11FSL(INe3,ISt3)*(2*M1*CF11FSRC(INe5,ISt3)*MNeu(INe5)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe5)+
     &  3*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+4*aA0TN(ISt3)*
     &  MNeu2(INe5)+3*MassSu2(ISt3)*MNeu2(INe5)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe5)+3*MNeu2(INe5)**2)+CF11FSLC(INe5,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe5)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe5)+3*M12**2*
     &  MNeu2(INe5)+8*M12*aA0TN(ISt3)*MNeu2(INe5)-3*MassSu(ISt3)**4*
     &  MNeu2(INe5)+2*M12*MassSu2(ISt3)*MNeu2(INe5)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe5)+3*MNeu(INe5)**4*MNeu2(INe5)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe5)+4*M12*MNeu2(INe5)**2+
     &  4*A0TNeu(INe5)*MNeu2(INe5)**2+8*aA0TN(ISt3)*MNeu2(INe5)**2))+
     &  CF11FSR(INe5,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu(INe3)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe5)+
     &  3*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+4*aA0TN(ISt3)*
     &  MNeu2(INe5)+3*MassSu2(ISt3)*MNeu2(INe5)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe5)+3*MNeu2(INe5)**2)+CF11FSRC(INe3,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe5)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe5)+3*M12**2*
     &  MNeu2(INe5)+8*M12*aA0TN(ISt3)*MNeu2(INe5)-3*MassSu(ISt3)**4*
     &  MNeu2(INe5)+2*M12*MassSu2(ISt3)*MNeu2(INe5)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe5)+3*MNeu(INe5)**4*MNeu2(INe5)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe5)+4*M12*MNeu2(INe5)**2+
     &  4*A0TNeu(INe5)*MNeu2(INe5)**2+8*aA0TN(ISt3)*MNeu2(INe5)**2)))+
     &  CF11F11V2L(INe3,INe3)*CF11F11V2L(INe5,INe3)*(8*a0t1*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)**3+6*M1*M12*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)**3+16*M1*
     &  A0TNeu(INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  *3+8*M1*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  MNeu(INe3)**3+6*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe3)**3+4*M12*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MNeu(INe3)**3*MNeu(INe5)+8*A0TNeu(INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)**3*MNeu(INe5)
     &  +8*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe5)+4*M12*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)+8*A0TNeu(INe3)*
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)
     &  +8*aA0TN(ISt3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe5)+2*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)**3*MNeu(INe5)+2*
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  **3*MNeu(INe5)-CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe3)**5*MNeu(INe5)-CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)
     &  *MNeu(INe3)**5*MNeu(INe5)-8*a0t1*M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe5,ISt3)*MNeu(INe5)**3-6*M1*M12*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe5,ISt3)*MNeu(INe5)**3-16*M1*A0TNeu(INe3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)**3-8*M1*
     &  aA0TN(ISt3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)**
     &  3-6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe5)**3-4*M12*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe3)*MNeu(INe5)**3-8*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**3-8*aA0TN(ISt3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  3-4*M12*CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3-8*A0TNeu(INe3)*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**3-8*aA0TN(ISt3)*
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  3-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu(INe5)**3-2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)**3+
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)**
     &  5+CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  *5-8*a0t1*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu2(INe3)-6*M1*M12*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)-8*M1*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe3)-8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  6*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)+4*M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)**3*MNeu2(INe3)+8*M1*A0TNeu(INe3)
     &  *CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*MNeu2(INe3)-
     &  4*M12*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-8*
     &  aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-4*M12*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe3)-8*aA0TN(ISt3)*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)-2*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe5)*MNeu2(INe3)-2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe3)+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)
     &  **3*MNeu(INe5)*MNeu2(INe3)+2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)*MNeu2(INe3)-4*M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)**3*
     &  MNeu2(INe3)-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)
     &  *MNeu(INe5)**3*MNeu2(INe3)-2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**3*MNeu2(INe3)-6*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe3)**
     &  2-2*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)**2-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe3)**2-16*M1*
     &  A0TNeu(INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu2(INe5)+8*M1*A0TNeu(INe5)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe5)+8*a0t1*M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*MNeu2(INe5)+
     &  6*M1*M12*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe5)+8*M1*A0TNeu(INe5)*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe5,ISt3)*MNeu(INe5)*MNeu2(INe5)+8*M1*aA0TN(ISt3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*MNeu2(INe5)+
     &  6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe5)*MNeu2(INe5)+4*M12*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+4*
     &  A0TNeu(INe5)*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+8*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe5,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+4*M12*
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*
     &  MNeu2(INe5)+4*A0TNeu(INe5)*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+8*
     &  aA0TN(ISt3)*CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)*MNeu2(INe5)+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)
     &  *MassSu2(ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)+2*
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe5)*MNeu2(INe5)-4*M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe3)*MNeu2(INe5)+6*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe5,ISt3)*MNeu(INe3)*MNeu2(INe5)**
     &  2+6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe5)**2+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe5,ISt3)*
     &  MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+2*CF11FSR(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe5)*MNeu2(INe5)**2+
     &  CF11FSL(INe5,ISt3)*(2*M1*CF11FSRC(INe3,ISt3)*MNeu(INe3)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe5)+
     &  3*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+4*aA0TN(ISt3)*
     &  MNeu2(INe5)+3*MassSu2(ISt3)*MNeu2(INe5)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe5)+3*MNeu2(INe5)**2)+CF11FSLC(INe3,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe5)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe5)+3*M12**2*
     &  MNeu2(INe5)+8*M12*aA0TN(ISt3)*MNeu2(INe5)-3*MassSu(ISt3)**4*
     &  MNeu2(INe5)+2*M12*MassSu2(ISt3)*MNeu2(INe5)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe5)+3*MNeu(INe5)**4*MNeu2(INe5)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe5)+4*M12*MNeu2(INe5)**2+
     &  4*A0TNeu(INe5)*MNeu2(INe5)**2+8*aA0TN(ISt3)*MNeu2(INe5)**2))+
     &  CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe5,ISt3)*MNeu(INe5)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe5)+
     &  3*M12*MNeu2(INe5)+4*A0TNeu(INe5)*MNeu2(INe5)+4*aA0TN(ISt3)*
     &  MNeu2(INe5)+3*MassSu2(ISt3)*MNeu2(INe5)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe5)+3*MNeu2(INe5)**2)+CF11FSRC(INe5,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe5)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe5)+3*M12**2*
     &  MNeu2(INe5)+8*M12*aA0TN(ISt3)*MNeu2(INe5)-3*MassSu(ISt3)**4*
     &  MNeu2(INe5)+2*M12*MassSu2(ISt3)*MNeu2(INe5)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe5)+3*MNeu(INe5)**4*MNeu2(INe5)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-MassSu2(ISt3)+
     &  4*MNeu2(INe3)))*MNeu2(INe5)+4*M12*MNeu2(INe5)**2+4*
     &   A0TNeu(INe5)*MNeu2(INe5)**2+8*aA0TN(ISt3)*MNeu2(INe5)**2))))
     &   )/(64.*(MNeu2(INe3)-MNeu2(INe5))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*(CF11F11V2L(INe3,INe3)*(CF11F11V2L(INe3,INe4)*
     &  (M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**3+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)+CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)-CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe4)-CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)**2+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)**3+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSL(INe3,ISt3)*(M1*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe4)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSLC(INe4,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2)))+CF11FSR(INe4,ISt3)*(M1*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSRC(INe3,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))))-2*CF11F11V2R(INe3,INe4)*
     &  (CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**4+CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)-CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSL(INe4,ISt3)*MNeu(INe3)*
     &  (CF11FSLC(INe3,ISt3)*MNeu(INe3)*(FD111TChiST(2,INe3,ISt3)-
     &  FD111TChiST(2,INe4,ISt3)+FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))+M1*CF11FSRC(INe3,ISt3)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSL(INe3,ISt3)*MNeu(INe3)*(CF11FSLC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+M1*
     &  CF11FSRC(INe4,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe4,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2)))+M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)+M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)*MNeu2(INe3)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)-M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*MNeu2(INe3)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu2(INe3)+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu2(INe3)+M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*MNeu2(INe3)))+
     &  CF11F11V2R(INe3,INe3)*(CF11F11V2R(INe3,INe4)*(M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)-M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3+M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*FD111ChiTST(4,INe3,ISt3)
     &  *MNeu(INe4)-M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)+CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)-CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)-CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe4)-CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD211ChiTST(4,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)**2+M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)**3+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSL(INe4,ISt3)*(M1*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSLC(INe3,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2)))+CF11FSR(INe3,ISt3)*(M1*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe4)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CF11FSRC(INe4,ISt3)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))))-2*CF11F11V2L(INe3,INe4)*
     &  (CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2-
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**4+CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(2,INe4,ISt3)
     &  *MNeu(INe3)*MNeu(INe4)-CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(2,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSLC(INe4,ISt3)*MNeu(INe3)*
     &  (CF11FSL(INe3,ISt3)*MNeu(INe3)*(FD111TChiST(2,INe3,ISt3)-
     &  FD111TChiST(2,INe4,ISt3)+FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))+M1*CF11FSR(INe3,ISt3)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*(CF11FSL(INe4,ISt3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+M1*
     &  CF11FSR(INe4,ISt3)*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe4,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2)))+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)+M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*FD111TChiST(1,INe3,ISt3)
     &  *MNeu(INe4)*MNeu2(INe3)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)-M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*MNeu2(INe3)-M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu2(INe3)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu2(INe3)+M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*MNeu2(INe3)))))/(4.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)**2)+(3*(CF11F11V2L(INe3,INe3)*
     &  CF11F11V2L(INe3,INe4)*(8*a0t1*M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3+6*M1*M12*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3+16*M1*A0TNeu(INe3)*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)**3+8*M1*
     &  aA0TN(ISt3)*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)**
     &  3+6*M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)**3+4*M12*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe4)+8*A0TNeu(INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+8*aA0TN(ISt3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)
     &  +4*M12*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe4)+8*A0TNeu(INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+8*aA0TN(ISt3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)
     &  +2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)**3*MNeu(INe4)+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)**5*MNeu(INe4)
     &  -CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**5*
     &  MNeu(INe4)-8*a0t1*M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe4)**3-6*M1*M12*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe4)**3-16*M1*A0TNeu(INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe4)**3-8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)**3-6*M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe4)
     &  **3-4*M12*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-8*A0TNeu(INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3-8*aA0TN(ISt3)*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  3-4*M12*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-8*A0TNeu(INe3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**3-8*aA0TN(ISt3)*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  3-2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu(INe4)**3-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  5+CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  *5-8*a0t1*M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*
     &  MNeu2(INe3)-6*M1*M12*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)-8*M1*A0TNeu(INe3)*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)-8*M1*aA0TN(ISt3)*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  6*M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)+4*M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)**3*MNeu2(INe3)+8*M1*A0TNeu(INe3)*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)-
     &  4*M12*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-8*
     &  aA0TN(ISt3)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*M12*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-8*aA0TN(ISt3)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe3)-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)
     &  **3*MNeu(INe4)*MNeu2(INe3)+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)*MNeu2(INe3)-4*M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu2(INe3)-2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)
     &  *MNeu(INe4)**3*MNeu2(INe3)-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**3*MNeu2(INe3)-6*M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)**
     &  2-2*M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)**2-2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-16*M1*
     &  A0TNeu(INe3)*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*
     &  MNeu2(INe4)+8*M1*A0TNeu(INe4)*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe4)+8*a0t1*M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*MNeu2(INe4)+
     &  6*M1*M12*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*
     &  MNeu2(INe4)+8*M1*A0TNeu(INe4)*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe4)*MNeu2(INe4)+8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*MNeu2(INe4)+
     &  6*M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe4)*MNeu2(INe4)+4*M12*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+8*aA0TN(ISt3)*CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+4*M12*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe4)+4*A0TNeu(INe4)*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+8*
     &  aA0TN(ISt3)*CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)
     &  *MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)-4*M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)+6*M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*MNeu(INe3)*MNeu2(INe4)**
     &  2+6*M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe4)*
     &  MNeu2(INe4)**2+2*CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+2*CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+
     &  CF11FSL(INe3,ISt3)*(2*M1*CF11FSRC(INe4,ISt3)*MNeu(INe4)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe4)+
     &  3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+4*aA0TN(ISt3)*
     &  MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2)+CF11FSLC(INe4,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe4)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe4)+3*M12**2*
     &  MNeu2(INe4)+8*M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*
     &  MNeu2(INe4)+2*M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe4)+4*M12*MNeu2(INe4)**2+
     &  4*A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*MNeu2(INe4)**2))+
     &  CF11FSR(INe4,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu(INe3)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe4)+
     &  3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+4*aA0TN(ISt3)*
     &  MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2)+CF11FSRC(INe3,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe4)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe4)+3*M12**2*
     &  MNeu2(INe4)+8*M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*
     &  MNeu2(INe4)+2*M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe4)+4*M12*MNeu2(INe4)**2+
     &  4*A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*MNeu2(INe4)**2)))+
     &  CF11F11V2R(INe3,INe3)*CF11F11V2R(INe3,INe4)*(8*a0t1*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**3+6*M1*M12*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)**3+16*M1*
     &  A0TNeu(INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  *3+8*M1*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)**3+6*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MassSu2(ISt3)*MNeu(INe3)**3+4*M12*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)+8*A0TNeu(INe3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)**3*MNeu(INe4)
     &  +8*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe4)+4*M12*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)+8*A0TNeu(INe3)*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)
     &  +8*aA0TN(ISt3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)**3*MNeu(INe4)+2*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)**3*MNeu(INe4)+2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  **3*MNeu(INe4)-CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)**5*MNeu(INe4)-CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)
     &  *MNeu(INe3)**5*MNeu(INe4)-8*a0t1*M1*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4)**3-6*M1*M12*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4)**3-16*M1*A0TNeu(INe3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)**3-8*M1*
     &  aA0TN(ISt3)*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)**
     &  3-6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe4)**3-4*M12*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)**3-8*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**3-8*aA0TN(ISt3)*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  3-4*M12*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3-8*A0TNeu(INe3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3-8*aA0TN(ISt3)*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  3-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu(INe4)**3-2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)**
     &  5+CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  *5-8*a0t1*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu2(INe3)-6*M1*M12*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)-8*M1*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)-8*M1*aA0TN(ISt3)*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)-
     &  6*M1*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe3)*MNeu2(INe3)+4*M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)**3*MNeu2(INe3)+8*M1*A0TNeu(INe3)
     &  *CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*MNeu2(INe3)-
     &  4*M12*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*A0TNeu(INe3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-8*
     &  aA0TN(ISt3)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-4*M12*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe3)-8*aA0TN(ISt3)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)-2*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe3)-2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe3)+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)
     &  **3*MNeu(INe4)*MNeu2(INe3)+2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)*MNeu2(INe3)-4*M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)**3*
     &  MNeu2(INe3)-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)
     &  *MNeu(INe4)**3*MNeu2(INe3)-2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3*MNeu2(INe3)-6*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)**
     &  2-2*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)**2-2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe3)**2-16*M1*
     &  A0TNeu(INe3)*CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu2(INe4)+8*M1*A0TNeu(INe4)*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe4)+8*a0t1*M1*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*MNeu2(INe4)+
     &  6*M1*M12*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe4)+8*M1*A0TNeu(INe4)*CF11FSLC(INe3,ISt3)*
     &  CF11FSR(INe4,ISt3)*MNeu(INe4)*MNeu2(INe4)+8*M1*aA0TN(ISt3)*
     &  CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*MNeu2(INe4)+
     &  6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MassSu2(ISt3)*
     &  MNeu(INe4)*MNeu2(INe4)+4*M12*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+4*
     &  A0TNeu(INe4)*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+8*aA0TN(ISt3)*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+4*M12*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*
     &  MNeu2(INe4)+4*A0TNeu(INe4)*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+8*
     &  aA0TN(ISt3)*CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu2(INe4)+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)
     &  *MassSu2(ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)+2*
     &  CF11FSR(INe4,ISt3)*CF11FSRC(INe3,ISt3)*MassSu2(ISt3)*MNeu(INe3)
     &  *MNeu(INe4)*MNeu2(INe4)-4*M1*CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)+6*M1*
     &  CF11FSL(INe3,ISt3)*CF11FSRC(INe4,ISt3)*MNeu(INe3)*MNeu2(INe4)**
     &  2+6*M1*CF11FSLC(INe3,ISt3)*CF11FSR(INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe4)**2+2*CF11FSL(INe3,ISt3)*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+2*CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu2(INe4)**2+
     &  CF11FSL(INe4,ISt3)*(2*M1*CF11FSRC(INe3,ISt3)*MNeu(INe3)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe4)+
     &  3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+4*aA0TN(ISt3)*
     &  MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2)+CF11FSLC(INe3,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe4)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe4)+3*M12**2*
     &  MNeu2(INe4)+8*M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*
     &  MNeu2(INe4)+2*M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))*MNeu2(INe4)+4*M12*MNeu2(INe4)**2+
     &  4*A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*MNeu2(INe4)**2))+
     &  CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe4,ISt3)*MNeu(INe4)*(-4*
     &  a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-
     &  4*aA0TN(ISt3)*MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu2(INe3)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe3)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))+4*a0t1*MNeu2(INe4)+
     &  3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+4*aA0TN(ISt3)*
     &  MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)-(4*a0t1+3*M12+8*
     &  A0TNeu(INe3)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+3*MNeu2(INe4)**2)+CF11FSRC(INe4,ISt3)*(-2*
     &  MassSu2(ISt3)*MNeu(INe3)**4+2*MassSu2(ISt3)*MNeu(INe4)**4-4*
     &  a0t1*M12*MNeu2(INe3)-3*M12**2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*
     &  MNeu2(INe3)+3*MassSu(ISt3)**4*MNeu2(INe3)-2*M12*MassSu2(ISt3)*
     &  MNeu2(INe3)+4*aA0TN(ISt3)*MassSu2(ISt3)*MNeu2(INe3)-3*
     &  MNeu(INe3)**4*MNeu2(INe3)-4*M12*MNeu2(INe3)**2-4*A0TNeu(INe3)*
     &  MNeu2(INe3)**2-8*aA0TN(ISt3)*MNeu2(INe3)**2+MNeu2(INe3)*(4*
     &  a0t1*M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-
     &  MassSu2(ISt3)+4*MNeu2(INe3)))+4*a0t1*M12*MNeu2(INe4)+3*M12**2*
     &  MNeu2(INe4)+8*M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*
     &  MNeu2(INe4)+2*M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)-(4*a0t1*
     &  M12+3*M12**2-3*MassSu(ISt3)**4+3*MNeu(INe3)**4+8*M12*
     &  MNeu2(INe3)+12*A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+2*
     &  MassSu2(ISt3)*(M12+2*MNeu2(INe3))+4*aA0TN(ISt3)*(2*M12-MassSu2(ISt3)
     &  +4*MNeu2(INe3)))*MNeu2(INe4)+4*M12*
     &  MNeu2(INe4)**2+4*A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*
     &  MNeu2(INe4)**2)))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
       selfZ=selfZ+((3*(CF11F11V2L(INe3,INe4)*(CF11F11V2L(INe4,INe3)*
     &  (CF11FSR(INe4,ISt3)*(CF11FSRC(INe4,ISt3)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*M1*CF11FSLC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSL(INe4,ISt3)*(CF11FSLC(INe4,ISt3)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*M1*CF11FSRC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+4*
     &  CF11F11V2R(INe4,INe3)*MNeu(INe3)*(CF11FSLC(INe4,ISt3)*
     &  (CF11FSL(INe4,ISt3)*MNeu(INe4)*(-FD111TChiST(2,INe3,ISt3)+
     &  FD111TChiST(2,INe4,ISt3)+FD211ChiTST(2,INe4,ISt3)*(MNeu(INe3)**
     &  2-MNeu(INe4)**2))+M1*CF11FSR(INe4,ISt3)*(-
     &  FD111ChiTST(4,INe3,ISt3)+FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2)))+
     &  CF11FSRC(INe4,ISt3)*(CF11FSR(INe4,ISt3)*MNeu(INe4)*(-
     &  FD111TChiST(2,INe3,ISt3)+FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2))+M1*
     &  CF11FSL(INe4,ISt3)*(-FD111TChiST(1,INe3,ISt3)+
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe4,ISt3)*(MNeu(INe3)**
     &  2-MNeu(INe4)**2))*MNeu2(INe4))))+CF11F11V2R(INe3,INe4)*
     &  (CF11F11V2R(INe4,INe3)*(CF11FSR(INe4,ISt3)*(CF11FSRC(INe4,ISt3)
     &  *(FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*M1*CF11FSLC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CF11FSL(INe4,ISt3)*(CF11FSLC(INe4,ISt3)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*M1*CF11FSRC(INe4,ISt3)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+4*
     &  CF11F11V2L(INe4,INe3)*MNeu(INe3)*(CF11FSL(INe4,ISt3)*
     &  (CF11FSLC(INe4,ISt3)*MNeu(INe4)*(-FD111TChiST(2,INe3,ISt3)+
     &  FD111TChiST(2,INe4,ISt3)+FD211ChiTST(2,INe4,ISt3)*(MNeu(INe3)**
     &  2-MNeu(INe4)**2))+M1*CF11FSRC(INe4,ISt3)*(-
     &  FD111ChiTST(4,INe3,ISt3)+FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2)))+
     &  CF11FSR(INe4,ISt3)*(CF11FSRC(INe4,ISt3)*MNeu(INe4)*(-
     &  FD111TChiST(2,INe3,ISt3)+FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(MNeu(INe3)**2-MNeu(INe4)**2))+M1*
     &  CF11FSLC(INe4,ISt3)*(-FD111TChiST(1,INe3,ISt3)+
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe4,ISt3)*(MNeu(INe3)**
     &  2-MNeu(INe4)**2))*MNeu2(INe4))))))/(4.*(MNeu(INe3)**2-
     &  MNeu(INe4)**2)**2)-(3*(CF11F11V2L(INe3,INe4)*
     &  CF11F11V2L(INe4,INe3)+CF11F11V2R(INe3,INe4)*
     &  CF11F11V2R(INe4,INe3))*(CF11FSL(INe4,ISt3)*(4*M1*
     &  CF11FSRC(INe4,ISt3)*MNeu(INe4)*(-4*a0t1*MNeu2(INe3)-3*M12*
     &  MNeu2(INe3)-4*A0TNeu(INe3)*MNeu2(INe3)-4*aA0TN(ISt3)*
     &  MNeu2(INe3)-3*MassSu2(ISt3)*MNeu2(INe3)-3*MNeu2(INe3)**2+4*
     &  a0t1*MNeu2(INe4)+3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+
     &  4*aA0TN(ISt3)*MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)+3*
     &  MNeu2(INe4)**2+MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe4)+4*
     &  aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe4))-MNeu2(INe4)*(4*a0t1+
     &  3*M12+8*A0TNeu(INe4)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*
     &  MNeu2(INe4)))+CF11FSLC(INe4,ISt3)*(-2*MassSu2(ISt3)*MNeu(INe3)*
     &  *4+2*MassSu2(ISt3)*MNeu(INe4)**4-4*a0t1*M12*MNeu2(INe3)-3*M12**
     &  2*MNeu2(INe3)-8*M12*aA0TN(ISt3)*MNeu2(INe3)+3*MassSu(ISt3)**4*
     &  MNeu2(INe3)-2*M12*MassSu2(ISt3)*MNeu2(INe3)+4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)-3*MNeu(INe3)**4*MNeu2(INe3)-4*M12*
     &  MNeu2(INe3)**2-4*A0TNeu(INe3)*MNeu2(INe3)**2-8*aA0TN(ISt3)*
     &  MNeu2(INe3)**2+4*a0t1*M12*MNeu2(INe4)+3*M12**2*MNeu2(INe4)+8*
     &  M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*MNeu2(INe4)+2*
     &  M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)+4*M12*MNeu2(INe4)**2+4*
     &  A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*MNeu2(INe4)**2-2*
     &  MNeu(INe4)**4*(2*M12+4*A0TNeu(INe4)+4*aA0TN(ISt3)+MassSu2(ISt3)
     &  +MNeu2(INe4))+MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**
     &  4+2*M12*MassSu2(ISt3)+3*MNeu(INe4)**4+8*M12*MNeu2(INe4)+12*
     &  A0TNeu(INe4)*MNeu2(INe4)+4*MassSu2(ISt3)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MNeu2(INe4)*(2*M12+4*A0TNeu(INe4)+
     &  MassSu2(ISt3)+MNeu2(INe4))+4*aA0TN(ISt3)*(2*M12-MassSu2(ISt3)+
     &  6*MNeu2(INe4)))-MNeu2(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)
     &  **4+MNeu(INe3)**4+2*MNeu(INe4)**4+4*M12*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+4*M12*MNeu2(INe4)+8*
     &  A0TNeu(INe4)*MNeu2(INe4)+2*MassSu2(ISt3)*(M12+MNeu2(INe3)+
     &  MNeu2(INe4))+aA0TN(ISt3)*(-4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)+
     &  MNeu2(INe4))))))+CF11FSR(INe4,ISt3)*(4*M1*CF11FSLC(INe4,ISt3)*
     &  MNeu(INe4)*(-4*a0t1*MNeu2(INe3)-3*M12*MNeu2(INe3)-4*
     &  A0TNeu(INe3)*MNeu2(INe3)-4*aA0TN(ISt3)*MNeu2(INe3)-3*
     &  MassSu2(ISt3)*MNeu2(INe3)-3*MNeu2(INe3)**2+4*a0t1*MNeu2(INe4)+
     &  3*M12*MNeu2(INe4)+4*A0TNeu(INe4)*MNeu2(INe4)+4*aA0TN(ISt3)*
     &  MNeu2(INe4)+3*MassSu2(ISt3)*MNeu2(INe4)+3*MNeu2(INe4)**2+
     &  MNeu2(INe3)*(4*a0t1+3*M12+8*A0TNeu(INe4)+4*aA0TN(ISt3)+3*
     &  MassSu2(ISt3)+2*MNeu2(INe4))-MNeu2(INe4)*(4*a0t1+3*M12+8*
     &  A0TNeu(INe4)+4*aA0TN(ISt3)+3*MassSu2(ISt3)+2*MNeu2(INe4)))+
     &  CF11FSRC(INe4,ISt3)*(-2*MassSu2(ISt3)*MNeu(INe3)**4+2*
     &  MassSu2(ISt3)*MNeu(INe4)**4-4*a0t1*M12*MNeu2(INe3)-3*M12**2*
     &  MNeu2(INe3)-8*M12*aA0TN(ISt3)*MNeu2(INe3)+3*MassSu(ISt3)**4*
     &  MNeu2(INe3)-2*M12*MassSu2(ISt3)*MNeu2(INe3)+4*aA0TN(ISt3)*
     &  MassSu2(ISt3)*MNeu2(INe3)-3*MNeu(INe3)**4*MNeu2(INe3)-4*M12*
     &  MNeu2(INe3)**2-4*A0TNeu(INe3)*MNeu2(INe3)**2-8*aA0TN(ISt3)*
     &  MNeu2(INe3)**2+4*a0t1*M12*MNeu2(INe4)+3*M12**2*MNeu2(INe4)+8*
     &  M12*aA0TN(ISt3)*MNeu2(INe4)-3*MassSu(ISt3)**4*MNeu2(INe4)+2*
     &  M12*MassSu2(ISt3)*MNeu2(INe4)-4*aA0TN(ISt3)*MassSu2(ISt3)*
     &  MNeu2(INe4)+3*MNeu(INe4)**4*MNeu2(INe4)+4*M12*MNeu2(INe4)**2+4*
     &  A0TNeu(INe4)*MNeu2(INe4)**2+8*aA0TN(ISt3)*MNeu2(INe4)**2-2*
     &  MNeu(INe4)**4*(2*M12+4*A0TNeu(INe4)+4*aA0TN(ISt3)+MassSu2(ISt3)
     &  +MNeu2(INe4))+MNeu2(INe3)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)**
     &  4+2*M12*MassSu2(ISt3)+3*MNeu(INe4)**4+8*M12*MNeu2(INe4)+12*
     &  A0TNeu(INe4)*MNeu2(INe4)+4*MassSu2(ISt3)*MNeu2(INe4)+2*
     &  MNeu2(INe4)**2+2*MNeu2(INe4)*(2*M12+4*A0TNeu(INe4)+
     &  MassSu2(ISt3)+MNeu2(INe4))+4*aA0TN(ISt3)*(2*M12-MassSu2(ISt3)+
     &  6*MNeu2(INe4)))-MNeu2(INe4)*(4*a0t1*M12+3*M12**2-3*MassSu(ISt3)
     &  **4+MNeu(INe3)**4+2*MNeu(INe4)**4+4*M12*MNeu2(INe3)+4*
     &  A0TNeu(INe3)*MNeu2(INe3)+2*MNeu2(INe3)**2+4*M12*MNeu2(INe4)+8*
     &  A0TNeu(INe4)*MNeu2(INe4)+2*MassSu2(ISt3)*(M12+MNeu2(INe3)+
     &  MNeu2(INe4))+aA0TN(ISt3)*(-4*MassSu2(ISt3)+8*(M12+MNeu2(INe3)+
     &  MNeu2(INe4))))))))/(64.*(MNeu2(INe3)-MNeu2(INe4))**2))
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe5)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       selfZ=selfZ+((3*((CF11F11V2R(INe3,INe3)**2*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt3)+CF11F11V2L(INe3,INe3)**2*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe3,ISt3))*(4*A0TNeu(INe3)-3*MNeu2(INe3))+
     &  (CF11F11V2L(INe3,INe3)**2*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt3)+CF11F11V2R(INe3,INe3)**2*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe3,ISt3))*(4*A0TNeu(INe3)-3*MNeu2(INe3))+(4*M1*
     &  (CF11F11V2L(INe3,INe3)**2+CF11F11V2R(INe3,INe3)**2)*
     &  (CF11FSLC(INe3,ISt3)*CF11FSR(INe3,ISt3)+CF11FSL(INe3,ISt3)*
     &  CF11FSRC(INe3,ISt3))*(4*A0TNeu(INe3)-3*MNeu2(INe3)))/MNeu(INe3)
     &  +(CF11F11V2R(INe3,INe3)**2*CF11FSL(INe3,ISt3)*
     &  CF11FSLC(INe3,ISt3)+CF11F11V2L(INe3,INe3)**2*CF11FSR(INe3,ISt3)
     &  *CF11FSRC(INe3,ISt3))*(4*M12+12*A0TNeu(INe3)+8*aA0TN(ISt3)+2*
     &  MassSu2(ISt3)-MNeu2(INe3))+(CF11F11V2L(INe3,INe3)**2*
     &  CF11FSL(INe3,ISt3)*CF11FSLC(INe3,ISt3)+CF11F11V2R(INe3,INe3)**
     &  2*CF11FSR(INe3,ISt3)*CF11FSRC(INe3,ISt3))*(4*M12+12*
     &  A0TNeu(INe3)+8*aA0TN(ISt3)+2*MassSu2(ISt3)-MNeu2(INe3))))/64.+
     &  (3*(-4*CF11F11V2L(INe3,INe3)*CF11F11V2R(INe3,INe3)*
     &  (CF11FSLC(INe3,ISt3)*(M1*CF11FSR(INe3,ISt3)*MNeu(INe3)*
     &  (FD311ChiTST(3,INe3,ISt3)+FD311ChiTST(1,INe3,ISt3)*MNeu(INe3)**
     &  2)+2*CF11FSL(INe3,ISt3)*FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))+
     &  CF11FSRC(INe3,ISt3)*(M1*CF11FSL(INe3,ISt3)*MNeu(INe3)*
     &  (FD311ChiTST(3,INe3,ISt3)+FD311ChiTST(1,INe3,ISt3)*MNeu(INe3)**
     &  2)+2*CF11FSR(INe3,ISt3)*FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)))+
     &  CF11F11V2L(INe3,INe3)**2*(CF11FSL(INe3,ISt3)*(2*M1*
     &  CF11FSRC(INe3,ISt3)*FD311ChiTST(3,INe3,ISt3)*MNeu(INe3)+
     &  CF11FSLC(INe3,ISt3)*(FD311ChiTST(4,INe3,ISt3)+
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)))+CF11FSR(INe3,ISt3)*(2*
     &  M1*CF11FSLC(INe3,ISt3)*FD311ChiTST(3,INe3,ISt3)*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt3)*(FD311ChiTST(4,INe3,ISt3)+
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))))+CF11F11V2R(INe3,INe3)**
     &  2*(CF11FSL(INe3,ISt3)*(2*M1*CF11FSRC(INe3,ISt3)*
     &  FD311ChiTST(3,INe3,ISt3)*MNeu(INe3)+CF11FSLC(INe3,ISt3)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))
     &  )+CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*
     &  FD311ChiTST(3,INe3,ISt3)*MNeu(INe3)+CF11FSRC(INe3,ISt3)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))))))/4.)
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 

       do ISt3=1,2
       selfZ=selfZ+((3*CF12F4S(ISt3)*CF12F4SC(ISt3)*(CF12F12V2L*
     &  (CF12F12V2L-4*CF12F12V2R)*MCha2*FD311ChaBST(2,ISt3)+CF12F12V2R*
     &  *2*FD311ChaBST(4,ISt3)))/2.+(3*CF12F4S(ISt3)*CF12F4SC(ISt3)*(4*
     &  a0tcha*CF12F12V2L**2+12*a0tcha*CF12F12V2R**2-3*CF12F12V2L**2*
     &  MCha2-CF12F12V2R**2*MCha2+8*CF12F12V2R**2*aA0TN(ISt3)+2*
     &  CF12F12V2R**2*MassSu2(ISt3)))/32.)
       enddo 

       selfZ=selfZ+((3*CF12F3S*CF12F3SC*(8*a0t5*CF12F12V2R**2+4*a0tcha*
     &  (CF12F12V2L**2+3*CF12F12V2R**2)+4*CF12F12V2R**2*M12-3*
     &  CF12F12V2L**2*MCha2-CF12F12V2R**2*MCha2+2*CF12F12V2R**2*MSQ2))
     &  /32.+(3*CF12F3S*CF12F3SC*(CF12F12V2L**2*MCha2*FD311ChaTSB(2)-4*
     &  CF12F12V2L*CF12F12V2R*MCha2*FD311ChaTSB(2)+CF12F12V2R**2*
     &  FD311ChaTSB(4)))/2.)

c
c topo6-NoGBC
c

c
c topo6-GBC
c

       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*(3*
     &  (FD111THT(6,INH4)*hy(INH5)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THT(6,INH5)*hy(INH5)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THT(8,INH4)*hy(INH5)*hyc(INH4)*Mah(INH3)**2+
     &  FD111THT(8,INH5)*hy(INH5)*hyc(INH4)*Mah(INH3)**2+
     &  FD111THT(6,INH4)*hy(INH4)*hyc(INH5)*Mah(INH3)**2-
     &  FD111THT(6,INH5)*hy(INH4)*hyc(INH5)*Mah(INH3)**2-
     &  FD111THT(8,INH4)*hy(INH4)*hyc(INH5)*Mah(INH3)**2+
     &  FD111THT(8,INH5)*hy(INH4)*hyc(INH5)*Mah(INH3)**2-M12*
     &  FD111THT(3,INH3)*hy(INH4)*hy(INH5)*Mah(INH4)**2-
     &  FD111THT(6,INH3)*hy(INH5)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THT(6,INH5)*hy(INH5)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THT(8,INH3)*hy(INH5)*hyc(INH4)*Mah(INH4)**2-
     &  FD111THT(8,INH5)*hy(INH5)*hyc(INH4)*Mah(INH4)**2-
     &  FD111THT(6,INH3)*hy(INH4)*hyc(INH5)*Mah(INH4)**2+
     &  FD111THT(6,INH5)*hy(INH4)*hyc(INH5)*Mah(INH4)**2+
     &  FD111THT(8,INH3)*hy(INH4)*hyc(INH5)*Mah(INH4)**2-
     &  FD111THT(8,INH5)*hy(INH4)*hyc(INH5)*Mah(INH4)**2-M12*
     &  FD111THT(3,INH3)*hyc(INH4)*hyc(INH5)*Mah(INH4)**2-M12*
     &  FD111THT(3,INH5)*(hy(INH4)*hy(INH5)+hyc(INH4)*hyc(INH5))*
     &  (Mah(INH3)**2-Mah(INH4)**2)+M12*FD111THT(3,INH3)*hy(INH4)*
     &  hy(INH5)*Mah(INH5)**2+FD111THT(6,INH3)*hy(INH5)*hyc(INH4)*
     &  Mah(INH5)**2-FD111THT(6,INH4)*hy(INH5)*hyc(INH4)*Mah(INH5)**2-
     &  FD111THT(8,INH3)*hy(INH5)*hyc(INH4)*Mah(INH5)**2+
     &  FD111THT(8,INH4)*hy(INH5)*hyc(INH4)*Mah(INH5)**2+
     &  FD111THT(6,INH3)*hy(INH4)*hyc(INH5)*Mah(INH5)**2-
     &  FD111THT(6,INH4)*hy(INH4)*hyc(INH5)*Mah(INH5)**2-
     &  FD111THT(8,INH3)*hy(INH4)*hyc(INH5)*Mah(INH5)**2+
     &  FD111THT(8,INH4)*hy(INH4)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD111THT(3,INH3)*hyc(INH4)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD111THT(3,INH4)*(hy(INH4)*hy(INH5)+hyc(INH4)*hyc(INH5))*
     &  (Mah(INH3)**2-Mah(INH5)**2))+CFF12S1L(INH4)*(CFF12S1R(INH5)*(-
     &  (FD111ChaHCha(8,INH4)*Mah(INH3)**2)+FD111ChaHCha(8,INH5)*
     &  Mah(INH3)**2-FD111ChaHCha(6,INH3)*Mah(INH4)**2+
     &  FD111ChaHCha(8,INH3)*Mah(INH4)**2-FD111ChaHCha(8,INH5)*
     &  Mah(INH4)**2+FD111ChaHCha(6,INH5)*(-Mah(INH3)**2+Mah(INH4)**2)+
     &  FD111ChaHCha(6,INH3)*Mah(INH5)**2-FD111ChaHCha(8,INH3)*
     &  Mah(INH5)**2+FD111ChaHCha(8,INH4)*Mah(INH5)**2+
     &  FD111ChaHCha(6,INH4)*(Mah(INH3)**2-Mah(INH5)**2))+MCha2*
     &  CFF12S1L(INH5)*(FD111ChaHCha(3,INH5)*(-Mah(INH3)**2+Mah(INH4)**
     &  2)+FD111ChaHCha(3,INH4)*(Mah(INH3)**2-Mah(INH5)**2)+
     &  FD111ChaHCha(3,INH3)*(-Mah(INH4)**2+Mah(INH5)**2)))+
     &  CFF12S1R(INH4)*(CFF12S1L(INH5)*(-(FD111ChaHCha(8,INH4)*
     &  Mah(INH3)**2)+FD111ChaHCha(8,INH5)*Mah(INH3)**2-
     &  FD111ChaHCha(6,INH3)*Mah(INH4)**2+FD111ChaHCha(8,INH3)*
     &  Mah(INH4)**2-FD111ChaHCha(8,INH5)*Mah(INH4)**2+
     &  FD111ChaHCha(6,INH5)*(-Mah(INH3)**2+Mah(INH4)**2)+
     &  FD111ChaHCha(6,INH3)*Mah(INH5)**2-FD111ChaHCha(8,INH3)*
     &  Mah(INH5)**2+FD111ChaHCha(8,INH4)*Mah(INH5)**2+
     &  FD111ChaHCha(6,INH4)*(Mah(INH3)**2-Mah(INH5)**2))+MCha2*
     &  CFF12S1R(INH5)*(FD111ChaHCha(3,INH5)*(-Mah(INH3)**2+Mah(INH4)**
     &  2)+FD111ChaHCha(3,INH4)*(Mah(INH3)**2-Mah(INH5)**2)+
     &  FD111ChaHCha(3,INH3)*(-Mah(INH4)**2+Mah(INH5)**2)))))/(2.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  ((6*M12*(hy(INH4)*hy(INH5)+hyc(INH4)*hyc(INH5))*(2*M12*(4*a0t1+
     &  M12)+(8*a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5)))+(2*MCha2*(CFF12S1L(INH4)*
     &  CFF12S1L(INH5)+CFF12S1R(INH4)*CFF12S1R(INH5))*(2*MCha2*(4*
     &  a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*Mah2(INH3)+3*
     &  Mah2(INH3)**2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5)))+(6*(hy(INH5)*
     &  hyc(INH4)+hy(INH4)*hyc(INH5))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*
     &  a0t1+3*M12+4*A0TNH(INH3))*Mah2(INH3)+(4*a0t1+5*M12)*Mah2(INH3)*
     &  *2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5)))+(2*(CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(2*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+(4*a0tcha+5*MCha2)*Mah2(INH3)**2))/((Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-Mah(INH5))*
     &  (Mah(INH3)+Mah(INH5)))-(3*(hy(INH5)*hyc(INH4)+hy(INH4)*
     &  hyc(INH5))*(4*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+M12)*Mah2(INH3)
     &  +(8*a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)**2+3*Mah2(INH3)**3))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5)))-((CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(4*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*Mah2(INH3)+(8*a0tcha+6*
     &  MCha2+4*A0TNH(INH3))*Mah2(INH3)**2+3*Mah2(INH3)**3))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5)))-(6*M12*(hy(INH4)*hy(INH5)+
     &  hyc(INH4)*hyc(INH5))*(2*M12*(4*a0t1+M12)+(8*a0t1+6*M12+4*
     &  A0TNH(INH4))*Mah2(INH4)+3*Mah2(INH4)**2))/((Mah(INH3)-Mah(INH4)
     &  )*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-Mah(INH5))*(Mah(INH4)+
     &  Mah(INH5)))-(2*MCha2*(CFF12S1L(INH4)*CFF12S1L(INH5)+
     &  CFF12S1R(INH4)*CFF12S1R(INH5))*(2*MCha2*(4*a0tcha+MCha2)+(8*
     &  a0tcha+6*MCha2+4*A0TNH(INH4))*Mah2(INH4)+3*Mah2(INH4)**2))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(6*(hy(INH5)*hyc(INH4)+
     &  hy(INH4)*hyc(INH5))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+
     &  4*A0TNH(INH4))*Mah2(INH4)+(4*a0t1+5*M12)*Mah2(INH4)**2))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(2*(CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(2*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*A0TNH(INH4))*
     &  Mah2(INH4)+(4*a0tcha+5*MCha2)*Mah2(INH4)**2))/((Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(3*(hy(INH5)*hyc(INH4)+hy(INH4)*
     &  hyc(INH5))*(4*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+M12)*Mah2(INH4)
     &  +(8*a0t1+6*M12+4*A0TNH(INH4))*Mah2(INH4)**2+3*Mah2(INH4)**3))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))+((CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(4*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*Mah2(INH4)+(8*a0tcha+6*
     &  MCha2+4*A0TNH(INH4))*Mah2(INH4)**2+3*Mah2(INH4)**3))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(6*M12*(hy(INH4)*hy(INH5)+
     &  hyc(INH4)*hyc(INH5))*(2*M12*(4*a0t1+M12)+(8*a0t1+6*M12+4*
     &  A0TNH(INH5))*Mah2(INH5)+3*Mah2(INH5)**2))/((Mah(INH3)-Mah(INH5)
     &  )*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+Mah(INH5))*(Mah(INH4)+
     &  Mah(INH5)))-(2*MCha2*(CFF12S1L(INH4)*CFF12S1L(INH5)+
     &  CFF12S1R(INH4)*CFF12S1R(INH5))*(2*MCha2*(4*a0tcha+MCha2)+(8*
     &  a0tcha+6*MCha2+4*A0TNH(INH5))*Mah2(INH5)+3*Mah2(INH5)**2))
     &  /((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(6*(hy(INH5)*hyc(INH4)+
     &  hy(INH4)*hyc(INH5))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+
     &  4*A0TNH(INH5))*Mah2(INH5)+(4*a0t1+5*M12)*Mah2(INH5)**2))
     &  /((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(2*(CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(2*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*A0TNH(INH5))*
     &  Mah2(INH5)+(4*a0tcha+5*MCha2)*Mah2(INH5)**2))/((Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(3*(hy(INH5)*hyc(INH4)+hy(INH4)*
     &  hyc(INH5))*(4*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+M12)*Mah2(INH5)
     &  +(8*a0t1+6*M12+4*A0TNH(INH5))*Mah2(INH5)**2+3*Mah2(INH5)**3))
     &  /((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))+((CFF12S1L(INH5)*
     &  CFF12S1R(INH4)+CFF12S1L(INH4)*CFF12S1R(INH5))*(4*MCha2**2*(4*
     &  a0tcha+MCha2)+2*MCha2*(4*a0tcha+MCha2)*Mah2(INH5)+(8*a0tcha+6*
     &  MCha2+4*A0TNH(INH5))*Mah2(INH5)**2+3*Mah2(INH5)**3))
     &  /((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))))/32.)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH5)*(3*
     &  (FD111THT(6,INH3)*hy(INH5)*hyc(INH3)-FD111THT(6,INH5)*hy(INH5)*
     &  hyc(INH3)-FD111THT(8,INH3)*hy(INH5)*hyc(INH3)+FD111THT(8,INH5)*
     &  hy(INH5)*hyc(INH3)+FD111THT(6,INH3)*hy(INH3)*hyc(INH5)-
     &  FD111THT(6,INH5)*hy(INH3)*hyc(INH5)-FD111THT(8,INH3)*hy(INH3)*
     &  hyc(INH5)+FD111THT(8,INH5)*hy(INH3)*hyc(INH5)+M12*
     &  FD111THT(3,INH3)*(hy(INH3)*hy(INH5)+hyc(INH3)*hyc(INH5))-M12*
     &  FD111THT(3,INH5)*(hy(INH3)*hy(INH5)+hyc(INH3)*hyc(INH5))-M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH5)*Mah(INH3)**2+
     &  FD211HTT(5,INH3)*hy(INH5)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HTT(6,INH3)*hy(INH5)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH5)*Mah(INH3)**2-
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH5)*Mah(INH3)**2-M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH5)*Mah(INH3)**2+M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH5)*Mah(INH5)**2-
     &  FD211HTT(5,INH3)*hy(INH5)*hyc(INH3)*Mah(INH5)**2+
     &  FD211HTT(6,INH3)*hy(INH5)*hyc(INH3)*Mah(INH5)**2-
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH5)*Mah(INH5)**2+
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH5)*Mah(INH5)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH5)*(FD111ChaHCha(6,INH3)-
     &  FD111ChaHCha(6,INH5)-FD111ChaHCha(8,INH3)+FD111ChaHCha(8,INH5)+
     &  FD211HChaCha(5,INH3)*Mah(INH3)**2-FD211HChaCha(6,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(5,INH3)*Mah(INH5)**2+
     &  FD211HChaCha(6,INH3)*Mah(INH5)**2)+MCha2*CFF12S1L(INH5)*
     &  (FD111ChaHCha(3,INH3)-FD111ChaHCha(3,INH5)+FD211HChaCha(4,INH3)
     &  *(-Mah(INH3)**2+Mah(INH5)**2)))+CFF12S1R(INH3)*(CFF12S1L(INH5)*
     &  (FD111ChaHCha(6,INH3)-FD111ChaHCha(6,INH5)-FD111ChaHCha(8,INH3)
     &  +FD111ChaHCha(8,INH5)+FD211HChaCha(5,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(6,INH3)*Mah(INH3)**2-FD211HChaCha(5,INH3)*
     &  Mah(INH5)**2+FD211HChaCha(6,INH3)*Mah(INH5)**2)+MCha2*
     &  CFF12S1R(INH5)*(FD111ChaHCha(3,INH3)-FD111ChaHCha(3,INH5)+
     &  FD211HChaCha(4,INH3)*(-Mah(INH3)**2+Mah(INH5)**2)))))/(2.*
     &  (Mah(INH3)**2-Mah(INH5)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH5)*(12*M12*(hy(INH3)*hy(INH5)+hyc(INH3)*
     &  hyc(INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(4*a0t1+
     &  3*M12+4*A0TNH(INH3)+Mah2(INH3))+4*MCha2*(CFF12S1L(INH3)*
     &  CFF12S1L(INH5)+CFF12S1R(INH3)*CFF12S1R(INH5))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5))*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH3)+Mah2(INH3))+12*(hy(INH5)*hyc(INH3)+hy(INH3)*
     &  hyc(INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(M12*(4*
     &  a0t1+3*M12)+8*M12*A0TNH(INH3)+(4*a0t1+M12)*Mah2(INH3))+4*
     &  (CFF12S1L(INH5)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH5))*
     &  (Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(MCha2*(4*a0tcha+3*
     &  MCha2)+8*MCha2*A0TNH(INH3)+(4*a0tcha+MCha2)*Mah2(INH3))-6*M12*
     &  (hy(INH3)*hy(INH5)+hyc(INH3)*hyc(INH5))*(2*M12*(4*a0t1+M12)+(8*
     &  a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2)-2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH5)+CFF12S1R(INH3)*CFF12S1R(INH5))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2)-3*(hy(INH5)*hyc(INH3)+hy(INH3)*
     &  hyc(INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(2*M12*
     &  (4*a0t1+M12)+4*(4*a0t1+3*M12+3*A0TNH(INH3))*Mah2(INH3)+5*
     &  Mah2(INH3)**2)-(CFF12S1L(INH5)*CFF12S1R(INH3)+CFF12S1L(INH3)*
     &  CFF12S1R(INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(2*
     &  MCha2*(4*a0tcha+MCha2)+4*(4*a0tcha+3*MCha2+3*A0TNH(INH3))*
     &  Mah2(INH3)+5*Mah2(INH3)**2)-6*(hy(INH5)*hyc(INH3)+hy(INH3)*
     &  hyc(INH5))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+4*
     &  A0TNH(INH3))*Mah2(INH3)+(4*a0t1+5*M12)*Mah2(INH3)**2)-2*
     &  (CFF12S1L(INH5)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH5))*
     &  (2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH3))*Mah2(INH3)+(4*a0tcha+5*MCha2)*Mah2(INH3)**2)+3*
     &  (hy(INH5)*hyc(INH3)+hy(INH3)*hyc(INH5))*(4*M12**2*(4*a0t1+M12)+
     &  2*M12*(4*a0t1+M12)*Mah2(INH3)+(8*a0t1+6*M12+4*A0TNH(INH3))*
     &  Mah2(INH3)**2+3*Mah2(INH3)**3)+(CFF12S1L(INH5)*CFF12S1R(INH3)+
     &  CFF12S1L(INH3)*CFF12S1R(INH5))*(4*MCha2**2*(4*a0tcha+MCha2)+2*
     &  MCha2*(4*a0tcha+MCha2)*Mah2(INH3)+(8*a0tcha+6*MCha2+4*
     &  A0TNH(INH3))*Mah2(INH3)**2+3*Mah2(INH3)**3)+6*M12*(hy(INH3)*
     &  hy(INH5)+hyc(INH3)*hyc(INH5))*(2*M12*(4*a0t1+M12)+(8*a0t1+6*
     &  M12+4*A0TNH(INH5))*Mah2(INH5)+3*Mah2(INH5)**2)+2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH5)+CFF12S1R(INH3)*CFF12S1R(INH5))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH5))*
     &  Mah2(INH5)+3*Mah2(INH5)**2)+6*(hy(INH5)*hyc(INH3)+hy(INH3)*
     &  hyc(INH5))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+4*
     &  A0TNH(INH5))*Mah2(INH5)+(4*a0t1+5*M12)*Mah2(INH5)**2)+2*
     &  (CFF12S1L(INH5)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH5))*
     &  (2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH5))*Mah2(INH5)+(4*a0tcha+5*MCha2)*Mah2(INH5)**2)-3*
     &  (hy(INH5)*hyc(INH3)+hy(INH3)*hyc(INH5))*(4*M12**2*(4*a0t1+M12)+
     &  2*M12*(4*a0t1+M12)*Mah2(INH5)+(8*a0t1+6*M12+4*A0TNH(INH5))*
     &  Mah2(INH5)**2+3*Mah2(INH5)**3)-(CFF12S1L(INH5)*CFF12S1R(INH3)+
     &  CFF12S1L(INH3)*CFF12S1R(INH5))*(4*MCha2**2*(4*a0tcha+MCha2)+2*
     &  MCha2*(4*a0tcha+MCha2)*Mah2(INH5)+(8*a0tcha+6*MCha2+4*
     &  A0TNH(INH5))*Mah2(INH5)**2+3*Mah2(INH5)**3)))/(32.*(Mah2(INH3)-Mah2(INH5))**2))

             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*(3*
     &  (FD111THT(6,INH3)*hy(INH4)*hyc(INH3)-FD111THT(6,INH4)*hy(INH4)*
     &  hyc(INH3)-FD111THT(8,INH3)*hy(INH4)*hyc(INH3)+FD111THT(8,INH4)*
     &  hy(INH4)*hyc(INH3)+FD111THT(6,INH3)*hy(INH3)*hyc(INH4)-
     &  FD111THT(6,INH4)*hy(INH3)*hyc(INH4)-FD111THT(8,INH3)*hy(INH3)*
     &  hyc(INH4)+FD111THT(8,INH4)*hy(INH3)*hyc(INH4)+M12*
     &  FD111THT(3,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD111THT(3,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH4)*Mah(INH3)**2+
     &  FD211HTT(5,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HTT(6,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH3)**2+M12*
     &  FD211HTT(4,INH3)*hy(INH3)*hy(INH4)*Mah(INH4)**2-
     &  FD211HTT(5,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2+
     &  FD211HTT(6,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2-
     &  FD211HTT(5,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+
     &  FD211HTT(6,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD211HTT(4,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH4)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(FD111ChaHCha(6,INH3)-
     &  FD111ChaHCha(6,INH4)-FD111ChaHCha(8,INH3)+FD111ChaHCha(8,INH4)+
     &  FD211HChaCha(5,INH3)*Mah(INH3)**2-FD211HChaCha(6,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(5,INH3)*Mah(INH4)**2+
     &  FD211HChaCha(6,INH3)*Mah(INH4)**2)+MCha2*CFF12S1L(INH4)*
     &  (FD111ChaHCha(3,INH3)-FD111ChaHCha(3,INH4)+FD211HChaCha(4,INH3)
     &  *(-Mah(INH3)**2+Mah(INH4)**2)))+CFF12S1R(INH3)*(CFF12S1L(INH4)*
     &  (FD111ChaHCha(6,INH3)-FD111ChaHCha(6,INH4)-FD111ChaHCha(8,INH3)
     &  +FD111ChaHCha(8,INH4)+FD211HChaCha(5,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(6,INH3)*Mah(INH3)**2-FD211HChaCha(5,INH3)*
     &  Mah(INH4)**2+FD211HChaCha(6,INH3)*Mah(INH4)**2)+MCha2*
     &  CFF12S1R(INH4)*(FD111ChaHCha(3,INH3)-FD111ChaHCha(3,INH4)+
     &  FD211HChaCha(4,INH3)*(-Mah(INH3)**2+Mah(INH4)**2)))))/(2.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH4)*(12*M12*(hy(INH3)*hy(INH4)+hyc(INH3)*
     &  hyc(INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(4*a0t1+
     &  3*M12+4*A0TNH(INH3)+Mah2(INH3))+4*MCha2*(CFF12S1L(INH3)*
     &  CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*(Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH3)+Mah2(INH3))+12*(hy(INH4)*hyc(INH3)+hy(INH3)*
     &  hyc(INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(M12*(4*
     &  a0t1+3*M12)+8*M12*A0TNH(INH3)+(4*a0t1+M12)*Mah2(INH3))+4*
     &  (CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(MCha2*(4*a0tcha+3*
     &  MCha2)+8*MCha2*A0TNH(INH3)+(4*a0tcha+MCha2)*Mah2(INH3))-6*M12*
     &  (hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))*(2*M12*(4*a0t1+M12)+(8*
     &  a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2)-2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2)-3*(hy(INH4)*hyc(INH3)+hy(INH3)*
     &  hyc(INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(2*M12*
     &  (4*a0t1+M12)+4*(4*a0t1+3*M12+3*A0TNH(INH3))*Mah2(INH3)+5*
     &  Mah2(INH3)**2)-(CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*
     &  CFF12S1R(INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(2*
     &  MCha2*(4*a0tcha+MCha2)+4*(4*a0tcha+3*MCha2+3*A0TNH(INH3))*
     &  Mah2(INH3)+5*Mah2(INH3)**2)-6*(hy(INH4)*hyc(INH3)+hy(INH3)*
     &  hyc(INH4))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+4*
     &  A0TNH(INH3))*Mah2(INH3)+(4*a0t1+5*M12)*Mah2(INH3)**2)-2*
     &  (CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH3))*Mah2(INH3)+(4*a0tcha+5*MCha2)*Mah2(INH3)**2)+3*
     &  (hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))*(4*M12**2*(4*a0t1+M12)+
     &  2*M12*(4*a0t1+M12)*Mah2(INH3)+(8*a0t1+6*M12+4*A0TNH(INH3))*
     &  Mah2(INH3)**2+3*Mah2(INH3)**3)+(CFF12S1L(INH4)*CFF12S1R(INH3)+
     &  CFF12S1L(INH3)*CFF12S1R(INH4))*(4*MCha2**2*(4*a0tcha+MCha2)+2*
     &  MCha2*(4*a0tcha+MCha2)*Mah2(INH3)+(8*a0tcha+6*MCha2+4*
     &  A0TNH(INH3))*Mah2(INH3)**2+3*Mah2(INH3)**3)+6*M12*(hy(INH3)*
     &  hy(INH4)+hyc(INH3)*hyc(INH4))*(2*M12*(4*a0t1+M12)+(8*a0t1+6*
     &  M12+4*A0TNH(INH4))*Mah2(INH4)+3*Mah2(INH4)**2)+2*MCha2*
     &  (CFF12S1L(INH3)*CFF12S1L(INH4)+CFF12S1R(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2*(4*a0tcha+MCha2)+(8*a0tcha+6*MCha2+4*A0TNH(INH4))*
     &  Mah2(INH4)+3*Mah2(INH4)**2)+6*(hy(INH4)*hyc(INH3)+hy(INH3)*
     &  hyc(INH4))*(2*M12**2*(4*a0t1+M12)+2*M12*(4*a0t1+3*M12+4*
     &  A0TNH(INH4))*Mah2(INH4)+(4*a0t1+5*M12)*Mah2(INH4)**2)+2*
     &  (CFF12S1L(INH4)*CFF12S1R(INH3)+CFF12S1L(INH3)*CFF12S1R(INH4))*
     &  (2*MCha2**2*(4*a0tcha+MCha2)+2*MCha2*(4*a0tcha+3*MCha2+4*
     &  A0TNH(INH4))*Mah2(INH4)+(4*a0tcha+5*MCha2)*Mah2(INH4)**2)-3*
     &  (hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))*(4*M12**2*(4*a0t1+M12)+
     &  2*M12*(4*a0t1+M12)*Mah2(INH4)+(8*a0t1+6*M12+4*A0TNH(INH4))*
     &  Mah2(INH4)**2+3*Mah2(INH4)**3)-(CFF12S1L(INH4)*CFF12S1R(INH3)+
     &  CFF12S1L(INH3)*CFF12S1R(INH4))*(4*MCha2**2*(4*a0tcha+MCha2)+2*
     &  MCha2*(4*a0tcha+MCha2)*Mah2(INH4)+(8*a0tcha+6*MCha2+4*
     &  A0TNH(INH4))*Mah2(INH4)**2+3*Mah2(INH4)**3)))/(32.*(Mah2(INH3)-Mah2(INH4))**2))

             endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)**2*(-2*CFF12S1L(INH4)*
     &  CFF12S1R(INH4)*(FD111ChaHCha(6,INH3)-FD111ChaHCha(6,INH4)-
     &  FD111ChaHCha(8,INH3)+FD111ChaHCha(8,INH4)+FD211HChaCha(5,INH4)*
     &  Mah(INH3)**2-FD211HChaCha(6,INH4)*Mah(INH3)**2-
     &  FD211HChaCha(5,INH4)*Mah(INH4)**2+FD211HChaCha(6,INH4)*
     &  Mah(INH4)**2)-3*(2*FD111THT(6,INH3)*hy(INH4)*hyc(INH4)-2*
     &  FD111THT(6,INH4)*hy(INH4)*hyc(INH4)-2*FD111THT(8,INH3)*hy(INH4)
     &  *hyc(INH4)+2*FD111THT(8,INH4)*hy(INH4)*hyc(INH4)+M12*
     &  FD111THT(3,INH3)*(hy(INH4)**2+hyc(INH4)**2)-M12*
     &  FD111THT(3,INH4)*(hy(INH4)**2+hyc(INH4)**2)-M12*
     &  FD211HTT(4,INH4)*hy(INH4)**2*Mah(INH3)**2+2*FD211HTT(5,INH4)*
     &  hy(INH4)*hyc(INH4)*Mah(INH3)**2-2*FD211HTT(6,INH4)*hy(INH4)*
     &  hyc(INH4)*Mah(INH3)**2-M12*FD211HTT(4,INH4)*hyc(INH4)**2*
     &  Mah(INH3)**2+M12*FD211HTT(4,INH4)*hy(INH4)**2*Mah(INH4)**2-2*
     &  FD211HTT(5,INH4)*hy(INH4)*hyc(INH4)*Mah(INH4)**2+2*
     &  FD211HTT(6,INH4)*hy(INH4)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD211HTT(4,INH4)*hyc(INH4)**2*Mah(INH4)**2)+MCha2*
     &  CFF12S1L(INH4)**2*(-FD111ChaHCha(3,INH3)+FD111ChaHCha(3,INH4)+
     &  FD211HChaCha(4,INH4)*(Mah(INH3)**2-Mah(INH4)**2))+MCha2*
     &  CFF12S1R(INH4)**2*(-FD111ChaHCha(3,INH3)+FD111ChaHCha(3,INH4)+
     &  FD211HChaCha(4,INH4)*(Mah(INH3)**2-Mah(INH4)**2))))/(2.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1V2(INH3,INH4)**2*(MCha2*
     &  CFF12S1L(INH4)**2*((8*a0tcha+6*MCha2+4*A0TNH(INH3))*Mah2(INH3)+
     &  3*Mah2(INH3)**2-2*(4*a0tcha+3*MCha2+4*A0TNH(INH4))*(Mah2(INH3)-
     &  Mah2(INH4))-2*(4*a0tcha+3*MCha2+2*A0TNH(INH4)+Mah2(INH3)-
     &  Mah2(INH4))*Mah2(INH4)-3*Mah2(INH4)**2)+MCha2*CFF12S1R(INH4)**
     &  2*((8*a0tcha+6*MCha2+4*A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2-
     &  2*(4*a0tcha+3*MCha2+4*A0TNH(INH4))*(Mah2(INH3)-Mah2(INH4))-2*
     &  (4*a0tcha+3*MCha2+2*A0TNH(INH4)+Mah2(INH3)-Mah2(INH4))*
     &  Mah2(INH4)-3*Mah2(INH4)**2)+CFF12S1L(INH4)*CFF12S1R(INH4)*(2*
     &  MCha2*(4*a0tcha+5*MCha2+8*A0TNH(INH3))*Mah2(INH3)+4*(MCha2-
     &  A0TNH(INH3))*Mah2(INH3)**2-3*Mah2(INH3)**3-2*MCha2*(4*a0tcha+5*
     &  MCha2+16*A0TNH(INH4))*(Mah2(INH3)-Mah2(INH4))+(-4*MCha2+4*
     &  A0TNH(INH4)+5*Mah2(INH3)-5*Mah2(INH4))*Mah2(INH4)**2+3*
     &  Mah2(INH4)**3-2*Mah2(INH4)*(MCha2*(4*a0tcha+5*MCha2-4*
     &  Mah2(INH3)+4*Mah2(INH4))+A0TNH(INH4)*(8*MCha2-6*Mah2(INH3)+6*
     &  Mah2(INH4))))+3*(M12*hy(INH4)**2*((8*a0t1+6*M12+4*A0TNH(INH3))*
     &  Mah2(INH3)+3*Mah2(INH3)**2-2*(4*a0t1+3*M12+4*A0TNH(INH4))*
     &  (Mah2(INH3)-Mah2(INH4))-2*(4*a0t1+3*M12+2*A0TNH(INH4)+
     &  Mah2(INH3)-Mah2(INH4))*Mah2(INH4)-3*Mah2(INH4)**2)+M12*
     &  hyc(INH4)**2*((8*a0t1+6*M12+4*A0TNH(INH3))*Mah2(INH3)+3*
     &  Mah2(INH3)**2-2*(4*a0t1+3*M12+4*A0TNH(INH4))*(Mah2(INH3)-
     &  Mah2(INH4))-2*(4*a0t1+3*M12+2*A0TNH(INH4)+Mah2(INH3)-Mah2(INH4)
     &  )*Mah2(INH4)-3*Mah2(INH4)**2)+hy(INH4)*hyc(INH4)*(2*M12*(4*
     &  a0t1+5*M12+8*A0TNH(INH3))*Mah2(INH3)+4*(M12-A0TNH(INH3))*
     &  Mah2(INH3)**2-3*Mah2(INH3)**3-2*M12*(4*a0t1+5*M12+16*
     &  A0TNH(INH4))*(Mah2(INH3)-Mah2(INH4))+(-4*M12+4*A0TNH(INH4)+5*
     &  Mah2(INH3)-5*Mah2(INH4))*Mah2(INH4)**2+3*Mah2(INH4)**3-2*
     &  Mah2(INH4)*(M12*(4*a0t1+5*M12-4*Mah2(INH3)+4*Mah2(INH4))+
     &  A0TNH(INH4)*(8*M12-6*Mah2(INH3)+6*Mah2(INH4)))))))/(16.*
     &  (Mah2(INH3)-Mah2(INH4))**2))

             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then
       selfZ=selfZ+(-(CS1S1V2(INH3,INH3)**2*(MCha2*CFF12S1L(INH3)**2*
     &  FD311HChaCha(3,INH3)+MCha2*CFF12S1R(INH3)**2*
     &  FD311HChaCha(3,INH3)+2*CFF12S1L(INH3)*CFF12S1R(INH3)*(-
     &  FD311HChaCha(4,INH3)+FD311HChaCha(6,INH3))+3*M12*
     &  FD311HTT(3,INH3)*hy(INH3)**2-6*FD311HTT(4,INH3)*hy(INH3)*
     &  hyc(INH3)+6*FD311HTT(6,INH3)*hy(INH3)*hyc(INH3)+3*M12*
     &  FD311HTT(3,INH3)*hyc(INH3)**2))/2.+(CS1S1V2(INH3,INH3)**2*(4*
     &  A0TNH(INH3)*(MCha2*CFF12S1L(INH3)**2+MCha2*CFF12S1R(INH3)**2+3*
     &  (M12*hy(INH3)**2+M12*hyc(INH3)**2+hy(INH3)*hyc(INH3)*(4*M12-3*
     &  Mah2(INH3)))+CFF12S1L(INH3)*CFF12S1R(INH3)*(4*MCha2-3*
     &  Mah2(INH3)))+Mah2(INH3)*(-3*MCha2*CFF12S1L(INH3)**2-3*(MCha2*
     &  CFF12S1R(INH3)**2+3*M12*hy(INH3)**2+3*M12*hyc(INH3)**2+hy(INH3)
     &  *hyc(INH3)*(20*M12-Mah2(INH3)))+CFF12S1L(INH3)*CFF12S1R(INH3)*
     &  (-20*MCha2+Mah2(INH3)))))/(16.*Mah2(INH3)))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 



       do INe3=1,3
       do INe4=1,3
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  (CFF11S1L(INe4,INe3,INH5)*(CFF11S1R(INe3,INe4,INH4)*(-
     &  (FD111ChiHChi(8,INe3,INH4,INe4)*Mah(INH3)**2)+
     &  FD111ChiHChi(8,INe3,INH5,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHChi(8,INe3,INH5,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(6,INe3,INH5,INe4)*(-Mah(INH3)**2+Mah(INH4)**2)+
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH5)**2-
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(8,INe3,INH4,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(6,INe3,INH4,INe4)*(Mah(INH3)**2-Mah(INH5)**2))+
     &  CFF11S1L(INe3,INe4,INH4)*(FD111ChiHChi(3,INe3,INH5,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(3,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-Mah(INH5)**2)+FD111ChiHChi(3,INe3,INH3,INe4)*(-
     &  Mah(INH4)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH5)*(CFF11S1L(INe3,INe4,INH4)*(-
     &  (FD111ChiHChi(8,INe3,INH4,INe4)*Mah(INH3)**2)+
     &  FD111ChiHChi(8,INe3,INH5,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHChi(8,INe3,INH5,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(6,INe3,INH5,INe4)*(-Mah(INH3)**2+Mah(INH4)**2)+
     &  FD111ChiHChi(6,INe3,INH3,INe4)*Mah(INH5)**2-
     &  FD111ChiHChi(8,INe3,INH3,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(8,INe3,INH4,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(6,INe3,INH4,INe4)*(Mah(INH3)**2-Mah(INH5)**2))+
     &  CFF11S1R(INe3,INe4,INH4)*(FD111ChiHChi(3,INe3,INH5,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(3,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-Mah(INH5)**2)+FD111ChiHChi(3,INe3,INH3,INe4)*(-
     &  Mah(INH4)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  (-(((CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH3)*Mah2(INH3)**2+3*Mah2(INH3)**3+Mah2(INH3)*MNeu(INe3)
     &  **4-3*Mah2(INH3)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH3)*
     &  MNeu2(INe3)+4*Mah2(INH3)**2*MNeu2(INe3)+2*Mah2(INH3)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH3)**2+8*MNeu(INe3)**4+
     &  Mah2(INH3)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH3)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5))))+((CFF11S1L(INe4,INe3,INH5)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH5))*(4*A0TNH(INH4)*Mah2(INH4)**2+3*
     &  Mah2(INH4)**3+Mah2(INH4)*MNeu(INe3)**4-3*Mah2(INH4)*MNeu(INe4)*
     &  *4+4*A0TNeu(INe3)*Mah2(INH4)*MNeu2(INe3)+4*Mah2(INH4)**2*
     &  MNeu2(INe3)+2*Mah2(INH4)*MNeu2(INe3)**2+A0TNeu(INe4)*(8*
     &  Mah2(INH4)**2+8*MNeu(INe3)**4+Mah2(INH4)*(8*MNeu2(INe3)-4*
     &  MNeu2(INe4)))+2*Mah2(INH4)**2*MNeu2(INe4)+4*MNeu(INe3)**4*
     &  MNeu2(INe4)+8*A0TNeu(INe3)*MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)
     &  *MNeu2(INe3)*MNeu2(INe4)))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH4)-Mah(INH5))*(Mah(INH4)+Mah(INH5)))+
     &  ((CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH5)*Mah2(INH5)**2+3*Mah2(INH5)**3+Mah2(INH5)*MNeu(INe3)
     &  **4-3*Mah2(INH5)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH5)*
     &  MNeu2(INe3)+4*Mah2(INH5)**2*MNeu2(INe3)+2*Mah2(INH5)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH5)**2+8*MNeu(INe3)**4+
     &  Mah2(INH5)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH5)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH5)*MNeu2(INe3)*MNeu2(INe4)))
     &  /((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-Mah(INH4)+
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))+(2*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*MNeu(INe4)*(4*A0TNH(INH3)*
     &  Mah2(INH3)+3*Mah2(INH3)**2+3*Mah2(INH3)*MNeu2(INe3)+4*
     &  A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+3*Mah2(INH3)*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH3)+
     &  MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5)))+(2*
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH3)*Mah2(INH3)*MNeu2(INe3)+3*Mah2(INH3)**2*MNeu2(INe3)+
     &  3*Mah2(INH3)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH3)**2+
     &  MNeu(INe3)**4+Mah2(INH3)*MNeu2(INe3))+4*A0TNH(INH3)*Mah2(INH3)*
     &  MNeu2(INe4)+2*Mah2(INH3)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+
     &  Mah(INH5)))-(2*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*MNeu(INe4)*(4*A0TNH(INH4)*
     &  Mah2(INH4)+3*Mah2(INH4)**2+3*Mah2(INH4)*MNeu2(INe3)+4*
     &  A0TNeu(INe4)*(Mah2(INH4)+MNeu2(INe3))+3*Mah2(INH4)*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH4)+
     &  MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH4)-Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(2*
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH4)*Mah2(INH4)*MNeu2(INe3)+3*Mah2(INH4)**2*MNeu2(INe3)+
     &  3*Mah2(INH4)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH4)**2+
     &  MNeu(INe3)**4+Mah2(INH4)*MNeu2(INe3))+4*A0TNH(INH4)*Mah2(INH4)*
     &  MNeu2(INe4)+2*Mah2(INH4)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH4)+MNeu2(INe4))))/((Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(Mah(INH4)-Mah(INH5))*(Mah(INH4)+
     &  Mah(INH5)))-(2*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*MNeu(INe4)*(4*A0TNH(INH5)*
     &  Mah2(INH5)+3*Mah2(INH5)**2+3*Mah2(INH5)*MNeu2(INe3)+4*
     &  A0TNeu(INe4)*(Mah2(INH5)+MNeu2(INe3))+3*Mah2(INH5)*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH5)+
     &  MNeu2(INe4))))/((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(-
     &  Mah(INH4)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))-(2*
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH5)*Mah2(INH5)*MNeu2(INe3)+3*Mah2(INH5)**2*MNeu2(INe3)+
     &  3*Mah2(INH5)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH5)**2+
     &  MNeu(INe3)**4+Mah2(INH5)*MNeu2(INe3))+4*A0TNH(INH5)*Mah2(INH5)*
     &  MNeu2(INe4)+2*Mah2(INH5)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH5)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH5)+MNeu2(INe4))))/((Mah(INH3)-Mah(INH5))*
     &  (Mah(INH3)+Mah(INH5))*(-Mah(INH4)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))))/64.)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH5)*
     &  (CFF11S1L(INe4,INe3,INH5)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH5,INe4)-
     &  FD111ChiHChi(8,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH5,INe4)+
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH5)**2)+
     &  CFF11S1L(INe3,INe4,INH3)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHChi(3,INe3,INH5,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH5)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH5,INe4)-
     &  FD111ChiHChi(8,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH5,INe4)+
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH5)**2)+
     &  CFF11S1R(INe3,INe4,INH3)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHChi(3,INe3,INH5,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)**2-Mah(INH5)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH5)*(2*(CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+
     &  Mah(INH5))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)
     &  +8*A0TNH(INH3)+2*Mah2(INH3)+3*MNeu2(INe3)+3*MNeu2(INe4))-
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH3)+Mah(INH5))*(12*A0TNH(INH3)*Mah2(INH3)+5*
     &  Mah2(INH3)**2+3*MNeu(INe3)**4-3*MNeu(INe4)**4+4*A0TNeu(INe3)*
     &  MNeu2(INe3)+8*Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(4*
     &  Mah2(INH3)+2*MNeu2(INe3)-MNeu2(INe4))+4*Mah2(INH3)*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4))+2*(CFF11S1L(INe4,INe3,INH5)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH5))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+
     &  Mah(INH5))*(4*A0TNeu(INe3)*MNeu2(INe3)+8*A0TNH(INH3)*
     &  MNeu2(INe3)+2*Mah2(INH3)*MNeu2(INe3)+3*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*(2*Mah2(INH3)+MNeu2(INe3))+8*A0TNH(INH3)*
     &  MNeu2(INe4)+3*MNeu2(INe3)*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH3)*Mah2(INH3)**2+3*Mah2(INH3)**3+Mah2(INH3)*MNeu(INe3)
     &  **4-3*Mah2(INH3)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH3)*
     &  MNeu2(INe3)+4*Mah2(INH3)**2*MNeu2(INe3)+2*Mah2(INH3)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH3)**2+8*MNeu(INe3)**4+
     &  Mah2(INH3)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH3)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4))-
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH5)*Mah2(INH5)**2+3*Mah2(INH5)**3+Mah2(INH5)*MNeu(INe3)
     &  **4-3*Mah2(INH5)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH5)*
     &  MNeu2(INe3)+4*Mah2(INH5)**2*MNeu2(INe3)+2*Mah2(INH5)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH5)**2+8*MNeu(INe3)**4+
     &  Mah2(INH5)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH5)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH5)*MNeu2(INe3)*MNeu2(INe4))-
     &  2*(CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH5)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2+3*
     &  Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+
     &  3*Mah2(INH3)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*(4*
     &  A0TNH(INH3)*Mah2(INH3)*MNeu2(INe3)+3*Mah2(INH3)**2*MNeu2(INe3)+
     &  3*Mah2(INH3)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH3)**2+
     &  MNeu(INe3)**4+Mah2(INH3)*MNeu2(INe3))+4*A0TNH(INH3)*Mah2(INH3)*
     &  MNeu2(INe4)+2*Mah2(INH3)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe4)))+2*
     &  (CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH5)+
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH5)*Mah2(INH5)+3*Mah2(INH5)**2+3*
     &  Mah2(INH5)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH5)+MNeu2(INe3))+
     &  3*Mah2(INH5)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH5)+MNeu2(INe4)))+4*
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH5))*(2*
     &  A0TNeu(INe4)*(Mah2(INH5)**2+MNeu(INe3)**4+Mah2(INH5)*
     &  MNeu2(INe3))+Mah2(INH5)**2*MNeu2(INe4)+MNeu(INe3)**4*
     &  MNeu2(INe4)+2*A0TNeu(INe3)*MNeu2(INe3)*(Mah2(INH5)+MNeu2(INe4))
     &  +(Mah2(INH5)*MNeu2(INe3)*(Mah2(INH5)+MNeu2(INe3)+MNeu2(INe4)))
     &  /2.+Mah2(INH5)*(2*A0TNH(INH5)*(MNeu2(INe3)+MNeu2(INe4))+
     &  MNeu2(INe3)*(Mah2(INH5)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*(Mah2(INH3)-Mah2(INH5))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*
     &  (CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH4)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH4,INe4)-
     &  FD111ChiHChi(8,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH4,INe4)+
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1L(INe3,INe4,INH4)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH4)*
     &  (FD111ChiHChi(6,INe3,INH3,INe4)-FD111ChiHChi(6,INe3,INH4,INe4)-
     &  FD111ChiHChi(8,INe3,INH3,INe4)+FD111ChiHChi(8,INe3,INH4,INe4)+
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(5,INH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HNeuNeu(6,INH3,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1R(INe3,INe4,INH4)*(FD111ChiHChi(3,INe3,INH3,INe4)-
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD211HNeuNeu(4,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH4)*(2*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)
     &  +8*A0TNH(INH3)+2*Mah2(INH3)+3*MNeu2(INe3)+3*MNeu2(INe4))-
     &  (CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*(Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(12*A0TNH(INH3)*Mah2(INH3)+5*
     &  Mah2(INH3)**2+3*MNeu(INe3)**4-3*MNeu(INe4)**4+4*A0TNeu(INe3)*
     &  MNeu2(INe3)+8*Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(4*
     &  Mah2(INH3)+2*MNeu2(INe3)-MNeu2(INe4))+4*Mah2(INH3)*MNeu2(INe4)+
     &  2*MNeu2(INe3)*MNeu2(INe4))+2*(CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(4*A0TNeu(INe3)*MNeu2(INe3)+8*A0TNH(INH3)*
     &  MNeu2(INe3)+2*Mah2(INH3)*MNeu2(INe3)+3*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*(2*Mah2(INH3)+MNeu2(INe3))+8*A0TNH(INH3)*
     &  MNeu2(INe4)+3*MNeu2(INe3)*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*(4*
     &  A0TNH(INH3)*Mah2(INH3)**2+3*Mah2(INH3)**3+Mah2(INH3)*MNeu(INe3)
     &  **4-3*Mah2(INH3)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH3)*
     &  MNeu2(INe3)+4*Mah2(INH3)**2*MNeu2(INe3)+2*Mah2(INH3)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH3)**2+8*MNeu(INe3)**4+
     &  Mah2(INH3)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH3)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4))-
     &  (CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*(4*
     &  A0TNH(INH4)*Mah2(INH4)**2+3*Mah2(INH4)**3+Mah2(INH4)*MNeu(INe3)
     &  **4-3*Mah2(INH4)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH4)*
     &  MNeu2(INe3)+4*Mah2(INH4)**2*MNeu2(INe3)+2*Mah2(INH4)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH4)**2+8*MNeu(INe3)**4+
     &  Mah2(INH4)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH4)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4))-
     &  2*(CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,INH3)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2+3*
     &  Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+
     &  3*Mah2(INH3)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*(4*
     &  A0TNH(INH3)*Mah2(INH3)*MNeu2(INe3)+3*Mah2(INH3)**2*MNeu2(INe3)+
     &  3*Mah2(INH3)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH3)**2+
     &  MNeu(INe3)**4+Mah2(INH3)*MNeu2(INe3))+4*A0TNH(INH3)*Mah2(INH3)*
     &  MNeu2(INe4)+2*Mah2(INH3)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe4)))+2*
     &  (CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,INH3)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2+3*
     &  Mah2(INH4)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH4)+MNeu2(INe3))+
     &  3*Mah2(INH4)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH4)+MNeu2(INe4)))+4*
     &  (CFF11S1L(INe4,INe3,INH3)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH3))*(2*
     &  A0TNeu(INe4)*(Mah2(INH4)**2+MNeu(INe3)**4+Mah2(INH4)*
     &  MNeu2(INe3))+Mah2(INH4)**2*MNeu2(INe4)+MNeu(INe3)**4*
     &  MNeu2(INe4)+2*A0TNeu(INe3)*MNeu2(INe3)*(Mah2(INH4)+MNeu2(INe4))
     &  +(Mah2(INH4)*MNeu2(INe3)*(Mah2(INH4)+MNeu2(INe3)+MNeu2(INe4)))
     &  /2.+Mah2(INH4)*(2*A0TNH(INH4)*(MNeu2(INe3)+MNeu2(INe4))+
     &  MNeu2(INe3)*(Mah2(INH4)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*(Mah2(INH3)-Mah2(INH4))**2))
             endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)**2*(CFF11S1L(INe4,INe3,INH4)*
     &  (CFF11S1R(INe3,INe4,INH4)*(-FD111ChiHChi(6,INe3,INH3,INe4)+
     &  FD111ChiHChi(6,INe3,INH4,INe4)+FD111ChiHChi(8,INe3,INH3,INe4)-
     &  FD111ChiHChi(8,INe3,INH4,INe4)-FD211HNeuNeu(5,INH4,INe3,INe4)*
     &  Mah(INH3)**2+FD211HNeuNeu(6,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(5,INH4,INe3,INe4)*Mah(INH4)**2-
     &  FD211HNeuNeu(6,INH4,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1L(INe3,INe4,INH4)*(-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD211HNeuNeu(4,INH4,INe3,INe4)*
     &  (Mah(INH3)**2-Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH4)*(-
     &  FD111ChiHChi(6,INe3,INH3,INe4)+FD111ChiHChi(6,INe3,INH4,INe4)+
     &  FD111ChiHChi(8,INe3,INH3,INe4)-FD111ChiHChi(8,INe3,INH4,INe4)-
     &  FD211HNeuNeu(5,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(6,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(5,INH4,INe3,INe4)*Mah(INH4)**2-
     &  FD211HNeuNeu(6,INH4,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1R(INe3,INe4,INH4)*(-FD111ChiHChi(3,INe3,INH3,INe4)+
     &  FD111ChiHChi(3,INe3,INH4,INe4)+FD211HNeuNeu(4,INH4,INe3,INe4)*
     &  (Mah(INH3)**2-Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))))/(4.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1V2(INH3,INH4)**2*(-2*
     &  (CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*(Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*MNeu(INe3)*MNeu(INe4)*(4*
     &  A0TNeu(INe3)+4*A0TNeu(INe4)+8*A0TNH(INH4)+2*Mah2(INH4)+3*
     &  MNeu2(INe3)+3*MNeu2(INe4))+(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(12*A0TNH(INH4)*Mah2(INH4)+5*Mah2(INH4)**2+3*
     &  MNeu(INe3)**4-3*MNeu(INe4)**4+4*A0TNeu(INe3)*MNeu2(INe3)+8*
     &  Mah2(INH4)*MNeu2(INe3)+4*A0TNeu(INe4)*(4*Mah2(INH4)+2*
     &  MNeu2(INe3)-MNeu2(INe4))+4*Mah2(INH4)*MNeu2(INe4)+2*MNeu2(INe3)
     &  *MNeu2(INe4))-2*(CFF11S1L(INe4,INe3,INH4)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH4))*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(4*A0TNeu(INe3)*MNeu2(INe3)+8*A0TNH(INH4)*
     &  MNeu2(INe3)+2*Mah2(INH4)*MNeu2(INe3)+3*MNeu2(INe3)**2+4*
     &  A0TNeu(INe4)*(2*Mah2(INH4)+MNeu2(INe3))+8*A0TNH(INH4)*
     &  MNeu2(INe4)+3*MNeu2(INe3)*MNeu2(INe4))-
     &  (CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*(4*
     &  A0TNH(INH3)*Mah2(INH3)**2+3*Mah2(INH3)**3+Mah2(INH3)*MNeu(INe3)
     &  **4-3*Mah2(INH3)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH3)*
     &  MNeu2(INe3)+4*Mah2(INH3)**2*MNeu2(INe3)+2*Mah2(INH3)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH3)**2+8*MNeu(INe3)**4+
     &  Mah2(INH3)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH3)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH3)*MNeu2(INe3)*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*(4*
     &  A0TNH(INH4)*Mah2(INH4)**2+3*Mah2(INH4)**3+Mah2(INH4)*MNeu(INe3)
     &  **4-3*Mah2(INH4)*MNeu(INe4)**4+4*A0TNeu(INe3)*Mah2(INH4)*
     &  MNeu2(INe3)+4*Mah2(INH4)**2*MNeu2(INe3)+2*Mah2(INH4)*
     &  MNeu2(INe3)**2+A0TNeu(INe4)*(8*Mah2(INH4)**2+8*MNeu(INe3)**4+
     &  Mah2(INH4)*(8*MNeu2(INe3)-4*MNeu2(INe4)))+2*Mah2(INH4)**2*
     &  MNeu2(INe4)+4*MNeu(INe3)**4*MNeu2(INe4)+8*A0TNeu(INe3)*
     &  MNeu2(INe3)*MNeu2(INe4)+2*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4))+
     &  2*(CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2+3*
     &  Mah2(INH3)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH3)+MNeu2(INe3))+
     &  3*Mah2(INH3)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,INH4)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*MNeu(INe3)*
     &  MNeu(INe4)*(4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2+3*
     &  Mah2(INH4)*MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH4)+MNeu2(INe3))+
     &  3*Mah2(INH4)*MNeu2(INe4)+2*MNeu2(INe3)*MNeu2(INe4)+4*
     &  A0TNeu(INe3)*(Mah2(INH4)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*(4*
     &  A0TNH(INH4)*Mah2(INH4)*MNeu2(INe3)+3*Mah2(INH4)**2*MNeu2(INe3)+
     &  3*Mah2(INH4)*MNeu2(INe3)**2+4*A0TNeu(INe4)*(Mah2(INH4)**2+
     &  MNeu(INe3)**4+Mah2(INH4)*MNeu2(INe3))+4*A0TNH(INH4)*Mah2(INH4)*
     &  MNeu2(INe4)+2*Mah2(INH4)**2*MNeu2(INe4)+2*MNeu(INe3)**4*
     &  MNeu2(INe4)+3*Mah2(INH4)*MNeu2(INe3)*MNeu2(INe4)+4*A0TNeu(INe3)
     &  *MNeu2(INe3)*(Mah2(INH4)+MNeu2(INe4)))+4*
     &  (CFF11S1L(INe4,INe3,INH4)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,INH4))*(2*
     &  A0TNeu(INe4)*(Mah2(INH3)**2+MNeu(INe3)**4+Mah2(INH3)*
     &  MNeu2(INe3))+Mah2(INH3)**2*MNeu2(INe4)+MNeu(INe3)**4*
     &  MNeu2(INe4)+2*A0TNeu(INe3)*MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe4))
     &  +(Mah2(INH3)*MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe3)+MNeu2(INe4)))
     &  /2.+Mah2(INH3)*(2*A0TNH(INH3)*(MNeu2(INe3)+MNeu2(INe4))+
     &  MNeu2(INe3)*(Mah2(INH3)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*(Mah2(INH3)-Mah2(INH4))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)**2*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(FD311HChiChi(4,INH3,INe3,INe4)-
     &  FD311HChiChi(6,INH3,INe3,INe4))-CFF11S1L(INe3,INe4,INH3)*
     &  FD311HChiChi(3,INH3,INe3,INe4)*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD311HChiChi(4,INH3,INe3,INe4)-FD311HChiChi(6,INH3,INe3,INe4))
     &  -CFF11S1R(INe3,INe4,INH3)*FD311HChiChi(3,INH3,INe3,INe4)*
     &  MNeu(INe3)*MNeu(INe4))))/4.+(CS1S1V2(INH3,INH3)**2*(Mah2(INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-6*CFF11S1R(INe3,INe4,INH3)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1L(INe3,INe4,INH3)*(Mah2(INH3)-10*
     &  (MNeu2(INe3)+MNeu2(INe4))))+CFF11S1L(INe4,INe3,INH3)*(-6*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(Mah2(INH3)-10*(MNeu2(INe3)+
     &  MNeu2(INe4)))))+4*A0TNH(INH3)*(CFF11S1R(INe4,INe3,INH3)*(2*
     &  CFF11S1R(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,INH3)*(-3*Mah2(INH3)+2*(MNeu2(INe3)+
     &  MNeu2(INe4))))+CFF11S1L(INe4,INe3,INH3)*(2*
     &  CFF11S1L(INe3,INe4,INH3)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,INH3)*(-3*Mah2(INH3)+2*(MNeu2(INe3)+
     &  MNeu2(INe4)))))))/(64.*Mah2(INH3)))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 



       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*(CTBS3(ICH5)*CTBS3C(ICH4)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)+CTBS3(ICH4)*
     &  CTBS3C(ICH5)*indexdelta(ICH3,ICH4)*indexdelta(ICH5,ICH3))*(-
     &  (FD111THpB(8,ICH4)*MassHpm(ICH3)**2)+FD111THpB(8,ICH5)*
     &  MassHpm(ICH3)**2-FD111THpB(6,ICH3)*MassHpm(ICH4)**2+
     &  FD111THpB(8,ICH3)*MassHpm(ICH4)**2-FD111THpB(8,ICH5)*
     &  MassHpm(ICH4)**2+FD111THpB(6,ICH5)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)+FD111THpB(6,ICH3)*MassHpm(ICH5)**2-
     &  FD111THpB(8,ICH3)*MassHpm(ICH5)**2+FD111THpB(8,ICH4)*
     &  MassHpm(ICH5)**2+FD111THpB(6,ICH4)*(MassHpm(ICH3)**2-
     &  MassHpm(ICH5)**2)))/(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*
     &  (MassHpm(ICH4)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  (MassHpm(ICH4)+MassHpm(ICH5)))+(3*C2W**2*(CTBS3(ICH5)*
     &  CTBS3C(ICH4)*indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)+
     &  CTBS3(ICH4)*CTBS3C(ICH5)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH5,ICH3))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2*(-2*
     &  M12+MassHpm(ICH4)**2)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)-4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*(-2*M12+MassHpm(ICH3)**2)*
     &  (MassHpm(ICH4)**2-MassHpm(ICH5)**2)+(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)*(-3*MassHpm(ICH3)**4*(MassHpm(ICH4)**2-
     &  MassHpm(ICH5)**2)+MassHpm(ICH3)**2*(2*M12-3*MassHpm(ICH4)**2)*
     &  (MassHpm(ICH4)**2-MassHpm(ICH5)**2)+MassHpm(ICH5)**2*(8*M12*
     &  A0THpN(ICH5)-2*M12*MassHpm(ICH4)**2+3*MassHpm(ICH4)**4+2*M12*
     &  MassHpm(ICH5)**2-4*A0THpN(ICH5)*MassHpm(ICH5)**2-3*
     &  MassHpm(ICH5)**4))))/(32.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*
     &  (MassHpm(ICH4)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  (MassHpm(ICH4)+MassHpm(ICH5))))
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*indexdelta(ICH3,ICH3)*(CTBS3(ICH5)*
     &  CTBS3C(ICH3)*indexdelta(ICH3,ICH5)+CTBS3(ICH3)*CTBS3C(ICH5)*
     &  indexdelta(ICH5,ICH3))*(FD111THpB(6,ICH3)-FD111THpB(6,ICH5)-
     &  FD111THpB(8,ICH3)+FD111THpB(8,ICH5)+FD211HpTB(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpTB(6,ICH3)*MassHpm(ICH3)**2-
     &  FD211HpTB(5,ICH3)*MassHpm(ICH5)**2+FD211HpTB(6,ICH3)*
     &  MassHpm(ICH5)**2))/(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH5))**2*
     &  (MassHpm(ICH3)+MassHpm(ICH5))**2)+(3*C2W**2*
     &  indexdelta(ICH3,ICH3)*(CTBS3(ICH5)*CTBS3C(ICH3)*
     &  indexdelta(ICH3,ICH5)+CTBS3(ICH3)*CTBS3C(ICH5)*
     &  indexdelta(ICH5,ICH3))*(-2*MassHpm(ICH3)**6+8*M12*A0THpN(ICH5)*
     &  MassHpm(ICH5)**2+4*M12*MassHpm(ICH3)**2*MassHpm(ICH5)**2+2*M12*
     &  MassHpm(ICH5)**4-4*A0THpN(ICH5)*MassHpm(ICH5)**4-3*
     &  MassHpm(ICH5)**6+MassHpm(ICH3)**4*(-6*M12+5*MassHpm(ICH5)**2)+
     &  4*A0THpN(ICH3)*(-2*MassHpm(ICH3)**4-4*M12*MassHpm(ICH5)**2+
     &  MassHpm(ICH3)**2*(2*M12+3*MassHpm(ICH5)**2))))/(32.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH5))**2*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  *2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*indexdelta(ICH3,ICH3)*(CTBS3(ICH4)*
     &  CTBS3C(ICH3)*indexdelta(ICH3,ICH4)+CTBS3(ICH3)*CTBS3C(ICH4)*
     &  indexdelta(ICH4,ICH3))*(FD111THpB(6,ICH3)-FD111THpB(6,ICH4)-
     &  FD111THpB(8,ICH3)+FD111THpB(8,ICH4)+FD211HpTB(5,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpTB(6,ICH3)*MassHpm(ICH3)**2-
     &  FD211HpTB(5,ICH3)*MassHpm(ICH4)**2+FD211HpTB(6,ICH3)*
     &  MassHpm(ICH4)**2))/(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**2*
     &  (MassHpm(ICH3)+MassHpm(ICH4))**2)+(3*C2W**2*
     &  indexdelta(ICH3,ICH3)*(CTBS3(ICH4)*CTBS3C(ICH3)*
     &  indexdelta(ICH3,ICH4)+CTBS3(ICH3)*CTBS3C(ICH4)*
     &  indexdelta(ICH4,ICH3))*(-2*MassHpm(ICH3)**6+8*M12*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2+4*M12*MassHpm(ICH3)**2*MassHpm(ICH4)**2+2*M12*
     &  MassHpm(ICH4)**4-4*A0THpN(ICH4)*MassHpm(ICH4)**4-3*
     &  MassHpm(ICH4)**6+MassHpm(ICH3)**4*(-6*M12+5*MassHpm(ICH4)**2)+
     &  4*A0THpN(ICH3)*(-2*MassHpm(ICH3)**4-4*M12*MassHpm(ICH4)**2+
     &  MassHpm(ICH3)**2*(2*M12+3*MassHpm(ICH4)**2))))/(32.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2))
             endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((-3*C2W**2*CTBS3(ICH4)*CTBS3C(ICH4)*
     &  indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)*(FD111THpB(6,ICH3)-
     &  FD111THpB(6,ICH4)-FD111THpB(8,ICH3)+FD111THpB(8,ICH4)+
     &  FD211HpTB(5,ICH4)*MassHpm(ICH3)**2-FD211HpTB(6,ICH4)*
     &  MassHpm(ICH3)**2-FD211HpTB(5,ICH4)*MassHpm(ICH4)**2+
     &  FD211HpTB(6,ICH4)*MassHpm(ICH4)**2))/(S2W**2*(MassHpm(ICH3)-
     &  MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))**2)+(3*C2W**2*
     &  CTBS3(ICH4)*CTBS3C(ICH4)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH4,ICH3)*(2*M12*MassHpm(ICH3)**4-3*MassHpm(ICH3)**
     &  6+A0THpN(ICH3)*(8*M12*MassHpm(ICH3)**2-4*MassHpm(ICH3)**4)+4*
     &  M12*MassHpm(ICH3)**2*MassHpm(ICH4)**2-6*M12*MassHpm(ICH4)**4+5*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**4-2*MassHpm(ICH4)**6-4*
     &  A0THpN(ICH4)*(-2*M12*MassHpm(ICH4)**2+2*MassHpm(ICH4)**4+
     &  MassHpm(ICH3)**2*(4*M12-3*MassHpm(ICH4)**2))))/(16.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  (FD311HpTB(4,ICH3)-FD311HpTB(6,ICH3))*indexdelta(ICH3,ICH3)**2)
     &  /S2W**2+(3*C2W**2*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  indexdelta(ICH3,ICH3)**2*(-10*M12*MassHpm(ICH3)**2+
     &  MassHpm(ICH3)**4+4*A0THpN(ICH3)*(2*M12-3*MassHpm(ICH3)**2)))
     &  /(16.*S2W**2*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INe3=1,3
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*(CF11F12S3R(INe3,ICH4)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)*
     &  (DCONJG(CF11F12S3R(INe3,ICH5))*(-(FD111ChiHpCha(8,INe3,ICH4)*
     &  MassHpm(ICH3)**2)+FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)
     &  +FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))
     &  +MCha*DCONJG(CF11F12S3L(INe3,ICH5))*(FD111ChiHpCha(3,INe3,ICH5)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)+
     &  FD111ChiHpCha(3,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)+
     &  FD111ChiHpCha(3,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)**2)
     &  )*MNeu(INe3))+CF11F12S3L(INe3,ICH4)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH4,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH5))*(-
     &  (FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH3)**2)+
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)
     &  +FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))
     &  +MCha*DCONJG(CF11F12S3R(INe3,ICH5))*(FD111ChiHpCha(3,INe3,ICH5)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)+
     &  FD111ChiHpCha(3,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)+
     &  FD111ChiHpCha(3,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)**2)
     &  )*MNeu(INe3))+indexdelta(ICH3,ICH4)*indexdelta(ICH5,ICH3)*
     &  (CF11F12S3R(INe3,ICH5)*(DCONJG(CF11F12S3R(INe3,ICH4))*(-
     &  (FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH3)**2)+
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)
     &  +FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))
     &  +MCha*DCONJG(CF11F12S3L(INe3,ICH4))*(FD111ChiHpCha(3,INe3,ICH5)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)+
     &  FD111ChiHpCha(3,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)+
     &  FD111ChiHpCha(3,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)**2)
     &  )*MNeu(INe3))+CF11F12S3L(INe3,ICH5)*
     &  (DCONJG(CF11F12S3L(INe3,ICH4))*(-(FD111ChiHpCha(8,INe3,ICH4)*
     &  MassHpm(ICH3)**2)+FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(8,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(6,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)
     &  +FD111ChiHpCha(6,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(8,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(8,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(6,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))
     &  +MCha*DCONJG(CF11F12S3R(INe3,ICH4))*(FD111ChiHpCha(3,INe3,ICH5)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)+
     &  FD111ChiHpCha(3,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)+
     &  FD111ChiHpCha(3,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)**2)
     &  )*MNeu(INe3)))))/(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*
     &  (MassHpm(ICH4)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  (MassHpm(ICH4)+MassHpm(ICH5)))+(C2W**2*(4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)*
     &  (CF11F12S3L(INe3,ICH4)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH4,ICH3)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH5))*(-MassHpm(ICH3)**2+2*
     &  (MCha2+MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(-MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3))))+indexdelta(ICH3,ICH4)*indexdelta(ICH5,ICH3)*
     &  (CF11F12S3L(INe3,ICH5)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(-MassHpm(ICH3)**2+2*
     &  (MCha2+MNeu2(INe3))))+CF11F12S3R(INe3,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3))))))-4*A0THpN(ICH4)*MassHpm(ICH4)**2*(MassHpm(ICH3)
     &  **2-MassHpm(ICH5)**2)*(CF11F12S3L(INe3,ICH4)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH5))*(-MassHpm(ICH4)**2+2*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH4,ICH3)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH5))*(-MassHpm(ICH4)**2+2*
     &  (MCha2+MNeu2(INe3))))+indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH5,ICH3)*(CF11F12S3L(INe3,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-MassHpm(ICH4)**2+2*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-MassHpm(ICH4)**2+2*(MCha2+
     &  MNeu2(INe3))))))+(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*
     &  (CF11F12S3L(INe3,ICH4)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH4,ICH3)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH5))*(3*
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH5)**2*(4*A0THpN(ICH5)-3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2))*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH5))*(-
     &  3*MassHpm(ICH3)**4*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(-3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+MassHpm(ICH5)**2*
     &  ((MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2-2*(MCha2+MNeu2(INe3)))+A0THpN(ICH5)*(-4*
     &  MassHpm(ICH5)**2+8*(MCha2+MNeu2(INe3))))))+
     &  CF11F12S3R(INe3,ICH4)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH4,ICH3)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH5))*(3*
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH5)**2*(4*A0THpN(ICH5)-3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2))*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH5))*(-
     &  3*MassHpm(ICH3)**4*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(-3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+MassHpm(ICH5)**2*
     &  ((MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2-2*(MCha2+MNeu2(INe3)))+A0THpN(ICH5)*(-4*
     &  MassHpm(ICH5)**2+8*(MCha2+MNeu2(INe3))))))+
     &  indexdelta(ICH3,ICH4)*indexdelta(ICH5,ICH3)*
     &  (CF11F12S3L(INe3,ICH5)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (3*MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH5)**2*(4*A0THpN(ICH5)-3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2))*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(-
     &  3*MassHpm(ICH3)**4*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(-3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+MassHpm(ICH5)**2*
     &  ((MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2-2*(MCha2+MNeu2(INe3)))+A0THpN(ICH5)*(-4*
     &  MassHpm(ICH5)**2+8*(MCha2+MNeu2(INe3))))))+
     &  CF11F12S3R(INe3,ICH5)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH4))*(3*
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH5)**2*(4*A0THpN(ICH5)-3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2))*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH4))*(-
     &  3*MassHpm(ICH3)**4*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  MassHpm(ICH3)**2*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(-3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+MassHpm(ICH5)**2*
     &  ((MassHpm(ICH4)**2-MassHpm(ICH5)**2)*(3*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH5)**2-2*(MCha2+MNeu2(INe3)))+A0THpN(ICH5)*(-4*
     &  MassHpm(ICH5)**2+8*(MCha2+MNeu2(INe3))))))))))/(32.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH4)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*(MassHpm(ICH4)+MassHpm(ICH5))))
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*indexdelta(ICH3,ICH5)*
     &  (DCONJG(CF11F12S3R(INe3,ICH5))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH5)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH5)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH5)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH3)*indexdelta(ICH3,ICH5)*
     &  (DCONJG(CF11F12S3L(INe3,ICH5))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH5)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH5)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH5)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3))+
     &  indexdelta(ICH5,ICH3)*(CF11F12S3R(INe3,ICH5)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH5)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH5)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH5)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH5)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH5)-
     &  FD111ChiHpCha(8,INe3,ICH3)+FD111ChiHpCha(8,INe3,ICH5)+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH5)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3)))))/(2.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH5))**2*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  *2)+(C2W**2*indexdelta(ICH3,ICH3)*(-6*MCha2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  indexdelta(ICH3,ICH5)*MassHpm(ICH3)**4-6*MCha2*
     &  CF11F12S3L(INe3,ICH5)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-6*MCha2*
     &  CF11F12S3R(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**6-2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**6-2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**6+8*MCha2*A0THpN(ICH5)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**2+8*MCha2*A0THpN(ICH5)*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2+8*MCha2*A0THpN(ICH5)*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2+4*MCha2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2+4*MCha2*CF11F12S3L(INe3,ICH5)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2+4*MCha2*CF11F12S3R(INe3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2+5*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**4*MassHpm(ICH5)**2+5*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MassHpm(ICH5)**2+5*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MassHpm(ICH5)**2+2*MCha2*CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**4-4*A0THpN(ICH5)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**4+2*MCha2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4-4*A0THpN(ICH5)*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4+2*MCha2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4-4*A0THpN(ICH5)*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4-3*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**6-3*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**6-3*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**6-2*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**4*MNeu(INe3)-2*MCha*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MNeu(INe3)-2*MCha*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MNeu(INe3)+8*MCha*A0THpN(ICH5)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  indexdelta(ICH3,ICH5)*MassHpm(ICH5)**2*MNeu(INe3)+8*MCha*
     &  A0THpN(ICH5)*CF11F12S3R(INe3,ICH5)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*indexdelta(ICH5,ICH3)*MassHpm(ICH5)**2*MNeu(INe3)+8*MCha*
     &  A0THpN(ICH5)*CF11F12S3L(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*indexdelta(ICH5,ICH3)*MassHpm(ICH5)**2*MNeu(INe3)-4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  indexdelta(ICH3,ICH5)*MassHpm(ICH3)**2*MassHpm(ICH5)**2*
     &  MNeu(INe3)-4*MCha*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2*MNeu(INe3)-4*MCha*
     &  CF11F12S3L(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH5)**2*
     &  MNeu(INe3)+6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**4*MNeu(INe3)+6*MCha*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4*MNeu(INe3)+6*MCha*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4*MNeu(INe3)-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4-2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4-2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**2*MNeu(INe3)**4+2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)**4+2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)**4-6*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)-6*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)-6*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+8*A0THpN(ICH5)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  indexdelta(ICH3,ICH5)*MassHpm(ICH5)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH5)*CF11F12S3L(INe3,ICH5)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*indexdelta(ICH5,ICH3)*MassHpm(ICH5)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH5)*CF11F12S3R(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*indexdelta(ICH5,ICH3)*MassHpm(ICH5)**2*MNeu2(INe3)+4*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  indexdelta(ICH3,ICH5)*MassHpm(ICH3)**2*MassHpm(ICH5)**2*
     &  MNeu2(INe3)+4*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2*MNeu2(INe3)+4*
     &  CF11F12S3R(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH5)**2*
     &  MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**4*MNeu2(INe3)+2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**4*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2+2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2+2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*indexdelta(ICH3,ICH5)*
     &  MassHpm(ICH5)**2*MNeu2(INe3)**2-2*CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2*MNeu2(INe3)**2-2*CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH5,ICH3)*
     &  MassHpm(ICH5)**2*MNeu2(INe3)**2+CF11F12S3L(INe3,ICH3)*
     &  indexdelta(ICH3,ICH5)*(-2*MCha*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  (MassHpm(ICH3)**4-4*A0THpN(ICH5)*MassHpm(ICH5)**2+2*
     &  MassHpm(ICH3)**2*MassHpm(ICH5)**2-3*MassHpm(ICH5)**4)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH5))*(-2*MassHpm(ICH3)**6+
     &  MassHpm(ICH3)**4*(5*MassHpm(ICH5)**2-6*(MCha2+MNeu2(INe3)))+2*
     &  MassHpm(ICH3)**2*(-MNeu(INe3)**4+MNeu2(INe3)**2+2*MassHpm(ICH5)
     &  **2*(MCha2+MNeu2(INe3)))+MassHpm(ICH5)**2*(-3*MassHpm(ICH5)**4+
     &  2*MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+2*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2)+A0THpN(ICH5)*(-4*MassHpm(ICH5)**2+8*(MCha2+
     &  MNeu2(INe3))))))+4*A0THpN(ICH3)*(CF11F12S3L(INe3,ICH3)*
     &  indexdelta(ICH3,ICH5)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH5)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH5))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH5)**2+2*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH3)
     &  *indexdelta(ICH3,ICH5)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH5)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH5)**2+2*(MCha2+MNeu2(INe3)))))+indexdelta(ICH5,ICH3)
     &  *(CF11F12S3L(INe3,ICH5)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH5)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH5)**2+2*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH5)
     &  *(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**2-2*
     &  MassHpm(ICH5)**2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  MassHpm(ICH3)**4-4*MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*MassHpm(ICH5)**2+2*(MCha2+MNeu2(INe3)))))))))/(32.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH5))**2*(MassHpm(ICH3)+MassHpm(ICH5))**2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*indexdelta(ICH3,ICH4)*
     &  (DCONJG(CF11F12S3R(INe3,ICH4))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH4)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH4)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH3)*indexdelta(ICH3,ICH4)*
     &  (DCONJG(CF11F12S3L(INe3,ICH4))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH4)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH4)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  indexdelta(ICH4,ICH3)*(CF11F12S3R(INe3,ICH4)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(6,INe3,ICH4)-FD111ChiHpCha(8,INe3,ICH3)+
     &  FD111ChiHpCha(8,INe3,ICH4)+FD211HpChiCha(5,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD111ChiHpCha(6,INe3,ICH3)-FD111ChiHpCha(6,INe3,ICH4)-
     &  FD111ChiHpCha(8,INe3,ICH3)+FD111ChiHpCha(8,INe3,ICH4)+
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(5,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(6,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(3,INe3,ICH3)-
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3)))))/(2.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2)+(C2W**2*indexdelta(ICH3,ICH3)*(-6*MCha2*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  indexdelta(ICH3,ICH4)*MassHpm(ICH3)**4-6*MCha2*
     &  CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  indexdelta(ICH4,ICH3)*MassHpm(ICH3)**4-6*MCha2*
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH4,ICH3)*MassHpm(ICH3)**4-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**6-2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**6-2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**6+8*MCha2*A0THpN(ICH4)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**2+8*MCha2*A0THpN(ICH4)*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2+8*MCha2*A0THpN(ICH4)*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2+4*MCha2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*MCha2*CF11F12S3L(INe3,ICH4)
     &  *DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*MCha2*CF11F12S3R(INe3,ICH4)
     &  *DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2+5*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**4*MassHpm(ICH4)**2+5*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MassHpm(ICH4)**2+5*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MassHpm(ICH4)**2+2*MCha2*CF11F12S3R(INe3,ICH3)
     &  *DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**4-4*A0THpN(ICH4)*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**4+2*MCha2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4-4*A0THpN(ICH4)*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4+2*MCha2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4-4*A0THpN(ICH4)*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4-3*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**6-3*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**6-3*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**6-2*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**4*MNeu(INe3)-2*MCha*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MNeu(INe3)-2*MCha*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MNeu(INe3)+8*MCha*A0THpN(ICH4)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  indexdelta(ICH3,ICH4)*MassHpm(ICH4)**2*MNeu(INe3)+8*MCha*
     &  A0THpN(ICH4)*CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*indexdelta(ICH4,ICH3)*MassHpm(ICH4)**2*MNeu(INe3)+8*MCha*
     &  A0THpN(ICH4)*CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*indexdelta(ICH4,ICH3)*MassHpm(ICH4)**2*MNeu(INe3)-4*MCha*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  indexdelta(ICH3,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2*
     &  MNeu(INe3)-4*MCha*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2*MNeu(INe3)-4*MCha*
     &  CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH4,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH4)**2*
     &  MNeu(INe3)+6*MCha*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**4*MNeu(INe3)+6*MCha*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4*MNeu(INe3)+6*MCha*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4*MNeu(INe3)-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4-2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4-2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)**4+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**2*MNeu(INe3)**4+2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)**4+2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)**4-6*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)-6*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)-6*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**4*MNeu2(INe3)+8*A0THpN(ICH4)*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  indexdelta(ICH3,ICH4)*MassHpm(ICH4)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH4)*CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*indexdelta(ICH4,ICH3)*MassHpm(ICH4)**2*MNeu2(INe3)+8*
     &  A0THpN(ICH4)*CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*indexdelta(ICH4,ICH3)*MassHpm(ICH4)**2*MNeu2(INe3)+4*
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  indexdelta(ICH3,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2*
     &  MNeu2(INe3)+4*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2*MNeu2(INe3)+4*
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  indexdelta(ICH4,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH4)**2*
     &  MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**4*MNeu2(INe3)+2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**4*MNeu2(INe3)+2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2+2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2+2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH3)**2*MNeu2(INe3)**2-2*CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*indexdelta(ICH3,ICH4)*
     &  MassHpm(ICH4)**2*MNeu2(INe3)**2-2*CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2*MNeu2(INe3)**2-2*CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*indexdelta(ICH4,ICH3)*
     &  MassHpm(ICH4)**2*MNeu2(INe3)**2+CF11F12S3L(INe3,ICH3)*
     &  indexdelta(ICH3,ICH4)*(-2*MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (MassHpm(ICH3)**4-4*A0THpN(ICH4)*MassHpm(ICH4)**2+2*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2-3*MassHpm(ICH4)**4)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(-2*MassHpm(ICH3)**6+
     &  MassHpm(ICH3)**4*(5*MassHpm(ICH4)**2-6*(MCha2+MNeu2(INe3)))+2*
     &  MassHpm(ICH3)**2*(-MNeu(INe3)**4+MNeu2(INe3)**2+2*MassHpm(ICH4)
     &  **2*(MCha2+MNeu2(INe3)))+MassHpm(ICH4)**2*(-3*MassHpm(ICH4)**4+
     &  2*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+2*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2)+A0THpN(ICH4)*(-4*MassHpm(ICH4)**2+8*(MCha2+
     &  MNeu2(INe3))))))+4*A0THpN(ICH3)*(CF11F12S3L(INe3,ICH3)*
     &  indexdelta(ICH3,ICH4)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH3)
     &  *indexdelta(ICH3,ICH4)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))))+indexdelta(ICH4,ICH3)
     &  *(CF11F12S3L(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-2*MassHpm(ICH3)**4-4*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*
     &  MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH4)
     &  *(2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**2-2*
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-2*
     &  MassHpm(ICH3)**4-4*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+MassHpm(ICH3)**2*(3*MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))))))))/(32.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))**2))
             endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)
     &  *(CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH4))*(-
     &  FD111ChiHpCha(6,INe3,ICH3)+FD111ChiHpCha(6,INe3,ICH4)+
     &  FD111ChiHpCha(8,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH4)-
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH4))*(-
     &  FD111ChiHpCha(6,INe3,ICH3)+FD111ChiHpCha(6,INe3,ICH4)+
     &  FD111ChiHpCha(8,INe3,ICH3)-FD111ChiHpCha(8,INe3,ICH4)-
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(5,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(6,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD111ChiHpCha(3,INe3,ICH4)+FD211HpChiCha(4,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))))/(S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2)+(C2W**2*indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3)))))-4*A0THpN(ICH4)*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(2*MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(2*MassHpm(ICH4)*
     &  *2*(-MCha2+MassHpm(ICH4)**2-MNeu2(INe3))+MassHpm(ICH3)**2*(-3*
     &  MassHpm(ICH4)**2+4*(MCha2+MNeu2(INe3)))))+CF11F12S3R(INe3,ICH4)
     &  *(2*MCha*DCONJG(CF11F12S3L(INe3,ICH4))*(2*MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH4))*(2*
     &  MassHpm(ICH4)**2*(-MCha2+MassHpm(ICH4)**2-MNeu2(INe3))+
     &  MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+4*(MCha2+MNeu2(INe3))))))
     &  +(MassHpm(ICH3)**2-MassHpm(ICH4)**2)*(CF11F12S3L(INe3,ICH4)*(2*
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH4))*(3*MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(-3*
     &  MassHpm(ICH3)**4+MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+2*
     &  (MCha2+MNeu2(INe3)))+2*(MassHpm(ICH4)**4+MNeu(INe3)**4-
     &  MNeu2(INe3)**2+3*MassHpm(ICH4)**2*(MCha2+MNeu2(INe3)))))+
     &  CF11F12S3R(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3L(INe3,ICH4))*(3*
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-3*MassHpm(ICH3)**4+
     &  MassHpm(ICH3)**2*(-3*MassHpm(ICH4)**2+2*(MCha2+MNeu2(INe3)))+2*
     &  (MassHpm(ICH4)**4+MNeu(INe3)**4-MNeu2(INe3)**2+3*MassHpm(ICH4)*
     &  *2*(MCha2+MNeu2(INe3))))))))/(16.*S2W**2*(MassHpm(ICH3)-
     &  MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))**2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH3)**2*
     &  (CF11F12S3R(INe3,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD311HpChiCha(4,ICH3,INe3)-FD311HpChiCha(6,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311HpChiCha(3,ICH3,INe3)*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(FD311HpChiCha(4,ICH3,INe3)-FD311HpChiCha(6,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311HpChiCha(3,ICH3,INe3)*
     &  MNeu(INe3))))/S2W**2+(C2W**2*indexdelta(ICH3,ICH3)**2*
     &  (MassHpm(ICH3)**2*(CF11F12S3L(INe3,ICH3)*(-6*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MassHpm(ICH3)**2-10*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH3)*(-6*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MassHpm(ICH3)**2-10*(MCha2+
     &  MNeu2(INe3)))))+4*A0THpN(ICH3)*(CF11F12S3L(INe3,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-3*MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3))))+CF11F12S3R(INe3,ICH3)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-3*MassHpm(ICH3)**2+2*(MCha2+
     &  MNeu2(INe3)))))))/(16.*S2W**2*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
c
c topo7-NoGBC
c

       ! diagram  1  
        INH3=6
        INH4=6
            do INH5=1,5
       selfZ=selfZ+((CS1S1V2(6,6)*CS1S1V2(6,INH5)*((CFF12S1R(INH5)*
     &  (MCha2*CFF12S1R(6)*FD211HChaCha(4,6)+CFF12S1L(6)*(-
     &  FD211HChaCha(5,6)+FD211HChaCha(6,6)))+CFF12S1L(INH5)*(MCha2*
     &  CFF12S1L(6)*FD211HChaCha(4,6)+CFF12S1R(6)*(-FD211HChaCha(5,6)+
     &  FD211HChaCha(6,6)))+3*hy(INH5)*(M12*FD211HTT(4,6)*hy(6)+(-
     &  FD211HTT(5,6)+FD211HTT(6,6))*hyc(6))+3*((-FD211HTT(5,6)+
     &  FD211HTT(6,6))*hy(6)+M12*FD211HTT(4,6)*hyc(6))*hyc(INH5))*
     &  Mah(INH5)**4+(CFF12S1R(INH5)*(MCha2*CFF12S1R(6)*
     &  FD111ChaHCha(3,6)-MCha2*CFF12S1R(6)*FD111ChaHCha(3,INH5)+
     &  CFF12S1L(6)*FD111ChaHCha(6,6)-CFF12S1L(6)*(FD111ChaHCha(6,INH5)
     &  +FD111ChaHCha(8,6)-FD111ChaHCha(8,INH5)))+CFF12S1L(INH5)*
     &  (MCha2*CFF12S1L(6)*FD111ChaHCha(3,6)-MCha2*CFF12S1L(6)*
     &  FD111ChaHCha(3,INH5)+CFF12S1R(6)*FD111ChaHCha(6,6)-CFF12S1R(6)*
     &  (FD111ChaHCha(6,INH5)+FD111ChaHCha(8,6)-FD111ChaHCha(8,INH5)))+
     &  3*hy(INH5)*(M12*(FD111THT(3,6)-FD111THT(3,INH5))*hy(6)+
     &  (FD111THT(6,6)-FD111THT(6,INH5)-FD111THT(8,6)+FD111THT(8,INH5))
     &  *hyc(6))+3*((FD111THT(6,6)-FD111THT(6,INH5)-FD111THT(8,6)+
     &  FD111THT(8,INH5))*hy(6)+M12*(FD111THT(3,6)-FD111THT(3,INH5))*
     &  hyc(6))*hyc(INH5))*Mah2(INH5)))/(2.*Mah(INH5)**4*Mah2(INH5))+
     &  (CS1S1V2(6,6)*CS1S1V2(6,INH5)*(4*MCha2*(4*a0tcha+3*MCha2)*
     &  CFF12S1R(6)*CFF12S1R(INH5)*Mah2(INH5)+8*MCha2*A0TNH(INH5)*
     &  CFF12S1R(6)*CFF12S1R(INH5)*Mah2(INH5)+48*a0t1*M12*hy(6)*
     &  hy(INH5)*Mah2(INH5)+36*M12**2*hy(6)*hy(INH5)*Mah2(INH5)+24*M12*
     &  A0TNH(INH5)*hy(6)*hy(INH5)*Mah2(INH5)+24*a0t1*M12*hy(INH5)*
     &  hyc(6)*Mah2(INH5)+30*M12**2*hy(INH5)*hyc(6)*Mah2(INH5)+48*M12*
     &  A0TNH(INH5)*hy(INH5)*hyc(6)*Mah2(INH5)+24*a0t1*M12*hy(6)*
     &  hyc(INH5)*Mah2(INH5)+30*M12**2*hy(6)*hyc(INH5)*Mah2(INH5)+48*
     &  M12*A0TNH(INH5)*hy(6)*hyc(INH5)*Mah2(INH5)+48*a0t1*M12*hyc(6)*
     &  hyc(INH5)*Mah2(INH5)+36*M12**2*hyc(6)*hyc(INH5)*Mah2(INH5)+24*
     &  M12*A0TNH(INH5)*hyc(6)*hyc(INH5)*Mah2(INH5)-2*(2*MCha2*(4*
     &  a0tcha+3*MCha2)*CFF12S1R(6)*CFF12S1R(INH5)+3*hy(INH5)*(2*M12*
     &  (4*a0t1+3*M12)*hy(6)+M12*(4*a0t1+5*M12)*hyc(6))+3*(M12*(4*a0t1+
     &  5*M12)*hy(6)+2*M12*(4*a0t1+3*M12)*hyc(6))*hyc(INH5))*Mah2(INH5)
     &  +6*MCha2*CFF12S1R(6)*CFF12S1R(INH5)*Mah2(INH5)**2+18*M12*hy(6)*
     &  hy(INH5)*Mah2(INH5)**2+12*M12*hy(INH5)*hyc(6)*Mah2(INH5)**2-12*
     &  A0TNH(INH5)*hy(INH5)*hyc(6)*Mah2(INH5)**2+12*M12*hy(6)*
     &  hyc(INH5)*Mah2(INH5)**2-12*A0TNH(INH5)*hy(6)*hyc(INH5)*
     &  Mah2(INH5)**2+18*M12*hyc(6)*hyc(INH5)*Mah2(INH5)**2-9*hy(INH5)*
     &  hyc(6)*Mah2(INH5)**3-9*hy(6)*hyc(INH5)*Mah2(INH5)**3+
     &  CFF12S1L(6)*CFF12S1R(INH5)*(-(Mah2(INH5)**2*(2*MCha2+4*
     &  A0TNH(INH5)+3*Mah2(INH5)))+2*MCha2*(-((4*a0tcha+5*MCha2)*
     &  Mah2(INH5))+(4*a0tcha+5*MCha2+8*A0TNH(INH5))*Mah2(INH5)+3*
     &  Mah2(INH5)**2))+CFF12S1L(INH5)*(2*MCha2*CFF12S1L(6)*(-2*(4*
     &  a0tcha+3*MCha2)*Mah2(INH5)+(8*a0tcha+6*MCha2+4*A0TNH(INH5))*
     &  Mah2(INH5)+3*Mah2(INH5)**2)+CFF12S1R(6)*(-(Mah2(INH5)**2*(2*
     &  MCha2+4*A0TNH(INH5)+3*Mah2(INH5)))+2*MCha2*(-((4*a0tcha+5*
     &  MCha2)*Mah2(INH5))+(4*a0tcha+5*MCha2+8*A0TNH(INH5))*Mah2(INH5)+
     &  3*Mah2(INH5)**2)))))/(32.*Mah(INH5)**4))
              enddo
        INH3=6
        INH5=6
            do INH4=1,5
       selfZ=selfZ+((CS1S1V2(6,6)*CS1S1V2(6,INH4)*((CFF12S1R(INH4)*
     &  (MCha2*CFF12S1R(6)*FD211HChaCha(4,6)+CFF12S1L(6)*(-
     &  FD211HChaCha(5,6)+FD211HChaCha(6,6)))+CFF12S1L(INH4)*(MCha2*
     &  CFF12S1L(6)*FD211HChaCha(4,6)+CFF12S1R(6)*(-FD211HChaCha(5,6)+
     &  FD211HChaCha(6,6)))+3*hy(INH4)*(M12*FD211HTT(4,6)*hy(6)+(-
     &  FD211HTT(5,6)+FD211HTT(6,6))*hyc(6))+3*((-FD211HTT(5,6)+
     &  FD211HTT(6,6))*hy(6)+M12*FD211HTT(4,6)*hyc(6))*hyc(INH4))*
     &  Mah(INH4)**4+(CFF12S1R(INH4)*(MCha2*CFF12S1R(6)*
     &  FD111ChaHCha(3,6)-MCha2*CFF12S1R(6)*FD111ChaHCha(3,INH4)+
     &  CFF12S1L(6)*FD111ChaHCha(6,6)-CFF12S1L(6)*(FD111ChaHCha(6,INH4)
     &  +FD111ChaHCha(8,6)-FD111ChaHCha(8,INH4)))+CFF12S1L(INH4)*
     &  (MCha2*CFF12S1L(6)*FD111ChaHCha(3,6)-MCha2*CFF12S1L(6)*
     &  FD111ChaHCha(3,INH4)+CFF12S1R(6)*FD111ChaHCha(6,6)-CFF12S1R(6)*
     &  (FD111ChaHCha(6,INH4)+FD111ChaHCha(8,6)-FD111ChaHCha(8,INH4)))+
     &  3*hy(INH4)*(M12*(FD111THT(3,6)-FD111THT(3,INH4))*hy(6)+
     &  (FD111THT(6,6)-FD111THT(6,INH4)-FD111THT(8,6)+FD111THT(8,INH4))
     &  *hyc(6))+3*((FD111THT(6,6)-FD111THT(6,INH4)-FD111THT(8,6)+
     &  FD111THT(8,INH4))*hy(6)+M12*(FD111THT(3,6)-FD111THT(3,INH4))*
     &  hyc(6))*hyc(INH4))*Mah2(INH4)))/(2.*Mah(INH4)**4*Mah2(INH4))+
     &  (CS1S1V2(6,6)*CS1S1V2(6,INH4)*(4*MCha2*(4*a0tcha+3*MCha2)*
     &  CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)+8*MCha2*A0TNH(INH4)*
     &  CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)+48*a0t1*M12*hy(6)*
     &  hy(INH4)*Mah2(INH4)+36*M12**2*hy(6)*hy(INH4)*Mah2(INH4)+24*M12*
     &  A0TNH(INH4)*hy(6)*hy(INH4)*Mah2(INH4)+24*a0t1*M12*hy(INH4)*
     &  hyc(6)*Mah2(INH4)+30*M12**2*hy(INH4)*hyc(6)*Mah2(INH4)+48*M12*
     &  A0TNH(INH4)*hy(INH4)*hyc(6)*Mah2(INH4)+24*a0t1*M12*hy(6)*
     &  hyc(INH4)*Mah2(INH4)+30*M12**2*hy(6)*hyc(INH4)*Mah2(INH4)+48*
     &  M12*A0TNH(INH4)*hy(6)*hyc(INH4)*Mah2(INH4)+48*a0t1*M12*hyc(6)*
     &  hyc(INH4)*Mah2(INH4)+36*M12**2*hyc(6)*hyc(INH4)*Mah2(INH4)+24*
     &  M12*A0TNH(INH4)*hyc(6)*hyc(INH4)*Mah2(INH4)-2*(2*MCha2*(4*
     &  a0tcha+3*MCha2)*CFF12S1R(6)*CFF12S1R(INH4)+3*hy(INH4)*(2*M12*
     &  (4*a0t1+3*M12)*hy(6)+M12*(4*a0t1+5*M12)*hyc(6))+3*(M12*(4*a0t1+
     &  5*M12)*hy(6)+2*M12*(4*a0t1+3*M12)*hyc(6))*hyc(INH4))*Mah2(INH4)
     &  +6*MCha2*CFF12S1R(6)*CFF12S1R(INH4)*Mah2(INH4)**2+18*M12*hy(6)*
     &  hy(INH4)*Mah2(INH4)**2+12*M12*hy(INH4)*hyc(6)*Mah2(INH4)**2-12*
     &  A0TNH(INH4)*hy(INH4)*hyc(6)*Mah2(INH4)**2+12*M12*hy(6)*
     &  hyc(INH4)*Mah2(INH4)**2-12*A0TNH(INH4)*hy(6)*hyc(INH4)*
     &  Mah2(INH4)**2+18*M12*hyc(6)*hyc(INH4)*Mah2(INH4)**2-9*hy(INH4)*
     &  hyc(6)*Mah2(INH4)**3-9*hy(6)*hyc(INH4)*Mah2(INH4)**3+
     &  CFF12S1L(6)*CFF12S1R(INH4)*(-(Mah2(INH4)**2*(2*MCha2+4*
     &  A0TNH(INH4)+3*Mah2(INH4)))+2*MCha2*(-((4*a0tcha+5*MCha2)*
     &  Mah2(INH4))+(4*a0tcha+5*MCha2+8*A0TNH(INH4))*Mah2(INH4)+3*
     &  Mah2(INH4)**2))+CFF12S1L(INH4)*(2*MCha2*CFF12S1L(6)*(-2*(4*
     &  a0tcha+3*MCha2)*Mah2(INH4)+(8*a0tcha+6*MCha2+4*A0TNH(INH4))*
     &  Mah2(INH4)+3*Mah2(INH4)**2)+CFF12S1R(6)*(-(Mah2(INH4)**2*(2*
     &  MCha2+4*A0TNH(INH4)+3*Mah2(INH4)))+2*MCha2*(-((4*a0tcha+5*
     &  MCha2)*Mah2(INH4))+(4*a0tcha+5*MCha2+8*A0TNH(INH4))*Mah2(INH4)+
     &  3*Mah2(INH4)**2)))))/(32.*Mah(INH4)**4))
              enddo
        INH5=6
        INH4=6
            do INH3=1,5
       selfZ=selfZ+((CS1S1V2(INH3,6)**2*((MCha2*(CFF12S1L(6)**2+
     &  CFF12S1R(6)**2)*FD211HChaCha(4,6)+2*CFF12S1L(6)*CFF12S1R(6)*(-
     &  FD211HChaCha(5,6)+FD211HChaCha(6,6))+6*(-FD211HTT(5,6)+
     &  FD211HTT(6,6))*hy(6)*hyc(6)+3*M12*FD211HTT(4,6)*(hy(6)**2+
     &  hyc(6)**2))*Mah(INH3)**4+(MCha2*(CFF12S1L(6)**2+CFF12S1R(6)**2)
     &  *FD111ChaHCha(3,6)-MCha2*(CFF12S1L(6)**2+CFF12S1R(6)**2)*
     &  FD111ChaHCha(3,INH3)+2*CFF12S1L(6)*CFF12S1R(6)*
     &  (FD111ChaHCha(6,6)-FD111ChaHCha(6,INH3)-FD111ChaHCha(8,6)+
     &  FD111ChaHCha(8,INH3))+3*M12*FD111THT(3,6)*hy(6)**2+3*hyc(6)*(2*
     &  (FD111THT(6,6)-FD111THT(6,INH3)-FD111THT(8,6)+FD111THT(8,INH3))
     &  *hy(6)+M12*FD111THT(3,6)*hyc(6))-3*M12*FD111THT(3,INH3)*(hy(6)*
     &  *2+hyc(6)**2))*Mah2(INH3)))/(2.*Mah(INH3)**4*Mah2(INH3))+
     &  (CS1S1V2(INH3,6)**2*(-8*a0tcha*MCha2*CFF12S1R(6)**2*Mah2(INH3)-
     &  6*MCha2**2*CFF12S1R(6)**2*Mah2(INH3)+2*MCha2*(4*a0tcha+3*MCha2)
     &  *CFF12S1R(6)**2*Mah2(INH3)+4*MCha2*A0TNH(INH3)*CFF12S1R(6)**2*
     &  Mah2(INH3)+12*M12*A0TNH(INH3)*hyc(6)**2*Mah2(INH3)+3*MCha2*
     &  CFF12S1R(6)**2*Mah2(INH3)**2+9*M12*hyc(6)**2*Mah2(INH3)**2+3*
     &  M12*hy(6)**2*(-2*(4*a0t1+3*M12)*Mah2(INH3)+(8*a0t1+6*M12+4*
     &  A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2)+MCha2*CFF12S1L(6)**2*
     &  (-2*(4*a0tcha+3*MCha2)*Mah2(INH3)+(8*a0tcha+6*MCha2+4*
     &  A0TNH(INH3))*Mah2(INH3)+3*Mah2(INH3)**2)+3*hy(6)*hyc(6)*(-
     &  (Mah2(INH3)**2*(2*M12+4*A0TNH(INH3)+3*Mah2(INH3)))+2*M12*(-((4*
     &  a0t1+5*M12)*Mah2(INH3))+(4*a0t1+5*M12+8*A0TNH(INH3))*Mah2(INH3)
     &  +3*Mah2(INH3)**2))+CFF12S1L(6)*CFF12S1R(6)*(-(Mah2(INH3)**2*(2*
     &  MCha2+4*A0TNH(INH3)+3*Mah2(INH3)))+2*MCha2*(-((4*a0tcha+5*
     &  MCha2)*Mah2(INH3))+(4*a0tcha+5*MCha2+8*A0TNH(INH3))*Mah2(INH3)+
     &  3*Mah2(INH3)**2))))/(16.*Mah(INH3)**4))
              enddo
        INH3=6
       selfZ=selfZ+((CS1S1V2(6,6)**2*((3-4*logx)*MCha2*CFF12S1L(6)**2+
     &  4*(1-4*logx)*MCha2*CFF12S1L(6)*CFF12S1R(6)-(-3+4*logx)*(MCha2*
     &  CFF12S1R(6)**2+3*M12*hy(6)**2)+12*(1-4*logx)*M12*hy(6)*hyc(6)+
     &  3*(3-4*logx)*M12*hyc(6)**2))/16.-(CS1S1V2(6,6)**2*(MCha2*
     &  (CFF12S1L(6)**2+CFF12S1R(6)**2)*FD311HChaCha(3,6)+2*CFF12S1L(6)
     &  *CFF12S1R(6)*(-FD311HChaCha(4,6)+FD311HChaCha(6,6))+6*(-
     &  FD311HTT(4,6)+FD311HTT(6,6))*hy(6)*hyc(6)+3*M12*FD311HTT(3,6)*
     &  (hy(6)**2+hyc(6)**2)))/2.)


       ! diagram  2  
       do INe3=1,3
       do INe4=1,3
        INH3=6
        INH4=6
            do INH5=1,5
       selfZ=selfZ+((CS1S1V2(6,6)*CS1S1V2(6,INH5)*(-
     &  ((CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH5))*
     &  ((FD211HNeuNeu(5,6,INe3,INe4)-FD211HNeuNeu(6,6,INe3,INe4))*
     &  Mah(INH5)**4+(-FD111ChiHChi(6,INe3,6,INe4)+
     &  FD111ChiHChi(6,INe3,INH5,INe4)+FD111ChiHChi(8,INe3,6,INe4)-
     &  FD111ChiHChi(8,INe3,INH5,INe4))*Mah2(INH5)))+
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,INH5)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH5))*
     &  (FD211HNeuNeu(4,6,INe3,INe4)*Mah(INH5)**4+
     &  (FD111ChiHChi(3,INe3,6,INe4)-FD111ChiHChi(3,INe3,INH5,INe4))*
     &  Mah2(INH5))*MNeu(INe3)*MNeu(INe4)))/(4.*Mah(INH5)**4*Mah2(INH5)
     &  )+(CS1S1V2(6,6)*CS1S1V2(6,INH5)*(-4*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*MNeu(INe4)*(2*A0TNeu(INe4)
     &  *MNeu2(INe3)+(2*A0TNeu(INe3)+MNeu2(INe3))*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH5))*Mah2(INH5)*
     &  (MNeu2(INe3)*(4*A0TNeu(INe3)+8*A0TNeu(INe4)+3*MNeu2(INe3)-
     &  MNeu2(INe4))+(-4*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))*
     &  MNeu2(INe4)-2*MNeu2(INe4)**2)+2*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,INH5)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH5))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe4)
     &  *(Mah2(INH5)+MNeu2(INe3))+Mah2(INH5)*(4*A0TNH(INH5)+3*
     &  (Mah2(INH5)+MNeu2(INe3)))+(3*Mah2(INH5)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH5)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,INH5)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH5))*Mah2(INH5)*
     &  MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*
     &  (MNeu2(INe3)+MNeu2(INe4)))-2*(CFF11S1L(INe4,INe3,INH5)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH5))*Mah2(INH5)*MNeu2(INe3)*(4*
     &  A0TNeu(INe3)+4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))+
     &  (CFF11S1L(INe4,INe3,INH5)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,INH5))*(-(Mah2(INH5)*
     &  (4*A0TNH(INH5)*Mah2(INH5)+3*(Mah2(INH5)+MNeu2(INe3))**2))+2*
     &  Mah2(INH5)**2*(MNeu2(INe3)-MNeu2(INe4))-2*MNeu2(INe3)*
     &  (Mah2(INH5)+2*MNeu2(INe3))*MNeu2(INe4)+3*Mah2(INH5)*MNeu2(INe4)
     &  **2-4*A0TNeu(INe4)*(2*Mah2(INH5)**2+2*Mah2(INH5)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2-Mah2(INH5)*MNeu2(INe4))+4*A0TNeu(INe3)*
     &  (Mah2(INH5)**2-Mah2(INH5)*(Mah2(INH5)+MNeu2(INe3))-2*
     &  MNeu2(INe3)*MNeu2(INe4)))+2*(CFF11S1L(INe4,INe3,INH5)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,INH5))*(4*A0TNeu(INe3)*Mah2(INH5)*
     &  MNeu2(INe3)+4*A0TNeu(INe4)*(Mah2(INH5)**2+MNeu(INe3)**4+
     &  Mah2(INH5)*MNeu2(INe3))+2*(Mah2(INH5)**2+MNeu(INe3)**4)*
     &  MNeu2(INe4)+4*A0TNH(INH5)*Mah2(INH5)*(MNeu2(INe3)+MNeu2(INe4))+
     &  MNeu2(INe3)*(4*A0TNeu(INe3)*MNeu2(INe4)+3*Mah2(INH5)*
     &  (Mah2(INH5)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*Mah(INH5)**4))
              enddo
        INH3=6
        INH5=6
            do INH4=1,5
       selfZ=selfZ+((CS1S1V2(6,6)*CS1S1V2(6,INH4)*(-
     &  ((CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,6))*
     &  ((FD211HNeuNeu(5,6,INe3,INe4)-FD211HNeuNeu(6,6,INe3,INe4))*
     &  Mah(INH4)**4+(-FD111ChiHChi(6,INe3,6,INe4)+
     &  FD111ChiHChi(6,INe3,INH4,INe4)+FD111ChiHChi(8,INe3,6,INe4)-
     &  FD111ChiHChi(8,INe3,INH4,INe4))*Mah2(INH4)))+
     &  (CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,6))*
     &  (FD211HNeuNeu(4,6,INe3,INe4)*Mah(INH4)**4+
     &  (FD111ChiHChi(3,INe3,6,INe4)-FD111ChiHChi(3,INe3,INH4,INe4))*
     &  Mah2(INH4))*MNeu(INe3)*MNeu(INe4)))/(4.*Mah(INH4)**4*Mah2(INH4)
     &  )+(CS1S1V2(6,6)*CS1S1V2(6,INH4)*(-4*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,6))*MNeu(INe3)*MNeu(INe4)*(2*A0TNeu(INe4)*
     &  MNeu2(INe3)+(2*A0TNeu(INe3)+MNeu2(INe3))*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,6))*Mah2(INH4)*
     &  (MNeu2(INe3)*(4*A0TNeu(INe3)+8*A0TNeu(INe4)+3*MNeu2(INe3)-
     &  MNeu2(INe4))+(-4*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))*
     &  MNeu2(INe4)-2*MNeu2(INe4)**2)+2*(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,6))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe4)*
     &  (Mah2(INH4)+MNeu2(INe3))+Mah2(INH4)*(4*A0TNH(INH4)+3*
     &  (Mah2(INH4)+MNeu2(INe3)))+(3*Mah2(INH4)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH4)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe3,INe4,INH4)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,6))*Mah2(INH4)*
     &  MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*
     &  (MNeu2(INe3)+MNeu2(INe4)))-2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,6))*Mah2(INH4)*MNeu2(INe3)*(4*A0TNeu(INe3)+
     &  4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,INH4)+
     &  CFF11S1L(INe3,INe4,INH4)*CFF11S1R(INe4,INe3,6))*(-(Mah2(INH4)*
     &  (4*A0TNH(INH4)*Mah2(INH4)+3*(Mah2(INH4)+MNeu2(INe3))**2))+2*
     &  Mah2(INH4)**2*(MNeu2(INe3)-MNeu2(INe4))-2*MNeu2(INe3)*
     &  (Mah2(INH4)+2*MNeu2(INe3))*MNeu2(INe4)+3*Mah2(INH4)*MNeu2(INe4)
     &  **2-4*A0TNeu(INe4)*(2*Mah2(INH4)**2+2*Mah2(INH4)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2-Mah2(INH4)*MNeu2(INe4))+4*A0TNeu(INe3)*
     &  (Mah2(INH4)**2-Mah2(INH4)*(Mah2(INH4)+MNeu2(INe3))-2*
     &  MNeu2(INe3)*MNeu2(INe4)))+2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,6))*(4*A0TNeu(INe3)*Mah2(INH4)*MNeu2(INe3)+
     &  4*A0TNeu(INe4)*(Mah2(INH4)**2+MNeu(INe3)**4+Mah2(INH4)*
     &  MNeu2(INe3))+2*(Mah2(INH4)**2+MNeu(INe3)**4)*MNeu2(INe4)+4*
     &  A0TNH(INH4)*Mah2(INH4)*(MNeu2(INe3)+MNeu2(INe4))+MNeu2(INe3)*
     &  (4*A0TNeu(INe3)*MNeu2(INe4)+3*Mah2(INH4)*(Mah2(INH4)+
     &  MNeu2(INe3)+MNeu2(INe4))))))/(64.*Mah(INH4)**4))
              enddo
        INH5=6
        INH4=6
            do INH3=1,5
       selfZ=selfZ+((CS1S1V2(INH3,6)**2*(-((CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*((FD211HNeuNeu(5,6,INe3,INe4)-
     &  FD211HNeuNeu(6,6,INe3,INe4))*Mah(INH3)**4+(-
     &  FD111ChiHChi(6,INe3,6,INe4)+FD111ChiHChi(6,INe3,INH3,INe4)+
     &  FD111ChiHChi(8,INe3,6,INe4)-FD111ChiHChi(8,INe3,INH3,INe4))*
     &  Mah2(INH3)))+(CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*
     &  (FD211HNeuNeu(4,6,INe3,INe4)*Mah(INH3)**4+
     &  (FD111ChiHChi(3,INe3,6,INe4)-FD111ChiHChi(3,INe3,INH3,INe4))*
     &  Mah2(INH3))*MNeu(INe3)*MNeu(INe4)))/(4.*Mah(INH3)**4*Mah2(INH3)
     &  )+(CS1S1V2(INH3,6)**2*(-4*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*MNeu(INe3)*MNeu(INe4)*(2*A0TNeu(INe4)*
     &  MNeu2(INe3)+(2*A0TNeu(INe3)+MNeu2(INe3))*MNeu2(INe4))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*Mah2(INH3)*
     &  (MNeu2(INe3)*(4*A0TNeu(INe3)+8*A0TNeu(INe4)+3*MNeu2(INe3)-
     &  MNeu2(INe4))+(-4*A0TNeu(INe4)+3*MNeu2(INe3)-MNeu2(INe4))*
     &  MNeu2(INe4)-2*MNeu2(INe4)**2)+2*(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe4)*
     &  (Mah2(INH3)+MNeu2(INe3))+Mah2(INH3)*(4*A0TNH(INH3)+3*
     &  (Mah2(INH3)+MNeu2(INe3)))+(3*Mah2(INH3)+2*MNeu2(INe3))*
     &  MNeu2(INe4)+4*A0TNeu(INe3)*(Mah2(INH3)+MNeu2(INe4)))-2*
     &  (CFF11S1L(INe3,INe4,6)*CFF11S1L(INe4,INe3,6)+
     &  CFF11S1R(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*Mah2(INH3)*
     &  MNeu(INe3)*MNeu(INe4)*(4*A0TNeu(INe3)+4*A0TNeu(INe4)+3*
     &  (MNeu2(INe3)+MNeu2(INe4)))-2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*Mah2(INH3)*MNeu2(INe3)*(4*A0TNeu(INe3)+
     &  4*A0TNeu(INe4)+3*(MNeu2(INe3)+MNeu2(INe4)))+
     &  (CFF11S1L(INe4,INe3,6)*CFF11S1R(INe3,INe4,6)+
     &  CFF11S1L(INe3,INe4,6)*CFF11S1R(INe4,INe3,6))*(-(Mah2(INH3)*(4*
     &  A0TNH(INH3)*Mah2(INH3)+3*(Mah2(INH3)+MNeu2(INe3))**2))+2*
     &  Mah2(INH3)**2*(MNeu2(INe3)-MNeu2(INe4))-2*MNeu2(INe3)*
     &  (Mah2(INH3)+2*MNeu2(INe3))*MNeu2(INe4)+3*Mah2(INH3)*MNeu2(INe4)
     &  **2-4*A0TNeu(INe4)*(2*Mah2(INH3)**2+2*Mah2(INH3)*MNeu2(INe3)+2*
     &  MNeu2(INe3)**2-Mah2(INH3)*MNeu2(INe4))+4*A0TNeu(INe3)*
     &  (Mah2(INH3)**2-Mah2(INH3)*(Mah2(INH3)+MNeu2(INe3))-2*
     &  MNeu2(INe3)*MNeu2(INe4)))+2*(CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*(4*A0TNeu(INe3)*Mah2(INH3)*MNeu2(INe3)+
     &  4*A0TNeu(INe4)*(Mah2(INH3)**2+MNeu(INe3)**4+Mah2(INH3)*
     &  MNeu2(INe3))+2*(Mah2(INH3)**2+MNeu(INe3)**4)*MNeu2(INe4)+4*
     &  A0TNH(INH3)*Mah2(INH3)*(MNeu2(INe3)+MNeu2(INe4))+MNeu2(INe3)*
     &  (4*A0TNeu(INe3)*MNeu2(INe4)+3*Mah2(INH3)*(Mah2(INH3)+MNeu2(INe3)+MNeu2(INe4))))))/(64.*Mah(INH3)**4))
              enddo
        INH3=6
       selfZ=selfZ+((CS1S1V2(6,6)**2*((CFF11S1L(INe4,INe3,6)*
     &  CFF11S1R(INe3,INe4,6)+CFF11S1L(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*(FD311HChiChi(4,6,INe3,INe4)-
     &  FD311HChiChi(6,6,INe3,INe4))-(CFF11S1L(INe3,INe4,6)*
     &  CFF11S1L(INe4,INe3,6)+CFF11S1R(INe3,INe4,6)*
     &  CFF11S1R(INe4,INe3,6))*FD311HChiChi(3,6,INe3,INe4)*MNeu(INe3)*
     &  MNeu(INe4)))/4.-(CS1S1V2(6,6)**2*(CFF11S1R(INe3,INe4,6)*((-3+4*
     &  logx)*CFF11S1R(INe4,INe3,6)*MNeu(INe3)*MNeu(INe4)+
     &  CFF11S1L(INe4,INe3,6)*(-2*MNeu2(INe3)+(1-2*logx)*MNeu2(INe3)-
     &  MNeu2(INe4)+2*logx*(3*MNeu2(INe3)+2*MNeu2(INe4))))+
     &  CFF11S1L(INe3,INe4,6)*((-3+4*logx)*CFF11S1L(INe4,INe3,6)*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1R(INe4,INe3,6)*(-2*MNeu2(INe3)+(1-
     &  2*logx)*MNeu2(INe3)-MNeu2(INe4)+2*logx*(3*MNeu2(INe3)+2*
     &  MNeu2(INe4))))))/32.)
       enddo 
       enddo 
 

       ! diagram  3  
        ICH3=1
        ICH4=1
            ICH5=2
       selfZ=selfZ+((3*C2W**2*indexdelta(1,1)*(CTBS3(ICH5)*CTBS3C(1)*
     &  indexdelta(1,ICH5)+CTBS3(1)*CTBS3C(ICH5)*indexdelta(ICH5,1))*
     &  (FD111THpB(6,1)-FD111THpB(6,ICH5)-FD111THpB(8,1)+
     &  FD111THpB(8,ICH5)+(-FD211HpTB(5,1)+FD211HpTB(6,1))*
     &  MassHpm(ICH5)**2))/(2.*S2W**2*MassHpm(ICH5)**4)+(3*C2W**2*
     &  indexdelta(1,1)*(CTBS3(ICH5)*CTBS3C(1)*indexdelta(1,ICH5)+
     &  CTBS3(1)*CTBS3C(ICH5)*indexdelta(ICH5,1))*(8*M12*A0THpN(ICH5)*
     &  MassHpm(ICH5)**2+2*(M12-2*A0THpN(ICH5))*MassHpm(ICH5)**4-3*
     &  MassHpm(ICH5)**6))/(32.*S2W**2*MassHpm(ICH5)**4))

        ICH3=1
        ICH5=1
            ICH4=2
       selfZ=selfZ+((3*C2W**2*indexdelta(1,1)*(CTBS3(ICH4)*CTBS3C(1)*
     &  indexdelta(1,ICH4)+CTBS3(1)*CTBS3C(ICH4)*indexdelta(ICH4,1))*
     &  (FD111THpB(6,1)-FD111THpB(6,ICH4)-FD111THpB(8,1)+
     &  FD111THpB(8,ICH4)+(-FD211HpTB(5,1)+FD211HpTB(6,1))*
     &  MassHpm(ICH4)**2))/(2.*S2W**2*MassHpm(ICH4)**4)+(3*C2W**2*
     &  indexdelta(1,1)*(CTBS3(ICH4)*CTBS3C(1)*indexdelta(1,ICH4)+
     &  CTBS3(1)*CTBS3C(ICH4)*indexdelta(ICH4,1))*(8*M12*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2+2*(M12-2*A0THpN(ICH4))*MassHpm(ICH4)**4-3*
     &  MassHpm(ICH4)**6))/(32.*S2W**2*MassHpm(ICH4)**4))

        ICH5=1
        ICH4=1
            ICH3=2
       selfZ=selfZ+((3*C2W**2*CTBS3(1)*CTBS3C(1)*indexdelta(1,ICH3)*
     &  indexdelta(ICH3,1)*(FD111THpB(6,1)-FD111THpB(6,ICH3)-
     &  FD111THpB(8,1)+FD111THpB(8,ICH3)+(-FD211HpTB(5,1)+
     &  FD211HpTB(6,1))*MassHpm(ICH3)**2))/(S2W**2*MassHpm(ICH3)**4)+
     &  (3*C2W**2*CTBS3(1)*CTBS3C(1)*indexdelta(1,ICH3)*
     &  indexdelta(ICH3,1)*(8*M12*A0THpN(ICH3)*MassHpm(ICH3)**2+2*(M12-
     &  2*A0THpN(ICH3))*MassHpm(ICH3)**4-3*MassHpm(ICH3)**6))/(16.*S2W*
     &  *2*MassHpm(ICH3)**4))


        ICH5=1
        ICH4=1
        ICH3=1
       selfZ=selfZ+((3*C2W**2*(1-4*logx)*M12*CTBS3(1)*CTBS3C(1)*
     &  indexdelta(1,1)**2)/(8.*S2W**2)+(3*C2W**2*CTBS3(1)*CTBS3C(1)*
     &  (FD311HpTB(4,1)-FD311HpTB(6,1))*indexdelta(1,1)**2)/S2W**2)


       ! diagram  4 

       do INe3=1,3
        ICH3=1
        ICH4=1
            ICH5=2
       selfZ=selfZ+((C2W**2*indexdelta(1,1)*(((CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))+CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,ICH5)))*indexdelta(1,ICH5)+
     &  (CF11F12S3L(INe3,ICH5)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,ICH5)*DCONJG(CF11F12S3R(INe3,1)))*
     &  indexdelta(ICH5,1))*(FD111ChiHpCha(6,INe3,1)-
     &  FD111ChiHpCha(6,INe3,ICH5)-FD111ChiHpCha(8,INe3,1)+
     &  FD111ChiHpCha(8,INe3,ICH5)+(-FD211HpChiCha(5,1,INe3)+
     &  FD211HpChiCha(6,1,INe3))*MassHpm(ICH5)**2)+MCha*
     &  ((CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,ICH5))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,ICH5)))*
     &  indexdelta(1,ICH5)+(CF11F12S3R(INe3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,1)))*indexdelta(ICH5,1))*
     &  (FD111ChiHpCha(3,INe3,1)-FD111ChiHpCha(3,INe3,ICH5)+
     &  FD211HpChiCha(4,1,INe3)*MassHpm(ICH5)**2)*MNeu(INe3)))/(2.*S2W*
     &  *2*MassHpm(ICH5)**4)+(C2W**2*indexdelta(1,1)*
     &  (CF11F12S3L(INe3,1)*indexdelta(1,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(4*A0THpN(ICH5)*MassHpm(ICH5)**2+
     &  3*MassHpm(ICH5)**4)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH5))*(-
     &  3*MassHpm(ICH5)**6+8*A0THpN(ICH5)*MassHpm(ICH5)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH5)**4*(MCha2-2*A0THpN(ICH5)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+CF11F12S3R(INe3,1)*indexdelta(1,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*(4*A0THpN(ICH5)*MassHpm(ICH5)**2+
     &  3*MassHpm(ICH5)**4)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH5))*(-
     &  3*MassHpm(ICH5)**6+8*A0THpN(ICH5)*MassHpm(ICH5)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH5)**4*(MCha2-2*A0THpN(ICH5)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+indexdelta(ICH5,1)*(CF11F12S3L(INe3,ICH5)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,1))*(4*A0THpN(ICH5)*MassHpm(ICH5)**2+3*
     &  MassHpm(ICH5)**4)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,1))*(-3*
     &  MassHpm(ICH5)**6+8*A0THpN(ICH5)*MassHpm(ICH5)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH5)**4*(MCha2-2*A0THpN(ICH5)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+CF11F12S3R(INe3,ICH5)*(2*MCha*DCONJG(CF11F12S3L(INe3,1))*(4*
     &  A0THpN(ICH5)*MassHpm(ICH5)**2+3*MassHpm(ICH5)**4)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,1))*(-3*MassHpm(ICH5)**6+8*A0THpN(ICH5)*
     &  MassHpm(ICH5)**2*(MCha2+MNeu2(INe3))+2*MassHpm(ICH5)**4*(MCha2-
     &  2*A0THpN(ICH5)+MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2))))))/(32.*S2W**2*MassHpm(ICH5)**4))
        ICH3=1
        ICH5=1
            ICH4=2
       selfZ=selfZ+((C2W**2*indexdelta(1,1)*(((CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*indexdelta(1,ICH4)+
     &  (CF11F12S3L(INe3,ICH4)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,ICH4)*DCONJG(CF11F12S3R(INe3,1)))*
     &  indexdelta(ICH4,1))*(FD111ChiHpCha(6,INe3,1)-
     &  FD111ChiHpCha(6,INe3,ICH4)-FD111ChiHpCha(8,INe3,1)+
     &  FD111ChiHpCha(8,INe3,ICH4)+(-FD211HpChiCha(5,1,INe3)+
     &  FD211HpChiCha(6,1,INe3))*MassHpm(ICH4)**2)+MCha*
     &  ((CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,ICH4))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,ICH4)))*
     &  indexdelta(1,ICH4)+(CF11F12S3R(INe3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,1)))*indexdelta(ICH4,1))*
     &  (FD111ChiHpCha(3,INe3,1)-FD111ChiHpCha(3,INe3,ICH4)+
     &  FD211HpChiCha(4,1,INe3)*MassHpm(ICH4)**2)*MNeu(INe3)))/(2.*S2W*
     &  *2*MassHpm(ICH4)**4)+(C2W**2*indexdelta(1,1)*
     &  (CF11F12S3L(INe3,1)*indexdelta(1,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2+
     &  3*MassHpm(ICH4)**4)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH4))*(-
     &  3*MassHpm(ICH4)**6+8*A0THpN(ICH4)*MassHpm(ICH4)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-2*A0THpN(ICH4)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+CF11F12S3R(INe3,1)*indexdelta(1,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2+
     &  3*MassHpm(ICH4)**4)*MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH4))*(-
     &  3*MassHpm(ICH4)**6+8*A0THpN(ICH4)*MassHpm(ICH4)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-2*A0THpN(ICH4)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+indexdelta(ICH4,1)*(CF11F12S3L(INe3,ICH4)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,1))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH4)**4)*MNeu(INe3)+DCONJG(CF11F12S3L(INe3,1))*(-3*
     &  MassHpm(ICH4)**6+8*A0THpN(ICH4)*MassHpm(ICH4)**2*(MCha2+
     &  MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-2*A0THpN(ICH4)+
     &  MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))
     &  )+CF11F12S3R(INe3,ICH4)*(2*MCha*DCONJG(CF11F12S3L(INe3,1))*(4*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2+3*MassHpm(ICH4)**4)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,1))*(-3*MassHpm(ICH4)**6+8*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2*(MCha2+MNeu2(INe3))+2*MassHpm(ICH4)**4*(MCha2-
     &  2*A0THpN(ICH4)+MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2))))))/(32.*S2W**2*MassHpm(ICH4)**4))
        ICH5=1
        ICH4=1
            ICH3=2
       selfZ=selfZ+((C2W**2*indexdelta(1,ICH3)*indexdelta(ICH3,1)*
     &  ((CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD111ChiHpCha(6,INe3,1)-FD111ChiHpCha(6,INe3,ICH3)-
     &  FD111ChiHpCha(8,INe3,1)+FD111ChiHpCha(8,INe3,ICH3)+(-
     &  FD211HpChiCha(5,1,INe3)+FD211HpChiCha(6,1,INe3))*MassHpm(ICH3)*
     &  *2)+MCha*(CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD111ChiHpCha(3,INe3,1)-FD111ChiHpCha(3,INe3,ICH3)+
     &  FD211HpChiCha(4,1,INe3)*MassHpm(ICH3)**2)*MNeu(INe3)))/(S2W**2*
     &  MassHpm(ICH3)**4)+(C2W**2*indexdelta(1,ICH3)*indexdelta(ICH3,1)
     &  *(2*MCha*(CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*(4*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2+3*MassHpm(ICH3)**4)*MNeu(INe3)+
     &  Abs(CF11F12S3L(INe3,1))**2*(-3*MassHpm(ICH3)**6+8*A0THpN(ICH3)*
     &  MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+2*MassHpm(ICH3)**4*(MCha2-
     &  2*A0THpN(ICH3)+MNeu2(INe3))+4*(2*a0tcha+MCha2)*(MNeu(INe3)**4-
     &  MNeu2(INe3)**2))+Abs(CF11F12S3R(INe3,1))**2*(-3*MassHpm(ICH3)**
     &  6+8*A0THpN(ICH3)*MassHpm(ICH3)**2*(MCha2+MNeu2(INe3))+2*
     &  MassHpm(ICH3)**4*(MCha2-2*A0THpN(ICH3)+MNeu2(INe3))+4*(2*
     &  a0tcha+MCha2)*(MNeu(INe3)**4-MNeu2(INe3)**2))))/(16.*S2W**2*
     &  MassHpm(ICH3)**4))
        ICH3=1
       selfZ=selfZ+((C2W**2*indexdelta(1,1)**2*((CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*(FD311HpChiCha(4,1,INe3)-
     &  FD311HpChiCha(6,1,INe3))-MCha*(CF11F12S3R(INe3,1)*
     &  DCONJG(CF11F12S3L(INe3,1))+CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1)))*FD311HpChiCha(3,1,INe3)*MNeu(INe3))
     &  )/S2W**2-(C2W**2*indexdelta(1,1)**2*((-3+4*logx)*MCha*
     &  (CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3L(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*MNeu(INe3)+
     &  Abs(CF11F12S3L(INe3,1))**2*(2*logx*MCha2+(-1+2*logx)*MCha2+(1-
     &  2*logx)*MNeu2(INe3)+(-2+6*logx)*MNeu2(INe3))+
     &  Abs(CF11F12S3R(INe3,1))**2*(2*logx*MCha2+(-1+2*logx)*MCha2+(1-
     &  2*logx)*MNeu2(INe3)+(-2+6*logx)*MNeu2(INe3))))/(8.*S2W**2))
       enddo 

c
c topo7-GBC
c

       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do INH6=1,6
       do INH7=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH7))*Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,INH7)*
     &  CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH7)*
     &  (FD111HHH(4,INH7,INH5,INH6)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HHH(4,INH3,INH5,INH6)*(Mah(INH4)**2-Mah(INH7)**2)+
     &  FD111HHH(4,INH4,INH5,INH6)*(-Mah(INH3)**2+Mah(INH7)**2)))/(8.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH7))*(Mah(INH4)-Mah(INH7))*(Mah(INH3)+Mah(INH7))*
     &  (Mah(INH4)+Mah(INH7)))+(CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH7)*
     &  (-((4*A0TNH(INH3)*Mah2(INH3)+4*A0TNH(INH6)*Mah2(INH3)+3*
     &  Mah2(INH3)**2+4*A0TNH(INH6)*Mah2(INH5)+3*Mah2(INH3)*Mah2(INH5)+
     &  3*Mah2(INH3)*Mah2(INH6)+2*Mah2(INH5)*Mah2(INH6)+4*A0TNH(INH5)*
     &  (Mah2(INH3)+Mah2(INH6)))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+
     &  Mah(INH4))*(Mah(INH3)-Mah(INH7))*(Mah(INH3)+Mah(INH7))))+(4*
     &  A0TNH(INH4)*Mah2(INH4)+4*A0TNH(INH6)*Mah2(INH4)+3*Mah2(INH4)**
     &  2+4*A0TNH(INH6)*Mah2(INH5)+3*Mah2(INH4)*Mah2(INH5)+3*Mah2(INH4)
     &  *Mah2(INH6)+2*Mah2(INH5)*Mah2(INH6)+4*A0TNH(INH5)*(Mah2(INH4)+
     &  Mah2(INH6)))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*
     &  (Mah(INH4)-Mah(INH7))*(Mah(INH4)+Mah(INH7)))+(2*Mah2(INH5)*
     &  Mah2(INH6)+4*A0TNH(INH7)*Mah2(INH7)+3*Mah2(INH5)*Mah2(INH7)+3*
     &  Mah2(INH6)*Mah2(INH7)+3*Mah2(INH7)**2+4*A0TNH(INH6)*(Mah2(INH5)
     &  +Mah2(INH7))+4*A0TNH(INH5)*(Mah2(INH6)+Mah2(INH7)))/((Mah(INH3)
     &  -Mah(INH7))*(Mah(INH3)+Mah(INH7))*(-Mah(INH4)+Mah(INH7))*
     &  (Mah(INH4)+Mah(INH7)))))/64.)
           else
             if( Abs(-Mah(INH3) + Mah(INH7))*Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH5,INH6)*CS1S1S1(INH5,INH6,INH7)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH7)*(-
     &  FD111HHH(4,INH3,INH5,INH6)+FD111HHH(4,INH7,INH5,INH6)+
     &  FD211HHH(4,INH3,INH5,INH6)*(Mah(INH3)**2-Mah(INH7)**2)))/(8.*
     &  (Mah(INH3)**2-Mah(INH7)**2)**2)+(CS1S1S1(INH3,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH7)*
     &  (Mah2(INH3)**2-4*A0TNH(INH7)*Mah2(INH7)+2*Mah2(INH3)*Mah2(INH7)
     &  -3*Mah2(INH7)**2+4*A0TNH(INH3)*(-Mah2(INH3)+2*Mah2(INH7))))
     &  /(64.*(Mah2(INH3)-Mah2(INH7))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,INH3)*
     &  CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*(-
     &  FD111HHH(4,INH3,INH5,INH6)+FD111HHH(4,INH4,INH5,INH6)+
     &  FD211HHH(4,INH3,INH5,INH6)*(Mah(INH3)**2-Mah(INH4)**2)))/(8.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH3)*CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*
     &  (Mah2(INH3)**2-4*A0TNH(INH4)*Mah2(INH4)+2*Mah2(INH3)*Mah2(INH4)
     &  -3*Mah2(INH4)**2+4*A0TNH(INH3)*(-Mah2(INH3)+2*Mah2(INH4))))
     &  /(64.*(Mah2(INH3)-Mah2(INH4))**2))
             endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH7)) .gt. 1D-15) then 
             if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,INH4)*
     &  CS1S1V2(INH3,INH4)**2*(FD111HHH(4,INH3,INH5,INH6)-
     &  FD111HHH(4,INH4,INH5,INH6)+FD211HHH(4,INH4,INH5,INH6)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)))/(8.*(Mah(INH3)**2-Mah(INH4)**2)**
     &  2)+(CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,INH4)*
     &  CS1S1V2(INH3,INH4)**2*(-4*A0TNH(INH3)*Mah2(INH3)+8*A0TNH(INH4)*
     &  Mah2(INH3)-3*Mah2(INH3)**2-4*A0TNH(INH4)*Mah2(INH4)+2*
     &  Mah2(INH3)*Mah2(INH4)+Mah2(INH4)**2))/(64.*(Mah2(INH3)-
     &  Mah2(INH4))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH7)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1S1(INH3,INH5,INH6)*CS1S1S1(INH5,INH6,INH3)*
     &  CS1S1V2(INH3,INH3)**2*FD311HHH(3,INH3,INH5,INH6))/8.+
     &  (CS1S1S1(INH3,INH5,INH6)*CS1S1S1(INH5,INH6,INH3)*
     &  CS1S1V2(INH3,INH3)**2*(-4*A0TNH(INH3)+3*Mah2(INH3)))/(64.*
     &  Mah2(INH3)))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  CS1S3S3(INH4,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*
     &  (FD111HHpHp(4,INH5,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HHpHp(4,INH3,ICH3,ICH4)*(Mah(INH4)**2-Mah(INH5)**2)+
     &  FD111HHpHp(4,INH4,ICH3,ICH4)*(-Mah(INH3)**2+Mah(INH5)**2)))
     &  /(4.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  CS1S3S3(INH4,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*(-((4*
     &  A0TNH(INH3)*Mah2(INH3)+3*Mah2(INH3)**2+3*Mah2(INH3)*
     &  MassHpm(ICH3)**2+4*A0THpN(ICH4)*(Mah2(INH3)+MassHpm(ICH3)**2)+
     &  3*Mah2(INH3)*MassHpm(ICH4)**2+2*MassHpm(ICH3)**2*MassHpm(ICH4)*
     &  *2+4*A0THpN(ICH3)*(Mah2(INH3)+MassHpm(ICH4)**2))/((Mah(INH3)-
     &  Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-Mah(INH5))*
     &  (Mah(INH3)+Mah(INH5))))+(4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)*
     &  *2+3*Mah2(INH4)*MassHpm(ICH3)**2+4*A0THpN(ICH4)*(Mah2(INH4)+
     &  MassHpm(ICH3)**2)+3*Mah2(INH4)*MassHpm(ICH4)**2+2*MassHpm(ICH3)
     &  **2*MassHpm(ICH4)**2+4*A0THpN(ICH3)*(Mah2(INH4)+MassHpm(ICH4)**
     &  2))/((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))+(4*A0TNH(INH5)*Mah2(INH5)+3*
     &  Mah2(INH5)**2+3*Mah2(INH5)*MassHpm(ICH3)**2+4*A0THpN(ICH4)*
     &  (Mah2(INH5)+MassHpm(ICH3)**2)+3*Mah2(INH5)*MassHpm(ICH4)**2+2*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*A0THpN(ICH3)*(Mah2(INH5)+
     &  MassHpm(ICH4)**2))/((Mah(INH3)-Mah(INH5))*(Mah(INH3)+Mah(INH5))
     &  *(-Mah(INH4)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))))/32.)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH5)*
     &  CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*(-
     &  FD111HHpHp(4,INH3,ICH3,ICH4)+FD111HHpHp(4,INH5,ICH3,ICH4)+
     &  FD211HHpHp(4,INH3,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH5)**2)))/(4.*
     &  (Mah(INH3)**2-Mah(INH5)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH5)*CS1S3S3(INH3,ICH4,ICH3)*
     &  CS1S3S3(INH5,ICH3,ICH4)*(-4*A0TNH(INH3)*Mah2(INH3)+Mah2(INH3)**
     &  2+8*A0TNH(INH3)*Mah2(INH5)-4*A0TNH(INH5)*Mah2(INH5)+2*
     &  Mah2(INH3)*Mah2(INH5)-3*Mah2(INH5)**2))/(32.*(Mah2(INH3)-
     &  Mah2(INH5))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*(-
     &  FD111HHpHp(4,INH3,ICH3,ICH4)+FD111HHpHp(4,INH4,ICH3,ICH4)+
     &  FD211HHpHp(4,INH3,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH4)**2)))/(4.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(-4*A0TNH(INH3)*Mah2(INH3)+Mah2(INH3)**
     &  2+8*A0TNH(INH3)*Mah2(INH4)-4*A0TNH(INH4)*Mah2(INH4)+2*
     &  Mah2(INH3)*Mah2(INH4)-3*Mah2(INH4)**2))/(32.*(Mah2(INH3)-
     &  Mah2(INH4))**2))
             endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH4)**2*CS1S3S3(INH4,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(FD111HHpHp(4,INH3,ICH3,ICH4)-
     &  FD111HHpHp(4,INH4,ICH3,ICH4)+FD211HHpHp(4,INH4,ICH3,ICH4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)))/(4.*(Mah(INH3)**2-Mah(INH4)**2)**
     &  2)+(CS1S1V2(INH3,INH4)**2*CS1S3S3(INH4,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(-4*A0TNH(INH3)*Mah2(INH3)+8*
     &  A0TNH(INH4)*Mah2(INH3)-3*Mah2(INH3)**2-4*A0TNH(INH4)*Mah2(INH4)
     &  +2*Mah2(INH3)*Mah2(INH4)+Mah2(INH4)**2))/(32.*(Mah2(INH3)-
     &  Mah2(INH4))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((CS1S1V2(INH3,INH3)**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*FD311HHpHp(3,INH3,ICH3,ICH4))/4.+
     &  (CS1S1V2(INH3,INH3)**2*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*(-4*A0TNH(INH3)+3*Mah2(INH3)))/(32.*
     &  Mah2(INH3)))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
       do INH3=1,6
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH6))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*(CS1S3S3(INH3,ICH5,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH5)*indexdelta(ICH3,ICH6)*
     &  indexdelta(ICH4,ICH3)+CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH6)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH6,ICH3))*(FD111HHpHp(3,INH3,ICH6,ICH5)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)+
     &  FD111HHpHp(3,INH3,ICH3,ICH5)*(MassHpm(ICH4)**2-MassHpm(ICH6)**
     &  2)+FD111HHpHp(3,INH3,ICH4,ICH5)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH6)**2)))/(4.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH6))*
     &  (MassHpm(ICH4)-MassHpm(ICH6))*(MassHpm(ICH3)+MassHpm(ICH6))*
     &  (MassHpm(ICH4)+MassHpm(ICH6)))-(C2W**2*(CS1S3S3(INH3,ICH5,ICH4)
     &  *CS1S3S3(INH3,ICH6,ICH5)*indexdelta(ICH3,ICH6)*
     &  indexdelta(ICH4,ICH3)+CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH6)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH6,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH6)**2)+4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2*(-MassHpm(ICH3)**2+MassHpm(ICH6)**2)+
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*(3*MassHpm(ICH3)**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH6)**2)+MassHpm(ICH6)**2*(4*
     &  A0THpN(ICH6)-3*MassHpm(ICH4)**2+3*MassHpm(ICH6)**2))))/(32.*
     &  S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH6))*(MassHpm(ICH4)-
     &  MassHpm(ICH6))*(MassHpm(ICH3)+MassHpm(ICH6))*(MassHpm(ICH4)+MassHpm(ICH6))))
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH6))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH3)*
     &  (CS1S3S3(INH3,ICH5,ICH3)*CS1S3S3(INH3,ICH6,ICH5)*
     &  indexdelta(ICH3,ICH6)+CS1S3S3(INH3,ICH3,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH6)*indexdelta(ICH6,ICH3))*(MassHpm(ICH3)**
     &  4-4*A0THpN(ICH6)*MassHpm(ICH6)**2+2*MassHpm(ICH3)**2*
     &  MassHpm(ICH6)**2-3*MassHpm(ICH6)**4-4*A0THpN(ICH3)*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH6)**2)))/(32.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH6))**2*(MassHpm(ICH3)+MassHpm(ICH6))*
     &  *2)+(C2W**2*indexdelta(ICH3,ICH3)*(CS1S3S3(INH3,ICH5,ICH3)*
     &  CS1S3S3(INH3,ICH6,ICH5)*indexdelta(ICH3,ICH6)+
     &  CS1S3S3(INH3,ICH3,ICH5)*CS1S3S3(INH3,ICH5,ICH6)*
     &  indexdelta(ICH6,ICH3))*(-FD111HHpHp(3,INH3,ICH3,ICH5)+
     &  FD111HHpHp(3,INH3,ICH6,ICH5)+FD211HpHHp(4,ICH3,INH3,ICH5)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH6)**2)))/(4.*S2W**2*(MassHpm(ICH3)
     &  -MassHpm(ICH6))**2*(MassHpm(ICH3)+MassHpm(ICH6))**2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*indexdelta(ICH3,ICH3)*
     &  (CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(INH3,ICH5,ICH3)*
     &  indexdelta(ICH3,ICH4)+CS1S3S3(INH3,ICH3,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH4)*indexdelta(ICH4,ICH3))*(MassHpm(ICH3)**
     &  4-4*A0THpN(ICH4)*MassHpm(ICH4)**2+2*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2-3*MassHpm(ICH4)**4-4*A0THpN(ICH3)*
     &  (MassHpm(ICH3)**2-2*MassHpm(ICH4)**2)))/(32.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2)+(C2W**2*indexdelta(ICH3,ICH3)*(CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH3)*indexdelta(ICH3,ICH4)+
     &  CS1S3S3(INH3,ICH3,ICH5)*CS1S3S3(INH3,ICH5,ICH4)*
     &  indexdelta(ICH4,ICH3))*(-FD111HHpHp(3,INH3,ICH3,ICH5)+
     &  FD111HHpHp(3,INH3,ICH4,ICH5)+FD211HpHHp(4,ICH3,INH3,ICH5)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)))/(4.*S2W**2*(MassHpm(ICH3)
     &  -MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))**2))
             endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH6)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH4)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH4,ICH3)*(-4*A0THpN(ICH3)*MassHpm(ICH3)**2-3*
     &  MassHpm(ICH3)**4+2*MassHpm(ICH3)**2*MassHpm(ICH4)**2+
     &  MassHpm(ICH4)**4+A0THpN(ICH4)*(8*MassHpm(ICH3)**2-4*
     &  MassHpm(ICH4)**2)))/(16.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**
     &  2*(MassHpm(ICH3)+MassHpm(ICH4))**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(INH3,ICH5,ICH4)*
     &  indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)*
     &  (FD111HHpHp(3,INH3,ICH3,ICH5)-FD111HHpHp(3,INH3,ICH4,ICH5)+
     &  FD211HpHHp(4,ICH4,INH3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**
     &  2)))/(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)
     &  +MassHpm(ICH4))**2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH6)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((C2W**2*CS1S3S3(INH3,ICH3,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH3)*FD311HpHHp(3,ICH3,INH3,ICH5)*
     &  indexdelta(ICH3,ICH3)**2)/(2.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,ICH3,ICH5)*CS1S3S3(INH3,ICH5,ICH3)*
     &  indexdelta(ICH3,ICH3)**2*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2))
     &  /(16.*S2W**2*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
       selfZ=selfZ+((3*CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)*
     &  CSSS(INH4,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*
     &  (FD111HSTST(4,INH5,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HSTST(4,INH3,ISt3,ISt4)*(Mah(INH4)**2-Mah(INH5)**2)+
     &  FD111HSTST(4,INH4,ISt3,ISt4)*(-Mah(INH3)**2+Mah(INH5)**2)))
     &  /(4.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+(3*CS1S1V2(INH3,INH4)*CS1S1V2(INH3,INH5)
     &  *CSSS(INH4,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*(-((4*A0TNH(INH3)*
     &  Mah2(INH3)+4*aA0TN(ISt4)*Mah2(INH3)+3*Mah2(INH3)**2+4*
     &  aA0TN(ISt4)*MassSu2(ISt3)+3*Mah2(INH3)*MassSu2(ISt3)+3*
     &  Mah2(INH3)*MassSu2(ISt4)+2*MassSu2(ISt3)*MassSu2(ISt4)+4*
     &  aA0TN(ISt3)*(Mah2(INH3)+MassSu2(ISt4)))/((Mah(INH3)-Mah(INH4))*
     &  (Mah(INH3)+Mah(INH4))*(Mah(INH3)-Mah(INH5))*(Mah(INH3)+
     &  Mah(INH5))))+(4*A0TNH(INH4)*Mah2(INH4)+4*aA0TN(ISt4)*Mah2(INH4)
     &  +3*Mah2(INH4)**2+4*aA0TN(ISt4)*MassSu2(ISt3)+3*Mah2(INH4)*
     &  MassSu2(ISt3)+3*Mah2(INH4)*MassSu2(ISt4)+2*MassSu2(ISt3)*
     &  MassSu2(ISt4)+4*aA0TN(ISt3)*(Mah2(INH4)+MassSu2(ISt4)))
     &  /((Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH4)-
     &  Mah(INH5))*(Mah(INH4)+Mah(INH5)))+(4*A0TNH(INH5)*Mah2(INH5)+4*
     &  aA0TN(ISt4)*Mah2(INH5)+3*Mah2(INH5)**2+4*aA0TN(ISt4)*
     &  MassSu2(ISt3)+3*Mah2(INH5)*MassSu2(ISt3)+3*Mah2(INH5)*
     &  MassSu2(ISt4)+2*MassSu2(ISt3)*MassSu2(ISt4)+4*aA0TN(ISt3)*
     &  (Mah2(INH5)+MassSu2(ISt4)))/((Mah(INH3)-Mah(INH5))*(Mah(INH3)+
     &  Mah(INH5))*(-Mah(INH4)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))))/32.)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*(-
     &  FD111HSTST(4,INH3,ISt3,ISt4)+FD111HSTST(4,INH5,ISt3,ISt4)+
     &  FD211HSTST(4,INH3,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH5)**2)))/(4.*
     &  (Mah(INH3)**2-Mah(INH5)**2)**2)+(3*CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH5)*CSSS(INH3,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*
     &  (Mah2(INH3)**2-4*A0TNH(INH5)*Mah2(INH5)+2*Mah2(INH3)*Mah2(INH5)
     &  -3*Mah2(INH5)**2+4*A0TNH(INH3)*(-Mah2(INH3)+2*Mah2(INH5))))
     &  /(32.*(Mah2(INH3)-Mah2(INH5))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*CS1S1V2(INH3,INH3)*CS1S1V2(INH3,INH4)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*(-
     &  FD111HSTST(4,INH3,ISt3,ISt4)+FD111HSTST(4,INH4,ISt3,ISt4)+
     &  FD211HSTST(4,INH3,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH4)**2)))/(4.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+(3*CS1S1V2(INH3,INH3)*
     &  CS1S1V2(INH3,INH4)*CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*
     &  (Mah2(INH3)**2-4*A0TNH(INH4)*Mah2(INH4)+2*Mah2(INH3)*Mah2(INH4)
     &  -3*Mah2(INH4)**2+4*A0TNH(INH3)*(-Mah2(INH3)+2*Mah2(INH4))))
     &  /(32.*(Mah2(INH3)-Mah2(INH4))**2))
             endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. 1D-15) then 
             if( Abs(Mah(INH4)) .gt. 1D-15) then 
       selfZ=selfZ+((3*CS1S1V2(INH3,INH4)**2*CSSS(INH4,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD111HSTST(4,INH3,ISt3,ISt4)-
     &  FD111HSTST(4,INH4,ISt3,ISt4)+FD211HSTST(4,INH4,ISt3,ISt4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)))/(4.*(Mah(INH3)**2-Mah(INH4)**2)**
     &  2)+(3*CS1S1V2(INH3,INH4)**2*CSSS(INH4,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(-4*A0TNH(INH3)*Mah2(INH3)+8*A0TNH(INH4)*
     &  Mah2(INH3)-3*Mah2(INH3)**2-4*A0TNH(INH4)*Mah2(INH4)+2*
     &  Mah2(INH3)*Mah2(INH4)+Mah2(INH4)**2))/(32.*(Mah2(INH3)-
     &  Mah2(INH4))**2))
             endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
             if( Abs(Mah(INH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*CS1S1V2(INH3,INH3)**2*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH3,ISt4,ISt3)*FD311HSTST(3,INH3,ISt3,ISt4))/4.+(3*
     &  CS1S1V2(INH3,INH3)**2*CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3)
     &  *(-4*A0TNH(INH3)+3*Mah2(INH3)))/(32.*Mah2(INH3)))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ISt3=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*(CS3S13S(ICH5,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)+CS3S13S(ICH4,ISt3)*
     &  CS3S13SC(ICH5,ISt3)*indexdelta(ICH3,ICH4)*indexdelta(ICH5,ICH3)
     &  )*(FD111HpSTSB(4,ICH5,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)
     &  +FD111HpSTSB(4,ICH3,ISt3)*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  FD111HpSTSB(4,ICH4,ISt3)*(-MassHpm(ICH3)**2+MassHpm(ICH5)**2)))
     &  /(4.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH4)-
     &  MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*(MassHpm(ICH4)+
     &  MassHpm(ICH5)))-(3*C2W**2*(CS3S13S(ICH5,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH3,ICH5)*indexdelta(ICH4,ICH3)
     &  +CS3S13S(ICH4,ISt3)*CS3S13SC(ICH5,ISt3)*indexdelta(ICH3,ICH4)*
     &  indexdelta(ICH5,ICH3))*(4*A0THpN(ICH3)*MassHpm(ICH3)**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH5)**2)+4*A0THpN(ICH4)*
     &  MassHpm(ICH4)**2*(-MassHpm(ICH3)**2+MassHpm(ICH5)**2)+
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)*(3*MassHpm(ICH3)**2*
     &  (MassHpm(ICH4)**2-MassHpm(ICH5)**2)+MassHpm(ICH5)**2*(4*
     &  A0THpN(ICH5)-3*MassHpm(ICH4)**2+3*MassHpm(ICH5)**2))))/(32.*
     &  S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH4)-
     &  MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*(MassHpm(ICH4)+
     &  MassHpm(ICH5))))
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*indexdelta(ICH3,ICH3)*(CS3S13S(ICH5,ISt3)
     &  *CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH5)+CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH5,ISt3)*indexdelta(ICH5,ICH3))*(MassHpm(ICH3)**4-4*
     &  A0THpN(ICH5)*MassHpm(ICH5)**2+2*MassHpm(ICH3)**2*MassHpm(ICH5)*
     &  *2-3*MassHpm(ICH5)**4-4*A0THpN(ICH3)*(MassHpm(ICH3)**2-2*
     &  MassHpm(ICH5)**2)))/(32.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH5))**
     &  2*(MassHpm(ICH3)+MassHpm(ICH5))**2)+(3*C2W**2*
     &  indexdelta(ICH3,ICH3)*(CS3S13S(ICH5,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  indexdelta(ICH3,ICH5)+CS3S13S(ICH3,ISt3)*CS3S13SC(ICH5,ISt3)*
     &  indexdelta(ICH5,ICH3))*(-FD111HpSTSB(4,ICH3,ISt3)+
     &  FD111HpSTSB(4,ICH5,ISt3)+FD211HpSTSB(4,ICH3,ISt3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH5)**2)))/(4.*S2W**2*(MassHpm(ICH3)
     &  -MassHpm(ICH5))**2*(MassHpm(ICH3)+MassHpm(ICH5))**2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*indexdelta(ICH3,ICH3)*(CS3S13S(ICH4,ISt3)
     &  *CS3S13SC(ICH3,ISt3)*indexdelta(ICH3,ICH4)+CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,ICH3))*(MassHpm(ICH3)**4-4*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2+2*MassHpm(ICH3)**2*MassHpm(ICH4)*
     &  *2-3*MassHpm(ICH4)**4-4*A0THpN(ICH3)*(MassHpm(ICH3)**2-2*
     &  MassHpm(ICH4)**2)))/(32.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**
     &  2*(MassHpm(ICH3)+MassHpm(ICH4))**2)+(3*C2W**2*
     &  indexdelta(ICH3,ICH3)*(CS3S13S(ICH4,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  indexdelta(ICH3,ICH4)+CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  indexdelta(ICH4,ICH3))*(-FD111HpSTSB(4,ICH3,ISt3)+
     &  FD111HpSTSB(4,ICH4,ISt3)+FD211HpSTSB(4,ICH3,ISt3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)))/(4.*S2W**2*(MassHpm(ICH3)
     &  -MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))**2))
             endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*CS3S13S(ICH4,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)*
     &  (FD111HpSTSB(4,ICH3,ISt3)-FD111HpSTSB(4,ICH4,ISt3)+
     &  FD211HpSTSB(4,ICH4,ISt3)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2)))
     &  /(2.*S2W**2*(MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+
     &  MassHpm(ICH4))**2)-(3*C2W**2*CS3S13S(ICH4,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)
     &  *(4*A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4-2*
     &  MassHpm(ICH3)**2*MassHpm(ICH4)**2-MassHpm(ICH4)**4+A0THpN(ICH4)
     &  *(-8*MassHpm(ICH3)**2+4*MassHpm(ICH4)**2)))/(16.*S2W**2*
     &  (MassHpm(ICH3)-MassHpm(ICH4))**2*(MassHpm(ICH3)+MassHpm(ICH4))*
     &  *2))
             endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
             if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       selfZ=selfZ+((3*C2W**2*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  FD311HpSTSB(3,ICH3,ISt3)*indexdelta(ICH3,ICH3)**2)/(2.*S2W**2)+
     &  (3*C2W**2*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  indexdelta(ICH3,ICH3)**2*(-4*A0THpN(ICH3)+3*MassHpm(ICH3)**2))
     &  /(16.*S2W**2*MassHpm(ICH3)**2))
             endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
c
c topo8-NoGBC
c
       ! diagram  1  
       do INH5=1,6
       do INH6=1,6
        INH3=6
        INH4=6
            do INH7=1,5
       selfZ=selfZ+(-(CS1S1S1(6,INH5,INH6)*CS1S1S1(INH5,INH6,INH7)*
     &  CS1S1V2(6,6)*CS1S1V2(6,INH7)*(FD211HHH(4,6,INH5,INH6)*Mah(INH7)
     &  **4+(FD111HHH(4,6,INH5,INH6)-FD111HHH(4,INH7,INH5,INH6))*
     &  Mah2(INH7)))/(8.*Mah(INH7)**4*Mah2(INH7))-(CS1S1S1(6,INH5,INH6)
     &  *CS1S1S1(INH5,INH6,INH7)*CS1S1V2(6,6)*CS1S1V2(6,INH7)*(4*
     &  A0TNH(INH7)*Mah2(INH7)+3*Mah2(INH5)*Mah2(INH7)+3*Mah2(INH6)*
     &  Mah2(INH7)-3*(Mah2(INH5)+Mah2(INH6))*Mah2(INH7)+3*Mah2(INH7)**
     &  2))/(64.*Mah(INH7)**4))
              enddo
        INH3=6
        INH7=6
            do INH4=1,5
       selfZ=selfZ+(-(CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,6)*
     &  CS1S1V2(6,6)*CS1S1V2(6,INH4)*(FD211HHH(4,6,INH5,INH6)*Mah(INH4)
     &  **4+(FD111HHH(4,6,INH5,INH6)-FD111HHH(4,INH4,INH5,INH6))*
     &  Mah2(INH4)))/(8.*Mah(INH4)**4*Mah2(INH4))-
     &  (CS1S1S1(INH4,INH5,INH6)*CS1S1S1(INH5,INH6,6)*CS1S1V2(6,6)*
     &  CS1S1V2(6,INH4)*(4*A0TNH(INH4)*Mah2(INH4)+4*A0TNH(INH6)*
     &  Mah2(INH4)+3*Mah2(INH4)**2+3*Mah2(INH4)*Mah2(INH5)+3*Mah2(INH4)
     &  *Mah2(INH6)-Mah2(INH4)*(4*A0TNH(INH6)+3*(Mah2(INH5)+Mah2(INH6))
     &  )))/(64.*Mah(INH4)**4))
              enddo
        INH7=6
        INH4=6
            do INH3=1,5
       selfZ=selfZ+(-(CS1S1S1(6,INH5,INH6)*CS1S1S1(INH5,INH6,6)*
     &  CS1S1V2(INH3,6)**2*(FD211HHH(4,6,INH5,INH6)*Mah(INH3)**4+
     &  (FD111HHH(4,6,INH5,INH6)-FD111HHH(4,INH3,INH5,INH6))*Mah2(INH3)
     &  ))/(8.*Mah(INH3)**4*Mah2(INH3))-(CS1S1S1(6,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,6)*CS1S1V2(INH3,6)**2*(4*A0TNH(INH3)*
     &  Mah2(INH3)+3*Mah2(INH3)**2))/(64.*Mah(INH3)**4))
              enddo
        INH3=6
       selfZ=selfZ+(((-3+4*logx)*CS1S1S1(6,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,6)*CS1S1V2(6,6)**2)/64.+(CS1S1S1(6,INH5,INH6)
     &  *CS1S1S1(INH5,INH6,6)*CS1S1V2(6,6)**2*FD311HHH(3,6,INH5,INH6))
     &  /8.)
       enddo 
       enddo 
       ! diagram  2  
       do ICH3=1,2
       do ICH4=1,2
        INH3=6
        INH4=6
            do INH5=1,5
       selfZ=selfZ+(-(CS1S1V2(6,6)*CS1S1V2(6,INH5)*CS1S3S3(6,ICH4,ICH3)
     &  *CS1S3S3(INH5,ICH3,ICH4)*(FD211HHpHp(4,6,ICH3,ICH4)*Mah(INH5)**
     &  4+(FD111HHpHp(4,6,ICH3,ICH4)-FD111HHpHp(4,INH5,ICH3,ICH4))*
     &  Mah2(INH5)))/(4.*Mah(INH5)**4*Mah2(INH5))-(CS1S1V2(6,6)*
     &  CS1S1V2(6,INH5)*CS1S3S3(6,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*
     &  (4*A0TNH(INH5)*Mah2(INH5)+3*Mah2(INH5)**2))/(32.*Mah(INH5)**4))
              enddo
        INH3=6
        INH5=6
            do INH4=1,5
       selfZ=selfZ+(-(CS1S1V2(6,6)*CS1S1V2(6,INH4)*CS1S3S3(6,ICH3,ICH4)
     &  *CS1S3S3(INH4,ICH4,ICH3)*(FD211HHpHp(4,6,ICH3,ICH4)*Mah(INH4)**
     &  4+(FD111HHpHp(4,6,ICH3,ICH4)-FD111HHpHp(4,INH4,ICH3,ICH4))*
     &  Mah2(INH4)))/(4.*Mah(INH4)**4*Mah2(INH4))-(CS1S1V2(6,6)*
     &  CS1S1V2(6,INH4)*CS1S3S3(6,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*
     &  (4*A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2))/(32.*Mah(INH4)**4))
              enddo
        INH5=6
        INH4=6
            do INH3=1,5
       selfZ=selfZ+(-(CS1S1V2(INH3,6)**2*CS1S3S3(6,ICH3,ICH4)*
     &  CS1S3S3(6,ICH4,ICH3)*(FD211HHpHp(4,6,ICH3,ICH4)*Mah(INH3)**4+
     &  (FD111HHpHp(4,6,ICH3,ICH4)-FD111HHpHp(4,INH3,ICH3,ICH4))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(CS1S1V2(INH3,6)**2*
     &  CS1S3S3(6,ICH3,ICH4)*CS1S3S3(6,ICH4,ICH3)*(4*A0TNH(INH3)*
     &  Mah2(INH3)+3*Mah2(INH3)**2))/(32.*Mah(INH3)**4))
              enddo
        INH3=6
       selfZ=selfZ+(((-3+4*logx)*CS1S1V2(6,6)**2*CS1S3S3(6,ICH3,ICH4)*
     &  CS1S3S3(6,ICH4,ICH3))/32.+(CS1S1V2(6,6)**2*CS1S3S3(6,ICH3,ICH4)
     &  *CS1S3S3(6,ICH4,ICH3)*FD311HHpHp(3,6,ICH3,ICH4))/4.)
       enddo 
       enddo 
       ! diagram  3  
       do ICH5=1,2
       do INH3=1,6
        ICH3=1
        ICH4=1
            ICH6=2
       selfZ=selfZ+(-(C2W**2*indexdelta(1,1)*(CS1S3S3(INH3,ICH5,1)*
     &  CS1S3S3(INH3,ICH6,ICH5)*indexdelta(1,ICH6)+CS1S3S3(INH3,1,ICH5)
     &  *CS1S3S3(INH3,ICH5,ICH6)*indexdelta(ICH6,1))*
     &  (FD111HHpHp(3,INH3,1,ICH5)-FD111HHpHp(3,INH3,ICH6,ICH5)+
     &  FD211HpHHp(4,1,INH3,ICH5)*MassHpm(ICH6)**2))/(4.*S2W**2*
     &  MassHpm(ICH6)**4)-(C2W**2*indexdelta(1,1)*(CS1S3S3(INH3,ICH5,1)
     &  *CS1S3S3(INH3,ICH6,ICH5)*indexdelta(1,ICH6)+
     &  CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH5,ICH6)*indexdelta(ICH6,1)
     &  )*(4*A0THpN(ICH6)*MassHpm(ICH6)**2+3*MassHpm(ICH6)**4))/(32.*
     &  S2W**2*MassHpm(ICH6)**4))
        ICH3=1
        ICH6=1
            ICH4=2
       selfZ=selfZ+(-(C2W**2*indexdelta(1,1)*(CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,1)*indexdelta(1,ICH4)+CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH4)*indexdelta(ICH4,1))*
     &  (FD111HHpHp(3,INH3,1,ICH5)-FD111HHpHp(3,INH3,ICH4,ICH5)+
     &  FD211HpHHp(4,1,INH3,ICH5)*MassHpm(ICH4)**2))/(4.*S2W**2*
     &  MassHpm(ICH4)**4)-(C2W**2*indexdelta(1,1)*
     &  (CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(INH3,ICH5,1)*
     &  indexdelta(1,ICH4)+CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH5,ICH4)
     &  *indexdelta(ICH4,1))*(4*A0THpN(ICH4)*MassHpm(ICH4)**2+3*
     &  MassHpm(ICH4)**4))/(32.*S2W**2*MassHpm(ICH4)**4))
        ICH6=1
        ICH4=1
            ICH3=2
       selfZ=selfZ+(-(C2W**2*CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH5,1)*
     &  indexdelta(1,ICH3)*indexdelta(ICH3,1)*
     &  (FD111HHpHp(3,INH3,1,ICH5)-FD111HHpHp(3,INH3,ICH3,ICH5)+
     &  FD211HpHHp(4,1,INH3,ICH5)*MassHpm(ICH3)**2))/(2.*S2W**2*
     &  MassHpm(ICH3)**4)-(C2W**2*CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,1)*indexdelta(1,ICH3)*indexdelta(ICH3,1)*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4))/(16.*S2W**2*
     &  MassHpm(ICH3)**4))
        ICH3=1
       selfZ=selfZ+((C2W**2*(-3+4*logx)*CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,1)*indexdelta(1,1)**2)/(16.*S2W**2)+(C2W**2*
     &  CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH5,1)*
     &  FD311HpHHp(3,1,INH3,ICH5)*indexdelta(1,1)**2)/(2.*S2W**2))
       enddo 
       enddo 
       ! diagram  4  
       do ISt3=1,2
       do ISt4=1,2
        INH3=6
        INH4=6
            do INH5=1,5
       selfZ=selfZ+((-3*CS1S1V2(6,6)*CS1S1V2(6,INH5)*CSSS(6,ISt4,ISt3)*
     &  CSSS(INH5,ISt3,ISt4)*(FD211HSTST(4,6,ISt3,ISt4)*Mah(INH5)**4+
     &  (FD111HSTST(4,6,ISt3,ISt4)-FD111HSTST(4,INH5,ISt3,ISt4))*
     &  Mah2(INH5)))/(4.*Mah(INH5)**4*Mah2(INH5))-(3*CS1S1V2(6,6)*
     &  CS1S1V2(6,INH5)*CSSS(6,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*(4*
     &  A0TNH(INH5)*Mah2(INH5)+3*Mah2(INH5)**2))/(32.*Mah(INH5)**4))
              enddo
        INH3=6
        INH5=6
            do INH4=1,5
       selfZ=selfZ+((-3*CS1S1V2(6,6)*CS1S1V2(6,INH4)*CSSS(6,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD211HSTST(4,6,ISt3,ISt4)*Mah(INH4)**4+
     &  (FD111HSTST(4,6,ISt3,ISt4)-FD111HSTST(4,INH4,ISt3,ISt4))*
     &  Mah2(INH4)))/(4.*Mah(INH4)**4*Mah2(INH4))-(3*CS1S1V2(6,6)*
     &  CS1S1V2(6,INH4)*CSSS(6,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*(4*
     &  A0TNH(INH4)*Mah2(INH4)+3*Mah2(INH4)**2))/(32.*Mah(INH4)**4))
              enddo
        INH5=6
        INH4=6
            do INH3=1,5
       selfZ=selfZ+((-3*CS1S1V2(INH3,6)**2*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3)*(FD211HSTST(4,6,ISt3,ISt4)*Mah(INH3)**4+
     &  (FD111HSTST(4,6,ISt3,ISt4)-FD111HSTST(4,INH3,ISt3,ISt4))*
     &  Mah2(INH3)))/(4.*Mah(INH3)**4*Mah2(INH3))-(3*CS1S1V2(INH3,6)**
     &  2*CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt3)*(4*A0TNH(INH3)*Mah2(INH3)
     &  +3*Mah2(INH3)**2))/(32.*Mah(INH3)**4))
              enddo
        INH3=6
       selfZ=selfZ+((3*(-3+4*logx)*CS1S1V2(6,6)**2*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3))/32.+(3*CS1S1V2(6,6)**2*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3)*FD311HSTST(3,6,ISt3,ISt4))/4.)
       enddo 
       enddo 
       ! diagram  5  
       do ISt3=1,2
        ICH3=1
        ICH4=1
            ICH5=2
       selfZ=selfZ+((-3*C2W**2*indexdelta(1,1)*(CS3S13S(ICH5,ISt3)*
     &  CS3S13SC(1,ISt3)*indexdelta(1,ICH5)+CS3S13S(1,ISt3)*
     &  CS3S13SC(ICH5,ISt3)*indexdelta(ICH5,1))*(FD111HpSTSB(4,1,ISt3)-
     &  FD111HpSTSB(4,ICH5,ISt3)+FD211HpSTSB(4,1,ISt3)*MassHpm(ICH5)**
     &  2))/(4.*S2W**2*MassHpm(ICH5)**4)-(3*C2W**2*indexdelta(1,1)*
     &  (CS3S13S(ICH5,ISt3)*CS3S13SC(1,ISt3)*indexdelta(1,ICH5)+
     &  CS3S13S(1,ISt3)*CS3S13SC(ICH5,ISt3)*indexdelta(ICH5,1))*(4*
     &  A0THpN(ICH5)*MassHpm(ICH5)**2+3*MassHpm(ICH5)**4))/(32.*S2W**2*
     &  MassHpm(ICH5)**4))
        ICH3=1
        ICH5=1
            ICH4=2
       selfZ=selfZ+((-3*C2W**2*indexdelta(1,1)*(CS3S13S(ICH4,ISt3)*
     &  CS3S13SC(1,ISt3)*indexdelta(1,ICH4)+CS3S13S(1,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,1))*(FD111HpSTSB(4,1,ISt3)-
     &  FD111HpSTSB(4,ICH4,ISt3)+FD211HpSTSB(4,1,ISt3)*MassHpm(ICH4)**
     &  2))/(4.*S2W**2*MassHpm(ICH4)**4)-(3*C2W**2*indexdelta(1,1)*
     &  (CS3S13S(ICH4,ISt3)*CS3S13SC(1,ISt3)*indexdelta(1,ICH4)+
     &  CS3S13S(1,ISt3)*CS3S13SC(ICH4,ISt3)*indexdelta(ICH4,1))*(4*
     &  A0THpN(ICH4)*MassHpm(ICH4)**2+3*MassHpm(ICH4)**4))/(32.*S2W**2*
     &  MassHpm(ICH4)**4))
        ICH5=1
        ICH4=1
            ICH3=2
       selfZ=selfZ+((-3*C2W**2*CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*
     &  indexdelta(1,ICH3)*indexdelta(ICH3,1)*(FD111HpSTSB(4,1,ISt3)-
     &  FD111HpSTSB(4,ICH3,ISt3)+FD211HpSTSB(4,1,ISt3)*MassHpm(ICH3)**
     &  2))/(2.*S2W**2*MassHpm(ICH3)**4)-(3*C2W**2*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*indexdelta(1,ICH3)*indexdelta(ICH3,1)*(4*
     &  A0THpN(ICH3)*MassHpm(ICH3)**2+3*MassHpm(ICH3)**4))/(16.*S2W**2*
     &  MassHpm(ICH3)**4))
        ICH3=1
       selfZ=selfZ+((3*C2W**2*(-3+4*logx)*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*indexdelta(1,1)**2)/(16.*S2W**2)+(3*C2W**2*
     &  CS3S13S(1,ISt3)*CS3S13SC(1,ISt3)*FD311HpSTSB(3,1,ISt3)*
     &  indexdelta(1,1)**2)/(2.*S2W**2))
       enddo 

c
c topo8-GBC
c
c[ counterterm inserted one-loop diagrams
    
       selfZCT=selfZCT+(48*aBEpTCha*(CF12F12V2L-CF12F12V2R)**2*CW**2*
     &  MCha*SW2*dMCha1L(1)-12*CW**2*MCha*(CF12F12V2L**2+CF12F12V2R**2+
     &  2*(aC0TCha3*(CF12F12V2L**2+CF12F12V2R**2)-2*aCEpTCha3*
     &  (CF12F12V2L**2-4*CF12F12V2L*CF12F12V2R+CF12F12V2R**2))*MCha2)*
     &  SW2*dMCha1L(1)-24*aB0TCha*CW**2*MCha*SW2*((CF12F12V2L**2+
     &  CF12F12V2R**2)*dMCha1L(1)-2*(CF12F12V2L-CF12F12V2R)**2*
     &  dMCha1L(2))+24*CW**2*MCha*SW2*((-CF12F12V2L**2-CF12F12V2R**2+2*
     &  aC0TCha3*(CF12F12V2L**2-4*CF12F12V2L*CF12F12V2R+CF12F12V2R**2)*
     &  MCha2)*dMCha1L(2)+2*(CF12F12V2L-CF12F12V2R)**2*dMCha1L(3))+M1*
     &  (-9*CW**4*(1+2*(aC0TT3-2*aCEpTT3)*M12)+(-17-34*aC0TT3*M12+4*
     &  aCEpTT3*M12)*SW**4+6*CW**2*(1+2*(aC0TT3+14*aCEpTT3)*M12)*SW2)*
     &  dmt4(1)+2*M1*(18*aBEpTN1*(CW**2+SW2)**2*dmt4(1)+(9*CW**4*(-1+2*
     &  aC0TT3*M12)+(-17+2*aC0TT3*M12)*SW**4+6*CW**2*(1+14*aC0TT3*M12)*
     &  SW2)*dmt4(2)+aB0TN1*((-9*CW**4-17*SW**4+6*CW**2*SW2)*dmt4(1)+
     &  18*(CW**2+SW2)**2*dmt4(2))+18*(CW**2+SW2)**2*dmt4(3)))/(3.*CW**
     &  2*SW**2)

        
       do INe3=1,3
       do INe4=1,3
       do INe5=1,3
              if( MNeu(INe3)*MNeu(INe4) + MNeu(INe3)*MNeu(INe5) + MNeu(INe4)*MNeu(INe5) .gt. 1D-15) then 
       selfZCT=selfZCT+(-(CF11F11V2R(INe4,INe5)*CF11F11V2R(INe5,INe3)*
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3))-CF11F11V2L(INe4,INe5)*
     &  CF11F11V2L(INe5,INe3)*dMNeu1L(INe3,INe4,1)*MNeu(INe3)-
     &  CF11F11V2L(INe4,INe5)*CF11F11V2L(INe5,INe3)*
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4)-CF11F11V2R(INe4,INe5)*
     &  CF11F11V2R(INe5,INe3)*dMNeu1L(INe3,INe4,1)*MNeu(INe4)-2*
     &  (CF11F11V2L(INe4,INe5)*CF11F11V2L(INe5,INe3)*
     &  (dMNeu1L(INe3,INe4,2)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,2))*
     &  MNeu(INe4))+CF11F11V2R(INe4,INe5)*CF11F11V2R(INe5,INe3)*
     &  (DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe3)+dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe4)))+4*(CF11F11V2R(INe4,INe5)*(CF11F11V2R(INe5,INe3)*
     &  (DCONJG(dMNeu1L(INe4,INe3,3))*MNeu(INe3)+dMNeu1L(INe3,INe4,3)*
     &  MNeu(INe4))-2*CF11F11V2L(INe5,INe3)*DCONJG(dMNeu1L(INe4,INe3,3)
     &  )*MNeu(INe5))+CF11F11V2L(INe4,INe5)*(CF11F11V2L(INe5,INe3)*
     &  (dMNeu1L(INe3,INe4,3)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,3))*
     &  MNeu(INe4))-2*CF11F11V2R(INe5,INe3)*dMNeu1L(INe3,INe4,3)*
     &  MNeu(INe5)))+4*(aCEpTChi3(INe3,INe4,INe5)*MNeu(INe3)*
     &  (CF11F11V2R(INe4,INe5)*(DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)
     &  +dMNeu1L(INe3,INe4,1)*MNeu(INe4))*(CF11F11V2R(INe5,INe3)*
     &  MNeu(INe3)-2*CF11F11V2L(INe5,INe3)*MNeu(INe5))+
     &  CF11F11V2L(INe4,INe5)*(dMNeu1L(INe3,INe4,1)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4))*(CF11F11V2L(INe5,INe3)
     &  *MNeu(INe3)-2*CF11F11V2R(INe5,INe3)*MNeu(INe5)))+
     &  aBEpTNeu(INe4,INe5)*(CF11F11V2R(INe4,INe5)*
     &  (CF11F11V2R(INe5,INe3)*(DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)
     &  +dMNeu1L(INe3,INe4,1)*MNeu(INe4))-2*CF11F11V2L(INe5,INe3)*
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe5))+CF11F11V2L(INe4,INe5)*
     &  (CF11F11V2L(INe5,INe3)*(dMNeu1L(INe3,INe4,1)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4))-2*
     &  CF11F11V2R(INe5,INe3)*dMNeu1L(INe3,INe4,1)*MNeu(INe5))))+4*
     &  (aC0TChi3(INe3,INe4,INe5)*MNeu(INe3)*(CF11F11V2R(INe4,INe5)*
     &  (DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe3)+dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe4))*(CF11F11V2R(INe5,INe3)*MNeu(INe3)-2*
     &  CF11F11V2L(INe5,INe3)*MNeu(INe5))+CF11F11V2L(INe4,INe5)*
     &  (dMNeu1L(INe3,INe4,2)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,2))*
     &  MNeu(INe4))*(CF11F11V2L(INe5,INe3)*MNeu(INe3)-2*
     &  CF11F11V2R(INe5,INe3)*MNeu(INe5)))+aB0TNeu(INe4,INe5)*
     &  (CF11F11V2R(INe4,INe5)*(CF11F11V2R(INe5,INe3)*
     &  (DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe3)+dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe4))-2*CF11F11V2L(INe5,INe3)*DCONJG(dMNeu1L(INe4,INe3,2)
     &  )*MNeu(INe5))+CF11F11V2L(INe4,INe5)*(CF11F11V2L(INe5,INe3)*
     &  (dMNeu1L(INe3,INe4,2)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,2))*
     &  MNeu(INe4))-2*CF11F11V2R(INe5,INe3)*dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe5))))-2*(CF11F11V2L(INe4,INe5)*CF11F11V2L(INe5,INe3)*
     &  (dMNeu1L(INe3,INe4,1)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,1))*
     &  MNeu(INe4))+CF11F11V2R(INe4,INe5)*CF11F11V2R(INe5,INe3)*
     &  (DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)+dMNeu1L(INe3,INe4,1)*
     &  MNeu(INe4)))*(aB0TNeu(INe4,INe5)+aC0TChi3(INe3,INe4,INe5)*MNeu2(INe3)))
              endif
       enddo 
       enddo 
       enddo 

c
c CTtopo1-NoGBC
c
c
c CTtopo1-GBC
c
        
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       selfZCT=selfZCT+(CS1S1V2(INH3,INH5)*CS1S1V2(INH4,INH5)*(4*
     &  (dMH1MT4(INH3,INH4,2)+2*dMH1MT4(INH3,INH4,3)-(A0TNH(INH5)+2*
     &  AETNH(INH5))*facZ*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH5)*
     &  facZ*dZHiggs1(INH3,INH4,2))+8*aC0TNH(INH3,INH4,INH5)*
     &  dMH1MT4(INH3,INH4,2)*Mah2(INH3)-2*facZ*dZHiggs1(INH3,INH4,1)*
     &  Mah2(INH3)+signf*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)-8*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)+4*signf*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)-4*
     &  facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH3)+2*signf*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH3)-8*facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH3)+4*signf*
     &  facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH3)-4*aC0TNH(INH3,INH4,INH5)*
     &  facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2+2*signf*
     &  aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2-8*
     &  aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2+4*
     &  signf*aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*
     &  *2-8*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH3)**
     &  2+4*signf*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH3)**2+dMH1MT4(INH3,INH4,1)*(2+4*aB0TNH(INH4,INH5)+8*
     &  aBEpTNH(INH4,INH5)+4*(aC0TNH(INH3,INH4,INH5)+2*
     &  aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))-2*facZ*dZHiggs1(INH3,INH4,1)*
     &  Mah2(INH4)+signf*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)-8*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)+4*signf*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)-4*
     &  facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH4)+2*signf*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH4)-8*facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH4)+4*signf*
     &  facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH4)+2*signf*aC0TNH(INH3,INH4,INH5)
     &  *facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*Mah2(INH4)+4*signf*
     &  aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*
     &  Mah2(INH4)+4*signf*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)
     &  *Mah2(INH3)*Mah2(INH4)+2*aB0TNH(INH4,INH5)*(4*
     &  dMH1MT4(INH3,INH4,2)+(-2+signf)*(facZ*dZHiggs1(INH3,INH4,1)+2*
     &  facZ*dZHiggs1(INH3,INH4,2))*(Mah2(INH3)+Mah2(INH4)))-2*
     &  (facZ*dZHiggs1(INH3,INH4,1)+2*facZ*dZHiggs1(INH3,INH4,2)+4*
     &  facZ*dZHiggs1(INH3,INH4,3))*Mah2(INH5)))/2.
              endif
       enddo 
       enddo 
       enddo

        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       selfZCT=selfZCT+(C2W**2*(8*dMCH1L(ICH4,ICH3,3)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)-4*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)-8*AETHpN(ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)-8*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)+2*((1+2*aB0TCH(ICH4,ICH5)+4*
     &  aBEpTCH(ICH4,ICH5))*dMCH1L(ICH3,ICH4,1)+(2+4*aB0TCH(ICH4,ICH5))
     &  *dMCH1L(ICH3,ICH4,2)+4*dMCH1L(ICH3,ICH4,3))*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)-4*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)-8*AETHpN(ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)-8*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)-2*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+
     &  signf*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)
     &  *indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-4*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+2*signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*facZ*dZCHiggs1(ICH4,ICH3,3)
     &  *indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+
     &  4*signf*facZ*dZCHiggs1(ICH4,ICH3,3)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*aC0TCH(ICH3,ICH4,ICH5)
     &  *dMCH1L(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*dMCH1L(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+8*
     &  aC0TCH(ICH3,ICH4,ICH5)*dMCH1L(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-2*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)
     &  *indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+2*signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*facZ*dZCHiggs1(ICH3,ICH4,3)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+
     &  4*signf*facZ*dZCHiggs1(ICH3,ICH4,3)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*aC0TCH(ICH3,ICH4,ICH5)
     &  *facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+2*signf*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-8*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-4*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+2*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4-8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4-8*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  dMCH1L(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)
     &  *(1+2*aB0TCH(ICH4,ICH5)+2*aC0TCH(ICH3,ICH4,ICH5)*MassHpm(ICH3)*
     &  *2)+2*dMCH1L(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*(1+2*aB0TCH(ICH4,ICH5)+4*
     &  aBEpTCH(ICH4,ICH5)+2*(aC0TCH(ICH3,ICH4,ICH5)+2*
     &  aCEpTCH(ICH3,ICH4,ICH5))*MassHpm(ICH3)**2)-2*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)
     &  *indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-4*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+2*signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*facZ*dZCHiggs1(ICH4,ICH3,3)
     &  *indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+
     &  4*signf*facZ*dZCHiggs1(ICH4,ICH3,3)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-2*facZ*dZCHiggs1(ICH3,ICH4,1)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+
     &  signf*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)
     &  *indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-4*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*facZ*dZCHiggs1(ICH3,ICH4,3)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+
     &  4*signf*facZ*dZCHiggs1(ICH3,ICH4,3)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+4*signf*aCEpTCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+2*signf*aC0TCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+4*signf*aC0TCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2-2*
     &  ((facZ*dZCHiggs1(ICH4,ICH3,1)+2*facZ*dZCHiggs1(ICH4,ICH3,2)+4*
     &  facZ*dZCHiggs1(ICH4,ICH3,3))*indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)+(facZ*dZCHiggs1(ICH3,ICH4,1)+2*facZ*dZCHiggs1(ICH3,ICH4,2)+4*facZ*dZCHiggs1(ICH3,ICH4,3))*indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4))*MassHpm(ICH5)**2))/(2.*S2W**2)
              endif
       enddo 
       enddo 
       enddo 

        
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
              if( MassSu(ISt3)*MassSu(ISt4) + MassSu(ISt3)*MassSu(ISt5) + MassSu(ISt4)*MassSu(ISt5) .gt. 1D-15) then 
       selfZCT=selfZCT+3*(CS13S13V2(ISt3,ISt5)*CS13S13V2(ISt5,ISt4)*
     &  (dMSf4(ISt3,ISt4,1)*(1+2*aB0T1(ISt4,ISt5)+4*aBEpT1(ISt4,ISt5)+
     &  2*(aC0T(ISt3,ISt4,ISt5)+2*aCEpT(ISt3,ISt4,ISt5))*MassSu2(ISt3))
     &  +2*(2*dMSf4(ISt3,ISt4,3)+dMSf4(ISt3,ISt4,2)*(1+2*
     &  aB0T1(ISt4,ISt5)+2*aC0T(ISt3,ISt4,ISt5)*MassSu2(ISt3))))+
     &  CS13S13V2(ISt4,ISt5)*CS13S13V2(ISt5,ISt3)*(dMSf4(ISt4,ISt3,1)*
     &  (1+2*aB0T1(ISt4,ISt5)+4*aBEpT1(ISt4,ISt5)+2*
     &  (aC0T(ISt3,ISt4,ISt5)+2*aCEpT(ISt3,ISt4,ISt5))*MassSu2(ISt3))+
     &  2*(2*dMSf4(ISt4,ISt3,3)+dMSf4(ISt4,ISt3,2)*(1+2*
     &  aB0T1(ISt4,ISt5)+2*aC0T(ISt3,ISt4,ISt5)*MassSu2(ISt3)))))
              endif
       enddo 
       enddo 
       enddo 
        
       selfZCT=selfZCT+6*CS14S14V2**2*((1+2*aB0T5+4*aBEpT5)*dMSQ4(1)+2*
     &  (dMSQ4(2)+2*aB0T5*dMSQ4(2)+2*dMSQ4(3))+2*MSQ2*(-(dMSQ4(1)+2*
     &  dMSQ4(2))/(2.*MSQ2)+(dMSQ4(1)*Log(MSQ2/Q2))/MSQ2))
c
c CTtopo2-NoGBC
c
        
       do INH3=1,6
       do INH4=1,6
       do INH5=1,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then 
       selfZCT=selfZCT+(CS1S1V2(INH3,INH5)*CS1S1V2(INH4,INH5)*(4*
     &  (dMH1MT4(INH3,INH4,2)+2*dMH1MT4(INH3,INH4,3)-(A0TNH(INH5)+2*
     &  AETNH(INH5))*facZ*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH5)*
     &  facZ*dZHiggs1(INH3,INH4,2))+8*aC0TNH(INH3,INH4,INH5)*
     &  dMH1MT4(INH3,INH4,2)*Mah2(INH3)-2*facZ*dZHiggs1(INH3,INH4,1)*
     &  Mah2(INH3)+signf*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)-8*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)+4*signf*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)-4*
     &  facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH3)+2*signf*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH3)-8*facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH3)+4*signf*
     &  facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH3)-4*aC0TNH(INH3,INH4,INH5)*
     &  facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2+2*signf*
     &  aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2-8*
     &  aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)**2+4*
     &  signf*aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*
     &  *2-8*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH3)**
     &  2+4*signf*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH3)**2+dMH1MT4(INH3,INH4,1)*(2+4*aB0TNH(INH4,INH5)+8*
     &  aBEpTNH(INH4,INH5)+4*(aC0TNH(INH3,INH4,INH5)+2*
     &  aCEpTNH(INH3,INH4,INH5))*Mah2(INH3))-2*facZ*dZHiggs1(INH3,INH4,1)*
     &  Mah2(INH4)+signf*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)-8*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)+4*signf*
     &  aBEpTNH(INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH4)-4*
     &  facZ*dZHiggs1(INH3,INH4,2)*Mah2(INH4)+2*signf*facZ*dZHiggs1(INH3,INH4,2)*
     &  Mah2(INH4)-8*facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH4)+4*signf*
     &  facZ*dZHiggs1(INH3,INH4,3)*Mah2(INH4)+2*signf*aC0TNH(INH3,INH4,INH5)
     &  *facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*Mah2(INH4)+4*signf*
     &  aCEpTNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,1)*Mah2(INH3)*
     &  Mah2(INH4)+4*signf*aC0TNH(INH3,INH4,INH5)*facZ*dZHiggs1(INH3,INH4,2)
     &  *Mah2(INH3)*Mah2(INH4)+2*aB0TNH(INH4,INH5)*(4*
     &  dMH1MT4(INH3,INH4,2)+(-2+signf)*(facZ*dZHiggs1(INH3,INH4,1)+2*
     &  facZ*dZHiggs1(INH3,INH4,2))*(Mah2(INH3)+Mah2(INH4)))-2*
     &  (facZ*dZHiggs1(INH3,INH4,1)+2*facZ*dZHiggs1(INH3,INH4,2)+4*
     &  facZ*dZHiggs1(INH3,INH4,3))*Mah2(INH5)))/2.
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
       selfZCT=selfZCT+(C2W**2*(8*dMCH1L(ICH4,ICH3,3)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)-4*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)-8*AETHpN(ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)-8*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)+2*((1+2*aB0TCH(ICH4,ICH5)+4*
     &  aBEpTCH(ICH4,ICH5))*dMCH1L(ICH3,ICH4,1)+(2+4*aB0TCH(ICH4,ICH5))
     &  *dMCH1L(ICH3,ICH4,2)+4*dMCH1L(ICH3,ICH4,3))*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)-4*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)-8*AETHpN(ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)-8*A0THpN(ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)-2*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+
     &  signf*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)
     &  *indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-4*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+2*signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2-8*facZ*dZCHiggs1(ICH4,ICH3,3)
     &  *indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+
     &  4*signf*facZ*dZCHiggs1(ICH4,ICH3,3)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2+4*aC0TCH(ICH3,ICH4,ICH5)
     &  *dMCH1L(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*dMCH1L(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+8*
     &  aC0TCH(ICH3,ICH4,ICH5)*dMCH1L(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-2*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)
     &  *indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+2*signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-8*facZ*dZCHiggs1(ICH3,ICH4,3)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2+
     &  4*signf*facZ*dZCHiggs1(ICH3,ICH4,3)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2-4*aC0TCH(ICH3,ICH4,ICH5)
     &  *facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+2*signf*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-8*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**4-4*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+2*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4-8*
     &  aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4-8*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**4+4*
     &  dMCH1L(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)
     &  *(1+2*aB0TCH(ICH4,ICH5)+2*aC0TCH(ICH3,ICH4,ICH5)*MassHpm(ICH3)*
     &  *2)+2*dMCH1L(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*(1+2*aB0TCH(ICH4,ICH5)+4*
     &  aBEpTCH(ICH4,ICH5)+2*(aC0TCH(ICH3,ICH4,ICH5)+2*
     &  aCEpTCH(ICH3,ICH4,ICH5))*MassHpm(ICH3)**2)-2*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)
     &  *indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-4*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+2*signf*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-8*facZ*dZCHiggs1(ICH4,ICH3,3)
     &  *indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2+
     &  4*signf*facZ*dZCHiggs1(ICH4,ICH3,3)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH4)**2-2*facZ*dZCHiggs1(ICH3,ICH4,1)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+
     &  signf*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-4*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*aBEpTCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+4*signf*
     &  aBEpTCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)
     &  *indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-4*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*aB0TCH(ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+4*signf*
     &  aB0TCH(ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2-8*facZ*dZCHiggs1(ICH3,ICH4,3)
     &  *indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+
     &  4*signf*facZ*dZCHiggs1(ICH3,ICH4,3)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH4)**2+2*signf*
     &  aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,1)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+4*signf*aCEpTCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH4,ICH3,1)*indexdelta(ICH4,ICH5)*
     &  indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*
     &  signf*aC0TCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH4,ICH3,2)*
     &  indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+2*signf*aC0TCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,1)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2+4*
     &  signf*aCEpTCH(ICH3,ICH4,ICH5)*facZ*dZCHiggs1(ICH3,ICH4,1)*
     &  indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*
     &  MassHpm(ICH4)**2+4*signf*aC0TCH(ICH3,ICH4,ICH5)*
     &  facZ*dZCHiggs1(ICH3,ICH4,2)*indexdelta(ICH3,ICH5)*
     &  indexdelta(ICH5,ICH4)*MassHpm(ICH3)**2*MassHpm(ICH4)**2-2*
     &  ((facZ*dZCHiggs1(ICH4,ICH3,1)+2*facZ*dZCHiggs1(ICH4,ICH3,2)+4*
     &  facZ*dZCHiggs1(ICH4,ICH3,3))*indexdelta(ICH4,ICH5)*indexdelta(ICH5,ICH3)
     &  +(facZ*dZCHiggs1(ICH3,ICH4,1)+2*facZ*dZCHiggs1(ICH3,ICH4,2)+4*facZ*dZCHiggs1(ICH3,ICH4,3))*
     &   indexdelta(ICH3,ICH5)*indexdelta(ICH5,ICH4))*MassHpm(ICH5)**2))/(2.*S2W**2)
              endif
       enddo 
       enddo 
       enddo 

        
c
c CTtopo2-GBC
c
        
       do INH3=1,6
       selfZCT=selfZCT+2*(AETNH(INH3)*dCS1S1V2V2(INH3,INH3,1)+
     &  A0TNH(INH3)*dCS1S1V2V2(INH3,INH3,2)+dCS1S1V2V2(INH3,INH3,3)*
     &  Mah2(INH3))
       enddo 
        
       do ICH3=1,2
       selfZCT=selfZCT+4*(AETHpN(ICH3)*dCS3S3V2V2(ICH3,ICH3,1)+
     &  A0THpN(ICH3)*dCS3S3V2V2(ICH3,ICH3,2)+dCS3S3V2V2(ICH3,ICH3,3)*
     &  MassHpm(ICH3)**2)
       enddo 

       do ISt3=1,2
       selfZCT=selfZCT+12*(aAETN(ISt3)*dCS13S13V2V2(ISt3,ISt3,1)+
     &  aA0TN(ISt3)*dCS13S13V2V2(ISt3,ISt3,2)+dCS13S13V2V2(ISt3,ISt3,3)
     &  *MassSu2(ISt3))
       enddo
        
       selfZCT=selfZCT+12*(aet5*dCS14S14V2V2(1)+a0t5*dCS14S14V2V2(2)+
     &  MSQ2*dCS14S14V2V2(3))

c
c CTtopo3-NoGBC
c

c
c CTtopo3-GBC
c
        
       selfZCT=selfZCT+(-2*(2*CF12F12V2L*CW*(a0tcha-2*aetcha+MCha2)*SW*
     &  dCF12F12V2L(1)-4*aBEpTCha*CW*MCha2*SW*(CF12F12V2L*
     &  (dCF12F12V2L(1)-2*dCF12F12V2R(1))+CF12F12V2R*(-2*dCF12F12V2L(1)
     &  +dCF12F12V2R(1)))+2*aB0TCha*CW*MCha2*SW*(CF12F12V2R*(4*
     &  dCF12F12V2L(2)+dCF12F12V2R(1)-2*dCF12F12V2R(2))+CF12F12V2L*
     &  (dCF12F12V2L(1)-2*dCF12F12V2L(2)+4*dCF12F12V2R(2)))+2*CW*SW*
     &  (a0tcha*(-2*CF12F12V2L*dCF12F12V2L(2)+CF12F12V2R*
     &  (dCF12F12V2R(1)-2*dCF12F12V2R(2)))+CF12F12V2R*(-2*aetcha*
     &  dCF12F12V2R(1)+MCha2*(4*dCF12F12V2L(3)+dCF12F12V2R(1)+2*
     &  dCF12F12V2R(2)-4*dCF12F12V2R(3)))+2*CF12F12V2L*MCha2*
     &  (dCF12F12V2L(2)-2*dCF12F12V2L(3)+2*dCF12F12V2R(3)))-3*a0t1*CW**
     &  2*dCF3F3V2L(1)+6*aet1*CW**2*dCF3F3V2L(1)-3*aB0TN1*CW**2*M12*
     &  dCF3F3V2L(1)+6*aBEpTN1*CW**2*M12*dCF3F3V2L(1)+a0t1*SW2*
     &  dCF3F3V2L(1)-2*aet1*SW2*dCF3F3V2L(1)+aB0TN1*M12*SW2*
     &  dCF3F3V2L(1)+14*aBEpTN1*M12*SW2*dCF3F3V2L(1)+M12*(-3*CW**2+SW2)
     &  *dCF3F3V2L(1)+6*a0t1*CW**2*dCF3F3V2L(2)-6*CW**2*M12*
     &  dCF3F3V2L(2)+6*aB0TN1*CW**2*M12*dCF3F3V2L(2)-2*a0t1*SW2*
     &  dCF3F3V2L(2)+2*M12*SW2*dCF3F3V2L(2)+14*aB0TN1*M12*SW2*
     &  dCF3F3V2L(2)+12*CW**2*M12*dCF3F3V2L(3)+12*M12*SW2*dCF3F3V2L(3)-
     &  12*aBEpTN1*CW**2*M12*dCF3F3V2R(1)+4*a0t1*SW2*dCF3F3V2R(1)-8*
     &  aet1*SW2*dCF3F3V2R(1)+4*M12*SW2*dCF3F3V2R(1)+4*aB0TN1*M12*SW2*
     &  dCF3F3V2R(1)-4*aBEpTN1*M12*SW2*dCF3F3V2R(1)-12*aB0TN1*CW**2*
     &  M12*dCF3F3V2R(2)-8*a0t1*SW2*dCF3F3V2R(2)+8*M12*SW2*dCF3F3V2R(2)
     &  -4*aB0TN1*M12*SW2*dCF3F3V2R(2)-12*M12*(CW**2+SW2)*dCF3F3V2R(3))
     &  )/(CW*SW)
        
       do INe3=1,3
       do INe4=1,3
              if( MNeu(INe3) + MNeu(INe4) .gt. 1D-15) then 
       selfZCT=selfZCT+(-(A0TNeu(INe4)*CF11F11V2L(INe4,INe3)*
     &  dCF11F11V2L(INe3,INe4,1))-A0TNeu(INe4)*CF11F11V2L(INe3,INe4)*
     &  dCF11F11V2L(INe4,INe3,1)-A0TNeu(INe4)*CF11F11V2R(INe4,INe3)*
     &  dCF11F11V2R(INe3,INe4,1)-A0TNeu(INe4)*CF11F11V2R(INe3,INe4)*
     &  dCF11F11V2R(INe4,INe3,1)-4*aBEpTNeu(INe3,INe4)*
     &  (CF11F11V2R(INe4,INe3)*dCF11F11V2L(INe3,INe4,1)+
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2L(INe4,INe3,1)+
     &  CF11F11V2L(INe4,INe3)*dCF11F11V2R(INe3,INe4,1)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2R(INe4,INe3,1))*MNeu(INe3)*
     &  MNeu(INe4)-4*aB0TNeu(INe3,INe4)*(CF11F11V2R(INe4,INe3)*
     &  dCF11F11V2L(INe3,INe4,2)+CF11F11V2R(INe3,INe4)*
     &  dCF11F11V2L(INe4,INe3,2)+CF11F11V2L(INe4,INe3)*
     &  dCF11F11V2R(INe3,INe4,2)+CF11F11V2L(INe3,INe4)*
     &  dCF11F11V2R(INe4,INe3,2))*MNeu(INe3)*MNeu(INe4)-4*
     &  (CF11F11V2R(INe4,INe3)*dCF11F11V2L(INe3,INe4,3)+
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2L(INe4,INe3,3)+
     &  CF11F11V2L(INe4,INe3)*dCF11F11V2R(INe3,INe4,3)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2R(INe4,INe3,3))*MNeu(INe3)*
     &  MNeu(INe4)-aB0TNeu(INe3,INe4)*CF11F11V2L(INe4,INe3)*
     &  dCF11F11V2L(INe3,INe4,1)*MNeu2(INe3)-CF11F11V2L(INe4,INe3)*
     &  dCF11F11V2L(INe3,INe4,2)*MNeu2(INe3)-aB0TNeu(INe3,INe4)*
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,1)*MNeu2(INe3)-
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,2)*MNeu2(INe3)-
     &  aB0TNeu(INe3,INe4)*CF11F11V2R(INe4,INe3)*
     &  dCF11F11V2R(INe3,INe4,1)*MNeu2(INe3)-CF11F11V2R(INe4,INe3)*
     &  dCF11F11V2R(INe3,INe4,2)*MNeu2(INe3)-aB0TNeu(INe3,INe4)*
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,1)*MNeu2(INe3)-
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,2)*MNeu2(INe3)+2*
     &  (CF11F11V2L(INe4,INe3)*dCF11F11V2L(INe3,INe4,3)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,3)+
     &  CF11F11V2R(INe4,INe3)*dCF11F11V2R(INe3,INe4,3)+
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,3))*MNeu2(INe3)+2*
     &  (CF11F11V2L(INe4,INe3)*dCF11F11V2L(INe3,INe4,2)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,2)+
     &  CF11F11V2R(INe4,INe3)*dCF11F11V2R(INe3,INe4,2)+
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,2))*(A0TNeu(INe4)+
     &  aB0TNeu(INe3,INe4)*MNeu2(INe3))+2*(CF11F11V2L(INe4,INe3)*
     &  dCF11F11V2L(INe3,INe4,1)+CF11F11V2L(INe3,INe4)*
     &  dCF11F11V2L(INe4,INe3,1)+CF11F11V2R(INe4,INe3)*
     &  dCF11F11V2R(INe3,INe4,1)+CF11F11V2R(INe3,INe4)*
     &  dCF11F11V2R(INe4,INe3,1))*(AETNeu(INe4)+aBEpTNeu(INe3,INe4)*
     &  MNeu2(INe3))-CF11F11V2L(INe4,INe3)*dCF11F11V2L(INe3,INe4,2)*
     &  MNeu2(INe4)-CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,2)*
     &  MNeu2(INe4)-CF11F11V2R(INe4,INe3)*dCF11F11V2R(INe3,INe4,2)*
     &  MNeu2(INe4)-CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,2)*
     &  MNeu2(INe4)+2*(CF11F11V2L(INe4,INe3)*dCF11F11V2L(INe3,INe4,3)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,3)+
     &  CF11F11V2R(INe4,INe3)*dCF11F11V2R(INe3,INe4,3)+
     &  CF11F11V2R(INe3,INe4)*dCF11F11V2R(INe4,INe3,3))*MNeu2(INe4)-
     &  ((CF11F11V2L(INe4,INe3)*dCF11F11V2L(INe3,INe4,1)+
     &  CF11F11V2L(INe3,INe4)*dCF11F11V2L(INe4,INe3,1)+
     &  CF11F11V2R(INe4,INe3)*dCF11F11V2R(INe3,INe4,1)+CF11F11V2R(INe3,INe4)
     &  *dCF11F11V2R(INe4,INe3,1))*(MNeu2(INe3)+MNeu2(INe4)))/2.)
              endif
       enddo 
       enddo 
 
c
c CTtopo4+7-NoGBC
c
c
c CTtopo4+7-GBC
c       
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       selfZCT=selfZCT+CS1S1V2(INH3,INH4)*(4*AETNH(INH4)*
     &  dCS1S1V2(INH3,INH4,1)+2*A0TNH(INH4)*(dCS1S1V2(INH3,INH4,1)+2*
     &  dCS1S1V2(INH3,INH4,2))+((1+2*aB0TNH(INH3,INH4)+4*
     &  aBEpTNH(INH3,INH4))*dCS1S1V2(INH3,INH4,1)+(2+4*
     &  aB0TNH(INH3,INH4))*dCS1S1V2(INH3,INH4,2)+4*
     &  dCS1S1V2(INH3,INH4,3))*Mah2(INH3)+(dCS1S1V2(INH3,INH4,1)+2*
     &  dCS1S1V2(INH3,INH4,2)+4*dCS1S1V2(INH3,INH4,3))*Mah2(INH4))
              endif
       enddo 
       enddo
        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfZCT=selfZCT+(C2W*indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)
     &  *(4*AETHpN(ICH4)*(dCS3S3V2(ICH3,ICH4,1)+dCS3S3V2(ICH4,ICH3,1))+
     &  2*A0THpN(ICH4)*(dCS3S3V2(ICH3,ICH4,1)+2*dCS3S3V2(ICH3,ICH4,2)+
     &  dCS3S3V2(ICH4,ICH3,1)+2*dCS3S3V2(ICH4,ICH3,2))+((1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4))*dCS3S3V2(ICH3,ICH4,1)+
     &  (2+4*aB0TCH(ICH3,ICH4))*dCS3S3V2(ICH3,ICH4,2)+4*
     &  dCS3S3V2(ICH3,ICH4,3)+(1+2*aB0TCH(ICH3,ICH4)+4*
     &  aBEpTCH(ICH3,ICH4))*dCS3S3V2(ICH4,ICH3,1)+4*aB0TCH(ICH3,ICH4)*
     &  dCS3S3V2(ICH4,ICH3,2)+2*(dCS3S3V2(ICH4,ICH3,2)+2*
     &  dCS3S3V2(ICH4,ICH3,3)))*MassHpm(ICH3)**2+(dCS3S3V2(ICH3,ICH4,1)
     &  +2*dCS3S3V2(ICH3,ICH4,2)+4*dCS3S3V2(ICH3,ICH4,3)+
     &  dCS3S3V2(ICH4,ICH3,1)+2*dCS3S3V2(ICH4,ICH3,2)+4*
     &  dCS3S3V2(ICH4,ICH3,3))*MassHpm(ICH4)**2))/S2W
              endif
       enddo 
       enddo 
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfZCT=selfZCT+3*(4*aAETN(ISt4)*(CS13S13V2(ISt4,ISt3)*
     &  dCS13S13V2(ISt3,ISt4,1)+CS13S13V2(ISt3,ISt4)*
     &  dCS13S13V2(ISt4,ISt3,1))+2*aA0TN(ISt4)*(CS13S13V2(ISt4,ISt3)*
     &  (dCS13S13V2(ISt3,ISt4,1)+2*dCS13S13V2(ISt3,ISt4,2))+
     &  CS13S13V2(ISt3,ISt4)*(dCS13S13V2(ISt4,ISt3,1)+2*
     &  dCS13S13V2(ISt4,ISt3,2)))+(CS13S13V2(ISt4,ISt3)*((1+2*
     &  aB0T1(ISt3,ISt4)+4*aBEpT1(ISt3,ISt4))*dCS13S13V2(ISt3,ISt4,1)+
     &  (2+4*aB0T1(ISt3,ISt4))*dCS13S13V2(ISt3,ISt4,2)+4*
     &  dCS13S13V2(ISt3,ISt4,3))+CS13S13V2(ISt3,ISt4)*((1+2*
     &  aB0T1(ISt3,ISt4)+4*aBEpT1(ISt3,ISt4))*dCS13S13V2(ISt4,ISt3,1)+
     &  (2+4*aB0T1(ISt3,ISt4))*dCS13S13V2(ISt4,ISt3,2)+4*
     &  dCS13S13V2(ISt4,ISt3,3)))*MassSu2(ISt3)+(CS13S13V2(ISt4,ISt3)*
     &  (dCS13S13V2(ISt3,ISt4,1)+2*dCS13S13V2(ISt3,ISt4,2)+4*
     &  dCS13S13V2(ISt3,ISt4,3))+CS13S13V2(ISt3,ISt4)*
     &  (dCS13S13V2(ISt4,ISt3,1)+2*dCS13S13V2(ISt4,ISt3,2)+4*
     &  dCS13S13V2(ISt4,ISt3,3)))*MassSu2(ISt4))
              endif
       enddo 
       enddo 
 
        
       selfZCT=selfZCT+12*CS14S14V2*(2*aet5*dCS14S14V2(1)+a0t5*
     &  (dCS14S14V2(1)+2*dCS14S14V2(2))+MSQ2*((1+aB0T5+2*aBEpT5)*
     &  dCS14S14V2(1)+2*(1+aB0T5)*dCS14S14V2(2)+4*dCS14S14V2(3)))
c
c CTtopo5+8-NoGBC
c       
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then 
       selfZCT=selfZCT+CS1S1V2(INH3,INH4)*(4*AETNH(INH4)*
     &  dCS1S1V2(INH3,INH4,1)+2*A0TNH(INH4)*(dCS1S1V2(INH3,INH4,1)+2*
     &  dCS1S1V2(INH3,INH4,2))+((1+2*aB0TNH(INH3,INH4)+4*
     &  aBEpTNH(INH3,INH4))*dCS1S1V2(INH3,INH4,1)+(2+4*
     &  aB0TNH(INH3,INH4))*dCS1S1V2(INH3,INH4,2)+4*
     &  dCS1S1V2(INH3,INH4,3))*Mah2(INH3)+(dCS1S1V2(INH3,INH4,1)+2*
     &  dCS1S1V2(INH3,INH4,2)+4*dCS1S1V2(INH3,INH4,3))*Mah2(INH4))
              endif
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
       selfZCT=selfZCT+(C2W*indexdelta(ICH3,ICH4)*indexdelta(ICH4,ICH3)
     &  *(4*AETHpN(ICH4)*(dCS3S3V2(ICH3,ICH4,1)+dCS3S3V2(ICH4,ICH3,1))+
     &  2*A0THpN(ICH4)*(dCS3S3V2(ICH3,ICH4,1)+2*dCS3S3V2(ICH3,ICH4,2)+
     &  dCS3S3V2(ICH4,ICH3,1)+2*dCS3S3V2(ICH4,ICH3,2))+((1+2*
     &  aB0TCH(ICH3,ICH4)+4*aBEpTCH(ICH3,ICH4))*dCS3S3V2(ICH3,ICH4,1)+
     &  (2+4*aB0TCH(ICH3,ICH4))*dCS3S3V2(ICH3,ICH4,2)+4*
     &  dCS3S3V2(ICH3,ICH4,3)+(1+2*aB0TCH(ICH3,ICH4)+4*
     &  aBEpTCH(ICH3,ICH4))*dCS3S3V2(ICH4,ICH3,1)+4*aB0TCH(ICH3,ICH4)*
     &  dCS3S3V2(ICH4,ICH3,2)+2*(dCS3S3V2(ICH4,ICH3,2)+2*
     &  dCS3S3V2(ICH4,ICH3,3)))*MassHpm(ICH3)**2+(dCS3S3V2(ICH3,ICH4,1)
     &  +2*dCS3S3V2(ICH3,ICH4,2)+4*dCS3S3V2(ICH3,ICH4,3)+
     &  dCS3S3V2(ICH4,ICH3,1)+2*dCS3S3V2(ICH4,ICH3,2)+4*
     &  dCS3S3V2(ICH4,ICH3,3))*MassHpm(ICH4)**2))/S2W
              endif
       enddo 
       enddo 

c
c CTtopo5+8-GBC
c       
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       selfZCT=selfZCT+CS1S1V2V2(INH3,INH4)*(2*dMH1MT4(INH3,INH4,3)-2*
     &  AETNH(INH4)*facZ*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH4)*
     &  facZ*dZHiggs1(INH3,INH4,2)+(-2+signf)*facZ*dZHiggs1(INH3,INH4,3)*
     &  (Mah2(INH3)+Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,1)+facZ*dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4)))+aB0TNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,2)+facZ*dZHiggs1(INH3,INH4,2)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))
              endif
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfZCT=selfZCT+2*CS3S3V2V2(ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*facZ*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)+(-2+signf)*facZ*dZCHiggs1(ICH4,ICH3,3)*
     &  (MassHpm(ICH3)**2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,1)+facZ*dZCHiggs1(ICH4,ICH3,1)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2))+aB0TCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+facZ*dZCHiggs1(ICH4,ICH3,2)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2)))
              endif
       enddo 
       enddo 
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfZCT=selfZCT+12*CS13S13V2V2(ISt4,ISt3)*(aBEpT1(ISt3,ISt4)*
     &  dMSf4(ISt4,ISt3,1)+aB0T1(ISt3,ISt4)*dMSf4(ISt4,ISt3,2)+
     &  dMSf4(ISt4,ISt3,3))
              endif
       enddo 
       enddo 

       selfZCT=selfZCT+12*CS14S14V2V2*(aBEpT5*dMSQ4(1)+aB0T5*dMSQ4(2)+dMSQ4(3))
c
c CTtopo6-NoGBC
c   
       do INH3=1,6
       do INH4=1,6
              if( Mah(INH3) + Mah(INH4) .lt. 1D-15) then
       selfZCT=selfZCT+CS1S1V2V2(INH3,INH4)*(2*dMH1MT4(INH3,INH4,3)-2*
     &  AETNH(INH4)*facZ*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH4)*
     &  facZ*dZHiggs1(INH3,INH4,2)+(-2+signf)*facZ*dZHiggs1(INH3,INH4,3)*
     &  (Mah2(INH3)+Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,1)+facZ*dZHiggs1(INH3,INH4,1)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4)))+aB0TNH(INH3,INH4)*(2*
     &  dMH1MT4(INH3,INH4,2)+facZ*dZHiggs1(INH3,INH4,2)*((-2+signf)*
     &  Mah2(INH3)+signf*Mah2(INH4))))
              endif
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .lt. 1D-15) then 
       selfZCT=selfZCT+2*CS3S3V2V2(ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*facZ*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  facZ*dZCHiggs1(ICH4,ICH3,2)+(-2+signf)*facZ*dZCHiggs1(ICH4,ICH3,3)*
     &  (MassHpm(ICH3)**2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,1)+facZ*dZCHiggs1(ICH4,ICH3,1)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2))+aB0TCH(ICH3,ICH4)*(2*
     &  dMCH1L(ICH4,ICH3,2)+facZ*dZCHiggs1(ICH4,ICH3,2)*((-2+signf)*
     &  MassHpm(ICH3)**2+signf*MassHpm(ICH4)**2)))
              endif
       enddo 
       enddo 

c
c topo6-GBC
c
       selfZ=-selfZCT*afac2- selfZ*afac
#ifdef printMT4
      Write(16,110) "TwoLoopZSelf[SUM][Nhung]=",selfZ
110   format(A,F24.14)   
#endif
      end

